/**
 * @licstart The following is the entire license notice for the
 * JavaScript code in this page
 *
 * Copyright 2024 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * JavaScript code in this page
 */

/******/ var __webpack_modules__ = ({

/***/ 9306:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isCallable = __webpack_require__(4901);
var tryToString = __webpack_require__(6823);

var $TypeError = TypeError;

// `Assert: IsCallable(argument) is true`
module.exports = function (argument) {
  if (isCallable(argument)) return argument;
  throw new $TypeError(tryToString(argument) + ' is not a function');
};


/***/ }),

/***/ 5548:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isConstructor = __webpack_require__(3517);
var tryToString = __webpack_require__(6823);

var $TypeError = TypeError;

// `Assert: IsConstructor(argument) is true`
module.exports = function (argument) {
  if (isConstructor(argument)) return argument;
  throw new $TypeError(tryToString(argument) + ' is not a constructor');
};


/***/ }),

/***/ 3506:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isPossiblePrototype = __webpack_require__(3925);

var $String = String;
var $TypeError = TypeError;

module.exports = function (argument) {
  if (isPossiblePrototype(argument)) return argument;
  throw new $TypeError("Can't set " + $String(argument) + ' as a prototype');
};


/***/ }),

/***/ 7080:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var has = (__webpack_require__(4402).has);

// Perform ? RequireInternalSlot(M, [[SetData]])
module.exports = function (it) {
  has(it);
  return it;
};


/***/ }),

/***/ 6469:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);
var create = __webpack_require__(2360);
var defineProperty = (__webpack_require__(4913).f);

var UNSCOPABLES = wellKnownSymbol('unscopables');
var ArrayPrototype = Array.prototype;

// Array.prototype[@@unscopables]
// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
if (ArrayPrototype[UNSCOPABLES] === undefined) {
  defineProperty(ArrayPrototype, UNSCOPABLES, {
    configurable: true,
    value: create(null)
  });
}

// add a key to Array.prototype[@@unscopables]
module.exports = function (key) {
  ArrayPrototype[UNSCOPABLES][key] = true;
};


/***/ }),

/***/ 7829:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var charAt = (__webpack_require__(8183).charAt);

// `AdvanceStringIndex` abstract operation
// https://tc39.es/ecma262/#sec-advancestringindex
module.exports = function (S, index, unicode) {
  return index + (unicode ? charAt(S, index).length : 1);
};


/***/ }),

/***/ 679:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isPrototypeOf = __webpack_require__(1625);

var $TypeError = TypeError;

module.exports = function (it, Prototype) {
  if (isPrototypeOf(Prototype, it)) return it;
  throw new $TypeError('Incorrect invocation');
};


/***/ }),

/***/ 8551:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isObject = __webpack_require__(34);

var $String = String;
var $TypeError = TypeError;

// `Assert: Type(argument) is Object`
module.exports = function (argument) {
  if (isObject(argument)) return argument;
  throw new $TypeError($String(argument) + ' is not an object');
};


/***/ }),

/***/ 7811:
/***/ ((module) => {


// eslint-disable-next-line es/no-typed-arrays -- safe
module.exports = typeof ArrayBuffer != 'undefined' && typeof DataView != 'undefined';


/***/ }),

/***/ 7394:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var uncurryThisAccessor = __webpack_require__(6706);
var classof = __webpack_require__(2195);

var ArrayBuffer = globalThis.ArrayBuffer;
var TypeError = globalThis.TypeError;

// Includes
// - Perform ? RequireInternalSlot(O, [[ArrayBufferData]]).
// - If IsSharedArrayBuffer(O) is true, throw a TypeError exception.
module.exports = ArrayBuffer && uncurryThisAccessor(ArrayBuffer.prototype, 'byteLength', 'get') || function (O) {
  if (classof(O) !== 'ArrayBuffer') throw new TypeError('ArrayBuffer expected');
  return O.byteLength;
};


/***/ }),

/***/ 3238:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(7476);
var arrayBufferByteLength = __webpack_require__(7394);

var ArrayBuffer = globalThis.ArrayBuffer;
var ArrayBufferPrototype = ArrayBuffer && ArrayBuffer.prototype;
var slice = ArrayBufferPrototype && uncurryThis(ArrayBufferPrototype.slice);

module.exports = function (O) {
  if (arrayBufferByteLength(O) !== 0) return false;
  if (!slice) return false;
  try {
    slice(O, 0, 0);
    return false;
  } catch (error) {
    return true;
  }
};


/***/ }),

/***/ 5652:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// FF26- bug: ArrayBuffers are non-extensible, but Object.isExtensible does not report it
var fails = __webpack_require__(9039);

module.exports = fails(function () {
  if (typeof ArrayBuffer == 'function') {
    var buffer = new ArrayBuffer(8);
    // eslint-disable-next-line es/no-object-isextensible, es/no-object-defineproperty -- safe
    if (Object.isExtensible(buffer)) Object.defineProperty(buffer, 'a', { value: 8 });
  }
});


/***/ }),

/***/ 5169:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isDetached = __webpack_require__(3238);

var $TypeError = TypeError;

module.exports = function (it) {
  if (isDetached(it)) throw new $TypeError('ArrayBuffer is detached');
  return it;
};


/***/ }),

/***/ 5636:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var uncurryThisAccessor = __webpack_require__(6706);
var toIndex = __webpack_require__(7696);
var notDetached = __webpack_require__(5169);
var arrayBufferByteLength = __webpack_require__(7394);
var detachTransferable = __webpack_require__(4483);
var PROPER_STRUCTURED_CLONE_TRANSFER = __webpack_require__(1548);

var structuredClone = globalThis.structuredClone;
var ArrayBuffer = globalThis.ArrayBuffer;
var DataView = globalThis.DataView;
var min = Math.min;
var ArrayBufferPrototype = ArrayBuffer.prototype;
var DataViewPrototype = DataView.prototype;
var slice = uncurryThis(ArrayBufferPrototype.slice);
var isResizable = uncurryThisAccessor(ArrayBufferPrototype, 'resizable', 'get');
var maxByteLength = uncurryThisAccessor(ArrayBufferPrototype, 'maxByteLength', 'get');
var getInt8 = uncurryThis(DataViewPrototype.getInt8);
var setInt8 = uncurryThis(DataViewPrototype.setInt8);

module.exports = (PROPER_STRUCTURED_CLONE_TRANSFER || detachTransferable) && function (arrayBuffer, newLength, preserveResizability) {
  var byteLength = arrayBufferByteLength(arrayBuffer);
  var newByteLength = newLength === undefined ? byteLength : toIndex(newLength);
  var fixedLength = !isResizable || !isResizable(arrayBuffer);
  var newBuffer;
  notDetached(arrayBuffer);
  if (PROPER_STRUCTURED_CLONE_TRANSFER) {
    arrayBuffer = structuredClone(arrayBuffer, { transfer: [arrayBuffer] });
    if (byteLength === newByteLength && (preserveResizability || fixedLength)) return arrayBuffer;
  }
  if (byteLength >= newByteLength && (!preserveResizability || fixedLength)) {
    newBuffer = slice(arrayBuffer, 0, newByteLength);
  } else {
    var options = preserveResizability && !fixedLength && maxByteLength ? { maxByteLength: maxByteLength(arrayBuffer) } : undefined;
    newBuffer = new ArrayBuffer(newByteLength, options);
    var a = new DataView(arrayBuffer);
    var b = new DataView(newBuffer);
    var copyLength = min(newByteLength, byteLength);
    for (var i = 0; i < copyLength; i++) setInt8(b, i, getInt8(a, i));
  }
  if (!PROPER_STRUCTURED_CLONE_TRANSFER) detachTransferable(arrayBuffer);
  return newBuffer;
};


/***/ }),

/***/ 4644:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_ARRAY_BUFFER = __webpack_require__(7811);
var DESCRIPTORS = __webpack_require__(3724);
var globalThis = __webpack_require__(4576);
var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);
var hasOwn = __webpack_require__(9297);
var classof = __webpack_require__(6955);
var tryToString = __webpack_require__(6823);
var createNonEnumerableProperty = __webpack_require__(6699);
var defineBuiltIn = __webpack_require__(6840);
var defineBuiltInAccessor = __webpack_require__(2106);
var isPrototypeOf = __webpack_require__(1625);
var getPrototypeOf = __webpack_require__(2787);
var setPrototypeOf = __webpack_require__(2967);
var wellKnownSymbol = __webpack_require__(8227);
var uid = __webpack_require__(3392);
var InternalStateModule = __webpack_require__(1181);

var enforceInternalState = InternalStateModule.enforce;
var getInternalState = InternalStateModule.get;
var Int8Array = globalThis.Int8Array;
var Int8ArrayPrototype = Int8Array && Int8Array.prototype;
var Uint8ClampedArray = globalThis.Uint8ClampedArray;
var Uint8ClampedArrayPrototype = Uint8ClampedArray && Uint8ClampedArray.prototype;
var TypedArray = Int8Array && getPrototypeOf(Int8Array);
var TypedArrayPrototype = Int8ArrayPrototype && getPrototypeOf(Int8ArrayPrototype);
var ObjectPrototype = Object.prototype;
var TypeError = globalThis.TypeError;

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
var TYPED_ARRAY_TAG = uid('TYPED_ARRAY_TAG');
var TYPED_ARRAY_CONSTRUCTOR = 'TypedArrayConstructor';
// Fixing native typed arrays in Opera Presto crashes the browser, see #595
var NATIVE_ARRAY_BUFFER_VIEWS = NATIVE_ARRAY_BUFFER && !!setPrototypeOf && classof(globalThis.opera) !== 'Opera';
var TYPED_ARRAY_TAG_REQUIRED = false;
var NAME, Constructor, Prototype;

var TypedArrayConstructorsList = {
  Int8Array: 1,
  Uint8Array: 1,
  Uint8ClampedArray: 1,
  Int16Array: 2,
  Uint16Array: 2,
  Int32Array: 4,
  Uint32Array: 4,
  Float32Array: 4,
  Float64Array: 8
};

var BigIntArrayConstructorsList = {
  BigInt64Array: 8,
  BigUint64Array: 8
};

var isView = function isView(it) {
  if (!isObject(it)) return false;
  var klass = classof(it);
  return klass === 'DataView'
    || hasOwn(TypedArrayConstructorsList, klass)
    || hasOwn(BigIntArrayConstructorsList, klass);
};

var getTypedArrayConstructor = function (it) {
  var proto = getPrototypeOf(it);
  if (!isObject(proto)) return;
  var state = getInternalState(proto);
  return (state && hasOwn(state, TYPED_ARRAY_CONSTRUCTOR)) ? state[TYPED_ARRAY_CONSTRUCTOR] : getTypedArrayConstructor(proto);
};

var isTypedArray = function (it) {
  if (!isObject(it)) return false;
  var klass = classof(it);
  return hasOwn(TypedArrayConstructorsList, klass)
    || hasOwn(BigIntArrayConstructorsList, klass);
};

var aTypedArray = function (it) {
  if (isTypedArray(it)) return it;
  throw new TypeError('Target is not a typed array');
};

var aTypedArrayConstructor = function (C) {
  if (isCallable(C) && (!setPrototypeOf || isPrototypeOf(TypedArray, C))) return C;
  throw new TypeError(tryToString(C) + ' is not a typed array constructor');
};

var exportTypedArrayMethod = function (KEY, property, forced, options) {
  if (!DESCRIPTORS) return;
  if (forced) for (var ARRAY in TypedArrayConstructorsList) {
    var TypedArrayConstructor = globalThis[ARRAY];
    if (TypedArrayConstructor && hasOwn(TypedArrayConstructor.prototype, KEY)) try {
      delete TypedArrayConstructor.prototype[KEY];
    } catch (error) {
      // old WebKit bug - some methods are non-configurable
      try {
        TypedArrayConstructor.prototype[KEY] = property;
      } catch (error2) { /* empty */ }
    }
  }
  if (!TypedArrayPrototype[KEY] || forced) {
    defineBuiltIn(TypedArrayPrototype, KEY, forced ? property
      : NATIVE_ARRAY_BUFFER_VIEWS && Int8ArrayPrototype[KEY] || property, options);
  }
};

var exportTypedArrayStaticMethod = function (KEY, property, forced) {
  var ARRAY, TypedArrayConstructor;
  if (!DESCRIPTORS) return;
  if (setPrototypeOf) {
    if (forced) for (ARRAY in TypedArrayConstructorsList) {
      TypedArrayConstructor = globalThis[ARRAY];
      if (TypedArrayConstructor && hasOwn(TypedArrayConstructor, KEY)) try {
        delete TypedArrayConstructor[KEY];
      } catch (error) { /* empty */ }
    }
    if (!TypedArray[KEY] || forced) {
      // V8 ~ Chrome 49-50 `%TypedArray%` methods are non-writable non-configurable
      try {
        return defineBuiltIn(TypedArray, KEY, forced ? property : NATIVE_ARRAY_BUFFER_VIEWS && TypedArray[KEY] || property);
      } catch (error) { /* empty */ }
    } else return;
  }
  for (ARRAY in TypedArrayConstructorsList) {
    TypedArrayConstructor = globalThis[ARRAY];
    if (TypedArrayConstructor && (!TypedArrayConstructor[KEY] || forced)) {
      defineBuiltIn(TypedArrayConstructor, KEY, property);
    }
  }
};

for (NAME in TypedArrayConstructorsList) {
  Constructor = globalThis[NAME];
  Prototype = Constructor && Constructor.prototype;
  if (Prototype) enforceInternalState(Prototype)[TYPED_ARRAY_CONSTRUCTOR] = Constructor;
  else NATIVE_ARRAY_BUFFER_VIEWS = false;
}

for (NAME in BigIntArrayConstructorsList) {
  Constructor = globalThis[NAME];
  Prototype = Constructor && Constructor.prototype;
  if (Prototype) enforceInternalState(Prototype)[TYPED_ARRAY_CONSTRUCTOR] = Constructor;
}

// WebKit bug - typed arrays constructors prototype is Object.prototype
if (!NATIVE_ARRAY_BUFFER_VIEWS || !isCallable(TypedArray) || TypedArray === Function.prototype) {
  // eslint-disable-next-line no-shadow -- safe
  TypedArray = function TypedArray() {
    throw new TypeError('Incorrect invocation');
  };
  if (NATIVE_ARRAY_BUFFER_VIEWS) for (NAME in TypedArrayConstructorsList) {
    if (globalThis[NAME]) setPrototypeOf(globalThis[NAME], TypedArray);
  }
}

if (!NATIVE_ARRAY_BUFFER_VIEWS || !TypedArrayPrototype || TypedArrayPrototype === ObjectPrototype) {
  TypedArrayPrototype = TypedArray.prototype;
  if (NATIVE_ARRAY_BUFFER_VIEWS) for (NAME in TypedArrayConstructorsList) {
    if (globalThis[NAME]) setPrototypeOf(globalThis[NAME].prototype, TypedArrayPrototype);
  }
}

// WebKit bug - one more object in Uint8ClampedArray prototype chain
if (NATIVE_ARRAY_BUFFER_VIEWS && getPrototypeOf(Uint8ClampedArrayPrototype) !== TypedArrayPrototype) {
  setPrototypeOf(Uint8ClampedArrayPrototype, TypedArrayPrototype);
}

if (DESCRIPTORS && !hasOwn(TypedArrayPrototype, TO_STRING_TAG)) {
  TYPED_ARRAY_TAG_REQUIRED = true;
  defineBuiltInAccessor(TypedArrayPrototype, TO_STRING_TAG, {
    configurable: true,
    get: function () {
      return isObject(this) ? this[TYPED_ARRAY_TAG] : undefined;
    }
  });
  for (NAME in TypedArrayConstructorsList) if (globalThis[NAME]) {
    createNonEnumerableProperty(globalThis[NAME], TYPED_ARRAY_TAG, NAME);
  }
}

module.exports = {
  NATIVE_ARRAY_BUFFER_VIEWS: NATIVE_ARRAY_BUFFER_VIEWS,
  TYPED_ARRAY_TAG: TYPED_ARRAY_TAG_REQUIRED && TYPED_ARRAY_TAG,
  aTypedArray: aTypedArray,
  aTypedArrayConstructor: aTypedArrayConstructor,
  exportTypedArrayMethod: exportTypedArrayMethod,
  exportTypedArrayStaticMethod: exportTypedArrayStaticMethod,
  getTypedArrayConstructor: getTypedArrayConstructor,
  isView: isView,
  isTypedArray: isTypedArray,
  TypedArray: TypedArray,
  TypedArrayPrototype: TypedArrayPrototype
};


/***/ }),

/***/ 6346:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var DESCRIPTORS = __webpack_require__(3724);
var NATIVE_ARRAY_BUFFER = __webpack_require__(7811);
var FunctionName = __webpack_require__(350);
var createNonEnumerableProperty = __webpack_require__(6699);
var defineBuiltInAccessor = __webpack_require__(2106);
var defineBuiltIns = __webpack_require__(6279);
var fails = __webpack_require__(9039);
var anInstance = __webpack_require__(679);
var toIntegerOrInfinity = __webpack_require__(1291);
var toLength = __webpack_require__(8014);
var toIndex = __webpack_require__(7696);
var fround = __webpack_require__(5617);
var IEEE754 = __webpack_require__(8490);
var getPrototypeOf = __webpack_require__(2787);
var setPrototypeOf = __webpack_require__(2967);
var arrayFill = __webpack_require__(4373);
var arraySlice = __webpack_require__(7680);
var inheritIfRequired = __webpack_require__(3167);
var copyConstructorProperties = __webpack_require__(7740);
var setToStringTag = __webpack_require__(687);
var InternalStateModule = __webpack_require__(1181);

var PROPER_FUNCTION_NAME = FunctionName.PROPER;
var CONFIGURABLE_FUNCTION_NAME = FunctionName.CONFIGURABLE;
var ARRAY_BUFFER = 'ArrayBuffer';
var DATA_VIEW = 'DataView';
var PROTOTYPE = 'prototype';
var WRONG_LENGTH = 'Wrong length';
var WRONG_INDEX = 'Wrong index';
var getInternalArrayBufferState = InternalStateModule.getterFor(ARRAY_BUFFER);
var getInternalDataViewState = InternalStateModule.getterFor(DATA_VIEW);
var setInternalState = InternalStateModule.set;
var NativeArrayBuffer = globalThis[ARRAY_BUFFER];
var $ArrayBuffer = NativeArrayBuffer;
var ArrayBufferPrototype = $ArrayBuffer && $ArrayBuffer[PROTOTYPE];
var $DataView = globalThis[DATA_VIEW];
var DataViewPrototype = $DataView && $DataView[PROTOTYPE];
var ObjectPrototype = Object.prototype;
var Array = globalThis.Array;
var RangeError = globalThis.RangeError;
var fill = uncurryThis(arrayFill);
var reverse = uncurryThis([].reverse);

var packIEEE754 = IEEE754.pack;
var unpackIEEE754 = IEEE754.unpack;

var packInt8 = function (number) {
  return [number & 0xFF];
};

var packInt16 = function (number) {
  return [number & 0xFF, number >> 8 & 0xFF];
};

var packInt32 = function (number) {
  return [number & 0xFF, number >> 8 & 0xFF, number >> 16 & 0xFF, number >> 24 & 0xFF];
};

var unpackInt32 = function (buffer) {
  return buffer[3] << 24 | buffer[2] << 16 | buffer[1] << 8 | buffer[0];
};

var packFloat32 = function (number) {
  return packIEEE754(fround(number), 23, 4);
};

var packFloat64 = function (number) {
  return packIEEE754(number, 52, 8);
};

var addGetter = function (Constructor, key, getInternalState) {
  defineBuiltInAccessor(Constructor[PROTOTYPE], key, {
    configurable: true,
    get: function () {
      return getInternalState(this)[key];
    }
  });
};

var get = function (view, count, index, isLittleEndian) {
  var store = getInternalDataViewState(view);
  var intIndex = toIndex(index);
  var boolIsLittleEndian = !!isLittleEndian;
  if (intIndex + count > store.byteLength) throw new RangeError(WRONG_INDEX);
  var bytes = store.bytes;
  var start = intIndex + store.byteOffset;
  var pack = arraySlice(bytes, start, start + count);
  return boolIsLittleEndian ? pack : reverse(pack);
};

var set = function (view, count, index, conversion, value, isLittleEndian) {
  var store = getInternalDataViewState(view);
  var intIndex = toIndex(index);
  var pack = conversion(+value);
  var boolIsLittleEndian = !!isLittleEndian;
  if (intIndex + count > store.byteLength) throw new RangeError(WRONG_INDEX);
  var bytes = store.bytes;
  var start = intIndex + store.byteOffset;
  for (var i = 0; i < count; i++) bytes[start + i] = pack[boolIsLittleEndian ? i : count - i - 1];
};

if (!NATIVE_ARRAY_BUFFER) {
  $ArrayBuffer = function ArrayBuffer(length) {
    anInstance(this, ArrayBufferPrototype);
    var byteLength = toIndex(length);
    setInternalState(this, {
      type: ARRAY_BUFFER,
      bytes: fill(Array(byteLength), 0),
      byteLength: byteLength
    });
    if (!DESCRIPTORS) {
      this.byteLength = byteLength;
      this.detached = false;
    }
  };

  ArrayBufferPrototype = $ArrayBuffer[PROTOTYPE];

  $DataView = function DataView(buffer, byteOffset, byteLength) {
    anInstance(this, DataViewPrototype);
    anInstance(buffer, ArrayBufferPrototype);
    var bufferState = getInternalArrayBufferState(buffer);
    var bufferLength = bufferState.byteLength;
    var offset = toIntegerOrInfinity(byteOffset);
    if (offset < 0 || offset > bufferLength) throw new RangeError('Wrong offset');
    byteLength = byteLength === undefined ? bufferLength - offset : toLength(byteLength);
    if (offset + byteLength > bufferLength) throw new RangeError(WRONG_LENGTH);
    setInternalState(this, {
      type: DATA_VIEW,
      buffer: buffer,
      byteLength: byteLength,
      byteOffset: offset,
      bytes: bufferState.bytes
    });
    if (!DESCRIPTORS) {
      this.buffer = buffer;
      this.byteLength = byteLength;
      this.byteOffset = offset;
    }
  };

  DataViewPrototype = $DataView[PROTOTYPE];

  if (DESCRIPTORS) {
    addGetter($ArrayBuffer, 'byteLength', getInternalArrayBufferState);
    addGetter($DataView, 'buffer', getInternalDataViewState);
    addGetter($DataView, 'byteLength', getInternalDataViewState);
    addGetter($DataView, 'byteOffset', getInternalDataViewState);
  }

  defineBuiltIns(DataViewPrototype, {
    getInt8: function getInt8(byteOffset) {
      return get(this, 1, byteOffset)[0] << 24 >> 24;
    },
    getUint8: function getUint8(byteOffset) {
      return get(this, 1, byteOffset)[0];
    },
    getInt16: function getInt16(byteOffset /* , littleEndian */) {
      var bytes = get(this, 2, byteOffset, arguments.length > 1 ? arguments[1] : false);
      return (bytes[1] << 8 | bytes[0]) << 16 >> 16;
    },
    getUint16: function getUint16(byteOffset /* , littleEndian */) {
      var bytes = get(this, 2, byteOffset, arguments.length > 1 ? arguments[1] : false);
      return bytes[1] << 8 | bytes[0];
    },
    getInt32: function getInt32(byteOffset /* , littleEndian */) {
      return unpackInt32(get(this, 4, byteOffset, arguments.length > 1 ? arguments[1] : false));
    },
    getUint32: function getUint32(byteOffset /* , littleEndian */) {
      return unpackInt32(get(this, 4, byteOffset, arguments.length > 1 ? arguments[1] : false)) >>> 0;
    },
    getFloat32: function getFloat32(byteOffset /* , littleEndian */) {
      return unpackIEEE754(get(this, 4, byteOffset, arguments.length > 1 ? arguments[1] : false), 23);
    },
    getFloat64: function getFloat64(byteOffset /* , littleEndian */) {
      return unpackIEEE754(get(this, 8, byteOffset, arguments.length > 1 ? arguments[1] : false), 52);
    },
    setInt8: function setInt8(byteOffset, value) {
      set(this, 1, byteOffset, packInt8, value);
    },
    setUint8: function setUint8(byteOffset, value) {
      set(this, 1, byteOffset, packInt8, value);
    },
    setInt16: function setInt16(byteOffset, value /* , littleEndian */) {
      set(this, 2, byteOffset, packInt16, value, arguments.length > 2 ? arguments[2] : false);
    },
    setUint16: function setUint16(byteOffset, value /* , littleEndian */) {
      set(this, 2, byteOffset, packInt16, value, arguments.length > 2 ? arguments[2] : false);
    },
    setInt32: function setInt32(byteOffset, value /* , littleEndian */) {
      set(this, 4, byteOffset, packInt32, value, arguments.length > 2 ? arguments[2] : false);
    },
    setUint32: function setUint32(byteOffset, value /* , littleEndian */) {
      set(this, 4, byteOffset, packInt32, value, arguments.length > 2 ? arguments[2] : false);
    },
    setFloat32: function setFloat32(byteOffset, value /* , littleEndian */) {
      set(this, 4, byteOffset, packFloat32, value, arguments.length > 2 ? arguments[2] : false);
    },
    setFloat64: function setFloat64(byteOffset, value /* , littleEndian */) {
      set(this, 8, byteOffset, packFloat64, value, arguments.length > 2 ? arguments[2] : false);
    }
  });
} else {
  var INCORRECT_ARRAY_BUFFER_NAME = PROPER_FUNCTION_NAME && NativeArrayBuffer.name !== ARRAY_BUFFER;
  /* eslint-disable no-new, sonarjs/inconsistent-function-call -- required for testing */
  if (!fails(function () {
    NativeArrayBuffer(1);
  }) || !fails(function () {
    new NativeArrayBuffer(-1);
  }) || fails(function () {
    new NativeArrayBuffer();
    new NativeArrayBuffer(1.5);
    new NativeArrayBuffer(NaN);
    return NativeArrayBuffer.length !== 1 || INCORRECT_ARRAY_BUFFER_NAME && !CONFIGURABLE_FUNCTION_NAME;
  })) {
    /* eslint-enable no-new, sonarjs/inconsistent-function-call -- required for testing */
    $ArrayBuffer = function ArrayBuffer(length) {
      anInstance(this, ArrayBufferPrototype);
      return inheritIfRequired(new NativeArrayBuffer(toIndex(length)), this, $ArrayBuffer);
    };

    $ArrayBuffer[PROTOTYPE] = ArrayBufferPrototype;

    ArrayBufferPrototype.constructor = $ArrayBuffer;

    copyConstructorProperties($ArrayBuffer, NativeArrayBuffer);
  } else if (INCORRECT_ARRAY_BUFFER_NAME && CONFIGURABLE_FUNCTION_NAME) {
    createNonEnumerableProperty(NativeArrayBuffer, 'name', ARRAY_BUFFER);
  }

  // WebKit bug - the same parent prototype for typed arrays and data view
  if (setPrototypeOf && getPrototypeOf(DataViewPrototype) !== ObjectPrototype) {
    setPrototypeOf(DataViewPrototype, ObjectPrototype);
  }

  // iOS Safari 7.x bug
  var testView = new $DataView(new $ArrayBuffer(2));
  var $setInt8 = uncurryThis(DataViewPrototype.setInt8);
  testView.setInt8(0, 2147483648);
  testView.setInt8(1, 2147483649);
  if (testView.getInt8(0) || !testView.getInt8(1)) defineBuiltIns(DataViewPrototype, {
    setInt8: function setInt8(byteOffset, value) {
      $setInt8(this, byteOffset, value << 24 >> 24);
    },
    setUint8: function setUint8(byteOffset, value) {
      $setInt8(this, byteOffset, value << 24 >> 24);
    }
  }, { unsafe: true });
}

setToStringTag($ArrayBuffer, ARRAY_BUFFER);
setToStringTag($DataView, DATA_VIEW);

module.exports = {
  ArrayBuffer: $ArrayBuffer,
  DataView: $DataView
};


/***/ }),

/***/ 7029:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toObject = __webpack_require__(8981);
var toAbsoluteIndex = __webpack_require__(5610);
var lengthOfArrayLike = __webpack_require__(6198);
var deletePropertyOrThrow = __webpack_require__(4606);

var min = Math.min;

// `Array.prototype.copyWithin` method implementation
// https://tc39.es/ecma262/#sec-array.prototype.copywithin
// eslint-disable-next-line es/no-array-prototype-copywithin -- safe
module.exports = [].copyWithin || function copyWithin(target /* = 0 */, start /* = 0, end = @length */) {
  var O = toObject(this);
  var len = lengthOfArrayLike(O);
  var to = toAbsoluteIndex(target, len);
  var from = toAbsoluteIndex(start, len);
  var end = arguments.length > 2 ? arguments[2] : undefined;
  var count = min((end === undefined ? len : toAbsoluteIndex(end, len)) - from, len - to);
  var inc = 1;
  if (from < to && to < from + count) {
    inc = -1;
    from += count - 1;
    to += count - 1;
  }
  while (count-- > 0) {
    if (from in O) O[to] = O[from];
    else deletePropertyOrThrow(O, to);
    to += inc;
    from += inc;
  } return O;
};


/***/ }),

/***/ 4373:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toObject = __webpack_require__(8981);
var toAbsoluteIndex = __webpack_require__(5610);
var lengthOfArrayLike = __webpack_require__(6198);

// `Array.prototype.fill` method implementation
// https://tc39.es/ecma262/#sec-array.prototype.fill
module.exports = function fill(value /* , start = 0, end = @length */) {
  var O = toObject(this);
  var length = lengthOfArrayLike(O);
  var argumentsLength = arguments.length;
  var index = toAbsoluteIndex(argumentsLength > 1 ? arguments[1] : undefined, length);
  var end = argumentsLength > 2 ? arguments[2] : undefined;
  var endPos = end === undefined ? length : toAbsoluteIndex(end, length);
  while (endPos > index) O[index++] = value;
  return O;
};


/***/ }),

/***/ 235:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $forEach = (__webpack_require__(9213).forEach);
var arrayMethodIsStrict = __webpack_require__(4598);

var STRICT_METHOD = arrayMethodIsStrict('forEach');

// `Array.prototype.forEach` method implementation
// https://tc39.es/ecma262/#sec-array.prototype.foreach
module.exports = !STRICT_METHOD ? function forEach(callbackfn /* , thisArg */) {
  return $forEach(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
// eslint-disable-next-line es/no-array-prototype-foreach -- safe
} : [].forEach;


/***/ }),

/***/ 5370:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var lengthOfArrayLike = __webpack_require__(6198);

module.exports = function (Constructor, list, $length) {
  var index = 0;
  var length = arguments.length > 2 ? $length : lengthOfArrayLike(list);
  var result = new Constructor(length);
  while (length > index) result[index] = list[index++];
  return result;
};


/***/ }),

/***/ 7916:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var bind = __webpack_require__(6080);
var call = __webpack_require__(9565);
var toObject = __webpack_require__(8981);
var callWithSafeIterationClosing = __webpack_require__(6319);
var isArrayIteratorMethod = __webpack_require__(4209);
var isConstructor = __webpack_require__(3517);
var lengthOfArrayLike = __webpack_require__(6198);
var createProperty = __webpack_require__(2278);
var getIterator = __webpack_require__(81);
var getIteratorMethod = __webpack_require__(851);

var $Array = Array;

// `Array.from` method implementation
// https://tc39.es/ecma262/#sec-array.from
module.exports = function from(arrayLike /* , mapfn = undefined, thisArg = undefined */) {
  var O = toObject(arrayLike);
  var IS_CONSTRUCTOR = isConstructor(this);
  var argumentsLength = arguments.length;
  var mapfn = argumentsLength > 1 ? arguments[1] : undefined;
  var mapping = mapfn !== undefined;
  if (mapping) mapfn = bind(mapfn, argumentsLength > 2 ? arguments[2] : undefined);
  var iteratorMethod = getIteratorMethod(O);
  var index = 0;
  var length, result, step, iterator, next, value;
  // if the target is not iterable or it's an array with the default iterator - use a simple case
  if (iteratorMethod && !(this === $Array && isArrayIteratorMethod(iteratorMethod))) {
    result = IS_CONSTRUCTOR ? new this() : [];
    iterator = getIterator(O, iteratorMethod);
    next = iterator.next;
    for (;!(step = call(next, iterator)).done; index++) {
      value = mapping ? callWithSafeIterationClosing(iterator, mapfn, [step.value, index], true) : step.value;
      createProperty(result, index, value);
    }
  } else {
    length = lengthOfArrayLike(O);
    result = IS_CONSTRUCTOR ? new this(length) : $Array(length);
    for (;length > index; index++) {
      value = mapping ? mapfn(O[index], index) : O[index];
      createProperty(result, index, value);
    }
  }
  result.length = index;
  return result;
};


/***/ }),

/***/ 9617:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIndexedObject = __webpack_require__(5397);
var toAbsoluteIndex = __webpack_require__(5610);
var lengthOfArrayLike = __webpack_require__(6198);

// `Array.prototype.{ indexOf, includes }` methods implementation
var createMethod = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIndexedObject($this);
    var length = lengthOfArrayLike(O);
    if (length === 0) return !IS_INCLUDES && -1;
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare -- NaN check
    if (IS_INCLUDES && el !== el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare -- NaN check
      if (value !== value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) {
      if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};

module.exports = {
  // `Array.prototype.includes` method
  // https://tc39.es/ecma262/#sec-array.prototype.includes
  includes: createMethod(true),
  // `Array.prototype.indexOf` method
  // https://tc39.es/ecma262/#sec-array.prototype.indexof
  indexOf: createMethod(false)
};


/***/ }),

/***/ 3839:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var bind = __webpack_require__(6080);
var IndexedObject = __webpack_require__(7055);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);

// `Array.prototype.{ findLast, findLastIndex }` methods implementation
var createMethod = function (TYPE) {
  var IS_FIND_LAST_INDEX = TYPE === 1;
  return function ($this, callbackfn, that) {
    var O = toObject($this);
    var self = IndexedObject(O);
    var index = lengthOfArrayLike(self);
    var boundFunction = bind(callbackfn, that);
    var value, result;
    while (index-- > 0) {
      value = self[index];
      result = boundFunction(value, index, O);
      if (result) switch (TYPE) {
        case 0: return value; // findLast
        case 1: return index; // findLastIndex
      }
    }
    return IS_FIND_LAST_INDEX ? -1 : undefined;
  };
};

module.exports = {
  // `Array.prototype.findLast` method
  // https://github.com/tc39/proposal-array-find-from-last
  findLast: createMethod(0),
  // `Array.prototype.findLastIndex` method
  // https://github.com/tc39/proposal-array-find-from-last
  findLastIndex: createMethod(1)
};


/***/ }),

/***/ 9213:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var bind = __webpack_require__(6080);
var uncurryThis = __webpack_require__(9504);
var IndexedObject = __webpack_require__(7055);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var arraySpeciesCreate = __webpack_require__(1469);

var push = uncurryThis([].push);

// `Array.prototype.{ forEach, map, filter, some, every, find, findIndex, filterReject }` methods implementation
var createMethod = function (TYPE) {
  var IS_MAP = TYPE === 1;
  var IS_FILTER = TYPE === 2;
  var IS_SOME = TYPE === 3;
  var IS_EVERY = TYPE === 4;
  var IS_FIND_INDEX = TYPE === 6;
  var IS_FILTER_REJECT = TYPE === 7;
  var NO_HOLES = TYPE === 5 || IS_FIND_INDEX;
  return function ($this, callbackfn, that, specificCreate) {
    var O = toObject($this);
    var self = IndexedObject(O);
    var length = lengthOfArrayLike(self);
    var boundFunction = bind(callbackfn, that);
    var index = 0;
    var create = specificCreate || arraySpeciesCreate;
    var target = IS_MAP ? create($this, length) : IS_FILTER || IS_FILTER_REJECT ? create($this, 0) : undefined;
    var value, result;
    for (;length > index; index++) if (NO_HOLES || index in self) {
      value = self[index];
      result = boundFunction(value, index, O);
      if (TYPE) {
        if (IS_MAP) target[index] = result; // map
        else if (result) switch (TYPE) {
          case 3: return true;              // some
          case 5: return value;             // find
          case 6: return index;             // findIndex
          case 2: push(target, value);      // filter
        } else switch (TYPE) {
          case 4: return false;             // every
          case 7: push(target, value);      // filterReject
        }
      }
    }
    return IS_FIND_INDEX ? -1 : IS_SOME || IS_EVERY ? IS_EVERY : target;
  };
};

module.exports = {
  // `Array.prototype.forEach` method
  // https://tc39.es/ecma262/#sec-array.prototype.foreach
  forEach: createMethod(0),
  // `Array.prototype.map` method
  // https://tc39.es/ecma262/#sec-array.prototype.map
  map: createMethod(1),
  // `Array.prototype.filter` method
  // https://tc39.es/ecma262/#sec-array.prototype.filter
  filter: createMethod(2),
  // `Array.prototype.some` method
  // https://tc39.es/ecma262/#sec-array.prototype.some
  some: createMethod(3),
  // `Array.prototype.every` method
  // https://tc39.es/ecma262/#sec-array.prototype.every
  every: createMethod(4),
  // `Array.prototype.find` method
  // https://tc39.es/ecma262/#sec-array.prototype.find
  find: createMethod(5),
  // `Array.prototype.findIndex` method
  // https://tc39.es/ecma262/#sec-array.prototype.findIndex
  findIndex: createMethod(6),
  // `Array.prototype.filterReject` method
  // https://github.com/tc39/proposal-array-filtering
  filterReject: createMethod(7)
};


/***/ }),

/***/ 8379:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable es/no-array-prototype-lastindexof -- safe */
var apply = __webpack_require__(8745);
var toIndexedObject = __webpack_require__(5397);
var toIntegerOrInfinity = __webpack_require__(1291);
var lengthOfArrayLike = __webpack_require__(6198);
var arrayMethodIsStrict = __webpack_require__(4598);

var min = Math.min;
var $lastIndexOf = [].lastIndexOf;
var NEGATIVE_ZERO = !!$lastIndexOf && 1 / [1].lastIndexOf(1, -0) < 0;
var STRICT_METHOD = arrayMethodIsStrict('lastIndexOf');
var FORCED = NEGATIVE_ZERO || !STRICT_METHOD;

// `Array.prototype.lastIndexOf` method implementation
// https://tc39.es/ecma262/#sec-array.prototype.lastindexof
module.exports = FORCED ? function lastIndexOf(searchElement /* , fromIndex = @[*-1] */) {
  // convert -0 to +0
  if (NEGATIVE_ZERO) return apply($lastIndexOf, this, arguments) || 0;
  var O = toIndexedObject(this);
  var length = lengthOfArrayLike(O);
  if (length === 0) return -1;
  var index = length - 1;
  if (arguments.length > 1) index = min(index, toIntegerOrInfinity(arguments[1]));
  if (index < 0) index = length + index;
  for (;index >= 0; index--) if (index in O && O[index] === searchElement) return index || 0;
  return -1;
} : $lastIndexOf;


/***/ }),

/***/ 597:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var wellKnownSymbol = __webpack_require__(8227);
var V8_VERSION = __webpack_require__(9519);

var SPECIES = wellKnownSymbol('species');

module.exports = function (METHOD_NAME) {
  // We can't use this feature detection in V8 since it causes
  // deoptimization and serious performance degradation
  // https://github.com/zloirock/core-js/issues/677
  return V8_VERSION >= 51 || !fails(function () {
    var array = [];
    var constructor = array.constructor = {};
    constructor[SPECIES] = function () {
      return { foo: 1 };
    };
    return array[METHOD_NAME](Boolean).foo !== 1;
  });
};


/***/ }),

/***/ 4598:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);

module.exports = function (METHOD_NAME, argument) {
  var method = [][METHOD_NAME];
  return !!method && fails(function () {
    // eslint-disable-next-line no-useless-call -- required for testing
    method.call(null, argument || function () { return 1; }, 1);
  });
};


/***/ }),

/***/ 926:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aCallable = __webpack_require__(9306);
var toObject = __webpack_require__(8981);
var IndexedObject = __webpack_require__(7055);
var lengthOfArrayLike = __webpack_require__(6198);

var $TypeError = TypeError;

var REDUCE_EMPTY = 'Reduce of empty array with no initial value';

// `Array.prototype.{ reduce, reduceRight }` methods implementation
var createMethod = function (IS_RIGHT) {
  return function (that, callbackfn, argumentsLength, memo) {
    var O = toObject(that);
    var self = IndexedObject(O);
    var length = lengthOfArrayLike(O);
    aCallable(callbackfn);
    if (length === 0 && argumentsLength < 2) throw new $TypeError(REDUCE_EMPTY);
    var index = IS_RIGHT ? length - 1 : 0;
    var i = IS_RIGHT ? -1 : 1;
    if (argumentsLength < 2) while (true) {
      if (index in self) {
        memo = self[index];
        index += i;
        break;
      }
      index += i;
      if (IS_RIGHT ? index < 0 : length <= index) {
        throw new $TypeError(REDUCE_EMPTY);
      }
    }
    for (;IS_RIGHT ? index >= 0 : length > index; index += i) if (index in self) {
      memo = callbackfn(memo, self[index], index, O);
    }
    return memo;
  };
};

module.exports = {
  // `Array.prototype.reduce` method
  // https://tc39.es/ecma262/#sec-array.prototype.reduce
  left: createMethod(false),
  // `Array.prototype.reduceRight` method
  // https://tc39.es/ecma262/#sec-array.prototype.reduceright
  right: createMethod(true)
};


/***/ }),

/***/ 4527:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var isArray = __webpack_require__(4376);

var $TypeError = TypeError;
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Safari < 13 does not throw an error in this case
var SILENT_ON_NON_WRITABLE_LENGTH_SET = DESCRIPTORS && !function () {
  // makes no sense without proper strict mode support
  if (this !== undefined) return true;
  try {
    // eslint-disable-next-line es/no-object-defineproperty -- safe
    Object.defineProperty([], 'length', { writable: false }).length = 1;
  } catch (error) {
    return error instanceof TypeError;
  }
}();

module.exports = SILENT_ON_NON_WRITABLE_LENGTH_SET ? function (O, length) {
  if (isArray(O) && !getOwnPropertyDescriptor(O, 'length').writable) {
    throw new $TypeError('Cannot set read only .length');
  } return O.length = length;
} : function (O, length) {
  return O.length = length;
};


/***/ }),

/***/ 7680:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

module.exports = uncurryThis([].slice);


/***/ }),

/***/ 4488:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var arraySlice = __webpack_require__(7680);

var floor = Math.floor;

var sort = function (array, comparefn) {
  var length = array.length;

  if (length < 8) {
    // insertion sort
    var i = 1;
    var element, j;

    while (i < length) {
      j = i;
      element = array[i];
      while (j && comparefn(array[j - 1], element) > 0) {
        array[j] = array[--j];
      }
      if (j !== i++) array[j] = element;
    }
  } else {
    // merge sort
    var middle = floor(length / 2);
    var left = sort(arraySlice(array, 0, middle), comparefn);
    var right = sort(arraySlice(array, middle), comparefn);
    var llength = left.length;
    var rlength = right.length;
    var lindex = 0;
    var rindex = 0;

    while (lindex < llength || rindex < rlength) {
      array[lindex + rindex] = (lindex < llength && rindex < rlength)
        ? comparefn(left[lindex], right[rindex]) <= 0 ? left[lindex++] : right[rindex++]
        : lindex < llength ? left[lindex++] : right[rindex++];
    }
  }

  return array;
};

module.exports = sort;


/***/ }),

/***/ 7433:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isArray = __webpack_require__(4376);
var isConstructor = __webpack_require__(3517);
var isObject = __webpack_require__(34);
var wellKnownSymbol = __webpack_require__(8227);

var SPECIES = wellKnownSymbol('species');
var $Array = Array;

// a part of `ArraySpeciesCreate` abstract operation
// https://tc39.es/ecma262/#sec-arrayspeciescreate
module.exports = function (originalArray) {
  var C;
  if (isArray(originalArray)) {
    C = originalArray.constructor;
    // cross-realm fallback
    if (isConstructor(C) && (C === $Array || isArray(C.prototype))) C = undefined;
    else if (isObject(C)) {
      C = C[SPECIES];
      if (C === null) C = undefined;
    }
  } return C === undefined ? $Array : C;
};


/***/ }),

/***/ 1469:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var arraySpeciesConstructor = __webpack_require__(7433);

// `ArraySpeciesCreate` abstract operation
// https://tc39.es/ecma262/#sec-arrayspeciescreate
module.exports = function (originalArray, length) {
  return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
};


/***/ }),

/***/ 7628:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var lengthOfArrayLike = __webpack_require__(6198);

// https://tc39.es/proposal-change-array-by-copy/#sec-array.prototype.toReversed
// https://tc39.es/proposal-change-array-by-copy/#sec-%typedarray%.prototype.toReversed
module.exports = function (O, C) {
  var len = lengthOfArrayLike(O);
  var A = new C(len);
  var k = 0;
  for (; k < len; k++) A[k] = O[len - k - 1];
  return A;
};


/***/ }),

/***/ 9928:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var lengthOfArrayLike = __webpack_require__(6198);
var toIntegerOrInfinity = __webpack_require__(1291);

var $RangeError = RangeError;

// https://tc39.es/proposal-change-array-by-copy/#sec-array.prototype.with
// https://tc39.es/proposal-change-array-by-copy/#sec-%typedarray%.prototype.with
module.exports = function (O, C, index, value) {
  var len = lengthOfArrayLike(O);
  var relativeIndex = toIntegerOrInfinity(index);
  var actualIndex = relativeIndex < 0 ? len + relativeIndex : relativeIndex;
  if (actualIndex >= len || actualIndex < 0) throw new $RangeError('Incorrect index');
  var A = new C(len);
  var k = 0;
  for (; k < len; k++) A[k] = k === actualIndex ? value : O[k];
  return A;
};


/***/ }),

/***/ 2804:
/***/ ((module) => {


var commonAlphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
var base64Alphabet = commonAlphabet + '+/';
var base64UrlAlphabet = commonAlphabet + '-_';

var inverse = function (characters) {
  // TODO: use `Object.create(null)` in `core-js@4`
  var result = {};
  var index = 0;
  for (; index < 64; index++) result[characters.charAt(index)] = index;
  return result;
};

module.exports = {
  i2c: base64Alphabet,
  c2i: inverse(base64Alphabet),
  i2cUrl: base64UrlAlphabet,
  c2iUrl: inverse(base64UrlAlphabet)
};


/***/ }),

/***/ 6319:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var anObject = __webpack_require__(8551);
var iteratorClose = __webpack_require__(9539);

// call something on iterator step with safe closing on error
module.exports = function (iterator, fn, value, ENTRIES) {
  try {
    return ENTRIES ? fn(anObject(value)[0], value[1]) : fn(value);
  } catch (error) {
    iteratorClose(iterator, 'throw', error);
  }
};


/***/ }),

/***/ 4428:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);

var ITERATOR = wellKnownSymbol('iterator');
var SAFE_CLOSING = false;

try {
  var called = 0;
  var iteratorWithReturn = {
    next: function () {
      return { done: !!called++ };
    },
    'return': function () {
      SAFE_CLOSING = true;
    }
  };
  iteratorWithReturn[ITERATOR] = function () {
    return this;
  };
  // eslint-disable-next-line es/no-array-from, no-throw-literal -- required for testing
  Array.from(iteratorWithReturn, function () { throw 2; });
} catch (error) { /* empty */ }

module.exports = function (exec, SKIP_CLOSING) {
  try {
    if (!SKIP_CLOSING && !SAFE_CLOSING) return false;
  } catch (error) { return false; } // workaround of old WebKit + `eval` bug
  var ITERATION_SUPPORT = false;
  try {
    var object = {};
    object[ITERATOR] = function () {
      return {
        next: function () {
          return { done: ITERATION_SUPPORT = true };
        }
      };
    };
    exec(object);
  } catch (error) { /* empty */ }
  return ITERATION_SUPPORT;
};


/***/ }),

/***/ 2195:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

var toString = uncurryThis({}.toString);
var stringSlice = uncurryThis(''.slice);

module.exports = function (it) {
  return stringSlice(toString(it), 8, -1);
};


/***/ }),

/***/ 6955:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var TO_STRING_TAG_SUPPORT = __webpack_require__(2140);
var isCallable = __webpack_require__(4901);
var classofRaw = __webpack_require__(2195);
var wellKnownSymbol = __webpack_require__(8227);

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
var $Object = Object;

// ES3 wrong here
var CORRECT_ARGUMENTS = classofRaw(function () { return arguments; }()) === 'Arguments';

// fallback for IE11 Script Access Denied error
var tryGet = function (it, key) {
  try {
    return it[key];
  } catch (error) { /* empty */ }
};

// getting tag from ES6+ `Object.prototype.toString`
module.exports = TO_STRING_TAG_SUPPORT ? classofRaw : function (it) {
  var O, tag, result;
  return it === undefined ? 'Undefined' : it === null ? 'Null'
    // @@toStringTag case
    : typeof (tag = tryGet(O = $Object(it), TO_STRING_TAG)) == 'string' ? tag
    // builtinTag case
    : CORRECT_ARGUMENTS ? classofRaw(O)
    // ES3 arguments fallback
    : (result = classofRaw(O)) === 'Object' && isCallable(O.callee) ? 'Arguments' : result;
};


/***/ }),

/***/ 6938:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var create = __webpack_require__(2360);
var defineBuiltInAccessor = __webpack_require__(2106);
var defineBuiltIns = __webpack_require__(6279);
var bind = __webpack_require__(6080);
var anInstance = __webpack_require__(679);
var isNullOrUndefined = __webpack_require__(4117);
var iterate = __webpack_require__(2652);
var defineIterator = __webpack_require__(1088);
var createIterResultObject = __webpack_require__(2529);
var setSpecies = __webpack_require__(7633);
var DESCRIPTORS = __webpack_require__(3724);
var fastKey = (__webpack_require__(3451).fastKey);
var InternalStateModule = __webpack_require__(1181);

var setInternalState = InternalStateModule.set;
var internalStateGetterFor = InternalStateModule.getterFor;

module.exports = {
  getConstructor: function (wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER) {
    var Constructor = wrapper(function (that, iterable) {
      anInstance(that, Prototype);
      setInternalState(that, {
        type: CONSTRUCTOR_NAME,
        index: create(null),
        first: null,
        last: null,
        size: 0
      });
      if (!DESCRIPTORS) that.size = 0;
      if (!isNullOrUndefined(iterable)) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
    });

    var Prototype = Constructor.prototype;

    var getInternalState = internalStateGetterFor(CONSTRUCTOR_NAME);

    var define = function (that, key, value) {
      var state = getInternalState(that);
      var entry = getEntry(that, key);
      var previous, index;
      // change existing entry
      if (entry) {
        entry.value = value;
      // create new entry
      } else {
        state.last = entry = {
          index: index = fastKey(key, true),
          key: key,
          value: value,
          previous: previous = state.last,
          next: null,
          removed: false
        };
        if (!state.first) state.first = entry;
        if (previous) previous.next = entry;
        if (DESCRIPTORS) state.size++;
        else that.size++;
        // add to index
        if (index !== 'F') state.index[index] = entry;
      } return that;
    };

    var getEntry = function (that, key) {
      var state = getInternalState(that);
      // fast case
      var index = fastKey(key);
      var entry;
      if (index !== 'F') return state.index[index];
      // frozen object case
      for (entry = state.first; entry; entry = entry.next) {
        if (entry.key === key) return entry;
      }
    };

    defineBuiltIns(Prototype, {
      // `{ Map, Set }.prototype.clear()` methods
      // https://tc39.es/ecma262/#sec-map.prototype.clear
      // https://tc39.es/ecma262/#sec-set.prototype.clear
      clear: function clear() {
        var that = this;
        var state = getInternalState(that);
        var entry = state.first;
        while (entry) {
          entry.removed = true;
          if (entry.previous) entry.previous = entry.previous.next = null;
          entry = entry.next;
        }
        state.first = state.last = null;
        state.index = create(null);
        if (DESCRIPTORS) state.size = 0;
        else that.size = 0;
      },
      // `{ Map, Set }.prototype.delete(key)` methods
      // https://tc39.es/ecma262/#sec-map.prototype.delete
      // https://tc39.es/ecma262/#sec-set.prototype.delete
      'delete': function (key) {
        var that = this;
        var state = getInternalState(that);
        var entry = getEntry(that, key);
        if (entry) {
          var next = entry.next;
          var prev = entry.previous;
          delete state.index[entry.index];
          entry.removed = true;
          if (prev) prev.next = next;
          if (next) next.previous = prev;
          if (state.first === entry) state.first = next;
          if (state.last === entry) state.last = prev;
          if (DESCRIPTORS) state.size--;
          else that.size--;
        } return !!entry;
      },
      // `{ Map, Set }.prototype.forEach(callbackfn, thisArg = undefined)` methods
      // https://tc39.es/ecma262/#sec-map.prototype.foreach
      // https://tc39.es/ecma262/#sec-set.prototype.foreach
      forEach: function forEach(callbackfn /* , that = undefined */) {
        var state = getInternalState(this);
        var boundFunction = bind(callbackfn, arguments.length > 1 ? arguments[1] : undefined);
        var entry;
        while (entry = entry ? entry.next : state.first) {
          boundFunction(entry.value, entry.key, this);
          // revert to the last existing entry
          while (entry && entry.removed) entry = entry.previous;
        }
      },
      // `{ Map, Set}.prototype.has(key)` methods
      // https://tc39.es/ecma262/#sec-map.prototype.has
      // https://tc39.es/ecma262/#sec-set.prototype.has
      has: function has(key) {
        return !!getEntry(this, key);
      }
    });

    defineBuiltIns(Prototype, IS_MAP ? {
      // `Map.prototype.get(key)` method
      // https://tc39.es/ecma262/#sec-map.prototype.get
      get: function get(key) {
        var entry = getEntry(this, key);
        return entry && entry.value;
      },
      // `Map.prototype.set(key, value)` method
      // https://tc39.es/ecma262/#sec-map.prototype.set
      set: function set(key, value) {
        return define(this, key === 0 ? 0 : key, value);
      }
    } : {
      // `Set.prototype.add(value)` method
      // https://tc39.es/ecma262/#sec-set.prototype.add
      add: function add(value) {
        return define(this, value = value === 0 ? 0 : value, value);
      }
    });
    if (DESCRIPTORS) defineBuiltInAccessor(Prototype, 'size', {
      configurable: true,
      get: function () {
        return getInternalState(this).size;
      }
    });
    return Constructor;
  },
  setStrong: function (Constructor, CONSTRUCTOR_NAME, IS_MAP) {
    var ITERATOR_NAME = CONSTRUCTOR_NAME + ' Iterator';
    var getInternalCollectionState = internalStateGetterFor(CONSTRUCTOR_NAME);
    var getInternalIteratorState = internalStateGetterFor(ITERATOR_NAME);
    // `{ Map, Set }.prototype.{ keys, values, entries, @@iterator }()` methods
    // https://tc39.es/ecma262/#sec-map.prototype.entries
    // https://tc39.es/ecma262/#sec-map.prototype.keys
    // https://tc39.es/ecma262/#sec-map.prototype.values
    // https://tc39.es/ecma262/#sec-map.prototype-@@iterator
    // https://tc39.es/ecma262/#sec-set.prototype.entries
    // https://tc39.es/ecma262/#sec-set.prototype.keys
    // https://tc39.es/ecma262/#sec-set.prototype.values
    // https://tc39.es/ecma262/#sec-set.prototype-@@iterator
    defineIterator(Constructor, CONSTRUCTOR_NAME, function (iterated, kind) {
      setInternalState(this, {
        type: ITERATOR_NAME,
        target: iterated,
        state: getInternalCollectionState(iterated),
        kind: kind,
        last: null
      });
    }, function () {
      var state = getInternalIteratorState(this);
      var kind = state.kind;
      var entry = state.last;
      // revert to the last existing entry
      while (entry && entry.removed) entry = entry.previous;
      // get next entry
      if (!state.target || !(state.last = entry = entry ? entry.next : state.state.first)) {
        // or finish the iteration
        state.target = null;
        return createIterResultObject(undefined, true);
      }
      // return step by kind
      if (kind === 'keys') return createIterResultObject(entry.key, false);
      if (kind === 'values') return createIterResultObject(entry.value, false);
      return createIterResultObject([entry.key, entry.value], false);
    }, IS_MAP ? 'entries' : 'values', !IS_MAP, true);

    // `{ Map, Set }.prototype[@@species]` accessors
    // https://tc39.es/ecma262/#sec-get-map-@@species
    // https://tc39.es/ecma262/#sec-get-set-@@species
    setSpecies(CONSTRUCTOR_NAME);
  }
};


/***/ }),

/***/ 4006:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var defineBuiltIns = __webpack_require__(6279);
var getWeakData = (__webpack_require__(3451).getWeakData);
var anInstance = __webpack_require__(679);
var anObject = __webpack_require__(8551);
var isNullOrUndefined = __webpack_require__(4117);
var isObject = __webpack_require__(34);
var iterate = __webpack_require__(2652);
var ArrayIterationModule = __webpack_require__(9213);
var hasOwn = __webpack_require__(9297);
var InternalStateModule = __webpack_require__(1181);

var setInternalState = InternalStateModule.set;
var internalStateGetterFor = InternalStateModule.getterFor;
var find = ArrayIterationModule.find;
var findIndex = ArrayIterationModule.findIndex;
var splice = uncurryThis([].splice);
var id = 0;

// fallback for uncaught frozen keys
var uncaughtFrozenStore = function (state) {
  return state.frozen || (state.frozen = new UncaughtFrozenStore());
};

var UncaughtFrozenStore = function () {
  this.entries = [];
};

var findUncaughtFrozen = function (store, key) {
  return find(store.entries, function (it) {
    return it[0] === key;
  });
};

UncaughtFrozenStore.prototype = {
  get: function (key) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) return entry[1];
  },
  has: function (key) {
    return !!findUncaughtFrozen(this, key);
  },
  set: function (key, value) {
    var entry = findUncaughtFrozen(this, key);
    if (entry) entry[1] = value;
    else this.entries.push([key, value]);
  },
  'delete': function (key) {
    var index = findIndex(this.entries, function (it) {
      return it[0] === key;
    });
    if (~index) splice(this.entries, index, 1);
    return !!~index;
  }
};

module.exports = {
  getConstructor: function (wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER) {
    var Constructor = wrapper(function (that, iterable) {
      anInstance(that, Prototype);
      setInternalState(that, {
        type: CONSTRUCTOR_NAME,
        id: id++,
        frozen: null
      });
      if (!isNullOrUndefined(iterable)) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
    });

    var Prototype = Constructor.prototype;

    var getInternalState = internalStateGetterFor(CONSTRUCTOR_NAME);

    var define = function (that, key, value) {
      var state = getInternalState(that);
      var data = getWeakData(anObject(key), true);
      if (data === true) uncaughtFrozenStore(state).set(key, value);
      else data[state.id] = value;
      return that;
    };

    defineBuiltIns(Prototype, {
      // `{ WeakMap, WeakSet }.prototype.delete(key)` methods
      // https://tc39.es/ecma262/#sec-weakmap.prototype.delete
      // https://tc39.es/ecma262/#sec-weakset.prototype.delete
      'delete': function (key) {
        var state = getInternalState(this);
        if (!isObject(key)) return false;
        var data = getWeakData(key);
        if (data === true) return uncaughtFrozenStore(state)['delete'](key);
        return data && hasOwn(data, state.id) && delete data[state.id];
      },
      // `{ WeakMap, WeakSet }.prototype.has(key)` methods
      // https://tc39.es/ecma262/#sec-weakmap.prototype.has
      // https://tc39.es/ecma262/#sec-weakset.prototype.has
      has: function has(key) {
        var state = getInternalState(this);
        if (!isObject(key)) return false;
        var data = getWeakData(key);
        if (data === true) return uncaughtFrozenStore(state).has(key);
        return data && hasOwn(data, state.id);
      }
    });

    defineBuiltIns(Prototype, IS_MAP ? {
      // `WeakMap.prototype.get(key)` method
      // https://tc39.es/ecma262/#sec-weakmap.prototype.get
      get: function get(key) {
        var state = getInternalState(this);
        if (isObject(key)) {
          var data = getWeakData(key);
          if (data === true) return uncaughtFrozenStore(state).get(key);
          if (data) return data[state.id];
        }
      },
      // `WeakMap.prototype.set(key, value)` method
      // https://tc39.es/ecma262/#sec-weakmap.prototype.set
      set: function set(key, value) {
        return define(this, key, value);
      }
    } : {
      // `WeakSet.prototype.add(value)` method
      // https://tc39.es/ecma262/#sec-weakset.prototype.add
      add: function add(value) {
        return define(this, value, true);
      }
    });

    return Constructor;
  }
};


/***/ }),

/***/ 6468:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var isForced = __webpack_require__(2796);
var defineBuiltIn = __webpack_require__(6840);
var InternalMetadataModule = __webpack_require__(3451);
var iterate = __webpack_require__(2652);
var anInstance = __webpack_require__(679);
var isCallable = __webpack_require__(4901);
var isNullOrUndefined = __webpack_require__(4117);
var isObject = __webpack_require__(34);
var fails = __webpack_require__(9039);
var checkCorrectnessOfIteration = __webpack_require__(4428);
var setToStringTag = __webpack_require__(687);
var inheritIfRequired = __webpack_require__(3167);

module.exports = function (CONSTRUCTOR_NAME, wrapper, common) {
  var IS_MAP = CONSTRUCTOR_NAME.indexOf('Map') !== -1;
  var IS_WEAK = CONSTRUCTOR_NAME.indexOf('Weak') !== -1;
  var ADDER = IS_MAP ? 'set' : 'add';
  var NativeConstructor = globalThis[CONSTRUCTOR_NAME];
  var NativePrototype = NativeConstructor && NativeConstructor.prototype;
  var Constructor = NativeConstructor;
  var exported = {};

  var fixMethod = function (KEY) {
    var uncurriedNativeMethod = uncurryThis(NativePrototype[KEY]);
    defineBuiltIn(NativePrototype, KEY,
      KEY === 'add' ? function add(value) {
        uncurriedNativeMethod(this, value === 0 ? 0 : value);
        return this;
      } : KEY === 'delete' ? function (key) {
        return IS_WEAK && !isObject(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
      } : KEY === 'get' ? function get(key) {
        return IS_WEAK && !isObject(key) ? undefined : uncurriedNativeMethod(this, key === 0 ? 0 : key);
      } : KEY === 'has' ? function has(key) {
        return IS_WEAK && !isObject(key) ? false : uncurriedNativeMethod(this, key === 0 ? 0 : key);
      } : function set(key, value) {
        uncurriedNativeMethod(this, key === 0 ? 0 : key, value);
        return this;
      }
    );
  };

  var REPLACE = isForced(
    CONSTRUCTOR_NAME,
    !isCallable(NativeConstructor) || !(IS_WEAK || NativePrototype.forEach && !fails(function () {
      new NativeConstructor().entries().next();
    }))
  );

  if (REPLACE) {
    // create collection constructor
    Constructor = common.getConstructor(wrapper, CONSTRUCTOR_NAME, IS_MAP, ADDER);
    InternalMetadataModule.enable();
  } else if (isForced(CONSTRUCTOR_NAME, true)) {
    var instance = new Constructor();
    // early implementations not supports chaining
    var HASNT_CHAINING = instance[ADDER](IS_WEAK ? {} : -0, 1) !== instance;
    // V8 ~ Chromium 40- weak-collections throws on primitives, but should return false
    var THROWS_ON_PRIMITIVES = fails(function () { instance.has(1); });
    // most early implementations doesn't supports iterables, most modern - not close it correctly
    // eslint-disable-next-line no-new -- required for testing
    var ACCEPT_ITERABLES = checkCorrectnessOfIteration(function (iterable) { new NativeConstructor(iterable); });
    // for early implementations -0 and +0 not the same
    var BUGGY_ZERO = !IS_WEAK && fails(function () {
      // V8 ~ Chromium 42- fails only with 5+ elements
      var $instance = new NativeConstructor();
      var index = 5;
      while (index--) $instance[ADDER](index, index);
      return !$instance.has(-0);
    });

    if (!ACCEPT_ITERABLES) {
      Constructor = wrapper(function (dummy, iterable) {
        anInstance(dummy, NativePrototype);
        var that = inheritIfRequired(new NativeConstructor(), dummy, Constructor);
        if (!isNullOrUndefined(iterable)) iterate(iterable, that[ADDER], { that: that, AS_ENTRIES: IS_MAP });
        return that;
      });
      Constructor.prototype = NativePrototype;
      NativePrototype.constructor = Constructor;
    }

    if (THROWS_ON_PRIMITIVES || BUGGY_ZERO) {
      fixMethod('delete');
      fixMethod('has');
      IS_MAP && fixMethod('get');
    }

    if (BUGGY_ZERO || HASNT_CHAINING) fixMethod(ADDER);

    // weak collections should not contains .clear method
    if (IS_WEAK && NativePrototype.clear) delete NativePrototype.clear;
  }

  exported[CONSTRUCTOR_NAME] = Constructor;
  $({ global: true, constructor: true, forced: Constructor !== NativeConstructor }, exported);

  setToStringTag(Constructor, CONSTRUCTOR_NAME);

  if (!IS_WEAK) common.setStrong(Constructor, CONSTRUCTOR_NAME, IS_MAP);

  return Constructor;
};


/***/ }),

/***/ 7740:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var hasOwn = __webpack_require__(9297);
var ownKeys = __webpack_require__(5031);
var getOwnPropertyDescriptorModule = __webpack_require__(7347);
var definePropertyModule = __webpack_require__(4913);

module.exports = function (target, source, exceptions) {
  var keys = ownKeys(source);
  var defineProperty = definePropertyModule.f;
  var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    if (!hasOwn(target, key) && !(exceptions && hasOwn(exceptions, key))) {
      defineProperty(target, key, getOwnPropertyDescriptor(source, key));
    }
  }
};


/***/ }),

/***/ 1436:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);

var MATCH = wellKnownSymbol('match');

module.exports = function (METHOD_NAME) {
  var regexp = /./;
  try {
    '/./'[METHOD_NAME](regexp);
  } catch (error1) {
    try {
      regexp[MATCH] = false;
      return '/./'[METHOD_NAME](regexp);
    } catch (error2) { /* empty */ }
  } return false;
};


/***/ }),

/***/ 2211:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);

module.exports = !fails(function () {
  function F() { /* empty */ }
  F.prototype.constructor = null;
  // eslint-disable-next-line es/no-object-getprototypeof -- required for testing
  return Object.getPrototypeOf(new F()) !== F.prototype;
});


/***/ }),

/***/ 2529:
/***/ ((module) => {


// `CreateIterResultObject` abstract operation
// https://tc39.es/ecma262/#sec-createiterresultobject
module.exports = function (value, done) {
  return { value: value, done: done };
};


/***/ }),

/***/ 6699:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var definePropertyModule = __webpack_require__(4913);
var createPropertyDescriptor = __webpack_require__(6980);

module.exports = DESCRIPTORS ? function (object, key, value) {
  return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};


/***/ }),

/***/ 6980:
/***/ ((module) => {


module.exports = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};


/***/ }),

/***/ 2278:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var definePropertyModule = __webpack_require__(4913);
var createPropertyDescriptor = __webpack_require__(6980);

module.exports = function (object, key, value) {
  if (DESCRIPTORS) definePropertyModule.f(object, key, createPropertyDescriptor(0, value));
  else object[key] = value;
};


/***/ }),

/***/ 3640:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var anObject = __webpack_require__(8551);
var ordinaryToPrimitive = __webpack_require__(4270);

var $TypeError = TypeError;

// `Date.prototype[@@toPrimitive](hint)` method implementation
// https://tc39.es/ecma262/#sec-date.prototype-@@toprimitive
module.exports = function (hint) {
  anObject(this);
  if (hint === 'string' || hint === 'default') hint = 'string';
  else if (hint !== 'number') throw new $TypeError('Incorrect hint');
  return ordinaryToPrimitive(this, hint);
};


/***/ }),

/***/ 2106:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var makeBuiltIn = __webpack_require__(283);
var defineProperty = __webpack_require__(4913);

module.exports = function (target, name, descriptor) {
  if (descriptor.get) makeBuiltIn(descriptor.get, name, { getter: true });
  if (descriptor.set) makeBuiltIn(descriptor.set, name, { setter: true });
  return defineProperty.f(target, name, descriptor);
};


/***/ }),

/***/ 6840:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isCallable = __webpack_require__(4901);
var definePropertyModule = __webpack_require__(4913);
var makeBuiltIn = __webpack_require__(283);
var defineGlobalProperty = __webpack_require__(9433);

module.exports = function (O, key, value, options) {
  if (!options) options = {};
  var simple = options.enumerable;
  var name = options.name !== undefined ? options.name : key;
  if (isCallable(value)) makeBuiltIn(value, name, options);
  if (options.global) {
    if (simple) O[key] = value;
    else defineGlobalProperty(key, value);
  } else {
    try {
      if (!options.unsafe) delete O[key];
      else if (O[key]) simple = true;
    } catch (error) { /* empty */ }
    if (simple) O[key] = value;
    else definePropertyModule.f(O, key, {
      value: value,
      enumerable: false,
      configurable: !options.nonConfigurable,
      writable: !options.nonWritable
    });
  } return O;
};


/***/ }),

/***/ 6279:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var defineBuiltIn = __webpack_require__(6840);

module.exports = function (target, src, options) {
  for (var key in src) defineBuiltIn(target, key, src[key], options);
  return target;
};


/***/ }),

/***/ 9433:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);

// eslint-disable-next-line es/no-object-defineproperty -- safe
var defineProperty = Object.defineProperty;

module.exports = function (key, value) {
  try {
    defineProperty(globalThis, key, { value: value, configurable: true, writable: true });
  } catch (error) {
    globalThis[key] = value;
  } return value;
};


/***/ }),

/***/ 4606:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var tryToString = __webpack_require__(6823);

var $TypeError = TypeError;

module.exports = function (O, P) {
  if (!delete O[P]) throw new $TypeError('Cannot delete property ' + tryToString(P) + ' of ' + tryToString(O));
};


/***/ }),

/***/ 3724:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);

// Detect IE8's incomplete defineProperty implementation
module.exports = !fails(function () {
  // eslint-disable-next-line es/no-object-defineproperty -- required for testing
  return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] !== 7;
});


/***/ }),

/***/ 4483:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var getBuiltInNodeModule = __webpack_require__(9429);
var PROPER_STRUCTURED_CLONE_TRANSFER = __webpack_require__(1548);

var structuredClone = globalThis.structuredClone;
var $ArrayBuffer = globalThis.ArrayBuffer;
var $MessageChannel = globalThis.MessageChannel;
var detach = false;
var WorkerThreads, channel, buffer, $detach;

if (PROPER_STRUCTURED_CLONE_TRANSFER) {
  detach = function (transferable) {
    structuredClone(transferable, { transfer: [transferable] });
  };
} else if ($ArrayBuffer) try {
  if (!$MessageChannel) {
    WorkerThreads = getBuiltInNodeModule('worker_threads');
    if (WorkerThreads) $MessageChannel = WorkerThreads.MessageChannel;
  }

  if ($MessageChannel) {
    channel = new $MessageChannel();
    buffer = new $ArrayBuffer(2);

    $detach = function (transferable) {
      channel.port1.postMessage(null, [transferable]);
    };

    if (buffer.byteLength === 2) {
      $detach(buffer);
      if (buffer.byteLength === 0) detach = $detach;
    }
  }
} catch (error) { /* empty */ }

module.exports = detach;


/***/ }),

/***/ 4055:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var isObject = __webpack_require__(34);

var document = globalThis.document;
// typeof document.createElement is 'object' in old IE
var EXISTS = isObject(document) && isObject(document.createElement);

module.exports = function (it) {
  return EXISTS ? document.createElement(it) : {};
};


/***/ }),

/***/ 6837:
/***/ ((module) => {


var $TypeError = TypeError;
var MAX_SAFE_INTEGER = 0x1FFFFFFFFFFFFF; // 2 ** 53 - 1 == 9007199254740991

module.exports = function (it) {
  if (it > MAX_SAFE_INTEGER) throw $TypeError('Maximum allowed index exceeded');
  return it;
};


/***/ }),

/***/ 5002:
/***/ ((module) => {


module.exports = {
  IndexSizeError: { s: 'INDEX_SIZE_ERR', c: 1, m: 1 },
  DOMStringSizeError: { s: 'DOMSTRING_SIZE_ERR', c: 2, m: 0 },
  HierarchyRequestError: { s: 'HIERARCHY_REQUEST_ERR', c: 3, m: 1 },
  WrongDocumentError: { s: 'WRONG_DOCUMENT_ERR', c: 4, m: 1 },
  InvalidCharacterError: { s: 'INVALID_CHARACTER_ERR', c: 5, m: 1 },
  NoDataAllowedError: { s: 'NO_DATA_ALLOWED_ERR', c: 6, m: 0 },
  NoModificationAllowedError: { s: 'NO_MODIFICATION_ALLOWED_ERR', c: 7, m: 1 },
  NotFoundError: { s: 'NOT_FOUND_ERR', c: 8, m: 1 },
  NotSupportedError: { s: 'NOT_SUPPORTED_ERR', c: 9, m: 1 },
  InUseAttributeError: { s: 'INUSE_ATTRIBUTE_ERR', c: 10, m: 1 },
  InvalidStateError: { s: 'INVALID_STATE_ERR', c: 11, m: 1 },
  SyntaxError: { s: 'SYNTAX_ERR', c: 12, m: 1 },
  InvalidModificationError: { s: 'INVALID_MODIFICATION_ERR', c: 13, m: 1 },
  NamespaceError: { s: 'NAMESPACE_ERR', c: 14, m: 1 },
  InvalidAccessError: { s: 'INVALID_ACCESS_ERR', c: 15, m: 1 },
  ValidationError: { s: 'VALIDATION_ERR', c: 16, m: 0 },
  TypeMismatchError: { s: 'TYPE_MISMATCH_ERR', c: 17, m: 1 },
  SecurityError: { s: 'SECURITY_ERR', c: 18, m: 1 },
  NetworkError: { s: 'NETWORK_ERR', c: 19, m: 1 },
  AbortError: { s: 'ABORT_ERR', c: 20, m: 1 },
  URLMismatchError: { s: 'URL_MISMATCH_ERR', c: 21, m: 1 },
  QuotaExceededError: { s: 'QUOTA_EXCEEDED_ERR', c: 22, m: 1 },
  TimeoutError: { s: 'TIMEOUT_ERR', c: 23, m: 1 },
  InvalidNodeTypeError: { s: 'INVALID_NODE_TYPE_ERR', c: 24, m: 1 },
  DataCloneError: { s: 'DATA_CLONE_ERR', c: 25, m: 1 }
};


/***/ }),

/***/ 7400:
/***/ ((module) => {


// iterable DOM collections
// flag - `iterable` interface - 'entries', 'keys', 'values', 'forEach' methods
module.exports = {
  CSSRuleList: 0,
  CSSStyleDeclaration: 0,
  CSSValueList: 0,
  ClientRectList: 0,
  DOMRectList: 0,
  DOMStringList: 0,
  DOMTokenList: 1,
  DataTransferItemList: 0,
  FileList: 0,
  HTMLAllCollection: 0,
  HTMLCollection: 0,
  HTMLFormElement: 0,
  HTMLSelectElement: 0,
  MediaList: 0,
  MimeTypeArray: 0,
  NamedNodeMap: 0,
  NodeList: 1,
  PaintRequestList: 0,
  Plugin: 0,
  PluginArray: 0,
  SVGLengthList: 0,
  SVGNumberList: 0,
  SVGPathSegList: 0,
  SVGPointList: 0,
  SVGStringList: 0,
  SVGTransformList: 0,
  SourceBufferList: 0,
  StyleSheetList: 0,
  TextTrackCueList: 0,
  TextTrackList: 0,
  TouchList: 0
};


/***/ }),

/***/ 9296:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// in old WebKit versions, `element.classList` is not an instance of global `DOMTokenList`
var documentCreateElement = __webpack_require__(4055);

var classList = documentCreateElement('span').classList;
var DOMTokenListPrototype = classList && classList.constructor && classList.constructor.prototype;

module.exports = DOMTokenListPrototype === Object.prototype ? undefined : DOMTokenListPrototype;


/***/ }),

/***/ 8727:
/***/ ((module) => {


// IE8- don't enum bug keys
module.exports = [
  'constructor',
  'hasOwnProperty',
  'isPrototypeOf',
  'propertyIsEnumerable',
  'toLocaleString',
  'toString',
  'valueOf'
];


/***/ }),

/***/ 3709:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var userAgent = __webpack_require__(2839);

var firefox = userAgent.match(/firefox\/(\d+)/i);

module.exports = !!firefox && +firefox[1];


/***/ }),

/***/ 3763:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var UA = __webpack_require__(2839);

module.exports = /MSIE|Trident/.test(UA);


/***/ }),

/***/ 4265:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var userAgent = __webpack_require__(2839);

module.exports = /ipad|iphone|ipod/i.test(userAgent) && typeof Pebble != 'undefined';


/***/ }),

/***/ 9544:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var userAgent = __webpack_require__(2839);

// eslint-disable-next-line redos/no-vulnerable -- safe
module.exports = /(?:ipad|iphone|ipod).*applewebkit/i.test(userAgent);


/***/ }),

/***/ 8574:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var ENVIRONMENT = __webpack_require__(4215);

module.exports = ENVIRONMENT === 'NODE';


/***/ }),

/***/ 7860:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var userAgent = __webpack_require__(2839);

module.exports = /web0s(?!.*chrome)/i.test(userAgent);


/***/ }),

/***/ 2839:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);

var navigator = globalThis.navigator;
var userAgent = navigator && navigator.userAgent;

module.exports = userAgent ? String(userAgent) : '';


/***/ }),

/***/ 9519:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var userAgent = __webpack_require__(2839);

var process = globalThis.process;
var Deno = globalThis.Deno;
var versions = process && process.versions || Deno && Deno.version;
var v8 = versions && versions.v8;
var match, version;

if (v8) {
  match = v8.split('.');
  // in old Chrome, versions of V8 isn't V8 = Chrome / 10
  // but their correct versions are not interesting for us
  version = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
}

// BrowserFS NodeJS `process` polyfill incorrectly set `.v8` to `0.0`
// so check `userAgent` even if `.v8` exists, but 0
if (!version && userAgent) {
  match = userAgent.match(/Edge\/(\d+)/);
  if (!match || match[1] >= 74) {
    match = userAgent.match(/Chrome\/(\d+)/);
    if (match) version = +match[1];
  }
}

module.exports = version;


/***/ }),

/***/ 3607:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var userAgent = __webpack_require__(2839);

var webkit = userAgent.match(/AppleWebKit\/(\d+)\./);

module.exports = !!webkit && +webkit[1];


/***/ }),

/***/ 4215:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* global Bun, Deno -- detection */
var globalThis = __webpack_require__(4576);
var userAgent = __webpack_require__(2839);
var classof = __webpack_require__(2195);

var userAgentStartsWith = function (string) {
  return userAgent.slice(0, string.length) === string;
};

module.exports = (function () {
  if (userAgentStartsWith('Bun/')) return 'BUN';
  if (userAgentStartsWith('Cloudflare-Workers')) return 'CLOUDFLARE';
  if (userAgentStartsWith('Deno/')) return 'DENO';
  if (userAgentStartsWith('Node.js/')) return 'NODE';
  if (globalThis.Bun && typeof Bun.version == 'string') return 'BUN';
  if (globalThis.Deno && typeof Deno.version == 'object') return 'DENO';
  if (classof(globalThis.process) === 'process') return 'NODE';
  if (globalThis.window && globalThis.document) return 'BROWSER';
  return 'REST';
})();


/***/ }),

/***/ 6193:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

var $Error = Error;
var replace = uncurryThis(''.replace);

var TEST = (function (arg) { return String(new $Error(arg).stack); })('zxcasd');
// eslint-disable-next-line redos/no-vulnerable, sonarjs/slow-regex -- safe
var V8_OR_CHAKRA_STACK_ENTRY = /\n\s*at [^:]*:[^\n]*/;
var IS_V8_OR_CHAKRA_STACK = V8_OR_CHAKRA_STACK_ENTRY.test(TEST);

module.exports = function (stack, dropEntries) {
  if (IS_V8_OR_CHAKRA_STACK && typeof stack == 'string' && !$Error.prepareStackTrace) {
    while (dropEntries--) stack = replace(stack, V8_OR_CHAKRA_STACK_ENTRY, '');
  } return stack;
};


/***/ }),

/***/ 747:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var createNonEnumerableProperty = __webpack_require__(6699);
var clearErrorStack = __webpack_require__(6193);
var ERROR_STACK_INSTALLABLE = __webpack_require__(4659);

// non-standard V8
var captureStackTrace = Error.captureStackTrace;

module.exports = function (error, C, stack, dropEntries) {
  if (ERROR_STACK_INSTALLABLE) {
    if (captureStackTrace) captureStackTrace(error, C);
    else createNonEnumerableProperty(error, 'stack', clearErrorStack(stack, dropEntries));
  }
};


/***/ }),

/***/ 4659:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var createPropertyDescriptor = __webpack_require__(6980);

module.exports = !fails(function () {
  var error = new Error('a');
  if (!('stack' in error)) return true;
  // eslint-disable-next-line es/no-object-defineproperty -- safe
  Object.defineProperty(error, 'stack', createPropertyDescriptor(1, 7));
  return error.stack !== 7;
});


/***/ }),

/***/ 7536:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var fails = __webpack_require__(9039);
var anObject = __webpack_require__(8551);
var normalizeStringArgument = __webpack_require__(2603);

var nativeErrorToString = Error.prototype.toString;

var INCORRECT_TO_STRING = fails(function () {
  if (DESCRIPTORS) {
    // Chrome 32- incorrectly call accessor
    // eslint-disable-next-line es/no-object-create, es/no-object-defineproperty -- safe
    var object = Object.create(Object.defineProperty({}, 'name', { get: function () {
      return this === object;
    } }));
    if (nativeErrorToString.call(object) !== 'true') return true;
  }
  // FF10- does not properly handle non-strings
  return nativeErrorToString.call({ message: 1, name: 2 }) !== '2: 1'
    // IE8 does not properly handle defaults
    || nativeErrorToString.call({}) !== 'Error';
});

module.exports = INCORRECT_TO_STRING ? function toString() {
  var O = anObject(this);
  var name = normalizeStringArgument(O.name, 'Error');
  var message = normalizeStringArgument(O.message);
  return !name ? message : !message ? name : name + ': ' + message;
} : nativeErrorToString;


/***/ }),

/***/ 6518:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var getOwnPropertyDescriptor = (__webpack_require__(7347).f);
var createNonEnumerableProperty = __webpack_require__(6699);
var defineBuiltIn = __webpack_require__(6840);
var defineGlobalProperty = __webpack_require__(9433);
var copyConstructorProperties = __webpack_require__(7740);
var isForced = __webpack_require__(2796);

/*
  options.target         - name of the target object
  options.global         - target is the global object
  options.stat           - export as static methods of target
  options.proto          - export as prototype methods of target
  options.real           - real prototype method for the `pure` version
  options.forced         - export even if the native feature is available
  options.bind           - bind methods to the target, required for the `pure` version
  options.wrap           - wrap constructors to preventing global pollution, required for the `pure` version
  options.unsafe         - use the simple assignment of property instead of delete + defineProperty
  options.sham           - add a flag to not completely full polyfills
  options.enumerable     - export as enumerable property
  options.dontCallGetSet - prevent calling a getter on target
  options.name           - the .name of the function if it does not match the key
*/
module.exports = function (options, source) {
  var TARGET = options.target;
  var GLOBAL = options.global;
  var STATIC = options.stat;
  var FORCED, target, key, targetProperty, sourceProperty, descriptor;
  if (GLOBAL) {
    target = globalThis;
  } else if (STATIC) {
    target = globalThis[TARGET] || defineGlobalProperty(TARGET, {});
  } else {
    target = globalThis[TARGET] && globalThis[TARGET].prototype;
  }
  if (target) for (key in source) {
    sourceProperty = source[key];
    if (options.dontCallGetSet) {
      descriptor = getOwnPropertyDescriptor(target, key);
      targetProperty = descriptor && descriptor.value;
    } else targetProperty = target[key];
    FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
    // contained in target
    if (!FORCED && targetProperty !== undefined) {
      if (typeof sourceProperty == typeof targetProperty) continue;
      copyConstructorProperties(sourceProperty, targetProperty);
    }
    // add a flag to not completely full polyfills
    if (options.sham || (targetProperty && targetProperty.sham)) {
      createNonEnumerableProperty(sourceProperty, 'sham', true);
    }
    defineBuiltIn(target, key, sourceProperty, options);
  }
};


/***/ }),

/***/ 9039:
/***/ ((module) => {


module.exports = function (exec) {
  try {
    return !!exec();
  } catch (error) {
    return true;
  }
};


/***/ }),

/***/ 9228:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4` since it's moved to entry points
__webpack_require__(7495);
var call = __webpack_require__(9565);
var defineBuiltIn = __webpack_require__(6840);
var regexpExec = __webpack_require__(7323);
var fails = __webpack_require__(9039);
var wellKnownSymbol = __webpack_require__(8227);
var createNonEnumerableProperty = __webpack_require__(6699);

var SPECIES = wellKnownSymbol('species');
var RegExpPrototype = RegExp.prototype;

module.exports = function (KEY, exec, FORCED, SHAM) {
  var SYMBOL = wellKnownSymbol(KEY);

  var DELEGATES_TO_SYMBOL = !fails(function () {
    // String methods call symbol-named RegExp methods
    var O = {};
    O[SYMBOL] = function () { return 7; };
    return ''[KEY](O) !== 7;
  });

  var DELEGATES_TO_EXEC = DELEGATES_TO_SYMBOL && !fails(function () {
    // Symbol-named RegExp methods call .exec
    var execCalled = false;
    var re = /a/;

    if (KEY === 'split') {
      // We can't use real regex here since it causes deoptimization
      // and serious performance degradation in V8
      // https://github.com/zloirock/core-js/issues/306
      re = {};
      // RegExp[@@split] doesn't call the regex's exec method, but first creates
      // a new one. We need to return the patched regex when creating the new one.
      re.constructor = {};
      re.constructor[SPECIES] = function () { return re; };
      re.flags = '';
      re[SYMBOL] = /./[SYMBOL];
    }

    re.exec = function () {
      execCalled = true;
      return null;
    };

    re[SYMBOL]('');
    return !execCalled;
  });

  if (
    !DELEGATES_TO_SYMBOL ||
    !DELEGATES_TO_EXEC ||
    FORCED
  ) {
    var nativeRegExpMethod = /./[SYMBOL];
    var methods = exec(SYMBOL, ''[KEY], function (nativeMethod, regexp, str, arg2, forceStringMethod) {
      var $exec = regexp.exec;
      if ($exec === regexpExec || $exec === RegExpPrototype.exec) {
        if (DELEGATES_TO_SYMBOL && !forceStringMethod) {
          // The native String method already delegates to @@method (this
          // polyfilled function), leasing to infinite recursion.
          // We avoid it by directly calling the native @@method method.
          return { done: true, value: call(nativeRegExpMethod, regexp, str, arg2) };
        }
        return { done: true, value: call(nativeMethod, str, regexp, arg2) };
      }
      return { done: false };
    });

    defineBuiltIn(String.prototype, KEY, methods[0]);
    defineBuiltIn(RegExpPrototype, SYMBOL, methods[1]);
  }

  if (SHAM) createNonEnumerableProperty(RegExpPrototype[SYMBOL], 'sham', true);
};


/***/ }),

/***/ 259:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isArray = __webpack_require__(4376);
var lengthOfArrayLike = __webpack_require__(6198);
var doesNotExceedSafeInteger = __webpack_require__(6837);
var bind = __webpack_require__(6080);

// `FlattenIntoArray` abstract operation
// https://tc39.github.io/proposal-flatMap/#sec-FlattenIntoArray
var flattenIntoArray = function (target, original, source, sourceLen, start, depth, mapper, thisArg) {
  var targetIndex = start;
  var sourceIndex = 0;
  var mapFn = mapper ? bind(mapper, thisArg) : false;
  var element, elementLen;

  while (sourceIndex < sourceLen) {
    if (sourceIndex in source) {
      element = mapFn ? mapFn(source[sourceIndex], sourceIndex, original) : source[sourceIndex];

      if (depth > 0 && isArray(element)) {
        elementLen = lengthOfArrayLike(element);
        targetIndex = flattenIntoArray(target, original, element, elementLen, targetIndex, depth - 1) - 1;
      } else {
        doesNotExceedSafeInteger(targetIndex + 1);
        target[targetIndex] = element;
      }

      targetIndex++;
    }
    sourceIndex++;
  }
  return targetIndex;
};

module.exports = flattenIntoArray;


/***/ }),

/***/ 2744:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);

module.exports = !fails(function () {
  // eslint-disable-next-line es/no-object-isextensible, es/no-object-preventextensions -- required for testing
  return Object.isExtensible(Object.preventExtensions({}));
});


/***/ }),

/***/ 8745:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_BIND = __webpack_require__(616);

var FunctionPrototype = Function.prototype;
var apply = FunctionPrototype.apply;
var call = FunctionPrototype.call;

// eslint-disable-next-line es/no-reflect -- safe
module.exports = typeof Reflect == 'object' && Reflect.apply || (NATIVE_BIND ? call.bind(apply) : function () {
  return call.apply(apply, arguments);
});


/***/ }),

/***/ 6080:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(7476);
var aCallable = __webpack_require__(9306);
var NATIVE_BIND = __webpack_require__(616);

var bind = uncurryThis(uncurryThis.bind);

// optional / simple context binding
module.exports = function (fn, that) {
  aCallable(fn);
  return that === undefined ? fn : NATIVE_BIND ? bind(fn, that) : function (/* ...args */) {
    return fn.apply(that, arguments);
  };
};


/***/ }),

/***/ 616:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);

module.exports = !fails(function () {
  // eslint-disable-next-line es/no-function-prototype-bind -- safe
  var test = (function () { /* empty */ }).bind();
  // eslint-disable-next-line no-prototype-builtins -- safe
  return typeof test != 'function' || test.hasOwnProperty('prototype');
});


/***/ }),

/***/ 566:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var aCallable = __webpack_require__(9306);
var isObject = __webpack_require__(34);
var hasOwn = __webpack_require__(9297);
var arraySlice = __webpack_require__(7680);
var NATIVE_BIND = __webpack_require__(616);

var $Function = Function;
var concat = uncurryThis([].concat);
var join = uncurryThis([].join);
var factories = {};

var construct = function (C, argsLength, args) {
  if (!hasOwn(factories, argsLength)) {
    var list = [];
    var i = 0;
    for (; i < argsLength; i++) list[i] = 'a[' + i + ']';
    factories[argsLength] = $Function('C,a', 'return new C(' + join(list, ',') + ')');
  } return factories[argsLength](C, args);
};

// `Function.prototype.bind` method implementation
// https://tc39.es/ecma262/#sec-function.prototype.bind
// eslint-disable-next-line es/no-function-prototype-bind -- detection
module.exports = NATIVE_BIND ? $Function.bind : function bind(that /* , ...args */) {
  var F = aCallable(this);
  var Prototype = F.prototype;
  var partArgs = arraySlice(arguments, 1);
  var boundFunction = function bound(/* args... */) {
    var args = concat(partArgs, arraySlice(arguments));
    return this instanceof boundFunction ? construct(F, args.length, args) : F.apply(that, args);
  };
  if (isObject(Prototype)) boundFunction.prototype = Prototype;
  return boundFunction;
};


/***/ }),

/***/ 9565:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_BIND = __webpack_require__(616);

var call = Function.prototype.call;

module.exports = NATIVE_BIND ? call.bind(call) : function () {
  return call.apply(call, arguments);
};


/***/ }),

/***/ 350:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var hasOwn = __webpack_require__(9297);

var FunctionPrototype = Function.prototype;
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getDescriptor = DESCRIPTORS && Object.getOwnPropertyDescriptor;

var EXISTS = hasOwn(FunctionPrototype, 'name');
// additional protection from minified / mangled / dropped function names
var PROPER = EXISTS && (function something() { /* empty */ }).name === 'something';
var CONFIGURABLE = EXISTS && (!DESCRIPTORS || (DESCRIPTORS && getDescriptor(FunctionPrototype, 'name').configurable));

module.exports = {
  EXISTS: EXISTS,
  PROPER: PROPER,
  CONFIGURABLE: CONFIGURABLE
};


/***/ }),

/***/ 6706:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var aCallable = __webpack_require__(9306);

module.exports = function (object, key, method) {
  try {
    // eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
    return uncurryThis(aCallable(Object.getOwnPropertyDescriptor(object, key)[method]));
  } catch (error) { /* empty */ }
};


/***/ }),

/***/ 7476:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var classofRaw = __webpack_require__(2195);
var uncurryThis = __webpack_require__(9504);

module.exports = function (fn) {
  // Nashorn bug:
  //   https://github.com/zloirock/core-js/issues/1128
  //   https://github.com/zloirock/core-js/issues/1130
  if (classofRaw(fn) === 'Function') return uncurryThis(fn);
};


/***/ }),

/***/ 9504:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_BIND = __webpack_require__(616);

var FunctionPrototype = Function.prototype;
var call = FunctionPrototype.call;
var uncurryThisWithBind = NATIVE_BIND && FunctionPrototype.bind.bind(call, call);

module.exports = NATIVE_BIND ? uncurryThisWithBind : function (fn) {
  return function () {
    return call.apply(fn, arguments);
  };
};


/***/ }),

/***/ 9429:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var IS_NODE = __webpack_require__(8574);

module.exports = function (name) {
  if (IS_NODE) {
    try {
      return globalThis.process.getBuiltinModule(name);
    } catch (error) { /* empty */ }
    try {
      // eslint-disable-next-line no-new-func -- safe
      return Function('return require("' + name + '")')();
    } catch (error) { /* empty */ }
  }
};


/***/ }),

/***/ 7751:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var isCallable = __webpack_require__(4901);

var aFunction = function (argument) {
  return isCallable(argument) ? argument : undefined;
};

module.exports = function (namespace, method) {
  return arguments.length < 2 ? aFunction(globalThis[namespace]) : globalThis[namespace] && globalThis[namespace][method];
};


/***/ }),

/***/ 1767:
/***/ ((module) => {


// `GetIteratorDirect(obj)` abstract operation
// https://tc39.es/proposal-iterator-helpers/#sec-getiteratordirect
module.exports = function (obj) {
  return {
    iterator: obj,
    next: obj.next,
    done: false
  };
};


/***/ }),

/***/ 8646:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);
var getIteratorMethod = __webpack_require__(851);

module.exports = function (obj, stringHandling) {
  if (!stringHandling || typeof obj !== 'string') anObject(obj);
  var method = getIteratorMethod(obj);
  return getIteratorDirect(anObject(method !== undefined ? call(method, obj) : obj));
};


/***/ }),

/***/ 851:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var classof = __webpack_require__(6955);
var getMethod = __webpack_require__(5966);
var isNullOrUndefined = __webpack_require__(4117);
var Iterators = __webpack_require__(6269);
var wellKnownSymbol = __webpack_require__(8227);

var ITERATOR = wellKnownSymbol('iterator');

module.exports = function (it) {
  if (!isNullOrUndefined(it)) return getMethod(it, ITERATOR)
    || getMethod(it, '@@iterator')
    || Iterators[classof(it)];
};


/***/ }),

/***/ 81:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var tryToString = __webpack_require__(6823);
var getIteratorMethod = __webpack_require__(851);

var $TypeError = TypeError;

module.exports = function (argument, usingIterator) {
  var iteratorMethod = arguments.length < 2 ? getIteratorMethod(argument) : usingIterator;
  if (aCallable(iteratorMethod)) return anObject(call(iteratorMethod, argument));
  throw new $TypeError(tryToString(argument) + ' is not iterable');
};


/***/ }),

/***/ 6933:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var isArray = __webpack_require__(4376);
var isCallable = __webpack_require__(4901);
var classof = __webpack_require__(2195);
var toString = __webpack_require__(655);

var push = uncurryThis([].push);

module.exports = function (replacer) {
  if (isCallable(replacer)) return replacer;
  if (!isArray(replacer)) return;
  var rawLength = replacer.length;
  var keys = [];
  for (var i = 0; i < rawLength; i++) {
    var element = replacer[i];
    if (typeof element == 'string') push(keys, element);
    else if (typeof element == 'number' || classof(element) === 'Number' || classof(element) === 'String') push(keys, toString(element));
  }
  var keysLength = keys.length;
  var root = true;
  return function (key, value) {
    if (root) {
      root = false;
      return value;
    }
    if (isArray(this)) return value;
    for (var j = 0; j < keysLength; j++) if (keys[j] === key) return value;
  };
};


/***/ }),

/***/ 5966:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aCallable = __webpack_require__(9306);
var isNullOrUndefined = __webpack_require__(4117);

// `GetMethod` abstract operation
// https://tc39.es/ecma262/#sec-getmethod
module.exports = function (V, P) {
  var func = V[P];
  return isNullOrUndefined(func) ? undefined : aCallable(func);
};


/***/ }),

/***/ 3789:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var call = __webpack_require__(9565);
var toIntegerOrInfinity = __webpack_require__(1291);
var getIteratorDirect = __webpack_require__(1767);

var INVALID_SIZE = 'Invalid size';
var $RangeError = RangeError;
var $TypeError = TypeError;
var max = Math.max;

var SetRecord = function (set, intSize) {
  this.set = set;
  this.size = max(intSize, 0);
  this.has = aCallable(set.has);
  this.keys = aCallable(set.keys);
};

SetRecord.prototype = {
  getIterator: function () {
    return getIteratorDirect(anObject(call(this.keys, this.set)));
  },
  includes: function (it) {
    return call(this.has, this.set, it);
  }
};

// `GetSetRecord` abstract operation
// https://tc39.es/proposal-set-methods/#sec-getsetrecord
module.exports = function (obj) {
  anObject(obj);
  var numSize = +obj.size;
  // NOTE: If size is undefined, then numSize will be NaN
  // eslint-disable-next-line no-self-compare -- NaN check
  if (numSize !== numSize) throw new $TypeError(INVALID_SIZE);
  var intSize = toIntegerOrInfinity(numSize);
  if (intSize < 0) throw new $RangeError(INVALID_SIZE);
  return new SetRecord(obj, intSize);
};


/***/ }),

/***/ 2478:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var toObject = __webpack_require__(8981);

var floor = Math.floor;
var charAt = uncurryThis(''.charAt);
var replace = uncurryThis(''.replace);
var stringSlice = uncurryThis(''.slice);
// eslint-disable-next-line redos/no-vulnerable -- safe
var SUBSTITUTION_SYMBOLS = /\$([$&'`]|\d{1,2}|<[^>]*>)/g;
var SUBSTITUTION_SYMBOLS_NO_NAMED = /\$([$&'`]|\d{1,2})/g;

// `GetSubstitution` abstract operation
// https://tc39.es/ecma262/#sec-getsubstitution
module.exports = function (matched, str, position, captures, namedCaptures, replacement) {
  var tailPos = position + matched.length;
  var m = captures.length;
  var symbols = SUBSTITUTION_SYMBOLS_NO_NAMED;
  if (namedCaptures !== undefined) {
    namedCaptures = toObject(namedCaptures);
    symbols = SUBSTITUTION_SYMBOLS;
  }
  return replace(replacement, symbols, function (match, ch) {
    var capture;
    switch (charAt(ch, 0)) {
      case '$': return '$';
      case '&': return matched;
      case '`': return stringSlice(str, 0, position);
      case "'": return stringSlice(str, tailPos);
      case '<':
        capture = namedCaptures[stringSlice(ch, 1, -1)];
        break;
      default: // \d\d?
        var n = +ch;
        if (n === 0) return match;
        if (n > m) {
          var f = floor(n / 10);
          if (f === 0) return match;
          if (f <= m) return captures[f - 1] === undefined ? charAt(ch, 1) : captures[f - 1] + charAt(ch, 1);
          return match;
        }
        capture = captures[n - 1];
    }
    return capture === undefined ? '' : capture;
  });
};


/***/ }),

/***/ 4576:
/***/ (function(module) {


var check = function (it) {
  return it && it.Math === Math && it;
};

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
module.exports =
  // eslint-disable-next-line es/no-global-this -- safe
  check(typeof globalThis == 'object' && globalThis) ||
  check(typeof window == 'object' && window) ||
  // eslint-disable-next-line no-restricted-globals -- safe
  check(typeof self == 'object' && self) ||
  check(typeof global == 'object' && global) ||
  check(typeof this == 'object' && this) ||
  // eslint-disable-next-line no-new-func -- fallback
  (function () { return this; })() || Function('return this')();


/***/ }),

/***/ 9297:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var toObject = __webpack_require__(8981);

var hasOwnProperty = uncurryThis({}.hasOwnProperty);

// `HasOwnProperty` abstract operation
// https://tc39.es/ecma262/#sec-hasownproperty
// eslint-disable-next-line es/no-object-hasown -- safe
module.exports = Object.hasOwn || function hasOwn(it, key) {
  return hasOwnProperty(toObject(it), key);
};


/***/ }),

/***/ 421:
/***/ ((module) => {


module.exports = {};


/***/ }),

/***/ 3138:
/***/ ((module) => {


module.exports = function (a, b) {
  try {
    // eslint-disable-next-line no-console -- safe
    arguments.length === 1 ? console.error(a) : console.error(a, b);
  } catch (error) { /* empty */ }
};


/***/ }),

/***/ 397:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);

module.exports = getBuiltIn('document', 'documentElement');


/***/ }),

/***/ 5917:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var fails = __webpack_require__(9039);
var createElement = __webpack_require__(4055);

// Thanks to IE8 for its funny defineProperty
module.exports = !DESCRIPTORS && !fails(function () {
  // eslint-disable-next-line es/no-object-defineproperty -- required for testing
  return Object.defineProperty(createElement('div'), 'a', {
    get: function () { return 7; }
  }).a !== 7;
});


/***/ }),

/***/ 8490:
/***/ ((module) => {


// IEEE754 conversions based on https://github.com/feross/ieee754
var $Array = Array;
var abs = Math.abs;
var pow = Math.pow;
var floor = Math.floor;
var log = Math.log;
var LN2 = Math.LN2;

var pack = function (number, mantissaLength, bytes) {
  var buffer = $Array(bytes);
  var exponentLength = bytes * 8 - mantissaLength - 1;
  var eMax = (1 << exponentLength) - 1;
  var eBias = eMax >> 1;
  var rt = mantissaLength === 23 ? pow(2, -24) - pow(2, -77) : 0;
  var sign = number < 0 || number === 0 && 1 / number < 0 ? 1 : 0;
  var index = 0;
  var exponent, mantissa, c;
  number = abs(number);
  // eslint-disable-next-line no-self-compare -- NaN check
  if (number !== number || number === Infinity) {
    // eslint-disable-next-line no-self-compare -- NaN check
    mantissa = number !== number ? 1 : 0;
    exponent = eMax;
  } else {
    exponent = floor(log(number) / LN2);
    c = pow(2, -exponent);
    if (number * c < 1) {
      exponent--;
      c *= 2;
    }
    if (exponent + eBias >= 1) {
      number += rt / c;
    } else {
      number += rt * pow(2, 1 - eBias);
    }
    if (number * c >= 2) {
      exponent++;
      c /= 2;
    }
    if (exponent + eBias >= eMax) {
      mantissa = 0;
      exponent = eMax;
    } else if (exponent + eBias >= 1) {
      mantissa = (number * c - 1) * pow(2, mantissaLength);
      exponent += eBias;
    } else {
      mantissa = number * pow(2, eBias - 1) * pow(2, mantissaLength);
      exponent = 0;
    }
  }
  while (mantissaLength >= 8) {
    buffer[index++] = mantissa & 255;
    mantissa /= 256;
    mantissaLength -= 8;
  }
  exponent = exponent << mantissaLength | mantissa;
  exponentLength += mantissaLength;
  while (exponentLength > 0) {
    buffer[index++] = exponent & 255;
    exponent /= 256;
    exponentLength -= 8;
  }
  buffer[index - 1] |= sign * 128;
  return buffer;
};

var unpack = function (buffer, mantissaLength) {
  var bytes = buffer.length;
  var exponentLength = bytes * 8 - mantissaLength - 1;
  var eMax = (1 << exponentLength) - 1;
  var eBias = eMax >> 1;
  var nBits = exponentLength - 7;
  var index = bytes - 1;
  var sign = buffer[index--];
  var exponent = sign & 127;
  var mantissa;
  sign >>= 7;
  while (nBits > 0) {
    exponent = exponent * 256 + buffer[index--];
    nBits -= 8;
  }
  mantissa = exponent & (1 << -nBits) - 1;
  exponent >>= -nBits;
  nBits += mantissaLength;
  while (nBits > 0) {
    mantissa = mantissa * 256 + buffer[index--];
    nBits -= 8;
  }
  if (exponent === 0) {
    exponent = 1 - eBias;
  } else if (exponent === eMax) {
    return mantissa ? NaN : sign ? -Infinity : Infinity;
  } else {
    mantissa += pow(2, mantissaLength);
    exponent -= eBias;
  } return (sign ? -1 : 1) * mantissa * pow(2, exponent - mantissaLength);
};

module.exports = {
  pack: pack,
  unpack: unpack
};


/***/ }),

/***/ 7055:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var fails = __webpack_require__(9039);
var classof = __webpack_require__(2195);

var $Object = Object;
var split = uncurryThis(''.split);

// fallback for non-array-like ES3 and non-enumerable old V8 strings
module.exports = fails(function () {
  // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
  // eslint-disable-next-line no-prototype-builtins -- safe
  return !$Object('z').propertyIsEnumerable(0);
}) ? function (it) {
  return classof(it) === 'String' ? split(it, '') : $Object(it);
} : $Object;


/***/ }),

/***/ 3167:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);
var setPrototypeOf = __webpack_require__(2967);

// makes subclassing work correct for wrapped built-ins
module.exports = function ($this, dummy, Wrapper) {
  var NewTarget, NewTargetPrototype;
  if (
    // it can work only with native `setPrototypeOf`
    setPrototypeOf &&
    // we haven't completely correct pre-ES6 way for getting `new.target`, so use this
    isCallable(NewTarget = dummy.constructor) &&
    NewTarget !== Wrapper &&
    isObject(NewTargetPrototype = NewTarget.prototype) &&
    NewTargetPrototype !== Wrapper.prototype
  ) setPrototypeOf($this, NewTargetPrototype);
  return $this;
};


/***/ }),

/***/ 3706:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var isCallable = __webpack_require__(4901);
var store = __webpack_require__(7629);

var functionToString = uncurryThis(Function.toString);

// this helper broken in `core-js@3.4.1-3.4.4`, so we can't use `shared` helper
if (!isCallable(store.inspectSource)) {
  store.inspectSource = function (it) {
    return functionToString(it);
  };
}

module.exports = store.inspectSource;


/***/ }),

/***/ 7584:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isObject = __webpack_require__(34);
var createNonEnumerableProperty = __webpack_require__(6699);

// `InstallErrorCause` abstract operation
// https://tc39.es/proposal-error-cause/#sec-errorobjects-install-error-cause
module.exports = function (O, options) {
  if (isObject(options) && 'cause' in options) {
    createNonEnumerableProperty(O, 'cause', options.cause);
  }
};


/***/ }),

/***/ 3451:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var hiddenKeys = __webpack_require__(421);
var isObject = __webpack_require__(34);
var hasOwn = __webpack_require__(9297);
var defineProperty = (__webpack_require__(4913).f);
var getOwnPropertyNamesModule = __webpack_require__(8480);
var getOwnPropertyNamesExternalModule = __webpack_require__(298);
var isExtensible = __webpack_require__(4124);
var uid = __webpack_require__(3392);
var FREEZING = __webpack_require__(2744);

var REQUIRED = false;
var METADATA = uid('meta');
var id = 0;

var setMetadata = function (it) {
  defineProperty(it, METADATA, { value: {
    objectID: 'O' + id++, // object ID
    weakData: {}          // weak collections IDs
  } });
};

var fastKey = function (it, create) {
  // return a primitive with prefix
  if (!isObject(it)) return typeof it == 'symbol' ? it : (typeof it == 'string' ? 'S' : 'P') + it;
  if (!hasOwn(it, METADATA)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return 'F';
    // not necessary to add metadata
    if (!create) return 'E';
    // add missing metadata
    setMetadata(it);
  // return object ID
  } return it[METADATA].objectID;
};

var getWeakData = function (it, create) {
  if (!hasOwn(it, METADATA)) {
    // can't set metadata to uncaught frozen object
    if (!isExtensible(it)) return true;
    // not necessary to add metadata
    if (!create) return false;
    // add missing metadata
    setMetadata(it);
  // return the store of weak collections IDs
  } return it[METADATA].weakData;
};

// add metadata on freeze-family methods calling
var onFreeze = function (it) {
  if (FREEZING && REQUIRED && isExtensible(it) && !hasOwn(it, METADATA)) setMetadata(it);
  return it;
};

var enable = function () {
  meta.enable = function () { /* empty */ };
  REQUIRED = true;
  var getOwnPropertyNames = getOwnPropertyNamesModule.f;
  var splice = uncurryThis([].splice);
  var test = {};
  test[METADATA] = 1;

  // prevent exposing of metadata key
  if (getOwnPropertyNames(test).length) {
    getOwnPropertyNamesModule.f = function (it) {
      var result = getOwnPropertyNames(it);
      for (var i = 0, length = result.length; i < length; i++) {
        if (result[i] === METADATA) {
          splice(result, i, 1);
          break;
        }
      } return result;
    };

    $({ target: 'Object', stat: true, forced: true }, {
      getOwnPropertyNames: getOwnPropertyNamesExternalModule.f
    });
  }
};

var meta = module.exports = {
  enable: enable,
  fastKey: fastKey,
  getWeakData: getWeakData,
  onFreeze: onFreeze
};

hiddenKeys[METADATA] = true;


/***/ }),

/***/ 1181:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_WEAK_MAP = __webpack_require__(8622);
var globalThis = __webpack_require__(4576);
var isObject = __webpack_require__(34);
var createNonEnumerableProperty = __webpack_require__(6699);
var hasOwn = __webpack_require__(9297);
var shared = __webpack_require__(7629);
var sharedKey = __webpack_require__(6119);
var hiddenKeys = __webpack_require__(421);

var OBJECT_ALREADY_INITIALIZED = 'Object already initialized';
var TypeError = globalThis.TypeError;
var WeakMap = globalThis.WeakMap;
var set, get, has;

var enforce = function (it) {
  return has(it) ? get(it) : set(it, {});
};

var getterFor = function (TYPE) {
  return function (it) {
    var state;
    if (!isObject(it) || (state = get(it)).type !== TYPE) {
      throw new TypeError('Incompatible receiver, ' + TYPE + ' required');
    } return state;
  };
};

if (NATIVE_WEAK_MAP || shared.state) {
  var store = shared.state || (shared.state = new WeakMap());
  /* eslint-disable no-self-assign -- prototype methods protection */
  store.get = store.get;
  store.has = store.has;
  store.set = store.set;
  /* eslint-enable no-self-assign -- prototype methods protection */
  set = function (it, metadata) {
    if (store.has(it)) throw new TypeError(OBJECT_ALREADY_INITIALIZED);
    metadata.facade = it;
    store.set(it, metadata);
    return metadata;
  };
  get = function (it) {
    return store.get(it) || {};
  };
  has = function (it) {
    return store.has(it);
  };
} else {
  var STATE = sharedKey('state');
  hiddenKeys[STATE] = true;
  set = function (it, metadata) {
    if (hasOwn(it, STATE)) throw new TypeError(OBJECT_ALREADY_INITIALIZED);
    metadata.facade = it;
    createNonEnumerableProperty(it, STATE, metadata);
    return metadata;
  };
  get = function (it) {
    return hasOwn(it, STATE) ? it[STATE] : {};
  };
  has = function (it) {
    return hasOwn(it, STATE);
  };
}

module.exports = {
  set: set,
  get: get,
  has: has,
  enforce: enforce,
  getterFor: getterFor
};


/***/ }),

/***/ 4209:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);
var Iterators = __webpack_require__(6269);

var ITERATOR = wellKnownSymbol('iterator');
var ArrayPrototype = Array.prototype;

// check on default Array iterator
module.exports = function (it) {
  return it !== undefined && (Iterators.Array === it || ArrayPrototype[ITERATOR] === it);
};


/***/ }),

/***/ 4376:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var classof = __webpack_require__(2195);

// `IsArray` abstract operation
// https://tc39.es/ecma262/#sec-isarray
// eslint-disable-next-line es/no-array-isarray -- safe
module.exports = Array.isArray || function isArray(argument) {
  return classof(argument) === 'Array';
};


/***/ }),

/***/ 1108:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var classof = __webpack_require__(6955);

module.exports = function (it) {
  var klass = classof(it);
  return klass === 'BigInt64Array' || klass === 'BigUint64Array';
};


/***/ }),

/***/ 4901:
/***/ ((module) => {


// https://tc39.es/ecma262/#sec-IsHTMLDDA-internal-slot
var documentAll = typeof document == 'object' && document.all;

// `IsCallable` abstract operation
// https://tc39.es/ecma262/#sec-iscallable
// eslint-disable-next-line unicorn/no-typeof-undefined -- required for testing
module.exports = typeof documentAll == 'undefined' && documentAll !== undefined ? function (argument) {
  return typeof argument == 'function' || argument === documentAll;
} : function (argument) {
  return typeof argument == 'function';
};


/***/ }),

/***/ 3517:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var fails = __webpack_require__(9039);
var isCallable = __webpack_require__(4901);
var classof = __webpack_require__(6955);
var getBuiltIn = __webpack_require__(7751);
var inspectSource = __webpack_require__(3706);

var noop = function () { /* empty */ };
var construct = getBuiltIn('Reflect', 'construct');
var constructorRegExp = /^\s*(?:class|function)\b/;
var exec = uncurryThis(constructorRegExp.exec);
var INCORRECT_TO_STRING = !constructorRegExp.test(noop);

var isConstructorModern = function isConstructor(argument) {
  if (!isCallable(argument)) return false;
  try {
    construct(noop, [], argument);
    return true;
  } catch (error) {
    return false;
  }
};

var isConstructorLegacy = function isConstructor(argument) {
  if (!isCallable(argument)) return false;
  switch (classof(argument)) {
    case 'AsyncFunction':
    case 'GeneratorFunction':
    case 'AsyncGeneratorFunction': return false;
  }
  try {
    // we can't check .prototype since constructors produced by .bind haven't it
    // `Function#toString` throws on some built-it function in some legacy engines
    // (for example, `DOMQuad` and similar in FF41-)
    return INCORRECT_TO_STRING || !!exec(constructorRegExp, inspectSource(argument));
  } catch (error) {
    return true;
  }
};

isConstructorLegacy.sham = true;

// `IsConstructor` abstract operation
// https://tc39.es/ecma262/#sec-isconstructor
module.exports = !construct || fails(function () {
  var called;
  return isConstructorModern(isConstructorModern.call)
    || !isConstructorModern(Object)
    || !isConstructorModern(function () { called = true; })
    || called;
}) ? isConstructorLegacy : isConstructorModern;


/***/ }),

/***/ 6575:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var hasOwn = __webpack_require__(9297);

module.exports = function (descriptor) {
  return descriptor !== undefined && (hasOwn(descriptor, 'value') || hasOwn(descriptor, 'writable'));
};


/***/ }),

/***/ 2796:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var isCallable = __webpack_require__(4901);

var replacement = /#|\.prototype\./;

var isForced = function (feature, detection) {
  var value = data[normalize(feature)];
  return value === POLYFILL ? true
    : value === NATIVE ? false
    : isCallable(detection) ? fails(detection)
    : !!detection;
};

var normalize = isForced.normalize = function (string) {
  return String(string).replace(replacement, '.').toLowerCase();
};

var data = isForced.data = {};
var NATIVE = isForced.NATIVE = 'N';
var POLYFILL = isForced.POLYFILL = 'P';

module.exports = isForced;


/***/ }),

/***/ 2087:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isObject = __webpack_require__(34);

var floor = Math.floor;

// `IsIntegralNumber` abstract operation
// https://tc39.es/ecma262/#sec-isintegralnumber
// eslint-disable-next-line es/no-number-isinteger -- safe
module.exports = Number.isInteger || function isInteger(it) {
  return !isObject(it) && isFinite(it) && floor(it) === it;
};


/***/ }),

/***/ 4117:
/***/ ((module) => {


// we can't use just `it == null` since of `document.all` special case
// https://tc39.es/ecma262/#sec-IsHTMLDDA-internal-slot-aec
module.exports = function (it) {
  return it === null || it === undefined;
};


/***/ }),

/***/ 34:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isCallable = __webpack_require__(4901);

module.exports = function (it) {
  return typeof it == 'object' ? it !== null : isCallable(it);
};


/***/ }),

/***/ 3925:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isObject = __webpack_require__(34);

module.exports = function (argument) {
  return isObject(argument) || argument === null;
};


/***/ }),

/***/ 6395:
/***/ ((module) => {


module.exports = false;


/***/ }),

/***/ 788:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isObject = __webpack_require__(34);
var classof = __webpack_require__(2195);
var wellKnownSymbol = __webpack_require__(8227);

var MATCH = wellKnownSymbol('match');

// `IsRegExp` abstract operation
// https://tc39.es/ecma262/#sec-isregexp
module.exports = function (it) {
  var isRegExp;
  return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classof(it) === 'RegExp');
};


/***/ }),

/***/ 757:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var isCallable = __webpack_require__(4901);
var isPrototypeOf = __webpack_require__(1625);
var USE_SYMBOL_AS_UID = __webpack_require__(7040);

var $Object = Object;

module.exports = USE_SYMBOL_AS_UID ? function (it) {
  return typeof it == 'symbol';
} : function (it) {
  var $Symbol = getBuiltIn('Symbol');
  return isCallable($Symbol) && isPrototypeOf($Symbol.prototype, $Object(it));
};


/***/ }),

/***/ 507:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);

module.exports = function (record, fn, ITERATOR_INSTEAD_OF_RECORD) {
  var iterator = ITERATOR_INSTEAD_OF_RECORD ? record : record.iterator;
  var next = record.next;
  var step, result;
  while (!(step = call(next, iterator)).done) {
    result = fn(step.value);
    if (result !== undefined) return result;
  }
};


/***/ }),

/***/ 2652:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var bind = __webpack_require__(6080);
var call = __webpack_require__(9565);
var anObject = __webpack_require__(8551);
var tryToString = __webpack_require__(6823);
var isArrayIteratorMethod = __webpack_require__(4209);
var lengthOfArrayLike = __webpack_require__(6198);
var isPrototypeOf = __webpack_require__(1625);
var getIterator = __webpack_require__(81);
var getIteratorMethod = __webpack_require__(851);
var iteratorClose = __webpack_require__(9539);

var $TypeError = TypeError;

var Result = function (stopped, result) {
  this.stopped = stopped;
  this.result = result;
};

var ResultPrototype = Result.prototype;

module.exports = function (iterable, unboundFunction, options) {
  var that = options && options.that;
  var AS_ENTRIES = !!(options && options.AS_ENTRIES);
  var IS_RECORD = !!(options && options.IS_RECORD);
  var IS_ITERATOR = !!(options && options.IS_ITERATOR);
  var INTERRUPTED = !!(options && options.INTERRUPTED);
  var fn = bind(unboundFunction, that);
  var iterator, iterFn, index, length, result, next, step;

  var stop = function (condition) {
    if (iterator) iteratorClose(iterator, 'normal', condition);
    return new Result(true, condition);
  };

  var callFn = function (value) {
    if (AS_ENTRIES) {
      anObject(value);
      return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
    } return INTERRUPTED ? fn(value, stop) : fn(value);
  };

  if (IS_RECORD) {
    iterator = iterable.iterator;
  } else if (IS_ITERATOR) {
    iterator = iterable;
  } else {
    iterFn = getIteratorMethod(iterable);
    if (!iterFn) throw new $TypeError(tryToString(iterable) + ' is not iterable');
    // optimisation for array iterators
    if (isArrayIteratorMethod(iterFn)) {
      for (index = 0, length = lengthOfArrayLike(iterable); length > index; index++) {
        result = callFn(iterable[index]);
        if (result && isPrototypeOf(ResultPrototype, result)) return result;
      } return new Result(false);
    }
    iterator = getIterator(iterable, iterFn);
  }

  next = IS_RECORD ? iterable.next : iterator.next;
  while (!(step = call(next, iterator)).done) {
    try {
      result = callFn(step.value);
    } catch (error) {
      iteratorClose(iterator, 'throw', error);
    }
    if (typeof result == 'object' && result && isPrototypeOf(ResultPrototype, result)) return result;
  } return new Result(false);
};


/***/ }),

/***/ 9539:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var anObject = __webpack_require__(8551);
var getMethod = __webpack_require__(5966);

module.exports = function (iterator, kind, value) {
  var innerResult, innerError;
  anObject(iterator);
  try {
    innerResult = getMethod(iterator, 'return');
    if (!innerResult) {
      if (kind === 'throw') throw value;
      return value;
    }
    innerResult = call(innerResult, iterator);
  } catch (error) {
    innerError = true;
    innerResult = error;
  }
  if (kind === 'throw') throw value;
  if (innerError) throw innerResult;
  anObject(innerResult);
  return value;
};


/***/ }),

/***/ 3994:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var IteratorPrototype = (__webpack_require__(7657).IteratorPrototype);
var create = __webpack_require__(2360);
var createPropertyDescriptor = __webpack_require__(6980);
var setToStringTag = __webpack_require__(687);
var Iterators = __webpack_require__(6269);

var returnThis = function () { return this; };

module.exports = function (IteratorConstructor, NAME, next, ENUMERABLE_NEXT) {
  var TO_STRING_TAG = NAME + ' Iterator';
  IteratorConstructor.prototype = create(IteratorPrototype, { next: createPropertyDescriptor(+!ENUMERABLE_NEXT, next) });
  setToStringTag(IteratorConstructor, TO_STRING_TAG, false, true);
  Iterators[TO_STRING_TAG] = returnThis;
  return IteratorConstructor;
};


/***/ }),

/***/ 9462:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var create = __webpack_require__(2360);
var createNonEnumerableProperty = __webpack_require__(6699);
var defineBuiltIns = __webpack_require__(6279);
var wellKnownSymbol = __webpack_require__(8227);
var InternalStateModule = __webpack_require__(1181);
var getMethod = __webpack_require__(5966);
var IteratorPrototype = (__webpack_require__(7657).IteratorPrototype);
var createIterResultObject = __webpack_require__(2529);
var iteratorClose = __webpack_require__(9539);

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
var ITERATOR_HELPER = 'IteratorHelper';
var WRAP_FOR_VALID_ITERATOR = 'WrapForValidIterator';
var setInternalState = InternalStateModule.set;

var createIteratorProxyPrototype = function (IS_ITERATOR) {
  var getInternalState = InternalStateModule.getterFor(IS_ITERATOR ? WRAP_FOR_VALID_ITERATOR : ITERATOR_HELPER);

  return defineBuiltIns(create(IteratorPrototype), {
    next: function next() {
      var state = getInternalState(this);
      // for simplification:
      //   for `%WrapForValidIteratorPrototype%.next` our `nextHandler` returns `IterResultObject`
      //   for `%IteratorHelperPrototype%.next` - just a value
      if (IS_ITERATOR) return state.nextHandler();
      try {
        var result = state.done ? undefined : state.nextHandler();
        return createIterResultObject(result, state.done);
      } catch (error) {
        state.done = true;
        throw error;
      }
    },
    'return': function () {
      var state = getInternalState(this);
      var iterator = state.iterator;
      state.done = true;
      if (IS_ITERATOR) {
        var returnMethod = getMethod(iterator, 'return');
        return returnMethod ? call(returnMethod, iterator) : createIterResultObject(undefined, true);
      }
      if (state.inner) try {
        iteratorClose(state.inner.iterator, 'normal');
      } catch (error) {
        return iteratorClose(iterator, 'throw', error);
      }
      if (iterator) iteratorClose(iterator, 'normal');
      return createIterResultObject(undefined, true);
    }
  });
};

var WrapForValidIteratorPrototype = createIteratorProxyPrototype(true);
var IteratorHelperPrototype = createIteratorProxyPrototype(false);

createNonEnumerableProperty(IteratorHelperPrototype, TO_STRING_TAG, 'Iterator Helper');

module.exports = function (nextHandler, IS_ITERATOR) {
  var IteratorProxy = function Iterator(record, state) {
    if (state) {
      state.iterator = record.iterator;
      state.next = record.next;
    } else state = record;
    state.type = IS_ITERATOR ? WRAP_FOR_VALID_ITERATOR : ITERATOR_HELPER;
    state.nextHandler = nextHandler;
    state.counter = 0;
    state.done = false;
    setInternalState(this, state);
  };

  IteratorProxy.prototype = IS_ITERATOR ? WrapForValidIteratorPrototype : IteratorHelperPrototype;

  return IteratorProxy;
};


/***/ }),

/***/ 1088:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var IS_PURE = __webpack_require__(6395);
var FunctionName = __webpack_require__(350);
var isCallable = __webpack_require__(4901);
var createIteratorConstructor = __webpack_require__(3994);
var getPrototypeOf = __webpack_require__(2787);
var setPrototypeOf = __webpack_require__(2967);
var setToStringTag = __webpack_require__(687);
var createNonEnumerableProperty = __webpack_require__(6699);
var defineBuiltIn = __webpack_require__(6840);
var wellKnownSymbol = __webpack_require__(8227);
var Iterators = __webpack_require__(6269);
var IteratorsCore = __webpack_require__(7657);

var PROPER_FUNCTION_NAME = FunctionName.PROPER;
var CONFIGURABLE_FUNCTION_NAME = FunctionName.CONFIGURABLE;
var IteratorPrototype = IteratorsCore.IteratorPrototype;
var BUGGY_SAFARI_ITERATORS = IteratorsCore.BUGGY_SAFARI_ITERATORS;
var ITERATOR = wellKnownSymbol('iterator');
var KEYS = 'keys';
var VALUES = 'values';
var ENTRIES = 'entries';

var returnThis = function () { return this; };

module.exports = function (Iterable, NAME, IteratorConstructor, next, DEFAULT, IS_SET, FORCED) {
  createIteratorConstructor(IteratorConstructor, NAME, next);

  var getIterationMethod = function (KIND) {
    if (KIND === DEFAULT && defaultIterator) return defaultIterator;
    if (!BUGGY_SAFARI_ITERATORS && KIND && KIND in IterablePrototype) return IterablePrototype[KIND];

    switch (KIND) {
      case KEYS: return function keys() { return new IteratorConstructor(this, KIND); };
      case VALUES: return function values() { return new IteratorConstructor(this, KIND); };
      case ENTRIES: return function entries() { return new IteratorConstructor(this, KIND); };
    }

    return function () { return new IteratorConstructor(this); };
  };

  var TO_STRING_TAG = NAME + ' Iterator';
  var INCORRECT_VALUES_NAME = false;
  var IterablePrototype = Iterable.prototype;
  var nativeIterator = IterablePrototype[ITERATOR]
    || IterablePrototype['@@iterator']
    || DEFAULT && IterablePrototype[DEFAULT];
  var defaultIterator = !BUGGY_SAFARI_ITERATORS && nativeIterator || getIterationMethod(DEFAULT);
  var anyNativeIterator = NAME === 'Array' ? IterablePrototype.entries || nativeIterator : nativeIterator;
  var CurrentIteratorPrototype, methods, KEY;

  // fix native
  if (anyNativeIterator) {
    CurrentIteratorPrototype = getPrototypeOf(anyNativeIterator.call(new Iterable()));
    if (CurrentIteratorPrototype !== Object.prototype && CurrentIteratorPrototype.next) {
      if (!IS_PURE && getPrototypeOf(CurrentIteratorPrototype) !== IteratorPrototype) {
        if (setPrototypeOf) {
          setPrototypeOf(CurrentIteratorPrototype, IteratorPrototype);
        } else if (!isCallable(CurrentIteratorPrototype[ITERATOR])) {
          defineBuiltIn(CurrentIteratorPrototype, ITERATOR, returnThis);
        }
      }
      // Set @@toStringTag to native iterators
      setToStringTag(CurrentIteratorPrototype, TO_STRING_TAG, true, true);
      if (IS_PURE) Iterators[TO_STRING_TAG] = returnThis;
    }
  }

  // fix Array.prototype.{ values, @@iterator }.name in V8 / FF
  if (PROPER_FUNCTION_NAME && DEFAULT === VALUES && nativeIterator && nativeIterator.name !== VALUES) {
    if (!IS_PURE && CONFIGURABLE_FUNCTION_NAME) {
      createNonEnumerableProperty(IterablePrototype, 'name', VALUES);
    } else {
      INCORRECT_VALUES_NAME = true;
      defaultIterator = function values() { return call(nativeIterator, this); };
    }
  }

  // export additional methods
  if (DEFAULT) {
    methods = {
      values: getIterationMethod(VALUES),
      keys: IS_SET ? defaultIterator : getIterationMethod(KEYS),
      entries: getIterationMethod(ENTRIES)
    };
    if (FORCED) for (KEY in methods) {
      if (BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME || !(KEY in IterablePrototype)) {
        defineBuiltIn(IterablePrototype, KEY, methods[KEY]);
      }
    } else $({ target: NAME, proto: true, forced: BUGGY_SAFARI_ITERATORS || INCORRECT_VALUES_NAME }, methods);
  }

  // define iterator
  if ((!IS_PURE || FORCED) && IterablePrototype[ITERATOR] !== defaultIterator) {
    defineBuiltIn(IterablePrototype, ITERATOR, defaultIterator, { name: DEFAULT });
  }
  Iterators[NAME] = defaultIterator;

  return methods;
};


/***/ }),

/***/ 713:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);
var createIteratorProxy = __webpack_require__(9462);
var callWithSafeIterationClosing = __webpack_require__(6319);

var IteratorProxy = createIteratorProxy(function () {
  var iterator = this.iterator;
  var result = anObject(call(this.next, iterator));
  var done = this.done = !!result.done;
  if (!done) return callWithSafeIterationClosing(iterator, this.mapper, [result.value, this.counter++], true);
});

// `Iterator.prototype.map` method
// https://github.com/tc39/proposal-iterator-helpers
module.exports = function map(mapper) {
  anObject(this);
  aCallable(mapper);
  return new IteratorProxy(getIteratorDirect(this), {
    mapper: mapper
  });
};


/***/ }),

/***/ 7657:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);
var create = __webpack_require__(2360);
var getPrototypeOf = __webpack_require__(2787);
var defineBuiltIn = __webpack_require__(6840);
var wellKnownSymbol = __webpack_require__(8227);
var IS_PURE = __webpack_require__(6395);

var ITERATOR = wellKnownSymbol('iterator');
var BUGGY_SAFARI_ITERATORS = false;

// `%IteratorPrototype%` object
// https://tc39.es/ecma262/#sec-%iteratorprototype%-object
var IteratorPrototype, PrototypeOfArrayIteratorPrototype, arrayIterator;

/* eslint-disable es/no-array-prototype-keys -- safe */
if ([].keys) {
  arrayIterator = [].keys();
  // Safari 8 has buggy iterators w/o `next`
  if (!('next' in arrayIterator)) BUGGY_SAFARI_ITERATORS = true;
  else {
    PrototypeOfArrayIteratorPrototype = getPrototypeOf(getPrototypeOf(arrayIterator));
    if (PrototypeOfArrayIteratorPrototype !== Object.prototype) IteratorPrototype = PrototypeOfArrayIteratorPrototype;
  }
}

var NEW_ITERATOR_PROTOTYPE = !isObject(IteratorPrototype) || fails(function () {
  var test = {};
  // FF44- legacy iterators case
  return IteratorPrototype[ITERATOR].call(test) !== test;
});

if (NEW_ITERATOR_PROTOTYPE) IteratorPrototype = {};
else if (IS_PURE) IteratorPrototype = create(IteratorPrototype);

// `%IteratorPrototype%[@@iterator]()` method
// https://tc39.es/ecma262/#sec-%iteratorprototype%-@@iterator
if (!isCallable(IteratorPrototype[ITERATOR])) {
  defineBuiltIn(IteratorPrototype, ITERATOR, function () {
    return this;
  });
}

module.exports = {
  IteratorPrototype: IteratorPrototype,
  BUGGY_SAFARI_ITERATORS: BUGGY_SAFARI_ITERATORS
};


/***/ }),

/***/ 6269:
/***/ ((module) => {


module.exports = {};


/***/ }),

/***/ 6198:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toLength = __webpack_require__(8014);

// `LengthOfArrayLike` abstract operation
// https://tc39.es/ecma262/#sec-lengthofarraylike
module.exports = function (obj) {
  return toLength(obj.length);
};


/***/ }),

/***/ 283:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var fails = __webpack_require__(9039);
var isCallable = __webpack_require__(4901);
var hasOwn = __webpack_require__(9297);
var DESCRIPTORS = __webpack_require__(3724);
var CONFIGURABLE_FUNCTION_NAME = (__webpack_require__(350).CONFIGURABLE);
var inspectSource = __webpack_require__(3706);
var InternalStateModule = __webpack_require__(1181);

var enforceInternalState = InternalStateModule.enforce;
var getInternalState = InternalStateModule.get;
var $String = String;
// eslint-disable-next-line es/no-object-defineproperty -- safe
var defineProperty = Object.defineProperty;
var stringSlice = uncurryThis(''.slice);
var replace = uncurryThis(''.replace);
var join = uncurryThis([].join);

var CONFIGURABLE_LENGTH = DESCRIPTORS && !fails(function () {
  return defineProperty(function () { /* empty */ }, 'length', { value: 8 }).length !== 8;
});

var TEMPLATE = String(String).split('String');

var makeBuiltIn = module.exports = function (value, name, options) {
  if (stringSlice($String(name), 0, 7) === 'Symbol(') {
    name = '[' + replace($String(name), /^Symbol\(([^)]*)\).*$/, '$1') + ']';
  }
  if (options && options.getter) name = 'get ' + name;
  if (options && options.setter) name = 'set ' + name;
  if (!hasOwn(value, 'name') || (CONFIGURABLE_FUNCTION_NAME && value.name !== name)) {
    if (DESCRIPTORS) defineProperty(value, 'name', { value: name, configurable: true });
    else value.name = name;
  }
  if (CONFIGURABLE_LENGTH && options && hasOwn(options, 'arity') && value.length !== options.arity) {
    defineProperty(value, 'length', { value: options.arity });
  }
  try {
    if (options && hasOwn(options, 'constructor') && options.constructor) {
      if (DESCRIPTORS) defineProperty(value, 'prototype', { writable: false });
    // in V8 ~ Chrome 53, prototypes of some methods, like `Array.prototype.values`, are non-writable
    } else if (value.prototype) value.prototype = undefined;
  } catch (error) { /* empty */ }
  var state = enforceInternalState(value);
  if (!hasOwn(state, 'source')) {
    state.source = join(TEMPLATE, typeof name == 'string' ? name : '');
  } return value;
};

// add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
// eslint-disable-next-line no-extend-native -- required
Function.prototype.toString = makeBuiltIn(function toString() {
  return isCallable(this) && getInternalState(this).source || inspectSource(this);
}, 'toString');


/***/ }),

/***/ 3164:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var sign = __webpack_require__(7782);

var abs = Math.abs;

var EPSILON = 2.220446049250313e-16; // Number.EPSILON
var INVERSE_EPSILON = 1 / EPSILON;

var roundTiesToEven = function (n) {
  return n + INVERSE_EPSILON - INVERSE_EPSILON;
};

module.exports = function (x, FLOAT_EPSILON, FLOAT_MAX_VALUE, FLOAT_MIN_VALUE) {
  var n = +x;
  var absolute = abs(n);
  var s = sign(n);
  if (absolute < FLOAT_MIN_VALUE) return s * roundTiesToEven(absolute / FLOAT_MIN_VALUE / FLOAT_EPSILON) * FLOAT_MIN_VALUE * FLOAT_EPSILON;
  var a = (1 + FLOAT_EPSILON / EPSILON) * absolute;
  var result = a - (a - absolute);
  // eslint-disable-next-line no-self-compare -- NaN check
  if (result > FLOAT_MAX_VALUE || result !== result) return s * Infinity;
  return s * result;
};


/***/ }),

/***/ 5617:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var floatRound = __webpack_require__(3164);

var FLOAT32_EPSILON = 1.1920928955078125e-7; // 2 ** -23;
var FLOAT32_MAX_VALUE = 3.4028234663852886e+38; // 2 ** 128 - 2 ** 104
var FLOAT32_MIN_VALUE = 1.1754943508222875e-38; // 2 ** -126;

// `Math.fround` method implementation
// https://tc39.es/ecma262/#sec-math.fround
// eslint-disable-next-line es/no-math-fround -- safe
module.exports = Math.fround || function fround(x) {
  return floatRound(x, FLOAT32_EPSILON, FLOAT32_MAX_VALUE, FLOAT32_MIN_VALUE);
};


/***/ }),

/***/ 7782:
/***/ ((module) => {


// `Math.sign` method implementation
// https://tc39.es/ecma262/#sec-math.sign
// eslint-disable-next-line es/no-math-sign -- safe
module.exports = Math.sign || function sign(x) {
  var n = +x;
  // eslint-disable-next-line no-self-compare -- NaN check
  return n === 0 || n !== n ? n : n < 0 ? -1 : 1;
};


/***/ }),

/***/ 741:
/***/ ((module) => {


var ceil = Math.ceil;
var floor = Math.floor;

// `Math.trunc` method
// https://tc39.es/ecma262/#sec-math.trunc
// eslint-disable-next-line es/no-math-trunc -- safe
module.exports = Math.trunc || function trunc(x) {
  var n = +x;
  return (n > 0 ? floor : ceil)(n);
};


/***/ }),

/***/ 1955:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var safeGetBuiltIn = __webpack_require__(3389);
var bind = __webpack_require__(6080);
var macrotask = (__webpack_require__(9225).set);
var Queue = __webpack_require__(8265);
var IS_IOS = __webpack_require__(9544);
var IS_IOS_PEBBLE = __webpack_require__(4265);
var IS_WEBOS_WEBKIT = __webpack_require__(7860);
var IS_NODE = __webpack_require__(8574);

var MutationObserver = globalThis.MutationObserver || globalThis.WebKitMutationObserver;
var document = globalThis.document;
var process = globalThis.process;
var Promise = globalThis.Promise;
var microtask = safeGetBuiltIn('queueMicrotask');
var notify, toggle, node, promise, then;

// modern engines have queueMicrotask method
if (!microtask) {
  var queue = new Queue();

  var flush = function () {
    var parent, fn;
    if (IS_NODE && (parent = process.domain)) parent.exit();
    while (fn = queue.get()) try {
      fn();
    } catch (error) {
      if (queue.head) notify();
      throw error;
    }
    if (parent) parent.enter();
  };

  // browsers with MutationObserver, except iOS - https://github.com/zloirock/core-js/issues/339
  // also except WebOS Webkit https://github.com/zloirock/core-js/issues/898
  if (!IS_IOS && !IS_NODE && !IS_WEBOS_WEBKIT && MutationObserver && document) {
    toggle = true;
    node = document.createTextNode('');
    new MutationObserver(flush).observe(node, { characterData: true });
    notify = function () {
      node.data = toggle = !toggle;
    };
  // environments with maybe non-completely correct, but existent Promise
  } else if (!IS_IOS_PEBBLE && Promise && Promise.resolve) {
    // Promise.resolve without an argument throws an error in LG WebOS 2
    promise = Promise.resolve(undefined);
    // workaround of WebKit ~ iOS Safari 10.1 bug
    promise.constructor = Promise;
    then = bind(promise.then, promise);
    notify = function () {
      then(flush);
    };
  // Node.js without promises
  } else if (IS_NODE) {
    notify = function () {
      process.nextTick(flush);
    };
  // for other environments - macrotask based on:
  // - setImmediate
  // - MessageChannel
  // - window.postMessage
  // - onreadystatechange
  // - setTimeout
  } else {
    // `webpack` dev server bug on IE global methods - use bind(fn, global)
    macrotask = bind(macrotask, globalThis);
    notify = function () {
      macrotask(flush);
    };
  }

  microtask = function (fn) {
    if (!queue.head) notify();
    queue.add(fn);
  };
}

module.exports = microtask;


/***/ }),

/***/ 6043:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aCallable = __webpack_require__(9306);

var $TypeError = TypeError;

var PromiseCapability = function (C) {
  var resolve, reject;
  this.promise = new C(function ($$resolve, $$reject) {
    if (resolve !== undefined || reject !== undefined) throw new $TypeError('Bad Promise constructor');
    resolve = $$resolve;
    reject = $$reject;
  });
  this.resolve = aCallable(resolve);
  this.reject = aCallable(reject);
};

// `NewPromiseCapability` abstract operation
// https://tc39.es/ecma262/#sec-newpromisecapability
module.exports.f = function (C) {
  return new PromiseCapability(C);
};


/***/ }),

/***/ 2603:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toString = __webpack_require__(655);

module.exports = function (argument, $default) {
  return argument === undefined ? arguments.length < 2 ? '' : $default : toString(argument);
};


/***/ }),

/***/ 4149:
/***/ ((module) => {


var $RangeError = RangeError;

module.exports = function (it) {
  // eslint-disable-next-line no-self-compare -- NaN check
  if (it === it) return it;
  throw new $RangeError('NaN is not allowed');
};


/***/ }),

/***/ 5749:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isRegExp = __webpack_require__(788);

var $TypeError = TypeError;

module.exports = function (it) {
  if (isRegExp(it)) {
    throw new $TypeError("The method doesn't accept regular expressions");
  } return it;
};


/***/ }),

/***/ 3904:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var fails = __webpack_require__(9039);
var uncurryThis = __webpack_require__(9504);
var toString = __webpack_require__(655);
var trim = (__webpack_require__(3802).trim);
var whitespaces = __webpack_require__(7452);

var charAt = uncurryThis(''.charAt);
var $parseFloat = globalThis.parseFloat;
var Symbol = globalThis.Symbol;
var ITERATOR = Symbol && Symbol.iterator;
var FORCED = 1 / $parseFloat(whitespaces + '-0') !== -Infinity
  // MS Edge 18- broken with boxed symbols
  || (ITERATOR && !fails(function () { $parseFloat(Object(ITERATOR)); }));

// `parseFloat` method
// https://tc39.es/ecma262/#sec-parsefloat-string
module.exports = FORCED ? function parseFloat(string) {
  var trimmedString = trim(toString(string));
  var result = $parseFloat(trimmedString);
  return result === 0 && charAt(trimmedString, 0) === '-' ? -0 : result;
} : $parseFloat;


/***/ }),

/***/ 2703:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var fails = __webpack_require__(9039);
var uncurryThis = __webpack_require__(9504);
var toString = __webpack_require__(655);
var trim = (__webpack_require__(3802).trim);
var whitespaces = __webpack_require__(7452);

var $parseInt = globalThis.parseInt;
var Symbol = globalThis.Symbol;
var ITERATOR = Symbol && Symbol.iterator;
var hex = /^[+-]?0x/i;
var exec = uncurryThis(hex.exec);
var FORCED = $parseInt(whitespaces + '08') !== 8 || $parseInt(whitespaces + '0x16') !== 22
  // MS Edge 18- broken with boxed symbols
  || (ITERATOR && !fails(function () { $parseInt(Object(ITERATOR)); }));

// `parseInt` method
// https://tc39.es/ecma262/#sec-parseint-string-radix
module.exports = FORCED ? function parseInt(string, radix) {
  var S = trim(toString(string));
  return $parseInt(S, (radix >>> 0) || (exec(hex, S) ? 16 : 10));
} : $parseInt;


/***/ }),

/***/ 4213:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var uncurryThis = __webpack_require__(9504);
var call = __webpack_require__(9565);
var fails = __webpack_require__(9039);
var objectKeys = __webpack_require__(1072);
var getOwnPropertySymbolsModule = __webpack_require__(3717);
var propertyIsEnumerableModule = __webpack_require__(8773);
var toObject = __webpack_require__(8981);
var IndexedObject = __webpack_require__(7055);

// eslint-disable-next-line es/no-object-assign -- safe
var $assign = Object.assign;
// eslint-disable-next-line es/no-object-defineproperty -- required for testing
var defineProperty = Object.defineProperty;
var concat = uncurryThis([].concat);

// `Object.assign` method
// https://tc39.es/ecma262/#sec-object.assign
module.exports = !$assign || fails(function () {
  // should have correct order of operations (Edge bug)
  if (DESCRIPTORS && $assign({ b: 1 }, $assign(defineProperty({}, 'a', {
    enumerable: true,
    get: function () {
      defineProperty(this, 'b', {
        value: 3,
        enumerable: false
      });
    }
  }), { b: 2 })).b !== 1) return true;
  // should work with symbols and should have deterministic property order (V8 bug)
  var A = {};
  var B = {};
  // eslint-disable-next-line es/no-symbol -- safe
  var symbol = Symbol('assign detection');
  var alphabet = 'abcdefghijklmnopqrst';
  A[symbol] = 7;
  alphabet.split('').forEach(function (chr) { B[chr] = chr; });
  return $assign({}, A)[symbol] !== 7 || objectKeys($assign({}, B)).join('') !== alphabet;
}) ? function assign(target, source) { // eslint-disable-line no-unused-vars -- required for `.length`
  var T = toObject(target);
  var argumentsLength = arguments.length;
  var index = 1;
  var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
  var propertyIsEnumerable = propertyIsEnumerableModule.f;
  while (argumentsLength > index) {
    var S = IndexedObject(arguments[index++]);
    var keys = getOwnPropertySymbols ? concat(objectKeys(S), getOwnPropertySymbols(S)) : objectKeys(S);
    var length = keys.length;
    var j = 0;
    var key;
    while (length > j) {
      key = keys[j++];
      if (!DESCRIPTORS || call(propertyIsEnumerable, S, key)) T[key] = S[key];
    }
  } return T;
} : $assign;


/***/ }),

/***/ 2360:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* global ActiveXObject -- old IE, WSH */
var anObject = __webpack_require__(8551);
var definePropertiesModule = __webpack_require__(6801);
var enumBugKeys = __webpack_require__(8727);
var hiddenKeys = __webpack_require__(421);
var html = __webpack_require__(397);
var documentCreateElement = __webpack_require__(4055);
var sharedKey = __webpack_require__(6119);

var GT = '>';
var LT = '<';
var PROTOTYPE = 'prototype';
var SCRIPT = 'script';
var IE_PROTO = sharedKey('IE_PROTO');

var EmptyConstructor = function () { /* empty */ };

var scriptTag = function (content) {
  return LT + SCRIPT + GT + content + LT + '/' + SCRIPT + GT;
};

// Create object with fake `null` prototype: use ActiveX Object with cleared prototype
var NullProtoObjectViaActiveX = function (activeXDocument) {
  activeXDocument.write(scriptTag(''));
  activeXDocument.close();
  var temp = activeXDocument.parentWindow.Object;
  // eslint-disable-next-line no-useless-assignment -- avoid memory leak
  activeXDocument = null;
  return temp;
};

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var NullProtoObjectViaIFrame = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = documentCreateElement('iframe');
  var JS = 'java' + SCRIPT + ':';
  var iframeDocument;
  iframe.style.display = 'none';
  html.appendChild(iframe);
  // https://github.com/zloirock/core-js/issues/475
  iframe.src = String(JS);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(scriptTag('document.F=Object'));
  iframeDocument.close();
  return iframeDocument.F;
};

// Check for document.domain and active x support
// No need to use active x approach when document.domain is not set
// see https://github.com/es-shims/es5-shim/issues/150
// variation of https://github.com/kitcambridge/es5-shim/commit/4f738ac066346
// avoid IE GC bug
var activeXDocument;
var NullProtoObject = function () {
  try {
    activeXDocument = new ActiveXObject('htmlfile');
  } catch (error) { /* ignore */ }
  NullProtoObject = typeof document != 'undefined'
    ? document.domain && activeXDocument
      ? NullProtoObjectViaActiveX(activeXDocument) // old IE
      : NullProtoObjectViaIFrame()
    : NullProtoObjectViaActiveX(activeXDocument); // WSH
  var length = enumBugKeys.length;
  while (length--) delete NullProtoObject[PROTOTYPE][enumBugKeys[length]];
  return NullProtoObject();
};

hiddenKeys[IE_PROTO] = true;

// `Object.create` method
// https://tc39.es/ecma262/#sec-object.create
// eslint-disable-next-line es/no-object-create -- safe
module.exports = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    EmptyConstructor[PROTOTYPE] = anObject(O);
    result = new EmptyConstructor();
    EmptyConstructor[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = NullProtoObject();
  return Properties === undefined ? result : definePropertiesModule.f(result, Properties);
};


/***/ }),

/***/ 6801:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var V8_PROTOTYPE_DEFINE_BUG = __webpack_require__(8686);
var definePropertyModule = __webpack_require__(4913);
var anObject = __webpack_require__(8551);
var toIndexedObject = __webpack_require__(5397);
var objectKeys = __webpack_require__(1072);

// `Object.defineProperties` method
// https://tc39.es/ecma262/#sec-object.defineproperties
// eslint-disable-next-line es/no-object-defineproperties -- safe
exports.f = DESCRIPTORS && !V8_PROTOTYPE_DEFINE_BUG ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var props = toIndexedObject(Properties);
  var keys = objectKeys(Properties);
  var length = keys.length;
  var index = 0;
  var key;
  while (length > index) definePropertyModule.f(O, key = keys[index++], props[key]);
  return O;
};


/***/ }),

/***/ 4913:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var IE8_DOM_DEFINE = __webpack_require__(5917);
var V8_PROTOTYPE_DEFINE_BUG = __webpack_require__(8686);
var anObject = __webpack_require__(8551);
var toPropertyKey = __webpack_require__(6969);

var $TypeError = TypeError;
// eslint-disable-next-line es/no-object-defineproperty -- safe
var $defineProperty = Object.defineProperty;
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var ENUMERABLE = 'enumerable';
var CONFIGURABLE = 'configurable';
var WRITABLE = 'writable';

// `Object.defineProperty` method
// https://tc39.es/ecma262/#sec-object.defineproperty
exports.f = DESCRIPTORS ? V8_PROTOTYPE_DEFINE_BUG ? function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPropertyKey(P);
  anObject(Attributes);
  if (typeof O === 'function' && P === 'prototype' && 'value' in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
    var current = $getOwnPropertyDescriptor(O, P);
    if (current && current[WRITABLE]) {
      O[P] = Attributes.value;
      Attributes = {
        configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
        enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
        writable: false
      };
    }
  } return $defineProperty(O, P, Attributes);
} : $defineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPropertyKey(P);
  anObject(Attributes);
  if (IE8_DOM_DEFINE) try {
    return $defineProperty(O, P, Attributes);
  } catch (error) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw new $TypeError('Accessors not supported');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};


/***/ }),

/***/ 7347:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var call = __webpack_require__(9565);
var propertyIsEnumerableModule = __webpack_require__(8773);
var createPropertyDescriptor = __webpack_require__(6980);
var toIndexedObject = __webpack_require__(5397);
var toPropertyKey = __webpack_require__(6969);
var hasOwn = __webpack_require__(9297);
var IE8_DOM_DEFINE = __webpack_require__(5917);

// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// `Object.getOwnPropertyDescriptor` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
exports.f = DESCRIPTORS ? $getOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
  O = toIndexedObject(O);
  P = toPropertyKey(P);
  if (IE8_DOM_DEFINE) try {
    return $getOwnPropertyDescriptor(O, P);
  } catch (error) { /* empty */ }
  if (hasOwn(O, P)) return createPropertyDescriptor(!call(propertyIsEnumerableModule.f, O, P), O[P]);
};


/***/ }),

/***/ 298:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable es/no-object-getownpropertynames -- safe */
var classof = __webpack_require__(2195);
var toIndexedObject = __webpack_require__(5397);
var $getOwnPropertyNames = (__webpack_require__(8480).f);
var arraySlice = __webpack_require__(7680);

var windowNames = typeof window == 'object' && window && Object.getOwnPropertyNames
  ? Object.getOwnPropertyNames(window) : [];

var getWindowNames = function (it) {
  try {
    return $getOwnPropertyNames(it);
  } catch (error) {
    return arraySlice(windowNames);
  }
};

// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
module.exports.f = function getOwnPropertyNames(it) {
  return windowNames && classof(it) === 'Window'
    ? getWindowNames(it)
    : $getOwnPropertyNames(toIndexedObject(it));
};


/***/ }),

/***/ 8480:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


var internalObjectKeys = __webpack_require__(1828);
var enumBugKeys = __webpack_require__(8727);

var hiddenKeys = enumBugKeys.concat('length', 'prototype');

// `Object.getOwnPropertyNames` method
// https://tc39.es/ecma262/#sec-object.getownpropertynames
// eslint-disable-next-line es/no-object-getownpropertynames -- safe
exports.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return internalObjectKeys(O, hiddenKeys);
};


/***/ }),

/***/ 3717:
/***/ ((__unused_webpack_module, exports) => {


// eslint-disable-next-line es/no-object-getownpropertysymbols -- safe
exports.f = Object.getOwnPropertySymbols;


/***/ }),

/***/ 2787:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var hasOwn = __webpack_require__(9297);
var isCallable = __webpack_require__(4901);
var toObject = __webpack_require__(8981);
var sharedKey = __webpack_require__(6119);
var CORRECT_PROTOTYPE_GETTER = __webpack_require__(2211);

var IE_PROTO = sharedKey('IE_PROTO');
var $Object = Object;
var ObjectPrototype = $Object.prototype;

// `Object.getPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.getprototypeof
// eslint-disable-next-line es/no-object-getprototypeof -- safe
module.exports = CORRECT_PROTOTYPE_GETTER ? $Object.getPrototypeOf : function (O) {
  var object = toObject(O);
  if (hasOwn(object, IE_PROTO)) return object[IE_PROTO];
  var constructor = object.constructor;
  if (isCallable(constructor) && object instanceof constructor) {
    return constructor.prototype;
  } return object instanceof $Object ? ObjectPrototype : null;
};


/***/ }),

/***/ 4124:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var isObject = __webpack_require__(34);
var classof = __webpack_require__(2195);
var ARRAY_BUFFER_NON_EXTENSIBLE = __webpack_require__(5652);

// eslint-disable-next-line es/no-object-isextensible -- safe
var $isExtensible = Object.isExtensible;
var FAILS_ON_PRIMITIVES = fails(function () { $isExtensible(1); });

// `Object.isExtensible` method
// https://tc39.es/ecma262/#sec-object.isextensible
module.exports = (FAILS_ON_PRIMITIVES || ARRAY_BUFFER_NON_EXTENSIBLE) ? function isExtensible(it) {
  if (!isObject(it)) return false;
  if (ARRAY_BUFFER_NON_EXTENSIBLE && classof(it) === 'ArrayBuffer') return false;
  return $isExtensible ? $isExtensible(it) : true;
} : $isExtensible;


/***/ }),

/***/ 1625:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

module.exports = uncurryThis({}.isPrototypeOf);


/***/ }),

/***/ 1828:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var hasOwn = __webpack_require__(9297);
var toIndexedObject = __webpack_require__(5397);
var indexOf = (__webpack_require__(9617).indexOf);
var hiddenKeys = __webpack_require__(421);

var push = uncurryThis([].push);

module.exports = function (object, names) {
  var O = toIndexedObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) !hasOwn(hiddenKeys, key) && hasOwn(O, key) && push(result, key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (hasOwn(O, key = names[i++])) {
    ~indexOf(result, key) || push(result, key);
  }
  return result;
};


/***/ }),

/***/ 1072:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var internalObjectKeys = __webpack_require__(1828);
var enumBugKeys = __webpack_require__(8727);

// `Object.keys` method
// https://tc39.es/ecma262/#sec-object.keys
// eslint-disable-next-line es/no-object-keys -- safe
module.exports = Object.keys || function keys(O) {
  return internalObjectKeys(O, enumBugKeys);
};


/***/ }),

/***/ 8773:
/***/ ((__unused_webpack_module, exports) => {


var $propertyIsEnumerable = {}.propertyIsEnumerable;
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Nashorn ~ JDK8 bug
var NASHORN_BUG = getOwnPropertyDescriptor && !$propertyIsEnumerable.call({ 1: 2 }, 1);

// `Object.prototype.propertyIsEnumerable` method implementation
// https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
exports.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
  var descriptor = getOwnPropertyDescriptor(this, V);
  return !!descriptor && descriptor.enumerable;
} : $propertyIsEnumerable;


/***/ }),

/***/ 2967:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable no-proto -- safe */
var uncurryThisAccessor = __webpack_require__(6706);
var isObject = __webpack_require__(34);
var requireObjectCoercible = __webpack_require__(7750);
var aPossiblePrototype = __webpack_require__(3506);

// `Object.setPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.setprototypeof
// Works with __proto__ only. Old v8 can't work with null proto objects.
// eslint-disable-next-line es/no-object-setprototypeof -- safe
module.exports = Object.setPrototypeOf || ('__proto__' in {} ? function () {
  var CORRECT_SETTER = false;
  var test = {};
  var setter;
  try {
    setter = uncurryThisAccessor(Object.prototype, '__proto__', 'set');
    setter(test, []);
    CORRECT_SETTER = test instanceof Array;
  } catch (error) { /* empty */ }
  return function setPrototypeOf(O, proto) {
    requireObjectCoercible(O);
    aPossiblePrototype(proto);
    if (!isObject(O)) return O;
    if (CORRECT_SETTER) setter(O, proto);
    else O.__proto__ = proto;
    return O;
  };
}() : undefined);


/***/ }),

/***/ 2357:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var fails = __webpack_require__(9039);
var uncurryThis = __webpack_require__(9504);
var objectGetPrototypeOf = __webpack_require__(2787);
var objectKeys = __webpack_require__(1072);
var toIndexedObject = __webpack_require__(5397);
var $propertyIsEnumerable = (__webpack_require__(8773).f);

var propertyIsEnumerable = uncurryThis($propertyIsEnumerable);
var push = uncurryThis([].push);

// in some IE versions, `propertyIsEnumerable` returns incorrect result on integer keys
// of `null` prototype objects
var IE_BUG = DESCRIPTORS && fails(function () {
  // eslint-disable-next-line es/no-object-create -- safe
  var O = Object.create(null);
  O[2] = 2;
  return !propertyIsEnumerable(O, 2);
});

// `Object.{ entries, values }` methods implementation
var createMethod = function (TO_ENTRIES) {
  return function (it) {
    var O = toIndexedObject(it);
    var keys = objectKeys(O);
    var IE_WORKAROUND = IE_BUG && objectGetPrototypeOf(O) === null;
    var length = keys.length;
    var i = 0;
    var result = [];
    var key;
    while (length > i) {
      key = keys[i++];
      if (!DESCRIPTORS || (IE_WORKAROUND ? key in O : propertyIsEnumerable(O, key))) {
        push(result, TO_ENTRIES ? [key, O[key]] : O[key]);
      }
    }
    return result;
  };
};

module.exports = {
  // `Object.entries` method
  // https://tc39.es/ecma262/#sec-object.entries
  entries: createMethod(true),
  // `Object.values` method
  // https://tc39.es/ecma262/#sec-object.values
  values: createMethod(false)
};


/***/ }),

/***/ 3179:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var TO_STRING_TAG_SUPPORT = __webpack_require__(2140);
var classof = __webpack_require__(6955);

// `Object.prototype.toString` method implementation
// https://tc39.es/ecma262/#sec-object.prototype.tostring
module.exports = TO_STRING_TAG_SUPPORT ? {}.toString : function toString() {
  return '[object ' + classof(this) + ']';
};


/***/ }),

/***/ 4270:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);

var $TypeError = TypeError;

// `OrdinaryToPrimitive` abstract operation
// https://tc39.es/ecma262/#sec-ordinarytoprimitive
module.exports = function (input, pref) {
  var fn, val;
  if (pref === 'string' && isCallable(fn = input.toString) && !isObject(val = call(fn, input))) return val;
  if (isCallable(fn = input.valueOf) && !isObject(val = call(fn, input))) return val;
  if (pref !== 'string' && isCallable(fn = input.toString) && !isObject(val = call(fn, input))) return val;
  throw new $TypeError("Can't convert object to primitive value");
};


/***/ }),

/***/ 5031:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var uncurryThis = __webpack_require__(9504);
var getOwnPropertyNamesModule = __webpack_require__(8480);
var getOwnPropertySymbolsModule = __webpack_require__(3717);
var anObject = __webpack_require__(8551);

var concat = uncurryThis([].concat);

// all object keys, includes non-enumerable and symbols
module.exports = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
  var keys = getOwnPropertyNamesModule.f(anObject(it));
  var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
  return getOwnPropertySymbols ? concat(keys, getOwnPropertySymbols(it)) : keys;
};


/***/ }),

/***/ 8235:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var hasOwn = __webpack_require__(9297);

var $SyntaxError = SyntaxError;
var $parseInt = parseInt;
var fromCharCode = String.fromCharCode;
var at = uncurryThis(''.charAt);
var slice = uncurryThis(''.slice);
var exec = uncurryThis(/./.exec);

var codePoints = {
  '\\"': '"',
  '\\\\': '\\',
  '\\/': '/',
  '\\b': '\b',
  '\\f': '\f',
  '\\n': '\n',
  '\\r': '\r',
  '\\t': '\t'
};

var IS_4_HEX_DIGITS = /^[\da-f]{4}$/i;
// eslint-disable-next-line regexp/no-control-character -- safe
var IS_C0_CONTROL_CODE = /^[\u0000-\u001F]$/;

module.exports = function (source, i) {
  var unterminated = true;
  var value = '';
  while (i < source.length) {
    var chr = at(source, i);
    if (chr === '\\') {
      var twoChars = slice(source, i, i + 2);
      if (hasOwn(codePoints, twoChars)) {
        value += codePoints[twoChars];
        i += 2;
      } else if (twoChars === '\\u') {
        i += 2;
        var fourHexDigits = slice(source, i, i + 4);
        if (!exec(IS_4_HEX_DIGITS, fourHexDigits)) throw new $SyntaxError('Bad Unicode escape at: ' + i);
        value += fromCharCode($parseInt(fourHexDigits, 16));
        i += 4;
      } else throw new $SyntaxError('Unknown escape sequence: "' + twoChars + '"');
    } else if (chr === '"') {
      unterminated = false;
      i++;
      break;
    } else {
      if (exec(IS_C0_CONTROL_CODE, chr)) throw new $SyntaxError('Bad control character in string literal at: ' + i);
      value += chr;
      i++;
    }
  }
  if (unterminated) throw new $SyntaxError('Unterminated string at: ' + i);
  return { value: value, end: i };
};


/***/ }),

/***/ 9167:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);

module.exports = globalThis;


/***/ }),

/***/ 1103:
/***/ ((module) => {


module.exports = function (exec) {
  try {
    return { error: false, value: exec() };
  } catch (error) {
    return { error: true, value: error };
  }
};


/***/ }),

/***/ 916:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var NativePromiseConstructor = __webpack_require__(550);
var isCallable = __webpack_require__(4901);
var isForced = __webpack_require__(2796);
var inspectSource = __webpack_require__(3706);
var wellKnownSymbol = __webpack_require__(8227);
var ENVIRONMENT = __webpack_require__(4215);
var IS_PURE = __webpack_require__(6395);
var V8_VERSION = __webpack_require__(9519);

var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;
var SPECIES = wellKnownSymbol('species');
var SUBCLASSING = false;
var NATIVE_PROMISE_REJECTION_EVENT = isCallable(globalThis.PromiseRejectionEvent);

var FORCED_PROMISE_CONSTRUCTOR = isForced('Promise', function () {
  var PROMISE_CONSTRUCTOR_SOURCE = inspectSource(NativePromiseConstructor);
  var GLOBAL_CORE_JS_PROMISE = PROMISE_CONSTRUCTOR_SOURCE !== String(NativePromiseConstructor);
  // V8 6.6 (Node 10 and Chrome 66) have a bug with resolving custom thenables
  // https://bugs.chromium.org/p/chromium/issues/detail?id=830565
  // We can't detect it synchronously, so just check versions
  if (!GLOBAL_CORE_JS_PROMISE && V8_VERSION === 66) return true;
  // We need Promise#{ catch, finally } in the pure version for preventing prototype pollution
  if (IS_PURE && !(NativePromisePrototype['catch'] && NativePromisePrototype['finally'])) return true;
  // We can't use @@species feature detection in V8 since it causes
  // deoptimization and performance degradation
  // https://github.com/zloirock/core-js/issues/679
  if (!V8_VERSION || V8_VERSION < 51 || !/native code/.test(PROMISE_CONSTRUCTOR_SOURCE)) {
    // Detect correctness of subclassing with @@species support
    var promise = new NativePromiseConstructor(function (resolve) { resolve(1); });
    var FakePromise = function (exec) {
      exec(function () { /* empty */ }, function () { /* empty */ });
    };
    var constructor = promise.constructor = {};
    constructor[SPECIES] = FakePromise;
    SUBCLASSING = promise.then(function () { /* empty */ }) instanceof FakePromise;
    if (!SUBCLASSING) return true;
  // Unhandled rejections tracking support, NodeJS Promise without it fails @@species test
  } return !GLOBAL_CORE_JS_PROMISE && (ENVIRONMENT === 'BROWSER' || ENVIRONMENT === 'DENO') && !NATIVE_PROMISE_REJECTION_EVENT;
});

module.exports = {
  CONSTRUCTOR: FORCED_PROMISE_CONSTRUCTOR,
  REJECTION_EVENT: NATIVE_PROMISE_REJECTION_EVENT,
  SUBCLASSING: SUBCLASSING
};


/***/ }),

/***/ 550:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);

module.exports = globalThis.Promise;


/***/ }),

/***/ 3438:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var anObject = __webpack_require__(8551);
var isObject = __webpack_require__(34);
var newPromiseCapability = __webpack_require__(6043);

module.exports = function (C, x) {
  anObject(C);
  if (isObject(x) && x.constructor === C) return x;
  var promiseCapability = newPromiseCapability.f(C);
  var resolve = promiseCapability.resolve;
  resolve(x);
  return promiseCapability.promise;
};


/***/ }),

/***/ 537:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NativePromiseConstructor = __webpack_require__(550);
var checkCorrectnessOfIteration = __webpack_require__(4428);
var FORCED_PROMISE_CONSTRUCTOR = (__webpack_require__(916).CONSTRUCTOR);

module.exports = FORCED_PROMISE_CONSTRUCTOR || !checkCorrectnessOfIteration(function (iterable) {
  NativePromiseConstructor.all(iterable).then(undefined, function () { /* empty */ });
});


/***/ }),

/***/ 1056:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var defineProperty = (__webpack_require__(4913).f);

module.exports = function (Target, Source, key) {
  key in Target || defineProperty(Target, key, {
    configurable: true,
    get: function () { return Source[key]; },
    set: function (it) { Source[key] = it; }
  });
};


/***/ }),

/***/ 8265:
/***/ ((module) => {


var Queue = function () {
  this.head = null;
  this.tail = null;
};

Queue.prototype = {
  add: function (item) {
    var entry = { item: item, next: null };
    var tail = this.tail;
    if (tail) tail.next = entry;
    else this.head = entry;
    this.tail = entry;
  },
  get: function () {
    var entry = this.head;
    if (entry) {
      var next = this.head = entry.next;
      if (next === null) this.tail = null;
      return entry.item;
    }
  }
};

module.exports = Queue;


/***/ }),

/***/ 6682:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var anObject = __webpack_require__(8551);
var isCallable = __webpack_require__(4901);
var classof = __webpack_require__(2195);
var regexpExec = __webpack_require__(7323);

var $TypeError = TypeError;

// `RegExpExec` abstract operation
// https://tc39.es/ecma262/#sec-regexpexec
module.exports = function (R, S) {
  var exec = R.exec;
  if (isCallable(exec)) {
    var result = call(exec, R, S);
    if (result !== null) anObject(result);
    return result;
  }
  if (classof(R) === 'RegExp') return call(regexpExec, R, S);
  throw new $TypeError('RegExp#exec called on incompatible receiver');
};


/***/ }),

/***/ 7323:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable regexp/no-empty-capturing-group, regexp/no-empty-group, regexp/no-lazy-ends -- testing */
/* eslint-disable regexp/no-useless-quantifier -- testing */
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var toString = __webpack_require__(655);
var regexpFlags = __webpack_require__(7979);
var stickyHelpers = __webpack_require__(8429);
var shared = __webpack_require__(5745);
var create = __webpack_require__(2360);
var getInternalState = (__webpack_require__(1181).get);
var UNSUPPORTED_DOT_ALL = __webpack_require__(3635);
var UNSUPPORTED_NCG = __webpack_require__(8814);

var nativeReplace = shared('native-string-replace', String.prototype.replace);
var nativeExec = RegExp.prototype.exec;
var patchedExec = nativeExec;
var charAt = uncurryThis(''.charAt);
var indexOf = uncurryThis(''.indexOf);
var replace = uncurryThis(''.replace);
var stringSlice = uncurryThis(''.slice);

var UPDATES_LAST_INDEX_WRONG = (function () {
  var re1 = /a/;
  var re2 = /b*/g;
  call(nativeExec, re1, 'a');
  call(nativeExec, re2, 'a');
  return re1.lastIndex !== 0 || re2.lastIndex !== 0;
})();

var UNSUPPORTED_Y = stickyHelpers.BROKEN_CARET;

// nonparticipating capturing group, copied from es5-shim's String#split patch.
var NPCG_INCLUDED = /()??/.exec('')[1] !== undefined;

var PATCH = UPDATES_LAST_INDEX_WRONG || NPCG_INCLUDED || UNSUPPORTED_Y || UNSUPPORTED_DOT_ALL || UNSUPPORTED_NCG;

if (PATCH) {
  patchedExec = function exec(string) {
    var re = this;
    var state = getInternalState(re);
    var str = toString(string);
    var raw = state.raw;
    var result, reCopy, lastIndex, match, i, object, group;

    if (raw) {
      raw.lastIndex = re.lastIndex;
      result = call(patchedExec, raw, str);
      re.lastIndex = raw.lastIndex;
      return result;
    }

    var groups = state.groups;
    var sticky = UNSUPPORTED_Y && re.sticky;
    var flags = call(regexpFlags, re);
    var source = re.source;
    var charsAdded = 0;
    var strCopy = str;

    if (sticky) {
      flags = replace(flags, 'y', '');
      if (indexOf(flags, 'g') === -1) {
        flags += 'g';
      }

      strCopy = stringSlice(str, re.lastIndex);
      // Support anchored sticky behavior.
      if (re.lastIndex > 0 && (!re.multiline || re.multiline && charAt(str, re.lastIndex - 1) !== '\n')) {
        source = '(?: ' + source + ')';
        strCopy = ' ' + strCopy;
        charsAdded++;
      }
      // ^(? + rx + ) is needed, in combination with some str slicing, to
      // simulate the 'y' flag.
      reCopy = new RegExp('^(?:' + source + ')', flags);
    }

    if (NPCG_INCLUDED) {
      reCopy = new RegExp('^' + source + '$(?!\\s)', flags);
    }
    if (UPDATES_LAST_INDEX_WRONG) lastIndex = re.lastIndex;

    match = call(nativeExec, sticky ? reCopy : re, strCopy);

    if (sticky) {
      if (match) {
        match.input = stringSlice(match.input, charsAdded);
        match[0] = stringSlice(match[0], charsAdded);
        match.index = re.lastIndex;
        re.lastIndex += match[0].length;
      } else re.lastIndex = 0;
    } else if (UPDATES_LAST_INDEX_WRONG && match) {
      re.lastIndex = re.global ? match.index + match[0].length : lastIndex;
    }
    if (NPCG_INCLUDED && match && match.length > 1) {
      // Fix browsers whose `exec` methods don't consistently return `undefined`
      // for NPCG, like IE8. NOTE: This doesn't work for /(.?)?/
      call(nativeReplace, match[0], reCopy, function () {
        for (i = 1; i < arguments.length - 2; i++) {
          if (arguments[i] === undefined) match[i] = undefined;
        }
      });
    }

    if (match && groups) {
      match.groups = object = create(null);
      for (i = 0; i < groups.length; i++) {
        group = groups[i];
        object[group[0]] = match[group[1]];
      }
    }

    return match;
  };
}

module.exports = patchedExec;


/***/ }),

/***/ 7979:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var anObject = __webpack_require__(8551);

// `RegExp.prototype.flags` getter implementation
// https://tc39.es/ecma262/#sec-get-regexp.prototype.flags
module.exports = function () {
  var that = anObject(this);
  var result = '';
  if (that.hasIndices) result += 'd';
  if (that.global) result += 'g';
  if (that.ignoreCase) result += 'i';
  if (that.multiline) result += 'm';
  if (that.dotAll) result += 's';
  if (that.unicode) result += 'u';
  if (that.unicodeSets) result += 'v';
  if (that.sticky) result += 'y';
  return result;
};


/***/ }),

/***/ 1034:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var hasOwn = __webpack_require__(9297);
var isPrototypeOf = __webpack_require__(1625);
var regExpFlags = __webpack_require__(7979);

var RegExpPrototype = RegExp.prototype;

module.exports = function (R) {
  var flags = R.flags;
  return flags === undefined && !('flags' in RegExpPrototype) && !hasOwn(R, 'flags') && isPrototypeOf(RegExpPrototype, R)
    ? call(regExpFlags, R) : flags;
};


/***/ }),

/***/ 8429:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var globalThis = __webpack_require__(4576);

// babel-minify and Closure Compiler transpiles RegExp('a', 'y') -> /a/y and it causes SyntaxError
var $RegExp = globalThis.RegExp;

var UNSUPPORTED_Y = fails(function () {
  var re = $RegExp('a', 'y');
  re.lastIndex = 2;
  return re.exec('abcd') !== null;
});

// UC Browser bug
// https://github.com/zloirock/core-js/issues/1008
var MISSED_STICKY = UNSUPPORTED_Y || fails(function () {
  return !$RegExp('a', 'y').sticky;
});

var BROKEN_CARET = UNSUPPORTED_Y || fails(function () {
  // https://bugzilla.mozilla.org/show_bug.cgi?id=773687
  var re = $RegExp('^r', 'gy');
  re.lastIndex = 2;
  return re.exec('str') !== null;
});

module.exports = {
  BROKEN_CARET: BROKEN_CARET,
  MISSED_STICKY: MISSED_STICKY,
  UNSUPPORTED_Y: UNSUPPORTED_Y
};


/***/ }),

/***/ 3635:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var globalThis = __webpack_require__(4576);

// babel-minify and Closure Compiler transpiles RegExp('.', 's') -> /./s and it causes SyntaxError
var $RegExp = globalThis.RegExp;

module.exports = fails(function () {
  var re = $RegExp('.', 's');
  return !(re.dotAll && re.test('\n') && re.flags === 's');
});


/***/ }),

/***/ 8814:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var globalThis = __webpack_require__(4576);

// babel-minify and Closure Compiler transpiles RegExp('(?<a>b)', 'g') -> /(?<a>b)/g and it causes SyntaxError
var $RegExp = globalThis.RegExp;

module.exports = fails(function () {
  var re = $RegExp('(?<a>b)', 'g');
  return re.exec('b').groups.a !== 'b' ||
    'b'.replace(re, '$<a>c') !== 'bc';
});


/***/ }),

/***/ 7750:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var isNullOrUndefined = __webpack_require__(4117);

var $TypeError = TypeError;

// `RequireObjectCoercible` abstract operation
// https://tc39.es/ecma262/#sec-requireobjectcoercible
module.exports = function (it) {
  if (isNullOrUndefined(it)) throw new $TypeError("Can't call method on " + it);
  return it;
};


/***/ }),

/***/ 3389:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var DESCRIPTORS = __webpack_require__(3724);

// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Avoid NodeJS experimental warning
module.exports = function (name) {
  if (!DESCRIPTORS) return globalThis[name];
  var descriptor = getOwnPropertyDescriptor(globalThis, name);
  return descriptor && descriptor.value;
};


/***/ }),

/***/ 9286:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var SetHelpers = __webpack_require__(4402);
var iterate = __webpack_require__(8469);

var Set = SetHelpers.Set;
var add = SetHelpers.add;

module.exports = function (set) {
  var result = new Set();
  iterate(set, function (it) {
    add(result, it);
  });
  return result;
};


/***/ }),

/***/ 3440:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var SetHelpers = __webpack_require__(4402);
var clone = __webpack_require__(9286);
var size = __webpack_require__(5170);
var getSetRecord = __webpack_require__(3789);
var iterateSet = __webpack_require__(8469);
var iterateSimple = __webpack_require__(507);

var has = SetHelpers.has;
var remove = SetHelpers.remove;

// `Set.prototype.difference` method
// https://github.com/tc39/proposal-set-methods
module.exports = function difference(other) {
  var O = aSet(this);
  var otherRec = getSetRecord(other);
  var result = clone(O);
  if (size(O) <= otherRec.size) iterateSet(O, function (e) {
    if (otherRec.includes(e)) remove(result, e);
  });
  else iterateSimple(otherRec.getIterator(), function (e) {
    if (has(O, e)) remove(result, e);
  });
  return result;
};


/***/ }),

/***/ 4402:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

// eslint-disable-next-line es/no-set -- safe
var SetPrototype = Set.prototype;

module.exports = {
  // eslint-disable-next-line es/no-set -- safe
  Set: Set,
  add: uncurryThis(SetPrototype.add),
  has: uncurryThis(SetPrototype.has),
  remove: uncurryThis(SetPrototype['delete']),
  proto: SetPrototype
};


/***/ }),

/***/ 8750:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var SetHelpers = __webpack_require__(4402);
var size = __webpack_require__(5170);
var getSetRecord = __webpack_require__(3789);
var iterateSet = __webpack_require__(8469);
var iterateSimple = __webpack_require__(507);

var Set = SetHelpers.Set;
var add = SetHelpers.add;
var has = SetHelpers.has;

// `Set.prototype.intersection` method
// https://github.com/tc39/proposal-set-methods
module.exports = function intersection(other) {
  var O = aSet(this);
  var otherRec = getSetRecord(other);
  var result = new Set();

  if (size(O) > otherRec.size) {
    iterateSimple(otherRec.getIterator(), function (e) {
      if (has(O, e)) add(result, e);
    });
  } else {
    iterateSet(O, function (e) {
      if (otherRec.includes(e)) add(result, e);
    });
  }

  return result;
};


/***/ }),

/***/ 4449:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var has = (__webpack_require__(4402).has);
var size = __webpack_require__(5170);
var getSetRecord = __webpack_require__(3789);
var iterateSet = __webpack_require__(8469);
var iterateSimple = __webpack_require__(507);
var iteratorClose = __webpack_require__(9539);

// `Set.prototype.isDisjointFrom` method
// https://tc39.github.io/proposal-set-methods/#Set.prototype.isDisjointFrom
module.exports = function isDisjointFrom(other) {
  var O = aSet(this);
  var otherRec = getSetRecord(other);
  if (size(O) <= otherRec.size) return iterateSet(O, function (e) {
    if (otherRec.includes(e)) return false;
  }, true) !== false;
  var iterator = otherRec.getIterator();
  return iterateSimple(iterator, function (e) {
    if (has(O, e)) return iteratorClose(iterator, 'normal', false);
  }) !== false;
};


/***/ }),

/***/ 3838:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var size = __webpack_require__(5170);
var iterate = __webpack_require__(8469);
var getSetRecord = __webpack_require__(3789);

// `Set.prototype.isSubsetOf` method
// https://tc39.github.io/proposal-set-methods/#Set.prototype.isSubsetOf
module.exports = function isSubsetOf(other) {
  var O = aSet(this);
  var otherRec = getSetRecord(other);
  if (size(O) > otherRec.size) return false;
  return iterate(O, function (e) {
    if (!otherRec.includes(e)) return false;
  }, true) !== false;
};


/***/ }),

/***/ 8527:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var has = (__webpack_require__(4402).has);
var size = __webpack_require__(5170);
var getSetRecord = __webpack_require__(3789);
var iterateSimple = __webpack_require__(507);
var iteratorClose = __webpack_require__(9539);

// `Set.prototype.isSupersetOf` method
// https://tc39.github.io/proposal-set-methods/#Set.prototype.isSupersetOf
module.exports = function isSupersetOf(other) {
  var O = aSet(this);
  var otherRec = getSetRecord(other);
  if (size(O) < otherRec.size) return false;
  var iterator = otherRec.getIterator();
  return iterateSimple(iterator, function (e) {
    if (!has(O, e)) return iteratorClose(iterator, 'normal', false);
  }) !== false;
};


/***/ }),

/***/ 8469:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var iterateSimple = __webpack_require__(507);
var SetHelpers = __webpack_require__(4402);

var Set = SetHelpers.Set;
var SetPrototype = SetHelpers.proto;
var forEach = uncurryThis(SetPrototype.forEach);
var keys = uncurryThis(SetPrototype.keys);
var next = keys(new Set()).next;

module.exports = function (set, fn, interruptible) {
  return interruptible ? iterateSimple({ iterator: keys(set), next: next }, fn) : forEach(set, fn);
};


/***/ }),

/***/ 4916:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);

var createSetLike = function (size) {
  return {
    size: size,
    has: function () {
      return false;
    },
    keys: function () {
      return {
        next: function () {
          return { done: true };
        }
      };
    }
  };
};

module.exports = function (name) {
  var Set = getBuiltIn('Set');
  try {
    new Set()[name](createSetLike(0));
    try {
      // late spec change, early WebKit ~ Safari 17.0 beta implementation does not pass it
      // https://github.com/tc39/proposal-set-methods/pull/88
      new Set()[name](createSetLike(-1));
      return false;
    } catch (error2) {
      return true;
    }
  } catch (error) {
    return false;
  }
};


/***/ }),

/***/ 5170:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThisAccessor = __webpack_require__(6706);
var SetHelpers = __webpack_require__(4402);

module.exports = uncurryThisAccessor(SetHelpers.proto, 'size', 'get') || function (set) {
  return set.size;
};


/***/ }),

/***/ 7633:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var defineBuiltInAccessor = __webpack_require__(2106);
var wellKnownSymbol = __webpack_require__(8227);
var DESCRIPTORS = __webpack_require__(3724);

var SPECIES = wellKnownSymbol('species');

module.exports = function (CONSTRUCTOR_NAME) {
  var Constructor = getBuiltIn(CONSTRUCTOR_NAME);

  if (DESCRIPTORS && Constructor && !Constructor[SPECIES]) {
    defineBuiltInAccessor(Constructor, SPECIES, {
      configurable: true,
      get: function () { return this; }
    });
  }
};


/***/ }),

/***/ 3650:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var SetHelpers = __webpack_require__(4402);
var clone = __webpack_require__(9286);
var getSetRecord = __webpack_require__(3789);
var iterateSimple = __webpack_require__(507);

var add = SetHelpers.add;
var has = SetHelpers.has;
var remove = SetHelpers.remove;

// `Set.prototype.symmetricDifference` method
// https://github.com/tc39/proposal-set-methods
module.exports = function symmetricDifference(other) {
  var O = aSet(this);
  var keysIter = getSetRecord(other).getIterator();
  var result = clone(O);
  iterateSimple(keysIter, function (e) {
    if (has(O, e)) remove(result, e);
    else add(result, e);
  });
  return result;
};


/***/ }),

/***/ 687:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var defineProperty = (__webpack_require__(4913).f);
var hasOwn = __webpack_require__(9297);
var wellKnownSymbol = __webpack_require__(8227);

var TO_STRING_TAG = wellKnownSymbol('toStringTag');

module.exports = function (target, TAG, STATIC) {
  if (target && !STATIC) target = target.prototype;
  if (target && !hasOwn(target, TO_STRING_TAG)) {
    defineProperty(target, TO_STRING_TAG, { configurable: true, value: TAG });
  }
};


/***/ }),

/***/ 4204:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var aSet = __webpack_require__(7080);
var add = (__webpack_require__(4402).add);
var clone = __webpack_require__(9286);
var getSetRecord = __webpack_require__(3789);
var iterateSimple = __webpack_require__(507);

// `Set.prototype.union` method
// https://github.com/tc39/proposal-set-methods
module.exports = function union(other) {
  var O = aSet(this);
  var keysIter = getSetRecord(other).getIterator();
  var result = clone(O);
  iterateSimple(keysIter, function (it) {
    add(result, it);
  });
  return result;
};


/***/ }),

/***/ 6119:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var shared = __webpack_require__(5745);
var uid = __webpack_require__(3392);

var keys = shared('keys');

module.exports = function (key) {
  return keys[key] || (keys[key] = uid(key));
};


/***/ }),

/***/ 7629:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var IS_PURE = __webpack_require__(6395);
var globalThis = __webpack_require__(4576);
var defineGlobalProperty = __webpack_require__(9433);

var SHARED = '__core-js_shared__';
var store = module.exports = globalThis[SHARED] || defineGlobalProperty(SHARED, {});

(store.versions || (store.versions = [])).push({
  version: '3.39.0',
  mode: IS_PURE ? 'pure' : 'global',
  copyright: '© 2014-2024 Denis Pushkarev (zloirock.ru)',
  license: 'https://github.com/zloirock/core-js/blob/v3.39.0/LICENSE',
  source: 'https://github.com/zloirock/core-js'
});


/***/ }),

/***/ 5745:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var store = __webpack_require__(7629);

module.exports = function (key, value) {
  return store[key] || (store[key] = value || {});
};


/***/ }),

/***/ 2293:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var anObject = __webpack_require__(8551);
var aConstructor = __webpack_require__(5548);
var isNullOrUndefined = __webpack_require__(4117);
var wellKnownSymbol = __webpack_require__(8227);

var SPECIES = wellKnownSymbol('species');

// `SpeciesConstructor` abstract operation
// https://tc39.es/ecma262/#sec-speciesconstructor
module.exports = function (O, defaultConstructor) {
  var C = anObject(O).constructor;
  var S;
  return C === undefined || isNullOrUndefined(S = anObject(C)[SPECIES]) ? defaultConstructor : aConstructor(S);
};


/***/ }),

/***/ 8183:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var toIntegerOrInfinity = __webpack_require__(1291);
var toString = __webpack_require__(655);
var requireObjectCoercible = __webpack_require__(7750);

var charAt = uncurryThis(''.charAt);
var charCodeAt = uncurryThis(''.charCodeAt);
var stringSlice = uncurryThis(''.slice);

var createMethod = function (CONVERT_TO_STRING) {
  return function ($this, pos) {
    var S = toString(requireObjectCoercible($this));
    var position = toIntegerOrInfinity(pos);
    var size = S.length;
    var first, second;
    if (position < 0 || position >= size) return CONVERT_TO_STRING ? '' : undefined;
    first = charCodeAt(S, position);
    return first < 0xD800 || first > 0xDBFF || position + 1 === size
      || (second = charCodeAt(S, position + 1)) < 0xDC00 || second > 0xDFFF
        ? CONVERT_TO_STRING
          ? charAt(S, position)
          : first
        : CONVERT_TO_STRING
          ? stringSlice(S, position, position + 2)
          : (first - 0xD800 << 10) + (second - 0xDC00) + 0x10000;
  };
};

module.exports = {
  // `String.prototype.codePointAt` method
  // https://tc39.es/ecma262/#sec-string.prototype.codepointat
  codeAt: createMethod(false),
  // `String.prototype.at` method
  // https://github.com/mathiasbynens/String.prototype.at
  charAt: createMethod(true)
};


/***/ }),

/***/ 3063:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// https://github.com/zloirock/core-js/issues/280
var userAgent = __webpack_require__(2839);

module.exports = /Version\/10(?:\.\d+){1,2}(?: [\w./]+)?(?: Mobile\/\w+)? Safari\//.test(userAgent);


/***/ }),

/***/ 533:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// https://github.com/tc39/proposal-string-pad-start-end
var uncurryThis = __webpack_require__(9504);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var $repeat = __webpack_require__(2333);
var requireObjectCoercible = __webpack_require__(7750);

var repeat = uncurryThis($repeat);
var stringSlice = uncurryThis(''.slice);
var ceil = Math.ceil;

// `String.prototype.{ padStart, padEnd }` methods implementation
var createMethod = function (IS_END) {
  return function ($this, maxLength, fillString) {
    var S = toString(requireObjectCoercible($this));
    var intMaxLength = toLength(maxLength);
    var stringLength = S.length;
    var fillStr = fillString === undefined ? ' ' : toString(fillString);
    var fillLen, stringFiller;
    if (intMaxLength <= stringLength || fillStr === '') return S;
    fillLen = intMaxLength - stringLength;
    stringFiller = repeat(fillStr, ceil(fillLen / fillStr.length));
    if (stringFiller.length > fillLen) stringFiller = stringSlice(stringFiller, 0, fillLen);
    return IS_END ? S + stringFiller : stringFiller + S;
  };
};

module.exports = {
  // `String.prototype.padStart` method
  // https://tc39.es/ecma262/#sec-string.prototype.padstart
  start: createMethod(false),
  // `String.prototype.padEnd` method
  // https://tc39.es/ecma262/#sec-string.prototype.padend
  end: createMethod(true)
};


/***/ }),

/***/ 6098:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// based on https://github.com/bestiejs/punycode.js/blob/master/punycode.js
var uncurryThis = __webpack_require__(9504);

var maxInt = 2147483647; // aka. 0x7FFFFFFF or 2^31-1
var base = 36;
var tMin = 1;
var tMax = 26;
var skew = 38;
var damp = 700;
var initialBias = 72;
var initialN = 128; // 0x80
var delimiter = '-'; // '\x2D'
var regexNonASCII = /[^\0-\u007E]/; // non-ASCII chars
var regexSeparators = /[.\u3002\uFF0E\uFF61]/g; // RFC 3490 separators
var OVERFLOW_ERROR = 'Overflow: input needs wider integers to process';
var baseMinusTMin = base - tMin;

var $RangeError = RangeError;
var exec = uncurryThis(regexSeparators.exec);
var floor = Math.floor;
var fromCharCode = String.fromCharCode;
var charCodeAt = uncurryThis(''.charCodeAt);
var join = uncurryThis([].join);
var push = uncurryThis([].push);
var replace = uncurryThis(''.replace);
var split = uncurryThis(''.split);
var toLowerCase = uncurryThis(''.toLowerCase);

/**
 * Creates an array containing the numeric code points of each Unicode
 * character in the string. While JavaScript uses UCS-2 internally,
 * this function will convert a pair of surrogate halves (each of which
 * UCS-2 exposes as separate characters) into a single code point,
 * matching UTF-16.
 */
var ucs2decode = function (string) {
  var output = [];
  var counter = 0;
  var length = string.length;
  while (counter < length) {
    var value = charCodeAt(string, counter++);
    if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
      // It's a high surrogate, and there is a next character.
      var extra = charCodeAt(string, counter++);
      if ((extra & 0xFC00) === 0xDC00) { // Low surrogate.
        push(output, ((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
      } else {
        // It's an unmatched surrogate; only append this code unit, in case the
        // next code unit is the high surrogate of a surrogate pair.
        push(output, value);
        counter--;
      }
    } else {
      push(output, value);
    }
  }
  return output;
};

/**
 * Converts a digit/integer into a basic code point.
 */
var digitToBasic = function (digit) {
  //  0..25 map to ASCII a..z or A..Z
  // 26..35 map to ASCII 0..9
  return digit + 22 + 75 * (digit < 26);
};

/**
 * Bias adaptation function as per section 3.4 of RFC 3492.
 * https://tools.ietf.org/html/rfc3492#section-3.4
 */
var adapt = function (delta, numPoints, firstTime) {
  var k = 0;
  delta = firstTime ? floor(delta / damp) : delta >> 1;
  delta += floor(delta / numPoints);
  while (delta > baseMinusTMin * tMax >> 1) {
    delta = floor(delta / baseMinusTMin);
    k += base;
  }
  return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
};

/**
 * Converts a string of Unicode symbols (e.g. a domain name label) to a
 * Punycode string of ASCII-only symbols.
 */
var encode = function (input) {
  var output = [];

  // Convert the input in UCS-2 to an array of Unicode code points.
  input = ucs2decode(input);

  // Cache the length.
  var inputLength = input.length;

  // Initialize the state.
  var n = initialN;
  var delta = 0;
  var bias = initialBias;
  var i, currentValue;

  // Handle the basic code points.
  for (i = 0; i < input.length; i++) {
    currentValue = input[i];
    if (currentValue < 0x80) {
      push(output, fromCharCode(currentValue));
    }
  }

  var basicLength = output.length; // number of basic code points.
  var handledCPCount = basicLength; // number of code points that have been handled;

  // Finish the basic string with a delimiter unless it's empty.
  if (basicLength) {
    push(output, delimiter);
  }

  // Main encoding loop:
  while (handledCPCount < inputLength) {
    // All non-basic code points < n have been handled already. Find the next larger one:
    var m = maxInt;
    for (i = 0; i < input.length; i++) {
      currentValue = input[i];
      if (currentValue >= n && currentValue < m) {
        m = currentValue;
      }
    }

    // Increase `delta` enough to advance the decoder's <n,i> state to <m,0>, but guard against overflow.
    var handledCPCountPlusOne = handledCPCount + 1;
    if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
      throw new $RangeError(OVERFLOW_ERROR);
    }

    delta += (m - n) * handledCPCountPlusOne;
    n = m;

    for (i = 0; i < input.length; i++) {
      currentValue = input[i];
      if (currentValue < n && ++delta > maxInt) {
        throw new $RangeError(OVERFLOW_ERROR);
      }
      if (currentValue === n) {
        // Represent delta as a generalized variable-length integer.
        var q = delta;
        var k = base;
        while (true) {
          var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
          if (q < t) break;
          var qMinusT = q - t;
          var baseMinusT = base - t;
          push(output, fromCharCode(digitToBasic(t + qMinusT % baseMinusT)));
          q = floor(qMinusT / baseMinusT);
          k += base;
        }

        push(output, fromCharCode(digitToBasic(q)));
        bias = adapt(delta, handledCPCountPlusOne, handledCPCount === basicLength);
        delta = 0;
        handledCPCount++;
      }
    }

    delta++;
    n++;
  }
  return join(output, '');
};

module.exports = function (input) {
  var encoded = [];
  var labels = split(replace(toLowerCase(input), regexSeparators, '\u002E'), '.');
  var i, label;
  for (i = 0; i < labels.length; i++) {
    label = labels[i];
    push(encoded, exec(regexNonASCII, label) ? 'xn--' + encode(label) : label);
  }
  return join(encoded, '.');
};


/***/ }),

/***/ 2333:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIntegerOrInfinity = __webpack_require__(1291);
var toString = __webpack_require__(655);
var requireObjectCoercible = __webpack_require__(7750);

var $RangeError = RangeError;

// `String.prototype.repeat` method implementation
// https://tc39.es/ecma262/#sec-string.prototype.repeat
module.exports = function repeat(count) {
  var str = toString(requireObjectCoercible(this));
  var result = '';
  var n = toIntegerOrInfinity(count);
  if (n < 0 || n === Infinity) throw new $RangeError('Wrong number of repetitions');
  for (;n > 0; (n >>>= 1) && (str += str)) if (n & 1) result += str;
  return result;
};


/***/ }),

/***/ 8866:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $trimEnd = (__webpack_require__(3802).end);
var forcedStringTrimMethod = __webpack_require__(706);

// `String.prototype.{ trimEnd, trimRight }` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// https://tc39.es/ecma262/#String.prototype.trimright
module.exports = forcedStringTrimMethod('trimEnd') ? function trimEnd() {
  return $trimEnd(this);
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
} : ''.trimEnd;


/***/ }),

/***/ 706:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var PROPER_FUNCTION_NAME = (__webpack_require__(350).PROPER);
var fails = __webpack_require__(9039);
var whitespaces = __webpack_require__(7452);

var non = '\u200B\u0085\u180E';

// check that a method works with the correct list
// of whitespaces and has a correct name
module.exports = function (METHOD_NAME) {
  return fails(function () {
    return !!whitespaces[METHOD_NAME]()
      || non[METHOD_NAME]() !== non
      || (PROPER_FUNCTION_NAME && whitespaces[METHOD_NAME].name !== METHOD_NAME);
  });
};


/***/ }),

/***/ 3487:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $trimStart = (__webpack_require__(3802).start);
var forcedStringTrimMethod = __webpack_require__(706);

// `String.prototype.{ trimStart, trimLeft }` method
// https://tc39.es/ecma262/#sec-string.prototype.trimstart
// https://tc39.es/ecma262/#String.prototype.trimleft
module.exports = forcedStringTrimMethod('trimStart') ? function trimStart() {
  return $trimStart(this);
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
} : ''.trimStart;


/***/ }),

/***/ 3802:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var requireObjectCoercible = __webpack_require__(7750);
var toString = __webpack_require__(655);
var whitespaces = __webpack_require__(7452);

var replace = uncurryThis(''.replace);
var ltrim = RegExp('^[' + whitespaces + ']+');
var rtrim = RegExp('(^|[^' + whitespaces + '])[' + whitespaces + ']+$');

// `String.prototype.{ trim, trimStart, trimEnd, trimLeft, trimRight }` methods implementation
var createMethod = function (TYPE) {
  return function ($this) {
    var string = toString(requireObjectCoercible($this));
    if (TYPE & 1) string = replace(string, ltrim, '');
    if (TYPE & 2) string = replace(string, rtrim, '$1');
    return string;
  };
};

module.exports = {
  // `String.prototype.{ trimLeft, trimStart }` methods
  // https://tc39.es/ecma262/#sec-string.prototype.trimstart
  start: createMethod(1),
  // `String.prototype.{ trimRight, trimEnd }` methods
  // https://tc39.es/ecma262/#sec-string.prototype.trimend
  end: createMethod(2),
  // `String.prototype.trim` method
  // https://tc39.es/ecma262/#sec-string.prototype.trim
  trim: createMethod(3)
};


/***/ }),

/***/ 1548:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var fails = __webpack_require__(9039);
var V8 = __webpack_require__(9519);
var ENVIRONMENT = __webpack_require__(4215);

var structuredClone = globalThis.structuredClone;

module.exports = !!structuredClone && !fails(function () {
  // prevent V8 ArrayBufferDetaching protector cell invalidation and performance degradation
  // https://github.com/zloirock/core-js/issues/679
  if ((ENVIRONMENT === 'DENO' && V8 > 92) || (ENVIRONMENT === 'NODE' && V8 > 94) || (ENVIRONMENT === 'BROWSER' && V8 > 97)) return false;
  var buffer = new ArrayBuffer(8);
  var clone = structuredClone(buffer, { transfer: [buffer] });
  return buffer.byteLength !== 0 || clone.byteLength !== 8;
});


/***/ }),

/***/ 4495:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable es/no-symbol -- required for testing */
var V8_VERSION = __webpack_require__(9519);
var fails = __webpack_require__(9039);
var globalThis = __webpack_require__(4576);

var $String = globalThis.String;

// eslint-disable-next-line es/no-object-getownpropertysymbols -- required for testing
module.exports = !!Object.getOwnPropertySymbols && !fails(function () {
  var symbol = Symbol('symbol detection');
  // Chrome 38 Symbol has incorrect toString conversion
  // `get-own-property-symbols` polyfill symbols converted to object are not Symbol instances
  // nb: Do not call `String` directly to avoid this being optimized out to `symbol+''` which will,
  // of course, fail.
  return !$String(symbol) || !(Object(symbol) instanceof Symbol) ||
    // Chrome 38-40 symbols are not inherited from DOM collections prototypes to instances
    !Symbol.sham && V8_VERSION && V8_VERSION < 41;
});


/***/ }),

/***/ 8242:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var getBuiltIn = __webpack_require__(7751);
var wellKnownSymbol = __webpack_require__(8227);
var defineBuiltIn = __webpack_require__(6840);

module.exports = function () {
  var Symbol = getBuiltIn('Symbol');
  var SymbolPrototype = Symbol && Symbol.prototype;
  var valueOf = SymbolPrototype && SymbolPrototype.valueOf;
  var TO_PRIMITIVE = wellKnownSymbol('toPrimitive');

  if (SymbolPrototype && !SymbolPrototype[TO_PRIMITIVE]) {
    // `Symbol.prototype[@@toPrimitive]` method
    // https://tc39.es/ecma262/#sec-symbol.prototype-@@toprimitive
    // eslint-disable-next-line no-unused-vars -- required for .length
    defineBuiltIn(SymbolPrototype, TO_PRIMITIVE, function (hint) {
      return call(valueOf, this);
    }, { arity: 1 });
  }
};


/***/ }),

/***/ 1296:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var NATIVE_SYMBOL = __webpack_require__(4495);

/* eslint-disable es/no-symbol -- safe */
module.exports = NATIVE_SYMBOL && !!Symbol['for'] && !!Symbol.keyFor;


/***/ }),

/***/ 9225:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var apply = __webpack_require__(8745);
var bind = __webpack_require__(6080);
var isCallable = __webpack_require__(4901);
var hasOwn = __webpack_require__(9297);
var fails = __webpack_require__(9039);
var html = __webpack_require__(397);
var arraySlice = __webpack_require__(7680);
var createElement = __webpack_require__(4055);
var validateArgumentsLength = __webpack_require__(2812);
var IS_IOS = __webpack_require__(9544);
var IS_NODE = __webpack_require__(8574);

var set = globalThis.setImmediate;
var clear = globalThis.clearImmediate;
var process = globalThis.process;
var Dispatch = globalThis.Dispatch;
var Function = globalThis.Function;
var MessageChannel = globalThis.MessageChannel;
var String = globalThis.String;
var counter = 0;
var queue = {};
var ONREADYSTATECHANGE = 'onreadystatechange';
var $location, defer, channel, port;

fails(function () {
  // Deno throws a ReferenceError on `location` access without `--location` flag
  $location = globalThis.location;
});

var run = function (id) {
  if (hasOwn(queue, id)) {
    var fn = queue[id];
    delete queue[id];
    fn();
  }
};

var runner = function (id) {
  return function () {
    run(id);
  };
};

var eventListener = function (event) {
  run(event.data);
};

var globalPostMessageDefer = function (id) {
  // old engines have not location.origin
  globalThis.postMessage(String(id), $location.protocol + '//' + $location.host);
};

// Node.js 0.9+ & IE10+ has setImmediate, otherwise:
if (!set || !clear) {
  set = function setImmediate(handler) {
    validateArgumentsLength(arguments.length, 1);
    var fn = isCallable(handler) ? handler : Function(handler);
    var args = arraySlice(arguments, 1);
    queue[++counter] = function () {
      apply(fn, undefined, args);
    };
    defer(counter);
    return counter;
  };
  clear = function clearImmediate(id) {
    delete queue[id];
  };
  // Node.js 0.8-
  if (IS_NODE) {
    defer = function (id) {
      process.nextTick(runner(id));
    };
  // Sphere (JS game engine) Dispatch API
  } else if (Dispatch && Dispatch.now) {
    defer = function (id) {
      Dispatch.now(runner(id));
    };
  // Browsers with MessageChannel, includes WebWorkers
  // except iOS - https://github.com/zloirock/core-js/issues/624
  } else if (MessageChannel && !IS_IOS) {
    channel = new MessageChannel();
    port = channel.port2;
    channel.port1.onmessage = eventListener;
    defer = bind(port.postMessage, port);
  // Browsers with postMessage, skip WebWorkers
  // IE8 has postMessage, but it's sync & typeof its postMessage is 'object'
  } else if (
    globalThis.addEventListener &&
    isCallable(globalThis.postMessage) &&
    !globalThis.importScripts &&
    $location && $location.protocol !== 'file:' &&
    !fails(globalPostMessageDefer)
  ) {
    defer = globalPostMessageDefer;
    globalThis.addEventListener('message', eventListener, false);
  // IE8-
  } else if (ONREADYSTATECHANGE in createElement('script')) {
    defer = function (id) {
      html.appendChild(createElement('script'))[ONREADYSTATECHANGE] = function () {
        html.removeChild(this);
        run(id);
      };
    };
  // Rest old browsers
  } else {
    defer = function (id) {
      setTimeout(runner(id), 0);
    };
  }
}

module.exports = {
  set: set,
  clear: clear
};


/***/ }),

/***/ 1240:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

// `thisNumberValue` abstract operation
// https://tc39.es/ecma262/#sec-thisnumbervalue
module.exports = uncurryThis(1.0.valueOf);


/***/ }),

/***/ 5610:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIntegerOrInfinity = __webpack_require__(1291);

var max = Math.max;
var min = Math.min;

// Helper for a popular repeating case of the spec:
// Let integer be ? ToInteger(index).
// If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
module.exports = function (index, length) {
  var integer = toIntegerOrInfinity(index);
  return integer < 0 ? max(integer + length, 0) : min(integer, length);
};


/***/ }),

/***/ 5854:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toPrimitive = __webpack_require__(2777);

var $TypeError = TypeError;

// `ToBigInt` abstract operation
// https://tc39.es/ecma262/#sec-tobigint
module.exports = function (argument) {
  var prim = toPrimitive(argument, 'number');
  if (typeof prim == 'number') throw new $TypeError("Can't convert number to bigint");
  // eslint-disable-next-line es/no-bigint -- safe
  return BigInt(prim);
};


/***/ }),

/***/ 7696:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIntegerOrInfinity = __webpack_require__(1291);
var toLength = __webpack_require__(8014);

var $RangeError = RangeError;

// `ToIndex` abstract operation
// https://tc39.es/ecma262/#sec-toindex
module.exports = function (it) {
  if (it === undefined) return 0;
  var number = toIntegerOrInfinity(it);
  var length = toLength(number);
  if (number !== length) throw new $RangeError('Wrong length or index');
  return length;
};


/***/ }),

/***/ 5397:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// toObject with fallback for non-array-like ES3 strings
var IndexedObject = __webpack_require__(7055);
var requireObjectCoercible = __webpack_require__(7750);

module.exports = function (it) {
  return IndexedObject(requireObjectCoercible(it));
};


/***/ }),

/***/ 1291:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var trunc = __webpack_require__(741);

// `ToIntegerOrInfinity` abstract operation
// https://tc39.es/ecma262/#sec-tointegerorinfinity
module.exports = function (argument) {
  var number = +argument;
  // eslint-disable-next-line no-self-compare -- NaN check
  return number !== number || number === 0 ? 0 : trunc(number);
};


/***/ }),

/***/ 8014:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIntegerOrInfinity = __webpack_require__(1291);

var min = Math.min;

// `ToLength` abstract operation
// https://tc39.es/ecma262/#sec-tolength
module.exports = function (argument) {
  var len = toIntegerOrInfinity(argument);
  return len > 0 ? min(len, 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
};


/***/ }),

/***/ 8981:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var requireObjectCoercible = __webpack_require__(7750);

var $Object = Object;

// `ToObject` abstract operation
// https://tc39.es/ecma262/#sec-toobject
module.exports = function (argument) {
  return $Object(requireObjectCoercible(argument));
};


/***/ }),

/***/ 8229:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toPositiveInteger = __webpack_require__(9590);

var $RangeError = RangeError;

module.exports = function (it, BYTES) {
  var offset = toPositiveInteger(it);
  if (offset % BYTES) throw new $RangeError('Wrong offset');
  return offset;
};


/***/ }),

/***/ 9590:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIntegerOrInfinity = __webpack_require__(1291);

var $RangeError = RangeError;

module.exports = function (it) {
  var result = toIntegerOrInfinity(it);
  if (result < 0) throw new $RangeError("The argument can't be less than 0");
  return result;
};


/***/ }),

/***/ 2777:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var isObject = __webpack_require__(34);
var isSymbol = __webpack_require__(757);
var getMethod = __webpack_require__(5966);
var ordinaryToPrimitive = __webpack_require__(4270);
var wellKnownSymbol = __webpack_require__(8227);

var $TypeError = TypeError;
var TO_PRIMITIVE = wellKnownSymbol('toPrimitive');

// `ToPrimitive` abstract operation
// https://tc39.es/ecma262/#sec-toprimitive
module.exports = function (input, pref) {
  if (!isObject(input) || isSymbol(input)) return input;
  var exoticToPrim = getMethod(input, TO_PRIMITIVE);
  var result;
  if (exoticToPrim) {
    if (pref === undefined) pref = 'default';
    result = call(exoticToPrim, input, pref);
    if (!isObject(result) || isSymbol(result)) return result;
    throw new $TypeError("Can't convert object to primitive value");
  }
  if (pref === undefined) pref = 'number';
  return ordinaryToPrimitive(input, pref);
};


/***/ }),

/***/ 6969:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toPrimitive = __webpack_require__(2777);
var isSymbol = __webpack_require__(757);

// `ToPropertyKey` abstract operation
// https://tc39.es/ecma262/#sec-topropertykey
module.exports = function (argument) {
  var key = toPrimitive(argument, 'string');
  return isSymbol(key) ? key : key + '';
};


/***/ }),

/***/ 2140:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);

var TO_STRING_TAG = wellKnownSymbol('toStringTag');
var test = {};

test[TO_STRING_TAG] = 'z';

module.exports = String(test) === '[object z]';


/***/ }),

/***/ 655:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var classof = __webpack_require__(6955);

var $String = String;

module.exports = function (argument) {
  if (classof(argument) === 'Symbol') throw new TypeError('Cannot convert a Symbol value to a string');
  return $String(argument);
};


/***/ }),

/***/ 8319:
/***/ ((module) => {


var round = Math.round;

module.exports = function (it) {
  var value = round(it);
  return value < 0 ? 0 : value > 0xFF ? 0xFF : value & 0xFF;
};


/***/ }),

/***/ 6823:
/***/ ((module) => {


var $String = String;

module.exports = function (argument) {
  try {
    return $String(argument);
  } catch (error) {
    return 'Object';
  }
};


/***/ }),

/***/ 5823:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var call = __webpack_require__(9565);
var DESCRIPTORS = __webpack_require__(3724);
var TYPED_ARRAYS_CONSTRUCTORS_REQUIRES_WRAPPERS = __webpack_require__(2805);
var ArrayBufferViewCore = __webpack_require__(4644);
var ArrayBufferModule = __webpack_require__(6346);
var anInstance = __webpack_require__(679);
var createPropertyDescriptor = __webpack_require__(6980);
var createNonEnumerableProperty = __webpack_require__(6699);
var isIntegralNumber = __webpack_require__(2087);
var toLength = __webpack_require__(8014);
var toIndex = __webpack_require__(7696);
var toOffset = __webpack_require__(8229);
var toUint8Clamped = __webpack_require__(8319);
var toPropertyKey = __webpack_require__(6969);
var hasOwn = __webpack_require__(9297);
var classof = __webpack_require__(6955);
var isObject = __webpack_require__(34);
var isSymbol = __webpack_require__(757);
var create = __webpack_require__(2360);
var isPrototypeOf = __webpack_require__(1625);
var setPrototypeOf = __webpack_require__(2967);
var getOwnPropertyNames = (__webpack_require__(8480).f);
var typedArrayFrom = __webpack_require__(3251);
var forEach = (__webpack_require__(9213).forEach);
var setSpecies = __webpack_require__(7633);
var defineBuiltInAccessor = __webpack_require__(2106);
var definePropertyModule = __webpack_require__(4913);
var getOwnPropertyDescriptorModule = __webpack_require__(7347);
var arrayFromConstructorAndList = __webpack_require__(5370);
var InternalStateModule = __webpack_require__(1181);
var inheritIfRequired = __webpack_require__(3167);

var getInternalState = InternalStateModule.get;
var setInternalState = InternalStateModule.set;
var enforceInternalState = InternalStateModule.enforce;
var nativeDefineProperty = definePropertyModule.f;
var nativeGetOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
var RangeError = globalThis.RangeError;
var ArrayBuffer = ArrayBufferModule.ArrayBuffer;
var ArrayBufferPrototype = ArrayBuffer.prototype;
var DataView = ArrayBufferModule.DataView;
var NATIVE_ARRAY_BUFFER_VIEWS = ArrayBufferViewCore.NATIVE_ARRAY_BUFFER_VIEWS;
var TYPED_ARRAY_TAG = ArrayBufferViewCore.TYPED_ARRAY_TAG;
var TypedArray = ArrayBufferViewCore.TypedArray;
var TypedArrayPrototype = ArrayBufferViewCore.TypedArrayPrototype;
var isTypedArray = ArrayBufferViewCore.isTypedArray;
var BYTES_PER_ELEMENT = 'BYTES_PER_ELEMENT';
var WRONG_LENGTH = 'Wrong length';

var addGetter = function (it, key) {
  defineBuiltInAccessor(it, key, {
    configurable: true,
    get: function () {
      return getInternalState(this)[key];
    }
  });
};

var isArrayBuffer = function (it) {
  var klass;
  return isPrototypeOf(ArrayBufferPrototype, it) || (klass = classof(it)) === 'ArrayBuffer' || klass === 'SharedArrayBuffer';
};

var isTypedArrayIndex = function (target, key) {
  return isTypedArray(target)
    && !isSymbol(key)
    && key in target
    && isIntegralNumber(+key)
    && key >= 0;
};

var wrappedGetOwnPropertyDescriptor = function getOwnPropertyDescriptor(target, key) {
  key = toPropertyKey(key);
  return isTypedArrayIndex(target, key)
    ? createPropertyDescriptor(2, target[key])
    : nativeGetOwnPropertyDescriptor(target, key);
};

var wrappedDefineProperty = function defineProperty(target, key, descriptor) {
  key = toPropertyKey(key);
  if (isTypedArrayIndex(target, key)
    && isObject(descriptor)
    && hasOwn(descriptor, 'value')
    && !hasOwn(descriptor, 'get')
    && !hasOwn(descriptor, 'set')
    // TODO: add validation descriptor w/o calling accessors
    && !descriptor.configurable
    && (!hasOwn(descriptor, 'writable') || descriptor.writable)
    && (!hasOwn(descriptor, 'enumerable') || descriptor.enumerable)
  ) {
    target[key] = descriptor.value;
    return target;
  } return nativeDefineProperty(target, key, descriptor);
};

if (DESCRIPTORS) {
  if (!NATIVE_ARRAY_BUFFER_VIEWS) {
    getOwnPropertyDescriptorModule.f = wrappedGetOwnPropertyDescriptor;
    definePropertyModule.f = wrappedDefineProperty;
    addGetter(TypedArrayPrototype, 'buffer');
    addGetter(TypedArrayPrototype, 'byteOffset');
    addGetter(TypedArrayPrototype, 'byteLength');
    addGetter(TypedArrayPrototype, 'length');
  }

  $({ target: 'Object', stat: true, forced: !NATIVE_ARRAY_BUFFER_VIEWS }, {
    getOwnPropertyDescriptor: wrappedGetOwnPropertyDescriptor,
    defineProperty: wrappedDefineProperty
  });

  module.exports = function (TYPE, wrapper, CLAMPED) {
    var BYTES = TYPE.match(/\d+/)[0] / 8;
    var CONSTRUCTOR_NAME = TYPE + (CLAMPED ? 'Clamped' : '') + 'Array';
    var GETTER = 'get' + TYPE;
    var SETTER = 'set' + TYPE;
    var NativeTypedArrayConstructor = globalThis[CONSTRUCTOR_NAME];
    var TypedArrayConstructor = NativeTypedArrayConstructor;
    var TypedArrayConstructorPrototype = TypedArrayConstructor && TypedArrayConstructor.prototype;
    var exported = {};

    var getter = function (that, index) {
      var data = getInternalState(that);
      return data.view[GETTER](index * BYTES + data.byteOffset, true);
    };

    var setter = function (that, index, value) {
      var data = getInternalState(that);
      data.view[SETTER](index * BYTES + data.byteOffset, CLAMPED ? toUint8Clamped(value) : value, true);
    };

    var addElement = function (that, index) {
      nativeDefineProperty(that, index, {
        get: function () {
          return getter(this, index);
        },
        set: function (value) {
          return setter(this, index, value);
        },
        enumerable: true
      });
    };

    if (!NATIVE_ARRAY_BUFFER_VIEWS) {
      TypedArrayConstructor = wrapper(function (that, data, offset, $length) {
        anInstance(that, TypedArrayConstructorPrototype);
        var index = 0;
        var byteOffset = 0;
        var buffer, byteLength, length;
        if (!isObject(data)) {
          length = toIndex(data);
          byteLength = length * BYTES;
          buffer = new ArrayBuffer(byteLength);
        } else if (isArrayBuffer(data)) {
          buffer = data;
          byteOffset = toOffset(offset, BYTES);
          var $len = data.byteLength;
          if ($length === undefined) {
            if ($len % BYTES) throw new RangeError(WRONG_LENGTH);
            byteLength = $len - byteOffset;
            if (byteLength < 0) throw new RangeError(WRONG_LENGTH);
          } else {
            byteLength = toLength($length) * BYTES;
            if (byteLength + byteOffset > $len) throw new RangeError(WRONG_LENGTH);
          }
          length = byteLength / BYTES;
        } else if (isTypedArray(data)) {
          return arrayFromConstructorAndList(TypedArrayConstructor, data);
        } else {
          return call(typedArrayFrom, TypedArrayConstructor, data);
        }
        setInternalState(that, {
          buffer: buffer,
          byteOffset: byteOffset,
          byteLength: byteLength,
          length: length,
          view: new DataView(buffer)
        });
        while (index < length) addElement(that, index++);
      });

      if (setPrototypeOf) setPrototypeOf(TypedArrayConstructor, TypedArray);
      TypedArrayConstructorPrototype = TypedArrayConstructor.prototype = create(TypedArrayPrototype);
    } else if (TYPED_ARRAYS_CONSTRUCTORS_REQUIRES_WRAPPERS) {
      TypedArrayConstructor = wrapper(function (dummy, data, typedArrayOffset, $length) {
        anInstance(dummy, TypedArrayConstructorPrototype);
        return inheritIfRequired(function () {
          if (!isObject(data)) return new NativeTypedArrayConstructor(toIndex(data));
          if (isArrayBuffer(data)) return $length !== undefined
            ? new NativeTypedArrayConstructor(data, toOffset(typedArrayOffset, BYTES), $length)
            : typedArrayOffset !== undefined
              ? new NativeTypedArrayConstructor(data, toOffset(typedArrayOffset, BYTES))
              : new NativeTypedArrayConstructor(data);
          if (isTypedArray(data)) return arrayFromConstructorAndList(TypedArrayConstructor, data);
          return call(typedArrayFrom, TypedArrayConstructor, data);
        }(), dummy, TypedArrayConstructor);
      });

      if (setPrototypeOf) setPrototypeOf(TypedArrayConstructor, TypedArray);
      forEach(getOwnPropertyNames(NativeTypedArrayConstructor), function (key) {
        if (!(key in TypedArrayConstructor)) {
          createNonEnumerableProperty(TypedArrayConstructor, key, NativeTypedArrayConstructor[key]);
        }
      });
      TypedArrayConstructor.prototype = TypedArrayConstructorPrototype;
    }

    if (TypedArrayConstructorPrototype.constructor !== TypedArrayConstructor) {
      createNonEnumerableProperty(TypedArrayConstructorPrototype, 'constructor', TypedArrayConstructor);
    }

    enforceInternalState(TypedArrayConstructorPrototype).TypedArrayConstructor = TypedArrayConstructor;

    if (TYPED_ARRAY_TAG) {
      createNonEnumerableProperty(TypedArrayConstructorPrototype, TYPED_ARRAY_TAG, CONSTRUCTOR_NAME);
    }

    var FORCED = TypedArrayConstructor !== NativeTypedArrayConstructor;

    exported[CONSTRUCTOR_NAME] = TypedArrayConstructor;

    $({ global: true, constructor: true, forced: FORCED, sham: !NATIVE_ARRAY_BUFFER_VIEWS }, exported);

    if (!(BYTES_PER_ELEMENT in TypedArrayConstructor)) {
      createNonEnumerableProperty(TypedArrayConstructor, BYTES_PER_ELEMENT, BYTES);
    }

    if (!(BYTES_PER_ELEMENT in TypedArrayConstructorPrototype)) {
      createNonEnumerableProperty(TypedArrayConstructorPrototype, BYTES_PER_ELEMENT, BYTES);
    }

    setSpecies(CONSTRUCTOR_NAME);
  };
} else module.exports = function () { /* empty */ };


/***/ }),

/***/ 2805:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable no-new, sonarjs/inconsistent-function-call -- required for testing */
var globalThis = __webpack_require__(4576);
var fails = __webpack_require__(9039);
var checkCorrectnessOfIteration = __webpack_require__(4428);
var NATIVE_ARRAY_BUFFER_VIEWS = (__webpack_require__(4644).NATIVE_ARRAY_BUFFER_VIEWS);

var ArrayBuffer = globalThis.ArrayBuffer;
var Int8Array = globalThis.Int8Array;

module.exports = !NATIVE_ARRAY_BUFFER_VIEWS || !fails(function () {
  Int8Array(1);
}) || !fails(function () {
  new Int8Array(-1);
}) || !checkCorrectnessOfIteration(function (iterable) {
  new Int8Array();
  new Int8Array(null);
  new Int8Array(1.5);
  new Int8Array(iterable);
}, true) || fails(function () {
  // Safari (11+) bug - a reason why even Safari 13 should load a typed array polyfill
  return new Int8Array(new ArrayBuffer(2), 1, undefined).length !== 1;
});


/***/ }),

/***/ 9948:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var arrayFromConstructorAndList = __webpack_require__(5370);
var getTypedArrayConstructor = (__webpack_require__(4644).getTypedArrayConstructor);

module.exports = function (instance, list) {
  return arrayFromConstructorAndList(getTypedArrayConstructor(instance), list);
};


/***/ }),

/***/ 3251:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var bind = __webpack_require__(6080);
var call = __webpack_require__(9565);
var aConstructor = __webpack_require__(5548);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var getIterator = __webpack_require__(81);
var getIteratorMethod = __webpack_require__(851);
var isArrayIteratorMethod = __webpack_require__(4209);
var isBigIntArray = __webpack_require__(1108);
var aTypedArrayConstructor = (__webpack_require__(4644).aTypedArrayConstructor);
var toBigInt = __webpack_require__(5854);

module.exports = function from(source /* , mapfn, thisArg */) {
  var C = aConstructor(this);
  var O = toObject(source);
  var argumentsLength = arguments.length;
  var mapfn = argumentsLength > 1 ? arguments[1] : undefined;
  var mapping = mapfn !== undefined;
  var iteratorMethod = getIteratorMethod(O);
  var i, length, result, thisIsBigIntArray, value, step, iterator, next;
  if (iteratorMethod && !isArrayIteratorMethod(iteratorMethod)) {
    iterator = getIterator(O, iteratorMethod);
    next = iterator.next;
    O = [];
    while (!(step = call(next, iterator)).done) {
      O.push(step.value);
    }
  }
  if (mapping && argumentsLength > 2) {
    mapfn = bind(mapfn, arguments[2]);
  }
  length = lengthOfArrayLike(O);
  result = new (aTypedArrayConstructor(C))(length);
  thisIsBigIntArray = isBigIntArray(result);
  for (i = 0; length > i; i++) {
    value = mapping ? mapfn(O[i], i) : O[i];
    // FF30- typed arrays doesn't properly convert objects to typed array values
    result[i] = thisIsBigIntArray ? toBigInt(value) : +value;
  }
  return result;
};


/***/ }),

/***/ 3392:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);

var id = 0;
var postfix = Math.random();
var toString = uncurryThis(1.0.toString);

module.exports = function (key) {
  return 'Symbol(' + (key === undefined ? '' : key) + ')_' + toString(++id + postfix, 36);
};


/***/ }),

/***/ 7416:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var fails = __webpack_require__(9039);
var wellKnownSymbol = __webpack_require__(8227);
var DESCRIPTORS = __webpack_require__(3724);
var IS_PURE = __webpack_require__(6395);

var ITERATOR = wellKnownSymbol('iterator');

module.exports = !fails(function () {
  // eslint-disable-next-line unicorn/relative-url-style -- required for testing
  var url = new URL('b?a=1&b=2&c=3', 'https://a');
  var params = url.searchParams;
  var params2 = new URLSearchParams('a=1&a=2&b=3');
  var result = '';
  url.pathname = 'c%20d';
  params.forEach(function (value, key) {
    params['delete']('b');
    result += key + value;
  });
  params2['delete']('a', 2);
  // `undefined` case is a Chromium 117 bug
  // https://bugs.chromium.org/p/v8/issues/detail?id=14222
  params2['delete']('b', undefined);
  return (IS_PURE && (!url.toJSON || !params2.has('a', 1) || params2.has('a', 2) || !params2.has('a', undefined) || params2.has('b')))
    || (!params.size && (IS_PURE || !DESCRIPTORS))
    || !params.sort
    || url.href !== 'https://a/c%20d?a=1&c=3'
    || params.get('c') !== '3'
    || String(new URLSearchParams('?a=1')) !== 'a=1'
    || !params[ITERATOR]
    // throws in Edge
    || new URL('https://a@b').username !== 'a'
    || new URLSearchParams(new URLSearchParams('a=b')).get('a') !== 'b'
    // not punycoded in Edge
    || new URL('https://тест').host !== 'xn--e1aybc'
    // not escaped in Chrome 62-
    || new URL('https://a#б').hash !== '#%D0%B1'
    // fails in Chrome 66-
    || result !== 'a1c3'
    // throws in Safari
    || new URL('https://x', undefined).host !== 'x';
});


/***/ }),

/***/ 7040:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable es/no-symbol -- required for testing */
var NATIVE_SYMBOL = __webpack_require__(4495);

module.exports = NATIVE_SYMBOL &&
  !Symbol.sham &&
  typeof Symbol.iterator == 'symbol';


/***/ }),

/***/ 8686:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var fails = __webpack_require__(9039);

// V8 ~ Chrome 36-
// https://bugs.chromium.org/p/v8/issues/detail?id=3334
module.exports = DESCRIPTORS && fails(function () {
  // eslint-disable-next-line es/no-object-defineproperty -- required for testing
  return Object.defineProperty(function () { /* empty */ }, 'prototype', {
    value: 42,
    writable: false
  }).prototype !== 42;
});


/***/ }),

/***/ 2812:
/***/ ((module) => {


var $TypeError = TypeError;

module.exports = function (passed, required) {
  if (passed < required) throw new $TypeError('Not enough arguments');
  return passed;
};


/***/ }),

/***/ 8622:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var isCallable = __webpack_require__(4901);

var WeakMap = globalThis.WeakMap;

module.exports = isCallable(WeakMap) && /native code/.test(String(WeakMap));


/***/ }),

/***/ 511:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var path = __webpack_require__(9167);
var hasOwn = __webpack_require__(9297);
var wrappedWellKnownSymbolModule = __webpack_require__(1951);
var defineProperty = (__webpack_require__(4913).f);

module.exports = function (NAME) {
  var Symbol = path.Symbol || (path.Symbol = {});
  if (!hasOwn(Symbol, NAME)) defineProperty(Symbol, NAME, {
    value: wrappedWellKnownSymbolModule.f(NAME)
  });
};


/***/ }),

/***/ 1951:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


var wellKnownSymbol = __webpack_require__(8227);

exports.f = wellKnownSymbol;


/***/ }),

/***/ 8227:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var shared = __webpack_require__(5745);
var hasOwn = __webpack_require__(9297);
var uid = __webpack_require__(3392);
var NATIVE_SYMBOL = __webpack_require__(4495);
var USE_SYMBOL_AS_UID = __webpack_require__(7040);

var Symbol = globalThis.Symbol;
var WellKnownSymbolsStore = shared('wks');
var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol['for'] || Symbol : Symbol && Symbol.withoutSetter || uid;

module.exports = function (name) {
  if (!hasOwn(WellKnownSymbolsStore, name)) {
    WellKnownSymbolsStore[name] = NATIVE_SYMBOL && hasOwn(Symbol, name)
      ? Symbol[name]
      : createWellKnownSymbol('Symbol.' + name);
  } return WellKnownSymbolsStore[name];
};


/***/ }),

/***/ 7452:
/***/ ((module) => {


// a string of all valid unicode whitespaces
module.exports = '\u0009\u000A\u000B\u000C\u000D\u0020\u00A0\u1680\u2000\u2001\u2002' +
  '\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028\u2029\uFEFF';


/***/ }),

/***/ 4601:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var hasOwn = __webpack_require__(9297);
var createNonEnumerableProperty = __webpack_require__(6699);
var isPrototypeOf = __webpack_require__(1625);
var setPrototypeOf = __webpack_require__(2967);
var copyConstructorProperties = __webpack_require__(7740);
var proxyAccessor = __webpack_require__(1056);
var inheritIfRequired = __webpack_require__(3167);
var normalizeStringArgument = __webpack_require__(2603);
var installErrorCause = __webpack_require__(7584);
var installErrorStack = __webpack_require__(747);
var DESCRIPTORS = __webpack_require__(3724);
var IS_PURE = __webpack_require__(6395);

module.exports = function (FULL_NAME, wrapper, FORCED, IS_AGGREGATE_ERROR) {
  var STACK_TRACE_LIMIT = 'stackTraceLimit';
  var OPTIONS_POSITION = IS_AGGREGATE_ERROR ? 2 : 1;
  var path = FULL_NAME.split('.');
  var ERROR_NAME = path[path.length - 1];
  var OriginalError = getBuiltIn.apply(null, path);

  if (!OriginalError) return;

  var OriginalErrorPrototype = OriginalError.prototype;

  // V8 9.3- bug https://bugs.chromium.org/p/v8/issues/detail?id=12006
  if (!IS_PURE && hasOwn(OriginalErrorPrototype, 'cause')) delete OriginalErrorPrototype.cause;

  if (!FORCED) return OriginalError;

  var BaseError = getBuiltIn('Error');

  var WrappedError = wrapper(function (a, b) {
    var message = normalizeStringArgument(IS_AGGREGATE_ERROR ? b : a, undefined);
    var result = IS_AGGREGATE_ERROR ? new OriginalError(a) : new OriginalError();
    if (message !== undefined) createNonEnumerableProperty(result, 'message', message);
    installErrorStack(result, WrappedError, result.stack, 2);
    if (this && isPrototypeOf(OriginalErrorPrototype, this)) inheritIfRequired(result, this, WrappedError);
    if (arguments.length > OPTIONS_POSITION) installErrorCause(result, arguments[OPTIONS_POSITION]);
    return result;
  });

  WrappedError.prototype = OriginalErrorPrototype;

  if (ERROR_NAME !== 'Error') {
    if (setPrototypeOf) setPrototypeOf(WrappedError, BaseError);
    else copyConstructorProperties(WrappedError, BaseError, { name: true });
  } else if (DESCRIPTORS && STACK_TRACE_LIMIT in OriginalError) {
    proxyAccessor(WrappedError, OriginalError, STACK_TRACE_LIMIT);
    proxyAccessor(WrappedError, OriginalError, 'prepareStackTrace');
  }

  copyConstructorProperties(WrappedError, OriginalError);

  if (!IS_PURE) try {
    // Safari 13- bug: WebAssembly errors does not have a proper `.name`
    if (OriginalErrorPrototype.name !== ERROR_NAME) {
      createNonEnumerableProperty(OriginalErrorPrototype, 'name', ERROR_NAME);
    }
    OriginalErrorPrototype.constructor = WrappedError;
  } catch (error) { /* empty */ }

  return WrappedError;
};


/***/ }),

/***/ 4743:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var arrayBufferModule = __webpack_require__(6346);
var setSpecies = __webpack_require__(7633);

var ARRAY_BUFFER = 'ArrayBuffer';
var ArrayBuffer = arrayBufferModule[ARRAY_BUFFER];
var NativeArrayBuffer = globalThis[ARRAY_BUFFER];

// `ArrayBuffer` constructor
// https://tc39.es/ecma262/#sec-arraybuffer-constructor
$({ global: true, constructor: true, forced: NativeArrayBuffer !== ArrayBuffer }, {
  ArrayBuffer: ArrayBuffer
});

setSpecies(ARRAY_BUFFER);


/***/ }),

/***/ 6573:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var defineBuiltInAccessor = __webpack_require__(2106);
var isDetached = __webpack_require__(3238);

var ArrayBufferPrototype = ArrayBuffer.prototype;

// `ArrayBuffer.prototype.detached` getter
// https://tc39.es/ecma262/#sec-get-arraybuffer.prototype.detached
if (DESCRIPTORS && !('detached' in ArrayBufferPrototype)) {
  defineBuiltInAccessor(ArrayBufferPrototype, 'detached', {
    configurable: true,
    get: function detached() {
      return isDetached(this);
    }
  });
}


/***/ }),

/***/ 9142:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var ArrayBufferViewCore = __webpack_require__(4644);

var NATIVE_ARRAY_BUFFER_VIEWS = ArrayBufferViewCore.NATIVE_ARRAY_BUFFER_VIEWS;

// `ArrayBuffer.isView` method
// https://tc39.es/ecma262/#sec-arraybuffer.isview
$({ target: 'ArrayBuffer', stat: true, forced: !NATIVE_ARRAY_BUFFER_VIEWS }, {
  isView: ArrayBufferViewCore.isView
});


/***/ }),

/***/ 1745:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(7476);
var fails = __webpack_require__(9039);
var ArrayBufferModule = __webpack_require__(6346);
var anObject = __webpack_require__(8551);
var toAbsoluteIndex = __webpack_require__(5610);
var toLength = __webpack_require__(8014);

var ArrayBuffer = ArrayBufferModule.ArrayBuffer;
var DataView = ArrayBufferModule.DataView;
var DataViewPrototype = DataView.prototype;
var nativeArrayBufferSlice = uncurryThis(ArrayBuffer.prototype.slice);
var getUint8 = uncurryThis(DataViewPrototype.getUint8);
var setUint8 = uncurryThis(DataViewPrototype.setUint8);

var INCORRECT_SLICE = fails(function () {
  return !new ArrayBuffer(2).slice(1, undefined).byteLength;
});

// `ArrayBuffer.prototype.slice` method
// https://tc39.es/ecma262/#sec-arraybuffer.prototype.slice
$({ target: 'ArrayBuffer', proto: true, unsafe: true, forced: INCORRECT_SLICE }, {
  slice: function slice(start, end) {
    if (nativeArrayBufferSlice && end === undefined) {
      return nativeArrayBufferSlice(anObject(this), start); // FF fix
    }
    var length = anObject(this).byteLength;
    var first = toAbsoluteIndex(start, length);
    var fin = toAbsoluteIndex(end === undefined ? length : end, length);
    var result = new ArrayBuffer(toLength(fin - first));
    var viewSource = new DataView(this);
    var viewTarget = new DataView(result);
    var index = 0;
    while (first < fin) {
      setUint8(viewTarget, index++, getUint8(viewSource, first++));
    } return result;
  }
});


/***/ }),

/***/ 7936:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $transfer = __webpack_require__(5636);

// `ArrayBuffer.prototype.transferToFixedLength` method
// https://tc39.es/proposal-arraybuffer-transfer/#sec-arraybuffer.prototype.transfertofixedlength
if ($transfer) $({ target: 'ArrayBuffer', proto: true }, {
  transferToFixedLength: function transferToFixedLength() {
    return $transfer(this, arguments.length ? arguments[0] : undefined, false);
  }
});


/***/ }),

/***/ 8100:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $transfer = __webpack_require__(5636);

// `ArrayBuffer.prototype.transfer` method
// https://tc39.es/proposal-arraybuffer-transfer/#sec-arraybuffer.prototype.transfer
if ($transfer) $({ target: 'ArrayBuffer', proto: true }, {
  transfer: function transfer() {
    return $transfer(this, arguments.length ? arguments[0] : undefined, true);
  }
});


/***/ }),

/***/ 8107:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var toIntegerOrInfinity = __webpack_require__(1291);
var addToUnscopables = __webpack_require__(6469);

// `Array.prototype.at` method
// https://tc39.es/ecma262/#sec-array.prototype.at
$({ target: 'Array', proto: true }, {
  at: function at(index) {
    var O = toObject(this);
    var len = lengthOfArrayLike(O);
    var relativeIndex = toIntegerOrInfinity(index);
    var k = relativeIndex >= 0 ? relativeIndex : len + relativeIndex;
    return (k < 0 || k >= len) ? undefined : O[k];
  }
});

addToUnscopables('at');


/***/ }),

/***/ 8706:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fails = __webpack_require__(9039);
var isArray = __webpack_require__(4376);
var isObject = __webpack_require__(34);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var doesNotExceedSafeInteger = __webpack_require__(6837);
var createProperty = __webpack_require__(2278);
var arraySpeciesCreate = __webpack_require__(1469);
var arrayMethodHasSpeciesSupport = __webpack_require__(597);
var wellKnownSymbol = __webpack_require__(8227);
var V8_VERSION = __webpack_require__(9519);

var IS_CONCAT_SPREADABLE = wellKnownSymbol('isConcatSpreadable');

// We can't use this feature detection in V8 since it causes
// deoptimization and serious performance degradation
// https://github.com/zloirock/core-js/issues/679
var IS_CONCAT_SPREADABLE_SUPPORT = V8_VERSION >= 51 || !fails(function () {
  var array = [];
  array[IS_CONCAT_SPREADABLE] = false;
  return array.concat()[0] !== array;
});

var isConcatSpreadable = function (O) {
  if (!isObject(O)) return false;
  var spreadable = O[IS_CONCAT_SPREADABLE];
  return spreadable !== undefined ? !!spreadable : isArray(O);
};

var FORCED = !IS_CONCAT_SPREADABLE_SUPPORT || !arrayMethodHasSpeciesSupport('concat');

// `Array.prototype.concat` method
// https://tc39.es/ecma262/#sec-array.prototype.concat
// with adding support of @@isConcatSpreadable and @@species
$({ target: 'Array', proto: true, arity: 1, forced: FORCED }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  concat: function concat(arg) {
    var O = toObject(this);
    var A = arraySpeciesCreate(O, 0);
    var n = 0;
    var i, k, length, len, E;
    for (i = -1, length = arguments.length; i < length; i++) {
      E = i === -1 ? O : arguments[i];
      if (isConcatSpreadable(E)) {
        len = lengthOfArrayLike(E);
        doesNotExceedSafeInteger(n + len);
        for (k = 0; k < len; k++, n++) if (k in E) createProperty(A, n, E[k]);
      } else {
        doesNotExceedSafeInteger(n + 1);
        createProperty(A, n++, E);
      }
    }
    A.length = n;
    return A;
  }
});


/***/ }),

/***/ 8431:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $every = (__webpack_require__(9213).every);
var arrayMethodIsStrict = __webpack_require__(4598);

var STRICT_METHOD = arrayMethodIsStrict('every');

// `Array.prototype.every` method
// https://tc39.es/ecma262/#sec-array.prototype.every
$({ target: 'Array', proto: true, forced: !STRICT_METHOD }, {
  every: function every(callbackfn /* , thisArg */) {
    return $every(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 3771:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fill = __webpack_require__(4373);
var addToUnscopables = __webpack_require__(6469);

// `Array.prototype.fill` method
// https://tc39.es/ecma262/#sec-array.prototype.fill
$({ target: 'Array', proto: true }, {
  fill: fill
});

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('fill');


/***/ }),

/***/ 2008:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $filter = (__webpack_require__(9213).filter);
var arrayMethodHasSpeciesSupport = __webpack_require__(597);

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('filter');

// `Array.prototype.filter` method
// https://tc39.es/ecma262/#sec-array.prototype.filter
// with adding support of @@species
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  filter: function filter(callbackfn /* , thisArg */) {
    return $filter(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 8980:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $findIndex = (__webpack_require__(9213).findIndex);
var addToUnscopables = __webpack_require__(6469);

var FIND_INDEX = 'findIndex';
var SKIPS_HOLES = true;

// Shouldn't skip holes
// eslint-disable-next-line es/no-array-prototype-findindex -- testing
if (FIND_INDEX in []) Array(1)[FIND_INDEX](function () { SKIPS_HOLES = false; });

// `Array.prototype.findIndex` method
// https://tc39.es/ecma262/#sec-array.prototype.findindex
$({ target: 'Array', proto: true, forced: SKIPS_HOLES }, {
  findIndex: function findIndex(callbackfn /* , that = undefined */) {
    return $findIndex(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables(FIND_INDEX);


/***/ }),

/***/ 8350:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var flattenIntoArray = __webpack_require__(259);
var aCallable = __webpack_require__(9306);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var arraySpeciesCreate = __webpack_require__(1469);

// `Array.prototype.flatMap` method
// https://tc39.es/ecma262/#sec-array.prototype.flatmap
$({ target: 'Array', proto: true }, {
  flatMap: function flatMap(callbackfn /* , thisArg */) {
    var O = toObject(this);
    var sourceLen = lengthOfArrayLike(O);
    var A;
    aCallable(callbackfn);
    A = arraySpeciesCreate(O, 0);
    A.length = flattenIntoArray(A, O, O, sourceLen, 0, 1, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
    return A;
  }
});


/***/ }),

/***/ 1629:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var forEach = __webpack_require__(235);

// `Array.prototype.forEach` method
// https://tc39.es/ecma262/#sec-array.prototype.foreach
// eslint-disable-next-line es/no-array-prototype-foreach -- safe
$({ target: 'Array', proto: true, forced: [].forEach !== forEach }, {
  forEach: forEach
});


/***/ }),

/***/ 3418:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var from = __webpack_require__(7916);
var checkCorrectnessOfIteration = __webpack_require__(4428);

var INCORRECT_ITERATION = !checkCorrectnessOfIteration(function (iterable) {
  // eslint-disable-next-line es/no-array-from -- required for testing
  Array.from(iterable);
});

// `Array.from` method
// https://tc39.es/ecma262/#sec-array.from
$({ target: 'Array', stat: true, forced: INCORRECT_ITERATION }, {
  from: from
});


/***/ }),

/***/ 4423:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $includes = (__webpack_require__(9617).includes);
var fails = __webpack_require__(9039);
var addToUnscopables = __webpack_require__(6469);

// FF99+ bug
var BROKEN_ON_SPARSE = fails(function () {
  // eslint-disable-next-line es/no-array-prototype-includes -- detection
  return !Array(1).includes();
});

// `Array.prototype.includes` method
// https://tc39.es/ecma262/#sec-array.prototype.includes
$({ target: 'Array', proto: true, forced: BROKEN_ON_SPARSE }, {
  includes: function includes(el /* , fromIndex = 0 */) {
    return $includes(this, el, arguments.length > 1 ? arguments[1] : undefined);
  }
});

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('includes');


/***/ }),

/***/ 5276:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable es/no-array-prototype-indexof -- required for testing */
var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(7476);
var $indexOf = (__webpack_require__(9617).indexOf);
var arrayMethodIsStrict = __webpack_require__(4598);

var nativeIndexOf = uncurryThis([].indexOf);

var NEGATIVE_ZERO = !!nativeIndexOf && 1 / nativeIndexOf([1], 1, -0) < 0;
var FORCED = NEGATIVE_ZERO || !arrayMethodIsStrict('indexOf');

// `Array.prototype.indexOf` method
// https://tc39.es/ecma262/#sec-array.prototype.indexof
$({ target: 'Array', proto: true, forced: FORCED }, {
  indexOf: function indexOf(searchElement /* , fromIndex = 0 */) {
    var fromIndex = arguments.length > 1 ? arguments[1] : undefined;
    return NEGATIVE_ZERO
      // convert -0 to +0
      ? nativeIndexOf(this, searchElement, fromIndex) || 0
      : $indexOf(this, searchElement, fromIndex);
  }
});


/***/ }),

/***/ 3792:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


var toIndexedObject = __webpack_require__(5397);
var addToUnscopables = __webpack_require__(6469);
var Iterators = __webpack_require__(6269);
var InternalStateModule = __webpack_require__(1181);
var defineProperty = (__webpack_require__(4913).f);
var defineIterator = __webpack_require__(1088);
var createIterResultObject = __webpack_require__(2529);
var IS_PURE = __webpack_require__(6395);
var DESCRIPTORS = __webpack_require__(3724);

var ARRAY_ITERATOR = 'Array Iterator';
var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(ARRAY_ITERATOR);

// `Array.prototype.entries` method
// https://tc39.es/ecma262/#sec-array.prototype.entries
// `Array.prototype.keys` method
// https://tc39.es/ecma262/#sec-array.prototype.keys
// `Array.prototype.values` method
// https://tc39.es/ecma262/#sec-array.prototype.values
// `Array.prototype[@@iterator]` method
// https://tc39.es/ecma262/#sec-array.prototype-@@iterator
// `CreateArrayIterator` internal method
// https://tc39.es/ecma262/#sec-createarrayiterator
module.exports = defineIterator(Array, 'Array', function (iterated, kind) {
  setInternalState(this, {
    type: ARRAY_ITERATOR,
    target: toIndexedObject(iterated), // target
    index: 0,                          // next index
    kind: kind                         // kind
  });
// `%ArrayIteratorPrototype%.next` method
// https://tc39.es/ecma262/#sec-%arrayiteratorprototype%.next
}, function () {
  var state = getInternalState(this);
  var target = state.target;
  var index = state.index++;
  if (!target || index >= target.length) {
    state.target = null;
    return createIterResultObject(undefined, true);
  }
  switch (state.kind) {
    case 'keys': return createIterResultObject(index, false);
    case 'values': return createIterResultObject(target[index], false);
  } return createIterResultObject([index, target[index]], false);
}, 'values');

// argumentsList[@@iterator] is %ArrayProto_values%
// https://tc39.es/ecma262/#sec-createunmappedargumentsobject
// https://tc39.es/ecma262/#sec-createmappedargumentsobject
var values = Iterators.Arguments = Iterators.Array;

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('keys');
addToUnscopables('values');
addToUnscopables('entries');

// V8 ~ Chrome 45- bug
if (!IS_PURE && DESCRIPTORS && values.name !== 'values') try {
  defineProperty(values, 'name', { value: 'values' });
} catch (error) { /* empty */ }


/***/ }),

/***/ 8598:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var IndexedObject = __webpack_require__(7055);
var toIndexedObject = __webpack_require__(5397);
var arrayMethodIsStrict = __webpack_require__(4598);

var nativeJoin = uncurryThis([].join);

var ES3_STRINGS = IndexedObject !== Object;
var FORCED = ES3_STRINGS || !arrayMethodIsStrict('join', ',');

// `Array.prototype.join` method
// https://tc39.es/ecma262/#sec-array.prototype.join
$({ target: 'Array', proto: true, forced: FORCED }, {
  join: function join(separator) {
    return nativeJoin(toIndexedObject(this), separator === undefined ? ',' : separator);
  }
});


/***/ }),

/***/ 8921:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var lastIndexOf = __webpack_require__(8379);

// `Array.prototype.lastIndexOf` method
// https://tc39.es/ecma262/#sec-array.prototype.lastindexof
// eslint-disable-next-line es/no-array-prototype-lastindexof -- required for testing
$({ target: 'Array', proto: true, forced: lastIndexOf !== [].lastIndexOf }, {
  lastIndexOf: lastIndexOf
});


/***/ }),

/***/ 2062:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $map = (__webpack_require__(9213).map);
var arrayMethodHasSpeciesSupport = __webpack_require__(597);

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('map');

// `Array.prototype.map` method
// https://tc39.es/ecma262/#sec-array.prototype.map
// with adding support of @@species
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  map: function map(callbackfn /* , thisArg */) {
    return $map(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 4114:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var setArrayLength = __webpack_require__(4527);
var doesNotExceedSafeInteger = __webpack_require__(6837);
var fails = __webpack_require__(9039);

var INCORRECT_TO_LENGTH = fails(function () {
  return [].push.call({ length: 0x100000000 }, 1) !== 4294967297;
});

// V8 <= 121 and Safari <= 15.4; FF < 23 throws InternalError
// https://bugs.chromium.org/p/v8/issues/detail?id=12681
var properErrorOnNonWritableLength = function () {
  try {
    // eslint-disable-next-line es/no-object-defineproperty -- safe
    Object.defineProperty([], 'length', { writable: false }).push();
  } catch (error) {
    return error instanceof TypeError;
  }
};

var FORCED = INCORRECT_TO_LENGTH || !properErrorOnNonWritableLength();

// `Array.prototype.push` method
// https://tc39.es/ecma262/#sec-array.prototype.push
$({ target: 'Array', proto: true, arity: 1, forced: FORCED }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  push: function push(item) {
    var O = toObject(this);
    var len = lengthOfArrayLike(O);
    var argCount = arguments.length;
    doesNotExceedSafeInteger(len + argCount);
    for (var i = 0; i < argCount; i++) {
      O[len] = arguments[i];
      len++;
    }
    setArrayLength(O, len);
    return len;
  }
});


/***/ }),

/***/ 2712:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $reduce = (__webpack_require__(926).left);
var arrayMethodIsStrict = __webpack_require__(4598);
var CHROME_VERSION = __webpack_require__(9519);
var IS_NODE = __webpack_require__(8574);

// Chrome 80-82 has a critical bug
// https://bugs.chromium.org/p/chromium/issues/detail?id=1049982
var CHROME_BUG = !IS_NODE && CHROME_VERSION > 79 && CHROME_VERSION < 83;
var FORCED = CHROME_BUG || !arrayMethodIsStrict('reduce');

// `Array.prototype.reduce` method
// https://tc39.es/ecma262/#sec-array.prototype.reduce
$({ target: 'Array', proto: true, forced: FORCED }, {
  reduce: function reduce(callbackfn /* , initialValue */) {
    var length = arguments.length;
    return $reduce(this, callbackfn, length, length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 4490:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var isArray = __webpack_require__(4376);

var nativeReverse = uncurryThis([].reverse);
var test = [1, 2];

// `Array.prototype.reverse` method
// https://tc39.es/ecma262/#sec-array.prototype.reverse
// fix for Safari 12.0 bug
// https://bugs.webkit.org/show_bug.cgi?id=188794
$({ target: 'Array', proto: true, forced: String(test) === String(test.reverse()) }, {
  reverse: function reverse() {
    // eslint-disable-next-line no-self-assign -- dirty hack
    if (isArray(this)) this.length = this.length;
    return nativeReverse(this);
  }
});


/***/ }),

/***/ 4782:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var isArray = __webpack_require__(4376);
var isConstructor = __webpack_require__(3517);
var isObject = __webpack_require__(34);
var toAbsoluteIndex = __webpack_require__(5610);
var lengthOfArrayLike = __webpack_require__(6198);
var toIndexedObject = __webpack_require__(5397);
var createProperty = __webpack_require__(2278);
var wellKnownSymbol = __webpack_require__(8227);
var arrayMethodHasSpeciesSupport = __webpack_require__(597);
var nativeSlice = __webpack_require__(7680);

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('slice');

var SPECIES = wellKnownSymbol('species');
var $Array = Array;
var max = Math.max;

// `Array.prototype.slice` method
// https://tc39.es/ecma262/#sec-array.prototype.slice
// fallback for not array-like ES3 strings and DOM objects
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  slice: function slice(start, end) {
    var O = toIndexedObject(this);
    var length = lengthOfArrayLike(O);
    var k = toAbsoluteIndex(start, length);
    var fin = toAbsoluteIndex(end === undefined ? length : end, length);
    // inline `ArraySpeciesCreate` for usage native `Array#slice` where it's possible
    var Constructor, result, n;
    if (isArray(O)) {
      Constructor = O.constructor;
      // cross-realm fallback
      if (isConstructor(Constructor) && (Constructor === $Array || isArray(Constructor.prototype))) {
        Constructor = undefined;
      } else if (isObject(Constructor)) {
        Constructor = Constructor[SPECIES];
        if (Constructor === null) Constructor = undefined;
      }
      if (Constructor === $Array || Constructor === undefined) {
        return nativeSlice(O, k, fin);
      }
    }
    result = new (Constructor === undefined ? $Array : Constructor)(max(fin - k, 0));
    for (n = 0; k < fin; k++, n++) if (k in O) createProperty(result, n, O[k]);
    result.length = n;
    return result;
  }
});


/***/ }),

/***/ 5086:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $some = (__webpack_require__(9213).some);
var arrayMethodIsStrict = __webpack_require__(4598);

var STRICT_METHOD = arrayMethodIsStrict('some');

// `Array.prototype.some` method
// https://tc39.es/ecma262/#sec-array.prototype.some
$({ target: 'Array', proto: true, forced: !STRICT_METHOD }, {
  some: function some(callbackfn /* , thisArg */) {
    return $some(this, callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 6910:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var aCallable = __webpack_require__(9306);
var toObject = __webpack_require__(8981);
var lengthOfArrayLike = __webpack_require__(6198);
var deletePropertyOrThrow = __webpack_require__(4606);
var toString = __webpack_require__(655);
var fails = __webpack_require__(9039);
var internalSort = __webpack_require__(4488);
var arrayMethodIsStrict = __webpack_require__(4598);
var FF = __webpack_require__(3709);
var IE_OR_EDGE = __webpack_require__(3763);
var V8 = __webpack_require__(9519);
var WEBKIT = __webpack_require__(3607);

var test = [];
var nativeSort = uncurryThis(test.sort);
var push = uncurryThis(test.push);

// IE8-
var FAILS_ON_UNDEFINED = fails(function () {
  test.sort(undefined);
});
// V8 bug
var FAILS_ON_NULL = fails(function () {
  test.sort(null);
});
// Old WebKit
var STRICT_METHOD = arrayMethodIsStrict('sort');

var STABLE_SORT = !fails(function () {
  // feature detection can be too slow, so check engines versions
  if (V8) return V8 < 70;
  if (FF && FF > 3) return;
  if (IE_OR_EDGE) return true;
  if (WEBKIT) return WEBKIT < 603;

  var result = '';
  var code, chr, value, index;

  // generate an array with more 512 elements (Chakra and old V8 fails only in this case)
  for (code = 65; code < 76; code++) {
    chr = String.fromCharCode(code);

    switch (code) {
      case 66: case 69: case 70: case 72: value = 3; break;
      case 68: case 71: value = 4; break;
      default: value = 2;
    }

    for (index = 0; index < 47; index++) {
      test.push({ k: chr + index, v: value });
    }
  }

  test.sort(function (a, b) { return b.v - a.v; });

  for (index = 0; index < test.length; index++) {
    chr = test[index].k.charAt(0);
    if (result.charAt(result.length - 1) !== chr) result += chr;
  }

  return result !== 'DGBEFHACIJK';
});

var FORCED = FAILS_ON_UNDEFINED || !FAILS_ON_NULL || !STRICT_METHOD || !STABLE_SORT;

var getSortCompare = function (comparefn) {
  return function (x, y) {
    if (y === undefined) return -1;
    if (x === undefined) return 1;
    if (comparefn !== undefined) return +comparefn(x, y) || 0;
    return toString(x) > toString(y) ? 1 : -1;
  };
};

// `Array.prototype.sort` method
// https://tc39.es/ecma262/#sec-array.prototype.sort
$({ target: 'Array', proto: true, forced: FORCED }, {
  sort: function sort(comparefn) {
    if (comparefn !== undefined) aCallable(comparefn);

    var array = toObject(this);

    if (STABLE_SORT) return comparefn === undefined ? nativeSort(array) : nativeSort(array, comparefn);

    var items = [];
    var arrayLength = lengthOfArrayLike(array);
    var itemsLength, index;

    for (index = 0; index < arrayLength; index++) {
      if (index in array) push(items, array[index]);
    }

    internalSort(items, getSortCompare(comparefn));

    itemsLength = lengthOfArrayLike(items);
    index = 0;

    while (index < itemsLength) array[index] = items[index++];
    while (index < arrayLength) deletePropertyOrThrow(array, index++);

    return array;
  }
});


/***/ }),

/***/ 4554:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var toObject = __webpack_require__(8981);
var toAbsoluteIndex = __webpack_require__(5610);
var toIntegerOrInfinity = __webpack_require__(1291);
var lengthOfArrayLike = __webpack_require__(6198);
var setArrayLength = __webpack_require__(4527);
var doesNotExceedSafeInteger = __webpack_require__(6837);
var arraySpeciesCreate = __webpack_require__(1469);
var createProperty = __webpack_require__(2278);
var deletePropertyOrThrow = __webpack_require__(4606);
var arrayMethodHasSpeciesSupport = __webpack_require__(597);

var HAS_SPECIES_SUPPORT = arrayMethodHasSpeciesSupport('splice');

var max = Math.max;
var min = Math.min;

// `Array.prototype.splice` method
// https://tc39.es/ecma262/#sec-array.prototype.splice
// with adding support of @@species
$({ target: 'Array', proto: true, forced: !HAS_SPECIES_SUPPORT }, {
  splice: function splice(start, deleteCount /* , ...items */) {
    var O = toObject(this);
    var len = lengthOfArrayLike(O);
    var actualStart = toAbsoluteIndex(start, len);
    var argumentsLength = arguments.length;
    var insertCount, actualDeleteCount, A, k, from, to;
    if (argumentsLength === 0) {
      insertCount = actualDeleteCount = 0;
    } else if (argumentsLength === 1) {
      insertCount = 0;
      actualDeleteCount = len - actualStart;
    } else {
      insertCount = argumentsLength - 2;
      actualDeleteCount = min(max(toIntegerOrInfinity(deleteCount), 0), len - actualStart);
    }
    doesNotExceedSafeInteger(len + insertCount - actualDeleteCount);
    A = arraySpeciesCreate(O, actualDeleteCount);
    for (k = 0; k < actualDeleteCount; k++) {
      from = actualStart + k;
      if (from in O) createProperty(A, k, O[from]);
    }
    A.length = actualDeleteCount;
    if (insertCount < actualDeleteCount) {
      for (k = actualStart; k < len - actualDeleteCount; k++) {
        from = k + actualDeleteCount;
        to = k + insertCount;
        if (from in O) O[to] = O[from];
        else deletePropertyOrThrow(O, to);
      }
      for (k = len; k > len - actualDeleteCount + insertCount; k--) deletePropertyOrThrow(O, k - 1);
    } else if (insertCount > actualDeleteCount) {
      for (k = len - actualDeleteCount; k > actualStart; k--) {
        from = k + actualDeleteCount - 1;
        to = k + insertCount - 1;
        if (from in O) O[to] = O[from];
        else deletePropertyOrThrow(O, to);
      }
    }
    for (k = 0; k < insertCount; k++) {
      O[k + actualStart] = arguments[k + 2];
    }
    setArrayLength(O, len - actualDeleteCount + insertCount);
    return A;
  }
});


/***/ }),

/***/ 237:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// this method was added to unscopables after implementation
// in popular engines, so it's moved to a separate module
var addToUnscopables = __webpack_require__(6469);

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('flatMap');


/***/ }),

/***/ 4359:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var ArrayBufferModule = __webpack_require__(6346);
var NATIVE_ARRAY_BUFFER = __webpack_require__(7811);

// `DataView` constructor
// https://tc39.es/ecma262/#sec-dataview-constructor
$({ global: true, constructor: true, forced: !NATIVE_ARRAY_BUFFER }, {
  DataView: ArrayBufferModule.DataView
});


/***/ }),

/***/ 8309:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(4359);


/***/ }),

/***/ 739:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fails = __webpack_require__(9039);
var toObject = __webpack_require__(8981);
var toPrimitive = __webpack_require__(2777);

var FORCED = fails(function () {
  return new Date(NaN).toJSON() !== null
    || Date.prototype.toJSON.call({ toISOString: function () { return 1; } }) !== 1;
});

// `Date.prototype.toJSON` method
// https://tc39.es/ecma262/#sec-date.prototype.tojson
$({ target: 'Date', proto: true, arity: 1, forced: FORCED }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  toJSON: function toJSON(key) {
    var O = toObject(this);
    var pv = toPrimitive(O, 'number');
    return typeof pv == 'number' && !isFinite(pv) ? null : O.toISOString();
  }
});


/***/ }),

/***/ 9572:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var hasOwn = __webpack_require__(9297);
var defineBuiltIn = __webpack_require__(6840);
var dateToPrimitive = __webpack_require__(3640);
var wellKnownSymbol = __webpack_require__(8227);

var TO_PRIMITIVE = wellKnownSymbol('toPrimitive');
var DatePrototype = Date.prototype;

// `Date.prototype[@@toPrimitive]` method
// https://tc39.es/ecma262/#sec-date.prototype-@@toprimitive
if (!hasOwn(DatePrototype, TO_PRIMITIVE)) {
  defineBuiltIn(DatePrototype, TO_PRIMITIVE, dateToPrimitive);
}


/***/ }),

/***/ 6280:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


/* eslint-disable no-unused-vars -- required for functions `.length` */
var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var apply = __webpack_require__(8745);
var wrapErrorConstructorWithCause = __webpack_require__(4601);

var WEB_ASSEMBLY = 'WebAssembly';
var WebAssembly = globalThis[WEB_ASSEMBLY];

// eslint-disable-next-line es/no-error-cause -- feature detection
var FORCED = new Error('e', { cause: 7 }).cause !== 7;

var exportGlobalErrorCauseWrapper = function (ERROR_NAME, wrapper) {
  var O = {};
  O[ERROR_NAME] = wrapErrorConstructorWithCause(ERROR_NAME, wrapper, FORCED);
  $({ global: true, constructor: true, arity: 1, forced: FORCED }, O);
};

var exportWebAssemblyErrorCauseWrapper = function (ERROR_NAME, wrapper) {
  if (WebAssembly && WebAssembly[ERROR_NAME]) {
    var O = {};
    O[ERROR_NAME] = wrapErrorConstructorWithCause(WEB_ASSEMBLY + '.' + ERROR_NAME, wrapper, FORCED);
    $({ target: WEB_ASSEMBLY, stat: true, constructor: true, arity: 1, forced: FORCED }, O);
  }
};

// https://tc39.es/ecma262/#sec-nativeerror
exportGlobalErrorCauseWrapper('Error', function (init) {
  return function Error(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('EvalError', function (init) {
  return function EvalError(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('RangeError', function (init) {
  return function RangeError(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('ReferenceError', function (init) {
  return function ReferenceError(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('SyntaxError', function (init) {
  return function SyntaxError(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('TypeError', function (init) {
  return function TypeError(message) { return apply(init, this, arguments); };
});
exportGlobalErrorCauseWrapper('URIError', function (init) {
  return function URIError(message) { return apply(init, this, arguments); };
});
exportWebAssemblyErrorCauseWrapper('CompileError', function (init) {
  return function CompileError(message) { return apply(init, this, arguments); };
});
exportWebAssemblyErrorCauseWrapper('LinkError', function (init) {
  return function LinkError(message) { return apply(init, this, arguments); };
});
exportWebAssemblyErrorCauseWrapper('RuntimeError', function (init) {
  return function RuntimeError(message) { return apply(init, this, arguments); };
});


/***/ }),

/***/ 6918:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineBuiltIn = __webpack_require__(6840);
var errorToString = __webpack_require__(7536);

var ErrorPrototype = Error.prototype;

// `Error.prototype.toString` method fix
// https://tc39.es/ecma262/#sec-error.prototype.tostring
if (ErrorPrototype.toString !== errorToString) {
  defineBuiltIn(ErrorPrototype, 'toString', errorToString);
}


/***/ }),

/***/ 5081:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);

// `globalThis` object
// https://tc39.es/ecma262/#sec-globalthis
$({ global: true, forced: globalThis.globalThis !== globalThis }, {
  globalThis: globalThis
});


/***/ }),

/***/ 8111:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var anInstance = __webpack_require__(679);
var anObject = __webpack_require__(8551);
var isCallable = __webpack_require__(4901);
var getPrototypeOf = __webpack_require__(2787);
var defineBuiltInAccessor = __webpack_require__(2106);
var createProperty = __webpack_require__(2278);
var fails = __webpack_require__(9039);
var hasOwn = __webpack_require__(9297);
var wellKnownSymbol = __webpack_require__(8227);
var IteratorPrototype = (__webpack_require__(7657).IteratorPrototype);
var DESCRIPTORS = __webpack_require__(3724);
var IS_PURE = __webpack_require__(6395);

var CONSTRUCTOR = 'constructor';
var ITERATOR = 'Iterator';
var TO_STRING_TAG = wellKnownSymbol('toStringTag');

var $TypeError = TypeError;
var NativeIterator = globalThis[ITERATOR];

// FF56- have non-standard global helper `Iterator`
var FORCED = IS_PURE
  || !isCallable(NativeIterator)
  || NativeIterator.prototype !== IteratorPrototype
  // FF44- non-standard `Iterator` passes previous tests
  || !fails(function () { NativeIterator({}); });

var IteratorConstructor = function Iterator() {
  anInstance(this, IteratorPrototype);
  if (getPrototypeOf(this) === IteratorPrototype) throw new $TypeError('Abstract class Iterator not directly constructable');
};

var defineIteratorPrototypeAccessor = function (key, value) {
  if (DESCRIPTORS) {
    defineBuiltInAccessor(IteratorPrototype, key, {
      configurable: true,
      get: function () {
        return value;
      },
      set: function (replacement) {
        anObject(this);
        if (this === IteratorPrototype) throw new $TypeError("You can't redefine this property");
        if (hasOwn(this, key)) this[key] = replacement;
        else createProperty(this, key, replacement);
      }
    });
  } else IteratorPrototype[key] = value;
};

if (!hasOwn(IteratorPrototype, TO_STRING_TAG)) defineIteratorPrototypeAccessor(TO_STRING_TAG, ITERATOR);

if (FORCED || !hasOwn(IteratorPrototype, CONSTRUCTOR) || IteratorPrototype[CONSTRUCTOR] === Object) {
  defineIteratorPrototypeAccessor(CONSTRUCTOR, IteratorConstructor);
}

IteratorConstructor.prototype = IteratorPrototype;

// `Iterator` constructor
// https://tc39.es/ecma262/#sec-iterator
$({ global: true, constructor: true, forced: FORCED }, {
  Iterator: IteratorConstructor
});


/***/ }),

/***/ 9314:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);
var notANaN = __webpack_require__(4149);
var toPositiveInteger = __webpack_require__(9590);
var createIteratorProxy = __webpack_require__(9462);
var IS_PURE = __webpack_require__(6395);

var IteratorProxy = createIteratorProxy(function () {
  var iterator = this.iterator;
  var next = this.next;
  var result, done;
  while (this.remaining) {
    this.remaining--;
    result = anObject(call(next, iterator));
    done = this.done = !!result.done;
    if (done) return;
  }
  result = anObject(call(next, iterator));
  done = this.done = !!result.done;
  if (!done) return result.value;
});

// `Iterator.prototype.drop` method
// https://tc39.es/ecma262/#sec-iterator.prototype.drop
$({ target: 'Iterator', proto: true, real: true, forced: IS_PURE }, {
  drop: function drop(limit) {
    anObject(this);
    var remaining = toPositiveInteger(notANaN(+limit));
    return new IteratorProxy(getIteratorDirect(this), {
      remaining: remaining
    });
  }
});


/***/ }),

/***/ 1148:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var iterate = __webpack_require__(2652);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);

// `Iterator.prototype.every` method
// https://tc39.es/ecma262/#sec-iterator.prototype.every
$({ target: 'Iterator', proto: true, real: true }, {
  every: function every(predicate) {
    anObject(this);
    aCallable(predicate);
    var record = getIteratorDirect(this);
    var counter = 0;
    return !iterate(record, function (value, stop) {
      if (!predicate(value, counter++)) return stop();
    }, { IS_RECORD: true, INTERRUPTED: true }).stopped;
  }
});


/***/ }),

/***/ 2489:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);
var createIteratorProxy = __webpack_require__(9462);
var callWithSafeIterationClosing = __webpack_require__(6319);
var IS_PURE = __webpack_require__(6395);

var IteratorProxy = createIteratorProxy(function () {
  var iterator = this.iterator;
  var predicate = this.predicate;
  var next = this.next;
  var result, done, value;
  while (true) {
    result = anObject(call(next, iterator));
    done = this.done = !!result.done;
    if (done) return;
    value = result.value;
    if (callWithSafeIterationClosing(iterator, predicate, [value, this.counter++], true)) return value;
  }
});

// `Iterator.prototype.filter` method
// https://tc39.es/ecma262/#sec-iterator.prototype.filter
$({ target: 'Iterator', proto: true, real: true, forced: IS_PURE }, {
  filter: function filter(predicate) {
    anObject(this);
    aCallable(predicate);
    return new IteratorProxy(getIteratorDirect(this), {
      predicate: predicate
    });
  }
});


/***/ }),

/***/ 531:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);
var getIteratorFlattenable = __webpack_require__(8646);
var createIteratorProxy = __webpack_require__(9462);
var iteratorClose = __webpack_require__(9539);
var IS_PURE = __webpack_require__(6395);

var IteratorProxy = createIteratorProxy(function () {
  var iterator = this.iterator;
  var mapper = this.mapper;
  var result, inner;

  while (true) {
    if (inner = this.inner) try {
      result = anObject(call(inner.next, inner.iterator));
      if (!result.done) return result.value;
      this.inner = null;
    } catch (error) { iteratorClose(iterator, 'throw', error); }

    result = anObject(call(this.next, iterator));

    if (this.done = !!result.done) return;

    try {
      this.inner = getIteratorFlattenable(mapper(result.value, this.counter++), false);
    } catch (error) { iteratorClose(iterator, 'throw', error); }
  }
});

// `Iterator.prototype.flatMap` method
// https://tc39.es/ecma262/#sec-iterator.prototype.flatmap
$({ target: 'Iterator', proto: true, real: true, forced: IS_PURE }, {
  flatMap: function flatMap(mapper) {
    anObject(this);
    aCallable(mapper);
    return new IteratorProxy(getIteratorDirect(this), {
      mapper: mapper,
      inner: null
    });
  }
});


/***/ }),

/***/ 7588:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var iterate = __webpack_require__(2652);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);

// `Iterator.prototype.forEach` method
// https://tc39.es/ecma262/#sec-iterator.prototype.foreach
$({ target: 'Iterator', proto: true, real: true }, {
  forEach: function forEach(fn) {
    anObject(this);
    aCallable(fn);
    var record = getIteratorDirect(this);
    var counter = 0;
    iterate(record, function (value) {
      fn(value, counter++);
    }, { IS_RECORD: true });
  }
});


/***/ }),

/***/ 1701:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var map = __webpack_require__(713);
var IS_PURE = __webpack_require__(6395);

// `Iterator.prototype.map` method
// https://tc39.es/ecma262/#sec-iterator.prototype.map
$({ target: 'Iterator', proto: true, real: true, forced: IS_PURE }, {
  map: map
});


/***/ }),

/***/ 3579:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var iterate = __webpack_require__(2652);
var aCallable = __webpack_require__(9306);
var anObject = __webpack_require__(8551);
var getIteratorDirect = __webpack_require__(1767);

// `Iterator.prototype.some` method
// https://tc39.es/ecma262/#sec-iterator.prototype.some
$({ target: 'Iterator', proto: true, real: true }, {
  some: function some(predicate) {
    anObject(this);
    aCallable(predicate);
    var record = getIteratorDirect(this);
    var counter = 0;
    return iterate(record, function (value, stop) {
      if (predicate(value, counter++)) return stop();
    }, { IS_RECORD: true, INTERRUPTED: true }).stopped;
  }
});


/***/ }),

/***/ 3110:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var getBuiltIn = __webpack_require__(7751);
var apply = __webpack_require__(8745);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var fails = __webpack_require__(9039);
var isCallable = __webpack_require__(4901);
var isSymbol = __webpack_require__(757);
var arraySlice = __webpack_require__(7680);
var getReplacerFunction = __webpack_require__(6933);
var NATIVE_SYMBOL = __webpack_require__(4495);

var $String = String;
var $stringify = getBuiltIn('JSON', 'stringify');
var exec = uncurryThis(/./.exec);
var charAt = uncurryThis(''.charAt);
var charCodeAt = uncurryThis(''.charCodeAt);
var replace = uncurryThis(''.replace);
var numberToString = uncurryThis(1.0.toString);

var tester = /[\uD800-\uDFFF]/g;
var low = /^[\uD800-\uDBFF]$/;
var hi = /^[\uDC00-\uDFFF]$/;

var WRONG_SYMBOLS_CONVERSION = !NATIVE_SYMBOL || fails(function () {
  var symbol = getBuiltIn('Symbol')('stringify detection');
  // MS Edge converts symbol values to JSON as {}
  return $stringify([symbol]) !== '[null]'
    // WebKit converts symbol values to JSON as null
    || $stringify({ a: symbol }) !== '{}'
    // V8 throws on boxed symbols
    || $stringify(Object(symbol)) !== '{}';
});

// https://github.com/tc39/proposal-well-formed-stringify
var ILL_FORMED_UNICODE = fails(function () {
  return $stringify('\uDF06\uD834') !== '"\\udf06\\ud834"'
    || $stringify('\uDEAD') !== '"\\udead"';
});

var stringifyWithSymbolsFix = function (it, replacer) {
  var args = arraySlice(arguments);
  var $replacer = getReplacerFunction(replacer);
  if (!isCallable($replacer) && (it === undefined || isSymbol(it))) return; // IE8 returns string on undefined
  args[1] = function (key, value) {
    // some old implementations (like WebKit) could pass numbers as keys
    if (isCallable($replacer)) value = call($replacer, this, $String(key), value);
    if (!isSymbol(value)) return value;
  };
  return apply($stringify, null, args);
};

var fixIllFormed = function (match, offset, string) {
  var prev = charAt(string, offset - 1);
  var next = charAt(string, offset + 1);
  if ((exec(low, match) && !exec(hi, next)) || (exec(hi, match) && !exec(low, prev))) {
    return '\\u' + numberToString(charCodeAt(match, 0), 16);
  } return match;
};

if ($stringify) {
  // `JSON.stringify` method
  // https://tc39.es/ecma262/#sec-json.stringify
  $({ target: 'JSON', stat: true, arity: 3, forced: WRONG_SYMBOLS_CONVERSION || ILL_FORMED_UNICODE }, {
    // eslint-disable-next-line no-unused-vars -- required for `.length`
    stringify: function stringify(it, replacer, space) {
      var args = arraySlice(arguments);
      var result = apply(WRONG_SYMBOLS_CONVERSION ? stringifyWithSymbolsFix : $stringify, null, args);
      return ILL_FORMED_UNICODE && typeof result == 'string' ? replace(result, tester, fixIllFormed) : result;
    }
  });
}


/***/ }),

/***/ 4731:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var setToStringTag = __webpack_require__(687);

// JSON[@@toStringTag] property
// https://tc39.es/ecma262/#sec-json-@@tostringtag
setToStringTag(globalThis.JSON, 'JSON', true);


/***/ }),

/***/ 8523:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var collection = __webpack_require__(6468);
var collectionStrong = __webpack_require__(6938);

// `Map` constructor
// https://tc39.es/ecma262/#sec-map-objects
collection('Map', function (init) {
  return function Map() { return init(this, arguments.length ? arguments[0] : undefined); };
}, collectionStrong);


/***/ }),

/***/ 6033:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(8523);


/***/ }),

/***/ 605:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fround = __webpack_require__(5617);

// `Math.fround` method
// https://tc39.es/ecma262/#sec-math.fround
$({ target: 'Math', stat: true }, { fround: fround });


/***/ }),

/***/ 9469:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);

// eslint-disable-next-line es/no-math-hypot -- required for testing
var $hypot = Math.hypot;
var abs = Math.abs;
var sqrt = Math.sqrt;

// Chrome 77 bug
// https://bugs.chromium.org/p/v8/issues/detail?id=9546
var FORCED = !!$hypot && $hypot(Infinity, NaN) !== Infinity;

// `Math.hypot` method
// https://tc39.es/ecma262/#sec-math.hypot
$({ target: 'Math', stat: true, arity: 2, forced: FORCED }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  hypot: function hypot(value1, value2) {
    var sum = 0;
    var i = 0;
    var aLen = arguments.length;
    var larg = 0;
    var arg, div;
    while (i < aLen) {
      arg = abs(arguments[i++]);
      if (larg < arg) {
        div = larg / arg;
        sum = sum * div * div + 1;
        larg = arg;
      } else if (arg > 0) {
        div = arg / larg;
        sum += div * div;
      } else sum += arg;
    }
    return larg === Infinity ? Infinity : larg * sqrt(sum);
  }
});


/***/ }),

/***/ 5914:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var sign = __webpack_require__(7782);

// `Math.sign` method
// https://tc39.es/ecma262/#sec-math.sign
$({ target: 'Math', stat: true }, {
  sign: sign
});


/***/ }),

/***/ 479:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var setToStringTag = __webpack_require__(687);

// Math[@@toStringTag] property
// https://tc39.es/ecma262/#sec-math-@@tostringtag
setToStringTag(Math, 'Math', true);


/***/ }),

/***/ 2892:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var IS_PURE = __webpack_require__(6395);
var DESCRIPTORS = __webpack_require__(3724);
var globalThis = __webpack_require__(4576);
var path = __webpack_require__(9167);
var uncurryThis = __webpack_require__(9504);
var isForced = __webpack_require__(2796);
var hasOwn = __webpack_require__(9297);
var inheritIfRequired = __webpack_require__(3167);
var isPrototypeOf = __webpack_require__(1625);
var isSymbol = __webpack_require__(757);
var toPrimitive = __webpack_require__(2777);
var fails = __webpack_require__(9039);
var getOwnPropertyNames = (__webpack_require__(8480).f);
var getOwnPropertyDescriptor = (__webpack_require__(7347).f);
var defineProperty = (__webpack_require__(4913).f);
var thisNumberValue = __webpack_require__(1240);
var trim = (__webpack_require__(3802).trim);

var NUMBER = 'Number';
var NativeNumber = globalThis[NUMBER];
var PureNumberNamespace = path[NUMBER];
var NumberPrototype = NativeNumber.prototype;
var TypeError = globalThis.TypeError;
var stringSlice = uncurryThis(''.slice);
var charCodeAt = uncurryThis(''.charCodeAt);

// `ToNumeric` abstract operation
// https://tc39.es/ecma262/#sec-tonumeric
var toNumeric = function (value) {
  var primValue = toPrimitive(value, 'number');
  return typeof primValue == 'bigint' ? primValue : toNumber(primValue);
};

// `ToNumber` abstract operation
// https://tc39.es/ecma262/#sec-tonumber
var toNumber = function (argument) {
  var it = toPrimitive(argument, 'number');
  var first, third, radix, maxCode, digits, length, index, code;
  if (isSymbol(it)) throw new TypeError('Cannot convert a Symbol value to a number');
  if (typeof it == 'string' && it.length > 2) {
    it = trim(it);
    first = charCodeAt(it, 0);
    if (first === 43 || first === 45) {
      third = charCodeAt(it, 2);
      if (third === 88 || third === 120) return NaN; // Number('+0x1') should be NaN, old V8 fix
    } else if (first === 48) {
      switch (charCodeAt(it, 1)) {
        // fast equal of /^0b[01]+$/i
        case 66:
        case 98:
          radix = 2;
          maxCode = 49;
          break;
        // fast equal of /^0o[0-7]+$/i
        case 79:
        case 111:
          radix = 8;
          maxCode = 55;
          break;
        default:
          return +it;
      }
      digits = stringSlice(it, 2);
      length = digits.length;
      for (index = 0; index < length; index++) {
        code = charCodeAt(digits, index);
        // parseInt parses a string to a first unavailable symbol
        // but ToNumber should return NaN if a string contains unavailable symbols
        if (code < 48 || code > maxCode) return NaN;
      } return parseInt(digits, radix);
    }
  } return +it;
};

var FORCED = isForced(NUMBER, !NativeNumber(' 0o1') || !NativeNumber('0b1') || NativeNumber('+0x1'));

var calledWithNew = function (dummy) {
  // includes check on 1..constructor(foo) case
  return isPrototypeOf(NumberPrototype, dummy) && fails(function () { thisNumberValue(dummy); });
};

// `Number` constructor
// https://tc39.es/ecma262/#sec-number-constructor
var NumberWrapper = function Number(value) {
  var n = arguments.length < 1 ? 0 : NativeNumber(toNumeric(value));
  return calledWithNew(this) ? inheritIfRequired(Object(n), this, NumberWrapper) : n;
};

NumberWrapper.prototype = NumberPrototype;
if (FORCED && !IS_PURE) NumberPrototype.constructor = NumberWrapper;

$({ global: true, constructor: true, wrap: true, forced: FORCED }, {
  Number: NumberWrapper
});

// Use `internal/copy-constructor-properties` helper in `core-js@4`
var copyConstructorProperties = function (target, source) {
  for (var keys = DESCRIPTORS ? getOwnPropertyNames(source) : (
    // ES3:
    'MAX_VALUE,MIN_VALUE,NaN,NEGATIVE_INFINITY,POSITIVE_INFINITY,' +
    // ES2015 (in case, if modules with ES2015 Number statics required before):
    'EPSILON,MAX_SAFE_INTEGER,MIN_SAFE_INTEGER,isFinite,isInteger,isNaN,isSafeInteger,parseFloat,parseInt,' +
    // ESNext
    'fromString,range'
  ).split(','), j = 0, key; keys.length > j; j++) {
    if (hasOwn(source, key = keys[j]) && !hasOwn(target, key)) {
      defineProperty(target, key, getOwnPropertyDescriptor(source, key));
    }
  }
};

if (IS_PURE && PureNumberNamespace) copyConstructorProperties(path[NUMBER], PureNumberNamespace);
if (FORCED || IS_PURE) copyConstructorProperties(path[NUMBER], NativeNumber);


/***/ }),

/***/ 2637:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var isIntegralNumber = __webpack_require__(2087);

// `Number.isInteger` method
// https://tc39.es/ecma262/#sec-number.isinteger
$({ target: 'Number', stat: true }, {
  isInteger: isIntegralNumber
});


/***/ }),

/***/ 9868:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var toIntegerOrInfinity = __webpack_require__(1291);
var thisNumberValue = __webpack_require__(1240);
var $repeat = __webpack_require__(2333);
var fails = __webpack_require__(9039);

var $RangeError = RangeError;
var $String = String;
var floor = Math.floor;
var repeat = uncurryThis($repeat);
var stringSlice = uncurryThis(''.slice);
var nativeToFixed = uncurryThis(1.0.toFixed);

var pow = function (x, n, acc) {
  return n === 0 ? acc : n % 2 === 1 ? pow(x, n - 1, acc * x) : pow(x * x, n / 2, acc);
};

var log = function (x) {
  var n = 0;
  var x2 = x;
  while (x2 >= 4096) {
    n += 12;
    x2 /= 4096;
  }
  while (x2 >= 2) {
    n += 1;
    x2 /= 2;
  } return n;
};

var multiply = function (data, n, c) {
  var index = -1;
  var c2 = c;
  while (++index < 6) {
    c2 += n * data[index];
    data[index] = c2 % 1e7;
    c2 = floor(c2 / 1e7);
  }
};

var divide = function (data, n) {
  var index = 6;
  var c = 0;
  while (--index >= 0) {
    c += data[index];
    data[index] = floor(c / n);
    c = (c % n) * 1e7;
  }
};

var dataToString = function (data) {
  var index = 6;
  var s = '';
  while (--index >= 0) {
    if (s !== '' || index === 0 || data[index] !== 0) {
      var t = $String(data[index]);
      s = s === '' ? t : s + repeat('0', 7 - t.length) + t;
    }
  } return s;
};

var FORCED = fails(function () {
  return nativeToFixed(0.00008, 3) !== '0.000' ||
    nativeToFixed(0.9, 0) !== '1' ||
    nativeToFixed(1.255, 2) !== '1.25' ||
    nativeToFixed(1000000000000000128.0, 0) !== '1000000000000000128';
}) || !fails(function () {
  // V8 ~ Android 4.3-
  nativeToFixed({});
});

// `Number.prototype.toFixed` method
// https://tc39.es/ecma262/#sec-number.prototype.tofixed
$({ target: 'Number', proto: true, forced: FORCED }, {
  toFixed: function toFixed(fractionDigits) {
    var number = thisNumberValue(this);
    var fractDigits = toIntegerOrInfinity(fractionDigits);
    var data = [0, 0, 0, 0, 0, 0];
    var sign = '';
    var result = '0';
    var e, z, j, k;

    // TODO: ES2018 increased the maximum number of fraction digits to 100, need to improve the implementation
    if (fractDigits < 0 || fractDigits > 20) throw new $RangeError('Incorrect fraction digits');
    // eslint-disable-next-line no-self-compare -- NaN check
    if (number !== number) return 'NaN';
    if (number <= -1e21 || number >= 1e21) return $String(number);
    if (number < 0) {
      sign = '-';
      number = -number;
    }
    if (number > 1e-21) {
      e = log(number * pow(2, 69, 1)) - 69;
      z = e < 0 ? number * pow(2, -e, 1) : number / pow(2, e, 1);
      z *= 0x10000000000000;
      e = 52 - e;
      if (e > 0) {
        multiply(data, 0, z);
        j = fractDigits;
        while (j >= 7) {
          multiply(data, 1e7, 0);
          j -= 7;
        }
        multiply(data, pow(10, j, 1), 0);
        j = e - 1;
        while (j >= 23) {
          divide(data, 1 << 23);
          j -= 23;
        }
        divide(data, 1 << j);
        multiply(data, 1, 1);
        divide(data, 2);
        result = dataToString(data);
      } else {
        multiply(data, 0, z);
        multiply(data, 1 << -e, 0);
        result = dataToString(data) + repeat('0', fractDigits);
      }
    }
    if (fractDigits > 0) {
      k = result.length;
      result = sign + (k <= fractDigits
        ? '0.' + repeat('0', fractDigits - k) + result
        : stringSlice(result, 0, k - fractDigits) + '.' + stringSlice(result, k - fractDigits));
    } else {
      result = sign + result;
    } return result;
  }
});


/***/ }),

/***/ 9085:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var assign = __webpack_require__(4213);

// `Object.assign` method
// https://tc39.es/ecma262/#sec-object.assign
// eslint-disable-next-line es/no-object-assign -- required for testing
$({ target: 'Object', stat: true, arity: 2, forced: Object.assign !== assign }, {
  assign: assign
});


/***/ }),

/***/ 5506:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $entries = (__webpack_require__(2357).entries);

// `Object.entries` method
// https://tc39.es/ecma262/#sec-object.entries
$({ target: 'Object', stat: true }, {
  entries: function entries(O) {
    return $entries(O);
  }
});


/***/ }),

/***/ 2811:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var FREEZING = __webpack_require__(2744);
var fails = __webpack_require__(9039);
var isObject = __webpack_require__(34);
var onFreeze = (__webpack_require__(3451).onFreeze);

// eslint-disable-next-line es/no-object-freeze -- safe
var $freeze = Object.freeze;
var FAILS_ON_PRIMITIVES = fails(function () { $freeze(1); });

// `Object.freeze` method
// https://tc39.es/ecma262/#sec-object.freeze
$({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES, sham: !FREEZING }, {
  freeze: function freeze(it) {
    return $freeze && isObject(it) ? $freeze(onFreeze(it)) : it;
  }
});


/***/ }),

/***/ 3851:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fails = __webpack_require__(9039);
var toIndexedObject = __webpack_require__(5397);
var nativeGetOwnPropertyDescriptor = (__webpack_require__(7347).f);
var DESCRIPTORS = __webpack_require__(3724);

var FORCED = !DESCRIPTORS || fails(function () { nativeGetOwnPropertyDescriptor(1); });

// `Object.getOwnPropertyDescriptor` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
$({ target: 'Object', stat: true, forced: FORCED, sham: !DESCRIPTORS }, {
  getOwnPropertyDescriptor: function getOwnPropertyDescriptor(it, key) {
    return nativeGetOwnPropertyDescriptor(toIndexedObject(it), key);
  }
});


/***/ }),

/***/ 1278:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var DESCRIPTORS = __webpack_require__(3724);
var ownKeys = __webpack_require__(5031);
var toIndexedObject = __webpack_require__(5397);
var getOwnPropertyDescriptorModule = __webpack_require__(7347);
var createProperty = __webpack_require__(2278);

// `Object.getOwnPropertyDescriptors` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptors
$({ target: 'Object', stat: true, sham: !DESCRIPTORS }, {
  getOwnPropertyDescriptors: function getOwnPropertyDescriptors(object) {
    var O = toIndexedObject(object);
    var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
    var keys = ownKeys(O);
    var result = {};
    var index = 0;
    var key, descriptor;
    while (keys.length > index) {
      descriptor = getOwnPropertyDescriptor(O, key = keys[index++]);
      if (descriptor !== undefined) createProperty(result, key, descriptor);
    }
    return result;
  }
});


/***/ }),

/***/ 9773:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var NATIVE_SYMBOL = __webpack_require__(4495);
var fails = __webpack_require__(9039);
var getOwnPropertySymbolsModule = __webpack_require__(3717);
var toObject = __webpack_require__(8981);

// V8 ~ Chrome 38 and 39 `Object.getOwnPropertySymbols` fails on primitives
// https://bugs.chromium.org/p/v8/issues/detail?id=3443
var FORCED = !NATIVE_SYMBOL || fails(function () { getOwnPropertySymbolsModule.f(1); });

// `Object.getOwnPropertySymbols` method
// https://tc39.es/ecma262/#sec-object.getownpropertysymbols
$({ target: 'Object', stat: true, forced: FORCED }, {
  getOwnPropertySymbols: function getOwnPropertySymbols(it) {
    var $getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
    return $getOwnPropertySymbols ? $getOwnPropertySymbols(toObject(it)) : [];
  }
});


/***/ }),

/***/ 875:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fails = __webpack_require__(9039);
var toObject = __webpack_require__(8981);
var nativeGetPrototypeOf = __webpack_require__(2787);
var CORRECT_PROTOTYPE_GETTER = __webpack_require__(2211);

var FAILS_ON_PRIMITIVES = fails(function () { nativeGetPrototypeOf(1); });

// `Object.getPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.getprototypeof
$({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES, sham: !CORRECT_PROTOTYPE_GETTER }, {
  getPrototypeOf: function getPrototypeOf(it) {
    return nativeGetPrototypeOf(toObject(it));
  }
});



/***/ }),

/***/ 9432:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var toObject = __webpack_require__(8981);
var nativeKeys = __webpack_require__(1072);
var fails = __webpack_require__(9039);

var FAILS_ON_PRIMITIVES = fails(function () { nativeKeys(1); });

// `Object.keys` method
// https://tc39.es/ecma262/#sec-object.keys
$({ target: 'Object', stat: true, forced: FAILS_ON_PRIMITIVES }, {
  keys: function keys(it) {
    return nativeKeys(toObject(it));
  }
});


/***/ }),

/***/ 287:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var setPrototypeOf = __webpack_require__(2967);

// `Object.setPrototypeOf` method
// https://tc39.es/ecma262/#sec-object.setprototypeof
$({ target: 'Object', stat: true }, {
  setPrototypeOf: setPrototypeOf
});


/***/ }),

/***/ 6099:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var TO_STRING_TAG_SUPPORT = __webpack_require__(2140);
var defineBuiltIn = __webpack_require__(6840);
var toString = __webpack_require__(3179);

// `Object.prototype.toString` method
// https://tc39.es/ecma262/#sec-object.prototype.tostring
if (!TO_STRING_TAG_SUPPORT) {
  defineBuiltIn(Object.prototype, 'toString', toString, { unsafe: true });
}


/***/ }),

/***/ 6034:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $values = (__webpack_require__(2357).values);

// `Object.values` method
// https://tc39.es/ecma262/#sec-object.values
$({ target: 'Object', stat: true }, {
  values: function values(O) {
    return $values(O);
  }
});


/***/ }),

/***/ 8459:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $parseFloat = __webpack_require__(3904);

// `parseFloat` method
// https://tc39.es/ecma262/#sec-parsefloat-string
$({ global: true, forced: parseFloat !== $parseFloat }, {
  parseFloat: $parseFloat
});


/***/ }),

/***/ 8940:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $parseInt = __webpack_require__(2703);

// `parseInt` method
// https://tc39.es/ecma262/#sec-parseint-string-radix
$({ global: true, forced: parseInt !== $parseInt }, {
  parseInt: $parseInt
});


/***/ }),

/***/ 6167:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var newPromiseCapabilityModule = __webpack_require__(6043);
var perform = __webpack_require__(1103);
var iterate = __webpack_require__(2652);
var PROMISE_STATICS_INCORRECT_ITERATION = __webpack_require__(537);

// `Promise.allSettled` method
// https://tc39.es/ecma262/#sec-promise.allsettled
$({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION }, {
  allSettled: function allSettled(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule.f(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform(function () {
      var promiseResolve = aCallable(C.resolve);
      var values = [];
      var counter = 0;
      var remaining = 1;
      iterate(iterable, function (promise) {
        var index = counter++;
        var alreadyCalled = false;
        remaining++;
        call(promiseResolve, C, promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = { status: 'fulfilled', value: value };
          --remaining || resolve(values);
        }, function (error) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = { status: 'rejected', reason: error };
          --remaining || resolve(values);
        });
      });
      --remaining || resolve(values);
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});


/***/ }),

/***/ 6499:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var newPromiseCapabilityModule = __webpack_require__(6043);
var perform = __webpack_require__(1103);
var iterate = __webpack_require__(2652);
var PROMISE_STATICS_INCORRECT_ITERATION = __webpack_require__(537);

// `Promise.all` method
// https://tc39.es/ecma262/#sec-promise.all
$({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION }, {
  all: function all(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule.f(C);
    var resolve = capability.resolve;
    var reject = capability.reject;
    var result = perform(function () {
      var $promiseResolve = aCallable(C.resolve);
      var values = [];
      var counter = 0;
      var remaining = 1;
      iterate(iterable, function (promise) {
        var index = counter++;
        var alreadyCalled = false;
        remaining++;
        call($promiseResolve, C, promise).then(function (value) {
          if (alreadyCalled) return;
          alreadyCalled = true;
          values[index] = value;
          --remaining || resolve(values);
        }, reject);
      });
      --remaining || resolve(values);
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});


/***/ }),

/***/ 2003:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var IS_PURE = __webpack_require__(6395);
var FORCED_PROMISE_CONSTRUCTOR = (__webpack_require__(916).CONSTRUCTOR);
var NativePromiseConstructor = __webpack_require__(550);
var getBuiltIn = __webpack_require__(7751);
var isCallable = __webpack_require__(4901);
var defineBuiltIn = __webpack_require__(6840);

var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;

// `Promise.prototype.catch` method
// https://tc39.es/ecma262/#sec-promise.prototype.catch
$({ target: 'Promise', proto: true, forced: FORCED_PROMISE_CONSTRUCTOR, real: true }, {
  'catch': function (onRejected) {
    return this.then(undefined, onRejected);
  }
});

// makes sure that native promise-based APIs `Promise#catch` properly works with patched `Promise#then`
if (!IS_PURE && isCallable(NativePromiseConstructor)) {
  var method = getBuiltIn('Promise').prototype['catch'];
  if (NativePromisePrototype['catch'] !== method) {
    defineBuiltIn(NativePromisePrototype, 'catch', method, { unsafe: true });
  }
}


/***/ }),

/***/ 436:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var IS_PURE = __webpack_require__(6395);
var IS_NODE = __webpack_require__(8574);
var globalThis = __webpack_require__(4576);
var call = __webpack_require__(9565);
var defineBuiltIn = __webpack_require__(6840);
var setPrototypeOf = __webpack_require__(2967);
var setToStringTag = __webpack_require__(687);
var setSpecies = __webpack_require__(7633);
var aCallable = __webpack_require__(9306);
var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);
var anInstance = __webpack_require__(679);
var speciesConstructor = __webpack_require__(2293);
var task = (__webpack_require__(9225).set);
var microtask = __webpack_require__(1955);
var hostReportErrors = __webpack_require__(3138);
var perform = __webpack_require__(1103);
var Queue = __webpack_require__(8265);
var InternalStateModule = __webpack_require__(1181);
var NativePromiseConstructor = __webpack_require__(550);
var PromiseConstructorDetection = __webpack_require__(916);
var newPromiseCapabilityModule = __webpack_require__(6043);

var PROMISE = 'Promise';
var FORCED_PROMISE_CONSTRUCTOR = PromiseConstructorDetection.CONSTRUCTOR;
var NATIVE_PROMISE_REJECTION_EVENT = PromiseConstructorDetection.REJECTION_EVENT;
var NATIVE_PROMISE_SUBCLASSING = PromiseConstructorDetection.SUBCLASSING;
var getInternalPromiseState = InternalStateModule.getterFor(PROMISE);
var setInternalState = InternalStateModule.set;
var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;
var PromiseConstructor = NativePromiseConstructor;
var PromisePrototype = NativePromisePrototype;
var TypeError = globalThis.TypeError;
var document = globalThis.document;
var process = globalThis.process;
var newPromiseCapability = newPromiseCapabilityModule.f;
var newGenericPromiseCapability = newPromiseCapability;

var DISPATCH_EVENT = !!(document && document.createEvent && globalThis.dispatchEvent);
var UNHANDLED_REJECTION = 'unhandledrejection';
var REJECTION_HANDLED = 'rejectionhandled';
var PENDING = 0;
var FULFILLED = 1;
var REJECTED = 2;
var HANDLED = 1;
var UNHANDLED = 2;

var Internal, OwnPromiseCapability, PromiseWrapper, nativeThen;

// helpers
var isThenable = function (it) {
  var then;
  return isObject(it) && isCallable(then = it.then) ? then : false;
};

var callReaction = function (reaction, state) {
  var value = state.value;
  var ok = state.state === FULFILLED;
  var handler = ok ? reaction.ok : reaction.fail;
  var resolve = reaction.resolve;
  var reject = reaction.reject;
  var domain = reaction.domain;
  var result, then, exited;
  try {
    if (handler) {
      if (!ok) {
        if (state.rejection === UNHANDLED) onHandleUnhandled(state);
        state.rejection = HANDLED;
      }
      if (handler === true) result = value;
      else {
        if (domain) domain.enter();
        result = handler(value); // can throw
        if (domain) {
          domain.exit();
          exited = true;
        }
      }
      if (result === reaction.promise) {
        reject(new TypeError('Promise-chain cycle'));
      } else if (then = isThenable(result)) {
        call(then, result, resolve, reject);
      } else resolve(result);
    } else reject(value);
  } catch (error) {
    if (domain && !exited) domain.exit();
    reject(error);
  }
};

var notify = function (state, isReject) {
  if (state.notified) return;
  state.notified = true;
  microtask(function () {
    var reactions = state.reactions;
    var reaction;
    while (reaction = reactions.get()) {
      callReaction(reaction, state);
    }
    state.notified = false;
    if (isReject && !state.rejection) onUnhandled(state);
  });
};

var dispatchEvent = function (name, promise, reason) {
  var event, handler;
  if (DISPATCH_EVENT) {
    event = document.createEvent('Event');
    event.promise = promise;
    event.reason = reason;
    event.initEvent(name, false, true);
    globalThis.dispatchEvent(event);
  } else event = { promise: promise, reason: reason };
  if (!NATIVE_PROMISE_REJECTION_EVENT && (handler = globalThis['on' + name])) handler(event);
  else if (name === UNHANDLED_REJECTION) hostReportErrors('Unhandled promise rejection', reason);
};

var onUnhandled = function (state) {
  call(task, globalThis, function () {
    var promise = state.facade;
    var value = state.value;
    var IS_UNHANDLED = isUnhandled(state);
    var result;
    if (IS_UNHANDLED) {
      result = perform(function () {
        if (IS_NODE) {
          process.emit('unhandledRejection', value, promise);
        } else dispatchEvent(UNHANDLED_REJECTION, promise, value);
      });
      // Browsers should not trigger `rejectionHandled` event if it was handled here, NodeJS - should
      state.rejection = IS_NODE || isUnhandled(state) ? UNHANDLED : HANDLED;
      if (result.error) throw result.value;
    }
  });
};

var isUnhandled = function (state) {
  return state.rejection !== HANDLED && !state.parent;
};

var onHandleUnhandled = function (state) {
  call(task, globalThis, function () {
    var promise = state.facade;
    if (IS_NODE) {
      process.emit('rejectionHandled', promise);
    } else dispatchEvent(REJECTION_HANDLED, promise, state.value);
  });
};

var bind = function (fn, state, unwrap) {
  return function (value) {
    fn(state, value, unwrap);
  };
};

var internalReject = function (state, value, unwrap) {
  if (state.done) return;
  state.done = true;
  if (unwrap) state = unwrap;
  state.value = value;
  state.state = REJECTED;
  notify(state, true);
};

var internalResolve = function (state, value, unwrap) {
  if (state.done) return;
  state.done = true;
  if (unwrap) state = unwrap;
  try {
    if (state.facade === value) throw new TypeError("Promise can't be resolved itself");
    var then = isThenable(value);
    if (then) {
      microtask(function () {
        var wrapper = { done: false };
        try {
          call(then, value,
            bind(internalResolve, wrapper, state),
            bind(internalReject, wrapper, state)
          );
        } catch (error) {
          internalReject(wrapper, error, state);
        }
      });
    } else {
      state.value = value;
      state.state = FULFILLED;
      notify(state, false);
    }
  } catch (error) {
    internalReject({ done: false }, error, state);
  }
};

// constructor polyfill
if (FORCED_PROMISE_CONSTRUCTOR) {
  // 25.4.3.1 Promise(executor)
  PromiseConstructor = function Promise(executor) {
    anInstance(this, PromisePrototype);
    aCallable(executor);
    call(Internal, this);
    var state = getInternalPromiseState(this);
    try {
      executor(bind(internalResolve, state), bind(internalReject, state));
    } catch (error) {
      internalReject(state, error);
    }
  };

  PromisePrototype = PromiseConstructor.prototype;

  // eslint-disable-next-line no-unused-vars -- required for `.length`
  Internal = function Promise(executor) {
    setInternalState(this, {
      type: PROMISE,
      done: false,
      notified: false,
      parent: false,
      reactions: new Queue(),
      rejection: false,
      state: PENDING,
      value: null
    });
  };

  // `Promise.prototype.then` method
  // https://tc39.es/ecma262/#sec-promise.prototype.then
  Internal.prototype = defineBuiltIn(PromisePrototype, 'then', function then(onFulfilled, onRejected) {
    var state = getInternalPromiseState(this);
    var reaction = newPromiseCapability(speciesConstructor(this, PromiseConstructor));
    state.parent = true;
    reaction.ok = isCallable(onFulfilled) ? onFulfilled : true;
    reaction.fail = isCallable(onRejected) && onRejected;
    reaction.domain = IS_NODE ? process.domain : undefined;
    if (state.state === PENDING) state.reactions.add(reaction);
    else microtask(function () {
      callReaction(reaction, state);
    });
    return reaction.promise;
  });

  OwnPromiseCapability = function () {
    var promise = new Internal();
    var state = getInternalPromiseState(promise);
    this.promise = promise;
    this.resolve = bind(internalResolve, state);
    this.reject = bind(internalReject, state);
  };

  newPromiseCapabilityModule.f = newPromiseCapability = function (C) {
    return C === PromiseConstructor || C === PromiseWrapper
      ? new OwnPromiseCapability(C)
      : newGenericPromiseCapability(C);
  };

  if (!IS_PURE && isCallable(NativePromiseConstructor) && NativePromisePrototype !== Object.prototype) {
    nativeThen = NativePromisePrototype.then;

    if (!NATIVE_PROMISE_SUBCLASSING) {
      // make `Promise#then` return a polyfilled `Promise` for native promise-based APIs
      defineBuiltIn(NativePromisePrototype, 'then', function then(onFulfilled, onRejected) {
        var that = this;
        return new PromiseConstructor(function (resolve, reject) {
          call(nativeThen, that, resolve, reject);
        }).then(onFulfilled, onRejected);
      // https://github.com/zloirock/core-js/issues/640
      }, { unsafe: true });
    }

    // make `.constructor === Promise` work for native promise-based APIs
    try {
      delete NativePromisePrototype.constructor;
    } catch (error) { /* empty */ }

    // make `instanceof Promise` work for native promise-based APIs
    if (setPrototypeOf) {
      setPrototypeOf(NativePromisePrototype, PromisePrototype);
    }
  }
}

// `Promise` constructor
// https://tc39.es/ecma262/#sec-promise-executor
$({ global: true, constructor: true, wrap: true, forced: FORCED_PROMISE_CONSTRUCTOR }, {
  Promise: PromiseConstructor
});

setToStringTag(PromiseConstructor, PROMISE, false, true);
setSpecies(PROMISE);


/***/ }),

/***/ 9391:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var IS_PURE = __webpack_require__(6395);
var NativePromiseConstructor = __webpack_require__(550);
var fails = __webpack_require__(9039);
var getBuiltIn = __webpack_require__(7751);
var isCallable = __webpack_require__(4901);
var speciesConstructor = __webpack_require__(2293);
var promiseResolve = __webpack_require__(3438);
var defineBuiltIn = __webpack_require__(6840);

var NativePromisePrototype = NativePromiseConstructor && NativePromiseConstructor.prototype;

// Safari bug https://bugs.webkit.org/show_bug.cgi?id=200829
var NON_GENERIC = !!NativePromiseConstructor && fails(function () {
  // eslint-disable-next-line unicorn/no-thenable -- required for testing
  NativePromisePrototype['finally'].call({ then: function () { /* empty */ } }, function () { /* empty */ });
});

// `Promise.prototype.finally` method
// https://tc39.es/ecma262/#sec-promise.prototype.finally
$({ target: 'Promise', proto: true, real: true, forced: NON_GENERIC }, {
  'finally': function (onFinally) {
    var C = speciesConstructor(this, getBuiltIn('Promise'));
    var isFunction = isCallable(onFinally);
    return this.then(
      isFunction ? function (x) {
        return promiseResolve(C, onFinally()).then(function () { return x; });
      } : onFinally,
      isFunction ? function (e) {
        return promiseResolve(C, onFinally()).then(function () { throw e; });
      } : onFinally
    );
  }
});

// makes sure that native promise-based APIs `Promise#finally` properly works with patched `Promise#then`
if (!IS_PURE && isCallable(NativePromiseConstructor)) {
  var method = getBuiltIn('Promise').prototype['finally'];
  if (NativePromisePrototype['finally'] !== method) {
    defineBuiltIn(NativePromisePrototype, 'finally', method, { unsafe: true });
  }
}


/***/ }),

/***/ 3362:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's split to modules listed below
__webpack_require__(436);
__webpack_require__(6499);
__webpack_require__(2003);
__webpack_require__(7743);
__webpack_require__(1481);
__webpack_require__(280);


/***/ }),

/***/ 7743:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var aCallable = __webpack_require__(9306);
var newPromiseCapabilityModule = __webpack_require__(6043);
var perform = __webpack_require__(1103);
var iterate = __webpack_require__(2652);
var PROMISE_STATICS_INCORRECT_ITERATION = __webpack_require__(537);

// `Promise.race` method
// https://tc39.es/ecma262/#sec-promise.race
$({ target: 'Promise', stat: true, forced: PROMISE_STATICS_INCORRECT_ITERATION }, {
  race: function race(iterable) {
    var C = this;
    var capability = newPromiseCapabilityModule.f(C);
    var reject = capability.reject;
    var result = perform(function () {
      var $promiseResolve = aCallable(C.resolve);
      iterate(iterable, function (promise) {
        call($promiseResolve, C, promise).then(capability.resolve, reject);
      });
    });
    if (result.error) reject(result.value);
    return capability.promise;
  }
});


/***/ }),

/***/ 1481:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var newPromiseCapabilityModule = __webpack_require__(6043);
var FORCED_PROMISE_CONSTRUCTOR = (__webpack_require__(916).CONSTRUCTOR);

// `Promise.reject` method
// https://tc39.es/ecma262/#sec-promise.reject
$({ target: 'Promise', stat: true, forced: FORCED_PROMISE_CONSTRUCTOR }, {
  reject: function reject(r) {
    var capability = newPromiseCapabilityModule.f(this);
    var capabilityReject = capability.reject;
    capabilityReject(r);
    return capability.promise;
  }
});


/***/ }),

/***/ 280:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var getBuiltIn = __webpack_require__(7751);
var IS_PURE = __webpack_require__(6395);
var NativePromiseConstructor = __webpack_require__(550);
var FORCED_PROMISE_CONSTRUCTOR = (__webpack_require__(916).CONSTRUCTOR);
var promiseResolve = __webpack_require__(3438);

var PromiseConstructorWrapper = getBuiltIn('Promise');
var CHECK_WRAPPER = IS_PURE && !FORCED_PROMISE_CONSTRUCTOR;

// `Promise.resolve` method
// https://tc39.es/ecma262/#sec-promise.resolve
$({ target: 'Promise', stat: true, forced: IS_PURE || FORCED_PROMISE_CONSTRUCTOR }, {
  resolve: function resolve(x) {
    return promiseResolve(CHECK_WRAPPER && this === PromiseConstructorWrapper ? NativePromiseConstructor : this, x);
  }
});


/***/ }),

/***/ 1689:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var apply = __webpack_require__(8745);
var slice = __webpack_require__(7680);
var newPromiseCapabilityModule = __webpack_require__(6043);
var aCallable = __webpack_require__(9306);
var perform = __webpack_require__(1103);

var Promise = globalThis.Promise;

var ACCEPT_ARGUMENTS = false;
// Avoiding the use of polyfills of the previous iteration of this proposal
// that does not accept arguments of the callback
var FORCED = !Promise || !Promise['try'] || perform(function () {
  Promise['try'](function (argument) {
    ACCEPT_ARGUMENTS = argument === 8;
  }, 8);
}).error || !ACCEPT_ARGUMENTS;

// `Promise.try` method
// https://tc39.es/ecma262/#sec-promise.try
$({ target: 'Promise', stat: true, forced: FORCED }, {
  'try': function (callbackfn /* , ...args */) {
    var args = arguments.length > 1 ? slice(arguments, 1) : [];
    var promiseCapability = newPromiseCapabilityModule.f(this);
    var result = perform(function () {
      return apply(aCallable(callbackfn), undefined, args);
    });
    (result.error ? promiseCapability.reject : promiseCapability.resolve)(result.value);
    return promiseCapability.promise;
  }
});


/***/ }),

/***/ 4628:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var newPromiseCapabilityModule = __webpack_require__(6043);

// `Promise.withResolvers` method
// https://tc39.es/ecma262/#sec-promise.withResolvers
$({ target: 'Promise', stat: true }, {
  withResolvers: function withResolvers() {
    var promiseCapability = newPromiseCapabilityModule.f(this);
    return {
      promise: promiseCapability.promise,
      resolve: promiseCapability.resolve,
      reject: promiseCapability.reject
    };
  }
});


/***/ }),

/***/ 825:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var getBuiltIn = __webpack_require__(7751);
var apply = __webpack_require__(8745);
var bind = __webpack_require__(566);
var aConstructor = __webpack_require__(5548);
var anObject = __webpack_require__(8551);
var isObject = __webpack_require__(34);
var create = __webpack_require__(2360);
var fails = __webpack_require__(9039);

var nativeConstruct = getBuiltIn('Reflect', 'construct');
var ObjectPrototype = Object.prototype;
var push = [].push;

// `Reflect.construct` method
// https://tc39.es/ecma262/#sec-reflect.construct
// MS Edge supports only 2 arguments and argumentsList argument is optional
// FF Nightly sets third argument as `new.target`, but does not create `this` from it
var NEW_TARGET_BUG = fails(function () {
  function F() { /* empty */ }
  return !(nativeConstruct(function () { /* empty */ }, [], F) instanceof F);
});

var ARGS_BUG = !fails(function () {
  nativeConstruct(function () { /* empty */ });
});

var FORCED = NEW_TARGET_BUG || ARGS_BUG;

$({ target: 'Reflect', stat: true, forced: FORCED, sham: FORCED }, {
  construct: function construct(Target, args /* , newTarget */) {
    aConstructor(Target);
    anObject(args);
    var newTarget = arguments.length < 3 ? Target : aConstructor(arguments[2]);
    if (ARGS_BUG && !NEW_TARGET_BUG) return nativeConstruct(Target, args, newTarget);
    if (Target === newTarget) {
      // w/o altered newTarget, optimization for 0-4 arguments
      switch (args.length) {
        case 0: return new Target();
        case 1: return new Target(args[0]);
        case 2: return new Target(args[0], args[1]);
        case 3: return new Target(args[0], args[1], args[2]);
        case 4: return new Target(args[0], args[1], args[2], args[3]);
      }
      // w/o altered newTarget, lot of arguments case
      var $args = [null];
      apply(push, $args, args);
      return new (apply(bind, Target, $args))();
    }
    // with altered newTarget, not support built-in constructors
    var proto = newTarget.prototype;
    var instance = create(isObject(proto) ? proto : ObjectPrototype);
    var result = apply(Target, instance, args);
    return isObject(result) ? result : instance;
  }
});


/***/ }),

/***/ 888:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var isObject = __webpack_require__(34);
var anObject = __webpack_require__(8551);
var isDataDescriptor = __webpack_require__(6575);
var getOwnPropertyDescriptorModule = __webpack_require__(7347);
var getPrototypeOf = __webpack_require__(2787);

// `Reflect.get` method
// https://tc39.es/ecma262/#sec-reflect.get
function get(target, propertyKey /* , receiver */) {
  var receiver = arguments.length < 3 ? target : arguments[2];
  var descriptor, prototype;
  if (anObject(target) === receiver) return target[propertyKey];
  descriptor = getOwnPropertyDescriptorModule.f(target, propertyKey);
  if (descriptor) return isDataDescriptor(descriptor)
    ? descriptor.value
    : descriptor.get === undefined ? undefined : call(descriptor.get, receiver);
  if (isObject(prototype = getPrototypeOf(target))) return get(prototype, propertyKey, receiver);
}

$({ target: 'Reflect', stat: true }, {
  get: get
});


/***/ }),

/***/ 5472:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var setToStringTag = __webpack_require__(687);

$({ global: true }, { Reflect: {} });

// Reflect[@@toStringTag] property
// https://tc39.es/ecma262/#sec-reflect-@@tostringtag
setToStringTag(globalThis.Reflect, 'Reflect', true);


/***/ }),

/***/ 4864:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var isForced = __webpack_require__(2796);
var inheritIfRequired = __webpack_require__(3167);
var createNonEnumerableProperty = __webpack_require__(6699);
var create = __webpack_require__(2360);
var getOwnPropertyNames = (__webpack_require__(8480).f);
var isPrototypeOf = __webpack_require__(1625);
var isRegExp = __webpack_require__(788);
var toString = __webpack_require__(655);
var getRegExpFlags = __webpack_require__(1034);
var stickyHelpers = __webpack_require__(8429);
var proxyAccessor = __webpack_require__(1056);
var defineBuiltIn = __webpack_require__(6840);
var fails = __webpack_require__(9039);
var hasOwn = __webpack_require__(9297);
var enforceInternalState = (__webpack_require__(1181).enforce);
var setSpecies = __webpack_require__(7633);
var wellKnownSymbol = __webpack_require__(8227);
var UNSUPPORTED_DOT_ALL = __webpack_require__(3635);
var UNSUPPORTED_NCG = __webpack_require__(8814);

var MATCH = wellKnownSymbol('match');
var NativeRegExp = globalThis.RegExp;
var RegExpPrototype = NativeRegExp.prototype;
var SyntaxError = globalThis.SyntaxError;
var exec = uncurryThis(RegExpPrototype.exec);
var charAt = uncurryThis(''.charAt);
var replace = uncurryThis(''.replace);
var stringIndexOf = uncurryThis(''.indexOf);
var stringSlice = uncurryThis(''.slice);
// TODO: Use only proper RegExpIdentifierName
var IS_NCG = /^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/;
var re1 = /a/g;
var re2 = /a/g;

// "new" should create a new object, old webkit bug
var CORRECT_NEW = new NativeRegExp(re1) !== re1;

var MISSED_STICKY = stickyHelpers.MISSED_STICKY;
var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;

var BASE_FORCED = DESCRIPTORS &&
  (!CORRECT_NEW || MISSED_STICKY || UNSUPPORTED_DOT_ALL || UNSUPPORTED_NCG || fails(function () {
    re2[MATCH] = false;
    // RegExp constructor can alter flags and IsRegExp works correct with @@match
    // eslint-disable-next-line sonarjs/inconsistent-function-call -- required for testing
    return NativeRegExp(re1) !== re1 || NativeRegExp(re2) === re2 || String(NativeRegExp(re1, 'i')) !== '/a/i';
  }));

var handleDotAll = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var brackets = false;
  var chr;
  for (; index <= length; index++) {
    chr = charAt(string, index);
    if (chr === '\\') {
      result += chr + charAt(string, ++index);
      continue;
    }
    if (!brackets && chr === '.') {
      result += '[\\s\\S]';
    } else {
      if (chr === '[') {
        brackets = true;
      } else if (chr === ']') {
        brackets = false;
      } result += chr;
    }
  } return result;
};

var handleNCG = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var named = [];
  var names = create(null);
  var brackets = false;
  var ncg = false;
  var groupid = 0;
  var groupname = '';
  var chr;
  for (; index <= length; index++) {
    chr = charAt(string, index);
    if (chr === '\\') {
      chr += charAt(string, ++index);
    } else if (chr === ']') {
      brackets = false;
    } else if (!brackets) switch (true) {
      case chr === '[':
        brackets = true;
        break;
      case chr === '(':
        result += chr;
        // ignore non-capturing groups
        if (stringSlice(string, index + 1, index + 3) === '?:') {
          continue;
        }
        if (exec(IS_NCG, stringSlice(string, index + 1))) {
          index += 2;
          ncg = true;
        }
        groupid++;
        continue;
      case chr === '>' && ncg:
        if (groupname === '' || hasOwn(names, groupname)) {
          throw new SyntaxError('Invalid capture group name');
        }
        names[groupname] = true;
        named[named.length] = [groupname, groupid];
        ncg = false;
        groupname = '';
        continue;
    }
    if (ncg) groupname += chr;
    else result += chr;
  } return [result, named];
};

// `RegExp` constructor
// https://tc39.es/ecma262/#sec-regexp-constructor
if (isForced('RegExp', BASE_FORCED)) {
  var RegExpWrapper = function RegExp(pattern, flags) {
    var thisIsRegExp = isPrototypeOf(RegExpPrototype, this);
    var patternIsRegExp = isRegExp(pattern);
    var flagsAreUndefined = flags === undefined;
    var groups = [];
    var rawPattern = pattern;
    var rawFlags, dotAll, sticky, handled, result, state;

    if (!thisIsRegExp && patternIsRegExp && flagsAreUndefined && pattern.constructor === RegExpWrapper) {
      return pattern;
    }

    if (patternIsRegExp || isPrototypeOf(RegExpPrototype, pattern)) {
      pattern = pattern.source;
      if (flagsAreUndefined) flags = getRegExpFlags(rawPattern);
    }

    pattern = pattern === undefined ? '' : toString(pattern);
    flags = flags === undefined ? '' : toString(flags);
    rawPattern = pattern;

    if (UNSUPPORTED_DOT_ALL && 'dotAll' in re1) {
      dotAll = !!flags && stringIndexOf(flags, 's') > -1;
      if (dotAll) flags = replace(flags, /s/g, '');
    }

    rawFlags = flags;

    if (MISSED_STICKY && 'sticky' in re1) {
      sticky = !!flags && stringIndexOf(flags, 'y') > -1;
      if (sticky && UNSUPPORTED_Y) flags = replace(flags, /y/g, '');
    }

    if (UNSUPPORTED_NCG) {
      handled = handleNCG(pattern);
      pattern = handled[0];
      groups = handled[1];
    }

    result = inheritIfRequired(NativeRegExp(pattern, flags), thisIsRegExp ? this : RegExpPrototype, RegExpWrapper);

    if (dotAll || sticky || groups.length) {
      state = enforceInternalState(result);
      if (dotAll) {
        state.dotAll = true;
        state.raw = RegExpWrapper(handleDotAll(pattern), rawFlags);
      }
      if (sticky) state.sticky = true;
      if (groups.length) state.groups = groups;
    }

    if (pattern !== rawPattern) try {
      // fails in old engines, but we have no alternatives for unsupported regex syntax
      createNonEnumerableProperty(result, 'source', rawPattern === '' ? '(?:)' : rawPattern);
    } catch (error) { /* empty */ }

    return result;
  };

  for (var keys = getOwnPropertyNames(NativeRegExp), index = 0; keys.length > index;) {
    proxyAccessor(RegExpWrapper, NativeRegExp, keys[index++]);
  }

  RegExpPrototype.constructor = RegExpWrapper;
  RegExpWrapper.prototype = RegExpPrototype;
  defineBuiltIn(globalThis, 'RegExp', RegExpWrapper, { constructor: true });
}

// https://tc39.es/ecma262/#sec-get-regexp-@@species
setSpecies('RegExp');


/***/ }),

/***/ 7465:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var UNSUPPORTED_DOT_ALL = __webpack_require__(3635);
var classof = __webpack_require__(2195);
var defineBuiltInAccessor = __webpack_require__(2106);
var getInternalState = (__webpack_require__(1181).get);

var RegExpPrototype = RegExp.prototype;
var $TypeError = TypeError;

// `RegExp.prototype.dotAll` getter
// https://tc39.es/ecma262/#sec-get-regexp.prototype.dotall
if (DESCRIPTORS && UNSUPPORTED_DOT_ALL) {
  defineBuiltInAccessor(RegExpPrototype, 'dotAll', {
    configurable: true,
    get: function dotAll() {
      if (this === RegExpPrototype) return;
      // We can't use InternalStateModule.getterFor because
      // we don't add metadata for regexps created by a literal.
      if (classof(this) === 'RegExp') {
        return !!getInternalState(this).dotAll;
      }
      throw new $TypeError('Incompatible receiver, RegExp required');
    }
  });
}


/***/ }),

/***/ 7495:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var exec = __webpack_require__(7323);

// `RegExp.prototype.exec` method
// https://tc39.es/ecma262/#sec-regexp.prototype.exec
$({ target: 'RegExp', proto: true, forced: /./.exec !== exec }, {
  exec: exec
});


/***/ }),

/***/ 7745:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var MISSED_STICKY = (__webpack_require__(8429).MISSED_STICKY);
var classof = __webpack_require__(2195);
var defineBuiltInAccessor = __webpack_require__(2106);
var getInternalState = (__webpack_require__(1181).get);

var RegExpPrototype = RegExp.prototype;
var $TypeError = TypeError;

// `RegExp.prototype.sticky` getter
// https://tc39.es/ecma262/#sec-get-regexp.prototype.sticky
if (DESCRIPTORS && MISSED_STICKY) {
  defineBuiltInAccessor(RegExpPrototype, 'sticky', {
    configurable: true,
    get: function sticky() {
      if (this === RegExpPrototype) return;
      // We can't use InternalStateModule.getterFor because
      // we don't add metadata for regexps created by a literal.
      if (classof(this) === 'RegExp') {
        return !!getInternalState(this).sticky;
      }
      throw new $TypeError('Incompatible receiver, RegExp required');
    }
  });
}


/***/ }),

/***/ 906:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4` since it's moved to entry points
__webpack_require__(7495);
var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var isCallable = __webpack_require__(4901);
var anObject = __webpack_require__(8551);
var toString = __webpack_require__(655);

var DELEGATES_TO_EXEC = function () {
  var execCalled = false;
  var re = /[ac]/;
  re.exec = function () {
    execCalled = true;
    return /./.exec.apply(this, arguments);
  };
  return re.test('abc') === true && execCalled;
}();

var nativeTest = /./.test;

// `RegExp.prototype.test` method
// https://tc39.es/ecma262/#sec-regexp.prototype.test
$({ target: 'RegExp', proto: true, forced: !DELEGATES_TO_EXEC }, {
  test: function (S) {
    var R = anObject(this);
    var string = toString(S);
    var exec = R.exec;
    if (!isCallable(exec)) return call(nativeTest, R, string);
    var result = call(exec, R, string);
    if (result === null) return false;
    anObject(result);
    return true;
  }
});


/***/ }),

/***/ 8781:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var PROPER_FUNCTION_NAME = (__webpack_require__(350).PROPER);
var defineBuiltIn = __webpack_require__(6840);
var anObject = __webpack_require__(8551);
var $toString = __webpack_require__(655);
var fails = __webpack_require__(9039);
var getRegExpFlags = __webpack_require__(1034);

var TO_STRING = 'toString';
var RegExpPrototype = RegExp.prototype;
var nativeToString = RegExpPrototype[TO_STRING];

var NOT_GENERIC = fails(function () { return nativeToString.call({ source: 'a', flags: 'b' }) !== '/a/b'; });
// FF44- RegExp#toString has a wrong name
var INCORRECT_NAME = PROPER_FUNCTION_NAME && nativeToString.name !== TO_STRING;

// `RegExp.prototype.toString` method
// https://tc39.es/ecma262/#sec-regexp.prototype.tostring
if (NOT_GENERIC || INCORRECT_NAME) {
  defineBuiltIn(RegExpPrototype, TO_STRING, function toString() {
    var R = anObject(this);
    var pattern = $toString(R.source);
    var flags = $toString(getRegExpFlags(R));
    return '/' + pattern + '/' + flags;
  }, { unsafe: true });
}


/***/ }),

/***/ 2405:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var collection = __webpack_require__(6468);
var collectionStrong = __webpack_require__(6938);

// `Set` constructor
// https://tc39.es/ecma262/#sec-set-objects
collection('Set', function (init) {
  return function Set() { return init(this, arguments.length ? arguments[0] : undefined); };
}, collectionStrong);


/***/ }),

/***/ 7642:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var difference = __webpack_require__(3440);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.difference` method
// https://tc39.es/ecma262/#sec-set.prototype.difference
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('difference') }, {
  difference: difference
});


/***/ }),

/***/ 8004:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var fails = __webpack_require__(9039);
var intersection = __webpack_require__(8750);
var setMethodAcceptSetLike = __webpack_require__(4916);

var INCORRECT = !setMethodAcceptSetLike('intersection') || fails(function () {
  // eslint-disable-next-line es/no-array-from, es/no-set -- testing
  return String(Array.from(new Set([1, 2, 3]).intersection(new Set([3, 2])))) !== '3,2';
});

// `Set.prototype.intersection` method
// https://tc39.es/ecma262/#sec-set.prototype.intersection
$({ target: 'Set', proto: true, real: true, forced: INCORRECT }, {
  intersection: intersection
});


/***/ }),

/***/ 3853:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var isDisjointFrom = __webpack_require__(4449);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.isDisjointFrom` method
// https://tc39.es/ecma262/#sec-set.prototype.isdisjointfrom
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('isDisjointFrom') }, {
  isDisjointFrom: isDisjointFrom
});


/***/ }),

/***/ 5876:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var isSubsetOf = __webpack_require__(3838);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.isSubsetOf` method
// https://tc39.es/ecma262/#sec-set.prototype.issubsetof
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('isSubsetOf') }, {
  isSubsetOf: isSubsetOf
});


/***/ }),

/***/ 2475:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var isSupersetOf = __webpack_require__(8527);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.isSupersetOf` method
// https://tc39.es/ecma262/#sec-set.prototype.issupersetof
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('isSupersetOf') }, {
  isSupersetOf: isSupersetOf
});


/***/ }),

/***/ 1415:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(2405);


/***/ }),

/***/ 5024:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var symmetricDifference = __webpack_require__(3650);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.symmetricDifference` method
// https://tc39.es/ecma262/#sec-set.prototype.symmetricdifference
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('symmetricDifference') }, {
  symmetricDifference: symmetricDifference
});


/***/ }),

/***/ 1698:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var union = __webpack_require__(4204);
var setMethodAcceptSetLike = __webpack_require__(4916);

// `Set.prototype.union` method
// https://tc39.es/ecma262/#sec-set.prototype.union
$({ target: 'Set', proto: true, real: true, forced: !setMethodAcceptSetLike('union') }, {
  union: union
});


/***/ }),

/***/ 7357:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var requireObjectCoercible = __webpack_require__(7750);
var toIntegerOrInfinity = __webpack_require__(1291);
var toString = __webpack_require__(655);
var fails = __webpack_require__(9039);

var charAt = uncurryThis(''.charAt);

var FORCED = fails(function () {
  // eslint-disable-next-line es/no-string-prototype-at -- safe
  return '𠮷'.at(-2) !== '\uD842';
});

// `String.prototype.at` method
// https://tc39.es/ecma262/#sec-string.prototype.at
$({ target: 'String', proto: true, forced: FORCED }, {
  at: function at(index) {
    var S = toString(requireObjectCoercible(this));
    var len = S.length;
    var relativeIndex = toIntegerOrInfinity(index);
    var k = relativeIndex >= 0 ? relativeIndex : len + relativeIndex;
    return (k < 0 || k >= len) ? undefined : charAt(S, k);
  }
});


/***/ }),

/***/ 9449:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(7476);
var getOwnPropertyDescriptor = (__webpack_require__(7347).f);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var notARegExp = __webpack_require__(5749);
var requireObjectCoercible = __webpack_require__(7750);
var correctIsRegExpLogic = __webpack_require__(1436);
var IS_PURE = __webpack_require__(6395);

var slice = uncurryThis(''.slice);
var min = Math.min;

var CORRECT_IS_REGEXP_LOGIC = correctIsRegExpLogic('endsWith');
// https://github.com/zloirock/core-js/pull/702
var MDN_POLYFILL_BUG = !IS_PURE && !CORRECT_IS_REGEXP_LOGIC && !!function () {
  var descriptor = getOwnPropertyDescriptor(String.prototype, 'endsWith');
  return descriptor && !descriptor.writable;
}();

// `String.prototype.endsWith` method
// https://tc39.es/ecma262/#sec-string.prototype.endswith
$({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG && !CORRECT_IS_REGEXP_LOGIC }, {
  endsWith: function endsWith(searchString /* , endPosition = @length */) {
    var that = toString(requireObjectCoercible(this));
    notARegExp(searchString);
    var endPosition = arguments.length > 1 ? arguments[1] : undefined;
    var len = that.length;
    var end = endPosition === undefined ? len : min(toLength(endPosition), len);
    var search = toString(searchString);
    return slice(that, end - search.length, end) === search;
  }
});


/***/ }),

/***/ 7337:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var toAbsoluteIndex = __webpack_require__(5610);

var $RangeError = RangeError;
var fromCharCode = String.fromCharCode;
// eslint-disable-next-line es/no-string-fromcodepoint -- required for testing
var $fromCodePoint = String.fromCodePoint;
var join = uncurryThis([].join);

// length should be 1, old FF problem
var INCORRECT_LENGTH = !!$fromCodePoint && $fromCodePoint.length !== 1;

// `String.fromCodePoint` method
// https://tc39.es/ecma262/#sec-string.fromcodepoint
$({ target: 'String', stat: true, arity: 1, forced: INCORRECT_LENGTH }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  fromCodePoint: function fromCodePoint(x) {
    var elements = [];
    var length = arguments.length;
    var i = 0;
    var code;
    while (length > i) {
      code = +arguments[i++];
      if (toAbsoluteIndex(code, 0x10FFFF) !== code) throw new $RangeError(code + ' is not a valid code point');
      elements[i] = code < 0x10000
        ? fromCharCode(code)
        : fromCharCode(((code -= 0x10000) >> 10) + 0xD800, code % 0x400 + 0xDC00);
    } return join(elements, '');
  }
});


/***/ }),

/***/ 1699:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(9504);
var notARegExp = __webpack_require__(5749);
var requireObjectCoercible = __webpack_require__(7750);
var toString = __webpack_require__(655);
var correctIsRegExpLogic = __webpack_require__(1436);

var stringIndexOf = uncurryThis(''.indexOf);

// `String.prototype.includes` method
// https://tc39.es/ecma262/#sec-string.prototype.includes
$({ target: 'String', proto: true, forced: !correctIsRegExpLogic('includes') }, {
  includes: function includes(searchString /* , position = 0 */) {
    return !!~stringIndexOf(
      toString(requireObjectCoercible(this)),
      toString(notARegExp(searchString)),
      arguments.length > 1 ? arguments[1] : undefined
    );
  }
});


/***/ }),

/***/ 7764:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var charAt = (__webpack_require__(8183).charAt);
var toString = __webpack_require__(655);
var InternalStateModule = __webpack_require__(1181);
var defineIterator = __webpack_require__(1088);
var createIterResultObject = __webpack_require__(2529);

var STRING_ITERATOR = 'String Iterator';
var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(STRING_ITERATOR);

// `String.prototype[@@iterator]` method
// https://tc39.es/ecma262/#sec-string.prototype-@@iterator
defineIterator(String, 'String', function (iterated) {
  setInternalState(this, {
    type: STRING_ITERATOR,
    string: toString(iterated),
    index: 0
  });
// `%StringIteratorPrototype%.next` method
// https://tc39.es/ecma262/#sec-%stringiteratorprototype%.next
}, function next() {
  var state = getInternalState(this);
  var string = state.string;
  var index = state.index;
  var point;
  if (index >= string.length) return createIterResultObject(undefined, true);
  point = charAt(string, index);
  state.index += point.length;
  return createIterResultObject(point, false);
});


/***/ }),

/***/ 1761:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var fixRegExpWellKnownSymbolLogic = __webpack_require__(9228);
var anObject = __webpack_require__(8551);
var isNullOrUndefined = __webpack_require__(4117);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var requireObjectCoercible = __webpack_require__(7750);
var getMethod = __webpack_require__(5966);
var advanceStringIndex = __webpack_require__(7829);
var regExpExec = __webpack_require__(6682);

// @@match logic
fixRegExpWellKnownSymbolLogic('match', function (MATCH, nativeMatch, maybeCallNative) {
  return [
    // `String.prototype.match` method
    // https://tc39.es/ecma262/#sec-string.prototype.match
    function match(regexp) {
      var O = requireObjectCoercible(this);
      var matcher = isNullOrUndefined(regexp) ? undefined : getMethod(regexp, MATCH);
      return matcher ? call(matcher, regexp, O) : new RegExp(regexp)[MATCH](toString(O));
    },
    // `RegExp.prototype[@@match]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@match
    function (string) {
      var rx = anObject(this);
      var S = toString(string);
      var res = maybeCallNative(nativeMatch, rx, S);

      if (res.done) return res.value;

      if (!rx.global) return regExpExec(rx, S);

      var fullUnicode = rx.unicode;
      rx.lastIndex = 0;
      var A = [];
      var n = 0;
      var result;
      while ((result = regExpExec(rx, S)) !== null) {
        var matchStr = toString(result[0]);
        A[n] = matchStr;
        if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
        n++;
      }
      return n === 0 ? null : A;
    }
  ];
});


/***/ }),

/***/ 5701:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $padEnd = (__webpack_require__(533).end);
var WEBKIT_BUG = __webpack_require__(3063);

// `String.prototype.padEnd` method
// https://tc39.es/ecma262/#sec-string.prototype.padend
$({ target: 'String', proto: true, forced: WEBKIT_BUG }, {
  padEnd: function padEnd(maxLength /* , fillString = ' ' */) {
    return $padEnd(this, maxLength, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 8156:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $padStart = (__webpack_require__(533).start);
var WEBKIT_BUG = __webpack_require__(3063);

// `String.prototype.padStart` method
// https://tc39.es/ecma262/#sec-string.prototype.padstart
$({ target: 'String', proto: true, forced: WEBKIT_BUG }, {
  padStart: function padStart(maxLength /* , fillString = ' ' */) {
    return $padStart(this, maxLength, arguments.length > 1 ? arguments[1] : undefined);
  }
});


/***/ }),

/***/ 9978:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var requireObjectCoercible = __webpack_require__(7750);
var isCallable = __webpack_require__(4901);
var isNullOrUndefined = __webpack_require__(4117);
var isRegExp = __webpack_require__(788);
var toString = __webpack_require__(655);
var getMethod = __webpack_require__(5966);
var getRegExpFlags = __webpack_require__(1034);
var getSubstitution = __webpack_require__(2478);
var wellKnownSymbol = __webpack_require__(8227);
var IS_PURE = __webpack_require__(6395);

var REPLACE = wellKnownSymbol('replace');
var $TypeError = TypeError;
var indexOf = uncurryThis(''.indexOf);
var replace = uncurryThis(''.replace);
var stringSlice = uncurryThis(''.slice);
var max = Math.max;

// `String.prototype.replaceAll` method
// https://tc39.es/ecma262/#sec-string.prototype.replaceall
$({ target: 'String', proto: true }, {
  replaceAll: function replaceAll(searchValue, replaceValue) {
    var O = requireObjectCoercible(this);
    var IS_REG_EXP, flags, replacer, string, searchString, functionalReplace, searchLength, advanceBy, position, replacement;
    var endOfLastMatch = 0;
    var result = '';
    if (!isNullOrUndefined(searchValue)) {
      IS_REG_EXP = isRegExp(searchValue);
      if (IS_REG_EXP) {
        flags = toString(requireObjectCoercible(getRegExpFlags(searchValue)));
        if (!~indexOf(flags, 'g')) throw new $TypeError('`.replaceAll` does not allow non-global regexes');
      }
      replacer = getMethod(searchValue, REPLACE);
      if (replacer) return call(replacer, searchValue, O, replaceValue);
      if (IS_PURE && IS_REG_EXP) return replace(toString(O), searchValue, replaceValue);
    }
    string = toString(O);
    searchString = toString(searchValue);
    functionalReplace = isCallable(replaceValue);
    if (!functionalReplace) replaceValue = toString(replaceValue);
    searchLength = searchString.length;
    advanceBy = max(1, searchLength);
    position = indexOf(string, searchString);
    while (position !== -1) {
      replacement = functionalReplace
        ? toString(replaceValue(searchString, position, string))
        : getSubstitution(searchString, string, position, [], undefined, replaceValue);
      result += stringSlice(string, endOfLastMatch, position) + replacement;
      endOfLastMatch = position + searchLength;
      position = position + advanceBy > string.length ? -1 : indexOf(string, searchString, position + advanceBy);
    }
    if (endOfLastMatch < string.length) {
      result += stringSlice(string, endOfLastMatch);
    }
    return result;
  }
});


/***/ }),

/***/ 5440:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var apply = __webpack_require__(8745);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var fixRegExpWellKnownSymbolLogic = __webpack_require__(9228);
var fails = __webpack_require__(9039);
var anObject = __webpack_require__(8551);
var isCallable = __webpack_require__(4901);
var isNullOrUndefined = __webpack_require__(4117);
var toIntegerOrInfinity = __webpack_require__(1291);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var requireObjectCoercible = __webpack_require__(7750);
var advanceStringIndex = __webpack_require__(7829);
var getMethod = __webpack_require__(5966);
var getSubstitution = __webpack_require__(2478);
var regExpExec = __webpack_require__(6682);
var wellKnownSymbol = __webpack_require__(8227);

var REPLACE = wellKnownSymbol('replace');
var max = Math.max;
var min = Math.min;
var concat = uncurryThis([].concat);
var push = uncurryThis([].push);
var stringIndexOf = uncurryThis(''.indexOf);
var stringSlice = uncurryThis(''.slice);

var maybeToString = function (it) {
  return it === undefined ? it : String(it);
};

// IE <= 11 replaces $0 with the whole match, as if it was $&
// https://stackoverflow.com/questions/6024666/getting-ie-to-replace-a-regex-with-the-literal-string-0
var REPLACE_KEEPS_$0 = (function () {
  // eslint-disable-next-line regexp/prefer-escape-replacement-dollar-char -- required for testing
  return 'a'.replace(/./, '$0') === '$0';
})();

// Safari <= 13.0.3(?) substitutes nth capture where n>m with an empty string
var REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE = (function () {
  if (/./[REPLACE]) {
    return /./[REPLACE]('a', '$0') === '';
  }
  return false;
})();

var REPLACE_SUPPORTS_NAMED_GROUPS = !fails(function () {
  var re = /./;
  re.exec = function () {
    var result = [];
    result.groups = { a: '7' };
    return result;
  };
  // eslint-disable-next-line regexp/no-useless-dollar-replacements -- false positive
  return ''.replace(re, '$<a>') !== '7';
});

// @@replace logic
fixRegExpWellKnownSymbolLogic('replace', function (_, nativeReplace, maybeCallNative) {
  var UNSAFE_SUBSTITUTE = REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE ? '$' : '$0';

  return [
    // `String.prototype.replace` method
    // https://tc39.es/ecma262/#sec-string.prototype.replace
    function replace(searchValue, replaceValue) {
      var O = requireObjectCoercible(this);
      var replacer = isNullOrUndefined(searchValue) ? undefined : getMethod(searchValue, REPLACE);
      return replacer
        ? call(replacer, searchValue, O, replaceValue)
        : call(nativeReplace, toString(O), searchValue, replaceValue);
    },
    // `RegExp.prototype[@@replace]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@replace
    function (string, replaceValue) {
      var rx = anObject(this);
      var S = toString(string);

      if (
        typeof replaceValue == 'string' &&
        stringIndexOf(replaceValue, UNSAFE_SUBSTITUTE) === -1 &&
        stringIndexOf(replaceValue, '$<') === -1
      ) {
        var res = maybeCallNative(nativeReplace, rx, S, replaceValue);
        if (res.done) return res.value;
      }

      var functionalReplace = isCallable(replaceValue);
      if (!functionalReplace) replaceValue = toString(replaceValue);

      var global = rx.global;
      var fullUnicode;
      if (global) {
        fullUnicode = rx.unicode;
        rx.lastIndex = 0;
      }

      var results = [];
      var result;
      while (true) {
        result = regExpExec(rx, S);
        if (result === null) break;

        push(results, result);
        if (!global) break;

        var matchStr = toString(result[0]);
        if (matchStr === '') rx.lastIndex = advanceStringIndex(S, toLength(rx.lastIndex), fullUnicode);
      }

      var accumulatedResult = '';
      var nextSourcePosition = 0;
      for (var i = 0; i < results.length; i++) {
        result = results[i];

        var matched = toString(result[0]);
        var position = max(min(toIntegerOrInfinity(result.index), S.length), 0);
        var captures = [];
        var replacement;
        // NOTE: This is equivalent to
        //   captures = result.slice(1).map(maybeToString)
        // but for some reason `nativeSlice.call(result, 1, result.length)` (called in
        // the slice polyfill when slicing native arrays) "doesn't work" in safari 9 and
        // causes a crash (https://pastebin.com/N21QzeQA) when trying to debug it.
        for (var j = 1; j < result.length; j++) push(captures, maybeToString(result[j]));
        var namedCaptures = result.groups;
        if (functionalReplace) {
          var replacerArgs = concat([matched], captures, position, S);
          if (namedCaptures !== undefined) push(replacerArgs, namedCaptures);
          replacement = toString(apply(replaceValue, undefined, replacerArgs));
        } else {
          replacement = getSubstitution(matched, S, position, captures, namedCaptures, replaceValue);
        }
        if (position >= nextSourcePosition) {
          accumulatedResult += stringSlice(S, nextSourcePosition, position) + replacement;
          nextSourcePosition = position + matched.length;
        }
      }

      return accumulatedResult + stringSlice(S, nextSourcePosition);
    }
  ];
}, !REPLACE_SUPPORTS_NAMED_GROUPS || !REPLACE_KEEPS_$0 || REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE);


/***/ }),

/***/ 744:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var fixRegExpWellKnownSymbolLogic = __webpack_require__(9228);
var anObject = __webpack_require__(8551);
var isNullOrUndefined = __webpack_require__(4117);
var requireObjectCoercible = __webpack_require__(7750);
var speciesConstructor = __webpack_require__(2293);
var advanceStringIndex = __webpack_require__(7829);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var getMethod = __webpack_require__(5966);
var regExpExec = __webpack_require__(6682);
var stickyHelpers = __webpack_require__(8429);
var fails = __webpack_require__(9039);

var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;
var MAX_UINT32 = 0xFFFFFFFF;
var min = Math.min;
var push = uncurryThis([].push);
var stringSlice = uncurryThis(''.slice);

// Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
// Weex JS has frozen built-in prototypes, so use try / catch wrapper
var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails(function () {
  // eslint-disable-next-line regexp/no-empty-group -- required for testing
  var re = /(?:)/;
  var originalExec = re.exec;
  re.exec = function () { return originalExec.apply(this, arguments); };
  var result = 'ab'.split(re);
  return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
});

var BUGGY = 'abbc'.split(/(b)*/)[1] === 'c' ||
  // eslint-disable-next-line regexp/no-empty-group -- required for testing
  'test'.split(/(?:)/, -1).length !== 4 ||
  'ab'.split(/(?:ab)*/).length !== 2 ||
  '.'.split(/(.?)(.?)/).length !== 4 ||
  // eslint-disable-next-line regexp/no-empty-capturing-group, regexp/no-empty-group -- required for testing
  '.'.split(/()()/).length > 1 ||
  ''.split(/.?/).length;

// @@split logic
fixRegExpWellKnownSymbolLogic('split', function (SPLIT, nativeSplit, maybeCallNative) {
  var internalSplit = '0'.split(undefined, 0).length ? function (separator, limit) {
    return separator === undefined && limit === 0 ? [] : call(nativeSplit, this, separator, limit);
  } : nativeSplit;

  return [
    // `String.prototype.split` method
    // https://tc39.es/ecma262/#sec-string.prototype.split
    function split(separator, limit) {
      var O = requireObjectCoercible(this);
      var splitter = isNullOrUndefined(separator) ? undefined : getMethod(separator, SPLIT);
      return splitter
        ? call(splitter, separator, O, limit)
        : call(internalSplit, toString(O), separator, limit);
    },
    // `RegExp.prototype[@@split]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@split
    //
    // NOTE: This cannot be properly polyfilled in engines that don't support
    // the 'y' flag.
    function (string, limit) {
      var rx = anObject(this);
      var S = toString(string);

      if (!BUGGY) {
        var res = maybeCallNative(internalSplit, rx, S, limit, internalSplit !== nativeSplit);
        if (res.done) return res.value;
      }

      var C = speciesConstructor(rx, RegExp);
      var unicodeMatching = rx.unicode;
      var flags = (rx.ignoreCase ? 'i' : '') +
                  (rx.multiline ? 'm' : '') +
                  (rx.unicode ? 'u' : '') +
                  (UNSUPPORTED_Y ? 'g' : 'y');
      // ^(? + rx + ) is needed, in combination with some S slicing, to
      // simulate the 'y' flag.
      var splitter = new C(UNSUPPORTED_Y ? '^(?:' + rx.source + ')' : rx, flags);
      var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
      if (lim === 0) return [];
      if (S.length === 0) return regExpExec(splitter, S) === null ? [S] : [];
      var p = 0;
      var q = 0;
      var A = [];
      while (q < S.length) {
        splitter.lastIndex = UNSUPPORTED_Y ? 0 : q;
        var z = regExpExec(splitter, UNSUPPORTED_Y ? stringSlice(S, q) : S);
        var e;
        if (
          z === null ||
          (e = min(toLength(splitter.lastIndex + (UNSUPPORTED_Y ? q : 0)), S.length)) === p
        ) {
          q = advanceStringIndex(S, q, unicodeMatching);
        } else {
          push(A, stringSlice(S, p, q));
          if (A.length === lim) return A;
          for (var i = 1; i <= z.length - 1; i++) {
            push(A, z[i]);
            if (A.length === lim) return A;
          }
          q = p = e;
        }
      }
      push(A, stringSlice(S, p));
      return A;
    }
  ];
}, BUGGY || !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC, UNSUPPORTED_Y);


/***/ }),

/***/ 1392:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var uncurryThis = __webpack_require__(7476);
var getOwnPropertyDescriptor = (__webpack_require__(7347).f);
var toLength = __webpack_require__(8014);
var toString = __webpack_require__(655);
var notARegExp = __webpack_require__(5749);
var requireObjectCoercible = __webpack_require__(7750);
var correctIsRegExpLogic = __webpack_require__(1436);
var IS_PURE = __webpack_require__(6395);

var stringSlice = uncurryThis(''.slice);
var min = Math.min;

var CORRECT_IS_REGEXP_LOGIC = correctIsRegExpLogic('startsWith');
// https://github.com/zloirock/core-js/pull/702
var MDN_POLYFILL_BUG = !IS_PURE && !CORRECT_IS_REGEXP_LOGIC && !!function () {
  var descriptor = getOwnPropertyDescriptor(String.prototype, 'startsWith');
  return descriptor && !descriptor.writable;
}();

// `String.prototype.startsWith` method
// https://tc39.es/ecma262/#sec-string.prototype.startswith
$({ target: 'String', proto: true, forced: !MDN_POLYFILL_BUG && !CORRECT_IS_REGEXP_LOGIC }, {
  startsWith: function startsWith(searchString /* , position = 0 */) {
    var that = toString(requireObjectCoercible(this));
    notARegExp(searchString);
    var index = toLength(min(arguments.length > 1 ? arguments[1] : undefined, that.length));
    var search = toString(searchString);
    return stringSlice(that, index, index + search.length) === search;
  }
});


/***/ }),

/***/ 9202:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this line from `core-js@4`
__webpack_require__(3313);
var $ = __webpack_require__(6518);
var trimEnd = __webpack_require__(8866);

// `String.prototype.trimEnd` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
$({ target: 'String', proto: true, name: 'trimEnd', forced: ''.trimEnd !== trimEnd }, {
  trimEnd: trimEnd
});


/***/ }),

/***/ 8934:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var trimStart = __webpack_require__(3487);

// `String.prototype.trimLeft` method
// https://tc39.es/ecma262/#sec-string.prototype.trimleft
// eslint-disable-next-line es/no-string-prototype-trimleft-trimright -- safe
$({ target: 'String', proto: true, name: 'trimStart', forced: ''.trimLeft !== trimStart }, {
  trimLeft: trimStart
});


/***/ }),

/***/ 3313:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var trimEnd = __webpack_require__(8866);

// `String.prototype.trimRight` method
// https://tc39.es/ecma262/#sec-string.prototype.trimend
// eslint-disable-next-line es/no-string-prototype-trimleft-trimright -- safe
$({ target: 'String', proto: true, name: 'trimEnd', forced: ''.trimRight !== trimEnd }, {
  trimRight: trimEnd
});


/***/ }),

/***/ 3359:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this line from `core-js@4`
__webpack_require__(8934);
var $ = __webpack_require__(6518);
var trimStart = __webpack_require__(3487);

// `String.prototype.trimStart` method
// https://tc39.es/ecma262/#sec-string.prototype.trimstart
// eslint-disable-next-line es/no-string-prototype-trimstart-trimend -- safe
$({ target: 'String', proto: true, name: 'trimStart', forced: ''.trimStart !== trimStart }, {
  trimStart: trimStart
});


/***/ }),

/***/ 2762:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var $trim = (__webpack_require__(3802).trim);
var forcedStringTrimMethod = __webpack_require__(706);

// `String.prototype.trim` method
// https://tc39.es/ecma262/#sec-string.prototype.trim
$({ target: 'String', proto: true, forced: forcedStringTrimMethod('trim') }, {
  trim: function trim() {
    return $trim(this);
  }
});


/***/ }),

/***/ 6412:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineWellKnownSymbol = __webpack_require__(511);

// `Symbol.asyncIterator` well-known symbol
// https://tc39.es/ecma262/#sec-symbol.asynciterator
defineWellKnownSymbol('asyncIterator');


/***/ }),

/***/ 6761:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var IS_PURE = __webpack_require__(6395);
var DESCRIPTORS = __webpack_require__(3724);
var NATIVE_SYMBOL = __webpack_require__(4495);
var fails = __webpack_require__(9039);
var hasOwn = __webpack_require__(9297);
var isPrototypeOf = __webpack_require__(1625);
var anObject = __webpack_require__(8551);
var toIndexedObject = __webpack_require__(5397);
var toPropertyKey = __webpack_require__(6969);
var $toString = __webpack_require__(655);
var createPropertyDescriptor = __webpack_require__(6980);
var nativeObjectCreate = __webpack_require__(2360);
var objectKeys = __webpack_require__(1072);
var getOwnPropertyNamesModule = __webpack_require__(8480);
var getOwnPropertyNamesExternal = __webpack_require__(298);
var getOwnPropertySymbolsModule = __webpack_require__(3717);
var getOwnPropertyDescriptorModule = __webpack_require__(7347);
var definePropertyModule = __webpack_require__(4913);
var definePropertiesModule = __webpack_require__(6801);
var propertyIsEnumerableModule = __webpack_require__(8773);
var defineBuiltIn = __webpack_require__(6840);
var defineBuiltInAccessor = __webpack_require__(2106);
var shared = __webpack_require__(5745);
var sharedKey = __webpack_require__(6119);
var hiddenKeys = __webpack_require__(421);
var uid = __webpack_require__(3392);
var wellKnownSymbol = __webpack_require__(8227);
var wrappedWellKnownSymbolModule = __webpack_require__(1951);
var defineWellKnownSymbol = __webpack_require__(511);
var defineSymbolToPrimitive = __webpack_require__(8242);
var setToStringTag = __webpack_require__(687);
var InternalStateModule = __webpack_require__(1181);
var $forEach = (__webpack_require__(9213).forEach);

var HIDDEN = sharedKey('hidden');
var SYMBOL = 'Symbol';
var PROTOTYPE = 'prototype';

var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(SYMBOL);

var ObjectPrototype = Object[PROTOTYPE];
var $Symbol = globalThis.Symbol;
var SymbolPrototype = $Symbol && $Symbol[PROTOTYPE];
var RangeError = globalThis.RangeError;
var TypeError = globalThis.TypeError;
var QObject = globalThis.QObject;
var nativeGetOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
var nativeDefineProperty = definePropertyModule.f;
var nativeGetOwnPropertyNames = getOwnPropertyNamesExternal.f;
var nativePropertyIsEnumerable = propertyIsEnumerableModule.f;
var push = uncurryThis([].push);

var AllSymbols = shared('symbols');
var ObjectPrototypeSymbols = shared('op-symbols');
var WellKnownSymbolsStore = shared('wks');

// Don't use setters in Qt Script, https://github.com/zloirock/core-js/issues/173
var USE_SETTER = !QObject || !QObject[PROTOTYPE] || !QObject[PROTOTYPE].findChild;

// fallback for old Android, https://code.google.com/p/v8/issues/detail?id=687
var fallbackDefineProperty = function (O, P, Attributes) {
  var ObjectPrototypeDescriptor = nativeGetOwnPropertyDescriptor(ObjectPrototype, P);
  if (ObjectPrototypeDescriptor) delete ObjectPrototype[P];
  nativeDefineProperty(O, P, Attributes);
  if (ObjectPrototypeDescriptor && O !== ObjectPrototype) {
    nativeDefineProperty(ObjectPrototype, P, ObjectPrototypeDescriptor);
  }
};

var setSymbolDescriptor = DESCRIPTORS && fails(function () {
  return nativeObjectCreate(nativeDefineProperty({}, 'a', {
    get: function () { return nativeDefineProperty(this, 'a', { value: 7 }).a; }
  })).a !== 7;
}) ? fallbackDefineProperty : nativeDefineProperty;

var wrap = function (tag, description) {
  var symbol = AllSymbols[tag] = nativeObjectCreate(SymbolPrototype);
  setInternalState(symbol, {
    type: SYMBOL,
    tag: tag,
    description: description
  });
  if (!DESCRIPTORS) symbol.description = description;
  return symbol;
};

var $defineProperty = function defineProperty(O, P, Attributes) {
  if (O === ObjectPrototype) $defineProperty(ObjectPrototypeSymbols, P, Attributes);
  anObject(O);
  var key = toPropertyKey(P);
  anObject(Attributes);
  if (hasOwn(AllSymbols, key)) {
    if (!Attributes.enumerable) {
      if (!hasOwn(O, HIDDEN)) nativeDefineProperty(O, HIDDEN, createPropertyDescriptor(1, nativeObjectCreate(null)));
      O[HIDDEN][key] = true;
    } else {
      if (hasOwn(O, HIDDEN) && O[HIDDEN][key]) O[HIDDEN][key] = false;
      Attributes = nativeObjectCreate(Attributes, { enumerable: createPropertyDescriptor(0, false) });
    } return setSymbolDescriptor(O, key, Attributes);
  } return nativeDefineProperty(O, key, Attributes);
};

var $defineProperties = function defineProperties(O, Properties) {
  anObject(O);
  var properties = toIndexedObject(Properties);
  var keys = objectKeys(properties).concat($getOwnPropertySymbols(properties));
  $forEach(keys, function (key) {
    if (!DESCRIPTORS || call($propertyIsEnumerable, properties, key)) $defineProperty(O, key, properties[key]);
  });
  return O;
};

var $create = function create(O, Properties) {
  return Properties === undefined ? nativeObjectCreate(O) : $defineProperties(nativeObjectCreate(O), Properties);
};

var $propertyIsEnumerable = function propertyIsEnumerable(V) {
  var P = toPropertyKey(V);
  var enumerable = call(nativePropertyIsEnumerable, this, P);
  if (this === ObjectPrototype && hasOwn(AllSymbols, P) && !hasOwn(ObjectPrototypeSymbols, P)) return false;
  return enumerable || !hasOwn(this, P) || !hasOwn(AllSymbols, P) || hasOwn(this, HIDDEN) && this[HIDDEN][P]
    ? enumerable : true;
};

var $getOwnPropertyDescriptor = function getOwnPropertyDescriptor(O, P) {
  var it = toIndexedObject(O);
  var key = toPropertyKey(P);
  if (it === ObjectPrototype && hasOwn(AllSymbols, key) && !hasOwn(ObjectPrototypeSymbols, key)) return;
  var descriptor = nativeGetOwnPropertyDescriptor(it, key);
  if (descriptor && hasOwn(AllSymbols, key) && !(hasOwn(it, HIDDEN) && it[HIDDEN][key])) {
    descriptor.enumerable = true;
  }
  return descriptor;
};

var $getOwnPropertyNames = function getOwnPropertyNames(O) {
  var names = nativeGetOwnPropertyNames(toIndexedObject(O));
  var result = [];
  $forEach(names, function (key) {
    if (!hasOwn(AllSymbols, key) && !hasOwn(hiddenKeys, key)) push(result, key);
  });
  return result;
};

var $getOwnPropertySymbols = function (O) {
  var IS_OBJECT_PROTOTYPE = O === ObjectPrototype;
  var names = nativeGetOwnPropertyNames(IS_OBJECT_PROTOTYPE ? ObjectPrototypeSymbols : toIndexedObject(O));
  var result = [];
  $forEach(names, function (key) {
    if (hasOwn(AllSymbols, key) && (!IS_OBJECT_PROTOTYPE || hasOwn(ObjectPrototype, key))) {
      push(result, AllSymbols[key]);
    }
  });
  return result;
};

// `Symbol` constructor
// https://tc39.es/ecma262/#sec-symbol-constructor
if (!NATIVE_SYMBOL) {
  $Symbol = function Symbol() {
    if (isPrototypeOf(SymbolPrototype, this)) throw new TypeError('Symbol is not a constructor');
    var description = !arguments.length || arguments[0] === undefined ? undefined : $toString(arguments[0]);
    var tag = uid(description);
    var setter = function (value) {
      var $this = this === undefined ? globalThis : this;
      if ($this === ObjectPrototype) call(setter, ObjectPrototypeSymbols, value);
      if (hasOwn($this, HIDDEN) && hasOwn($this[HIDDEN], tag)) $this[HIDDEN][tag] = false;
      var descriptor = createPropertyDescriptor(1, value);
      try {
        setSymbolDescriptor($this, tag, descriptor);
      } catch (error) {
        if (!(error instanceof RangeError)) throw error;
        fallbackDefineProperty($this, tag, descriptor);
      }
    };
    if (DESCRIPTORS && USE_SETTER) setSymbolDescriptor(ObjectPrototype, tag, { configurable: true, set: setter });
    return wrap(tag, description);
  };

  SymbolPrototype = $Symbol[PROTOTYPE];

  defineBuiltIn(SymbolPrototype, 'toString', function toString() {
    return getInternalState(this).tag;
  });

  defineBuiltIn($Symbol, 'withoutSetter', function (description) {
    return wrap(uid(description), description);
  });

  propertyIsEnumerableModule.f = $propertyIsEnumerable;
  definePropertyModule.f = $defineProperty;
  definePropertiesModule.f = $defineProperties;
  getOwnPropertyDescriptorModule.f = $getOwnPropertyDescriptor;
  getOwnPropertyNamesModule.f = getOwnPropertyNamesExternal.f = $getOwnPropertyNames;
  getOwnPropertySymbolsModule.f = $getOwnPropertySymbols;

  wrappedWellKnownSymbolModule.f = function (name) {
    return wrap(wellKnownSymbol(name), name);
  };

  if (DESCRIPTORS) {
    // https://github.com/tc39/proposal-Symbol-description
    defineBuiltInAccessor(SymbolPrototype, 'description', {
      configurable: true,
      get: function description() {
        return getInternalState(this).description;
      }
    });
    if (!IS_PURE) {
      defineBuiltIn(ObjectPrototype, 'propertyIsEnumerable', $propertyIsEnumerable, { unsafe: true });
    }
  }
}

$({ global: true, constructor: true, wrap: true, forced: !NATIVE_SYMBOL, sham: !NATIVE_SYMBOL }, {
  Symbol: $Symbol
});

$forEach(objectKeys(WellKnownSymbolsStore), function (name) {
  defineWellKnownSymbol(name);
});

$({ target: SYMBOL, stat: true, forced: !NATIVE_SYMBOL }, {
  useSetter: function () { USE_SETTER = true; },
  useSimple: function () { USE_SETTER = false; }
});

$({ target: 'Object', stat: true, forced: !NATIVE_SYMBOL, sham: !DESCRIPTORS }, {
  // `Object.create` method
  // https://tc39.es/ecma262/#sec-object.create
  create: $create,
  // `Object.defineProperty` method
  // https://tc39.es/ecma262/#sec-object.defineproperty
  defineProperty: $defineProperty,
  // `Object.defineProperties` method
  // https://tc39.es/ecma262/#sec-object.defineproperties
  defineProperties: $defineProperties,
  // `Object.getOwnPropertyDescriptor` method
  // https://tc39.es/ecma262/#sec-object.getownpropertydescriptors
  getOwnPropertyDescriptor: $getOwnPropertyDescriptor
});

$({ target: 'Object', stat: true, forced: !NATIVE_SYMBOL }, {
  // `Object.getOwnPropertyNames` method
  // https://tc39.es/ecma262/#sec-object.getownpropertynames
  getOwnPropertyNames: $getOwnPropertyNames
});

// `Symbol.prototype[@@toPrimitive]` method
// https://tc39.es/ecma262/#sec-symbol.prototype-@@toprimitive
defineSymbolToPrimitive();

// `Symbol.prototype[@@toStringTag]` property
// https://tc39.es/ecma262/#sec-symbol.prototype-@@tostringtag
setToStringTag($Symbol, SYMBOL);

hiddenKeys[HIDDEN] = true;


/***/ }),

/***/ 9463:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

// `Symbol.prototype.description` getter
// https://tc39.es/ecma262/#sec-symbol.prototype.description

var $ = __webpack_require__(6518);
var DESCRIPTORS = __webpack_require__(3724);
var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var hasOwn = __webpack_require__(9297);
var isCallable = __webpack_require__(4901);
var isPrototypeOf = __webpack_require__(1625);
var toString = __webpack_require__(655);
var defineBuiltInAccessor = __webpack_require__(2106);
var copyConstructorProperties = __webpack_require__(7740);

var NativeSymbol = globalThis.Symbol;
var SymbolPrototype = NativeSymbol && NativeSymbol.prototype;

if (DESCRIPTORS && isCallable(NativeSymbol) && (!('description' in SymbolPrototype) ||
  // Safari 12 bug
  NativeSymbol().description !== undefined
)) {
  var EmptyStringDescriptionStore = {};
  // wrap Symbol constructor for correct work with undefined description
  var SymbolWrapper = function Symbol() {
    var description = arguments.length < 1 || arguments[0] === undefined ? undefined : toString(arguments[0]);
    var result = isPrototypeOf(SymbolPrototype, this)
      // eslint-disable-next-line sonarjs/inconsistent-function-call -- ok
      ? new NativeSymbol(description)
      // in Edge 13, String(Symbol(undefined)) === 'Symbol(undefined)'
      : description === undefined ? NativeSymbol() : NativeSymbol(description);
    if (description === '') EmptyStringDescriptionStore[result] = true;
    return result;
  };

  copyConstructorProperties(SymbolWrapper, NativeSymbol);
  SymbolWrapper.prototype = SymbolPrototype;
  SymbolPrototype.constructor = SymbolWrapper;

  var NATIVE_SYMBOL = String(NativeSymbol('description detection')) === 'Symbol(description detection)';
  var thisSymbolValue = uncurryThis(SymbolPrototype.valueOf);
  var symbolDescriptiveString = uncurryThis(SymbolPrototype.toString);
  var regexp = /^Symbol\((.*)\)[^)]+$/;
  var replace = uncurryThis(''.replace);
  var stringSlice = uncurryThis(''.slice);

  defineBuiltInAccessor(SymbolPrototype, 'description', {
    configurable: true,
    get: function description() {
      var symbol = thisSymbolValue(this);
      if (hasOwn(EmptyStringDescriptionStore, symbol)) return '';
      var string = symbolDescriptiveString(symbol);
      var desc = NATIVE_SYMBOL ? stringSlice(string, 7, -1) : replace(string, regexp, '$1');
      return desc === '' ? undefined : desc;
    }
  });

  $({ global: true, constructor: true, forced: true }, {
    Symbol: SymbolWrapper
  });
}


/***/ }),

/***/ 1510:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var getBuiltIn = __webpack_require__(7751);
var hasOwn = __webpack_require__(9297);
var toString = __webpack_require__(655);
var shared = __webpack_require__(5745);
var NATIVE_SYMBOL_REGISTRY = __webpack_require__(1296);

var StringToSymbolRegistry = shared('string-to-symbol-registry');
var SymbolToStringRegistry = shared('symbol-to-string-registry');

// `Symbol.for` method
// https://tc39.es/ecma262/#sec-symbol.for
$({ target: 'Symbol', stat: true, forced: !NATIVE_SYMBOL_REGISTRY }, {
  'for': function (key) {
    var string = toString(key);
    if (hasOwn(StringToSymbolRegistry, string)) return StringToSymbolRegistry[string];
    var symbol = getBuiltIn('Symbol')(string);
    StringToSymbolRegistry[string] = symbol;
    SymbolToStringRegistry[symbol] = string;
    return symbol;
  }
});


/***/ }),

/***/ 2259:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineWellKnownSymbol = __webpack_require__(511);

// `Symbol.iterator` well-known symbol
// https://tc39.es/ecma262/#sec-symbol.iterator
defineWellKnownSymbol('iterator');


/***/ }),

/***/ 2675:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's split to modules listed below
__webpack_require__(6761);
__webpack_require__(1510);
__webpack_require__(7812);
__webpack_require__(3110);
__webpack_require__(9773);


/***/ }),

/***/ 7812:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var hasOwn = __webpack_require__(9297);
var isSymbol = __webpack_require__(757);
var tryToString = __webpack_require__(6823);
var shared = __webpack_require__(5745);
var NATIVE_SYMBOL_REGISTRY = __webpack_require__(1296);

var SymbolToStringRegistry = shared('symbol-to-string-registry');

// `Symbol.keyFor` method
// https://tc39.es/ecma262/#sec-symbol.keyfor
$({ target: 'Symbol', stat: true, forced: !NATIVE_SYMBOL_REGISTRY }, {
  keyFor: function keyFor(sym) {
    if (!isSymbol(sym)) throw new TypeError(tryToString(sym) + ' is not a symbol');
    if (hasOwn(SymbolToStringRegistry, sym)) return SymbolToStringRegistry[sym];
  }
});


/***/ }),

/***/ 5700:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineWellKnownSymbol = __webpack_require__(511);
var defineSymbolToPrimitive = __webpack_require__(8242);

// `Symbol.toPrimitive` well-known symbol
// https://tc39.es/ecma262/#sec-symbol.toprimitive
defineWellKnownSymbol('toPrimitive');

// `Symbol.prototype[@@toPrimitive]` method
// https://tc39.es/ecma262/#sec-symbol.prototype-@@toprimitive
defineSymbolToPrimitive();


/***/ }),

/***/ 8125:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var defineWellKnownSymbol = __webpack_require__(511);
var setToStringTag = __webpack_require__(687);

// `Symbol.toStringTag` well-known symbol
// https://tc39.es/ecma262/#sec-symbol.tostringtag
defineWellKnownSymbol('toStringTag');

// `Symbol.prototype[@@toStringTag]` property
// https://tc39.es/ecma262/#sec-symbol.prototype-@@tostringtag
setToStringTag(getBuiltIn('Symbol'), 'Symbol');


/***/ }),

/***/ 8140:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var lengthOfArrayLike = __webpack_require__(6198);
var toIntegerOrInfinity = __webpack_require__(1291);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.at` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.at
exportTypedArrayMethod('at', function at(index) {
  var O = aTypedArray(this);
  var len = lengthOfArrayLike(O);
  var relativeIndex = toIntegerOrInfinity(index);
  var k = relativeIndex >= 0 ? relativeIndex : len + relativeIndex;
  return (k < 0 || k >= len) ? undefined : O[k];
});


/***/ }),

/***/ 1630:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var uncurryThis = __webpack_require__(9504);
var ArrayBufferViewCore = __webpack_require__(4644);
var $ArrayCopyWithin = __webpack_require__(7029);

var u$ArrayCopyWithin = uncurryThis($ArrayCopyWithin);
var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.copyWithin` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.copywithin
exportTypedArrayMethod('copyWithin', function copyWithin(target, start /* , end */) {
  return u$ArrayCopyWithin(aTypedArray(this), target, start, arguments.length > 2 ? arguments[2] : undefined);
});


/***/ }),

/***/ 2170:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $every = (__webpack_require__(9213).every);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.every` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.every
exportTypedArrayMethod('every', function every(callbackfn /* , thisArg */) {
  return $every(aTypedArray(this), callbackfn, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 5044:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $fill = __webpack_require__(4373);
var toBigInt = __webpack_require__(5854);
var classof = __webpack_require__(6955);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var fails = __webpack_require__(9039);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var slice = uncurryThis(''.slice);

// V8 ~ Chrome < 59, Safari < 14.1, FF < 55, Edge <=18
var CONVERSION_BUG = fails(function () {
  var count = 0;
  // eslint-disable-next-line es/no-typed-arrays -- safe
  new Int8Array(2).fill({ valueOf: function () { return count++; } });
  return count !== 1;
});

// `%TypedArray%.prototype.fill` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.fill
exportTypedArrayMethod('fill', function fill(value /* , start, end */) {
  var length = arguments.length;
  aTypedArray(this);
  var actualValue = slice(classof(this), 0, 3) === 'Big' ? toBigInt(value) : +value;
  return call($fill, this, actualValue, length > 1 ? arguments[1] : undefined, length > 2 ? arguments[2] : undefined);
}, CONVERSION_BUG);


/***/ }),

/***/ 1920:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $filter = (__webpack_require__(9213).filter);
var fromSameTypeAndList = __webpack_require__(9948);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.filter` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.filter
exportTypedArrayMethod('filter', function filter(callbackfn /* , thisArg */) {
  var list = $filter(aTypedArray(this), callbackfn, arguments.length > 1 ? arguments[1] : undefined);
  return fromSameTypeAndList(this, list);
});


/***/ }),

/***/ 9955:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $findIndex = (__webpack_require__(9213).findIndex);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.findIndex` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.findindex
exportTypedArrayMethod('findIndex', function findIndex(predicate /* , thisArg */) {
  return $findIndex(aTypedArray(this), predicate, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 1134:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $findLastIndex = (__webpack_require__(3839).findLastIndex);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.findLastIndex` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.findlastindex
exportTypedArrayMethod('findLastIndex', function findLastIndex(predicate /* , thisArg */) {
  return $findLastIndex(aTypedArray(this), predicate, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 1903:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $findLast = (__webpack_require__(3839).findLast);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.findLast` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.findlast
exportTypedArrayMethod('findLast', function findLast(predicate /* , thisArg */) {
  return $findLast(aTypedArray(this), predicate, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 1694:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $find = (__webpack_require__(9213).find);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.find` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.find
exportTypedArrayMethod('find', function find(predicate /* , thisArg */) {
  return $find(aTypedArray(this), predicate, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 4594:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var createTypedArrayConstructor = __webpack_require__(5823);

// `Float32Array` constructor
// https://tc39.es/ecma262/#sec-typedarray-objects
createTypedArrayConstructor('Float32', function (init) {
  return function Float32Array(data, byteOffset, length) {
    return init(this, data, byteOffset, length);
  };
});


/***/ }),

/***/ 9833:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var createTypedArrayConstructor = __webpack_require__(5823);

// `Float64Array` constructor
// https://tc39.es/ecma262/#sec-typedarray-objects
createTypedArrayConstructor('Float64', function (init) {
  return function Float64Array(data, byteOffset, length) {
    return init(this, data, byteOffset, length);
  };
});


/***/ }),

/***/ 3206:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $forEach = (__webpack_require__(9213).forEach);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.forEach` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.foreach
exportTypedArrayMethod('forEach', function forEach(callbackfn /* , thisArg */) {
  $forEach(aTypedArray(this), callbackfn, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 4496:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $includes = (__webpack_require__(9617).includes);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.includes` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.includes
exportTypedArrayMethod('includes', function includes(searchElement /* , fromIndex */) {
  return $includes(aTypedArray(this), searchElement, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 6651:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $indexOf = (__webpack_require__(9617).indexOf);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.indexOf` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.indexof
exportTypedArrayMethod('indexOf', function indexOf(searchElement /* , fromIndex */) {
  return $indexOf(aTypedArray(this), searchElement, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 5477:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var createTypedArrayConstructor = __webpack_require__(5823);

// `Int32Array` constructor
// https://tc39.es/ecma262/#sec-typedarray-objects
createTypedArrayConstructor('Int32', function (init) {
  return function Int32Array(data, byteOffset, length) {
    return init(this, data, byteOffset, length);
  };
});


/***/ }),

/***/ 2887:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var fails = __webpack_require__(9039);
var uncurryThis = __webpack_require__(9504);
var ArrayBufferViewCore = __webpack_require__(4644);
var ArrayIterators = __webpack_require__(3792);
var wellKnownSymbol = __webpack_require__(8227);

var ITERATOR = wellKnownSymbol('iterator');
var Uint8Array = globalThis.Uint8Array;
var arrayValues = uncurryThis(ArrayIterators.values);
var arrayKeys = uncurryThis(ArrayIterators.keys);
var arrayEntries = uncurryThis(ArrayIterators.entries);
var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var TypedArrayPrototype = Uint8Array && Uint8Array.prototype;

var GENERIC = !fails(function () {
  TypedArrayPrototype[ITERATOR].call([1]);
});

var ITERATOR_IS_VALUES = !!TypedArrayPrototype
  && TypedArrayPrototype.values
  && TypedArrayPrototype[ITERATOR] === TypedArrayPrototype.values
  && TypedArrayPrototype.values.name === 'values';

var typedArrayValues = function values() {
  return arrayValues(aTypedArray(this));
};

// `%TypedArray%.prototype.entries` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.entries
exportTypedArrayMethod('entries', function entries() {
  return arrayEntries(aTypedArray(this));
}, GENERIC);
// `%TypedArray%.prototype.keys` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.keys
exportTypedArrayMethod('keys', function keys() {
  return arrayKeys(aTypedArray(this));
}, GENERIC);
// `%TypedArray%.prototype.values` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.values
exportTypedArrayMethod('values', typedArrayValues, GENERIC || !ITERATOR_IS_VALUES, { name: 'values' });
// `%TypedArray%.prototype[@@iterator]` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype-@@iterator
exportTypedArrayMethod(ITERATOR, typedArrayValues, GENERIC || !ITERATOR_IS_VALUES, { name: 'values' });


/***/ }),

/***/ 9369:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var uncurryThis = __webpack_require__(9504);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var $join = uncurryThis([].join);

// `%TypedArray%.prototype.join` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.join
exportTypedArrayMethod('join', function join(separator) {
  return $join(aTypedArray(this), separator);
});


/***/ }),

/***/ 6812:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var apply = __webpack_require__(8745);
var $lastIndexOf = __webpack_require__(8379);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.lastIndexOf` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.lastindexof
exportTypedArrayMethod('lastIndexOf', function lastIndexOf(searchElement /* , fromIndex */) {
  var length = arguments.length;
  return apply($lastIndexOf, aTypedArray(this), length > 1 ? [searchElement, arguments[1]] : [searchElement]);
});


/***/ }),

/***/ 8995:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $map = (__webpack_require__(9213).map);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.map` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.map
exportTypedArrayMethod('map', function map(mapfn /* , thisArg */) {
  return $map(aTypedArray(this), mapfn, arguments.length > 1 ? arguments[1] : undefined, function (O, length) {
    return new (getTypedArrayConstructor(O))(length);
  });
});


/***/ }),

/***/ 6072:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $reduceRight = (__webpack_require__(926).right);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.reduceRight` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.reduceright
exportTypedArrayMethod('reduceRight', function reduceRight(callbackfn /* , initialValue */) {
  var length = arguments.length;
  return $reduceRight(aTypedArray(this), callbackfn, length, length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 1575:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $reduce = (__webpack_require__(926).left);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.reduce` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.reduce
exportTypedArrayMethod('reduce', function reduce(callbackfn /* , initialValue */) {
  var length = arguments.length;
  return $reduce(aTypedArray(this), callbackfn, length, length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 8747:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var floor = Math.floor;

// `%TypedArray%.prototype.reverse` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.reverse
exportTypedArrayMethod('reverse', function reverse() {
  var that = this;
  var length = aTypedArray(that).length;
  var middle = floor(length / 2);
  var index = 0;
  var value;
  while (index < middle) {
    value = that[index];
    that[index++] = that[--length];
    that[length] = value;
  } return that;
});


/***/ }),

/***/ 8845:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var call = __webpack_require__(9565);
var ArrayBufferViewCore = __webpack_require__(4644);
var lengthOfArrayLike = __webpack_require__(6198);
var toOffset = __webpack_require__(8229);
var toIndexedObject = __webpack_require__(8981);
var fails = __webpack_require__(9039);

var RangeError = globalThis.RangeError;
var Int8Array = globalThis.Int8Array;
var Int8ArrayPrototype = Int8Array && Int8Array.prototype;
var $set = Int8ArrayPrototype && Int8ArrayPrototype.set;
var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

var WORKS_WITH_OBJECTS_AND_GENERIC_ON_TYPED_ARRAYS = !fails(function () {
  // eslint-disable-next-line es/no-typed-arrays -- required for testing
  var array = new Uint8ClampedArray(2);
  call($set, array, { length: 1, 0: 3 }, 1);
  return array[1] !== 3;
});

// https://bugs.chromium.org/p/v8/issues/detail?id=11294 and other
var TO_OBJECT_BUG = WORKS_WITH_OBJECTS_AND_GENERIC_ON_TYPED_ARRAYS && ArrayBufferViewCore.NATIVE_ARRAY_BUFFER_VIEWS && fails(function () {
  var array = new Int8Array(2);
  array.set(1);
  array.set('2', 1);
  return array[0] !== 0 || array[1] !== 2;
});

// `%TypedArray%.prototype.set` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.set
exportTypedArrayMethod('set', function set(arrayLike /* , offset */) {
  aTypedArray(this);
  var offset = toOffset(arguments.length > 1 ? arguments[1] : undefined, 1);
  var src = toIndexedObject(arrayLike);
  if (WORKS_WITH_OBJECTS_AND_GENERIC_ON_TYPED_ARRAYS) return call($set, this, src, offset);
  var length = this.length;
  var len = lengthOfArrayLike(src);
  var index = 0;
  if (len + offset > length) throw new RangeError('Wrong length');
  while (index < len) this[offset + index] = src[index++];
}, !WORKS_WITH_OBJECTS_AND_GENERIC_ON_TYPED_ARRAYS || TO_OBJECT_BUG);


/***/ }),

/***/ 9423:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var fails = __webpack_require__(9039);
var arraySlice = __webpack_require__(7680);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

var FORCED = fails(function () {
  // eslint-disable-next-line es/no-typed-arrays -- required for testing
  new Int8Array(1).slice();
});

// `%TypedArray%.prototype.slice` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.slice
exportTypedArrayMethod('slice', function slice(start, end) {
  var list = arraySlice(aTypedArray(this), start, end);
  var C = getTypedArrayConstructor(this);
  var index = 0;
  var length = list.length;
  var result = new C(length);
  while (length > index) result[index] = list[index++];
  return result;
}, FORCED);


/***/ }),

/***/ 7301:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var $some = (__webpack_require__(9213).some);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.some` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.some
exportTypedArrayMethod('some', function some(callbackfn /* , thisArg */) {
  return $some(aTypedArray(this), callbackfn, arguments.length > 1 ? arguments[1] : undefined);
});


/***/ }),

/***/ 373:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(7476);
var fails = __webpack_require__(9039);
var aCallable = __webpack_require__(9306);
var internalSort = __webpack_require__(4488);
var ArrayBufferViewCore = __webpack_require__(4644);
var FF = __webpack_require__(3709);
var IE_OR_EDGE = __webpack_require__(3763);
var V8 = __webpack_require__(9519);
var WEBKIT = __webpack_require__(3607);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var Uint16Array = globalThis.Uint16Array;
var nativeSort = Uint16Array && uncurryThis(Uint16Array.prototype.sort);

// WebKit
var ACCEPT_INCORRECT_ARGUMENTS = !!nativeSort && !(fails(function () {
  nativeSort(new Uint16Array(2), null);
}) && fails(function () {
  nativeSort(new Uint16Array(2), {});
}));

var STABLE_SORT = !!nativeSort && !fails(function () {
  // feature detection can be too slow, so check engines versions
  if (V8) return V8 < 74;
  if (FF) return FF < 67;
  if (IE_OR_EDGE) return true;
  if (WEBKIT) return WEBKIT < 602;

  var array = new Uint16Array(516);
  var expected = Array(516);
  var index, mod;

  for (index = 0; index < 516; index++) {
    mod = index % 4;
    array[index] = 515 - index;
    expected[index] = index - 2 * mod + 3;
  }

  nativeSort(array, function (a, b) {
    return (a / 4 | 0) - (b / 4 | 0);
  });

  for (index = 0; index < 516; index++) {
    if (array[index] !== expected[index]) return true;
  }
});

var getSortCompare = function (comparefn) {
  return function (x, y) {
    if (comparefn !== undefined) return +comparefn(x, y) || 0;
    // eslint-disable-next-line no-self-compare -- NaN check
    if (y !== y) return -1;
    // eslint-disable-next-line no-self-compare -- NaN check
    if (x !== x) return 1;
    if (x === 0 && y === 0) return 1 / x > 0 && 1 / y < 0 ? 1 : -1;
    return x > y;
  };
};

// `%TypedArray%.prototype.sort` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.sort
exportTypedArrayMethod('sort', function sort(comparefn) {
  if (comparefn !== undefined) aCallable(comparefn);
  if (STABLE_SORT) return nativeSort(this, comparefn);

  return internalSort(aTypedArray(this), getSortCompare(comparefn));
}, !STABLE_SORT || ACCEPT_INCORRECT_ARGUMENTS);


/***/ }),

/***/ 6614:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var toLength = __webpack_require__(8014);
var toAbsoluteIndex = __webpack_require__(5610);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

// `%TypedArray%.prototype.subarray` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.subarray
exportTypedArrayMethod('subarray', function subarray(begin, end) {
  var O = aTypedArray(this);
  var length = O.length;
  var beginIndex = toAbsoluteIndex(begin, length);
  var C = getTypedArrayConstructor(O);
  return new C(
    O.buffer,
    O.byteOffset + beginIndex * O.BYTES_PER_ELEMENT,
    toLength((end === undefined ? length : toAbsoluteIndex(end, length)) - beginIndex)
  );
});


/***/ }),

/***/ 1405:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var apply = __webpack_require__(8745);
var ArrayBufferViewCore = __webpack_require__(4644);
var fails = __webpack_require__(9039);
var arraySlice = __webpack_require__(7680);

var Int8Array = globalThis.Int8Array;
var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var $toLocaleString = [].toLocaleString;

// iOS Safari 6.x fails here
var TO_LOCALE_STRING_BUG = !!Int8Array && fails(function () {
  $toLocaleString.call(new Int8Array(1));
});

var FORCED = fails(function () {
  return [1, 2].toLocaleString() !== new Int8Array([1, 2]).toLocaleString();
}) || !fails(function () {
  Int8Array.prototype.toLocaleString.call([1, 2]);
});

// `%TypedArray%.prototype.toLocaleString` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.tolocalestring
exportTypedArrayMethod('toLocaleString', function toLocaleString() {
  return apply(
    $toLocaleString,
    TO_LOCALE_STRING_BUG ? arraySlice(aTypedArray(this)) : aTypedArray(this),
    arraySlice(arguments)
  );
}, FORCED);


/***/ }),

/***/ 7467:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var arrayToReversed = __webpack_require__(7628);
var ArrayBufferViewCore = __webpack_require__(4644);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;

// `%TypedArray%.prototype.toReversed` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.toreversed
exportTypedArrayMethod('toReversed', function toReversed() {
  return arrayToReversed(aTypedArray(this), getTypedArrayConstructor(this));
});


/***/ }),

/***/ 4732:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var ArrayBufferViewCore = __webpack_require__(4644);
var uncurryThis = __webpack_require__(9504);
var aCallable = __webpack_require__(9306);
var arrayFromConstructorAndList = __webpack_require__(5370);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;
var sort = uncurryThis(ArrayBufferViewCore.TypedArrayPrototype.sort);

// `%TypedArray%.prototype.toSorted` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.tosorted
exportTypedArrayMethod('toSorted', function toSorted(compareFn) {
  if (compareFn !== undefined) aCallable(compareFn);
  var O = aTypedArray(this);
  var A = arrayFromConstructorAndList(getTypedArrayConstructor(O), O);
  return sort(A, compareFn);
});


/***/ }),

/***/ 3684:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var exportTypedArrayMethod = (__webpack_require__(4644).exportTypedArrayMethod);
var fails = __webpack_require__(9039);
var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);

var Uint8Array = globalThis.Uint8Array;
var Uint8ArrayPrototype = Uint8Array && Uint8Array.prototype || {};
var arrayToString = [].toString;
var join = uncurryThis([].join);

if (fails(function () { arrayToString.call({}); })) {
  arrayToString = function toString() {
    return join(this);
  };
}

var IS_NOT_ARRAY_METHOD = Uint8ArrayPrototype.toString !== arrayToString;

// `%TypedArray%.prototype.toString` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.tostring
exportTypedArrayMethod('toString', arrayToString, IS_NOT_ARRAY_METHOD);


/***/ }),

/***/ 1740:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var createTypedArrayConstructor = __webpack_require__(5823);

// `Uint32Array` constructor
// https://tc39.es/ecma262/#sec-typedarray-objects
createTypedArrayConstructor('Uint32', function (init) {
  return function Uint32Array(data, byteOffset, length) {
    return init(this, data, byteOffset, length);
  };
});


/***/ }),

/***/ 1489:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var createTypedArrayConstructor = __webpack_require__(5823);

// `Uint8Array` constructor
// https://tc39.es/ecma262/#sec-typedarray-objects
createTypedArrayConstructor('Uint8', function (init) {
  return function Uint8Array(data, byteOffset, length) {
    return init(this, data, byteOffset, length);
  };
});


/***/ }),

/***/ 9577:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var arrayWith = __webpack_require__(9928);
var ArrayBufferViewCore = __webpack_require__(4644);
var isBigIntArray = __webpack_require__(1108);
var toIntegerOrInfinity = __webpack_require__(1291);
var toBigInt = __webpack_require__(5854);

var aTypedArray = ArrayBufferViewCore.aTypedArray;
var getTypedArrayConstructor = ArrayBufferViewCore.getTypedArrayConstructor;
var exportTypedArrayMethod = ArrayBufferViewCore.exportTypedArrayMethod;

var PROPER_ORDER = !!function () {
  try {
    // eslint-disable-next-line no-throw-literal, es/no-typed-arrays, es/no-array-prototype-with -- required for testing
    new Int8Array(1)['with'](2, { valueOf: function () { throw 8; } });
  } catch (error) {
    // some early implementations, like WebKit, does not follow the final semantic
    // https://github.com/tc39/proposal-change-array-by-copy/pull/86
    return error === 8;
  }
}();

// `%TypedArray%.prototype.with` method
// https://tc39.es/ecma262/#sec-%typedarray%.prototype.with
exportTypedArrayMethod('with', { 'with': function (index, value) {
  var O = aTypedArray(this);
  var relativeIndex = toIntegerOrInfinity(index);
  var actualValue = isBigIntArray(O) ? toBigInt(value) : +value;
  return arrayWith(O, getTypedArrayConstructor(O), relativeIndex, actualValue);
} }['with'], !PROPER_ORDER);


/***/ }),

/***/ 5746:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var FREEZING = __webpack_require__(2744);
var globalThis = __webpack_require__(4576);
var uncurryThis = __webpack_require__(9504);
var defineBuiltIns = __webpack_require__(6279);
var InternalMetadataModule = __webpack_require__(3451);
var collection = __webpack_require__(6468);
var collectionWeak = __webpack_require__(4006);
var isObject = __webpack_require__(34);
var enforceInternalState = (__webpack_require__(1181).enforce);
var fails = __webpack_require__(9039);
var NATIVE_WEAK_MAP = __webpack_require__(8622);

var $Object = Object;
// eslint-disable-next-line es/no-array-isarray -- safe
var isArray = Array.isArray;
// eslint-disable-next-line es/no-object-isextensible -- safe
var isExtensible = $Object.isExtensible;
// eslint-disable-next-line es/no-object-isfrozen -- safe
var isFrozen = $Object.isFrozen;
// eslint-disable-next-line es/no-object-issealed -- safe
var isSealed = $Object.isSealed;
// eslint-disable-next-line es/no-object-freeze -- safe
var freeze = $Object.freeze;
// eslint-disable-next-line es/no-object-seal -- safe
var seal = $Object.seal;

var IS_IE11 = !globalThis.ActiveXObject && 'ActiveXObject' in globalThis;
var InternalWeakMap;

var wrapper = function (init) {
  return function WeakMap() {
    return init(this, arguments.length ? arguments[0] : undefined);
  };
};

// `WeakMap` constructor
// https://tc39.es/ecma262/#sec-weakmap-constructor
var $WeakMap = collection('WeakMap', wrapper, collectionWeak);
var WeakMapPrototype = $WeakMap.prototype;
var nativeSet = uncurryThis(WeakMapPrototype.set);

// Chakra Edge bug: adding frozen arrays to WeakMap unfreeze them
var hasMSEdgeFreezingBug = function () {
  return FREEZING && fails(function () {
    var frozenArray = freeze([]);
    nativeSet(new $WeakMap(), frozenArray, 1);
    return !isFrozen(frozenArray);
  });
};

// IE11 WeakMap frozen keys fix
// We can't use feature detection because it crash some old IE builds
// https://github.com/zloirock/core-js/issues/485
if (NATIVE_WEAK_MAP) if (IS_IE11) {
  InternalWeakMap = collectionWeak.getConstructor(wrapper, 'WeakMap', true);
  InternalMetadataModule.enable();
  var nativeDelete = uncurryThis(WeakMapPrototype['delete']);
  var nativeHas = uncurryThis(WeakMapPrototype.has);
  var nativeGet = uncurryThis(WeakMapPrototype.get);
  defineBuiltIns(WeakMapPrototype, {
    'delete': function (key) {
      if (isObject(key) && !isExtensible(key)) {
        var state = enforceInternalState(this);
        if (!state.frozen) state.frozen = new InternalWeakMap();
        return nativeDelete(this, key) || state.frozen['delete'](key);
      } return nativeDelete(this, key);
    },
    has: function has(key) {
      if (isObject(key) && !isExtensible(key)) {
        var state = enforceInternalState(this);
        if (!state.frozen) state.frozen = new InternalWeakMap();
        return nativeHas(this, key) || state.frozen.has(key);
      } return nativeHas(this, key);
    },
    get: function get(key) {
      if (isObject(key) && !isExtensible(key)) {
        var state = enforceInternalState(this);
        if (!state.frozen) state.frozen = new InternalWeakMap();
        return nativeHas(this, key) ? nativeGet(this, key) : state.frozen.get(key);
      } return nativeGet(this, key);
    },
    set: function set(key, value) {
      if (isObject(key) && !isExtensible(key)) {
        var state = enforceInternalState(this);
        if (!state.frozen) state.frozen = new InternalWeakMap();
        nativeHas(this, key) ? nativeSet(this, key, value) : state.frozen.set(key, value);
      } else nativeSet(this, key, value);
      return this;
    }
  });
// Chakra Edge frozen keys fix
} else if (hasMSEdgeFreezingBug()) {
  defineBuiltIns(WeakMapPrototype, {
    set: function set(key, value) {
      var arrayIntegrityLevel;
      if (isArray(key)) {
        if (isFrozen(key)) arrayIntegrityLevel = freeze;
        else if (isSealed(key)) arrayIntegrityLevel = seal;
      }
      nativeSet(this, key, value);
      if (arrayIntegrityLevel) arrayIntegrityLevel(key);
      return this;
    }
  });
}


/***/ }),

/***/ 3772:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(5746);


/***/ }),

/***/ 5240:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var collection = __webpack_require__(6468);
var collectionWeak = __webpack_require__(4006);

// `WeakSet` constructor
// https://tc39.es/ecma262/#sec-weakset-constructor
collection('WeakSet', function (init) {
  return function WeakSet() { return init(this, arguments.length ? arguments[0] : undefined); };
}, collectionWeak);


/***/ }),

/***/ 958:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(5240);


/***/ }),

/***/ 8992:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(8111);


/***/ }),

/***/ 7124:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(9314);


/***/ }),

/***/ 3215:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(1148);


/***/ }),

/***/ 4520:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(2489);


/***/ }),

/***/ 670:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(531);


/***/ }),

/***/ 3949:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(7588);


/***/ }),

/***/ 1454:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(1701);


/***/ }),

/***/ 7550:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(3579);


/***/ }),

/***/ 8335:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var DESCRIPTORS = __webpack_require__(3724);
var globalThis = __webpack_require__(4576);
var getBuiltIn = __webpack_require__(7751);
var uncurryThis = __webpack_require__(9504);
var call = __webpack_require__(9565);
var isCallable = __webpack_require__(4901);
var isObject = __webpack_require__(34);
var isArray = __webpack_require__(4376);
var hasOwn = __webpack_require__(9297);
var toString = __webpack_require__(655);
var lengthOfArrayLike = __webpack_require__(6198);
var createProperty = __webpack_require__(2278);
var fails = __webpack_require__(9039);
var parseJSONString = __webpack_require__(8235);
var NATIVE_SYMBOL = __webpack_require__(4495);

var JSON = globalThis.JSON;
var Number = globalThis.Number;
var SyntaxError = globalThis.SyntaxError;
var nativeParse = JSON && JSON.parse;
var enumerableOwnProperties = getBuiltIn('Object', 'keys');
// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var at = uncurryThis(''.charAt);
var slice = uncurryThis(''.slice);
var exec = uncurryThis(/./.exec);
var push = uncurryThis([].push);

var IS_DIGIT = /^\d$/;
var IS_NON_ZERO_DIGIT = /^[1-9]$/;
var IS_NUMBER_START = /^[\d-]$/;
var IS_WHITESPACE = /^[\t\n\r ]$/;

var PRIMITIVE = 0;
var OBJECT = 1;

var $parse = function (source, reviver) {
  source = toString(source);
  var context = new Context(source, 0, '');
  var root = context.parse();
  var value = root.value;
  var endIndex = context.skip(IS_WHITESPACE, root.end);
  if (endIndex < source.length) {
    throw new SyntaxError('Unexpected extra character: "' + at(source, endIndex) + '" after the parsed data at: ' + endIndex);
  }
  return isCallable(reviver) ? internalize({ '': value }, '', reviver, root) : value;
};

var internalize = function (holder, name, reviver, node) {
  var val = holder[name];
  var unmodified = node && val === node.value;
  var context = unmodified && typeof node.source == 'string' ? { source: node.source } : {};
  var elementRecordsLen, keys, len, i, P;
  if (isObject(val)) {
    var nodeIsArray = isArray(val);
    var nodes = unmodified ? node.nodes : nodeIsArray ? [] : {};
    if (nodeIsArray) {
      elementRecordsLen = nodes.length;
      len = lengthOfArrayLike(val);
      for (i = 0; i < len; i++) {
        internalizeProperty(val, i, internalize(val, '' + i, reviver, i < elementRecordsLen ? nodes[i] : undefined));
      }
    } else {
      keys = enumerableOwnProperties(val);
      len = lengthOfArrayLike(keys);
      for (i = 0; i < len; i++) {
        P = keys[i];
        internalizeProperty(val, P, internalize(val, P, reviver, hasOwn(nodes, P) ? nodes[P] : undefined));
      }
    }
  }
  return call(reviver, holder, name, val, context);
};

var internalizeProperty = function (object, key, value) {
  if (DESCRIPTORS) {
    var descriptor = getOwnPropertyDescriptor(object, key);
    if (descriptor && !descriptor.configurable) return;
  }
  if (value === undefined) delete object[key];
  else createProperty(object, key, value);
};

var Node = function (value, end, source, nodes) {
  this.value = value;
  this.end = end;
  this.source = source;
  this.nodes = nodes;
};

var Context = function (source, index) {
  this.source = source;
  this.index = index;
};

// https://www.json.org/json-en.html
Context.prototype = {
  fork: function (nextIndex) {
    return new Context(this.source, nextIndex);
  },
  parse: function () {
    var source = this.source;
    var i = this.skip(IS_WHITESPACE, this.index);
    var fork = this.fork(i);
    var chr = at(source, i);
    if (exec(IS_NUMBER_START, chr)) return fork.number();
    switch (chr) {
      case '{':
        return fork.object();
      case '[':
        return fork.array();
      case '"':
        return fork.string();
      case 't':
        return fork.keyword(true);
      case 'f':
        return fork.keyword(false);
      case 'n':
        return fork.keyword(null);
    } throw new SyntaxError('Unexpected character: "' + chr + '" at: ' + i);
  },
  node: function (type, value, start, end, nodes) {
    return new Node(value, end, type ? null : slice(this.source, start, end), nodes);
  },
  object: function () {
    var source = this.source;
    var i = this.index + 1;
    var expectKeypair = false;
    var object = {};
    var nodes = {};
    while (i < source.length) {
      i = this.until(['"', '}'], i);
      if (at(source, i) === '}' && !expectKeypair) {
        i++;
        break;
      }
      // Parsing the key
      var result = this.fork(i).string();
      var key = result.value;
      i = result.end;
      i = this.until([':'], i) + 1;
      // Parsing value
      i = this.skip(IS_WHITESPACE, i);
      result = this.fork(i).parse();
      createProperty(nodes, key, result);
      createProperty(object, key, result.value);
      i = this.until([',', '}'], result.end);
      var chr = at(source, i);
      if (chr === ',') {
        expectKeypair = true;
        i++;
      } else if (chr === '}') {
        i++;
        break;
      }
    }
    return this.node(OBJECT, object, this.index, i, nodes);
  },
  array: function () {
    var source = this.source;
    var i = this.index + 1;
    var expectElement = false;
    var array = [];
    var nodes = [];
    while (i < source.length) {
      i = this.skip(IS_WHITESPACE, i);
      if (at(source, i) === ']' && !expectElement) {
        i++;
        break;
      }
      var result = this.fork(i).parse();
      push(nodes, result);
      push(array, result.value);
      i = this.until([',', ']'], result.end);
      if (at(source, i) === ',') {
        expectElement = true;
        i++;
      } else if (at(source, i) === ']') {
        i++;
        break;
      }
    }
    return this.node(OBJECT, array, this.index, i, nodes);
  },
  string: function () {
    var index = this.index;
    var parsed = parseJSONString(this.source, this.index + 1);
    return this.node(PRIMITIVE, parsed.value, index, parsed.end);
  },
  number: function () {
    var source = this.source;
    var startIndex = this.index;
    var i = startIndex;
    if (at(source, i) === '-') i++;
    if (at(source, i) === '0') i++;
    else if (exec(IS_NON_ZERO_DIGIT, at(source, i))) i = this.skip(IS_DIGIT, i + 1);
    else throw new SyntaxError('Failed to parse number at: ' + i);
    if (at(source, i) === '.') i = this.skip(IS_DIGIT, i + 1);
    if (at(source, i) === 'e' || at(source, i) === 'E') {
      i++;
      if (at(source, i) === '+' || at(source, i) === '-') i++;
      var exponentStartIndex = i;
      i = this.skip(IS_DIGIT, i);
      if (exponentStartIndex === i) throw new SyntaxError("Failed to parse number's exponent value at: " + i);
    }
    return this.node(PRIMITIVE, Number(slice(source, startIndex, i)), startIndex, i);
  },
  keyword: function (value) {
    var keyword = '' + value;
    var index = this.index;
    var endIndex = index + keyword.length;
    if (slice(this.source, index, endIndex) !== keyword) throw new SyntaxError('Failed to parse value at: ' + index);
    return this.node(PRIMITIVE, value, index, endIndex);
  },
  skip: function (regex, i) {
    var source = this.source;
    for (; i < source.length; i++) if (!exec(regex, at(source, i))) break;
    return i;
  },
  until: function (array, i) {
    i = this.skip(IS_WHITESPACE, i);
    var chr = at(this.source, i);
    for (var j = 0; j < array.length; j++) if (array[j] === chr) return i;
    throw new SyntaxError('Unexpected character: "' + chr + '" at: ' + i);
  }
};

var NO_SOURCE_SUPPORT = fails(function () {
  var unsafeInt = '9007199254740993';
  var source;
  nativeParse(unsafeInt, function (key, value, context) {
    source = context.source;
  });
  return source !== unsafeInt;
});

var PROPER_BASE_PARSE = NATIVE_SYMBOL && !fails(function () {
  // Safari 9 bug
  return 1 / nativeParse('-0 \t') !== -Infinity;
});

// `JSON.parse` method
// https://tc39.es/ecma262/#sec-json.parse
// https://github.com/tc39/proposal-json-parse-with-source
$({ target: 'JSON', stat: true, forced: NO_SOURCE_SUPPORT }, {
  parse: function parse(text, reviver) {
    return PROPER_BASE_PARSE && !isCallable(reviver) ? nativeParse(text) : $parse(text, reviver);
  }
});


/***/ }),

/***/ 5247:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove from `core-js@4`
__webpack_require__(1689);


/***/ }),

/***/ 2945:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var getBuiltIn = __webpack_require__(7751);
var uncurryThis = __webpack_require__(9504);
var call = __webpack_require__(9565);
var fails = __webpack_require__(9039);
var toString = __webpack_require__(655);
var validateArgumentsLength = __webpack_require__(2812);
var c2i = (__webpack_require__(2804).c2i);

var disallowed = /[^\d+/a-z]/i;
var whitespaces = /[\t\n\f\r ]+/g;
var finalEq = /[=]{1,2}$/;

var $atob = getBuiltIn('atob');
var fromCharCode = String.fromCharCode;
var charAt = uncurryThis(''.charAt);
var replace = uncurryThis(''.replace);
var exec = uncurryThis(disallowed.exec);

var BASIC = !!$atob && !fails(function () {
  return $atob('aGk=') !== 'hi';
});

var NO_SPACES_IGNORE = BASIC && fails(function () {
  return $atob(' ') !== '';
});

var NO_ENCODING_CHECK = BASIC && !fails(function () {
  $atob('a');
});

var NO_ARG_RECEIVING_CHECK = BASIC && !fails(function () {
  $atob();
});

var WRONG_ARITY = BASIC && $atob.length !== 1;

var FORCED = !BASIC || NO_SPACES_IGNORE || NO_ENCODING_CHECK || NO_ARG_RECEIVING_CHECK || WRONG_ARITY;

// `atob` method
// https://html.spec.whatwg.org/multipage/webappapis.html#dom-atob
$({ global: true, bind: true, enumerable: true, forced: FORCED }, {
  atob: function atob(data) {
    validateArgumentsLength(arguments.length, 1);
    // `webpack` dev server bug on IE global methods - use call(fn, global, ...)
    if (BASIC && !NO_SPACES_IGNORE && !NO_ENCODING_CHECK) return call($atob, globalThis, data);
    var string = replace(toString(data), whitespaces, '');
    var output = '';
    var position = 0;
    var bc = 0;
    var length, chr, bs;
    if (string.length % 4 === 0) {
      string = replace(string, finalEq, '');
    }
    length = string.length;
    if (length % 4 === 1 || exec(disallowed, string)) {
      throw new (getBuiltIn('DOMException'))('The string is not correctly encoded', 'InvalidCharacterError');
    }
    while (position < length) {
      chr = charAt(string, position++);
      bs = bc % 4 ? bs * 64 + c2i[chr] : c2i[chr];
      if (bc++ % 4) output += fromCharCode(255 & bs >> (-2 * bc & 6));
    } return output;
  }
});


/***/ }),

/***/ 3500:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var DOMIterables = __webpack_require__(7400);
var DOMTokenListPrototype = __webpack_require__(9296);
var forEach = __webpack_require__(235);
var createNonEnumerableProperty = __webpack_require__(6699);

var handlePrototype = function (CollectionPrototype) {
  // some Chrome versions have non-configurable methods on DOMTokenList
  if (CollectionPrototype && CollectionPrototype.forEach !== forEach) try {
    createNonEnumerableProperty(CollectionPrototype, 'forEach', forEach);
  } catch (error) {
    CollectionPrototype.forEach = forEach;
  }
};

for (var COLLECTION_NAME in DOMIterables) {
  if (DOMIterables[COLLECTION_NAME]) {
    handlePrototype(globalThis[COLLECTION_NAME] && globalThis[COLLECTION_NAME].prototype);
  }
}

handlePrototype(DOMTokenListPrototype);


/***/ }),

/***/ 2953:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var globalThis = __webpack_require__(4576);
var DOMIterables = __webpack_require__(7400);
var DOMTokenListPrototype = __webpack_require__(9296);
var ArrayIteratorMethods = __webpack_require__(3792);
var createNonEnumerableProperty = __webpack_require__(6699);
var setToStringTag = __webpack_require__(687);
var wellKnownSymbol = __webpack_require__(8227);

var ITERATOR = wellKnownSymbol('iterator');
var ArrayValues = ArrayIteratorMethods.values;

var handlePrototype = function (CollectionPrototype, COLLECTION_NAME) {
  if (CollectionPrototype) {
    // some Chrome versions have non-configurable methods on DOMTokenList
    if (CollectionPrototype[ITERATOR] !== ArrayValues) try {
      createNonEnumerableProperty(CollectionPrototype, ITERATOR, ArrayValues);
    } catch (error) {
      CollectionPrototype[ITERATOR] = ArrayValues;
    }
    setToStringTag(CollectionPrototype, COLLECTION_NAME, true);
    if (DOMIterables[COLLECTION_NAME]) for (var METHOD_NAME in ArrayIteratorMethods) {
      // some Chrome versions have non-configurable methods on DOMTokenList
      if (CollectionPrototype[METHOD_NAME] !== ArrayIteratorMethods[METHOD_NAME]) try {
        createNonEnumerableProperty(CollectionPrototype, METHOD_NAME, ArrayIteratorMethods[METHOD_NAME]);
      } catch (error) {
        CollectionPrototype[METHOD_NAME] = ArrayIteratorMethods[METHOD_NAME];
      }
    }
  }
};

for (var COLLECTION_NAME in DOMIterables) {
  handlePrototype(globalThis[COLLECTION_NAME] && globalThis[COLLECTION_NAME].prototype, COLLECTION_NAME);
}

handlePrototype(DOMTokenListPrototype, 'DOMTokenList');


/***/ }),

/***/ 5815:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var getBuiltIn = __webpack_require__(7751);
var getBuiltInNodeModule = __webpack_require__(9429);
var fails = __webpack_require__(9039);
var create = __webpack_require__(2360);
var createPropertyDescriptor = __webpack_require__(6980);
var defineProperty = (__webpack_require__(4913).f);
var defineBuiltIn = __webpack_require__(6840);
var defineBuiltInAccessor = __webpack_require__(2106);
var hasOwn = __webpack_require__(9297);
var anInstance = __webpack_require__(679);
var anObject = __webpack_require__(8551);
var errorToString = __webpack_require__(7536);
var normalizeStringArgument = __webpack_require__(2603);
var DOMExceptionConstants = __webpack_require__(5002);
var clearErrorStack = __webpack_require__(6193);
var InternalStateModule = __webpack_require__(1181);
var DESCRIPTORS = __webpack_require__(3724);
var IS_PURE = __webpack_require__(6395);

var DOM_EXCEPTION = 'DOMException';
var DATA_CLONE_ERR = 'DATA_CLONE_ERR';
var Error = getBuiltIn('Error');
// NodeJS < 17.0 does not expose `DOMException` to global
var NativeDOMException = getBuiltIn(DOM_EXCEPTION) || (function () {
  try {
    // NodeJS < 15.0 does not expose `MessageChannel` to global
    var MessageChannel = getBuiltIn('MessageChannel') || getBuiltInNodeModule('worker_threads').MessageChannel;
    // eslint-disable-next-line es/no-weak-map, unicorn/require-post-message-target-origin -- safe
    new MessageChannel().port1.postMessage(new WeakMap());
  } catch (error) {
    if (error.name === DATA_CLONE_ERR && error.code === 25) return error.constructor;
  }
})();
var NativeDOMExceptionPrototype = NativeDOMException && NativeDOMException.prototype;
var ErrorPrototype = Error.prototype;
var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(DOM_EXCEPTION);
var HAS_STACK = 'stack' in new Error(DOM_EXCEPTION);

var codeFor = function (name) {
  return hasOwn(DOMExceptionConstants, name) && DOMExceptionConstants[name].m ? DOMExceptionConstants[name].c : 0;
};

var $DOMException = function DOMException() {
  anInstance(this, DOMExceptionPrototype);
  var argumentsLength = arguments.length;
  var message = normalizeStringArgument(argumentsLength < 1 ? undefined : arguments[0]);
  var name = normalizeStringArgument(argumentsLength < 2 ? undefined : arguments[1], 'Error');
  var code = codeFor(name);
  setInternalState(this, {
    type: DOM_EXCEPTION,
    name: name,
    message: message,
    code: code
  });
  if (!DESCRIPTORS) {
    this.name = name;
    this.message = message;
    this.code = code;
  }
  if (HAS_STACK) {
    var error = new Error(message);
    error.name = DOM_EXCEPTION;
    defineProperty(this, 'stack', createPropertyDescriptor(1, clearErrorStack(error.stack, 1)));
  }
};

var DOMExceptionPrototype = $DOMException.prototype = create(ErrorPrototype);

var createGetterDescriptor = function (get) {
  return { enumerable: true, configurable: true, get: get };
};

var getterFor = function (key) {
  return createGetterDescriptor(function () {
    return getInternalState(this)[key];
  });
};

if (DESCRIPTORS) {
  // `DOMException.prototype.code` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'code', getterFor('code'));
  // `DOMException.prototype.message` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'message', getterFor('message'));
  // `DOMException.prototype.name` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'name', getterFor('name'));
}

defineProperty(DOMExceptionPrototype, 'constructor', createPropertyDescriptor(1, $DOMException));

// FF36- DOMException is a function, but can't be constructed
var INCORRECT_CONSTRUCTOR = fails(function () {
  return !(new NativeDOMException() instanceof Error);
});

// Safari 10.1 / Chrome 32- / IE8- DOMException.prototype.toString bugs
var INCORRECT_TO_STRING = INCORRECT_CONSTRUCTOR || fails(function () {
  return ErrorPrototype.toString !== errorToString || String(new NativeDOMException(1, 2)) !== '2: 1';
});

// Deno 1.6.3- DOMException.prototype.code just missed
var INCORRECT_CODE = INCORRECT_CONSTRUCTOR || fails(function () {
  return new NativeDOMException(1, 'DataCloneError').code !== 25;
});

// Deno 1.6.3- DOMException constants just missed
var MISSED_CONSTANTS = INCORRECT_CONSTRUCTOR
  || NativeDOMException[DATA_CLONE_ERR] !== 25
  || NativeDOMExceptionPrototype[DATA_CLONE_ERR] !== 25;

var FORCED_CONSTRUCTOR = IS_PURE ? INCORRECT_TO_STRING || INCORRECT_CODE || MISSED_CONSTANTS : INCORRECT_CONSTRUCTOR;

// `DOMException` constructor
// https://webidl.spec.whatwg.org/#idl-DOMException
$({ global: true, constructor: true, forced: FORCED_CONSTRUCTOR }, {
  DOMException: FORCED_CONSTRUCTOR ? $DOMException : NativeDOMException
});

var PolyfilledDOMException = getBuiltIn(DOM_EXCEPTION);
var PolyfilledDOMExceptionPrototype = PolyfilledDOMException.prototype;

if (INCORRECT_TO_STRING && (IS_PURE || NativeDOMException === PolyfilledDOMException)) {
  defineBuiltIn(PolyfilledDOMExceptionPrototype, 'toString', errorToString);
}

if (INCORRECT_CODE && DESCRIPTORS && NativeDOMException === PolyfilledDOMException) {
  defineBuiltInAccessor(PolyfilledDOMExceptionPrototype, 'code', createGetterDescriptor(function () {
    return codeFor(anObject(this).name);
  }));
}

// `DOMException` constants
for (var key in DOMExceptionConstants) if (hasOwn(DOMExceptionConstants, key)) {
  var constant = DOMExceptionConstants[key];
  var constantName = constant.s;
  var descriptor = createPropertyDescriptor(6, constant.c);
  if (!hasOwn(PolyfilledDOMException, constantName)) {
    defineProperty(PolyfilledDOMException, constantName, descriptor);
  }
  if (!hasOwn(PolyfilledDOMExceptionPrototype, constantName)) {
    defineProperty(PolyfilledDOMExceptionPrototype, constantName, descriptor);
  }
}


/***/ }),

/***/ 4979:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var getBuiltIn = __webpack_require__(7751);
var createPropertyDescriptor = __webpack_require__(6980);
var defineProperty = (__webpack_require__(4913).f);
var hasOwn = __webpack_require__(9297);
var anInstance = __webpack_require__(679);
var inheritIfRequired = __webpack_require__(3167);
var normalizeStringArgument = __webpack_require__(2603);
var DOMExceptionConstants = __webpack_require__(5002);
var clearErrorStack = __webpack_require__(6193);
var DESCRIPTORS = __webpack_require__(3724);
var IS_PURE = __webpack_require__(6395);

var DOM_EXCEPTION = 'DOMException';
var Error = getBuiltIn('Error');
var NativeDOMException = getBuiltIn(DOM_EXCEPTION);

var $DOMException = function DOMException() {
  anInstance(this, DOMExceptionPrototype);
  var argumentsLength = arguments.length;
  var message = normalizeStringArgument(argumentsLength < 1 ? undefined : arguments[0]);
  var name = normalizeStringArgument(argumentsLength < 2 ? undefined : arguments[1], 'Error');
  var that = new NativeDOMException(message, name);
  var error = new Error(message);
  error.name = DOM_EXCEPTION;
  defineProperty(that, 'stack', createPropertyDescriptor(1, clearErrorStack(error.stack, 1)));
  inheritIfRequired(that, this, $DOMException);
  return that;
};

var DOMExceptionPrototype = $DOMException.prototype = NativeDOMException.prototype;

var ERROR_HAS_STACK = 'stack' in new Error(DOM_EXCEPTION);
var DOM_EXCEPTION_HAS_STACK = 'stack' in new NativeDOMException(1, 2);

// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var descriptor = NativeDOMException && DESCRIPTORS && Object.getOwnPropertyDescriptor(globalThis, DOM_EXCEPTION);

// Bun ~ 0.1.1 DOMException have incorrect descriptor and we can't redefine it
// https://github.com/Jarred-Sumner/bun/issues/399
var BUGGY_DESCRIPTOR = !!descriptor && !(descriptor.writable && descriptor.configurable);

var FORCED_CONSTRUCTOR = ERROR_HAS_STACK && !BUGGY_DESCRIPTOR && !DOM_EXCEPTION_HAS_STACK;

// `DOMException` constructor patch for `.stack` where it's required
// https://webidl.spec.whatwg.org/#es-DOMException-specialness
$({ global: true, constructor: true, forced: IS_PURE || FORCED_CONSTRUCTOR }, { // TODO: fix export logic
  DOMException: FORCED_CONSTRUCTOR ? $DOMException : NativeDOMException
});

var PolyfilledDOMException = getBuiltIn(DOM_EXCEPTION);
var PolyfilledDOMExceptionPrototype = PolyfilledDOMException.prototype;

if (PolyfilledDOMExceptionPrototype.constructor !== PolyfilledDOMException) {
  if (!IS_PURE) {
    defineProperty(PolyfilledDOMExceptionPrototype, 'constructor', createPropertyDescriptor(1, PolyfilledDOMException));
  }

  for (var key in DOMExceptionConstants) if (hasOwn(DOMExceptionConstants, key)) {
    var constant = DOMExceptionConstants[key];
    var constantName = constant.s;
    if (!hasOwn(PolyfilledDOMException, constantName)) {
      defineProperty(PolyfilledDOMException, constantName, createPropertyDescriptor(6, constant.c));
    }
  }
}


/***/ }),

/***/ 9739:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var getBuiltIn = __webpack_require__(7751);
var setToStringTag = __webpack_require__(687);

var DOM_EXCEPTION = 'DOMException';

// `DOMException.prototype[@@toStringTag]` property
setToStringTag(getBuiltIn(DOM_EXCEPTION), DOM_EXCEPTION);


/***/ }),

/***/ 8406:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {


// TODO: in core-js@4, move /modules/ dependencies to public entries for better optimization by tools like `preset-env`
__webpack_require__(3792);
__webpack_require__(7337);
var $ = __webpack_require__(6518);
var globalThis = __webpack_require__(4576);
var safeGetBuiltIn = __webpack_require__(3389);
var getBuiltIn = __webpack_require__(7751);
var call = __webpack_require__(9565);
var uncurryThis = __webpack_require__(9504);
var DESCRIPTORS = __webpack_require__(3724);
var USE_NATIVE_URL = __webpack_require__(7416);
var defineBuiltIn = __webpack_require__(6840);
var defineBuiltInAccessor = __webpack_require__(2106);
var defineBuiltIns = __webpack_require__(6279);
var setToStringTag = __webpack_require__(687);
var createIteratorConstructor = __webpack_require__(3994);
var InternalStateModule = __webpack_require__(1181);
var anInstance = __webpack_require__(679);
var isCallable = __webpack_require__(4901);
var hasOwn = __webpack_require__(9297);
var bind = __webpack_require__(6080);
var classof = __webpack_require__(6955);
var anObject = __webpack_require__(8551);
var isObject = __webpack_require__(34);
var $toString = __webpack_require__(655);
var create = __webpack_require__(2360);
var createPropertyDescriptor = __webpack_require__(6980);
var getIterator = __webpack_require__(81);
var getIteratorMethod = __webpack_require__(851);
var createIterResultObject = __webpack_require__(2529);
var validateArgumentsLength = __webpack_require__(2812);
var wellKnownSymbol = __webpack_require__(8227);
var arraySort = __webpack_require__(4488);

var ITERATOR = wellKnownSymbol('iterator');
var URL_SEARCH_PARAMS = 'URLSearchParams';
var URL_SEARCH_PARAMS_ITERATOR = URL_SEARCH_PARAMS + 'Iterator';
var setInternalState = InternalStateModule.set;
var getInternalParamsState = InternalStateModule.getterFor(URL_SEARCH_PARAMS);
var getInternalIteratorState = InternalStateModule.getterFor(URL_SEARCH_PARAMS_ITERATOR);

var nativeFetch = safeGetBuiltIn('fetch');
var NativeRequest = safeGetBuiltIn('Request');
var Headers = safeGetBuiltIn('Headers');
var RequestPrototype = NativeRequest && NativeRequest.prototype;
var HeadersPrototype = Headers && Headers.prototype;
var TypeError = globalThis.TypeError;
var encodeURIComponent = globalThis.encodeURIComponent;
var fromCharCode = String.fromCharCode;
var fromCodePoint = getBuiltIn('String', 'fromCodePoint');
var $parseInt = parseInt;
var charAt = uncurryThis(''.charAt);
var join = uncurryThis([].join);
var push = uncurryThis([].push);
var replace = uncurryThis(''.replace);
var shift = uncurryThis([].shift);
var splice = uncurryThis([].splice);
var split = uncurryThis(''.split);
var stringSlice = uncurryThis(''.slice);
var exec = uncurryThis(/./.exec);

var plus = /\+/g;
var FALLBACK_REPLACER = '\uFFFD';
var VALID_HEX = /^[0-9a-f]+$/i;

var parseHexOctet = function (string, start) {
  var substr = stringSlice(string, start, start + 2);
  if (!exec(VALID_HEX, substr)) return NaN;

  return $parseInt(substr, 16);
};

var getLeadingOnes = function (octet) {
  var count = 0;
  for (var mask = 0x80; mask > 0 && (octet & mask) !== 0; mask >>= 1) {
    count++;
  }
  return count;
};

var utf8Decode = function (octets) {
  var codePoint = null;

  switch (octets.length) {
    case 1:
      codePoint = octets[0];
      break;
    case 2:
      codePoint = (octets[0] & 0x1F) << 6 | (octets[1] & 0x3F);
      break;
    case 3:
      codePoint = (octets[0] & 0x0F) << 12 | (octets[1] & 0x3F) << 6 | (octets[2] & 0x3F);
      break;
    case 4:
      codePoint = (octets[0] & 0x07) << 18 | (octets[1] & 0x3F) << 12 | (octets[2] & 0x3F) << 6 | (octets[3] & 0x3F);
      break;
  }

  return codePoint > 0x10FFFF ? null : codePoint;
};

var decode = function (input) {
  input = replace(input, plus, ' ');
  var length = input.length;
  var result = '';
  var i = 0;

  while (i < length) {
    var decodedChar = charAt(input, i);

    if (decodedChar === '%') {
      if (charAt(input, i + 1) === '%' || i + 3 > length) {
        result += '%';
        i++;
        continue;
      }

      var octet = parseHexOctet(input, i + 1);

      // eslint-disable-next-line no-self-compare -- NaN check
      if (octet !== octet) {
        result += decodedChar;
        i++;
        continue;
      }

      i += 2;
      var byteSequenceLength = getLeadingOnes(octet);

      if (byteSequenceLength === 0) {
        decodedChar = fromCharCode(octet);
      } else {
        if (byteSequenceLength === 1 || byteSequenceLength > 4) {
          result += FALLBACK_REPLACER;
          i++;
          continue;
        }

        var octets = [octet];
        var sequenceIndex = 1;

        while (sequenceIndex < byteSequenceLength) {
          i++;
          if (i + 3 > length || charAt(input, i) !== '%') break;

          var nextByte = parseHexOctet(input, i + 1);

          // eslint-disable-next-line no-self-compare -- NaN check
          if (nextByte !== nextByte) {
            i += 3;
            break;
          }
          if (nextByte > 191 || nextByte < 128) break;

          push(octets, nextByte);
          i += 2;
          sequenceIndex++;
        }

        if (octets.length !== byteSequenceLength) {
          result += FALLBACK_REPLACER;
          continue;
        }

        var codePoint = utf8Decode(octets);
        if (codePoint === null) {
          result += FALLBACK_REPLACER;
        } else {
          decodedChar = fromCodePoint(codePoint);
        }
      }
    }

    result += decodedChar;
    i++;
  }

  return result;
};

var find = /[!'()~]|%20/g;

var replacements = {
  '!': '%21',
  "'": '%27',
  '(': '%28',
  ')': '%29',
  '~': '%7E',
  '%20': '+'
};

var replacer = function (match) {
  return replacements[match];
};

var serialize = function (it) {
  return replace(encodeURIComponent(it), find, replacer);
};

var URLSearchParamsIterator = createIteratorConstructor(function Iterator(params, kind) {
  setInternalState(this, {
    type: URL_SEARCH_PARAMS_ITERATOR,
    target: getInternalParamsState(params).entries,
    index: 0,
    kind: kind
  });
}, URL_SEARCH_PARAMS, function next() {
  var state = getInternalIteratorState(this);
  var target = state.target;
  var index = state.index++;
  if (!target || index >= target.length) {
    state.target = null;
    return createIterResultObject(undefined, true);
  }
  var entry = target[index];
  switch (state.kind) {
    case 'keys': return createIterResultObject(entry.key, false);
    case 'values': return createIterResultObject(entry.value, false);
  } return createIterResultObject([entry.key, entry.value], false);
}, true);

var URLSearchParamsState = function (init) {
  this.entries = [];
  this.url = null;

  if (init !== undefined) {
    if (isObject(init)) this.parseObject(init);
    else this.parseQuery(typeof init == 'string' ? charAt(init, 0) === '?' ? stringSlice(init, 1) : init : $toString(init));
  }
};

URLSearchParamsState.prototype = {
  type: URL_SEARCH_PARAMS,
  bindURL: function (url) {
    this.url = url;
    this.update();
  },
  parseObject: function (object) {
    var entries = this.entries;
    var iteratorMethod = getIteratorMethod(object);
    var iterator, next, step, entryIterator, entryNext, first, second;

    if (iteratorMethod) {
      iterator = getIterator(object, iteratorMethod);
      next = iterator.next;
      while (!(step = call(next, iterator)).done) {
        entryIterator = getIterator(anObject(step.value));
        entryNext = entryIterator.next;
        if (
          (first = call(entryNext, entryIterator)).done ||
          (second = call(entryNext, entryIterator)).done ||
          !call(entryNext, entryIterator).done
        ) throw new TypeError('Expected sequence with length 2');
        push(entries, { key: $toString(first.value), value: $toString(second.value) });
      }
    } else for (var key in object) if (hasOwn(object, key)) {
      push(entries, { key: key, value: $toString(object[key]) });
    }
  },
  parseQuery: function (query) {
    if (query) {
      var entries = this.entries;
      var attributes = split(query, '&');
      var index = 0;
      var attribute, entry;
      while (index < attributes.length) {
        attribute = attributes[index++];
        if (attribute.length) {
          entry = split(attribute, '=');
          push(entries, {
            key: decode(shift(entry)),
            value: decode(join(entry, '='))
          });
        }
      }
    }
  },
  serialize: function () {
    var entries = this.entries;
    var result = [];
    var index = 0;
    var entry;
    while (index < entries.length) {
      entry = entries[index++];
      push(result, serialize(entry.key) + '=' + serialize(entry.value));
    } return join(result, '&');
  },
  update: function () {
    this.entries.length = 0;
    this.parseQuery(this.url.query);
  },
  updateURL: function () {
    if (this.url) this.url.update();
  }
};

// `URLSearchParams` constructor
// https://url.spec.whatwg.org/#interface-urlsearchparams
var URLSearchParamsConstructor = function URLSearchParams(/* init */) {
  anInstance(this, URLSearchParamsPrototype);
  var init = arguments.length > 0 ? arguments[0] : undefined;
  var state = setInternalState(this, new URLSearchParamsState(init));
  if (!DESCRIPTORS) this.size = state.entries.length;
};

var URLSearchParamsPrototype = URLSearchParamsConstructor.prototype;

defineBuiltIns(URLSearchParamsPrototype, {
  // `URLSearchParams.prototype.append` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-append
  append: function append(name, value) {
    var state = getInternalParamsState(this);
    validateArgumentsLength(arguments.length, 2);
    push(state.entries, { key: $toString(name), value: $toString(value) });
    if (!DESCRIPTORS) this.length++;
    state.updateURL();
  },
  // `URLSearchParams.prototype.delete` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-delete
  'delete': function (name /* , value */) {
    var state = getInternalParamsState(this);
    var length = validateArgumentsLength(arguments.length, 1);
    var entries = state.entries;
    var key = $toString(name);
    var $value = length < 2 ? undefined : arguments[1];
    var value = $value === undefined ? $value : $toString($value);
    var index = 0;
    while (index < entries.length) {
      var entry = entries[index];
      if (entry.key === key && (value === undefined || entry.value === value)) {
        splice(entries, index, 1);
        if (value !== undefined) break;
      } else index++;
    }
    if (!DESCRIPTORS) this.size = entries.length;
    state.updateURL();
  },
  // `URLSearchParams.prototype.get` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-get
  get: function get(name) {
    var entries = getInternalParamsState(this).entries;
    validateArgumentsLength(arguments.length, 1);
    var key = $toString(name);
    var index = 0;
    for (; index < entries.length; index++) {
      if (entries[index].key === key) return entries[index].value;
    }
    return null;
  },
  // `URLSearchParams.prototype.getAll` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-getall
  getAll: function getAll(name) {
    var entries = getInternalParamsState(this).entries;
    validateArgumentsLength(arguments.length, 1);
    var key = $toString(name);
    var result = [];
    var index = 0;
    for (; index < entries.length; index++) {
      if (entries[index].key === key) push(result, entries[index].value);
    }
    return result;
  },
  // `URLSearchParams.prototype.has` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-has
  has: function has(name /* , value */) {
    var entries = getInternalParamsState(this).entries;
    var length = validateArgumentsLength(arguments.length, 1);
    var key = $toString(name);
    var $value = length < 2 ? undefined : arguments[1];
    var value = $value === undefined ? $value : $toString($value);
    var index = 0;
    while (index < entries.length) {
      var entry = entries[index++];
      if (entry.key === key && (value === undefined || entry.value === value)) return true;
    }
    return false;
  },
  // `URLSearchParams.prototype.set` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-set
  set: function set(name, value) {
    var state = getInternalParamsState(this);
    validateArgumentsLength(arguments.length, 1);
    var entries = state.entries;
    var found = false;
    var key = $toString(name);
    var val = $toString(value);
    var index = 0;
    var entry;
    for (; index < entries.length; index++) {
      entry = entries[index];
      if (entry.key === key) {
        if (found) splice(entries, index--, 1);
        else {
          found = true;
          entry.value = val;
        }
      }
    }
    if (!found) push(entries, { key: key, value: val });
    if (!DESCRIPTORS) this.size = entries.length;
    state.updateURL();
  },
  // `URLSearchParams.prototype.sort` method
  // https://url.spec.whatwg.org/#dom-urlsearchparams-sort
  sort: function sort() {
    var state = getInternalParamsState(this);
    arraySort(state.entries, function (a, b) {
      return a.key > b.key ? 1 : -1;
    });
    state.updateURL();
  },
  // `URLSearchParams.prototype.forEach` method
  forEach: function forEach(callback /* , thisArg */) {
    var entries = getInternalParamsState(this).entries;
    var boundFunction = bind(callback, arguments.length > 1 ? arguments[1] : undefined);
    var index = 0;
    var entry;
    while (index < entries.length) {
      entry = entries[index++];
      boundFunction(entry.value, entry.key, this);
    }
  },
  // `URLSearchParams.prototype.keys` method
  keys: function keys() {
    return new URLSearchParamsIterator(this, 'keys');
  },
  // `URLSearchParams.prototype.values` method
  values: function values() {
    return new URLSearchParamsIterator(this, 'values');
  },
  // `URLSearchParams.prototype.entries` method
  entries: function entries() {
    return new URLSearchParamsIterator(this, 'entries');
  }
}, { enumerable: true });

// `URLSearchParams.prototype[@@iterator]` method
defineBuiltIn(URLSearchParamsPrototype, ITERATOR, URLSearchParamsPrototype.entries, { name: 'entries' });

// `URLSearchParams.prototype.toString` method
// https://url.spec.whatwg.org/#urlsearchparams-stringification-behavior
defineBuiltIn(URLSearchParamsPrototype, 'toString', function toString() {
  return getInternalParamsState(this).serialize();
}, { enumerable: true });

// `URLSearchParams.prototype.size` getter
// https://github.com/whatwg/url/pull/734
if (DESCRIPTORS) defineBuiltInAccessor(URLSearchParamsPrototype, 'size', {
  get: function size() {
    return getInternalParamsState(this).entries.length;
  },
  configurable: true,
  enumerable: true
});

setToStringTag(URLSearchParamsConstructor, URL_SEARCH_PARAMS);

$({ global: true, constructor: true, forced: !USE_NATIVE_URL }, {
  URLSearchParams: URLSearchParamsConstructor
});

// Wrap `fetch` and `Request` for correct work with polyfilled `URLSearchParams`
if (!USE_NATIVE_URL && isCallable(Headers)) {
  var headersHas = uncurryThis(HeadersPrototype.has);
  var headersSet = uncurryThis(HeadersPrototype.set);

  var wrapRequestOptions = function (init) {
    if (isObject(init)) {
      var body = init.body;
      var headers;
      if (classof(body) === URL_SEARCH_PARAMS) {
        headers = init.headers ? new Headers(init.headers) : new Headers();
        if (!headersHas(headers, 'content-type')) {
          headersSet(headers, 'content-type', 'application/x-www-form-urlencoded;charset=UTF-8');
        }
        return create(init, {
          body: createPropertyDescriptor(0, $toString(body)),
          headers: createPropertyDescriptor(0, headers)
        });
      }
    } return init;
  };

  if (isCallable(nativeFetch)) {
    $({ global: true, enumerable: true, dontCallGetSet: true, forced: true }, {
      fetch: function fetch(input /* , init */) {
        return nativeFetch(input, arguments.length > 1 ? wrapRequestOptions(arguments[1]) : {});
      }
    });
  }

  if (isCallable(NativeRequest)) {
    var RequestConstructor = function Request(input /* , init */) {
      anInstance(this, RequestPrototype);
      return new NativeRequest(input, arguments.length > 1 ? wrapRequestOptions(arguments[1]) : {});
    };

    RequestPrototype.constructor = RequestConstructor;
    RequestConstructor.prototype = RequestPrototype;

    $({ global: true, constructor: true, dontCallGetSet: true, forced: true }, {
      Request: RequestConstructor
    });
  }
}

module.exports = {
  URLSearchParams: URLSearchParamsConstructor,
  getState: getInternalParamsState
};


/***/ }),

/***/ 4603:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineBuiltIn = __webpack_require__(6840);
var uncurryThis = __webpack_require__(9504);
var toString = __webpack_require__(655);
var validateArgumentsLength = __webpack_require__(2812);

var $URLSearchParams = URLSearchParams;
var URLSearchParamsPrototype = $URLSearchParams.prototype;
var append = uncurryThis(URLSearchParamsPrototype.append);
var $delete = uncurryThis(URLSearchParamsPrototype['delete']);
var forEach = uncurryThis(URLSearchParamsPrototype.forEach);
var push = uncurryThis([].push);
var params = new $URLSearchParams('a=1&a=2&b=3');

params['delete']('a', 1);
// `undefined` case is a Chromium 117 bug
// https://bugs.chromium.org/p/v8/issues/detail?id=14222
params['delete']('b', undefined);

if (params + '' !== 'a=2') {
  defineBuiltIn(URLSearchParamsPrototype, 'delete', function (name /* , value */) {
    var length = arguments.length;
    var $value = length < 2 ? undefined : arguments[1];
    if (length && $value === undefined) return $delete(this, name);
    var entries = [];
    forEach(this, function (v, k) { // also validates `this`
      push(entries, { key: k, value: v });
    });
    validateArgumentsLength(length, 1);
    var key = toString(name);
    var value = toString($value);
    var index = 0;
    var dindex = 0;
    var found = false;
    var entriesLength = entries.length;
    var entry;
    while (index < entriesLength) {
      entry = entries[index++];
      if (found || entry.key === key) {
        found = true;
        $delete(this, entry.key);
      } else dindex++;
    }
    while (dindex < entriesLength) {
      entry = entries[dindex++];
      if (!(entry.key === key && entry.value === value)) append(this, entry.key, entry.value);
    }
  }, { enumerable: true, unsafe: true });
}


/***/ }),

/***/ 7566:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var defineBuiltIn = __webpack_require__(6840);
var uncurryThis = __webpack_require__(9504);
var toString = __webpack_require__(655);
var validateArgumentsLength = __webpack_require__(2812);

var $URLSearchParams = URLSearchParams;
var URLSearchParamsPrototype = $URLSearchParams.prototype;
var getAll = uncurryThis(URLSearchParamsPrototype.getAll);
var $has = uncurryThis(URLSearchParamsPrototype.has);
var params = new $URLSearchParams('a=1');

// `undefined` case is a Chromium 117 bug
// https://bugs.chromium.org/p/v8/issues/detail?id=14222
if (params.has('a', 2) || !params.has('a', undefined)) {
  defineBuiltIn(URLSearchParamsPrototype, 'has', function has(name /* , value */) {
    var length = arguments.length;
    var $value = length < 2 ? undefined : arguments[1];
    if (length && $value === undefined) return $has(this, name);
    var values = getAll(this, name); // also validates `this`
    validateArgumentsLength(length, 1);
    var value = toString($value);
    var index = 0;
    while (index < values.length) {
      if (values[index++] === value) return true;
    } return false;
  }, { enumerable: true, unsafe: true });
}


/***/ }),

/***/ 8408:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(8406);


/***/ }),

/***/ 8721:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var DESCRIPTORS = __webpack_require__(3724);
var uncurryThis = __webpack_require__(9504);
var defineBuiltInAccessor = __webpack_require__(2106);

var URLSearchParamsPrototype = URLSearchParams.prototype;
var forEach = uncurryThis(URLSearchParamsPrototype.forEach);

// `URLSearchParams.prototype.size` getter
// https://github.com/whatwg/url/pull/734
if (DESCRIPTORS && !('size' in URLSearchParamsPrototype)) {
  defineBuiltInAccessor(URLSearchParamsPrototype, 'size', {
    get: function size() {
      var count = 0;
      forEach(this, function () { count++; });
      return count;
    },
    configurable: true,
    enumerable: true
  });
}


/***/ }),

/***/ 5806:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: in core-js@4, move /modules/ dependencies to public entries for better optimization by tools like `preset-env`
__webpack_require__(7764);
var $ = __webpack_require__(6518);
var DESCRIPTORS = __webpack_require__(3724);
var USE_NATIVE_URL = __webpack_require__(7416);
var globalThis = __webpack_require__(4576);
var bind = __webpack_require__(6080);
var uncurryThis = __webpack_require__(9504);
var defineBuiltIn = __webpack_require__(6840);
var defineBuiltInAccessor = __webpack_require__(2106);
var anInstance = __webpack_require__(679);
var hasOwn = __webpack_require__(9297);
var assign = __webpack_require__(4213);
var arrayFrom = __webpack_require__(7916);
var arraySlice = __webpack_require__(7680);
var codeAt = (__webpack_require__(8183).codeAt);
var toASCII = __webpack_require__(6098);
var $toString = __webpack_require__(655);
var setToStringTag = __webpack_require__(687);
var validateArgumentsLength = __webpack_require__(2812);
var URLSearchParamsModule = __webpack_require__(8406);
var InternalStateModule = __webpack_require__(1181);

var setInternalState = InternalStateModule.set;
var getInternalURLState = InternalStateModule.getterFor('URL');
var URLSearchParams = URLSearchParamsModule.URLSearchParams;
var getInternalSearchParamsState = URLSearchParamsModule.getState;

var NativeURL = globalThis.URL;
var TypeError = globalThis.TypeError;
var parseInt = globalThis.parseInt;
var floor = Math.floor;
var pow = Math.pow;
var charAt = uncurryThis(''.charAt);
var exec = uncurryThis(/./.exec);
var join = uncurryThis([].join);
var numberToString = uncurryThis(1.0.toString);
var pop = uncurryThis([].pop);
var push = uncurryThis([].push);
var replace = uncurryThis(''.replace);
var shift = uncurryThis([].shift);
var split = uncurryThis(''.split);
var stringSlice = uncurryThis(''.slice);
var toLowerCase = uncurryThis(''.toLowerCase);
var unshift = uncurryThis([].unshift);

var INVALID_AUTHORITY = 'Invalid authority';
var INVALID_SCHEME = 'Invalid scheme';
var INVALID_HOST = 'Invalid host';
var INVALID_PORT = 'Invalid port';

var ALPHA = /[a-z]/i;
// eslint-disable-next-line regexp/no-obscure-range -- safe
var ALPHANUMERIC = /[\d+-.a-z]/i;
var DIGIT = /\d/;
var HEX_START = /^0x/i;
var OCT = /^[0-7]+$/;
var DEC = /^\d+$/;
var HEX = /^[\da-f]+$/i;
/* eslint-disable regexp/no-control-character -- safe */
var FORBIDDEN_HOST_CODE_POINT = /[\0\t\n\r #%/:<>?@[\\\]^|]/;
var FORBIDDEN_HOST_CODE_POINT_EXCLUDING_PERCENT = /[\0\t\n\r #/:<>?@[\\\]^|]/;
var LEADING_C0_CONTROL_OR_SPACE = /^[\u0000-\u0020]+/;
var TRAILING_C0_CONTROL_OR_SPACE = /(^|[^\u0000-\u0020])[\u0000-\u0020]+$/;
var TAB_AND_NEW_LINE = /[\t\n\r]/g;
/* eslint-enable regexp/no-control-character -- safe */
var EOF;

// https://url.spec.whatwg.org/#ipv4-number-parser
var parseIPv4 = function (input) {
  var parts = split(input, '.');
  var partsLength, numbers, index, part, radix, number, ipv4;
  if (parts.length && parts[parts.length - 1] === '') {
    parts.length--;
  }
  partsLength = parts.length;
  if (partsLength > 4) return input;
  numbers = [];
  for (index = 0; index < partsLength; index++) {
    part = parts[index];
    if (part === '') return input;
    radix = 10;
    if (part.length > 1 && charAt(part, 0) === '0') {
      radix = exec(HEX_START, part) ? 16 : 8;
      part = stringSlice(part, radix === 8 ? 1 : 2);
    }
    if (part === '') {
      number = 0;
    } else {
      if (!exec(radix === 10 ? DEC : radix === 8 ? OCT : HEX, part)) return input;
      number = parseInt(part, radix);
    }
    push(numbers, number);
  }
  for (index = 0; index < partsLength; index++) {
    number = numbers[index];
    if (index === partsLength - 1) {
      if (number >= pow(256, 5 - partsLength)) return null;
    } else if (number > 255) return null;
  }
  ipv4 = pop(numbers);
  for (index = 0; index < numbers.length; index++) {
    ipv4 += numbers[index] * pow(256, 3 - index);
  }
  return ipv4;
};

// https://url.spec.whatwg.org/#concept-ipv6-parser
// eslint-disable-next-line max-statements -- TODO
var parseIPv6 = function (input) {
  var address = [0, 0, 0, 0, 0, 0, 0, 0];
  var pieceIndex = 0;
  var compress = null;
  var pointer = 0;
  var value, length, numbersSeen, ipv4Piece, number, swaps, swap;

  var chr = function () {
    return charAt(input, pointer);
  };

  if (chr() === ':') {
    if (charAt(input, 1) !== ':') return;
    pointer += 2;
    pieceIndex++;
    compress = pieceIndex;
  }
  while (chr()) {
    if (pieceIndex === 8) return;
    if (chr() === ':') {
      if (compress !== null) return;
      pointer++;
      pieceIndex++;
      compress = pieceIndex;
      continue;
    }
    value = length = 0;
    while (length < 4 && exec(HEX, chr())) {
      value = value * 16 + parseInt(chr(), 16);
      pointer++;
      length++;
    }
    if (chr() === '.') {
      if (length === 0) return;
      pointer -= length;
      if (pieceIndex > 6) return;
      numbersSeen = 0;
      while (chr()) {
        ipv4Piece = null;
        if (numbersSeen > 0) {
          if (chr() === '.' && numbersSeen < 4) pointer++;
          else return;
        }
        if (!exec(DIGIT, chr())) return;
        while (exec(DIGIT, chr())) {
          number = parseInt(chr(), 10);
          if (ipv4Piece === null) ipv4Piece = number;
          else if (ipv4Piece === 0) return;
          else ipv4Piece = ipv4Piece * 10 + number;
          if (ipv4Piece > 255) return;
          pointer++;
        }
        address[pieceIndex] = address[pieceIndex] * 256 + ipv4Piece;
        numbersSeen++;
        if (numbersSeen === 2 || numbersSeen === 4) pieceIndex++;
      }
      if (numbersSeen !== 4) return;
      break;
    } else if (chr() === ':') {
      pointer++;
      if (!chr()) return;
    } else if (chr()) return;
    address[pieceIndex++] = value;
  }
  if (compress !== null) {
    swaps = pieceIndex - compress;
    pieceIndex = 7;
    while (pieceIndex !== 0 && swaps > 0) {
      swap = address[pieceIndex];
      address[pieceIndex--] = address[compress + swaps - 1];
      address[compress + --swaps] = swap;
    }
  } else if (pieceIndex !== 8) return;
  return address;
};

var findLongestZeroSequence = function (ipv6) {
  var maxIndex = null;
  var maxLength = 1;
  var currStart = null;
  var currLength = 0;
  var index = 0;
  for (; index < 8; index++) {
    if (ipv6[index] !== 0) {
      if (currLength > maxLength) {
        maxIndex = currStart;
        maxLength = currLength;
      }
      currStart = null;
      currLength = 0;
    } else {
      if (currStart === null) currStart = index;
      ++currLength;
    }
  }
  return currLength > maxLength ? currStart : maxIndex;
};

// https://url.spec.whatwg.org/#host-serializing
var serializeHost = function (host) {
  var result, index, compress, ignore0;

  // ipv4
  if (typeof host == 'number') {
    result = [];
    for (index = 0; index < 4; index++) {
      unshift(result, host % 256);
      host = floor(host / 256);
    }
    return join(result, '.');
  }

  // ipv6
  if (typeof host == 'object') {
    result = '';
    compress = findLongestZeroSequence(host);
    for (index = 0; index < 8; index++) {
      if (ignore0 && host[index] === 0) continue;
      if (ignore0) ignore0 = false;
      if (compress === index) {
        result += index ? ':' : '::';
        ignore0 = true;
      } else {
        result += numberToString(host[index], 16);
        if (index < 7) result += ':';
      }
    }
    return '[' + result + ']';
  }

  return host;
};

var C0ControlPercentEncodeSet = {};
var fragmentPercentEncodeSet = assign({}, C0ControlPercentEncodeSet, {
  ' ': 1, '"': 1, '<': 1, '>': 1, '`': 1
});
var pathPercentEncodeSet = assign({}, fragmentPercentEncodeSet, {
  '#': 1, '?': 1, '{': 1, '}': 1
});
var userinfoPercentEncodeSet = assign({}, pathPercentEncodeSet, {
  '/': 1, ':': 1, ';': 1, '=': 1, '@': 1, '[': 1, '\\': 1, ']': 1, '^': 1, '|': 1
});

var percentEncode = function (chr, set) {
  var code = codeAt(chr, 0);
  return code > 0x20 && code < 0x7F && !hasOwn(set, chr) ? chr : encodeURIComponent(chr);
};

// https://url.spec.whatwg.org/#special-scheme
var specialSchemes = {
  ftp: 21,
  file: null,
  http: 80,
  https: 443,
  ws: 80,
  wss: 443
};

// https://url.spec.whatwg.org/#windows-drive-letter
var isWindowsDriveLetter = function (string, normalized) {
  var second;
  return string.length === 2 && exec(ALPHA, charAt(string, 0))
    && ((second = charAt(string, 1)) === ':' || (!normalized && second === '|'));
};

// https://url.spec.whatwg.org/#start-with-a-windows-drive-letter
var startsWithWindowsDriveLetter = function (string) {
  var third;
  return string.length > 1 && isWindowsDriveLetter(stringSlice(string, 0, 2)) && (
    string.length === 2 ||
    ((third = charAt(string, 2)) === '/' || third === '\\' || third === '?' || third === '#')
  );
};

// https://url.spec.whatwg.org/#single-dot-path-segment
var isSingleDot = function (segment) {
  return segment === '.' || toLowerCase(segment) === '%2e';
};

// https://url.spec.whatwg.org/#double-dot-path-segment
var isDoubleDot = function (segment) {
  segment = toLowerCase(segment);
  return segment === '..' || segment === '%2e.' || segment === '.%2e' || segment === '%2e%2e';
};

// States:
var SCHEME_START = {};
var SCHEME = {};
var NO_SCHEME = {};
var SPECIAL_RELATIVE_OR_AUTHORITY = {};
var PATH_OR_AUTHORITY = {};
var RELATIVE = {};
var RELATIVE_SLASH = {};
var SPECIAL_AUTHORITY_SLASHES = {};
var SPECIAL_AUTHORITY_IGNORE_SLASHES = {};
var AUTHORITY = {};
var HOST = {};
var HOSTNAME = {};
var PORT = {};
var FILE = {};
var FILE_SLASH = {};
var FILE_HOST = {};
var PATH_START = {};
var PATH = {};
var CANNOT_BE_A_BASE_URL_PATH = {};
var QUERY = {};
var FRAGMENT = {};

var URLState = function (url, isBase, base) {
  var urlString = $toString(url);
  var baseState, failure, searchParams;
  if (isBase) {
    failure = this.parse(urlString);
    if (failure) throw new TypeError(failure);
    this.searchParams = null;
  } else {
    if (base !== undefined) baseState = new URLState(base, true);
    failure = this.parse(urlString, null, baseState);
    if (failure) throw new TypeError(failure);
    searchParams = getInternalSearchParamsState(new URLSearchParams());
    searchParams.bindURL(this);
    this.searchParams = searchParams;
  }
};

URLState.prototype = {
  type: 'URL',
  // https://url.spec.whatwg.org/#url-parsing
  // eslint-disable-next-line max-statements -- TODO
  parse: function (input, stateOverride, base) {
    var url = this;
    var state = stateOverride || SCHEME_START;
    var pointer = 0;
    var buffer = '';
    var seenAt = false;
    var seenBracket = false;
    var seenPasswordToken = false;
    var codePoints, chr, bufferCodePoints, failure;

    input = $toString(input);

    if (!stateOverride) {
      url.scheme = '';
      url.username = '';
      url.password = '';
      url.host = null;
      url.port = null;
      url.path = [];
      url.query = null;
      url.fragment = null;
      url.cannotBeABaseURL = false;
      input = replace(input, LEADING_C0_CONTROL_OR_SPACE, '');
      input = replace(input, TRAILING_C0_CONTROL_OR_SPACE, '$1');
    }

    input = replace(input, TAB_AND_NEW_LINE, '');

    codePoints = arrayFrom(input);

    while (pointer <= codePoints.length) {
      chr = codePoints[pointer];
      switch (state) {
        case SCHEME_START:
          if (chr && exec(ALPHA, chr)) {
            buffer += toLowerCase(chr);
            state = SCHEME;
          } else if (!stateOverride) {
            state = NO_SCHEME;
            continue;
          } else return INVALID_SCHEME;
          break;

        case SCHEME:
          if (chr && (exec(ALPHANUMERIC, chr) || chr === '+' || chr === '-' || chr === '.')) {
            buffer += toLowerCase(chr);
          } else if (chr === ':') {
            if (stateOverride && (
              (url.isSpecial() !== hasOwn(specialSchemes, buffer)) ||
              (buffer === 'file' && (url.includesCredentials() || url.port !== null)) ||
              (url.scheme === 'file' && !url.host)
            )) return;
            url.scheme = buffer;
            if (stateOverride) {
              if (url.isSpecial() && specialSchemes[url.scheme] === url.port) url.port = null;
              return;
            }
            buffer = '';
            if (url.scheme === 'file') {
              state = FILE;
            } else if (url.isSpecial() && base && base.scheme === url.scheme) {
              state = SPECIAL_RELATIVE_OR_AUTHORITY;
            } else if (url.isSpecial()) {
              state = SPECIAL_AUTHORITY_SLASHES;
            } else if (codePoints[pointer + 1] === '/') {
              state = PATH_OR_AUTHORITY;
              pointer++;
            } else {
              url.cannotBeABaseURL = true;
              push(url.path, '');
              state = CANNOT_BE_A_BASE_URL_PATH;
            }
          } else if (!stateOverride) {
            buffer = '';
            state = NO_SCHEME;
            pointer = 0;
            continue;
          } else return INVALID_SCHEME;
          break;

        case NO_SCHEME:
          if (!base || (base.cannotBeABaseURL && chr !== '#')) return INVALID_SCHEME;
          if (base.cannotBeABaseURL && chr === '#') {
            url.scheme = base.scheme;
            url.path = arraySlice(base.path);
            url.query = base.query;
            url.fragment = '';
            url.cannotBeABaseURL = true;
            state = FRAGMENT;
            break;
          }
          state = base.scheme === 'file' ? FILE : RELATIVE;
          continue;

        case SPECIAL_RELATIVE_OR_AUTHORITY:
          if (chr === '/' && codePoints[pointer + 1] === '/') {
            state = SPECIAL_AUTHORITY_IGNORE_SLASHES;
            pointer++;
          } else {
            state = RELATIVE;
            continue;
          } break;

        case PATH_OR_AUTHORITY:
          if (chr === '/') {
            state = AUTHORITY;
            break;
          } else {
            state = PATH;
            continue;
          }

        case RELATIVE:
          url.scheme = base.scheme;
          if (chr === EOF) {
            url.username = base.username;
            url.password = base.password;
            url.host = base.host;
            url.port = base.port;
            url.path = arraySlice(base.path);
            url.query = base.query;
          } else if (chr === '/' || (chr === '\\' && url.isSpecial())) {
            state = RELATIVE_SLASH;
          } else if (chr === '?') {
            url.username = base.username;
            url.password = base.password;
            url.host = base.host;
            url.port = base.port;
            url.path = arraySlice(base.path);
            url.query = '';
            state = QUERY;
          } else if (chr === '#') {
            url.username = base.username;
            url.password = base.password;
            url.host = base.host;
            url.port = base.port;
            url.path = arraySlice(base.path);
            url.query = base.query;
            url.fragment = '';
            state = FRAGMENT;
          } else {
            url.username = base.username;
            url.password = base.password;
            url.host = base.host;
            url.port = base.port;
            url.path = arraySlice(base.path);
            url.path.length--;
            state = PATH;
            continue;
          } break;

        case RELATIVE_SLASH:
          if (url.isSpecial() && (chr === '/' || chr === '\\')) {
            state = SPECIAL_AUTHORITY_IGNORE_SLASHES;
          } else if (chr === '/') {
            state = AUTHORITY;
          } else {
            url.username = base.username;
            url.password = base.password;
            url.host = base.host;
            url.port = base.port;
            state = PATH;
            continue;
          } break;

        case SPECIAL_AUTHORITY_SLASHES:
          state = SPECIAL_AUTHORITY_IGNORE_SLASHES;
          if (chr !== '/' || charAt(buffer, pointer + 1) !== '/') continue;
          pointer++;
          break;

        case SPECIAL_AUTHORITY_IGNORE_SLASHES:
          if (chr !== '/' && chr !== '\\') {
            state = AUTHORITY;
            continue;
          } break;

        case AUTHORITY:
          if (chr === '@') {
            if (seenAt) buffer = '%40' + buffer;
            seenAt = true;
            bufferCodePoints = arrayFrom(buffer);
            for (var i = 0; i < bufferCodePoints.length; i++) {
              var codePoint = bufferCodePoints[i];
              if (codePoint === ':' && !seenPasswordToken) {
                seenPasswordToken = true;
                continue;
              }
              var encodedCodePoints = percentEncode(codePoint, userinfoPercentEncodeSet);
              if (seenPasswordToken) url.password += encodedCodePoints;
              else url.username += encodedCodePoints;
            }
            buffer = '';
          } else if (
            chr === EOF || chr === '/' || chr === '?' || chr === '#' ||
            (chr === '\\' && url.isSpecial())
          ) {
            if (seenAt && buffer === '') return INVALID_AUTHORITY;
            pointer -= arrayFrom(buffer).length + 1;
            buffer = '';
            state = HOST;
          } else buffer += chr;
          break;

        case HOST:
        case HOSTNAME:
          if (stateOverride && url.scheme === 'file') {
            state = FILE_HOST;
            continue;
          } else if (chr === ':' && !seenBracket) {
            if (buffer === '') return INVALID_HOST;
            failure = url.parseHost(buffer);
            if (failure) return failure;
            buffer = '';
            state = PORT;
            if (stateOverride === HOSTNAME) return;
          } else if (
            chr === EOF || chr === '/' || chr === '?' || chr === '#' ||
            (chr === '\\' && url.isSpecial())
          ) {
            if (url.isSpecial() && buffer === '') return INVALID_HOST;
            if (stateOverride && buffer === '' && (url.includesCredentials() || url.port !== null)) return;
            failure = url.parseHost(buffer);
            if (failure) return failure;
            buffer = '';
            state = PATH_START;
            if (stateOverride) return;
            continue;
          } else {
            if (chr === '[') seenBracket = true;
            else if (chr === ']') seenBracket = false;
            buffer += chr;
          } break;

        case PORT:
          if (exec(DIGIT, chr)) {
            buffer += chr;
          } else if (
            chr === EOF || chr === '/' || chr === '?' || chr === '#' ||
            (chr === '\\' && url.isSpecial()) ||
            stateOverride
          ) {
            if (buffer !== '') {
              var port = parseInt(buffer, 10);
              if (port > 0xFFFF) return INVALID_PORT;
              url.port = (url.isSpecial() && port === specialSchemes[url.scheme]) ? null : port;
              buffer = '';
            }
            if (stateOverride) return;
            state = PATH_START;
            continue;
          } else return INVALID_PORT;
          break;

        case FILE:
          url.scheme = 'file';
          if (chr === '/' || chr === '\\') state = FILE_SLASH;
          else if (base && base.scheme === 'file') {
            switch (chr) {
              case EOF:
                url.host = base.host;
                url.path = arraySlice(base.path);
                url.query = base.query;
                break;
              case '?':
                url.host = base.host;
                url.path = arraySlice(base.path);
                url.query = '';
                state = QUERY;
                break;
              case '#':
                url.host = base.host;
                url.path = arraySlice(base.path);
                url.query = base.query;
                url.fragment = '';
                state = FRAGMENT;
                break;
              default:
                if (!startsWithWindowsDriveLetter(join(arraySlice(codePoints, pointer), ''))) {
                  url.host = base.host;
                  url.path = arraySlice(base.path);
                  url.shortenPath();
                }
                state = PATH;
                continue;
            }
          } else {
            state = PATH;
            continue;
          } break;

        case FILE_SLASH:
          if (chr === '/' || chr === '\\') {
            state = FILE_HOST;
            break;
          }
          if (base && base.scheme === 'file' && !startsWithWindowsDriveLetter(join(arraySlice(codePoints, pointer), ''))) {
            if (isWindowsDriveLetter(base.path[0], true)) push(url.path, base.path[0]);
            else url.host = base.host;
          }
          state = PATH;
          continue;

        case FILE_HOST:
          if (chr === EOF || chr === '/' || chr === '\\' || chr === '?' || chr === '#') {
            if (!stateOverride && isWindowsDriveLetter(buffer)) {
              state = PATH;
            } else if (buffer === '') {
              url.host = '';
              if (stateOverride) return;
              state = PATH_START;
            } else {
              failure = url.parseHost(buffer);
              if (failure) return failure;
              if (url.host === 'localhost') url.host = '';
              if (stateOverride) return;
              buffer = '';
              state = PATH_START;
            } continue;
          } else buffer += chr;
          break;

        case PATH_START:
          if (url.isSpecial()) {
            state = PATH;
            if (chr !== '/' && chr !== '\\') continue;
          } else if (!stateOverride && chr === '?') {
            url.query = '';
            state = QUERY;
          } else if (!stateOverride && chr === '#') {
            url.fragment = '';
            state = FRAGMENT;
          } else if (chr !== EOF) {
            state = PATH;
            if (chr !== '/') continue;
          } break;

        case PATH:
          if (
            chr === EOF || chr === '/' ||
            (chr === '\\' && url.isSpecial()) ||
            (!stateOverride && (chr === '?' || chr === '#'))
          ) {
            if (isDoubleDot(buffer)) {
              url.shortenPath();
              if (chr !== '/' && !(chr === '\\' && url.isSpecial())) {
                push(url.path, '');
              }
            } else if (isSingleDot(buffer)) {
              if (chr !== '/' && !(chr === '\\' && url.isSpecial())) {
                push(url.path, '');
              }
            } else {
              if (url.scheme === 'file' && !url.path.length && isWindowsDriveLetter(buffer)) {
                if (url.host) url.host = '';
                buffer = charAt(buffer, 0) + ':'; // normalize windows drive letter
              }
              push(url.path, buffer);
            }
            buffer = '';
            if (url.scheme === 'file' && (chr === EOF || chr === '?' || chr === '#')) {
              while (url.path.length > 1 && url.path[0] === '') {
                shift(url.path);
              }
            }
            if (chr === '?') {
              url.query = '';
              state = QUERY;
            } else if (chr === '#') {
              url.fragment = '';
              state = FRAGMENT;
            }
          } else {
            buffer += percentEncode(chr, pathPercentEncodeSet);
          } break;

        case CANNOT_BE_A_BASE_URL_PATH:
          if (chr === '?') {
            url.query = '';
            state = QUERY;
          } else if (chr === '#') {
            url.fragment = '';
            state = FRAGMENT;
          } else if (chr !== EOF) {
            url.path[0] += percentEncode(chr, C0ControlPercentEncodeSet);
          } break;

        case QUERY:
          if (!stateOverride && chr === '#') {
            url.fragment = '';
            state = FRAGMENT;
          } else if (chr !== EOF) {
            if (chr === "'" && url.isSpecial()) url.query += '%27';
            else if (chr === '#') url.query += '%23';
            else url.query += percentEncode(chr, C0ControlPercentEncodeSet);
          } break;

        case FRAGMENT:
          if (chr !== EOF) url.fragment += percentEncode(chr, fragmentPercentEncodeSet);
          break;
      }

      pointer++;
    }
  },
  // https://url.spec.whatwg.org/#host-parsing
  parseHost: function (input) {
    var result, codePoints, index;
    if (charAt(input, 0) === '[') {
      if (charAt(input, input.length - 1) !== ']') return INVALID_HOST;
      result = parseIPv6(stringSlice(input, 1, -1));
      if (!result) return INVALID_HOST;
      this.host = result;
    // opaque host
    } else if (!this.isSpecial()) {
      if (exec(FORBIDDEN_HOST_CODE_POINT_EXCLUDING_PERCENT, input)) return INVALID_HOST;
      result = '';
      codePoints = arrayFrom(input);
      for (index = 0; index < codePoints.length; index++) {
        result += percentEncode(codePoints[index], C0ControlPercentEncodeSet);
      }
      this.host = result;
    } else {
      input = toASCII(input);
      if (exec(FORBIDDEN_HOST_CODE_POINT, input)) return INVALID_HOST;
      result = parseIPv4(input);
      if (result === null) return INVALID_HOST;
      this.host = result;
    }
  },
  // https://url.spec.whatwg.org/#cannot-have-a-username-password-port
  cannotHaveUsernamePasswordPort: function () {
    return !this.host || this.cannotBeABaseURL || this.scheme === 'file';
  },
  // https://url.spec.whatwg.org/#include-credentials
  includesCredentials: function () {
    return this.username !== '' || this.password !== '';
  },
  // https://url.spec.whatwg.org/#is-special
  isSpecial: function () {
    return hasOwn(specialSchemes, this.scheme);
  },
  // https://url.spec.whatwg.org/#shorten-a-urls-path
  shortenPath: function () {
    var path = this.path;
    var pathSize = path.length;
    if (pathSize && (this.scheme !== 'file' || pathSize !== 1 || !isWindowsDriveLetter(path[0], true))) {
      path.length--;
    }
  },
  // https://url.spec.whatwg.org/#concept-url-serializer
  serialize: function () {
    var url = this;
    var scheme = url.scheme;
    var username = url.username;
    var password = url.password;
    var host = url.host;
    var port = url.port;
    var path = url.path;
    var query = url.query;
    var fragment = url.fragment;
    var output = scheme + ':';
    if (host !== null) {
      output += '//';
      if (url.includesCredentials()) {
        output += username + (password ? ':' + password : '') + '@';
      }
      output += serializeHost(host);
      if (port !== null) output += ':' + port;
    } else if (scheme === 'file') output += '//';
    output += url.cannotBeABaseURL ? path[0] : path.length ? '/' + join(path, '/') : '';
    if (query !== null) output += '?' + query;
    if (fragment !== null) output += '#' + fragment;
    return output;
  },
  // https://url.spec.whatwg.org/#dom-url-href
  setHref: function (href) {
    var failure = this.parse(href);
    if (failure) throw new TypeError(failure);
    this.searchParams.update();
  },
  // https://url.spec.whatwg.org/#dom-url-origin
  getOrigin: function () {
    var scheme = this.scheme;
    var port = this.port;
    if (scheme === 'blob') try {
      return new URLConstructor(scheme.path[0]).origin;
    } catch (error) {
      return 'null';
    }
    if (scheme === 'file' || !this.isSpecial()) return 'null';
    return scheme + '://' + serializeHost(this.host) + (port !== null ? ':' + port : '');
  },
  // https://url.spec.whatwg.org/#dom-url-protocol
  getProtocol: function () {
    return this.scheme + ':';
  },
  setProtocol: function (protocol) {
    this.parse($toString(protocol) + ':', SCHEME_START);
  },
  // https://url.spec.whatwg.org/#dom-url-username
  getUsername: function () {
    return this.username;
  },
  setUsername: function (username) {
    var codePoints = arrayFrom($toString(username));
    if (this.cannotHaveUsernamePasswordPort()) return;
    this.username = '';
    for (var i = 0; i < codePoints.length; i++) {
      this.username += percentEncode(codePoints[i], userinfoPercentEncodeSet);
    }
  },
  // https://url.spec.whatwg.org/#dom-url-password
  getPassword: function () {
    return this.password;
  },
  setPassword: function (password) {
    var codePoints = arrayFrom($toString(password));
    if (this.cannotHaveUsernamePasswordPort()) return;
    this.password = '';
    for (var i = 0; i < codePoints.length; i++) {
      this.password += percentEncode(codePoints[i], userinfoPercentEncodeSet);
    }
  },
  // https://url.spec.whatwg.org/#dom-url-host
  getHost: function () {
    var host = this.host;
    var port = this.port;
    return host === null ? ''
      : port === null ? serializeHost(host)
      : serializeHost(host) + ':' + port;
  },
  setHost: function (host) {
    if (this.cannotBeABaseURL) return;
    this.parse(host, HOST);
  },
  // https://url.spec.whatwg.org/#dom-url-hostname
  getHostname: function () {
    var host = this.host;
    return host === null ? '' : serializeHost(host);
  },
  setHostname: function (hostname) {
    if (this.cannotBeABaseURL) return;
    this.parse(hostname, HOSTNAME);
  },
  // https://url.spec.whatwg.org/#dom-url-port
  getPort: function () {
    var port = this.port;
    return port === null ? '' : $toString(port);
  },
  setPort: function (port) {
    if (this.cannotHaveUsernamePasswordPort()) return;
    port = $toString(port);
    if (port === '') this.port = null;
    else this.parse(port, PORT);
  },
  // https://url.spec.whatwg.org/#dom-url-pathname
  getPathname: function () {
    var path = this.path;
    return this.cannotBeABaseURL ? path[0] : path.length ? '/' + join(path, '/') : '';
  },
  setPathname: function (pathname) {
    if (this.cannotBeABaseURL) return;
    this.path = [];
    this.parse(pathname, PATH_START);
  },
  // https://url.spec.whatwg.org/#dom-url-search
  getSearch: function () {
    var query = this.query;
    return query ? '?' + query : '';
  },
  setSearch: function (search) {
    search = $toString(search);
    if (search === '') {
      this.query = null;
    } else {
      if (charAt(search, 0) === '?') search = stringSlice(search, 1);
      this.query = '';
      this.parse(search, QUERY);
    }
    this.searchParams.update();
  },
  // https://url.spec.whatwg.org/#dom-url-searchparams
  getSearchParams: function () {
    return this.searchParams.facade;
  },
  // https://url.spec.whatwg.org/#dom-url-hash
  getHash: function () {
    var fragment = this.fragment;
    return fragment ? '#' + fragment : '';
  },
  setHash: function (hash) {
    hash = $toString(hash);
    if (hash === '') {
      this.fragment = null;
      return;
    }
    if (charAt(hash, 0) === '#') hash = stringSlice(hash, 1);
    this.fragment = '';
    this.parse(hash, FRAGMENT);
  },
  update: function () {
    this.query = this.searchParams.serialize() || null;
  }
};

// `URL` constructor
// https://url.spec.whatwg.org/#url-class
var URLConstructor = function URL(url /* , base */) {
  var that = anInstance(this, URLPrototype);
  var base = validateArgumentsLength(arguments.length, 1) > 1 ? arguments[1] : undefined;
  var state = setInternalState(that, new URLState(url, false, base));
  if (!DESCRIPTORS) {
    that.href = state.serialize();
    that.origin = state.getOrigin();
    that.protocol = state.getProtocol();
    that.username = state.getUsername();
    that.password = state.getPassword();
    that.host = state.getHost();
    that.hostname = state.getHostname();
    that.port = state.getPort();
    that.pathname = state.getPathname();
    that.search = state.getSearch();
    that.searchParams = state.getSearchParams();
    that.hash = state.getHash();
  }
};

var URLPrototype = URLConstructor.prototype;

var accessorDescriptor = function (getter, setter) {
  return {
    get: function () {
      return getInternalURLState(this)[getter]();
    },
    set: setter && function (value) {
      return getInternalURLState(this)[setter](value);
    },
    configurable: true,
    enumerable: true
  };
};

if (DESCRIPTORS) {
  // `URL.prototype.href` accessors pair
  // https://url.spec.whatwg.org/#dom-url-href
  defineBuiltInAccessor(URLPrototype, 'href', accessorDescriptor('serialize', 'setHref'));
  // `URL.prototype.origin` getter
  // https://url.spec.whatwg.org/#dom-url-origin
  defineBuiltInAccessor(URLPrototype, 'origin', accessorDescriptor('getOrigin'));
  // `URL.prototype.protocol` accessors pair
  // https://url.spec.whatwg.org/#dom-url-protocol
  defineBuiltInAccessor(URLPrototype, 'protocol', accessorDescriptor('getProtocol', 'setProtocol'));
  // `URL.prototype.username` accessors pair
  // https://url.spec.whatwg.org/#dom-url-username
  defineBuiltInAccessor(URLPrototype, 'username', accessorDescriptor('getUsername', 'setUsername'));
  // `URL.prototype.password` accessors pair
  // https://url.spec.whatwg.org/#dom-url-password
  defineBuiltInAccessor(URLPrototype, 'password', accessorDescriptor('getPassword', 'setPassword'));
  // `URL.prototype.host` accessors pair
  // https://url.spec.whatwg.org/#dom-url-host
  defineBuiltInAccessor(URLPrototype, 'host', accessorDescriptor('getHost', 'setHost'));
  // `URL.prototype.hostname` accessors pair
  // https://url.spec.whatwg.org/#dom-url-hostname
  defineBuiltInAccessor(URLPrototype, 'hostname', accessorDescriptor('getHostname', 'setHostname'));
  // `URL.prototype.port` accessors pair
  // https://url.spec.whatwg.org/#dom-url-port
  defineBuiltInAccessor(URLPrototype, 'port', accessorDescriptor('getPort', 'setPort'));
  // `URL.prototype.pathname` accessors pair
  // https://url.spec.whatwg.org/#dom-url-pathname
  defineBuiltInAccessor(URLPrototype, 'pathname', accessorDescriptor('getPathname', 'setPathname'));
  // `URL.prototype.search` accessors pair
  // https://url.spec.whatwg.org/#dom-url-search
  defineBuiltInAccessor(URLPrototype, 'search', accessorDescriptor('getSearch', 'setSearch'));
  // `URL.prototype.searchParams` getter
  // https://url.spec.whatwg.org/#dom-url-searchparams
  defineBuiltInAccessor(URLPrototype, 'searchParams', accessorDescriptor('getSearchParams'));
  // `URL.prototype.hash` accessors pair
  // https://url.spec.whatwg.org/#dom-url-hash
  defineBuiltInAccessor(URLPrototype, 'hash', accessorDescriptor('getHash', 'setHash'));
}

// `URL.prototype.toJSON` method
// https://url.spec.whatwg.org/#dom-url-tojson
defineBuiltIn(URLPrototype, 'toJSON', function toJSON() {
  return getInternalURLState(this).serialize();
}, { enumerable: true });

// `URL.prototype.toString` method
// https://url.spec.whatwg.org/#URL-stringification-behavior
defineBuiltIn(URLPrototype, 'toString', function toString() {
  return getInternalURLState(this).serialize();
}, { enumerable: true });

if (NativeURL) {
  var nativeCreateObjectURL = NativeURL.createObjectURL;
  var nativeRevokeObjectURL = NativeURL.revokeObjectURL;
  // `URL.createObjectURL` method
  // https://developer.mozilla.org/en-US/docs/Web/API/URL/createObjectURL
  if (nativeCreateObjectURL) defineBuiltIn(URLConstructor, 'createObjectURL', bind(nativeCreateObjectURL, NativeURL));
  // `URL.revokeObjectURL` method
  // https://developer.mozilla.org/en-US/docs/Web/API/URL/revokeObjectURL
  if (nativeRevokeObjectURL) defineBuiltIn(URLConstructor, 'revokeObjectURL', bind(nativeRevokeObjectURL, NativeURL));
}

setToStringTag(URLConstructor, 'URL');

$({ global: true, constructor: true, forced: !USE_NATIVE_URL, sham: !DESCRIPTORS }, {
  URL: URLConstructor
});


/***/ }),

/***/ 3296:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


// TODO: Remove this module from `core-js@4` since it's replaced to module below
__webpack_require__(5806);


/***/ }),

/***/ 7208:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {


var $ = __webpack_require__(6518);
var call = __webpack_require__(9565);

// `URL.prototype.toJSON` method
// https://url.spec.whatwg.org/#dom-url-tojson
$({ target: 'URL', proto: true, enumerable: true }, {
  toJSON: function toJSON() {
    return call(URL.prototype.toString, this);
  }
});


/***/ })

/******/ });
/************************************************************************/
/******/ // The module cache
/******/ var __webpack_module_cache__ = {};
/******/ 
/******/ // The require function
/******/ function __webpack_require__(moduleId) {
/******/ 	// Check if module is in cache
/******/ 	var cachedModule = __webpack_module_cache__[moduleId];
/******/ 	if (cachedModule !== undefined) {
/******/ 		return cachedModule.exports;
/******/ 	}
/******/ 	// Create a new module (and put it into the cache)
/******/ 	var module = __webpack_module_cache__[moduleId] = {
/******/ 		// no module.id needed
/******/ 		// no module.loaded needed
/******/ 		exports: {}
/******/ 	};
/******/ 
/******/ 	// Execute the module function
/******/ 	__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 
/******/ 	// Return the exports of the module
/******/ 	return module.exports;
/******/ }
/******/ 
/************************************************************************/
/******/ /* webpack/runtime/define property getters */
/******/ (() => {
/******/ 	// define getter functions for harmony exports
/******/ 	__webpack_require__.d = (exports, definition) => {
/******/ 		for(var key in definition) {
/******/ 			if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 				Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 			}
/******/ 		}
/******/ 	};
/******/ })();
/******/ 
/******/ /* webpack/runtime/hasOwnProperty shorthand */
/******/ (() => {
/******/ 	__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ })();
/******/ 
/************************************************************************/
var __webpack_exports__ = globalThis.pdfjsLib = {};

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  AbortException: () => (/* reexport */ AbortException),
  AnnotationEditorLayer: () => (/* reexport */ AnnotationEditorLayer),
  AnnotationEditorParamsType: () => (/* reexport */ AnnotationEditorParamsType),
  AnnotationEditorType: () => (/* reexport */ AnnotationEditorType),
  AnnotationEditorUIManager: () => (/* reexport */ AnnotationEditorUIManager),
  AnnotationLayer: () => (/* reexport */ AnnotationLayer),
  AnnotationMode: () => (/* reexport */ AnnotationMode),
  ColorPicker: () => (/* reexport */ ColorPicker),
  DOMSVGFactory: () => (/* reexport */ DOMSVGFactory),
  DrawLayer: () => (/* reexport */ DrawLayer),
  FeatureTest: () => (/* reexport */ util_FeatureTest),
  GlobalWorkerOptions: () => (/* reexport */ GlobalWorkerOptions),
  ImageKind: () => (/* reexport */ util_ImageKind),
  InvalidPDFException: () => (/* reexport */ InvalidPDFException),
  MissingPDFException: () => (/* reexport */ MissingPDFException),
  OPS: () => (/* reexport */ OPS),
  OutputScale: () => (/* reexport */ OutputScale),
  PDFDataRangeTransport: () => (/* reexport */ PDFDataRangeTransport),
  PDFDateString: () => (/* reexport */ PDFDateString),
  PDFWorker: () => (/* reexport */ PDFWorker),
  PasswordResponses: () => (/* reexport */ PasswordResponses),
  PermissionFlag: () => (/* reexport */ PermissionFlag),
  PixelsPerInch: () => (/* reexport */ PixelsPerInch),
  RenderingCancelledException: () => (/* reexport */ RenderingCancelledException),
  TextLayer: () => (/* reexport */ TextLayer),
  TouchManager: () => (/* reexport */ TouchManager),
  UnexpectedResponseException: () => (/* reexport */ UnexpectedResponseException),
  Util: () => (/* reexport */ Util),
  VerbosityLevel: () => (/* reexport */ VerbosityLevel),
  XfaLayer: () => (/* reexport */ XfaLayer),
  build: () => (/* reexport */ build),
  createValidAbsoluteUrl: () => (/* reexport */ createValidAbsoluteUrl),
  fetchData: () => (/* reexport */ fetchData),
  getDocument: () => (/* reexport */ getDocument),
  getFilenameFromUrl: () => (/* reexport */ getFilenameFromUrl),
  getPdfFilenameFromUrl: () => (/* reexport */ getPdfFilenameFromUrl),
  getXfaPageViewport: () => (/* reexport */ getXfaPageViewport),
  isDataScheme: () => (/* reexport */ isDataScheme),
  isPdfFile: () => (/* reexport */ isPdfFile),
  noContextMenu: () => (/* reexport */ noContextMenu),
  normalizeUnicode: () => (/* reexport */ normalizeUnicode),
  setLayerDimensions: () => (/* reexport */ setLayerDimensions),
  shadow: () => (/* reexport */ shadow),
  stopEvent: () => (/* reexport */ stopEvent),
  version: () => (/* reexport */ version)
});

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.global-this.js
var es_global_this = __webpack_require__(5081);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.js
var es_symbol = __webpack_require__(2675);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.description.js
var es_symbol_description = __webpack_require__(9463);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.iterator.js
var es_symbol_iterator = __webpack_require__(2259);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.to-primitive.js
var es_symbol_to_primitive = __webpack_require__(5700);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.error.cause.js
var es_error_cause = __webpack_require__(6280);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.error.to-string.js
var es_error_to_string = __webpack_require__(6918);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.concat.js
var es_array_concat = __webpack_require__(8706);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.from.js
var es_array_from = __webpack_require__(3418);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.includes.js
var es_array_includes = __webpack_require__(4423);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.iterator.js
var es_array_iterator = __webpack_require__(3792);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.join.js
var es_array_join = __webpack_require__(8598);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.push.js
var es_array_push = __webpack_require__(4114);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.slice.js
var es_array_slice = __webpack_require__(4782);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.constructor.js
var es_array_buffer_constructor = __webpack_require__(4743);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.slice.js
var es_array_buffer_slice = __webpack_require__(1745);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.data-view.js
var es_data_view = __webpack_require__(8309);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.detached.js
var es_array_buffer_detached = __webpack_require__(6573);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.transfer.js
var es_array_buffer_transfer = __webpack_require__(8100);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.transfer-to-fixed-length.js
var es_array_buffer_transfer_to_fixed_length = __webpack_require__(7936);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.date.to-primitive.js
var es_date_to_primitive = __webpack_require__(9572);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.map.js
var es_map = __webpack_require__(6033);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.number.constructor.js
var es_number_constructor = __webpack_require__(2892);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.number.is-integer.js
var es_number_is_integer = __webpack_require__(2637);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.get-prototype-of.js
var es_object_get_prototype_of = __webpack_require__(875);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.keys.js
var es_object_keys = __webpack_require__(9432);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.set-prototype-of.js
var es_object_set_prototype_of = __webpack_require__(287);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.to-string.js
var es_object_to_string = __webpack_require__(6099);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.promise.js
var es_promise = __webpack_require__(3362);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.reflect.construct.js
var es_reflect_construct = __webpack_require__(825);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.exec.js
var es_regexp_exec = __webpack_require__(7495);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.test.js
var es_regexp_test = __webpack_require__(906);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.to-string.js
var es_regexp_to_string = __webpack_require__(8781);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.includes.js
var es_string_includes = __webpack_require__(1699);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.iterator.js
var es_string_iterator = __webpack_require__(7764);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.match.js
var es_string_match = __webpack_require__(1761);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.pad-start.js
var es_string_pad_start = __webpack_require__(8156);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.replace.js
var es_string_replace = __webpack_require__(5440);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.replace-all.js
var es_string_replace_all = __webpack_require__(9978);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.starts-with.js
var es_string_starts_with = __webpack_require__(1392);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.uint8-array.js
var es_typed_array_uint8_array = __webpack_require__(1489);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.uint32-array.js
var es_typed_array_uint32_array = __webpack_require__(1740);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.at.js
var es_typed_array_at = __webpack_require__(8140);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.copy-within.js
var es_typed_array_copy_within = __webpack_require__(1630);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.every.js
var es_typed_array_every = __webpack_require__(2170);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.fill.js
var es_typed_array_fill = __webpack_require__(5044);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.filter.js
var es_typed_array_filter = __webpack_require__(1920);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.find.js
var es_typed_array_find = __webpack_require__(1694);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.find-index.js
var es_typed_array_find_index = __webpack_require__(9955);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.find-last.js
var es_typed_array_find_last = __webpack_require__(1903);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.find-last-index.js
var es_typed_array_find_last_index = __webpack_require__(1134);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.for-each.js
var es_typed_array_for_each = __webpack_require__(3206);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.includes.js
var es_typed_array_includes = __webpack_require__(4496);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.index-of.js
var es_typed_array_index_of = __webpack_require__(6651);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.iterator.js
var es_typed_array_iterator = __webpack_require__(2887);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.join.js
var es_typed_array_join = __webpack_require__(9369);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.last-index-of.js
var es_typed_array_last_index_of = __webpack_require__(6812);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.map.js
var es_typed_array_map = __webpack_require__(8995);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.reduce.js
var es_typed_array_reduce = __webpack_require__(1575);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.reduce-right.js
var es_typed_array_reduce_right = __webpack_require__(6072);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.reverse.js
var es_typed_array_reverse = __webpack_require__(8747);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.set.js
var es_typed_array_set = __webpack_require__(8845);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.slice.js
var es_typed_array_slice = __webpack_require__(9423);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.some.js
var es_typed_array_some = __webpack_require__(7301);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.sort.js
var es_typed_array_sort = __webpack_require__(373);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.subarray.js
var es_typed_array_subarray = __webpack_require__(6614);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.to-locale-string.js
var es_typed_array_to_locale_string = __webpack_require__(1405);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.to-reversed.js
var es_typed_array_to_reversed = __webpack_require__(7467);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.to-sorted.js
var es_typed_array_to_sorted = __webpack_require__(4732);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.to-string.js
var es_typed_array_to_string = __webpack_require__(3684);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.with.js
var es_typed_array_with = __webpack_require__(9577);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.promise.try.js
var esnext_promise_try = __webpack_require__(5247);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.atob.js
var web_atob = __webpack_require__(2945);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-collections.iterator.js
var web_dom_collections_iterator = __webpack_require__(2953);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-exception.constructor.js
var web_dom_exception_constructor = __webpack_require__(5815);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-exception.stack.js
var web_dom_exception_stack = __webpack_require__(4979);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-exception.to-string-tag.js
var web_dom_exception_to_string_tag = __webpack_require__(9739);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url.js
var web_url = __webpack_require__(3296);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url.to-json.js
var web_url_to_json = __webpack_require__(7208);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url-search-params.js
var web_url_search_params = __webpack_require__(8408);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url-search-params.delete.js
var web_url_search_params_delete = __webpack_require__(4603);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url-search-params.has.js
var web_url_search_params_has = __webpack_require__(7566);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.url-search-params.size.js
var web_url_search_params_size = __webpack_require__(8721);
;// ./src/shared/util.js
var _Util;
function _assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }



















































































function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var isNodeJS = (typeof process === "undefined" ? "undefined" : _typeof(process)) === "object" && process + "" === "[object process]" && !process.versions.nw && !(process.versions.electron && process.type && process.type !== "browser");
var IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
var FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
var MAX_IMAGE_SIZE_TO_CACHE = 10e6;
var LINE_FACTOR = 1.35;
var LINE_DESCENT_FACTOR = 0.35;
var BASELINE_FACTOR = LINE_DESCENT_FACTOR / LINE_FACTOR;
var RenderingIntentFlag = {
  ANY: 0x01,
  DISPLAY: 0x02,
  PRINT: 0x04,
  SAVE: 0x08,
  ANNOTATIONS_FORMS: 0x10,
  ANNOTATIONS_STORAGE: 0x20,
  ANNOTATIONS_DISABLE: 0x40,
  IS_EDITING: 0x80,
  OPLIST: 0x100
};
var AnnotationMode = {
  DISABLE: 0,
  ENABLE: 1,
  ENABLE_FORMS: 2,
  ENABLE_STORAGE: 3
};
var AnnotationEditorPrefix = "pdfjs_internal_editor_";
var AnnotationEditorType = {
  DISABLE: -1,
  NONE: 0,
  FREETEXT: 3,
  HIGHLIGHT: 9,
  STAMP: 13,
  INK: 15
};
var AnnotationEditorParamsType = {
  RESIZE: 1,
  CREATE: 2,
  FREETEXT_SIZE: 11,
  FREETEXT_COLOR: 12,
  FREETEXT_OPACITY: 13,
  INK_COLOR: 21,
  INK_THICKNESS: 22,
  INK_OPACITY: 23,
  HIGHLIGHT_COLOR: 31,
  HIGHLIGHT_DEFAULT_COLOR: 32,
  HIGHLIGHT_THICKNESS: 33,
  HIGHLIGHT_FREE: 34,
  HIGHLIGHT_SHOW_ALL: 35,
  DRAW_STEP: 41
};
var PermissionFlag = {
  PRINT: 0x04,
  MODIFY_CONTENTS: 0x08,
  COPY: 0x10,
  MODIFY_ANNOTATIONS: 0x20,
  FILL_INTERACTIVE_FORMS: 0x100,
  COPY_FOR_ACCESSIBILITY: 0x200,
  ASSEMBLE: 0x400,
  PRINT_HIGH_QUALITY: 0x800
};
var TextRenderingMode = {
  FILL: 0,
  STROKE: 1,
  FILL_STROKE: 2,
  INVISIBLE: 3,
  FILL_ADD_TO_PATH: 4,
  STROKE_ADD_TO_PATH: 5,
  FILL_STROKE_ADD_TO_PATH: 6,
  ADD_TO_PATH: 7,
  FILL_STROKE_MASK: 3,
  ADD_TO_PATH_FLAG: 4
};
var util_ImageKind = {
  GRAYSCALE_1BPP: 1,
  RGB_24BPP: 2,
  RGBA_32BPP: 3
};
var AnnotationType = {
  TEXT: 1,
  LINK: 2,
  FREETEXT: 3,
  LINE: 4,
  SQUARE: 5,
  CIRCLE: 6,
  POLYGON: 7,
  POLYLINE: 8,
  HIGHLIGHT: 9,
  UNDERLINE: 10,
  SQUIGGLY: 11,
  STRIKEOUT: 12,
  STAMP: 13,
  CARET: 14,
  INK: 15,
  POPUP: 16,
  FILEATTACHMENT: 17,
  SOUND: 18,
  MOVIE: 19,
  WIDGET: 20,
  SCREEN: 21,
  PRINTERMARK: 22,
  TRAPNET: 23,
  WATERMARK: 24,
  THREED: 25,
  REDACT: 26
};
var AnnotationReplyType = {
  GROUP: "Group",
  REPLY: "R"
};
var AnnotationFlag = {
  INVISIBLE: 0x01,
  HIDDEN: 0x02,
  PRINT: 0x04,
  NOZOOM: 0x08,
  NOROTATE: 0x10,
  NOVIEW: 0x20,
  READONLY: 0x40,
  LOCKED: 0x80,
  TOGGLENOVIEW: 0x100,
  LOCKEDCONTENTS: 0x200
};
var AnnotationFieldFlag = {
  READONLY: 0x0000001,
  REQUIRED: 0x0000002,
  NOEXPORT: 0x0000004,
  MULTILINE: 0x0001000,
  PASSWORD: 0x0002000,
  NOTOGGLETOOFF: 0x0004000,
  RADIO: 0x0008000,
  PUSHBUTTON: 0x0010000,
  COMBO: 0x0020000,
  EDIT: 0x0040000,
  SORT: 0x0080000,
  FILESELECT: 0x0100000,
  MULTISELECT: 0x0200000,
  DONOTSPELLCHECK: 0x0400000,
  DONOTSCROLL: 0x0800000,
  COMB: 0x1000000,
  RICHTEXT: 0x2000000,
  RADIOSINUNISON: 0x2000000,
  COMMITONSELCHANGE: 0x4000000
};
var AnnotationBorderStyleType = {
  SOLID: 1,
  DASHED: 2,
  BEVELED: 3,
  INSET: 4,
  UNDERLINE: 5
};
var AnnotationActionEventType = {
  E: "Mouse Enter",
  X: "Mouse Exit",
  D: "Mouse Down",
  U: "Mouse Up",
  Fo: "Focus",
  Bl: "Blur",
  PO: "PageOpen",
  PC: "PageClose",
  PV: "PageVisible",
  PI: "PageInvisible",
  K: "Keystroke",
  F: "Format",
  V: "Validate",
  C: "Calculate"
};
var DocumentActionEventType = {
  WC: "WillClose",
  WS: "WillSave",
  DS: "DidSave",
  WP: "WillPrint",
  DP: "DidPrint"
};
var PageActionEventType = {
  O: "PageOpen",
  C: "PageClose"
};
var VerbosityLevel = {
  ERRORS: 0,
  WARNINGS: 1,
  INFOS: 5
};
var OPS = {
  dependency: 1,
  setLineWidth: 2,
  setLineCap: 3,
  setLineJoin: 4,
  setMiterLimit: 5,
  setDash: 6,
  setRenderingIntent: 7,
  setFlatness: 8,
  setGState: 9,
  save: 10,
  restore: 11,
  transform: 12,
  moveTo: 13,
  lineTo: 14,
  curveTo: 15,
  curveTo2: 16,
  curveTo3: 17,
  closePath: 18,
  rectangle: 19,
  stroke: 20,
  closeStroke: 21,
  fill: 22,
  eoFill: 23,
  fillStroke: 24,
  eoFillStroke: 25,
  closeFillStroke: 26,
  closeEOFillStroke: 27,
  endPath: 28,
  clip: 29,
  eoClip: 30,
  beginText: 31,
  endText: 32,
  setCharSpacing: 33,
  setWordSpacing: 34,
  setHScale: 35,
  setLeading: 36,
  setFont: 37,
  setTextRenderingMode: 38,
  setTextRise: 39,
  moveText: 40,
  setLeadingMoveText: 41,
  setTextMatrix: 42,
  nextLine: 43,
  showText: 44,
  showSpacedText: 45,
  nextLineShowText: 46,
  nextLineSetSpacingShowText: 47,
  setCharWidth: 48,
  setCharWidthAndBounds: 49,
  setStrokeColorSpace: 50,
  setFillColorSpace: 51,
  setStrokeColor: 52,
  setStrokeColorN: 53,
  setFillColor: 54,
  setFillColorN: 55,
  setStrokeGray: 56,
  setFillGray: 57,
  setStrokeRGBColor: 58,
  setFillRGBColor: 59,
  setStrokeCMYKColor: 60,
  setFillCMYKColor: 61,
  shadingFill: 62,
  beginInlineImage: 63,
  beginImageData: 64,
  endInlineImage: 65,
  paintXObject: 66,
  markPoint: 67,
  markPointProps: 68,
  beginMarkedContent: 69,
  beginMarkedContentProps: 70,
  endMarkedContent: 71,
  beginCompat: 72,
  endCompat: 73,
  paintFormXObjectBegin: 74,
  paintFormXObjectEnd: 75,
  beginGroup: 76,
  endGroup: 77,
  beginAnnotation: 80,
  endAnnotation: 81,
  paintImageMaskXObject: 83,
  paintImageMaskXObjectGroup: 84,
  paintImageXObject: 85,
  paintInlineImageXObject: 86,
  paintInlineImageXObjectGroup: 87,
  paintImageXObjectRepeat: 88,
  paintImageMaskXObjectRepeat: 89,
  paintSolidColorImageMask: 90,
  constructPath: 91,
  setStrokeTransparent: 92,
  setFillTransparent: 93
};
var PasswordResponses = {
  NEED_PASSWORD: 1,
  INCORRECT_PASSWORD: 2
};
var verbosity = VerbosityLevel.WARNINGS;
function setVerbosityLevel(level) {
  if (Number.isInteger(level)) {
    verbosity = level;
  }
}
function getVerbosityLevel() {
  return verbosity;
}
function info(msg) {
  if (verbosity >= VerbosityLevel.INFOS) {
    console.log("Info: ".concat(msg));
  }
}
function warn(msg) {
  if (verbosity >= VerbosityLevel.WARNINGS) {
    console.log("Warning: ".concat(msg));
  }
}
function unreachable(msg) {
  throw new Error(msg);
}
function assert(cond, msg) {
  if (!cond) {
    unreachable(msg);
  }
}
function _isValidProtocol(url) {
  switch (url === null || url === void 0 ? void 0 : url.protocol) {
    case "http:":
    case "https:":
    case "ftp:":
    case "mailto:":
    case "tel:":
      return true;
    default:
      return false;
  }
}
function createValidAbsoluteUrl(url) {
  var baseUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  if (!url) {
    return null;
  }
  try {
    if (options && typeof url === "string") {
      if (options.addDefaultProtocol && url.startsWith("www.")) {
        var dots = url.match(/\./g);
        if ((dots === null || dots === void 0 ? void 0 : dots.length) >= 2) {
          url = "http://".concat(url);
        }
      }
      if (options.tryConvertEncoding) {
        try {
          url = stringToUTF8String(url);
        } catch (_unused) {}
      }
    }
    var absoluteUrl = baseUrl ? new URL(url, baseUrl) : new URL(url);
    if (_isValidProtocol(absoluteUrl)) {
      return absoluteUrl;
    }
  } catch (_unused2) {}
  return null;
}
function shadow(obj, prop, value) {
  var nonSerializable = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  Object.defineProperty(obj, prop, {
    value: value,
    enumerable: !nonSerializable,
    configurable: true,
    writable: false
  });
  return value;
}
var BaseException = function BaseExceptionClosure() {
  function BaseException(message, name) {
    this.message = message;
    this.name = name;
  }
  BaseException.prototype = new Error();
  BaseException.constructor = BaseException;
  return BaseException;
}();
var PasswordException = /*#__PURE__*/function (_BaseException) {
  function PasswordException(msg, code) {
    var _this;
    _classCallCheck(this, PasswordException);
    _this = _callSuper(this, PasswordException, [msg, "PasswordException"]);
    _this.code = code;
    return _this;
  }
  _inherits(PasswordException, _BaseException);
  return _createClass(PasswordException);
}(BaseException);
var UnknownErrorException = /*#__PURE__*/function (_BaseException2) {
  function UnknownErrorException(msg, details) {
    var _this2;
    _classCallCheck(this, UnknownErrorException);
    _this2 = _callSuper(this, UnknownErrorException, [msg, "UnknownErrorException"]);
    _this2.details = details;
    return _this2;
  }
  _inherits(UnknownErrorException, _BaseException2);
  return _createClass(UnknownErrorException);
}(BaseException);
var InvalidPDFException = /*#__PURE__*/function (_BaseException3) {
  function InvalidPDFException(msg) {
    _classCallCheck(this, InvalidPDFException);
    return _callSuper(this, InvalidPDFException, [msg, "InvalidPDFException"]);
  }
  _inherits(InvalidPDFException, _BaseException3);
  return _createClass(InvalidPDFException);
}(BaseException);
var MissingPDFException = /*#__PURE__*/function (_BaseException4) {
  function MissingPDFException(msg) {
    _classCallCheck(this, MissingPDFException);
    return _callSuper(this, MissingPDFException, [msg, "MissingPDFException"]);
  }
  _inherits(MissingPDFException, _BaseException4);
  return _createClass(MissingPDFException);
}(BaseException);
var UnexpectedResponseException = /*#__PURE__*/function (_BaseException5) {
  function UnexpectedResponseException(msg, status) {
    var _this3;
    _classCallCheck(this, UnexpectedResponseException);
    _this3 = _callSuper(this, UnexpectedResponseException, [msg, "UnexpectedResponseException"]);
    _this3.status = status;
    return _this3;
  }
  _inherits(UnexpectedResponseException, _BaseException5);
  return _createClass(UnexpectedResponseException);
}(BaseException);
var FormatError = /*#__PURE__*/function (_BaseException6) {
  function FormatError(msg) {
    _classCallCheck(this, FormatError);
    return _callSuper(this, FormatError, [msg, "FormatError"]);
  }
  _inherits(FormatError, _BaseException6);
  return _createClass(FormatError);
}(BaseException);
var AbortException = /*#__PURE__*/function (_BaseException7) {
  function AbortException(msg) {
    _classCallCheck(this, AbortException);
    return _callSuper(this, AbortException, [msg, "AbortException"]);
  }
  _inherits(AbortException, _BaseException7);
  return _createClass(AbortException);
}(BaseException);
function bytesToString(bytes) {
  if (_typeof(bytes) !== "object" || (bytes === null || bytes === void 0 ? void 0 : bytes.length) === undefined) {
    unreachable("Invalid argument for bytesToString");
  }
  var length = bytes.length;
  var MAX_ARGUMENT_COUNT = 8192;
  if (length < MAX_ARGUMENT_COUNT) {
    return String.fromCharCode.apply(null, bytes);
  }
  var strBuf = [];
  for (var i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
    var chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
    var chunk = bytes.subarray(i, chunkEnd);
    strBuf.push(String.fromCharCode.apply(null, chunk));
  }
  return strBuf.join("");
}
function stringToBytes(str) {
  if (typeof str !== "string") {
    unreachable("Invalid argument for stringToBytes");
  }
  var length = str.length;
  var bytes = new Uint8Array(length);
  for (var i = 0; i < length; ++i) {
    bytes[i] = str.charCodeAt(i) & 0xff;
  }
  return bytes;
}
function string32(value) {
  return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
}
function objectSize(obj) {
  return Object.keys(obj).length;
}
function objectFromMap(map) {
  var obj = Object.create(null);
  var _iterator = _createForOfIteratorHelper(map),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _slicedToArray(_step.value, 2),
        key = _step$value[0],
        value = _step$value[1];
      obj[key] = value;
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return obj;
}
function isLittleEndian() {
  var buffer8 = new Uint8Array(4);
  buffer8[0] = 1;
  var view32 = new Uint32Array(buffer8.buffer, 0, 1);
  return view32[0] === 1;
}
function isEvalSupported() {
  try {
    new Function("");
    return true;
  } catch (_unused3) {
    return false;
  }
}
var util_FeatureTest = /*#__PURE__*/function () {
  function FeatureTest() {
    _classCallCheck(this, FeatureTest);
  }
  return _createClass(FeatureTest, null, [{
    key: "isLittleEndian",
    get: function get() {
      return shadow(this, "isLittleEndian", isLittleEndian());
    }
  }, {
    key: "isEvalSupported",
    get: function get() {
      return shadow(this, "isEvalSupported", isEvalSupported());
    }
  }, {
    key: "isOffscreenCanvasSupported",
    get: function get() {
      return shadow(this, "isOffscreenCanvasSupported", typeof OffscreenCanvas !== "undefined");
    }
  }, {
    key: "isImageDecoderSupported",
    get: function get() {
      return shadow(this, "isImageDecoderSupported", typeof ImageDecoder !== "undefined");
    }
  }, {
    key: "platform",
    get: function get() {
      var _navigator;
      if (typeof navigator !== "undefined" && typeof ((_navigator = navigator) === null || _navigator === void 0 ? void 0 : _navigator.platform) === "string") {
        var _navigator2;
        return shadow(this, "platform", {
          isMac: navigator.platform.includes("Mac"),
          isWindows: navigator.platform.includes("Win"),
          isFirefox: typeof ((_navigator2 = navigator) === null || _navigator2 === void 0 ? void 0 : _navigator2.userAgent) === "string" && navigator.userAgent.includes("Firefox")
        });
      }
      return shadow(this, "platform", {
        isMac: false,
        isWindows: false,
        isFirefox: false
      });
    }
  }, {
    key: "isCSSRoundSupported",
    get: function get() {
      var _globalThis$CSS, _globalThis$CSS$suppo;
      return shadow(this, "isCSSRoundSupported", (_globalThis$CSS = globalThis.CSS) === null || _globalThis$CSS === void 0 || (_globalThis$CSS$suppo = _globalThis$CSS.supports) === null || _globalThis$CSS$suppo === void 0 ? void 0 : _globalThis$CSS$suppo.call(_globalThis$CSS, "width: round(1.5px, 1px)"));
    }
  }]);
}();
var hexNumbers = Array.from(Array(256).keys(), function (n) {
  return n.toString(16).padStart(2, "0");
});
var Util = /*#__PURE__*/function () {
  function Util() {
    _classCallCheck(this, Util);
  }
  return _createClass(Util, null, [{
    key: "makeHexColor",
    value: function makeHexColor(r, g, b) {
      return "#".concat(hexNumbers[r]).concat(hexNumbers[g]).concat(hexNumbers[b]);
    }
  }, {
    key: "scaleMinMax",
    value: function scaleMinMax(transform, minMax) {
      var temp;
      if (transform[0]) {
        if (transform[0] < 0) {
          temp = minMax[0];
          minMax[0] = minMax[2];
          minMax[2] = temp;
        }
        minMax[0] *= transform[0];
        minMax[2] *= transform[0];
        if (transform[3] < 0) {
          temp = minMax[1];
          minMax[1] = minMax[3];
          minMax[3] = temp;
        }
        minMax[1] *= transform[3];
        minMax[3] *= transform[3];
      } else {
        temp = minMax[0];
        minMax[0] = minMax[1];
        minMax[1] = temp;
        temp = minMax[2];
        minMax[2] = minMax[3];
        minMax[3] = temp;
        if (transform[1] < 0) {
          temp = minMax[1];
          minMax[1] = minMax[3];
          minMax[3] = temp;
        }
        minMax[1] *= transform[1];
        minMax[3] *= transform[1];
        if (transform[2] < 0) {
          temp = minMax[0];
          minMax[0] = minMax[2];
          minMax[2] = temp;
        }
        minMax[0] *= transform[2];
        minMax[2] *= transform[2];
      }
      minMax[0] += transform[4];
      minMax[1] += transform[5];
      minMax[2] += transform[4];
      minMax[3] += transform[5];
    }
  }, {
    key: "transform",
    value: function transform(m1, m2) {
      return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
    }
  }, {
    key: "applyTransform",
    value: function applyTransform(p, m) {
      var xt = p[0] * m[0] + p[1] * m[2] + m[4];
      var yt = p[0] * m[1] + p[1] * m[3] + m[5];
      return [xt, yt];
    }
  }, {
    key: "applyInverseTransform",
    value: function applyInverseTransform(p, m) {
      var d = m[0] * m[3] - m[1] * m[2];
      var xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
      var yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
      return [xt, yt];
    }
  }, {
    key: "getAxialAlignedBoundingBox",
    value: function getAxialAlignedBoundingBox(r, m) {
      var p1 = this.applyTransform(r, m);
      var p2 = this.applyTransform(r.slice(2, 4), m);
      var p3 = this.applyTransform([r[0], r[3]], m);
      var p4 = this.applyTransform([r[2], r[1]], m);
      return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
    }
  }, {
    key: "inverseTransform",
    value: function inverseTransform(m) {
      var d = m[0] * m[3] - m[1] * m[2];
      return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
    }
  }, {
    key: "singularValueDecompose2dScale",
    value: function singularValueDecompose2dScale(m) {
      var transpose = [m[0], m[2], m[1], m[3]];
      var a = m[0] * transpose[0] + m[1] * transpose[2];
      var b = m[0] * transpose[1] + m[1] * transpose[3];
      var c = m[2] * transpose[0] + m[3] * transpose[2];
      var d = m[2] * transpose[1] + m[3] * transpose[3];
      var first = (a + d) / 2;
      var second = Math.sqrt(Math.pow(a + d, 2) - 4 * (a * d - c * b)) / 2;
      var sx = first + second || 1;
      var sy = first - second || 1;
      return [Math.sqrt(sx), Math.sqrt(sy)];
    }
  }, {
    key: "normalizeRect",
    value: function normalizeRect(rect) {
      var r = rect.slice(0);
      if (rect[0] > rect[2]) {
        r[0] = rect[2];
        r[2] = rect[0];
      }
      if (rect[1] > rect[3]) {
        r[1] = rect[3];
        r[3] = rect[1];
      }
      return r;
    }
  }, {
    key: "intersect",
    value: function intersect(rect1, rect2) {
      var xLow = Math.max(Math.min(rect1[0], rect1[2]), Math.min(rect2[0], rect2[2]));
      var xHigh = Math.min(Math.max(rect1[0], rect1[2]), Math.max(rect2[0], rect2[2]));
      if (xLow > xHigh) {
        return null;
      }
      var yLow = Math.max(Math.min(rect1[1], rect1[3]), Math.min(rect2[1], rect2[3]));
      var yHigh = Math.min(Math.max(rect1[1], rect1[3]), Math.max(rect2[1], rect2[3]));
      if (yLow > yHigh) {
        return null;
      }
      return [xLow, yLow, xHigh, yHigh];
    }
  }, {
    key: "bezierBoundingBox",
    value: function bezierBoundingBox(x0, y0, x1, y1, x2, y2, x3, y3, minMax) {
      if (minMax) {
        minMax[0] = Math.min(minMax[0], x0, x3);
        minMax[1] = Math.min(minMax[1], y0, y3);
        minMax[2] = Math.max(minMax[2], x0, x3);
        minMax[3] = Math.max(minMax[3], y0, y3);
      } else {
        minMax = [Math.min(x0, x3), Math.min(y0, y3), Math.max(x0, x3), Math.max(y0, y3)];
      }
      _assertClassBrand(Util, this, _getExtremum).call(this, x0, x1, x2, x3, y0, y1, y2, y3, 3 * (-x0 + 3 * (x1 - x2) + x3), 6 * (x0 - 2 * x1 + x2), 3 * (x1 - x0), minMax);
      _assertClassBrand(Util, this, _getExtremum).call(this, x0, x1, x2, x3, y0, y1, y2, y3, 3 * (-y0 + 3 * (y1 - y2) + y3), 6 * (y0 - 2 * y1 + y2), 3 * (y1 - y0), minMax);
      return minMax;
    }
  }]);
}();
_Util = Util;
function _getExtremumOnCurve(x0, x1, x2, x3, y0, y1, y2, y3, t, minMax) {
  if (t <= 0 || t >= 1) {
    return;
  }
  var mt = 1 - t;
  var tt = t * t;
  var ttt = tt * t;
  var x = mt * (mt * (mt * x0 + 3 * t * x1) + 3 * tt * x2) + ttt * x3;
  var y = mt * (mt * (mt * y0 + 3 * t * y1) + 3 * tt * y2) + ttt * y3;
  minMax[0] = Math.min(minMax[0], x);
  minMax[1] = Math.min(minMax[1], y);
  minMax[2] = Math.max(minMax[2], x);
  minMax[3] = Math.max(minMax[3], y);
}
function _getExtremum(x0, x1, x2, x3, y0, y1, y2, y3, a, b, c, minMax) {
  if (Math.abs(a) < 1e-12) {
    if (Math.abs(b) >= 1e-12) {
      _assertClassBrand(_Util, this, _getExtremumOnCurve).call(this, x0, x1, x2, x3, y0, y1, y2, y3, -c / b, minMax);
    }
    return;
  }
  var delta = Math.pow(b, 2) - 4 * c * a;
  if (delta < 0) {
    return;
  }
  var sqrtDelta = Math.sqrt(delta);
  var a2 = 2 * a;
  _assertClassBrand(_Util, this, _getExtremumOnCurve).call(this, x0, x1, x2, x3, y0, y1, y2, y3, (-b + sqrtDelta) / a2, minMax);
  _assertClassBrand(_Util, this, _getExtremumOnCurve).call(this, x0, x1, x2, x3, y0, y1, y2, y3, (-b - sqrtDelta) / a2, minMax);
}
var PDFStringTranslateTable = (/* unused pure expression or super */ null && ([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2d8, 0x2c7, 0x2c6, 0x2d9, 0x2dd, 0x2db, 0x2da, 0x2dc, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203a, 0x2212, 0x2030, 0x201e, 0x201c, 0x201d, 0x2018, 0x2019, 0x201a, 0x2122, 0xfb01, 0xfb02, 0x141, 0x152, 0x160, 0x178, 0x17d, 0x131, 0x142, 0x153, 0x161, 0x17e, 0, 0x20ac]));
function stringToPDFString(str) {
  if (str[0] >= "\xEF") {
    var encoding;
    if (str[0] === "\xFE" && str[1] === "\xFF") {
      encoding = "utf-16be";
      if (str.length % 2 === 1) {
        str = str.slice(0, -1);
      }
    } else if (str[0] === "\xFF" && str[1] === "\xFE") {
      encoding = "utf-16le";
      if (str.length % 2 === 1) {
        str = str.slice(0, -1);
      }
    } else if (str[0] === "\xEF" && str[1] === "\xBB" && str[2] === "\xBF") {
      encoding = "utf-8";
    }
    if (encoding) {
      try {
        var decoder = new TextDecoder(encoding, {
          fatal: true
        });
        var buffer = stringToBytes(str);
        var decoded = decoder.decode(buffer);
        if (!decoded.includes("\x1b")) {
          return decoded;
        }
        return decoded.replaceAll(/\x1b[^\x1b]*(?:\x1b|$)/g, "");
      } catch (ex) {
        warn("stringToPDFString: \"".concat(ex, "\"."));
      }
    }
  }
  var strBuf = [];
  for (var i = 0, ii = str.length; i < ii; i++) {
    var charCode = str.charCodeAt(i);
    if (charCode === 0x1b) {
      while (++i < ii && str.charCodeAt(i) !== 0x1b) {}
      continue;
    }
    var code = PDFStringTranslateTable[charCode];
    strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
  }
  return strBuf.join("");
}
function stringToUTF8String(str) {
  return decodeURIComponent(escape(str));
}
function utf8StringToString(str) {
  return unescape(encodeURIComponent(str));
}
function isArrayEqual(arr1, arr2) {
  if (arr1.length !== arr2.length) {
    return false;
  }
  for (var i = 0, ii = arr1.length; i < ii; i++) {
    if (arr1[i] !== arr2[i]) {
      return false;
    }
  }
  return true;
}
function getModificationDate() {
  var date = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new Date();
  var buffer = [date.getUTCFullYear().toString(), (date.getUTCMonth() + 1).toString().padStart(2, "0"), date.getUTCDate().toString().padStart(2, "0"), date.getUTCHours().toString().padStart(2, "0"), date.getUTCMinutes().toString().padStart(2, "0"), date.getUTCSeconds().toString().padStart(2, "0")];
  return buffer.join("");
}
var NormalizeRegex = null;
var NormalizationMap = null;
function normalizeUnicode(str) {
  if (!NormalizeRegex) {
    NormalizeRegex = /([\xA0\xB5\u037E\u0EB3\u2000-\u200A\u202F\u2126\uFB00-\uFB04\uFB06\uFB20-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBA1\uFBA4-\uFBA9\uFBAE-\uFBB1\uFBD3-\uFBDC\uFBDE-\uFBE7\uFBEA-\uFBF8\uFBFC\uFBFD\uFC00-\uFC5D\uFC64-\uFCF1\uFCF5-\uFD3D\uFD88\uFDF4\uFDFA\uFDFB\uFE71\uFE77\uFE79\uFE7B\uFE7D]+)|(\uFB05+)/g;
    NormalizationMap = new Map([["ﬅ", "ſt"]]);
  }
  return str.replaceAll(NormalizeRegex, function (_, p1, p2) {
    return p1 ? p1.normalize("NFKC") : NormalizationMap.get(p2);
  });
}
function getUuid() {
  if (typeof crypto.randomUUID === "function") {
    return crypto.randomUUID();
  }
  var buf = new Uint8Array(32);
  crypto.getRandomValues(buf);
  return bytesToString(buf);
}
var AnnotationPrefix = "pdfjs_internal_id_";
function toHexUtil(arr) {
  if (Uint8Array.prototype.toHex) {
    return arr.toHex();
  }
  return Array.from(arr, function (num) {
    return hexNumbers[num];
  }).join("");
}
function toBase64Util(arr) {
  if (Uint8Array.prototype.toBase64) {
    return arr.toBase64();
  }
  return btoa(bytesToString(arr));
}
function fromBase64Util(str) {
  if (Uint8Array.fromBase64) {
    return Uint8Array.fromBase64(str);
  }
  return stringToBytes(atob(str));
}

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.async-iterator.js
var es_symbol_async_iterator = __webpack_require__(6412);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.to-string-tag.js
var es_symbol_to_string_tag = __webpack_require__(8125);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.filter.js
var es_array_filter = __webpack_require__(2008);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.map.js
var es_array_map = __webpack_require__(2062);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.for-each.js
var es_array_for_each = __webpack_require__(1629);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.reverse.js
var es_array_reverse = __webpack_require__(4490);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array-buffer.is-view.js
var es_array_buffer_is_view = __webpack_require__(9142);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.json.to-string-tag.js
var es_json_to_string_tag = __webpack_require__(4731);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.math.to-string-tag.js
var es_math_to_string_tag = __webpack_require__(479);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.assign.js
var es_object_assign = __webpack_require__(9085);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.get-own-property-descriptor.js
var es_object_get_own_property_descriptor = __webpack_require__(3851);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.get-own-property-descriptors.js
var es_object_get_own_property_descriptors = __webpack_require__(1278);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.promise.finally.js
var es_promise_finally = __webpack_require__(9391);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.promise.with-resolvers.js
var es_promise_with_resolvers = __webpack_require__(4628);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.js
var es_set = __webpack_require__(1415);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.difference.v2.js
var es_set_difference_v2 = __webpack_require__(7642);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.intersection.v2.js
var es_set_intersection_v2 = __webpack_require__(8004);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.is-disjoint-from.v2.js
var es_set_is_disjoint_from_v2 = __webpack_require__(3853);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.is-subset-of.v2.js
var es_set_is_subset_of_v2 = __webpack_require__(5876);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.is-superset-of.v2.js
var es_set_is_superset_of_v2 = __webpack_require__(2475);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.symmetric-difference.v2.js
var es_set_symmetric_difference_v2 = __webpack_require__(5024);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.set.union.v2.js
var es_set_union_v2 = __webpack_require__(1698);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.weak-map.js
var es_weak_map = __webpack_require__(3772);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.weak-set.js
var es_weak_set = __webpack_require__(958);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.filter.js
var esnext_iterator_filter = __webpack_require__(4520);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.map.js
var esnext_iterator_map = __webpack_require__(1454);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.constructor.js
var esnext_iterator_constructor = __webpack_require__(8992);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.for-each.js
var esnext_iterator_for_each = __webpack_require__(3949);
// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-collections.for-each.js
var web_dom_collections_for_each = __webpack_require__(3500);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.date.to-json.js
var es_date_to_json = __webpack_require__(739);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.json.stringify.js
var es_json_stringify = __webpack_require__(3110);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.entries.js
var es_object_entries = __webpack_require__(5506);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.freeze.js
var es_object_freeze = __webpack_require__(2811);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.math.hypot.js
var es_math_hypot = __webpack_require__(9469);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.number.to-fixed.js
var es_number_to_fixed = __webpack_require__(9868);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.parse-float.js
var es_parse_float = __webpack_require__(8459);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.ends-with.js
var es_string_ends_with = __webpack_require__(9449);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.at.js
var es_array_at = __webpack_require__(8107);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.every.js
var es_array_every = __webpack_require__(8431);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.some.js
var es_array_some = __webpack_require__(5086);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.splice.js
var es_array_splice = __webpack_require__(4554);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.at-alternative.js
var es_string_at_alternative = __webpack_require__(7357);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.trim.js
var es_string_trim = __webpack_require__(2762);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.drop.js
var esnext_iterator_drop = __webpack_require__(7124);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.every.js
var esnext_iterator_every = __webpack_require__(3215);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.some.js
var esnext_iterator_some = __webpack_require__(7550);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.json.parse.js
var esnext_json_parse = __webpack_require__(8335);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.last-index-of.js
var es_array_last_index_of = __webpack_require__(8921);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.parse-int.js
var es_parse_int = __webpack_require__(8940);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.constructor.js
var es_regexp_constructor = __webpack_require__(4864);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.dot-all.js
var es_regexp_dot_all = __webpack_require__(7465);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.regexp.sticky.js
var es_regexp_sticky = __webpack_require__(7745);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.pad-end.js
var es_string_pad_end = __webpack_require__(5701);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.split.js
var es_string_split = __webpack_require__(744);
;// ./src/display/display_utils.js
var _PixelsPerInch;
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == display_utils_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(display_utils_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function display_utils_typeof(o) { "@babel/helpers - typeof"; return display_utils_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, display_utils_typeof(o); }
function display_utils_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function display_utils_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = display_utils_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function display_utils_slicedToArray(r, e) { return display_utils_arrayWithHoles(r) || display_utils_iterableToArrayLimit(r, e) || display_utils_unsupportedIterableToArray(r, e) || display_utils_nonIterableRest(); }
function display_utils_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function display_utils_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return display_utils_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? display_utils_arrayLikeToArray(r, a) : void 0; } }
function display_utils_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function display_utils_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function display_utils_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function display_utils_callSuper(t, o, e) { return o = display_utils_getPrototypeOf(o), display_utils_possibleConstructorReturn(t, display_utils_isNativeReflectConstruct() ? Reflect.construct(o, e || [], display_utils_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function display_utils_possibleConstructorReturn(t, e) { if (e && ("object" == display_utils_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return display_utils_assertThisInitialized(t); }
function display_utils_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function display_utils_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (display_utils_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function display_utils_getPrototypeOf(t) { return display_utils_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, display_utils_getPrototypeOf(t); }
function display_utils_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && display_utils_setPrototypeOf(t, e); }
function display_utils_setPrototypeOf(t, e) { return display_utils_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, display_utils_setPrototypeOf(t, e); }




















































function asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function _asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function display_utils_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, display_utils_toPropertyKey(o.key), o); } }
function display_utils_createClass(e, r, t) { return r && display_utils_defineProperties(e.prototype, r), t && display_utils_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function display_utils_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperty(e, r, t) { return (r = display_utils_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function display_utils_toPropertyKey(t) { var i = display_utils_toPrimitive(t, "string"); return "symbol" == display_utils_typeof(i) ? i : i + ""; }
function display_utils_toPrimitive(t, r) { if ("object" != display_utils_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != display_utils_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

var SVG_NS = "http://www.w3.org/2000/svg";
var PixelsPerInch = /*#__PURE__*/display_utils_createClass(function PixelsPerInch() {
  display_utils_classCallCheck(this, PixelsPerInch);
});
_PixelsPerInch = PixelsPerInch;
_defineProperty(PixelsPerInch, "CSS", 96.0);
_defineProperty(PixelsPerInch, "PDF", 72.0);
_defineProperty(PixelsPerInch, "PDF_TO_CSS_UNITS", _PixelsPerInch.CSS / _PixelsPerInch.PDF);
function fetchData(_x) {
  return _fetchData.apply(this, arguments);
}
function _fetchData() {
  _fetchData = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(url) {
    var type,
      response,
      _args = arguments;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          type = _args.length > 1 && _args[1] !== undefined ? _args[1] : "text";
          if (!isValidFetchUrl(url, document.baseURI)) {
            _context.next = 14;
            break;
          }
          _context.next = 4;
          return fetch(url);
        case 4:
          response = _context.sent;
          if (response.ok) {
            _context.next = 7;
            break;
          }
          throw new Error(response.statusText);
        case 7:
          _context.t0 = type;
          _context.next = _context.t0 === "arraybuffer" ? 10 : _context.t0 === "blob" ? 11 : _context.t0 === "json" ? 12 : 13;
          break;
        case 10:
          return _context.abrupt("return", response.arrayBuffer());
        case 11:
          return _context.abrupt("return", response.blob());
        case 12:
          return _context.abrupt("return", response.json());
        case 13:
          return _context.abrupt("return", response.text());
        case 14:
          return _context.abrupt("return", new Promise(function (resolve, reject) {
            var request = new XMLHttpRequest();
            request.open("GET", url, true);
            request.responseType = type;
            request.onreadystatechange = function () {
              if (request.readyState !== XMLHttpRequest.DONE) {
                return;
              }
              if (request.status === 200 || request.status === 0) {
                switch (type) {
                  case "arraybuffer":
                  case "blob":
                  case "json":
                    resolve(request.response);
                    return;
                }
                resolve(request.responseText);
                return;
              }
              reject(new Error(request.statusText));
            };
            request.send(null);
          }));
        case 15:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _fetchData.apply(this, arguments);
}
var PageViewport = /*#__PURE__*/function () {
  function PageViewport(_ref) {
    var viewBox = _ref.viewBox,
      userUnit = _ref.userUnit,
      scale = _ref.scale,
      rotation = _ref.rotation,
      _ref$offsetX = _ref.offsetX,
      offsetX = _ref$offsetX === void 0 ? 0 : _ref$offsetX,
      _ref$offsetY = _ref.offsetY,
      offsetY = _ref$offsetY === void 0 ? 0 : _ref$offsetY,
      _ref$dontFlip = _ref.dontFlip,
      dontFlip = _ref$dontFlip === void 0 ? false : _ref$dontFlip;
    display_utils_classCallCheck(this, PageViewport);
    this.viewBox = viewBox;
    this.userUnit = userUnit;
    this.scale = scale;
    this.rotation = rotation;
    this.offsetX = offsetX;
    this.offsetY = offsetY;
    scale *= userUnit;
    var centerX = (viewBox[2] + viewBox[0]) / 2;
    var centerY = (viewBox[3] + viewBox[1]) / 2;
    var rotateA, rotateB, rotateC, rotateD;
    rotation %= 360;
    if (rotation < 0) {
      rotation += 360;
    }
    switch (rotation) {
      case 180:
        rotateA = -1;
        rotateB = 0;
        rotateC = 0;
        rotateD = 1;
        break;
      case 90:
        rotateA = 0;
        rotateB = 1;
        rotateC = 1;
        rotateD = 0;
        break;
      case 270:
        rotateA = 0;
        rotateB = -1;
        rotateC = -1;
        rotateD = 0;
        break;
      case 0:
        rotateA = 1;
        rotateB = 0;
        rotateC = 0;
        rotateD = -1;
        break;
      default:
        throw new Error("PageViewport: Invalid rotation, must be a multiple of 90 degrees.");
    }
    if (dontFlip) {
      rotateC = -rotateC;
      rotateD = -rotateD;
    }
    var offsetCanvasX, offsetCanvasY;
    var width, height;
    if (rotateA === 0) {
      offsetCanvasX = Math.abs(centerY - viewBox[1]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerX - viewBox[0]) * scale + offsetY;
      width = (viewBox[3] - viewBox[1]) * scale;
      height = (viewBox[2] - viewBox[0]) * scale;
    } else {
      offsetCanvasX = Math.abs(centerX - viewBox[0]) * scale + offsetX;
      offsetCanvasY = Math.abs(centerY - viewBox[1]) * scale + offsetY;
      width = (viewBox[2] - viewBox[0]) * scale;
      height = (viewBox[3] - viewBox[1]) * scale;
    }
    this.transform = [rotateA * scale, rotateB * scale, rotateC * scale, rotateD * scale, offsetCanvasX - rotateA * scale * centerX - rotateC * scale * centerY, offsetCanvasY - rotateB * scale * centerX - rotateD * scale * centerY];
    this.width = width;
    this.height = height;
  }
  return display_utils_createClass(PageViewport, [{
    key: "rawDims",
    get: function get() {
      var userUnit = this.userUnit,
        viewBox = this.viewBox;
      var dims = viewBox.map(function (x) {
        return x * userUnit;
      });
      return shadow(this, "rawDims", {
        pageWidth: dims[2] - dims[0],
        pageHeight: dims[3] - dims[1],
        pageX: dims[0],
        pageY: dims[1]
      });
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref2$scale = _ref2.scale,
        scale = _ref2$scale === void 0 ? this.scale : _ref2$scale,
        _ref2$rotation = _ref2.rotation,
        rotation = _ref2$rotation === void 0 ? this.rotation : _ref2$rotation,
        _ref2$offsetX = _ref2.offsetX,
        offsetX = _ref2$offsetX === void 0 ? this.offsetX : _ref2$offsetX,
        _ref2$offsetY = _ref2.offsetY,
        offsetY = _ref2$offsetY === void 0 ? this.offsetY : _ref2$offsetY,
        _ref2$dontFlip = _ref2.dontFlip,
        dontFlip = _ref2$dontFlip === void 0 ? false : _ref2$dontFlip;
      return new PageViewport({
        viewBox: this.viewBox.slice(),
        userUnit: this.userUnit,
        scale: scale,
        rotation: rotation,
        offsetX: offsetX,
        offsetY: offsetY,
        dontFlip: dontFlip
      });
    }
  }, {
    key: "convertToViewportPoint",
    value: function convertToViewportPoint(x, y) {
      return Util.applyTransform([x, y], this.transform);
    }
  }, {
    key: "convertToViewportRectangle",
    value: function convertToViewportRectangle(rect) {
      var topLeft = Util.applyTransform([rect[0], rect[1]], this.transform);
      var bottomRight = Util.applyTransform([rect[2], rect[3]], this.transform);
      return [topLeft[0], topLeft[1], bottomRight[0], bottomRight[1]];
    }
  }, {
    key: "convertToPdfPoint",
    value: function convertToPdfPoint(x, y) {
      return Util.applyInverseTransform([x, y], this.transform);
    }
  }]);
}();
var RenderingCancelledException = /*#__PURE__*/function (_BaseException) {
  function RenderingCancelledException(msg) {
    var _this;
    var extraDelay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    display_utils_classCallCheck(this, RenderingCancelledException);
    _this = display_utils_callSuper(this, RenderingCancelledException, [msg, "RenderingCancelledException"]);
    _this.extraDelay = extraDelay;
    return _this;
  }
  display_utils_inherits(RenderingCancelledException, _BaseException);
  return display_utils_createClass(RenderingCancelledException);
}(BaseException);
function isDataScheme(url) {
  var ii = url.length;
  var i = 0;
  while (i < ii && url[i].trim() === "") {
    i++;
  }
  return url.substring(i, i + 5).toLowerCase() === "data:";
}
function isPdfFile(filename) {
  return typeof filename === "string" && /\.pdf$/i.test(filename);
}
function getFilenameFromUrl(url) {
  var _url$split = url.split(/[#?]/, 1);
  var _url$split2 = display_utils_slicedToArray(_url$split, 1);
  url = _url$split2[0];
  return url.substring(url.lastIndexOf("/") + 1);
}
function getPdfFilenameFromUrl(url) {
  var defaultFilename = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "document.pdf";
  if (typeof url !== "string") {
    return defaultFilename;
  }
  if (isDataScheme(url)) {
    warn('getPdfFilenameFromUrl: ignore "data:"-URL for performance reasons.');
    return defaultFilename;
  }
  var reURI = /^(?:(?:[^:]+:)?\/\/[^/]+)?([^?#]*)(\?[^#]*)?(#.*)?$/;
  var reFilename = /[^/?#=]+\.pdf\b(?!.*\.pdf\b)/i;
  var splitURI = reURI.exec(url);
  var suggestedFilename = reFilename.exec(splitURI[1]) || reFilename.exec(splitURI[2]) || reFilename.exec(splitURI[3]);
  if (suggestedFilename) {
    suggestedFilename = suggestedFilename[0];
    if (suggestedFilename.includes("%")) {
      try {
        suggestedFilename = reFilename.exec(decodeURIComponent(suggestedFilename))[0];
      } catch (_unused) {}
    }
  }
  return suggestedFilename || defaultFilename;
}
var StatTimer = /*#__PURE__*/function () {
  function StatTimer() {
    display_utils_classCallCheck(this, StatTimer);
    _defineProperty(this, "started", Object.create(null));
    _defineProperty(this, "times", []);
  }
  return display_utils_createClass(StatTimer, [{
    key: "time",
    value: function time(name) {
      if (name in this.started) {
        warn("Timer is already running for ".concat(name));
      }
      this.started[name] = Date.now();
    }
  }, {
    key: "timeEnd",
    value: function timeEnd(name) {
      if (!(name in this.started)) {
        warn("Timer has not been started for ".concat(name));
      }
      this.times.push({
        name: name,
        start: this.started[name],
        end: Date.now()
      });
      delete this.started[name];
    }
  }, {
    key: "toString",
    value: function toString() {
      var outBuf = [];
      var longest = 0;
      var _iterator = display_utils_createForOfIteratorHelper(this.times),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var name = _step.value.name;
          longest = Math.max(name.length, longest);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      var _iterator2 = display_utils_createForOfIteratorHelper(this.times),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = _step2.value,
            _name = _step2$value.name,
            start = _step2$value.start,
            end = _step2$value.end;
          outBuf.push("".concat(_name.padEnd(longest), " ").concat(end - start, "ms\n"));
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return outBuf.join("");
    }
  }]);
}();
function isValidFetchUrl(url, baseUrl) {
  try {
    var _ref3 = baseUrl ? new URL(url, baseUrl) : new URL(url),
      protocol = _ref3.protocol;
    return protocol === "http:" || protocol === "https:";
  } catch (_unused2) {
    return false;
  }
}
function noContextMenu(e) {
  e.preventDefault();
}
function stopEvent(e) {
  e.preventDefault();
  e.stopPropagation();
}
function deprecated(details) {
  console.log("Deprecated API usage: " + details);
}
var PDFDateString = /*#__PURE__*/function () {
  function PDFDateString() {
    display_utils_classCallCheck(this, PDFDateString);
  }
  return display_utils_createClass(PDFDateString, null, [{
    key: "toDateObject",
    value: function toDateObject(input) {
      if (!input || typeof input !== "string") {
        return null;
      }
      display_utils_assertClassBrand(PDFDateString, this, _regex)._ || (_regex._ = display_utils_assertClassBrand(PDFDateString, this, new RegExp("^D:" + "(\\d{4})" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "(\\d{2})?" + "([Z|+|-])?" + "(\\d{2})?" + "'?" + "(\\d{2})?" + "'?")));
      var matches = display_utils_assertClassBrand(PDFDateString, this, _regex)._.exec(input);
      if (!matches) {
        return null;
      }
      var year = parseInt(matches[1], 10);
      var month = parseInt(matches[2], 10);
      month = month >= 1 && month <= 12 ? month - 1 : 0;
      var day = parseInt(matches[3], 10);
      day = day >= 1 && day <= 31 ? day : 1;
      var hour = parseInt(matches[4], 10);
      hour = hour >= 0 && hour <= 23 ? hour : 0;
      var minute = parseInt(matches[5], 10);
      minute = minute >= 0 && minute <= 59 ? minute : 0;
      var second = parseInt(matches[6], 10);
      second = second >= 0 && second <= 59 ? second : 0;
      var universalTimeRelation = matches[7] || "Z";
      var offsetHour = parseInt(matches[8], 10);
      offsetHour = offsetHour >= 0 && offsetHour <= 23 ? offsetHour : 0;
      var offsetMinute = parseInt(matches[9], 10) || 0;
      offsetMinute = offsetMinute >= 0 && offsetMinute <= 59 ? offsetMinute : 0;
      if (universalTimeRelation === "-") {
        hour += offsetHour;
        minute += offsetMinute;
      } else if (universalTimeRelation === "+") {
        hour -= offsetHour;
        minute -= offsetMinute;
      }
      return new Date(Date.UTC(year, month, day, hour, minute, second));
    }
  }]);
}();
var _regex = {
  _: void 0
};
function getXfaPageViewport(xfaPage, _ref4) {
  var _ref4$scale = _ref4.scale,
    scale = _ref4$scale === void 0 ? 1 : _ref4$scale,
    _ref4$rotation = _ref4.rotation,
    rotation = _ref4$rotation === void 0 ? 0 : _ref4$rotation;
  var _xfaPage$attributes$s = xfaPage.attributes.style,
    width = _xfaPage$attributes$s.width,
    height = _xfaPage$attributes$s.height;
  var viewBox = [0, 0, parseInt(width), parseInt(height)];
  return new PageViewport({
    viewBox: viewBox,
    userUnit: 1,
    scale: scale,
    rotation: rotation
  });
}
function getRGB(color) {
  if (color.startsWith("#")) {
    var colorRGB = parseInt(color.slice(1), 16);
    return [(colorRGB & 0xff0000) >> 16, (colorRGB & 0x00ff00) >> 8, colorRGB & 0x0000ff];
  }
  if (color.startsWith("rgb(")) {
    return color.slice(4, -1).split(",").map(function (x) {
      return parseInt(x);
    });
  }
  if (color.startsWith("rgba(")) {
    return color.slice(5, -1).split(",").map(function (x) {
      return parseInt(x);
    }).slice(0, 3);
  }
  warn("Not a valid color format: \"".concat(color, "\""));
  return [0, 0, 0];
}
function getColorValues(colors) {
  var span = document.createElement("span");
  span.style.visibility = "hidden";
  document.body.append(span);
  var _iterator3 = display_utils_createForOfIteratorHelper(colors.keys()),
    _step3;
  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var name = _step3.value;
      span.style.color = name;
      var computedColor = window.getComputedStyle(span).color;
      colors.set(name, getRGB(computedColor));
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
  span.remove();
}
function getCurrentTransform(ctx) {
  var _ctx$getTransform = ctx.getTransform(),
    a = _ctx$getTransform.a,
    b = _ctx$getTransform.b,
    c = _ctx$getTransform.c,
    d = _ctx$getTransform.d,
    e = _ctx$getTransform.e,
    f = _ctx$getTransform.f;
  return [a, b, c, d, e, f];
}
function getCurrentTransformInverse(ctx) {
  var _ctx$getTransform$inv = ctx.getTransform().invertSelf(),
    a = _ctx$getTransform$inv.a,
    b = _ctx$getTransform$inv.b,
    c = _ctx$getTransform$inv.c,
    d = _ctx$getTransform$inv.d,
    e = _ctx$getTransform$inv.e,
    f = _ctx$getTransform$inv.f;
  return [a, b, c, d, e, f];
}
function setLayerDimensions(div, viewport) {
  var mustFlip = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var mustRotate = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  if (viewport instanceof PageViewport) {
    var _viewport$rawDims = viewport.rawDims,
      pageWidth = _viewport$rawDims.pageWidth,
      pageHeight = _viewport$rawDims.pageHeight;
    var style = div.style;
    var useRound = util_FeatureTest.isCSSRoundSupported;
    var w = "var(--scale-factor) * ".concat(pageWidth, "px"),
      h = "var(--scale-factor) * ".concat(pageHeight, "px");
    var widthStr = useRound ? "round(down, ".concat(w, ", var(--scale-round-x, 1px))") : "calc(".concat(w, ")"),
      heightStr = useRound ? "round(down, ".concat(h, ", var(--scale-round-y, 1px))") : "calc(".concat(h, ")");
    if (!mustFlip || viewport.rotation % 180 === 0) {
      style.width = widthStr;
      style.height = heightStr;
    } else {
      style.width = heightStr;
      style.height = widthStr;
    }
  }
  if (mustRotate) {
    div.setAttribute("data-main-rotation", viewport.rotation);
  }
}
var OutputScale = /*#__PURE__*/function () {
  function OutputScale() {
    display_utils_classCallCheck(this, OutputScale);
    var pixelRatio = window.devicePixelRatio || 1;
    this.sx = pixelRatio;
    this.sy = pixelRatio;
  }
  return display_utils_createClass(OutputScale, [{
    key: "scaled",
    get: function get() {
      return this.sx !== 1 || this.sy !== 1;
    }
  }, {
    key: "symmetric",
    get: function get() {
      return this.sx === this.sy;
    }
  }]);
}();

;// ./src/display/editor/toolbar.js
function toolbar_typeof(o) { "@babel/helpers - typeof"; return toolbar_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, toolbar_typeof(o); }
function toolbar_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = toolbar_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function toolbar_slicedToArray(r, e) { return toolbar_arrayWithHoles(r) || toolbar_iterableToArrayLimit(r, e) || toolbar_unsupportedIterableToArray(r, e) || toolbar_nonIterableRest(); }
function toolbar_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function toolbar_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return toolbar_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? toolbar_arrayLikeToArray(r, a) : void 0; } }
function toolbar_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function toolbar_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function toolbar_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function toolbar_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ toolbar_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == toolbar_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(toolbar_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function toolbar_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function toolbar_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { toolbar_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { toolbar_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }

































function toolbar_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function toolbar_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, toolbar_toPropertyKey(o.key), o); } }
function toolbar_createClass(e, r, t) { return r && toolbar_defineProperties(e.prototype, r), t && toolbar_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function toolbar_toPropertyKey(t) { var i = toolbar_toPrimitive(t, "string"); return "symbol" == toolbar_typeof(i) ? i : i + ""; }
function toolbar_toPrimitive(t, r) { if ("object" != toolbar_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != toolbar_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classPrivateMethodInitSpec(e, a) { _checkPrivateRedeclaration(e, a), a.add(e); }
function _classPrivateFieldInitSpec(e, t, a) { _checkPrivateRedeclaration(e, t), t.set(e, a); }
function _checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function _classPrivateGetter(s, r, a) { return a(toolbar_assertClassBrand(s, r)); }
function _classPrivateFieldGet(s, a) { return s.get(toolbar_assertClassBrand(s, a)); }
function _classPrivateFieldSet(s, a, r) { return s.set(toolbar_assertClassBrand(s, a), r), r; }
function toolbar_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }

var _toolbar = /*#__PURE__*/new WeakMap();
var _colorPicker = /*#__PURE__*/new WeakMap();
var _editor = /*#__PURE__*/new WeakMap();
var _buttons = /*#__PURE__*/new WeakMap();
var _altText = /*#__PURE__*/new WeakMap();
var _EditorToolbar_brand = /*#__PURE__*/new WeakSet();
var EditorToolbar = /*#__PURE__*/function () {
  function EditorToolbar(editor) {
    toolbar_classCallCheck(this, EditorToolbar);
    _classPrivateMethodInitSpec(this, _EditorToolbar_brand);
    _classPrivateFieldInitSpec(this, _toolbar, null);
    _classPrivateFieldInitSpec(this, _colorPicker, null);
    _classPrivateFieldInitSpec(this, _editor, void 0);
    _classPrivateFieldInitSpec(this, _buttons, null);
    _classPrivateFieldInitSpec(this, _altText, null);
    _classPrivateFieldSet(_editor, this, editor);
    _l10nRemove._ || (_l10nRemove._ = Object.freeze({
      freetext: "pdfjs-editor-remove-freetext-button",
      highlight: "pdfjs-editor-remove-highlight-button",
      ink: "pdfjs-editor-remove-ink-button",
      stamp: "pdfjs-editor-remove-stamp-button"
    }));
  }
  return toolbar_createClass(EditorToolbar, [{
    key: "render",
    value: function render() {
      var editToolbar = _classPrivateFieldSet(_toolbar, this, document.createElement("div"));
      editToolbar.classList.add("editToolbar", "hidden");
      editToolbar.setAttribute("role", "toolbar");
      var signal = _classPrivateFieldGet(_editor, this)._uiManager._signal;
      editToolbar.addEventListener("contextmenu", noContextMenu, {
        signal: signal
      });
      editToolbar.addEventListener("pointerdown", _pointerDown, {
        signal: signal
      });
      var buttons = _classPrivateFieldSet(_buttons, this, document.createElement("div"));
      buttons.className = "buttons";
      editToolbar.append(buttons);
      var position = _classPrivateFieldGet(_editor, this).toolbarPosition;
      if (position) {
        var style = editToolbar.style;
        var x = _classPrivateFieldGet(_editor, this)._uiManager.direction === "ltr" ? 1 - position[0] : position[0];
        style.insetInlineEnd = "".concat(100 * x, "%");
        style.top = "calc(".concat(100 * position[1], "% + var(--editor-toolbar-vert-offset))");
      }
      toolbar_assertClassBrand(_EditorToolbar_brand, this, _addDeleteButton).call(this);
      return editToolbar;
    }
  }, {
    key: "div",
    get: function get() {
      return _classPrivateFieldGet(_toolbar, this);
    }
  }, {
    key: "hide",
    value: function hide() {
      var _classPrivateFieldGet2;
      _classPrivateFieldGet(_toolbar, this).classList.add("hidden");
      (_classPrivateFieldGet2 = _classPrivateFieldGet(_colorPicker, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.hideDropdown();
    }
  }, {
    key: "show",
    value: function show() {
      var _classPrivateFieldGet3;
      _classPrivateFieldGet(_toolbar, this).classList.remove("hidden");
      (_classPrivateFieldGet3 = _classPrivateFieldGet(_altText, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.shown();
    }
  }, {
    key: "addAltText",
    value: function () {
      var _addAltText = toolbar_asyncToGenerator(/*#__PURE__*/toolbar_regeneratorRuntime().mark(function _callee(altText) {
        var button;
        return toolbar_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return altText.render();
            case 2:
              button = _context.sent;
              toolbar_assertClassBrand(_EditorToolbar_brand, this, _addListenersToElement).call(this, button);
              _classPrivateFieldGet(_buttons, this).prepend(button, _classPrivateGetter(_EditorToolbar_brand, this, _get_divider));
              _classPrivateFieldSet(_altText, this, altText);
            case 6:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function addAltText(_x) {
        return _addAltText.apply(this, arguments);
      }
      return addAltText;
    }()
  }, {
    key: "addColorPicker",
    value: function addColorPicker(colorPicker) {
      _classPrivateFieldSet(_colorPicker, this, colorPicker);
      var button = colorPicker.renderButton();
      toolbar_assertClassBrand(_EditorToolbar_brand, this, _addListenersToElement).call(this, button);
      _classPrivateFieldGet(_buttons, this).prepend(button, _classPrivateGetter(_EditorToolbar_brand, this, _get_divider));
    }
  }, {
    key: "remove",
    value: function remove() {
      var _classPrivateFieldGet4;
      _classPrivateFieldGet(_toolbar, this).remove();
      (_classPrivateFieldGet4 = _classPrivateFieldGet(_colorPicker, this)) === null || _classPrivateFieldGet4 === void 0 || _classPrivateFieldGet4.destroy();
      _classPrivateFieldSet(_colorPicker, this, null);
    }
  }]);
}();
function _pointerDown(e) {
  e.stopPropagation();
}
function _focusIn(e) {
  _classPrivateFieldGet(_editor, this)._focusEventsAllowed = false;
  stopEvent(e);
}
function _focusOut(e) {
  _classPrivateFieldGet(_editor, this)._focusEventsAllowed = true;
  stopEvent(e);
}
function _addListenersToElement(element) {
  var signal = _classPrivateFieldGet(_editor, this)._uiManager._signal;
  element.addEventListener("focusin", toolbar_assertClassBrand(_EditorToolbar_brand, this, _focusIn).bind(this), {
    capture: true,
    signal: signal
  });
  element.addEventListener("focusout", toolbar_assertClassBrand(_EditorToolbar_brand, this, _focusOut).bind(this), {
    capture: true,
    signal: signal
  });
  element.addEventListener("contextmenu", noContextMenu, {
    signal: signal
  });
}
function _addDeleteButton() {
  var _classPrivateFieldGet5 = _classPrivateFieldGet(_editor, this),
    editorType = _classPrivateFieldGet5.editorType,
    _uiManager = _classPrivateFieldGet5._uiManager;
  var button = document.createElement("button");
  button.className = "delete";
  button.tabIndex = 0;
  button.setAttribute("data-l10n-id", _l10nRemove._[editorType]);
  toolbar_assertClassBrand(_EditorToolbar_brand, this, _addListenersToElement).call(this, button);
  button.addEventListener("click", function (e) {
    _uiManager.delete();
  }, {
    signal: _uiManager._signal
  });
  _classPrivateFieldGet(_buttons, this).append(button);
}
function _get_divider(_this) {
  var divider = document.createElement("div");
  divider.className = "divider";
  return divider;
}
var _l10nRemove = {
  _: null
};
var _buttons2 = /*#__PURE__*/new WeakMap();
var _toolbar2 = /*#__PURE__*/new WeakMap();
var _uiManager2 = /*#__PURE__*/new WeakMap();
var _HighlightToolbar_brand = /*#__PURE__*/new WeakSet();
var HighlightToolbar = /*#__PURE__*/function () {
  function HighlightToolbar(uiManager) {
    toolbar_classCallCheck(this, HighlightToolbar);
    _classPrivateMethodInitSpec(this, _HighlightToolbar_brand);
    _classPrivateFieldInitSpec(this, _buttons2, null);
    _classPrivateFieldInitSpec(this, _toolbar2, null);
    _classPrivateFieldInitSpec(this, _uiManager2, void 0);
    _classPrivateFieldSet(_uiManager2, this, uiManager);
  }
  return toolbar_createClass(HighlightToolbar, [{
    key: "show",
    value: function show(parent, boxes, isLTR) {
      var _assertClassBrand$cal = toolbar_assertClassBrand(_HighlightToolbar_brand, this, _getLastPoint).call(this, boxes, isLTR),
        _assertClassBrand$cal2 = toolbar_slicedToArray(_assertClassBrand$cal, 2),
        x = _assertClassBrand$cal2[0],
        y = _assertClassBrand$cal2[1];
      var _ref = _classPrivateFieldGet(_toolbar2, this) || _classPrivateFieldSet(_toolbar2, this, toolbar_assertClassBrand(_HighlightToolbar_brand, this, _render).call(this)),
        style = _ref.style;
      parent.append(_classPrivateFieldGet(_toolbar2, this));
      style.insetInlineEnd = "".concat(100 * x, "%");
      style.top = "calc(".concat(100 * y, "% + var(--editor-toolbar-vert-offset))");
    }
  }, {
    key: "hide",
    value: function hide() {
      _classPrivateFieldGet(_toolbar2, this).remove();
    }
  }]);
}();
function _render() {
  var editToolbar = _classPrivateFieldSet(_toolbar2, this, document.createElement("div"));
  editToolbar.className = "editToolbar";
  editToolbar.setAttribute("role", "toolbar");
  editToolbar.addEventListener("contextmenu", noContextMenu, {
    signal: _classPrivateFieldGet(_uiManager2, this)._signal
  });
  var buttons = _classPrivateFieldSet(_buttons2, this, document.createElement("div"));
  buttons.className = "buttons";
  editToolbar.append(buttons);
  toolbar_assertClassBrand(_HighlightToolbar_brand, this, _addHighlightButton).call(this);
  return editToolbar;
}
function _getLastPoint(boxes, isLTR) {
  var lastY = 0;
  var lastX = 0;
  var _iterator = toolbar_createForOfIteratorHelper(boxes),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var box = _step.value;
      var y = box.y + box.height;
      if (y < lastY) {
        continue;
      }
      var x = box.x + (isLTR ? box.width : 0);
      if (y > lastY) {
        lastX = x;
        lastY = y;
        continue;
      }
      if (isLTR) {
        if (x > lastX) {
          lastX = x;
        }
      } else if (x < lastX) {
        lastX = x;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return [isLTR ? 1 - lastX : lastX, lastY];
}
function _addHighlightButton() {
  var _this2 = this;
  var button = document.createElement("button");
  button.className = "highlightButton";
  button.tabIndex = 0;
  button.setAttribute("data-l10n-id", "pdfjs-highlight-floating-button1");
  var span = document.createElement("span");
  button.append(span);
  span.className = "visuallyHidden";
  span.setAttribute("data-l10n-id", "pdfjs-highlight-floating-button-label");
  var signal = _classPrivateFieldGet(_uiManager2, this)._signal;
  button.addEventListener("contextmenu", noContextMenu, {
    signal: signal
  });
  button.addEventListener("click", function () {
    _classPrivateFieldGet(_uiManager2, _this2).highlightSelection("floating_button");
  }, {
    signal: signal
  });
  _classPrivateFieldGet(_buttons2, this).append(button);
}

;// ./src/display/editor/tools.js
function tools_typeof(o) { "@babel/helpers - typeof"; return tools_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, tools_typeof(o); }

















var _ImageManager;
function tools_classPrivateGetter(s, r, a) { return a(tools_assertClassBrand(s, r)); }
function tools_defineProperty(e, r, t) { return (r = tools_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || tools_unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return tools_arrayLikeToArray(r); }
function tools_slicedToArray(r, e) { return tools_arrayWithHoles(r) || tools_iterableToArrayLimit(r, e) || tools_unsupportedIterableToArray(r, e) || tools_nonIterableRest(); }
function tools_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function tools_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function tools_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _readOnlyError(r) { throw new TypeError('"' + r + '" is read-only'); }
function tools_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ tools_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == tools_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(tools_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function tools_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function tools_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { tools_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { tools_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function tools_classPrivateMethodInitSpec(e, a) { tools_checkPrivateRedeclaration(e, a), a.add(e); }
function tools_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function tools_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, tools_toPropertyKey(o.key), o); } }
function tools_createClass(e, r, t) { return r && tools_defineProperties(e.prototype, r), t && tools_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function tools_toPropertyKey(t) { var i = tools_toPrimitive(t, "string"); return "symbol" == tools_typeof(i) ? i : i + ""; }
function tools_toPrimitive(t, r) { if ("object" != tools_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != tools_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function tools_classPrivateFieldInitSpec(e, t, a) { tools_checkPrivateRedeclaration(e, t), t.set(e, a); }
function tools_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function tools_classPrivateFieldGet(s, a) { return s.get(tools_assertClassBrand(s, a)); }
function tools_classPrivateFieldSet(s, a, r) { return s.set(tools_assertClassBrand(s, a), r), r; }
function tools_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


















































































function tools_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = tools_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function tools_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return tools_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? tools_arrayLikeToArray(r, a) : void 0; } }
function tools_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }



function bindEvents(obj, element, names) {
  var _iterator = tools_createForOfIteratorHelper(names),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var name = _step.value;
      element.addEventListener(name, obj[name].bind(obj));
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}
function opacityToHex(opacity) {
  return Math.round(Math.min(255, Math.max(1, 255 * opacity))).toString(16).padStart(2, "0");
}
var _id = /*#__PURE__*/new WeakMap();
var IdManager = /*#__PURE__*/function () {
  function IdManager() {
    var _this = this;
    tools_classCallCheck(this, IdManager);
    tools_classPrivateFieldInitSpec(this, _id, 0);
  }
  return tools_createClass(IdManager, [{
    key: "id",
    get: function get() {
      var _this$id, _this$id2;
      return "".concat(AnnotationEditorPrefix).concat((tools_classPrivateFieldSet(_id, this, (_this$id = tools_classPrivateFieldGet(_id, this), _this$id2 = _this$id++, _this$id)), _this$id2));
    }
  }]);
}();
var _baseId = /*#__PURE__*/new WeakMap();
var _id2 = /*#__PURE__*/new WeakMap();
var _cache = /*#__PURE__*/new WeakMap();
var _ImageManager_brand = /*#__PURE__*/new WeakSet();
var ImageManager = /*#__PURE__*/function () {
  function ImageManager() {
    tools_classCallCheck(this, ImageManager);
    tools_classPrivateMethodInitSpec(this, _ImageManager_brand);
    tools_classPrivateFieldInitSpec(this, _baseId, getUuid());
    tools_classPrivateFieldInitSpec(this, _id2, 0);
    tools_classPrivateFieldInitSpec(this, _cache, null);
  }
  return tools_createClass(ImageManager, [{
    key: "getFromFile",
    value: function () {
      var _getFromFile = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee(file) {
        var lastModified, name, size, type;
        return tools_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              lastModified = file.lastModified, name = file.name, size = file.size, type = file.type;
              return _context.abrupt("return", tools_assertClassBrand(_ImageManager_brand, this, _get).call(this, "".concat(lastModified, "_").concat(name, "_").concat(size, "_").concat(type), file));
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function getFromFile(_x) {
        return _getFromFile.apply(this, arguments);
      }
      return getFromFile;
    }()
  }, {
    key: "getFromUrl",
    value: function () {
      var _getFromUrl = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee2(url) {
        return tools_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", tools_assertClassBrand(_ImageManager_brand, this, _get).call(this, url, url));
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function getFromUrl(_x2) {
        return _getFromUrl.apply(this, arguments);
      }
      return getFromUrl;
    }()
  }, {
    key: "getFromBlob",
    value: function () {
      var _getFromBlob = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee3(id, blobPromise) {
        var blob;
        return tools_regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return blobPromise;
            case 2:
              blob = _context3.sent;
              return _context3.abrupt("return", tools_assertClassBrand(_ImageManager_brand, this, _get).call(this, id, blob));
            case 4:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function getFromBlob(_x3, _x4) {
        return _getFromBlob.apply(this, arguments);
      }
      return getFromBlob;
    }()
  }, {
    key: "getFromId",
    value: function () {
      var _getFromId = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee4(id) {
        var data, blobPromise;
        return tools_regeneratorRuntime().wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              tools_classPrivateFieldGet(_cache, this) || tools_classPrivateFieldSet(_cache, this, new Map());
              data = tools_classPrivateFieldGet(_cache, this).get(id);
              if (data) {
                _context4.next = 4;
                break;
              }
              return _context4.abrupt("return", null);
            case 4:
              if (!data.bitmap) {
                _context4.next = 7;
                break;
              }
              data.refCounter += 1;
              return _context4.abrupt("return", data);
            case 7:
              if (!data.file) {
                _context4.next = 9;
                break;
              }
              return _context4.abrupt("return", this.getFromFile(data.file));
            case 9:
              if (!data.blobPromise) {
                _context4.next = 13;
                break;
              }
              blobPromise = data.blobPromise;
              delete data.blobPromise;
              return _context4.abrupt("return", this.getFromBlob(data.id, blobPromise));
            case 13:
              return _context4.abrupt("return", this.getFromUrl(data.url));
            case 14:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function getFromId(_x5) {
        return _getFromId.apply(this, arguments);
      }
      return getFromId;
    }()
  }, {
    key: "getFromCanvas",
    value: function getFromCanvas(id, canvas) {
      var _this$id5, _this$id6, _data;
      tools_classPrivateFieldGet(_cache, this) || tools_classPrivateFieldSet(_cache, this, new Map());
      var data = tools_classPrivateFieldGet(_cache, this).get(id);
      if ((_data = data) !== null && _data !== void 0 && _data.bitmap) {
        data.refCounter += 1;
        return data;
      }
      var offscreen = new OffscreenCanvas(canvas.width, canvas.height);
      var ctx = offscreen.getContext("2d");
      ctx.drawImage(canvas, 0, 0);
      data = {
        bitmap: offscreen.transferToImageBitmap(),
        id: "image_".concat(tools_classPrivateFieldGet(_baseId, this), "_").concat((tools_classPrivateFieldSet(_id2, this, (_this$id5 = tools_classPrivateFieldGet(_id2, this), _this$id6 = _this$id5++, _this$id5)), _this$id6)),
        refCounter: 1,
        isSvg: false
      };
      tools_classPrivateFieldGet(_cache, this).set(id, data);
      tools_classPrivateFieldGet(_cache, this).set(data.id, data);
      return data;
    }
  }, {
    key: "getSvgUrl",
    value: function getSvgUrl(id) {
      var data = tools_classPrivateFieldGet(_cache, this).get(id);
      if (!(data !== null && data !== void 0 && data.isSvg)) {
        return null;
      }
      return data.svgUrl;
    }
  }, {
    key: "deleteId",
    value: function deleteId(id) {
      var _bitmap$close;
      tools_classPrivateFieldGet(_cache, this) || tools_classPrivateFieldSet(_cache, this, new Map());
      var data = tools_classPrivateFieldGet(_cache, this).get(id);
      if (!data) {
        return;
      }
      data.refCounter -= 1;
      if (data.refCounter !== 0) {
        return;
      }
      var bitmap = data.bitmap;
      if (!data.url && !data.file) {
        var canvas = new OffscreenCanvas(bitmap.width, bitmap.height);
        var ctx = canvas.getContext("bitmaprenderer");
        ctx.transferFromImageBitmap(bitmap);
        data.blobPromise = canvas.convertToBlob();
      }
      (_bitmap$close = bitmap.close) === null || _bitmap$close === void 0 || _bitmap$close.call(bitmap);
      data.bitmap = null;
    }
  }, {
    key: "isValidId",
    value: function isValidId(id) {
      return id.startsWith("image_".concat(tools_classPrivateFieldGet(_baseId, this), "_"));
    }
  }], [{
    key: "_isSVGFittingCanvas",
    get: function get() {
      var svg = "data:image/svg+xml;charset=UTF-8,<svg viewBox=\"0 0 1 1\" width=\"1\" height=\"1\" xmlns=\"http://www.w3.org/2000/svg\"><rect width=\"1\" height=\"1\" style=\"fill:red;\"/></svg>";
      var canvas = new OffscreenCanvas(1, 3);
      var ctx = canvas.getContext("2d", {
        willReadFrequently: true
      });
      var image = new Image();
      image.src = svg;
      var promise = image.decode().then(function () {
        ctx.drawImage(image, 0, 0, 1, 1, 0, 0, 1, 3);
        return new Uint32Array(ctx.getImageData(0, 0, 1, 1).data.buffer)[0] === 0;
      });
      return shadow(this, "_isSVGFittingCanvas", promise);
    }
  }]);
}();
_ImageManager = ImageManager;
function _get(_x8, _x9) {
  return _get2.apply(this, arguments);
}
function _get2() {
  _get2 = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee8(key, rawData) {
    var _data2;
    var data, _this$id3, _this$id4, image, mustRemoveAspectRatioPromise, fileReader, imageElement, imagePromise;
    return tools_regeneratorRuntime().wrap(function _callee8$(_context8) {
      while (1) switch (_context8.prev = _context8.next) {
        case 0:
          tools_classPrivateFieldGet(_cache, this) || tools_classPrivateFieldSet(_cache, this, new Map());
          data = tools_classPrivateFieldGet(_cache, this).get(key);
          if (!(data === null)) {
            _context8.next = 4;
            break;
          }
          return _context8.abrupt("return", null);
        case 4:
          if (!((_data2 = data) !== null && _data2 !== void 0 && _data2.bitmap)) {
            _context8.next = 7;
            break;
          }
          data.refCounter += 1;
          return _context8.abrupt("return", data);
        case 7:
          _context8.prev = 7;
          data || (data = {
            bitmap: null,
            id: "image_".concat(tools_classPrivateFieldGet(_baseId, this), "_").concat((tools_classPrivateFieldSet(_id2, this, (_this$id3 = tools_classPrivateFieldGet(_id2, this), _this$id4 = _this$id3++, _this$id3)), _this$id4)),
            refCounter: 0,
            isSvg: false
          });
          if (!(typeof rawData === "string")) {
            _context8.next = 16;
            break;
          }
          data.url = rawData;
          _context8.next = 13;
          return fetchData(rawData, "blob");
        case 13:
          image = _context8.sent;
          _context8.next = 17;
          break;
        case 16:
          if (rawData instanceof File) {
            image = data.file = rawData;
          } else if (rawData instanceof Blob) {
            image = rawData;
          }
        case 17:
          if (!(image.type === "image/svg+xml")) {
            _context8.next = 27;
            break;
          }
          mustRemoveAspectRatioPromise = _ImageManager._isSVGFittingCanvas;
          fileReader = new FileReader();
          imageElement = new Image();
          imagePromise = new Promise(function (resolve, reject) {
            imageElement.onload = function () {
              data.bitmap = imageElement;
              data.isSvg = true;
              resolve();
            };
            fileReader.onload = /*#__PURE__*/tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee7() {
              var url;
              return tools_regeneratorRuntime().wrap(function _callee7$(_context7) {
                while (1) switch (_context7.prev = _context7.next) {
                  case 0:
                    url = data.svgUrl = fileReader.result;
                    _context7.next = 3;
                    return mustRemoveAspectRatioPromise;
                  case 3:
                    if (!_context7.sent) {
                      _context7.next = 7;
                      break;
                    }
                    _context7.t0 = "".concat(url, "#svgView(preserveAspectRatio(none))");
                    _context7.next = 8;
                    break;
                  case 7:
                    _context7.t0 = url;
                  case 8:
                    imageElement.src = _context7.t0;
                  case 9:
                  case "end":
                    return _context7.stop();
                }
              }, _callee7);
            }));
            imageElement.onerror = fileReader.onerror = reject;
          });
          fileReader.readAsDataURL(image);
          _context8.next = 25;
          return imagePromise;
        case 25:
          _context8.next = 30;
          break;
        case 27:
          _context8.next = 29;
          return createImageBitmap(image);
        case 29:
          data.bitmap = _context8.sent;
        case 30:
          data.refCounter = 1;
          _context8.next = 37;
          break;
        case 33:
          _context8.prev = 33;
          _context8.t0 = _context8["catch"](7);
          warn(_context8.t0);
          data = null;
        case 37:
          tools_classPrivateFieldGet(_cache, this).set(key, data);
          if (data) {
            tools_classPrivateFieldGet(_cache, this).set(data.id, data);
          }
          return _context8.abrupt("return", data);
        case 40:
        case "end":
          return _context8.stop();
      }
    }, _callee8, this, [[7, 33]]);
  }));
  return _get2.apply(this, arguments);
}
var _commands = /*#__PURE__*/new WeakMap();
var _locked = /*#__PURE__*/new WeakMap();
var _maxSize = /*#__PURE__*/new WeakMap();
var _position = /*#__PURE__*/new WeakMap();
var CommandManager = /*#__PURE__*/function () {
  function CommandManager() {
    var maxSize = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 128;
    tools_classCallCheck(this, CommandManager);
    tools_classPrivateFieldInitSpec(this, _commands, []);
    tools_classPrivateFieldInitSpec(this, _locked, false);
    tools_classPrivateFieldInitSpec(this, _maxSize, void 0);
    tools_classPrivateFieldInitSpec(this, _position, -1);
    tools_classPrivateFieldSet(_maxSize, this, maxSize);
  }
  return tools_createClass(CommandManager, [{
    key: "add",
    value: function add(_ref) {
      var cmd = _ref.cmd,
        undo = _ref.undo,
        post = _ref.post,
        mustExec = _ref.mustExec,
        _ref$type = _ref.type,
        type = _ref$type === void 0 ? NaN : _ref$type,
        _ref$overwriteIfSameT = _ref.overwriteIfSameType,
        overwriteIfSameType = _ref$overwriteIfSameT === void 0 ? false : _ref$overwriteIfSameT,
        _ref$keepUndo = _ref.keepUndo,
        keepUndo = _ref$keepUndo === void 0 ? false : _ref$keepUndo;
      if (mustExec) {
        cmd();
      }
      if (tools_classPrivateFieldGet(_locked, this)) {
        return;
      }
      var save = {
        cmd: cmd,
        undo: undo,
        post: post,
        type: type
      };
      if (tools_classPrivateFieldGet(_position, this) === -1) {
        if (tools_classPrivateFieldGet(_commands, this).length > 0) {
          tools_classPrivateFieldGet(_commands, this).length = 0;
        }
        tools_classPrivateFieldSet(_position, this, 0);
        tools_classPrivateFieldGet(_commands, this).push(save);
        return;
      }
      if (overwriteIfSameType && tools_classPrivateFieldGet(_commands, this)[tools_classPrivateFieldGet(_position, this)].type === type) {
        if (keepUndo) {
          save.undo = tools_classPrivateFieldGet(_commands, this)[tools_classPrivateFieldGet(_position, this)].undo;
        }
        tools_classPrivateFieldGet(_commands, this)[tools_classPrivateFieldGet(_position, this)] = save;
        return;
      }
      var next = tools_classPrivateFieldGet(_position, this) + 1;
      if (next === tools_classPrivateFieldGet(_maxSize, this)) {
        tools_classPrivateFieldGet(_commands, this).splice(0, 1);
      } else {
        tools_classPrivateFieldSet(_position, this, next);
        if (next < tools_classPrivateFieldGet(_commands, this).length) {
          tools_classPrivateFieldGet(_commands, this).splice(next);
        }
      }
      tools_classPrivateFieldGet(_commands, this).push(save);
    }
  }, {
    key: "undo",
    value: function undo() {
      if (tools_classPrivateFieldGet(_position, this) === -1) {
        return;
      }
      tools_classPrivateFieldSet(_locked, this, true);
      var _classPrivateFieldGet2 = tools_classPrivateFieldGet(_commands, this)[tools_classPrivateFieldGet(_position, this)],
        undo = _classPrivateFieldGet2.undo,
        post = _classPrivateFieldGet2.post;
      undo();
      post === null || post === void 0 || post();
      tools_classPrivateFieldSet(_locked, this, false);
      tools_classPrivateFieldSet(_position, this, tools_classPrivateFieldGet(_position, this) - 1);
    }
  }, {
    key: "redo",
    value: function redo() {
      if (tools_classPrivateFieldGet(_position, this) < tools_classPrivateFieldGet(_commands, this).length - 1) {
        tools_classPrivateFieldSet(_position, this, tools_classPrivateFieldGet(_position, this) + 1);
        tools_classPrivateFieldSet(_locked, this, true);
        var _classPrivateFieldGet3 = tools_classPrivateFieldGet(_commands, this)[tools_classPrivateFieldGet(_position, this)],
          cmd = _classPrivateFieldGet3.cmd,
          post = _classPrivateFieldGet3.post;
        cmd();
        post === null || post === void 0 || post();
        tools_classPrivateFieldSet(_locked, this, false);
      }
    }
  }, {
    key: "hasSomethingToUndo",
    value: function hasSomethingToUndo() {
      return tools_classPrivateFieldGet(_position, this) !== -1;
    }
  }, {
    key: "hasSomethingToRedo",
    value: function hasSomethingToRedo() {
      return tools_classPrivateFieldGet(_position, this) < tools_classPrivateFieldGet(_commands, this).length - 1;
    }
  }, {
    key: "cleanType",
    value: function cleanType(type) {
      if (tools_classPrivateFieldGet(_position, this) === -1) {
        return;
      }
      for (var i = tools_classPrivateFieldGet(_position, this); i >= 0; i--) {
        if (tools_classPrivateFieldGet(_commands, this)[i].type !== type) {
          tools_classPrivateFieldGet(_commands, this).splice(i + 1, tools_classPrivateFieldGet(_position, this) - i);
          tools_classPrivateFieldSet(_position, this, i);
          return;
        }
      }
      tools_classPrivateFieldGet(_commands, this).length = 0;
      tools_classPrivateFieldSet(_position, this, -1);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      tools_classPrivateFieldSet(_commands, this, null);
    }
  }]);
}();
var _KeyboardManager_brand = /*#__PURE__*/new WeakSet();
var KeyboardManager = /*#__PURE__*/function () {
  function KeyboardManager(callbacks) {
    tools_classCallCheck(this, KeyboardManager);
    tools_classPrivateMethodInitSpec(this, _KeyboardManager_brand);
    this.buffer = [];
    this.callbacks = new Map();
    this.allKeys = new Set();
    var isMac = util_FeatureTest.platform.isMac;
    var _iterator2 = tools_createForOfIteratorHelper(callbacks),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var _step2$value = tools_slicedToArray(_step2.value, 3),
          keys = _step2$value[0],
          callback = _step2$value[1],
          _step2$value$ = _step2$value[2],
          options = _step2$value$ === void 0 ? {} : _step2$value$;
        var _iterator3 = tools_createForOfIteratorHelper(keys),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var key = _step3.value;
            var isMacKey = key.startsWith("mac+");
            if (isMac && isMacKey) {
              this.callbacks.set(key.slice(4), {
                callback: callback,
                options: options
              });
              this.allKeys.add(key.split("+").at(-1));
            } else if (!isMac && !isMacKey) {
              this.callbacks.set(key, {
                callback: callback,
                options: options
              });
              this.allKeys.add(key.split("+").at(-1));
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
  }
  return tools_createClass(KeyboardManager, [{
    key: "exec",
    value: function exec(self, event) {
      if (!this.allKeys.has(event.key)) {
        return;
      }
      var info = this.callbacks.get(tools_assertClassBrand(_KeyboardManager_brand, this, _serialize).call(this, event));
      if (!info) {
        return;
      }
      var callback = info.callback,
        _info$options = info.options,
        _info$options$bubbles = _info$options.bubbles,
        bubbles = _info$options$bubbles === void 0 ? false : _info$options$bubbles,
        _info$options$args = _info$options.args,
        args = _info$options$args === void 0 ? [] : _info$options$args,
        _info$options$checker = _info$options.checker,
        checker = _info$options$checker === void 0 ? null : _info$options$checker;
      if (checker && !checker(self, event)) {
        return;
      }
      callback.bind.apply(callback, [self].concat(_toConsumableArray(args), [event]))();
      if (!bubbles) {
        stopEvent(event);
      }
    }
  }]);
}();
function _serialize(event) {
  if (event.altKey) {
    this.buffer.push("alt");
  }
  if (event.ctrlKey) {
    this.buffer.push("ctrl");
  }
  if (event.metaKey) {
    this.buffer.push("meta");
  }
  if (event.shiftKey) {
    this.buffer.push("shift");
  }
  this.buffer.push(event.key);
  var str = this.buffer.join("+");
  this.buffer.length = 0;
  return str;
}
var ColorManager = /*#__PURE__*/function () {
  function ColorManager() {
    tools_classCallCheck(this, ColorManager);
  }
  return tools_createClass(ColorManager, [{
    key: "_colors",
    get: function get() {
      var colors = new Map([["CanvasText", null], ["Canvas", null]]);
      getColorValues(colors);
      return shadow(this, "_colors", colors);
    }
  }, {
    key: "convert",
    value: function convert(color) {
      var rgb = getRGB(color);
      if (!window.matchMedia("(forced-colors: active)").matches) {
        return rgb;
      }
      var _iterator4 = tools_createForOfIteratorHelper(this._colors),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var _step4$value = tools_slicedToArray(_step4.value, 2),
            name = _step4$value[0],
            RGB = _step4$value[1];
          if (RGB.every(function (x, i) {
            return x === rgb[i];
          })) {
            return ColorManager._colorsMapping.get(name);
          }
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      return rgb;
    }
  }, {
    key: "getHexCode",
    value: function getHexCode(name) {
      var rgb = this._colors.get(name);
      if (!rgb) {
        return name;
      }
      return Util.makeHexColor.apply(Util, _toConsumableArray(rgb));
    }
  }]);
}();
tools_defineProperty(ColorManager, "_colorsMapping", new Map([["CanvasText", [0, 0, 0]], ["Canvas", [255, 255, 255]]]));
var _abortController = /*#__PURE__*/new WeakMap();
var _activeEditor = /*#__PURE__*/new WeakMap();
var _allEditors = /*#__PURE__*/new WeakMap();
var _allLayers = /*#__PURE__*/new WeakMap();
var _altTextManager = /*#__PURE__*/new WeakMap();
var _annotationStorage = /*#__PURE__*/new WeakMap();
var _changedExistingAnnotations = /*#__PURE__*/new WeakMap();
var _commandManager = /*#__PURE__*/new WeakMap();
var _copyPasteAC = /*#__PURE__*/new WeakMap();
var _currentDrawingSession = /*#__PURE__*/new WeakMap();
var _currentPageIndex = /*#__PURE__*/new WeakMap();
var _deletedAnnotationsElementIds = /*#__PURE__*/new WeakMap();
var _draggingEditors = /*#__PURE__*/new WeakMap();
var _editorTypes = /*#__PURE__*/new WeakMap();
var _editorsToRescale = /*#__PURE__*/new WeakMap();
var _enableHighlightFloatingButton = /*#__PURE__*/new WeakMap();
var _enableUpdatedAddImage = /*#__PURE__*/new WeakMap();
var _enableNewAltTextWhenAddingImage = /*#__PURE__*/new WeakMap();
var _filterFactory = /*#__PURE__*/new WeakMap();
var _focusMainContainerTimeoutId = /*#__PURE__*/new WeakMap();
var _focusManagerAC = /*#__PURE__*/new WeakMap();
var _highlightColors = /*#__PURE__*/new WeakMap();
var _highlightWhenShiftUp = /*#__PURE__*/new WeakMap();
var _highlightToolbar = /*#__PURE__*/new WeakMap();
var _idManager = /*#__PURE__*/new WeakMap();
var _isEnabled = /*#__PURE__*/new WeakMap();
var _isWaiting = /*#__PURE__*/new WeakMap();
var _keyboardManagerAC = /*#__PURE__*/new WeakMap();
var _lastActiveElement = /*#__PURE__*/new WeakMap();
var _mainHighlightColorPicker = /*#__PURE__*/new WeakMap();
var _mlManager = /*#__PURE__*/new WeakMap();
var _mode = /*#__PURE__*/new WeakMap();
var _selectedEditors = /*#__PURE__*/new WeakMap();
var _selectedTextNode = /*#__PURE__*/new WeakMap();
var _pageColors = /*#__PURE__*/new WeakMap();
var _showAllStates = /*#__PURE__*/new WeakMap();
var _previousStates = /*#__PURE__*/new WeakMap();
var _translation = /*#__PURE__*/new WeakMap();
var _translationTimeoutId = /*#__PURE__*/new WeakMap();
var _container = /*#__PURE__*/new WeakMap();
var _viewer = /*#__PURE__*/new WeakMap();
var _updateModeCapability = /*#__PURE__*/new WeakMap();
var _AnnotationEditorUIManager_brand = /*#__PURE__*/new WeakSet();
var AnnotationEditorUIManager = /*#__PURE__*/function () {
  function AnnotationEditorUIManager(container, viewer, altTextManager, eventBus, pdfDocument, pageColors, highlightColors, enableHighlightFloatingButton, enableUpdatedAddImage, enableNewAltTextWhenAddingImage, mlManager, editorUndoBar, supportsPinchToZoom) {
    var _this3 = this;
    tools_classCallCheck(this, AnnotationEditorUIManager);
    tools_classPrivateMethodInitSpec(this, _AnnotationEditorUIManager_brand);
    tools_classPrivateFieldInitSpec(this, _abortController, new AbortController());
    tools_classPrivateFieldInitSpec(this, _activeEditor, null);
    tools_classPrivateFieldInitSpec(this, _allEditors, new Map());
    tools_classPrivateFieldInitSpec(this, _allLayers, new Map());
    tools_classPrivateFieldInitSpec(this, _altTextManager, null);
    tools_classPrivateFieldInitSpec(this, _annotationStorage, null);
    tools_classPrivateFieldInitSpec(this, _changedExistingAnnotations, null);
    tools_classPrivateFieldInitSpec(this, _commandManager, new CommandManager());
    tools_classPrivateFieldInitSpec(this, _copyPasteAC, null);
    tools_classPrivateFieldInitSpec(this, _currentDrawingSession, null);
    tools_classPrivateFieldInitSpec(this, _currentPageIndex, 0);
    tools_classPrivateFieldInitSpec(this, _deletedAnnotationsElementIds, new Set());
    tools_classPrivateFieldInitSpec(this, _draggingEditors, null);
    tools_classPrivateFieldInitSpec(this, _editorTypes, null);
    tools_classPrivateFieldInitSpec(this, _editorsToRescale, new Set());
    tools_defineProperty(this, "_editorUndoBar", null);
    tools_classPrivateFieldInitSpec(this, _enableHighlightFloatingButton, false);
    tools_classPrivateFieldInitSpec(this, _enableUpdatedAddImage, false);
    tools_classPrivateFieldInitSpec(this, _enableNewAltTextWhenAddingImage, false);
    tools_classPrivateFieldInitSpec(this, _filterFactory, null);
    tools_classPrivateFieldInitSpec(this, _focusMainContainerTimeoutId, null);
    tools_classPrivateFieldInitSpec(this, _focusManagerAC, null);
    tools_classPrivateFieldInitSpec(this, _highlightColors, null);
    tools_classPrivateFieldInitSpec(this, _highlightWhenShiftUp, false);
    tools_classPrivateFieldInitSpec(this, _highlightToolbar, null);
    tools_classPrivateFieldInitSpec(this, _idManager, new IdManager());
    tools_classPrivateFieldInitSpec(this, _isEnabled, false);
    tools_classPrivateFieldInitSpec(this, _isWaiting, false);
    tools_classPrivateFieldInitSpec(this, _keyboardManagerAC, null);
    tools_classPrivateFieldInitSpec(this, _lastActiveElement, null);
    tools_classPrivateFieldInitSpec(this, _mainHighlightColorPicker, null);
    tools_classPrivateFieldInitSpec(this, _mlManager, null);
    tools_classPrivateFieldInitSpec(this, _mode, AnnotationEditorType.NONE);
    tools_classPrivateFieldInitSpec(this, _selectedEditors, new Set());
    tools_classPrivateFieldInitSpec(this, _selectedTextNode, null);
    tools_classPrivateFieldInitSpec(this, _pageColors, null);
    tools_classPrivateFieldInitSpec(this, _showAllStates, null);
    tools_classPrivateFieldInitSpec(this, _previousStates, {
      isEditing: false,
      isEmpty: true,
      hasSomethingToUndo: false,
      hasSomethingToRedo: false,
      hasSelectedEditor: false,
      hasSelectedText: false
    });
    tools_classPrivateFieldInitSpec(this, _translation, [0, 0]);
    tools_classPrivateFieldInitSpec(this, _translationTimeoutId, null);
    tools_classPrivateFieldInitSpec(this, _container, null);
    tools_classPrivateFieldInitSpec(this, _viewer, null);
    tools_classPrivateFieldInitSpec(this, _updateModeCapability, null);
    var _signal = this._signal = tools_classPrivateFieldGet(_abortController, this).signal;
    tools_classPrivateFieldSet(_container, this, container);
    tools_classPrivateFieldSet(_viewer, this, viewer);
    tools_classPrivateFieldSet(_altTextManager, this, altTextManager);
    this._eventBus = eventBus;
    eventBus._on("editingaction", this.onEditingAction.bind(this), {
      signal: _signal
    });
    eventBus._on("pagechanging", this.onPageChanging.bind(this), {
      signal: _signal
    });
    eventBus._on("scalechanging", this.onScaleChanging.bind(this), {
      signal: _signal
    });
    eventBus._on("rotationchanging", this.onRotationChanging.bind(this), {
      signal: _signal
    });
    eventBus._on("setpreference", this.onSetPreference.bind(this), {
      signal: _signal
    });
    eventBus._on("switchannotationeditorparams", function (evt) {
      return _this3.updateParams(evt.type, evt.value);
    }, {
      signal: _signal
    });
    tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addSelectionListener).call(this);
    tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addDragAndDropListeners).call(this);
    tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addKeyboardManager).call(this);
    tools_classPrivateFieldSet(_annotationStorage, this, pdfDocument.annotationStorage);
    tools_classPrivateFieldSet(_filterFactory, this, pdfDocument.filterFactory);
    tools_classPrivateFieldSet(_pageColors, this, pageColors);
    tools_classPrivateFieldSet(_highlightColors, this, highlightColors || null);
    tools_classPrivateFieldSet(_enableHighlightFloatingButton, this, enableHighlightFloatingButton);
    tools_classPrivateFieldSet(_enableUpdatedAddImage, this, enableUpdatedAddImage);
    tools_classPrivateFieldSet(_enableNewAltTextWhenAddingImage, this, enableNewAltTextWhenAddingImage);
    tools_classPrivateFieldSet(_mlManager, this, mlManager || null);
    this.viewParameters = {
      realScale: PixelsPerInch.PDF_TO_CSS_UNITS,
      rotation: 0
    };
    this.isShiftKeyDown = false;
    this._editorUndoBar = editorUndoBar || null;
    this._supportsPinchToZoom = supportsPinchToZoom !== false;
  }
  return tools_createClass(AnnotationEditorUIManager, [{
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet4, _classPrivateFieldGet5, _classPrivateFieldGet6, _classPrivateFieldGet7, _this$_editorUndoBar;
      (_classPrivateFieldGet4 = tools_classPrivateFieldGet(_updateModeCapability, this)) === null || _classPrivateFieldGet4 === void 0 || _classPrivateFieldGet4.resolve();
      tools_classPrivateFieldSet(_updateModeCapability, this, null);
      (_classPrivateFieldGet5 = tools_classPrivateFieldGet(_abortController, this)) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.abort();
      tools_classPrivateFieldSet(_abortController, this, null);
      this._signal = null;
      var _iterator5 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values()),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var layer = _step5.value;
          layer.destroy();
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      tools_classPrivateFieldGet(_allLayers, this).clear();
      tools_classPrivateFieldGet(_allEditors, this).clear();
      tools_classPrivateFieldGet(_editorsToRescale, this).clear();
      tools_classPrivateFieldSet(_activeEditor, this, null);
      tools_classPrivateFieldGet(_selectedEditors, this).clear();
      tools_classPrivateFieldGet(_commandManager, this).destroy();
      (_classPrivateFieldGet6 = tools_classPrivateFieldGet(_altTextManager, this)) === null || _classPrivateFieldGet6 === void 0 || _classPrivateFieldGet6.destroy();
      (_classPrivateFieldGet7 = tools_classPrivateFieldGet(_highlightToolbar, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.hide();
      tools_classPrivateFieldSet(_highlightToolbar, this, null);
      if (tools_classPrivateFieldGet(_focusMainContainerTimeoutId, this)) {
        clearTimeout(tools_classPrivateFieldGet(_focusMainContainerTimeoutId, this));
        tools_classPrivateFieldSet(_focusMainContainerTimeoutId, this, null);
      }
      if (tools_classPrivateFieldGet(_translationTimeoutId, this)) {
        clearTimeout(tools_classPrivateFieldGet(_translationTimeoutId, this));
        tools_classPrivateFieldSet(_translationTimeoutId, this, null);
      }
      (_this$_editorUndoBar = this._editorUndoBar) === null || _this$_editorUndoBar === void 0 || _this$_editorUndoBar.destroy();
    }
  }, {
    key: "combinedSignal",
    value: function combinedSignal(ac) {
      return AbortSignal.any([this._signal, ac.signal]);
    }
  }, {
    key: "mlManager",
    get: function get() {
      return tools_classPrivateFieldGet(_mlManager, this);
    }
  }, {
    key: "useNewAltTextFlow",
    get: function get() {
      return tools_classPrivateFieldGet(_enableUpdatedAddImage, this);
    }
  }, {
    key: "useNewAltTextWhenAddingImage",
    get: function get() {
      return tools_classPrivateFieldGet(_enableNewAltTextWhenAddingImage, this);
    }
  }, {
    key: "hcmFilter",
    get: function get() {
      return shadow(this, "hcmFilter", tools_classPrivateFieldGet(_pageColors, this) ? tools_classPrivateFieldGet(_filterFactory, this).addHCMFilter(tools_classPrivateFieldGet(_pageColors, this).foreground, tools_classPrivateFieldGet(_pageColors, this).background) : "none");
    }
  }, {
    key: "direction",
    get: function get() {
      return shadow(this, "direction", getComputedStyle(tools_classPrivateFieldGet(_container, this)).direction);
    }
  }, {
    key: "highlightColors",
    get: function get() {
      return shadow(this, "highlightColors", tools_classPrivateFieldGet(_highlightColors, this) ? new Map(tools_classPrivateFieldGet(_highlightColors, this).split(",").map(function (pair) {
        return pair.split("=").map(function (x) {
          return x.trim();
        });
      })) : null);
    }
  }, {
    key: "highlightColorNames",
    get: function get() {
      return shadow(this, "highlightColorNames", this.highlightColors ? new Map(Array.from(this.highlightColors, function (e) {
        return e.reverse();
      })) : null);
    }
  }, {
    key: "setCurrentDrawingSession",
    value: function setCurrentDrawingSession(layer) {
      if (layer) {
        this.unselectAll();
        this.disableUserSelect(true);
      } else {
        this.disableUserSelect(false);
      }
      tools_classPrivateFieldSet(_currentDrawingSession, this, layer);
    }
  }, {
    key: "setMainHighlightColorPicker",
    value: function setMainHighlightColorPicker(colorPicker) {
      tools_classPrivateFieldSet(_mainHighlightColorPicker, this, colorPicker);
    }
  }, {
    key: "editAltText",
    value: function editAltText(editor) {
      var _classPrivateFieldGet8;
      var firstTime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      (_classPrivateFieldGet8 = tools_classPrivateFieldGet(_altTextManager, this)) === null || _classPrivateFieldGet8 === void 0 || _classPrivateFieldGet8.editAltText(this, editor, firstTime);
    }
  }, {
    key: "switchToMode",
    value: function switchToMode(mode, callback) {
      this._eventBus.on("annotationeditormodechanged", callback, {
        once: true,
        signal: this._signal
      });
      this._eventBus.dispatch("showannotationeditorui", {
        source: this,
        mode: mode
      });
    }
  }, {
    key: "setPreference",
    value: function setPreference(name, value) {
      this._eventBus.dispatch("setpreference", {
        source: this,
        name: name,
        value: value
      });
    }
  }, {
    key: "onSetPreference",
    value: function onSetPreference(_ref2) {
      var name = _ref2.name,
        value = _ref2.value;
      switch (name) {
        case "enableNewAltTextWhenAddingImage":
          tools_classPrivateFieldSet(_enableNewAltTextWhenAddingImage, this, value);
          break;
      }
    }
  }, {
    key: "onPageChanging",
    value: function onPageChanging(_ref3) {
      var pageNumber = _ref3.pageNumber;
      tools_classPrivateFieldSet(_currentPageIndex, this, pageNumber - 1);
    }
  }, {
    key: "focusMainContainer",
    value: function focusMainContainer() {
      tools_classPrivateFieldGet(_container, this).focus();
    }
  }, {
    key: "findParent",
    value: function findParent(x, y) {
      var _iterator6 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values()),
        _step6;
      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var layer = _step6.value;
          var _layer$div$getBoundin = layer.div.getBoundingClientRect(),
            layerX = _layer$div$getBoundin.x,
            layerY = _layer$div$getBoundin.y,
            width = _layer$div$getBoundin.width,
            height = _layer$div$getBoundin.height;
          if (x >= layerX && x <= layerX + width && y >= layerY && y <= layerY + height) {
            return layer;
          }
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }
      return null;
    }
  }, {
    key: "disableUserSelect",
    value: function disableUserSelect() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      tools_classPrivateFieldGet(_viewer, this).classList.toggle("noUserSelect", value);
    }
  }, {
    key: "addShouldRescale",
    value: function addShouldRescale(editor) {
      tools_classPrivateFieldGet(_editorsToRescale, this).add(editor);
    }
  }, {
    key: "removeShouldRescale",
    value: function removeShouldRescale(editor) {
      tools_classPrivateFieldGet(_editorsToRescale, this).delete(editor);
    }
  }, {
    key: "onScaleChanging",
    value: function onScaleChanging(_ref4) {
      var _classPrivateFieldGet9;
      var scale = _ref4.scale;
      this.commitOrRemove();
      this.viewParameters.realScale = scale * PixelsPerInch.PDF_TO_CSS_UNITS;
      var _iterator7 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorsToRescale, this)),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var editor = _step7.value;
          editor.onScaleChanging();
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
      (_classPrivateFieldGet9 = tools_classPrivateFieldGet(_currentDrawingSession, this)) === null || _classPrivateFieldGet9 === void 0 || _classPrivateFieldGet9.onScaleChanging();
    }
  }, {
    key: "onRotationChanging",
    value: function onRotationChanging(_ref5) {
      var pagesRotation = _ref5.pagesRotation;
      this.commitOrRemove();
      this.viewParameters.rotation = pagesRotation;
    }
  }, {
    key: "highlightSelection",
    value: function highlightSelection() {
      var _this4 = this;
      var methodOfCreation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
      var selection = document.getSelection();
      if (!selection || selection.isCollapsed) {
        return;
      }
      var anchorNode = selection.anchorNode,
        anchorOffset = selection.anchorOffset,
        focusNode = selection.focusNode,
        focusOffset = selection.focusOffset;
      var text = selection.toString();
      var anchorElement = tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _getAnchorElementForSelection).call(this, selection);
      var textLayer = anchorElement.closest(".textLayer");
      var boxes = this.getSelectionBoxes(textLayer);
      if (!boxes) {
        return;
      }
      selection.empty();
      var layer = tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _getLayerForTextLayer).call(this, textLayer);
      var isNoneMode = tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.NONE;
      var callback = function callback() {
        layer === null || layer === void 0 || layer.createAndAddNewEditor({
          x: 0,
          y: 0
        }, false, {
          methodOfCreation: methodOfCreation,
          boxes: boxes,
          anchorNode: anchorNode,
          anchorOffset: anchorOffset,
          focusNode: focusNode,
          focusOffset: focusOffset,
          text: text
        });
        if (isNoneMode) {
          _this4.showAllEditors("highlight", true, true);
        }
      };
      if (isNoneMode) {
        this.switchToMode(AnnotationEditorType.HIGHLIGHT, callback);
        return;
      }
      callback();
    }
  }, {
    key: "addToAnnotationStorage",
    value: function addToAnnotationStorage(editor) {
      if (!editor.isEmpty() && tools_classPrivateFieldGet(_annotationStorage, this) && !tools_classPrivateFieldGet(_annotationStorage, this).has(editor.id)) {
        tools_classPrivateFieldGet(_annotationStorage, this).setValue(editor.id, editor);
      }
    }
  }, {
    key: "blur",
    value: function blur() {
      this.isShiftKeyDown = false;
      if (tools_classPrivateFieldGet(_highlightWhenShiftUp, this)) {
        tools_classPrivateFieldSet(_highlightWhenShiftUp, this, false);
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _onSelectEnd).call(this, "main_toolbar");
      }
      if (!this.hasSelection) {
        return;
      }
      var _document = document,
        activeElement = _document.activeElement;
      var _iterator8 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step8;
      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var editor = _step8.value;
          if (editor.div.contains(activeElement)) {
            tools_classPrivateFieldSet(_lastActiveElement, this, [editor, activeElement]);
            editor._focusEventsAllowed = false;
            break;
          }
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }
    }
  }, {
    key: "focus",
    value: function focus() {
      if (!tools_classPrivateFieldGet(_lastActiveElement, this)) {
        return;
      }
      var _classPrivateFieldGet10 = tools_classPrivateFieldGet(_lastActiveElement, this),
        _classPrivateFieldGet11 = tools_slicedToArray(_classPrivateFieldGet10, 2),
        lastEditor = _classPrivateFieldGet11[0],
        lastActiveElement = _classPrivateFieldGet11[1];
      tools_classPrivateFieldSet(_lastActiveElement, this, null);
      lastActiveElement.addEventListener("focusin", function () {
        lastEditor._focusEventsAllowed = true;
      }, {
        once: true,
        signal: this._signal
      });
      lastActiveElement.focus();
    }
  }, {
    key: "addEditListeners",
    value: function addEditListeners() {
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addKeyboardManager).call(this);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addCopyPasteListeners).call(this);
    }
  }, {
    key: "removeEditListeners",
    value: function removeEditListeners() {
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _removeKeyboardManager).call(this);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _removeCopyPasteListeners).call(this);
    }
  }, {
    key: "dragOver",
    value: function dragOver(event) {
      var _iterator9 = tools_createForOfIteratorHelper(event.dataTransfer.items),
        _step9;
      try {
        for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
          var type = _step9.value.type;
          var _iterator10 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorTypes, this)),
            _step10;
          try {
            for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
              var editorType = _step10.value;
              if (editorType.isHandlingMimeForPasting(type)) {
                event.dataTransfer.dropEffect = "copy";
                event.preventDefault();
                return;
              }
            }
          } catch (err) {
            _iterator10.e(err);
          } finally {
            _iterator10.f();
          }
        }
      } catch (err) {
        _iterator9.e(err);
      } finally {
        _iterator9.f();
      }
    }
  }, {
    key: "drop",
    value: function drop(event) {
      var _iterator11 = tools_createForOfIteratorHelper(event.dataTransfer.items),
        _step11;
      try {
        for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
          var item = _step11.value;
          var _iterator12 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorTypes, this)),
            _step12;
          try {
            for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
              var editorType = _step12.value;
              if (editorType.isHandlingMimeForPasting(item.type)) {
                editorType.paste(item, this.currentLayer);
                event.preventDefault();
                return;
              }
            }
          } catch (err) {
            _iterator12.e(err);
          } finally {
            _iterator12.f();
          }
        }
      } catch (err) {
        _iterator11.e(err);
      } finally {
        _iterator11.f();
      }
    }
  }, {
    key: "copy",
    value: function copy(event) {
      var _classPrivateFieldGet12;
      event.preventDefault();
      (_classPrivateFieldGet12 = tools_classPrivateFieldGet(_activeEditor, this)) === null || _classPrivateFieldGet12 === void 0 || _classPrivateFieldGet12.commitOrRemove();
      if (!this.hasSelection) {
        return;
      }
      var editors = [];
      var _iterator13 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step13;
      try {
        for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
          var editor = _step13.value;
          var serialized = editor.serialize(true);
          if (serialized) {
            editors.push(serialized);
          }
        }
      } catch (err) {
        _iterator13.e(err);
      } finally {
        _iterator13.f();
      }
      if (editors.length === 0) {
        return;
      }
      event.clipboardData.setData("application/pdfjs", JSON.stringify(editors));
    }
  }, {
    key: "cut",
    value: function cut(event) {
      this.copy(event);
      this.delete();
    }
  }, {
    key: "paste",
    value: function () {
      var _paste = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee5(event) {
        var _this5 = this;
        var clipboardData, _iterator14, _step14, item, _iterator16, _step16, editorType, data, layer, newEditors, _iterator15, _step15, editor, deserializedEditor, cmd, undo;
        return tools_regeneratorRuntime().wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              event.preventDefault();
              clipboardData = event.clipboardData;
              _iterator14 = tools_createForOfIteratorHelper(clipboardData.items);
              _context5.prev = 3;
              _iterator14.s();
            case 5:
              if ((_step14 = _iterator14.n()).done) {
                _context5.next = 27;
                break;
              }
              item = _step14.value;
              _iterator16 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorTypes, this));
              _context5.prev = 8;
              _iterator16.s();
            case 10:
              if ((_step16 = _iterator16.n()).done) {
                _context5.next = 17;
                break;
              }
              editorType = _step16.value;
              if (!editorType.isHandlingMimeForPasting(item.type)) {
                _context5.next = 15;
                break;
              }
              editorType.paste(item, this.currentLayer);
              return _context5.abrupt("return");
            case 15:
              _context5.next = 10;
              break;
            case 17:
              _context5.next = 22;
              break;
            case 19:
              _context5.prev = 19;
              _context5.t0 = _context5["catch"](8);
              _iterator16.e(_context5.t0);
            case 22:
              _context5.prev = 22;
              _iterator16.f();
              return _context5.finish(22);
            case 25:
              _context5.next = 5;
              break;
            case 27:
              _context5.next = 32;
              break;
            case 29:
              _context5.prev = 29;
              _context5.t1 = _context5["catch"](3);
              _iterator14.e(_context5.t1);
            case 32:
              _context5.prev = 32;
              _iterator14.f();
              return _context5.finish(32);
            case 35:
              data = clipboardData.getData("application/pdfjs");
              if (data) {
                _context5.next = 38;
                break;
              }
              return _context5.abrupt("return");
            case 38:
              _context5.prev = 38;
              data = JSON.parse(data);
              _context5.next = 46;
              break;
            case 42:
              _context5.prev = 42;
              _context5.t2 = _context5["catch"](38);
              warn("paste: \"".concat(_context5.t2.message, "\"."));
              return _context5.abrupt("return");
            case 46:
              if (Array.isArray(data)) {
                _context5.next = 48;
                break;
              }
              return _context5.abrupt("return");
            case 48:
              this.unselectAll();
              layer = this.currentLayer;
              _context5.prev = 50;
              newEditors = [];
              _iterator15 = tools_createForOfIteratorHelper(data);
              _context5.prev = 53;
              _iterator15.s();
            case 55:
              if ((_step15 = _iterator15.n()).done) {
                _context5.next = 65;
                break;
              }
              editor = _step15.value;
              _context5.next = 59;
              return layer.deserialize(editor);
            case 59:
              deserializedEditor = _context5.sent;
              if (deserializedEditor) {
                _context5.next = 62;
                break;
              }
              return _context5.abrupt("return");
            case 62:
              newEditors.push(deserializedEditor);
            case 63:
              _context5.next = 55;
              break;
            case 65:
              _context5.next = 70;
              break;
            case 67:
              _context5.prev = 67;
              _context5.t3 = _context5["catch"](53);
              _iterator15.e(_context5.t3);
            case 70:
              _context5.prev = 70;
              _iterator15.f();
              return _context5.finish(70);
            case 73:
              cmd = function cmd() {
                for (var _i = 0, _newEditors = newEditors; _i < _newEditors.length; _i++) {
                  var editor = _newEditors[_i];
                  tools_assertClassBrand(_AnnotationEditorUIManager_brand, _this5, _addEditorToLayer).call(_this5, editor);
                }
                tools_assertClassBrand(_AnnotationEditorUIManager_brand, _this5, _selectEditors).call(_this5, newEditors);
              };
              undo = function undo() {
                for (var _i2 = 0, _newEditors2 = newEditors; _i2 < _newEditors2.length; _i2++) {
                  var editor = _newEditors2[_i2];
                  editor.remove();
                }
              };
              this.addCommands({
                cmd: cmd,
                undo: undo,
                mustExec: true
              });
              _context5.next = 81;
              break;
            case 78:
              _context5.prev = 78;
              _context5.t4 = _context5["catch"](50);
              warn("paste: \"".concat(_context5.t4.message, "\"."));
            case 81:
            case "end":
              return _context5.stop();
          }
        }, _callee5, this, [[3, 29, 32, 35], [8, 19, 22, 25], [38, 42], [50, 78], [53, 67, 70, 73]]);
      }));
      function paste(_x6) {
        return _paste.apply(this, arguments);
      }
      return paste;
    }()
  }, {
    key: "keydown",
    value: function keydown(event) {
      if (!this.isShiftKeyDown && event.key === "Shift") {
        this.isShiftKeyDown = true;
      }
      if (tools_classPrivateFieldGet(_mode, this) !== AnnotationEditorType.NONE && !this.isEditorHandlingKeyboard) {
        AnnotationEditorUIManager._keyboardManager.exec(this, event);
      }
    }
  }, {
    key: "keyup",
    value: function keyup(event) {
      if (this.isShiftKeyDown && event.key === "Shift") {
        this.isShiftKeyDown = false;
        if (tools_classPrivateFieldGet(_highlightWhenShiftUp, this)) {
          tools_classPrivateFieldSet(_highlightWhenShiftUp, this, false);
          tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _onSelectEnd).call(this, "main_toolbar");
        }
      }
    }
  }, {
    key: "onEditingAction",
    value: function onEditingAction(_ref6) {
      var name = _ref6.name;
      switch (name) {
        case "undo":
        case "redo":
        case "delete":
        case "selectAll":
          this[name]();
          break;
        case "highlightSelection":
          this.highlightSelection("context_menu");
          break;
      }
    }
  }, {
    key: "setEditingState",
    value: function setEditingState(isEditing) {
      if (isEditing) {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addFocusManager).call(this);
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _addCopyPasteListeners).call(this);
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
          isEditing: tools_classPrivateFieldGet(_mode, this) !== AnnotationEditorType.NONE,
          isEmpty: tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _isEmpty).call(this),
          hasSomethingToUndo: tools_classPrivateFieldGet(_commandManager, this).hasSomethingToUndo(),
          hasSomethingToRedo: tools_classPrivateFieldGet(_commandManager, this).hasSomethingToRedo(),
          hasSelectedEditor: false
        });
      } else {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _removeFocusManager).call(this);
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _removeCopyPasteListeners).call(this);
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
          isEditing: false
        });
        this.disableUserSelect(false);
      }
    }
  }, {
    key: "registerEditorTypes",
    value: function registerEditorTypes(types) {
      if (tools_classPrivateFieldGet(_editorTypes, this)) {
        return;
      }
      tools_classPrivateFieldSet(_editorTypes, this, types);
      var _iterator17 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorTypes, this)),
        _step17;
      try {
        for (_iterator17.s(); !(_step17 = _iterator17.n()).done;) {
          var editorType = _step17.value;
          tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editorType.defaultPropertiesToUpdate);
        }
      } catch (err) {
        _iterator17.e(err);
      } finally {
        _iterator17.f();
      }
    }
  }, {
    key: "getId",
    value: function getId() {
      return tools_classPrivateFieldGet(_idManager, this).id;
    }
  }, {
    key: "currentLayer",
    get: function get() {
      return tools_classPrivateFieldGet(_allLayers, this).get(tools_classPrivateFieldGet(_currentPageIndex, this));
    }
  }, {
    key: "getLayer",
    value: function getLayer(pageIndex) {
      return tools_classPrivateFieldGet(_allLayers, this).get(pageIndex);
    }
  }, {
    key: "currentPageIndex",
    get: function get() {
      return tools_classPrivateFieldGet(_currentPageIndex, this);
    }
  }, {
    key: "addLayer",
    value: function addLayer(layer) {
      tools_classPrivateFieldGet(_allLayers, this).set(layer.pageIndex, layer);
      if (tools_classPrivateFieldGet(_isEnabled, this)) {
        layer.enable();
      } else {
        layer.disable();
      }
    }
  }, {
    key: "removeLayer",
    value: function removeLayer(layer) {
      tools_classPrivateFieldGet(_allLayers, this).delete(layer.pageIndex);
    }
  }, {
    key: "updateMode",
    value: function () {
      var _updateMode = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee6(mode) {
        var editId,
          isFromKeyboard,
          _this$_editorUndoBar2,
          _iterator18,
          _step18,
          layer,
          _iterator19,
          _step19,
          editor,
          _args6 = arguments;
        return tools_regeneratorRuntime().wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              editId = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : null;
              isFromKeyboard = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : false;
              if (!(tools_classPrivateFieldGet(_mode, this) === mode)) {
                _context6.next = 4;
                break;
              }
              return _context6.abrupt("return");
            case 4:
              if (!tools_classPrivateFieldGet(_updateModeCapability, this)) {
                _context6.next = 9;
                break;
              }
              _context6.next = 7;
              return tools_classPrivateFieldGet(_updateModeCapability, this).promise;
            case 7:
              if (tools_classPrivateFieldGet(_updateModeCapability, this)) {
                _context6.next = 9;
                break;
              }
              return _context6.abrupt("return");
            case 9:
              tools_classPrivateFieldSet(_updateModeCapability, this, Promise.withResolvers());
              tools_classPrivateFieldSet(_mode, this, mode);
              if (!(mode === AnnotationEditorType.NONE)) {
                _context6.next = 17;
                break;
              }
              this.setEditingState(false);
              tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _disableAll).call(this);
              (_this$_editorUndoBar2 = this._editorUndoBar) === null || _this$_editorUndoBar2 === void 0 || _this$_editorUndoBar2.hide();
              tools_classPrivateFieldGet(_updateModeCapability, this).resolve();
              return _context6.abrupt("return");
            case 17:
              this.setEditingState(true);
              _context6.next = 20;
              return tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _enableAll).call(this);
            case 20:
              this.unselectAll();
              _iterator18 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values());
              try {
                for (_iterator18.s(); !(_step18 = _iterator18.n()).done;) {
                  layer = _step18.value;
                  layer.updateMode(mode);
                }
              } catch (err) {
                _iterator18.e(err);
              } finally {
                _iterator18.f();
              }
              if (editId) {
                _context6.next = 27;
                break;
              }
              if (isFromKeyboard) {
                this.addNewEditorFromKeyboard();
              }
              tools_classPrivateFieldGet(_updateModeCapability, this).resolve();
              return _context6.abrupt("return");
            case 27:
              _iterator19 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values());
              try {
                for (_iterator19.s(); !(_step19 = _iterator19.n()).done;) {
                  editor = _step19.value;
                  if (editor.annotationElementId === editId) {
                    this.setSelected(editor);
                    editor.enterInEditMode();
                  } else {
                    editor.unselect();
                  }
                }
              } catch (err) {
                _iterator19.e(err);
              } finally {
                _iterator19.f();
              }
              tools_classPrivateFieldGet(_updateModeCapability, this).resolve();
            case 30:
            case "end":
              return _context6.stop();
          }
        }, _callee6, this);
      }));
      function updateMode(_x7) {
        return _updateMode.apply(this, arguments);
      }
      return updateMode;
    }()
  }, {
    key: "addNewEditorFromKeyboard",
    value: function addNewEditorFromKeyboard() {
      if (this.currentLayer.canCreateNewEmptyEditor()) {
        this.currentLayer.addNewEditor();
      }
    }
  }, {
    key: "updateToolbar",
    value: function updateToolbar(mode) {
      if (mode === tools_classPrivateFieldGet(_mode, this)) {
        return;
      }
      this._eventBus.dispatch("switchannotationeditormode", {
        source: this,
        mode: mode
      });
    }
  }, {
    key: "updateParams",
    value: function updateParams(type, value) {
      var _classPrivateFieldGet13;
      if (!tools_classPrivateFieldGet(_editorTypes, this)) {
        return;
      }
      switch (type) {
        case AnnotationEditorParamsType.CREATE:
          this.currentLayer.addNewEditor();
          return;
        case AnnotationEditorParamsType.HIGHLIGHT_DEFAULT_COLOR:
          (_classPrivateFieldGet13 = tools_classPrivateFieldGet(_mainHighlightColorPicker, this)) === null || _classPrivateFieldGet13 === void 0 || _classPrivateFieldGet13.updateColor(value);
          break;
        case AnnotationEditorParamsType.HIGHLIGHT_SHOW_ALL:
          this._eventBus.dispatch("reporttelemetry", {
            source: this,
            details: {
              type: "editing",
              data: {
                type: "highlight",
                action: "toggle_visibility"
              }
            }
          });
          (tools_classPrivateFieldGet(_showAllStates, this) || tools_classPrivateFieldSet(_showAllStates, this, new Map())).set(type, value);
          this.showAllEditors("highlight", value);
          break;
      }
      var _iterator20 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step20;
      try {
        for (_iterator20.s(); !(_step20 = _iterator20.n()).done;) {
          var editor = _step20.value;
          editor.updateParams(type, value);
        }
      } catch (err) {
        _iterator20.e(err);
      } finally {
        _iterator20.f();
      }
      var _iterator21 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_editorTypes, this)),
        _step21;
      try {
        for (_iterator21.s(); !(_step21 = _iterator21.n()).done;) {
          var editorType = _step21.value;
          editorType.updateDefaultParams(type, value);
        }
      } catch (err) {
        _iterator21.e(err);
      } finally {
        _iterator21.f();
      }
    }
  }, {
    key: "showAllEditors",
    value: function showAllEditors(type, visible) {
      var _classPrivateFieldGet14, _classPrivateFieldGet15;
      var updateButton = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var _iterator22 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values()),
        _step22;
      try {
        for (_iterator22.s(); !(_step22 = _iterator22.n()).done;) {
          var editor = _step22.value;
          if (editor.editorType === type) {
            editor.show(visible);
          }
        }
      } catch (err) {
        _iterator22.e(err);
      } finally {
        _iterator22.f();
      }
      var state = (_classPrivateFieldGet14 = (_classPrivateFieldGet15 = tools_classPrivateFieldGet(_showAllStates, this)) === null || _classPrivateFieldGet15 === void 0 ? void 0 : _classPrivateFieldGet15.get(AnnotationEditorParamsType.HIGHLIGHT_SHOW_ALL)) !== null && _classPrivateFieldGet14 !== void 0 ? _classPrivateFieldGet14 : true;
      if (state !== visible) {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, [[AnnotationEditorParamsType.HIGHLIGHT_SHOW_ALL, visible]]);
      }
    }
  }, {
    key: "enableWaiting",
    value: function enableWaiting() {
      var mustWait = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (tools_classPrivateFieldGet(_isWaiting, this) === mustWait) {
        return;
      }
      tools_classPrivateFieldSet(_isWaiting, this, mustWait);
      var _iterator23 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values()),
        _step23;
      try {
        for (_iterator23.s(); !(_step23 = _iterator23.n()).done;) {
          var layer = _step23.value;
          if (mustWait) {
            layer.disableClick();
          } else {
            layer.enableClick();
          }
          layer.div.classList.toggle("waiting", mustWait);
        }
      } catch (err) {
        _iterator23.e(err);
      } finally {
        _iterator23.f();
      }
    }
  }, {
    key: "getEditors",
    value: function getEditors(pageIndex) {
      var editors = [];
      var _iterator24 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values()),
        _step24;
      try {
        for (_iterator24.s(); !(_step24 = _iterator24.n()).done;) {
          var editor = _step24.value;
          if (editor.pageIndex === pageIndex) {
            editors.push(editor);
          }
        }
      } catch (err) {
        _iterator24.e(err);
      } finally {
        _iterator24.f();
      }
      return editors;
    }
  }, {
    key: "getEditor",
    value: function getEditor(id) {
      return tools_classPrivateFieldGet(_allEditors, this).get(id);
    }
  }, {
    key: "addEditor",
    value: function addEditor(editor) {
      tools_classPrivateFieldGet(_allEditors, this).set(editor.id, editor);
    }
  }, {
    key: "removeEditor",
    value: function removeEditor(editor) {
      var _this6 = this;
      if (editor.div.contains(document.activeElement)) {
        if (tools_classPrivateFieldGet(_focusMainContainerTimeoutId, this)) {
          clearTimeout(tools_classPrivateFieldGet(_focusMainContainerTimeoutId, this));
        }
        tools_classPrivateFieldSet(_focusMainContainerTimeoutId, this, setTimeout(function () {
          _this6.focusMainContainer();
          tools_classPrivateFieldSet(_focusMainContainerTimeoutId, _this6, null);
        }, 0));
      }
      tools_classPrivateFieldGet(_allEditors, this).delete(editor.id);
      this.unselect(editor);
      if (!editor.annotationElementId || !tools_classPrivateFieldGet(_deletedAnnotationsElementIds, this).has(editor.annotationElementId)) {
        var _classPrivateFieldGet16;
        (_classPrivateFieldGet16 = tools_classPrivateFieldGet(_annotationStorage, this)) === null || _classPrivateFieldGet16 === void 0 || _classPrivateFieldGet16.remove(editor.id);
      }
    }
  }, {
    key: "addDeletedAnnotationElement",
    value: function addDeletedAnnotationElement(editor) {
      tools_classPrivateFieldGet(_deletedAnnotationsElementIds, this).add(editor.annotationElementId);
      this.addChangedExistingAnnotation(editor);
      editor.deleted = true;
    }
  }, {
    key: "isDeletedAnnotationElement",
    value: function isDeletedAnnotationElement(annotationElementId) {
      return tools_classPrivateFieldGet(_deletedAnnotationsElementIds, this).has(annotationElementId);
    }
  }, {
    key: "removeDeletedAnnotationElement",
    value: function removeDeletedAnnotationElement(editor) {
      tools_classPrivateFieldGet(_deletedAnnotationsElementIds, this).delete(editor.annotationElementId);
      this.removeChangedExistingAnnotation(editor);
      editor.deleted = false;
    }
  }, {
    key: "setActiveEditor",
    value: function setActiveEditor(editor) {
      if (tools_classPrivateFieldGet(_activeEditor, this) === editor) {
        return;
      }
      tools_classPrivateFieldSet(_activeEditor, this, editor);
      if (editor) {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editor.propertiesToUpdate);
      }
    }
  }, {
    key: "updateUI",
    value: function updateUI(editor) {
      if (tools_classPrivateGetter(_AnnotationEditorUIManager_brand, this, _get_lastSelectedEditor) === editor) {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editor.propertiesToUpdate);
      }
    }
  }, {
    key: "updateUIForDefaultProperties",
    value: function updateUIForDefaultProperties(editorType) {
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editorType.defaultPropertiesToUpdate);
    }
  }, {
    key: "toggleSelected",
    value: function toggleSelected(editor) {
      if (tools_classPrivateFieldGet(_selectedEditors, this).has(editor)) {
        tools_classPrivateFieldGet(_selectedEditors, this).delete(editor);
        editor.unselect();
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
          hasSelectedEditor: this.hasSelection
        });
        return;
      }
      tools_classPrivateFieldGet(_selectedEditors, this).add(editor);
      editor.select();
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editor.propertiesToUpdate);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedEditor: true
      });
    }
  }, {
    key: "setSelected",
    value: function setSelected(editor) {
      var _classPrivateFieldGet17;
      (_classPrivateFieldGet17 = tools_classPrivateFieldGet(_currentDrawingSession, this)) === null || _classPrivateFieldGet17 === void 0 || _classPrivateFieldGet17.commitOrRemove();
      var _iterator25 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step25;
      try {
        for (_iterator25.s(); !(_step25 = _iterator25.n()).done;) {
          var ed = _step25.value;
          if (ed !== editor) {
            ed.unselect();
          }
        }
      } catch (err) {
        _iterator25.e(err);
      } finally {
        _iterator25.f();
      }
      tools_classPrivateFieldGet(_selectedEditors, this).clear();
      tools_classPrivateFieldGet(_selectedEditors, this).add(editor);
      editor.select();
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, editor.propertiesToUpdate);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedEditor: true
      });
    }
  }, {
    key: "isSelected",
    value: function isSelected(editor) {
      return tools_classPrivateFieldGet(_selectedEditors, this).has(editor);
    }
  }, {
    key: "firstSelectedEditor",
    get: function get() {
      return tools_classPrivateFieldGet(_selectedEditors, this).values().next().value;
    }
  }, {
    key: "unselect",
    value: function unselect(editor) {
      editor.unselect();
      tools_classPrivateFieldGet(_selectedEditors, this).delete(editor);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedEditor: this.hasSelection
      });
    }
  }, {
    key: "hasSelection",
    get: function get() {
      return tools_classPrivateFieldGet(_selectedEditors, this).size !== 0;
    }
  }, {
    key: "isEnterHandled",
    get: function get() {
      return tools_classPrivateFieldGet(_selectedEditors, this).size === 1 && this.firstSelectedEditor.isEnterHandled;
    }
  }, {
    key: "undo",
    value: function undo() {
      var _this$_editorUndoBar3;
      tools_classPrivateFieldGet(_commandManager, this).undo();
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSomethingToUndo: tools_classPrivateFieldGet(_commandManager, this).hasSomethingToUndo(),
        hasSomethingToRedo: true,
        isEmpty: tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _isEmpty).call(this)
      });
      (_this$_editorUndoBar3 = this._editorUndoBar) === null || _this$_editorUndoBar3 === void 0 || _this$_editorUndoBar3.hide();
    }
  }, {
    key: "redo",
    value: function redo() {
      tools_classPrivateFieldGet(_commandManager, this).redo();
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSomethingToUndo: true,
        hasSomethingToRedo: tools_classPrivateFieldGet(_commandManager, this).hasSomethingToRedo(),
        isEmpty: tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _isEmpty).call(this)
      });
    }
  }, {
    key: "addCommands",
    value: function addCommands(params) {
      tools_classPrivateFieldGet(_commandManager, this).add(params);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSomethingToUndo: true,
        hasSomethingToRedo: false,
        isEmpty: tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _isEmpty).call(this)
      });
    }
  }, {
    key: "cleanUndoStack",
    value: function cleanUndoStack(type) {
      tools_classPrivateFieldGet(_commandManager, this).cleanType(type);
    }
  }, {
    key: "delete",
    value: function _delete() {
      var _this$currentLayer,
        _this7 = this;
      this.commitOrRemove();
      var drawingEditor = (_this$currentLayer = this.currentLayer) === null || _this$currentLayer === void 0 ? void 0 : _this$currentLayer.endDrawingSession(true);
      if (!this.hasSelection && !drawingEditor) {
        return;
      }
      var editors = drawingEditor ? [drawingEditor] : _toConsumableArray(tools_classPrivateFieldGet(_selectedEditors, this));
      var cmd = function cmd() {
        var _this7$_editorUndoBar;
        (_this7$_editorUndoBar = _this7._editorUndoBar) === null || _this7$_editorUndoBar === void 0 || _this7$_editorUndoBar.show(undo, editors.length === 1 ? editors[0].editorType : editors.length);
        var _iterator26 = tools_createForOfIteratorHelper(editors),
          _step26;
        try {
          for (_iterator26.s(); !(_step26 = _iterator26.n()).done;) {
            var editor = _step26.value;
            editor.remove();
          }
        } catch (err) {
          _iterator26.e(err);
        } finally {
          _iterator26.f();
        }
      };
      var undo = function undo() {
        var _iterator27 = tools_createForOfIteratorHelper(editors),
          _step27;
        try {
          for (_iterator27.s(); !(_step27 = _iterator27.n()).done;) {
            var editor = _step27.value;
            tools_assertClassBrand(_AnnotationEditorUIManager_brand, _this7, _addEditorToLayer).call(_this7, editor);
          }
        } catch (err) {
          _iterator27.e(err);
        } finally {
          _iterator27.f();
        }
      };
      this.addCommands({
        cmd: cmd,
        undo: undo,
        mustExec: true
      });
    }
  }, {
    key: "commitOrRemove",
    value: function commitOrRemove() {
      var _classPrivateFieldGet18;
      (_classPrivateFieldGet18 = tools_classPrivateFieldGet(_activeEditor, this)) === null || _classPrivateFieldGet18 === void 0 || _classPrivateFieldGet18.commitOrRemove();
    }
  }, {
    key: "hasSomethingToControl",
    value: function hasSomethingToControl() {
      return tools_classPrivateFieldGet(_activeEditor, this) || this.hasSelection;
    }
  }, {
    key: "selectAll",
    value: function selectAll() {
      var _iterator28 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step28;
      try {
        for (_iterator28.s(); !(_step28 = _iterator28.n()).done;) {
          var editor = _step28.value;
          editor.commit();
        }
      } catch (err) {
        _iterator28.e(err);
      } finally {
        _iterator28.f();
      }
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _selectEditors).call(this, tools_classPrivateFieldGet(_allEditors, this).values());
    }
  }, {
    key: "unselectAll",
    value: function unselectAll() {
      var _classPrivateFieldGet19;
      if (tools_classPrivateFieldGet(_activeEditor, this)) {
        tools_classPrivateFieldGet(_activeEditor, this).commitOrRemove();
        if (tools_classPrivateFieldGet(_mode, this) !== AnnotationEditorType.NONE) {
          return;
        }
      }
      if ((_classPrivateFieldGet19 = tools_classPrivateFieldGet(_currentDrawingSession, this)) !== null && _classPrivateFieldGet19 !== void 0 && _classPrivateFieldGet19.commitOrRemove()) {
        return;
      }
      if (!this.hasSelection) {
        return;
      }
      var _iterator29 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step29;
      try {
        for (_iterator29.s(); !(_step29 = _iterator29.n()).done;) {
          var editor = _step29.value;
          editor.unselect();
        }
      } catch (err) {
        _iterator29.e(err);
      } finally {
        _iterator29.f();
      }
      tools_classPrivateFieldGet(_selectedEditors, this).clear();
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedEditor: false
      });
    }
  }, {
    key: "translateSelectedEditors",
    value: function translateSelectedEditors(x, y) {
      var _this8 = this;
      var noCommit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (!noCommit) {
        this.commitOrRemove();
      }
      if (!this.hasSelection) {
        return;
      }
      tools_classPrivateFieldGet(_translation, this)[0] += x;
      tools_classPrivateFieldGet(_translation, this)[1] += y;
      var _classPrivateFieldGet20 = tools_classPrivateFieldGet(_translation, this),
        _classPrivateFieldGet21 = tools_slicedToArray(_classPrivateFieldGet20, 2),
        totalX = _classPrivateFieldGet21[0],
        totalY = _classPrivateFieldGet21[1];
      var editors = _toConsumableArray(tools_classPrivateFieldGet(_selectedEditors, this));
      var TIME_TO_WAIT = 1000;
      if (tools_classPrivateFieldGet(_translationTimeoutId, this)) {
        clearTimeout(tools_classPrivateFieldGet(_translationTimeoutId, this));
      }
      tools_classPrivateFieldSet(_translationTimeoutId, this, setTimeout(function () {
        tools_classPrivateFieldSet(_translationTimeoutId, _this8, null);
        tools_classPrivateFieldGet(_translation, _this8)[0] = tools_classPrivateFieldGet(_translation, _this8)[1] = 0;
        _this8.addCommands({
          cmd: function cmd() {
            var _iterator30 = tools_createForOfIteratorHelper(editors),
              _step30;
            try {
              for (_iterator30.s(); !(_step30 = _iterator30.n()).done;) {
                var editor = _step30.value;
                if (tools_classPrivateFieldGet(_allEditors, _this8).has(editor.id)) {
                  editor.translateInPage(totalX, totalY);
                }
              }
            } catch (err) {
              _iterator30.e(err);
            } finally {
              _iterator30.f();
            }
          },
          undo: function undo() {
            var _iterator31 = tools_createForOfIteratorHelper(editors),
              _step31;
            try {
              for (_iterator31.s(); !(_step31 = _iterator31.n()).done;) {
                var editor = _step31.value;
                if (tools_classPrivateFieldGet(_allEditors, _this8).has(editor.id)) {
                  editor.translateInPage(-totalX, -totalY);
                }
              }
            } catch (err) {
              _iterator31.e(err);
            } finally {
              _iterator31.f();
            }
          },
          mustExec: false
        });
      }, TIME_TO_WAIT));
      var _iterator32 = tools_createForOfIteratorHelper(editors),
        _step32;
      try {
        for (_iterator32.s(); !(_step32 = _iterator32.n()).done;) {
          var editor = _step32.value;
          editor.translateInPage(x, y);
        }
      } catch (err) {
        _iterator32.e(err);
      } finally {
        _iterator32.f();
      }
    }
  }, {
    key: "setUpDragSession",
    value: function setUpDragSession() {
      if (!this.hasSelection) {
        return;
      }
      this.disableUserSelect(true);
      tools_classPrivateFieldSet(_draggingEditors, this, new Map());
      var _iterator33 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
        _step33;
      try {
        for (_iterator33.s(); !(_step33 = _iterator33.n()).done;) {
          var editor = _step33.value;
          tools_classPrivateFieldGet(_draggingEditors, this).set(editor, {
            savedX: editor.x,
            savedY: editor.y,
            savedPageIndex: editor.pageIndex,
            newX: 0,
            newY: 0,
            newPageIndex: -1
          });
        }
      } catch (err) {
        _iterator33.e(err);
      } finally {
        _iterator33.f();
      }
    }
  }, {
    key: "endDragSession",
    value: function endDragSession() {
      var _this9 = this;
      if (!tools_classPrivateFieldGet(_draggingEditors, this)) {
        return false;
      }
      this.disableUserSelect(false);
      var map = tools_classPrivateFieldGet(_draggingEditors, this);
      tools_classPrivateFieldSet(_draggingEditors, this, null);
      var mustBeAddedInUndoStack = false;
      var _iterator34 = tools_createForOfIteratorHelper(map),
        _step34;
      try {
        for (_iterator34.s(); !(_step34 = _iterator34.n()).done;) {
          var _step34$value = tools_slicedToArray(_step34.value, 2),
            _step34$value$ = _step34$value[0],
            x = _step34$value$.x,
            y = _step34$value$.y,
            pageIndex = _step34$value$.pageIndex,
            value = _step34$value[1];
          value.newX = x;
          value.newY = y;
          value.newPageIndex = pageIndex;
          mustBeAddedInUndoStack || (mustBeAddedInUndoStack = x !== value.savedX || y !== value.savedY || pageIndex !== value.savedPageIndex);
        }
      } catch (err) {
        _iterator34.e(err);
      } finally {
        _iterator34.f();
      }
      if (!mustBeAddedInUndoStack) {
        return false;
      }
      var move = function move(editor, x, y, pageIndex) {
        if (tools_classPrivateFieldGet(_allEditors, _this9).has(editor.id)) {
          var parent = tools_classPrivateFieldGet(_allLayers, _this9).get(pageIndex);
          if (parent) {
            editor._setParentAndPosition(parent, x, y);
          } else {
            editor.pageIndex = pageIndex;
            editor.x = x;
            editor.y = y;
          }
        }
      };
      this.addCommands({
        cmd: function cmd() {
          var _iterator35 = tools_createForOfIteratorHelper(map),
            _step35;
          try {
            for (_iterator35.s(); !(_step35 = _iterator35.n()).done;) {
              var _step35$value = tools_slicedToArray(_step35.value, 2),
                editor = _step35$value[0],
                _step35$value$ = _step35$value[1],
                newX = _step35$value$.newX,
                newY = _step35$value$.newY,
                newPageIndex = _step35$value$.newPageIndex;
              move(editor, newX, newY, newPageIndex);
            }
          } catch (err) {
            _iterator35.e(err);
          } finally {
            _iterator35.f();
          }
        },
        undo: function undo() {
          var _iterator36 = tools_createForOfIteratorHelper(map),
            _step36;
          try {
            for (_iterator36.s(); !(_step36 = _iterator36.n()).done;) {
              var _step36$value = tools_slicedToArray(_step36.value, 2),
                editor = _step36$value[0],
                _step36$value$ = _step36$value[1],
                savedX = _step36$value$.savedX,
                savedY = _step36$value$.savedY,
                savedPageIndex = _step36$value$.savedPageIndex;
              move(editor, savedX, savedY, savedPageIndex);
            }
          } catch (err) {
            _iterator36.e(err);
          } finally {
            _iterator36.f();
          }
        },
        mustExec: true
      });
      return true;
    }
  }, {
    key: "dragSelectedEditors",
    value: function dragSelectedEditors(tx, ty) {
      if (!tools_classPrivateFieldGet(_draggingEditors, this)) {
        return;
      }
      var _iterator37 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_draggingEditors, this).keys()),
        _step37;
      try {
        for (_iterator37.s(); !(_step37 = _iterator37.n()).done;) {
          var editor = _step37.value;
          editor.drag(tx, ty);
        }
      } catch (err) {
        _iterator37.e(err);
      } finally {
        _iterator37.f();
      }
    }
  }, {
    key: "rebuild",
    value: function rebuild(editor) {
      if (editor.parent === null) {
        var parent = this.getLayer(editor.pageIndex);
        if (parent) {
          parent.changeParent(editor);
          parent.addOrRebuild(editor);
        } else {
          this.addEditor(editor);
          this.addToAnnotationStorage(editor);
          editor.rebuild();
        }
      } else {
        editor.parent.addOrRebuild(editor);
      }
    }
  }, {
    key: "isEditorHandlingKeyboard",
    get: function get() {
      var _this$getActive;
      return ((_this$getActive = this.getActive()) === null || _this$getActive === void 0 ? void 0 : _this$getActive.shouldGetKeyboardEvents()) || tools_classPrivateFieldGet(_selectedEditors, this).size === 1 && this.firstSelectedEditor.shouldGetKeyboardEvents();
    }
  }, {
    key: "isActive",
    value: function isActive(editor) {
      return tools_classPrivateFieldGet(_activeEditor, this) === editor;
    }
  }, {
    key: "getActive",
    value: function getActive() {
      return tools_classPrivateFieldGet(_activeEditor, this);
    }
  }, {
    key: "getMode",
    value: function getMode() {
      return tools_classPrivateFieldGet(_mode, this);
    }
  }, {
    key: "imageManager",
    get: function get() {
      return shadow(this, "imageManager", new ImageManager());
    }
  }, {
    key: "getSelectionBoxes",
    value: function getSelectionBoxes(textLayer) {
      if (!textLayer) {
        return null;
      }
      var selection = document.getSelection();
      for (var i = 0, ii = selection.rangeCount; i < ii; i++) {
        if (!textLayer.contains(selection.getRangeAt(i).commonAncestorContainer)) {
          return null;
        }
      }
      var _textLayer$getBoundin = textLayer.getBoundingClientRect(),
        layerX = _textLayer$getBoundin.x,
        layerY = _textLayer$getBoundin.y,
        parentWidth = _textLayer$getBoundin.width,
        parentHeight = _textLayer$getBoundin.height;
      var rotator;
      switch (textLayer.getAttribute("data-main-rotation")) {
        case "90":
          rotator = function rotator(x, y, w, h) {
            return {
              x: (y - layerY) / parentHeight,
              y: 1 - (x + w - layerX) / parentWidth,
              width: h / parentHeight,
              height: w / parentWidth
            };
          };
          break;
        case "180":
          rotator = function rotator(x, y, w, h) {
            return {
              x: 1 - (x + w - layerX) / parentWidth,
              y: 1 - (y + h - layerY) / parentHeight,
              width: w / parentWidth,
              height: h / parentHeight
            };
          };
          break;
        case "270":
          rotator = function rotator(x, y, w, h) {
            return {
              x: 1 - (y + h - layerY) / parentHeight,
              y: (x - layerX) / parentWidth,
              width: h / parentHeight,
              height: w / parentWidth
            };
          };
          break;
        default:
          rotator = function rotator(x, y, w, h) {
            return {
              x: (x - layerX) / parentWidth,
              y: (y - layerY) / parentHeight,
              width: w / parentWidth,
              height: h / parentHeight
            };
          };
          break;
      }
      var boxes = [];
      for (var _i3 = 0, _ii = selection.rangeCount; _i3 < _ii; _i3++) {
        var range = selection.getRangeAt(_i3);
        if (range.collapsed) {
          continue;
        }
        var _iterator38 = tools_createForOfIteratorHelper(range.getClientRects()),
          _step38;
        try {
          for (_iterator38.s(); !(_step38 = _iterator38.n()).done;) {
            var _step38$value = _step38.value,
              x = _step38$value.x,
              y = _step38$value.y,
              width = _step38$value.width,
              height = _step38$value.height;
            if (width === 0 || height === 0) {
              continue;
            }
            boxes.push(rotator(x, y, width, height));
          }
        } catch (err) {
          _iterator38.e(err);
        } finally {
          _iterator38.f();
        }
      }
      return boxes.length === 0 ? null : boxes;
    }
  }, {
    key: "addChangedExistingAnnotation",
    value: function addChangedExistingAnnotation(_ref7) {
      var annotationElementId = _ref7.annotationElementId,
        id = _ref7.id;
      (tools_classPrivateFieldGet(_changedExistingAnnotations, this) || tools_classPrivateFieldSet(_changedExistingAnnotations, this, new Map())).set(annotationElementId, id);
    }
  }, {
    key: "removeChangedExistingAnnotation",
    value: function removeChangedExistingAnnotation(_ref8) {
      var _classPrivateFieldGet22;
      var annotationElementId = _ref8.annotationElementId;
      (_classPrivateFieldGet22 = tools_classPrivateFieldGet(_changedExistingAnnotations, this)) === null || _classPrivateFieldGet22 === void 0 || _classPrivateFieldGet22.delete(annotationElementId);
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      var _classPrivateFieldGet23;
      var editorId = (_classPrivateFieldGet23 = tools_classPrivateFieldGet(_changedExistingAnnotations, this)) === null || _classPrivateFieldGet23 === void 0 ? void 0 : _classPrivateFieldGet23.get(annotation.data.id);
      if (!editorId) {
        return;
      }
      var editor = tools_classPrivateFieldGet(_annotationStorage, this).getRawValue(editorId);
      if (!editor) {
        return;
      }
      if (tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.NONE && !editor.hasBeenModified) {
        return;
      }
      editor.renderAnnotationElement(annotation);
    }
  }], [{
    key: "_keyboardManager",
    get: function get() {
      var proto = AnnotationEditorUIManager.prototype;
      var arrowChecker = function arrowChecker(self) {
        return tools_classPrivateFieldGet(_container, self).contains(document.activeElement) && document.activeElement.tagName !== "BUTTON" && self.hasSomethingToControl();
      };
      var textInputChecker = function textInputChecker(_self, _ref9) {
        var el = _ref9.target;
        if (el instanceof HTMLInputElement) {
          var type = el.type;
          return type !== "text" && type !== "number";
        }
        return true;
      };
      var small = this.TRANSLATE_SMALL;
      var big = this.TRANSLATE_BIG;
      return shadow(this, "_keyboardManager", new KeyboardManager([[["ctrl+a", "mac+meta+a"], proto.selectAll, {
        checker: textInputChecker
      }], [["ctrl+z", "mac+meta+z"], proto.undo, {
        checker: textInputChecker
      }], [["ctrl+y", "ctrl+shift+z", "mac+meta+shift+z", "ctrl+shift+Z", "mac+meta+shift+Z"], proto.redo, {
        checker: textInputChecker
      }], [["Backspace", "alt+Backspace", "ctrl+Backspace", "shift+Backspace", "mac+Backspace", "mac+alt+Backspace", "mac+ctrl+Backspace", "Delete", "ctrl+Delete", "shift+Delete", "mac+Delete"], proto.delete, {
        checker: textInputChecker
      }], [["Enter", "mac+Enter"], proto.addNewEditorFromKeyboard, {
        checker: function checker(self, _ref10) {
          var el = _ref10.target;
          return !(el instanceof HTMLButtonElement) && tools_classPrivateFieldGet(_container, self).contains(el) && !self.isEnterHandled;
        }
      }], [[" ", "mac+ "], proto.addNewEditorFromKeyboard, {
        checker: function checker(self, _ref11) {
          var el = _ref11.target;
          return !(el instanceof HTMLButtonElement) && tools_classPrivateFieldGet(_container, self).contains(document.activeElement);
        }
      }], [["Escape", "mac+Escape"], proto.unselectAll], [["ArrowLeft", "mac+ArrowLeft"], proto.translateSelectedEditors, {
        args: [-small, 0],
        checker: arrowChecker
      }], [["ctrl+ArrowLeft", "mac+shift+ArrowLeft"], proto.translateSelectedEditors, {
        args: [-big, 0],
        checker: arrowChecker
      }], [["ArrowRight", "mac+ArrowRight"], proto.translateSelectedEditors, {
        args: [small, 0],
        checker: arrowChecker
      }], [["ctrl+ArrowRight", "mac+shift+ArrowRight"], proto.translateSelectedEditors, {
        args: [big, 0],
        checker: arrowChecker
      }], [["ArrowUp", "mac+ArrowUp"], proto.translateSelectedEditors, {
        args: [0, -small],
        checker: arrowChecker
      }], [["ctrl+ArrowUp", "mac+shift+ArrowUp"], proto.translateSelectedEditors, {
        args: [0, -big],
        checker: arrowChecker
      }], [["ArrowDown", "mac+ArrowDown"], proto.translateSelectedEditors, {
        args: [0, small],
        checker: arrowChecker
      }], [["ctrl+ArrowDown", "mac+shift+ArrowDown"], proto.translateSelectedEditors, {
        args: [0, big],
        checker: arrowChecker
      }]]));
    }
  }]);
}();
function _getAnchorElementForSelection(_ref12) {
  var anchorNode = _ref12.anchorNode;
  return anchorNode.nodeType === Node.TEXT_NODE ? anchorNode.parentElement : anchorNode;
}
function _getLayerForTextLayer(textLayer) {
  var currentLayer = this.currentLayer;
  if (currentLayer.hasTextLayer(textLayer)) {
    return currentLayer;
  }
  var _iterator39 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values()),
    _step39;
  try {
    for (_iterator39.s(); !(_step39 = _iterator39.n()).done;) {
      var layer = _step39.value;
      if (layer.hasTextLayer(textLayer)) {
        return layer;
      }
    }
  } catch (err) {
    _iterator39.e(err);
  } finally {
    _iterator39.f();
  }
  return null;
}
function _displayHighlightToolbar() {
  var selection = document.getSelection();
  if (!selection || selection.isCollapsed) {
    return;
  }
  var anchorElement = tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _getAnchorElementForSelection).call(this, selection);
  var textLayer = anchorElement.closest(".textLayer");
  var boxes = this.getSelectionBoxes(textLayer);
  if (!boxes) {
    return;
  }
  tools_classPrivateFieldGet(_highlightToolbar, this) || tools_classPrivateFieldSet(_highlightToolbar, this, new HighlightToolbar(this));
  tools_classPrivateFieldGet(_highlightToolbar, this).show(textLayer, boxes, this.direction === "ltr");
}
function _selectionChange() {
  var _classPrivateFieldGet26,
    _this10 = this;
  var selection = document.getSelection();
  if (!selection || selection.isCollapsed) {
    if (tools_classPrivateFieldGet(_selectedTextNode, this)) {
      var _classPrivateFieldGet24;
      (_classPrivateFieldGet24 = tools_classPrivateFieldGet(_highlightToolbar, this)) === null || _classPrivateFieldGet24 === void 0 || _classPrivateFieldGet24.hide();
      tools_classPrivateFieldSet(_selectedTextNode, this, null);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedText: false
      });
    }
    return;
  }
  var anchorNode = selection.anchorNode;
  if (anchorNode === tools_classPrivateFieldGet(_selectedTextNode, this)) {
    return;
  }
  var anchorElement = tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _getAnchorElementForSelection).call(this, selection);
  var textLayer = anchorElement.closest(".textLayer");
  if (!textLayer) {
    if (tools_classPrivateFieldGet(_selectedTextNode, this)) {
      var _classPrivateFieldGet25;
      (_classPrivateFieldGet25 = tools_classPrivateFieldGet(_highlightToolbar, this)) === null || _classPrivateFieldGet25 === void 0 || _classPrivateFieldGet25.hide();
      tools_classPrivateFieldSet(_selectedTextNode, this, null);
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
        hasSelectedText: false
      });
    }
    return;
  }
  (_classPrivateFieldGet26 = tools_classPrivateFieldGet(_highlightToolbar, this)) === null || _classPrivateFieldGet26 === void 0 || _classPrivateFieldGet26.hide();
  tools_classPrivateFieldSet(_selectedTextNode, this, anchorNode);
  tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
    hasSelectedText: true
  });
  if (tools_classPrivateFieldGet(_mode, this) !== AnnotationEditorType.HIGHLIGHT && tools_classPrivateFieldGet(_mode, this) !== AnnotationEditorType.NONE) {
    return;
  }
  if (tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.HIGHLIGHT) {
    this.showAllEditors("highlight", true, true);
  }
  tools_classPrivateFieldSet(_highlightWhenShiftUp, this, this.isShiftKeyDown);
  if (!this.isShiftKeyDown) {
    var activeLayer = tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.HIGHLIGHT ? tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _getLayerForTextLayer).call(this, textLayer) : null;
    activeLayer === null || activeLayer === void 0 || activeLayer.toggleDrawing();
    var ac = new AbortController();
    var signal = this.combinedSignal(ac);
    var pointerup = function pointerup(e) {
      if (e.type === "pointerup" && e.button !== 0) {
        return;
      }
      ac.abort();
      activeLayer === null || activeLayer === void 0 || activeLayer.toggleDrawing(true);
      if (e.type === "pointerup") {
        tools_assertClassBrand(_AnnotationEditorUIManager_brand, _this10, _onSelectEnd).call(_this10, "main_toolbar");
      }
    };
    window.addEventListener("pointerup", pointerup, {
      signal: signal
    });
    window.addEventListener("blur", pointerup, {
      signal: signal
    });
  }
}
function _onSelectEnd() {
  var methodOfCreation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";
  if (tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.HIGHLIGHT) {
    this.highlightSelection(methodOfCreation);
  } else if (tools_classPrivateFieldGet(_enableHighlightFloatingButton, this)) {
    tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _displayHighlightToolbar).call(this);
  }
}
function _addSelectionListener() {
  document.addEventListener("selectionchange", tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _selectionChange).bind(this), {
    signal: this._signal
  });
}
function _addFocusManager() {
  if (tools_classPrivateFieldGet(_focusManagerAC, this)) {
    return;
  }
  tools_classPrivateFieldSet(_focusManagerAC, this, new AbortController());
  var signal = this.combinedSignal(tools_classPrivateFieldGet(_focusManagerAC, this));
  window.addEventListener("focus", this.focus.bind(this), {
    signal: signal
  });
  window.addEventListener("blur", this.blur.bind(this), {
    signal: signal
  });
}
function _removeFocusManager() {
  var _classPrivateFieldGet27;
  (_classPrivateFieldGet27 = tools_classPrivateFieldGet(_focusManagerAC, this)) === null || _classPrivateFieldGet27 === void 0 || _classPrivateFieldGet27.abort();
  tools_classPrivateFieldSet(_focusManagerAC, this, null);
}
function _addKeyboardManager() {
  if (tools_classPrivateFieldGet(_keyboardManagerAC, this)) {
    return;
  }
  tools_classPrivateFieldSet(_keyboardManagerAC, this, new AbortController());
  var signal = this.combinedSignal(tools_classPrivateFieldGet(_keyboardManagerAC, this));
  window.addEventListener("keydown", this.keydown.bind(this), {
    signal: signal
  });
  window.addEventListener("keyup", this.keyup.bind(this), {
    signal: signal
  });
}
function _removeKeyboardManager() {
  var _classPrivateFieldGet28;
  (_classPrivateFieldGet28 = tools_classPrivateFieldGet(_keyboardManagerAC, this)) === null || _classPrivateFieldGet28 === void 0 || _classPrivateFieldGet28.abort();
  tools_classPrivateFieldSet(_keyboardManagerAC, this, null);
}
function _addCopyPasteListeners() {
  if (tools_classPrivateFieldGet(_copyPasteAC, this)) {
    return;
  }
  tools_classPrivateFieldSet(_copyPasteAC, this, new AbortController());
  var signal = this.combinedSignal(tools_classPrivateFieldGet(_copyPasteAC, this));
  document.addEventListener("copy", this.copy.bind(this), {
    signal: signal
  });
  document.addEventListener("cut", this.cut.bind(this), {
    signal: signal
  });
  document.addEventListener("paste", this.paste.bind(this), {
    signal: signal
  });
}
function _removeCopyPasteListeners() {
  var _classPrivateFieldGet29;
  (_classPrivateFieldGet29 = tools_classPrivateFieldGet(_copyPasteAC, this)) === null || _classPrivateFieldGet29 === void 0 || _classPrivateFieldGet29.abort();
  tools_classPrivateFieldSet(_copyPasteAC, this, null);
}
function _addDragAndDropListeners() {
  var signal = this._signal;
  document.addEventListener("dragover", this.dragOver.bind(this), {
    signal: signal
  });
  document.addEventListener("drop", this.drop.bind(this), {
    signal: signal
  });
}
function _dispatchUpdateStates(details) {
  var _this11 = this;
  var hasChanged = Object.entries(details).some(function (_ref13) {
    var _ref14 = tools_slicedToArray(_ref13, 2),
      key = _ref14[0],
      value = _ref14[1];
    return tools_classPrivateFieldGet(_previousStates, _this11)[key] !== value;
  });
  if (hasChanged) {
    this._eventBus.dispatch("annotationeditorstateschanged", {
      source: this,
      details: Object.assign(tools_classPrivateFieldGet(_previousStates, this), details)
    });
    if (tools_classPrivateFieldGet(_mode, this) === AnnotationEditorType.HIGHLIGHT && details.hasSelectedEditor === false) {
      tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateUI).call(this, [[AnnotationEditorParamsType.HIGHLIGHT_FREE, true]]);
    }
  }
}
function _dispatchUpdateUI(details) {
  this._eventBus.dispatch("annotationeditorparamschanged", {
    source: this,
    details: details
  });
}
function _enableAll() {
  return _enableAll2.apply(this, arguments);
}
function _enableAll2() {
  _enableAll2 = tools_asyncToGenerator(/*#__PURE__*/tools_regeneratorRuntime().mark(function _callee9() {
    var promises, _iterator46, _step46, layer, _iterator47, _step47, editor;
    return tools_regeneratorRuntime().wrap(function _callee9$(_context9) {
      while (1) switch (_context9.prev = _context9.next) {
        case 0:
          if (tools_classPrivateFieldGet(_isEnabled, this)) {
            _context9.next = 9;
            break;
          }
          tools_classPrivateFieldSet(_isEnabled, this, true);
          promises = [];
          _iterator46 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values());
          try {
            for (_iterator46.s(); !(_step46 = _iterator46.n()).done;) {
              layer = _step46.value;
              promises.push(layer.enable());
            }
          } catch (err) {
            _iterator46.e(err);
          } finally {
            _iterator46.f();
          }
          _context9.next = 7;
          return Promise.all(promises);
        case 7:
          _iterator47 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values());
          try {
            for (_iterator47.s(); !(_step47 = _iterator47.n()).done;) {
              editor = _step47.value;
              editor.enable();
            }
          } catch (err) {
            _iterator47.e(err);
          } finally {
            _iterator47.f();
          }
        case 9:
        case "end":
          return _context9.stop();
      }
    }, _callee9, this);
  }));
  return _enableAll2.apply(this, arguments);
}
function _disableAll() {
  this.unselectAll();
  if (tools_classPrivateFieldGet(_isEnabled, this)) {
    tools_classPrivateFieldSet(_isEnabled, this, false);
    var _iterator40 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allLayers, this).values()),
      _step40;
    try {
      for (_iterator40.s(); !(_step40 = _iterator40.n()).done;) {
        var layer = _step40.value;
        layer.disable();
      }
    } catch (err) {
      _iterator40.e(err);
    } finally {
      _iterator40.f();
    }
    var _iterator41 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values()),
      _step41;
    try {
      for (_iterator41.s(); !(_step41 = _iterator41.n()).done;) {
        var editor = _step41.value;
        editor.disable();
      }
    } catch (err) {
      _iterator41.e(err);
    } finally {
      _iterator41.f();
    }
  }
}
function _addEditorToLayer(editor) {
  var layer = tools_classPrivateFieldGet(_allLayers, this).get(editor.pageIndex);
  if (layer) {
    layer.addOrRebuild(editor);
  } else {
    this.addEditor(editor);
    this.addToAnnotationStorage(editor);
  }
}
function _get_lastSelectedEditor(_this2) {
  var ed = null;
  var _iterator42 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, _this2)),
    _step42;
  try {
    for (_iterator42.s(); !(_step42 = _iterator42.n()).done;) {
      ed = _step42.value;
    }
  } catch (err) {
    _iterator42.e(err);
  } finally {
    _iterator42.f();
  }
  return ed;
}
function _isEmpty() {
  if (tools_classPrivateFieldGet(_allEditors, this).size === 0) {
    return true;
  }
  if (tools_classPrivateFieldGet(_allEditors, this).size === 1) {
    var _iterator43 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_allEditors, this).values()),
      _step43;
    try {
      for (_iterator43.s(); !(_step43 = _iterator43.n()).done;) {
        var editor = _step43.value;
        return editor.isEmpty();
      }
    } catch (err) {
      _iterator43.e(err);
    } finally {
      _iterator43.f();
    }
  }
  return false;
}
function _selectEditors(editors) {
  var _iterator44 = tools_createForOfIteratorHelper(tools_classPrivateFieldGet(_selectedEditors, this)),
    _step44;
  try {
    for (_iterator44.s(); !(_step44 = _iterator44.n()).done;) {
      var editor = _step44.value;
      editor.unselect();
    }
  } catch (err) {
    _iterator44.e(err);
  } finally {
    _iterator44.f();
  }
  tools_classPrivateFieldGet(_selectedEditors, this).clear();
  var _iterator45 = tools_createForOfIteratorHelper(editors),
    _step45;
  try {
    for (_iterator45.s(); !(_step45 = _iterator45.n()).done;) {
      var _editor = _step45.value;
      if (_editor.isEmpty()) {
        continue;
      }
      tools_classPrivateFieldGet(_selectedEditors, this).add(_editor);
      _editor.select();
    }
  } catch (err) {
    _iterator45.e(err);
  } finally {
    _iterator45.f();
  }
  tools_assertClassBrand(_AnnotationEditorUIManager_brand, this, _dispatchUpdateStates).call(this, {
    hasSelectedEditor: this.hasSelection
  });
}
tools_defineProperty(AnnotationEditorUIManager, "TRANSLATE_SMALL", 1);
tools_defineProperty(AnnotationEditorUIManager, "TRANSLATE_BIG", 10);

;// ./src/display/editor/alt_text.js
function alt_text_typeof(o) { "@babel/helpers - typeof"; return alt_text_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, alt_text_typeof(o); }
function alt_text_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ alt_text_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == alt_text_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(alt_text_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function alt_text_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function alt_text_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { alt_text_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { alt_text_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }





























function alt_text_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function alt_text_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, alt_text_toPropertyKey(o.key), o); } }
function alt_text_createClass(e, r, t) { return r && alt_text_defineProperties(e.prototype, r), t && alt_text_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function alt_text_classPrivateMethodInitSpec(e, a) { alt_text_checkPrivateRedeclaration(e, a), a.add(e); }
function alt_text_defineProperty(e, r, t) { return (r = alt_text_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function alt_text_toPropertyKey(t) { var i = alt_text_toPrimitive(t, "string"); return "symbol" == alt_text_typeof(i) ? i : i + ""; }
function alt_text_toPrimitive(t, r) { if ("object" != alt_text_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != alt_text_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function alt_text_classPrivateFieldInitSpec(e, t, a) { alt_text_checkPrivateRedeclaration(e, t), t.set(e, a); }
function alt_text_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function alt_text_classPrivateGetter(s, r, a) { return a(alt_text_assertClassBrand(s, r)); }
function alt_text_classPrivateFieldGet(s, a) { return s.get(alt_text_assertClassBrand(s, a)); }
function alt_text_classPrivateFieldSet(s, a, r) { return s.set(alt_text_assertClassBrand(s, a), r), r; }
function alt_text_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }

var alt_text_altText = /*#__PURE__*/new WeakMap();
var _altTextDecorative = /*#__PURE__*/new WeakMap();
var _altTextButton = /*#__PURE__*/new WeakMap();
var _altTextButtonLabel = /*#__PURE__*/new WeakMap();
var _altTextTooltip = /*#__PURE__*/new WeakMap();
var _altTextTooltipTimeout = /*#__PURE__*/new WeakMap();
var _altTextWasFromKeyBoard = /*#__PURE__*/new WeakMap();
var _badge = /*#__PURE__*/new WeakMap();
var alt_text_editor = /*#__PURE__*/new WeakMap();
var _guessedText = /*#__PURE__*/new WeakMap();
var _textWithDisclaimer = /*#__PURE__*/new WeakMap();
var _useNewAltTextFlow = /*#__PURE__*/new WeakMap();
var _AltText_brand = /*#__PURE__*/new WeakSet();
var AltText = /*#__PURE__*/function () {
  function AltText(editor) {
    alt_text_classCallCheck(this, AltText);
    alt_text_classPrivateMethodInitSpec(this, _AltText_brand);
    alt_text_classPrivateFieldInitSpec(this, alt_text_altText, null);
    alt_text_classPrivateFieldInitSpec(this, _altTextDecorative, false);
    alt_text_classPrivateFieldInitSpec(this, _altTextButton, null);
    alt_text_classPrivateFieldInitSpec(this, _altTextButtonLabel, null);
    alt_text_classPrivateFieldInitSpec(this, _altTextTooltip, null);
    alt_text_classPrivateFieldInitSpec(this, _altTextTooltipTimeout, null);
    alt_text_classPrivateFieldInitSpec(this, _altTextWasFromKeyBoard, false);
    alt_text_classPrivateFieldInitSpec(this, _badge, null);
    alt_text_classPrivateFieldInitSpec(this, alt_text_editor, null);
    alt_text_classPrivateFieldInitSpec(this, _guessedText, null);
    alt_text_classPrivateFieldInitSpec(this, _textWithDisclaimer, null);
    alt_text_classPrivateFieldInitSpec(this, _useNewAltTextFlow, false);
    alt_text_classPrivateFieldSet(alt_text_editor, this, editor);
    alt_text_classPrivateFieldSet(_useNewAltTextFlow, this, editor._uiManager.useNewAltTextFlow);
    _l10nNewButton._ || (_l10nNewButton._ = Object.freeze({
      added: "pdfjs-editor-new-alt-text-added-button",
      "added-label": "pdfjs-editor-new-alt-text-added-button-label",
      missing: "pdfjs-editor-new-alt-text-missing-button",
      "missing-label": "pdfjs-editor-new-alt-text-missing-button-label",
      review: "pdfjs-editor-new-alt-text-to-review-button",
      "review-label": "pdfjs-editor-new-alt-text-to-review-button-label"
    }));
  }
  return alt_text_createClass(AltText, [{
    key: "render",
    value: function () {
      var _render = alt_text_asyncToGenerator(/*#__PURE__*/alt_text_regeneratorRuntime().mark(function _callee() {
        var _this2 = this;
        var altText, label, signal, onClick;
        return alt_text_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              altText = alt_text_classPrivateFieldSet(_altTextButton, this, document.createElement("button"));
              altText.className = "altText";
              altText.tabIndex = "0";
              label = alt_text_classPrivateFieldSet(_altTextButtonLabel, this, document.createElement("span"));
              altText.append(label);
              if (alt_text_classPrivateFieldGet(_useNewAltTextFlow, this)) {
                altText.classList.add("new");
                altText.setAttribute("data-l10n-id", _l10nNewButton._.missing);
                label.setAttribute("data-l10n-id", _l10nNewButton._["missing-label"]);
              } else {
                altText.setAttribute("data-l10n-id", "pdfjs-editor-alt-text-button");
                label.setAttribute("data-l10n-id", "pdfjs-editor-alt-text-button-label");
              }
              signal = alt_text_classPrivateFieldGet(alt_text_editor, this)._uiManager._signal;
              altText.addEventListener("contextmenu", noContextMenu, {
                signal: signal
              });
              altText.addEventListener("pointerdown", function (event) {
                return event.stopPropagation();
              }, {
                signal: signal
              });
              onClick = function onClick(event) {
                event.preventDefault();
                alt_text_classPrivateFieldGet(alt_text_editor, _this2)._uiManager.editAltText(alt_text_classPrivateFieldGet(alt_text_editor, _this2));
                if (alt_text_classPrivateFieldGet(_useNewAltTextFlow, _this2)) {
                  alt_text_classPrivateFieldGet(alt_text_editor, _this2)._reportTelemetry({
                    action: "pdfjs.image.alt_text.image_status_label_clicked",
                    data: {
                      label: alt_text_classPrivateGetter(_AltText_brand, _this2, _get_label)
                    }
                  });
                }
              };
              altText.addEventListener("click", onClick, {
                capture: true,
                signal: signal
              });
              altText.addEventListener("keydown", function (event) {
                if (event.target === altText && event.key === "Enter") {
                  alt_text_classPrivateFieldSet(_altTextWasFromKeyBoard, _this2, true);
                  onClick(event);
                }
              }, {
                signal: signal
              });
              _context.next = 14;
              return alt_text_assertClassBrand(_AltText_brand, this, _setState).call(this);
            case 14:
              return _context.abrupt("return", altText);
            case 15:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function render() {
        return _render.apply(this, arguments);
      }
      return render;
    }()
  }, {
    key: "finish",
    value: function finish() {
      if (!alt_text_classPrivateFieldGet(_altTextButton, this)) {
        return;
      }
      alt_text_classPrivateFieldGet(_altTextButton, this).focus({
        focusVisible: alt_text_classPrivateFieldGet(_altTextWasFromKeyBoard, this)
      });
      alt_text_classPrivateFieldSet(_altTextWasFromKeyBoard, this, false);
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      if (alt_text_classPrivateFieldGet(_useNewAltTextFlow, this)) {
        return alt_text_classPrivateFieldGet(alt_text_altText, this) === null;
      }
      return !alt_text_classPrivateFieldGet(alt_text_altText, this) && !alt_text_classPrivateFieldGet(_altTextDecorative, this);
    }
  }, {
    key: "hasData",
    value: function hasData() {
      if (alt_text_classPrivateFieldGet(_useNewAltTextFlow, this)) {
        return alt_text_classPrivateFieldGet(alt_text_altText, this) !== null || !!alt_text_classPrivateFieldGet(_guessedText, this);
      }
      return this.isEmpty();
    }
  }, {
    key: "guessedText",
    get: function get() {
      return alt_text_classPrivateFieldGet(_guessedText, this);
    }
  }, {
    key: "setGuessedText",
    value: function () {
      var _setGuessedText = alt_text_asyncToGenerator(/*#__PURE__*/alt_text_regeneratorRuntime().mark(function _callee2(guessedText) {
        return alt_text_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!(alt_text_classPrivateFieldGet(alt_text_altText, this) !== null)) {
                _context2.next = 2;
                break;
              }
              return _context2.abrupt("return");
            case 2:
              alt_text_classPrivateFieldSet(_guessedText, this, guessedText);
              _context2.t0 = alt_text_classPrivateFieldSet;
              _context2.t1 = _textWithDisclaimer;
              _context2.t2 = this;
              _context2.next = 8;
              return AltText._l10n.get("pdfjs-editor-new-alt-text-generated-alt-text-with-disclaimer", {
                generatedAltText: guessedText
              });
            case 8:
              _context2.t3 = _context2.sent;
              (0, _context2.t0)(_context2.t1, _context2.t2, _context2.t3);
              alt_text_assertClassBrand(_AltText_brand, this, _setState).call(this);
            case 11:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function setGuessedText(_x) {
        return _setGuessedText.apply(this, arguments);
      }
      return setGuessedText;
    }()
  }, {
    key: "toggleAltTextBadge",
    value: function toggleAltTextBadge() {
      var visibility = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!alt_text_classPrivateFieldGet(_useNewAltTextFlow, this) || alt_text_classPrivateFieldGet(alt_text_altText, this)) {
        var _classPrivateFieldGet2;
        (_classPrivateFieldGet2 = alt_text_classPrivateFieldGet(_badge, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.remove();
        alt_text_classPrivateFieldSet(_badge, this, null);
        return;
      }
      if (!alt_text_classPrivateFieldGet(_badge, this)) {
        var badge = alt_text_classPrivateFieldSet(_badge, this, document.createElement("div"));
        badge.className = "noAltTextBadge";
        alt_text_classPrivateFieldGet(alt_text_editor, this).div.append(badge);
      }
      alt_text_classPrivateFieldGet(_badge, this).classList.toggle("hidden", !visibility);
    }
  }, {
    key: "serialize",
    value: function serialize(isForCopying) {
      var altText = alt_text_classPrivateFieldGet(alt_text_altText, this);
      if (!isForCopying && alt_text_classPrivateFieldGet(_guessedText, this) === altText) {
        altText = alt_text_classPrivateFieldGet(_textWithDisclaimer, this);
      }
      return {
        altText: altText,
        decorative: alt_text_classPrivateFieldGet(_altTextDecorative, this),
        guessedText: alt_text_classPrivateFieldGet(_guessedText, this),
        textWithDisclaimer: alt_text_classPrivateFieldGet(_textWithDisclaimer, this)
      };
    }
  }, {
    key: "data",
    get: function get() {
      return {
        altText: alt_text_classPrivateFieldGet(alt_text_altText, this),
        decorative: alt_text_classPrivateFieldGet(_altTextDecorative, this)
      };
    },
    set: function set(_ref) {
      var altText = _ref.altText,
        decorative = _ref.decorative,
        guessedText = _ref.guessedText,
        textWithDisclaimer = _ref.textWithDisclaimer,
        _ref$cancel = _ref.cancel,
        cancel = _ref$cancel === void 0 ? false : _ref$cancel;
      if (guessedText) {
        alt_text_classPrivateFieldSet(_guessedText, this, guessedText);
        alt_text_classPrivateFieldSet(_textWithDisclaimer, this, textWithDisclaimer);
      }
      if (alt_text_classPrivateFieldGet(alt_text_altText, this) === altText && alt_text_classPrivateFieldGet(_altTextDecorative, this) === decorative) {
        return;
      }
      if (!cancel) {
        alt_text_classPrivateFieldSet(alt_text_altText, this, altText);
        alt_text_classPrivateFieldSet(_altTextDecorative, this, decorative);
      }
      alt_text_assertClassBrand(_AltText_brand, this, _setState).call(this);
    }
  }, {
    key: "toggle",
    value: function toggle() {
      var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!alt_text_classPrivateFieldGet(_altTextButton, this)) {
        return;
      }
      if (!enabled && alt_text_classPrivateFieldGet(_altTextTooltipTimeout, this)) {
        clearTimeout(alt_text_classPrivateFieldGet(_altTextTooltipTimeout, this));
        alt_text_classPrivateFieldSet(_altTextTooltipTimeout, this, null);
      }
      alt_text_classPrivateFieldGet(_altTextButton, this).disabled = !enabled;
    }
  }, {
    key: "shown",
    value: function shown() {
      alt_text_classPrivateFieldGet(alt_text_editor, this)._reportTelemetry({
        action: "pdfjs.image.alt_text.image_status_label_displayed",
        data: {
          label: alt_text_classPrivateGetter(_AltText_brand, this, _get_label)
        }
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet3, _classPrivateFieldGet4;
      (_classPrivateFieldGet3 = alt_text_classPrivateFieldGet(_altTextButton, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.remove();
      alt_text_classPrivateFieldSet(_altTextButton, this, null);
      alt_text_classPrivateFieldSet(_altTextButtonLabel, this, null);
      alt_text_classPrivateFieldSet(_altTextTooltip, this, null);
      (_classPrivateFieldGet4 = alt_text_classPrivateFieldGet(_badge, this)) === null || _classPrivateFieldGet4 === void 0 || _classPrivateFieldGet4.remove();
      alt_text_classPrivateFieldSet(_badge, this, null);
    }
  }], [{
    key: "initialize",
    value: function initialize(l10n) {
      var _AltText$_l10n;
      (_AltText$_l10n = AltText._l10n) !== null && _AltText$_l10n !== void 0 ? _AltText$_l10n : AltText._l10n = l10n;
    }
  }]);
}();
function _get_label(_this) {
  return alt_text_classPrivateFieldGet(alt_text_altText, _this) && "added" || alt_text_classPrivateFieldGet(alt_text_altText, _this) === null && _this.guessedText && "review" || "missing";
}
function _setState() {
  return _setState2.apply(this, arguments);
}
function _setState2() {
  _setState2 = alt_text_asyncToGenerator(/*#__PURE__*/alt_text_regeneratorRuntime().mark(function _callee3() {
    var _this3 = this;
    var button, _classPrivateFieldGet5, _classPrivateFieldGet6, _classPrivateFieldGet7, tooltip, DELAY_TO_SHOW_TOOLTIP, signal, element;
    return alt_text_regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          button = alt_text_classPrivateFieldGet(_altTextButton, this);
          if (button) {
            _context3.next = 3;
            break;
          }
          return _context3.abrupt("return");
        case 3:
          if (!alt_text_classPrivateFieldGet(_useNewAltTextFlow, this)) {
            _context3.next = 12;
            break;
          }
          button.classList.toggle("done", !!alt_text_classPrivateFieldGet(alt_text_altText, this));
          button.setAttribute("data-l10n-id", _l10nNewButton._[alt_text_classPrivateGetter(_AltText_brand, this, _get_label)]);
          (_classPrivateFieldGet5 = alt_text_classPrivateFieldGet(_altTextButtonLabel, this)) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.setAttribute("data-l10n-id", _l10nNewButton._["".concat(alt_text_classPrivateGetter(_AltText_brand, this, _get_label), "-label")]);
          if (alt_text_classPrivateFieldGet(alt_text_altText, this)) {
            _context3.next = 10;
            break;
          }
          (_classPrivateFieldGet6 = alt_text_classPrivateFieldGet(_altTextTooltip, this)) === null || _classPrivateFieldGet6 === void 0 || _classPrivateFieldGet6.remove();
          return _context3.abrupt("return");
        case 10:
          _context3.next = 18;
          break;
        case 12:
          if (!(!alt_text_classPrivateFieldGet(alt_text_altText, this) && !alt_text_classPrivateFieldGet(_altTextDecorative, this))) {
            _context3.next = 16;
            break;
          }
          button.classList.remove("done");
          (_classPrivateFieldGet7 = alt_text_classPrivateFieldGet(_altTextTooltip, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.remove();
          return _context3.abrupt("return");
        case 16:
          button.classList.add("done");
          button.setAttribute("data-l10n-id", "pdfjs-editor-alt-text-edit-button");
        case 18:
          tooltip = alt_text_classPrivateFieldGet(_altTextTooltip, this);
          if (!tooltip) {
            alt_text_classPrivateFieldSet(_altTextTooltip, this, tooltip = document.createElement("span"));
            tooltip.className = "tooltip";
            tooltip.setAttribute("role", "tooltip");
            tooltip.id = "alt-text-tooltip-".concat(alt_text_classPrivateFieldGet(alt_text_editor, this).id);
            DELAY_TO_SHOW_TOOLTIP = 100;
            signal = alt_text_classPrivateFieldGet(alt_text_editor, this)._uiManager._signal;
            signal.addEventListener("abort", function () {
              clearTimeout(alt_text_classPrivateFieldGet(_altTextTooltipTimeout, _this3));
              alt_text_classPrivateFieldSet(_altTextTooltipTimeout, _this3, null);
            }, {
              once: true
            });
            button.addEventListener("mouseenter", function () {
              alt_text_classPrivateFieldSet(_altTextTooltipTimeout, _this3, setTimeout(function () {
                alt_text_classPrivateFieldSet(_altTextTooltipTimeout, _this3, null);
                alt_text_classPrivateFieldGet(_altTextTooltip, _this3).classList.add("show");
                alt_text_classPrivateFieldGet(alt_text_editor, _this3)._reportTelemetry({
                  action: "alt_text_tooltip"
                });
              }, DELAY_TO_SHOW_TOOLTIP));
            }, {
              signal: signal
            });
            button.addEventListener("mouseleave", function () {
              var _classPrivateFieldGet8;
              if (alt_text_classPrivateFieldGet(_altTextTooltipTimeout, _this3)) {
                clearTimeout(alt_text_classPrivateFieldGet(_altTextTooltipTimeout, _this3));
                alt_text_classPrivateFieldSet(_altTextTooltipTimeout, _this3, null);
              }
              (_classPrivateFieldGet8 = alt_text_classPrivateFieldGet(_altTextTooltip, _this3)) === null || _classPrivateFieldGet8 === void 0 || _classPrivateFieldGet8.classList.remove("show");
            }, {
              signal: signal
            });
          }
          if (alt_text_classPrivateFieldGet(_altTextDecorative, this)) {
            tooltip.setAttribute("data-l10n-id", "pdfjs-editor-alt-text-decorative-tooltip");
          } else {
            tooltip.removeAttribute("data-l10n-id");
            tooltip.textContent = alt_text_classPrivateFieldGet(alt_text_altText, this);
          }
          if (!tooltip.parentNode) {
            button.append(tooltip);
          }
          element = alt_text_classPrivateFieldGet(alt_text_editor, this).getImageForAltText();
          element === null || element === void 0 || element.setAttribute("aria-describedby", tooltip.id);
        case 24:
        case "end":
          return _context3.stop();
      }
    }, _callee3, this);
  }));
  return _setState2.apply(this, arguments);
}
var _l10nNewButton = {
  _: null
};
alt_text_defineProperty(AltText, "_l10n", null);

;// ./src/display/touch_manager.js












function touch_manager_typeof(o) { "@babel/helpers - typeof"; return touch_manager_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, touch_manager_typeof(o); }
var _TouchManager;
function touch_manager_slicedToArray(r, e) { return touch_manager_arrayWithHoles(r) || touch_manager_iterableToArrayLimit(r, e) || touch_manager_unsupportedIterableToArray(r, e) || touch_manager_nonIterableRest(); }
function touch_manager_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function touch_manager_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return touch_manager_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? touch_manager_arrayLikeToArray(r, a) : void 0; } }
function touch_manager_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function touch_manager_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function touch_manager_arrayWithHoles(r) { if (Array.isArray(r)) return r; }









function touch_manager_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function touch_manager_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, touch_manager_toPropertyKey(o.key), o); } }
function touch_manager_createClass(e, r, t) { return r && touch_manager_defineProperties(e.prototype, r), t && touch_manager_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function touch_manager_toPropertyKey(t) { var i = touch_manager_toPrimitive(t, "string"); return "symbol" == touch_manager_typeof(i) ? i : i + ""; }
function touch_manager_toPrimitive(t, r) { if ("object" != touch_manager_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != touch_manager_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function touch_manager_classPrivateMethodInitSpec(e, a) { touch_manager_checkPrivateRedeclaration(e, a), a.add(e); }
function touch_manager_classPrivateFieldInitSpec(e, t, a) { touch_manager_checkPrivateRedeclaration(e, t), t.set(e, a); }
function touch_manager_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function touch_manager_classPrivateFieldGet(s, a) { return s.get(touch_manager_assertClassBrand(s, a)); }
function touch_manager_classPrivateFieldSet(s, a, r) { return s.set(touch_manager_assertClassBrand(s, a), r), r; }
function touch_manager_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var touch_manager_container = /*#__PURE__*/new WeakMap();
var _isPinching = /*#__PURE__*/new WeakMap();
var _isPinchingStopped = /*#__PURE__*/new WeakMap();
var _isPinchingDisabled = /*#__PURE__*/new WeakMap();
var _onPinchStart = /*#__PURE__*/new WeakMap();
var _onPinching = /*#__PURE__*/new WeakMap();
var _onPinchEnd = /*#__PURE__*/new WeakMap();
var _signal = /*#__PURE__*/new WeakMap();
var _touchInfo = /*#__PURE__*/new WeakMap();
var _touchManagerAC = /*#__PURE__*/new WeakMap();
var _touchMoveAC = /*#__PURE__*/new WeakMap();
var _TouchManager_brand = /*#__PURE__*/new WeakSet();
var TouchManager = /*#__PURE__*/function () {
  function TouchManager(_ref) {
    var _container2 = _ref.container,
      _ref$isPinchingDisabl = _ref.isPinchingDisabled,
      isPinchingDisabled = _ref$isPinchingDisabl === void 0 ? null : _ref$isPinchingDisabl,
      _ref$isPinchingStoppe = _ref.isPinchingStopped,
      isPinchingStopped = _ref$isPinchingStoppe === void 0 ? null : _ref$isPinchingStoppe,
      _ref$onPinchStart = _ref.onPinchStart,
      onPinchStart = _ref$onPinchStart === void 0 ? null : _ref$onPinchStart,
      _ref$onPinching = _ref.onPinching,
      onPinching = _ref$onPinching === void 0 ? null : _ref$onPinching,
      _ref$onPinchEnd = _ref.onPinchEnd,
      onPinchEnd = _ref$onPinchEnd === void 0 ? null : _ref$onPinchEnd,
      _signal2 = _ref.signal;
    touch_manager_classCallCheck(this, TouchManager);
    touch_manager_classPrivateMethodInitSpec(this, _TouchManager_brand);
    touch_manager_classPrivateFieldInitSpec(this, touch_manager_container, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _isPinching, false);
    touch_manager_classPrivateFieldInitSpec(this, _isPinchingStopped, null);
    touch_manager_classPrivateFieldInitSpec(this, _isPinchingDisabled, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _onPinchStart, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _onPinching, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _onPinchEnd, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _signal, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _touchInfo, null);
    touch_manager_classPrivateFieldInitSpec(this, _touchManagerAC, void 0);
    touch_manager_classPrivateFieldInitSpec(this, _touchMoveAC, null);
    touch_manager_classPrivateFieldSet(touch_manager_container, this, _container2);
    touch_manager_classPrivateFieldSet(_isPinchingStopped, this, isPinchingStopped);
    touch_manager_classPrivateFieldSet(_isPinchingDisabled, this, isPinchingDisabled);
    touch_manager_classPrivateFieldSet(_onPinchStart, this, onPinchStart);
    touch_manager_classPrivateFieldSet(_onPinching, this, onPinching);
    touch_manager_classPrivateFieldSet(_onPinchEnd, this, onPinchEnd);
    touch_manager_classPrivateFieldSet(_touchManagerAC, this, new AbortController());
    touch_manager_classPrivateFieldSet(_signal, this, AbortSignal.any([_signal2, touch_manager_classPrivateFieldGet(_touchManagerAC, this).signal]));
    _container2.addEventListener("touchstart", touch_manager_assertClassBrand(_TouchManager_brand, this, _onTouchStart).bind(this), {
      passive: false,
      signal: touch_manager_classPrivateFieldGet(_signal, this)
    });
  }
  return touch_manager_createClass(TouchManager, [{
    key: "MIN_TOUCH_DISTANCE_TO_PINCH",
    get: function get() {
      return shadow(this, "MIN_TOUCH_DISTANCE_TO_PINCH", 35 / (window.devicePixelRatio || 1));
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet2;
      (_classPrivateFieldGet2 = touch_manager_classPrivateFieldGet(_touchManagerAC, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.abort();
      touch_manager_classPrivateFieldSet(_touchManagerAC, this, null);
    }
  }]);
}();
_TouchManager = TouchManager;
function _onTouchStart(evt) {
  var _classPrivateFieldGet3, _classPrivateFieldGet5;
  if ((_classPrivateFieldGet3 = touch_manager_classPrivateFieldGet(_isPinchingDisabled, this)) !== null && _classPrivateFieldGet3 !== void 0 && _classPrivateFieldGet3.call(this) || evt.touches.length < 2) {
    return;
  }
  if (!touch_manager_classPrivateFieldGet(_touchMoveAC, this)) {
    var _classPrivateFieldGet4;
    touch_manager_classPrivateFieldSet(_touchMoveAC, this, new AbortController());
    var signal = AbortSignal.any([touch_manager_classPrivateFieldGet(_signal, this), touch_manager_classPrivateFieldGet(_touchMoveAC, this).signal]);
    var container = touch_manager_classPrivateFieldGet(touch_manager_container, this);
    var opt = {
      signal: signal,
      passive: false
    };
    container.addEventListener("touchmove", touch_manager_assertClassBrand(_TouchManager_brand, this, _onTouchMove).bind(this), opt);
    container.addEventListener("touchend", touch_manager_assertClassBrand(_TouchManager_brand, this, _onTouchEnd).bind(this), opt);
    container.addEventListener("touchcancel", touch_manager_assertClassBrand(_TouchManager_brand, this, _onTouchEnd).bind(this), opt);
    (_classPrivateFieldGet4 = touch_manager_classPrivateFieldGet(_onPinchStart, this)) === null || _classPrivateFieldGet4 === void 0 || _classPrivateFieldGet4.call(this);
  }
  stopEvent(evt);
  if (evt.touches.length !== 2 || (_classPrivateFieldGet5 = touch_manager_classPrivateFieldGet(_isPinchingStopped, this)) !== null && _classPrivateFieldGet5 !== void 0 && _classPrivateFieldGet5.call(this)) {
    touch_manager_classPrivateFieldSet(_touchInfo, this, null);
    return;
  }
  var _evt$touches = touch_manager_slicedToArray(evt.touches, 2),
    touch0 = _evt$touches[0],
    touch1 = _evt$touches[1];
  if (touch0.identifier > touch1.identifier) {
    var _ref2 = [touch1, touch0];
    touch0 = _ref2[0];
    touch1 = _ref2[1];
  }
  touch_manager_classPrivateFieldSet(_touchInfo, this, {
    touch0X: touch0.screenX,
    touch0Y: touch0.screenY,
    touch1X: touch1.screenX,
    touch1Y: touch1.screenY
  });
}
function _onTouchMove(evt) {
  var _classPrivateFieldGet6;
  if (!touch_manager_classPrivateFieldGet(_touchInfo, this) || evt.touches.length !== 2) {
    return;
  }
  var _evt$touches2 = touch_manager_slicedToArray(evt.touches, 2),
    touch0 = _evt$touches2[0],
    touch1 = _evt$touches2[1];
  if (touch0.identifier > touch1.identifier) {
    var _ref3 = [touch1, touch0];
    touch0 = _ref3[0];
    touch1 = _ref3[1];
  }
  var _touch = touch0,
    screen0X = _touch.screenX,
    screen0Y = _touch.screenY;
  var _touch2 = touch1,
    screen1X = _touch2.screenX,
    screen1Y = _touch2.screenY;
  var touchInfo = touch_manager_classPrivateFieldGet(_touchInfo, this);
  var pTouch0X = touchInfo.touch0X,
    pTouch0Y = touchInfo.touch0Y,
    pTouch1X = touchInfo.touch1X,
    pTouch1Y = touchInfo.touch1Y;
  var prevGapX = pTouch1X - pTouch0X;
  var prevGapY = pTouch1Y - pTouch0Y;
  var currGapX = screen1X - screen0X;
  var currGapY = screen1Y - screen0Y;
  var distance = Math.hypot(currGapX, currGapY) || 1;
  var pDistance = Math.hypot(prevGapX, prevGapY) || 1;
  if (!touch_manager_classPrivateFieldGet(_isPinching, this) && Math.abs(pDistance - distance) <= _TouchManager.MIN_TOUCH_DISTANCE_TO_PINCH) {
    return;
  }
  touchInfo.touch0X = screen0X;
  touchInfo.touch0Y = screen0Y;
  touchInfo.touch1X = screen1X;
  touchInfo.touch1Y = screen1Y;
  evt.preventDefault();
  if (!touch_manager_classPrivateFieldGet(_isPinching, this)) {
    touch_manager_classPrivateFieldSet(_isPinching, this, true);
    return;
  }
  var origin = [(screen0X + screen1X) / 2, (screen0Y + screen1Y) / 2];
  (_classPrivateFieldGet6 = touch_manager_classPrivateFieldGet(_onPinching, this)) === null || _classPrivateFieldGet6 === void 0 || _classPrivateFieldGet6.call(this, origin, pDistance, distance);
}
function _onTouchEnd(evt) {
  var _classPrivateFieldGet7;
  touch_manager_classPrivateFieldGet(_touchMoveAC, this).abort();
  touch_manager_classPrivateFieldSet(_touchMoveAC, this, null);
  (_classPrivateFieldGet7 = touch_manager_classPrivateFieldGet(_onPinchEnd, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.call(this);
  if (!touch_manager_classPrivateFieldGet(_touchInfo, this)) {
    return;
  }
  evt.preventDefault();
  touch_manager_classPrivateFieldSet(_touchInfo, this, null);
  touch_manager_classPrivateFieldSet(_isPinching, this, false);
}

;// ./src/display/editor/editor.js






















function editor_typeof(o) { "@babel/helpers - typeof"; return editor_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, editor_typeof(o); }
var _AnnotationEditor;
function editor_toConsumableArray(r) { return editor_arrayWithoutHoles(r) || editor_iterableToArray(r) || editor_unsupportedIterableToArray(r) || editor_nonIterableSpread(); }
function editor_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function editor_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function editor_arrayWithoutHoles(r) { if (Array.isArray(r)) return editor_arrayLikeToArray(r); }
function editor_callSuper(t, o, e) { return o = editor_getPrototypeOf(o), editor_possibleConstructorReturn(t, editor_isNativeReflectConstruct() ? Reflect.construct(o, e || [], editor_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function editor_possibleConstructorReturn(t, e) { if (e && ("object" == editor_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return editor_assertThisInitialized(t); }
function editor_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function editor_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (editor_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function editor_getPrototypeOf(t) { return editor_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, editor_getPrototypeOf(t); }
function editor_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && editor_setPrototypeOf(t, e); }
function editor_setPrototypeOf(t, e) { return editor_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, editor_setPrototypeOf(t, e); }
function editor_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = editor_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function editor_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ editor_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == editor_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(editor_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function editor_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function editor_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { editor_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { editor_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }

















function editor_slicedToArray(r, e) { return editor_arrayWithHoles(r) || editor_iterableToArrayLimit(r, e) || editor_unsupportedIterableToArray(r, e) || editor_nonIterableRest(); }
function editor_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function editor_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return editor_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? editor_arrayLikeToArray(r, a) : void 0; } }
function editor_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function editor_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function editor_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function editor_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function editor_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, editor_toPropertyKey(o.key), o); } }
function editor_createClass(e, r, t) { return r && editor_defineProperties(e.prototype, r), t && editor_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function editor_classPrivateMethodInitSpec(e, a) { editor_checkPrivateRedeclaration(e, a), a.add(e); }
function editor_defineProperty(e, r, t) { return (r = editor_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function editor_toPropertyKey(t) { var i = editor_toPrimitive(t, "string"); return "symbol" == editor_typeof(i) ? i : i + ""; }
function editor_toPrimitive(t, r) { if ("object" != editor_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != editor_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function editor_classPrivateFieldInitSpec(e, t, a) { editor_checkPrivateRedeclaration(e, t), t.set(e, a); }
function editor_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function editor_classPrivateFieldSet(s, a, r) { return s.set(editor_assertClassBrand(s, a), r), r; }
function editor_classPrivateFieldGet(s, a) { return s.get(editor_assertClassBrand(s, a)); }
function editor_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }






var _accessibilityData = /*#__PURE__*/new WeakMap();
var _allResizerDivs = /*#__PURE__*/new WeakMap();
var editor_altText = /*#__PURE__*/new WeakMap();
var _disabled = /*#__PURE__*/new WeakMap();
var _dragPointerId = /*#__PURE__*/new WeakMap();
var _dragPointerType = /*#__PURE__*/new WeakMap();
var _keepAspectRatio = /*#__PURE__*/new WeakMap();
var _resizersDiv = /*#__PURE__*/new WeakMap();
var _lastPointerCoords = /*#__PURE__*/new WeakMap();
var _savedDimensions = /*#__PURE__*/new WeakMap();
var _focusAC = /*#__PURE__*/new WeakMap();
var _focusedResizerName = /*#__PURE__*/new WeakMap();
var _hasBeenClicked = /*#__PURE__*/new WeakMap();
var _initialRect = /*#__PURE__*/new WeakMap();
var _isEditing = /*#__PURE__*/new WeakMap();
var _isInEditMode = /*#__PURE__*/new WeakMap();
var _isResizerEnabledForKeyboard = /*#__PURE__*/new WeakMap();
var _moveInDOMTimeout = /*#__PURE__*/new WeakMap();
var _prevDragX = /*#__PURE__*/new WeakMap();
var _prevDragY = /*#__PURE__*/new WeakMap();
var _telemetryTimeouts = /*#__PURE__*/new WeakMap();
var _touchManager = /*#__PURE__*/new WeakMap();
var _isDraggable = /*#__PURE__*/new WeakMap();
var _zIndex = /*#__PURE__*/new WeakMap();
var _AnnotationEditor_brand = /*#__PURE__*/new WeakSet();
var AnnotationEditor = /*#__PURE__*/function () {
  function AnnotationEditor(parameters) {
    editor_classCallCheck(this, AnnotationEditor);
    editor_classPrivateMethodInitSpec(this, _AnnotationEditor_brand);
    editor_classPrivateFieldInitSpec(this, _accessibilityData, null);
    editor_classPrivateFieldInitSpec(this, _allResizerDivs, null);
    editor_classPrivateFieldInitSpec(this, editor_altText, null);
    editor_classPrivateFieldInitSpec(this, _disabled, false);
    editor_classPrivateFieldInitSpec(this, _dragPointerId, null);
    editor_classPrivateFieldInitSpec(this, _dragPointerType, "");
    editor_classPrivateFieldInitSpec(this, _keepAspectRatio, false);
    editor_classPrivateFieldInitSpec(this, _resizersDiv, null);
    editor_classPrivateFieldInitSpec(this, _lastPointerCoords, null);
    editor_classPrivateFieldInitSpec(this, _savedDimensions, null);
    editor_classPrivateFieldInitSpec(this, _focusAC, null);
    editor_classPrivateFieldInitSpec(this, _focusedResizerName, "");
    editor_classPrivateFieldInitSpec(this, _hasBeenClicked, false);
    editor_classPrivateFieldInitSpec(this, _initialRect, null);
    editor_classPrivateFieldInitSpec(this, _isEditing, false);
    editor_classPrivateFieldInitSpec(this, _isInEditMode, false);
    editor_classPrivateFieldInitSpec(this, _isResizerEnabledForKeyboard, false);
    editor_classPrivateFieldInitSpec(this, _moveInDOMTimeout, null);
    editor_classPrivateFieldInitSpec(this, _prevDragX, 0);
    editor_classPrivateFieldInitSpec(this, _prevDragY, 0);
    editor_classPrivateFieldInitSpec(this, _telemetryTimeouts, null);
    editor_classPrivateFieldInitSpec(this, _touchManager, null);
    editor_defineProperty(this, "_editToolbar", null);
    editor_defineProperty(this, "_initialOptions", Object.create(null));
    editor_defineProperty(this, "_initialData", null);
    editor_defineProperty(this, "_isVisible", true);
    editor_defineProperty(this, "_uiManager", null);
    editor_defineProperty(this, "_focusEventsAllowed", true);
    editor_classPrivateFieldInitSpec(this, _isDraggable, false);
    editor_classPrivateFieldInitSpec(this, _zIndex, AnnotationEditor._zIndex++);
    this.parent = parameters.parent;
    this.id = parameters.id;
    this.width = this.height = null;
    this.pageIndex = parameters.parent.pageIndex;
    this.name = parameters.name;
    this.div = null;
    this._uiManager = parameters.uiManager;
    this.annotationElementId = null;
    this._willKeepAspectRatio = false;
    this._initialOptions.isCentered = parameters.isCentered;
    this._structTreeParentId = null;
    var _this$parent$viewport = this.parent.viewport,
      _rotation = _this$parent$viewport.rotation,
      _this$parent$viewport2 = _this$parent$viewport.rawDims,
      _pageWidth = _this$parent$viewport2.pageWidth,
      _pageHeight = _this$parent$viewport2.pageHeight,
      pageX = _this$parent$viewport2.pageX,
      pageY = _this$parent$viewport2.pageY;
    this.rotation = _rotation;
    this.pageRotation = (360 + _rotation - this._uiManager.viewParameters.rotation) % 360;
    this.pageDimensions = [_pageWidth, _pageHeight];
    this.pageTranslation = [pageX, pageY];
    var _this$parentDimension = editor_slicedToArray(this.parentDimensions, 2),
      _width = _this$parentDimension[0],
      _height = _this$parentDimension[1];
    this.x = parameters.x / _width;
    this.y = parameters.y / _height;
    this.isAttachedToDOM = false;
    this.deleted = false;
  }
  return editor_createClass(AnnotationEditor, [{
    key: "editorType",
    get: function get() {
      return Object.getPrototypeOf(this).constructor._type;
    }
  }, {
    key: "propertiesToUpdate",
    get: function get() {
      return [];
    }
  }, {
    key: "_isDraggable",
    get: function get() {
      return editor_classPrivateFieldGet(_isDraggable, this);
    },
    set: function set(value) {
      var _this$div;
      editor_classPrivateFieldSet(_isDraggable, this, value);
      (_this$div = this.div) === null || _this$div === void 0 || _this$div.classList.toggle("draggable", value);
    }
  }, {
    key: "isEnterHandled",
    get: function get() {
      return true;
    }
  }, {
    key: "center",
    value: function center() {
      var _this$pageDimensions = editor_slicedToArray(this.pageDimensions, 2),
        pageWidth = _this$pageDimensions[0],
        pageHeight = _this$pageDimensions[1];
      switch (this.parentRotation) {
        case 90:
          this.x -= this.height * pageHeight / (pageWidth * 2);
          this.y += this.width * pageWidth / (pageHeight * 2);
          break;
        case 180:
          this.x += this.width / 2;
          this.y += this.height / 2;
          break;
        case 270:
          this.x += this.height * pageHeight / (pageWidth * 2);
          this.y -= this.width * pageWidth / (pageHeight * 2);
          break;
        default:
          this.x -= this.width / 2;
          this.y -= this.height / 2;
          break;
      }
      this.fixAndSetPosition();
    }
  }, {
    key: "addCommands",
    value: function addCommands(params) {
      this._uiManager.addCommands(params);
    }
  }, {
    key: "currentLayer",
    get: function get() {
      return this._uiManager.currentLayer;
    }
  }, {
    key: "setInBackground",
    value: function setInBackground() {
      this.div.style.zIndex = 0;
    }
  }, {
    key: "setInForeground",
    value: function setInForeground() {
      this.div.style.zIndex = editor_classPrivateFieldGet(_zIndex, this);
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      if (parent !== null) {
        this.pageIndex = parent.pageIndex;
        this.pageDimensions = parent.pageDimensions;
      } else {
        editor_assertClassBrand(_AnnotationEditor_brand, this, _stopResizing).call(this);
      }
      this.parent = parent;
    }
  }, {
    key: "focusin",
    value: function focusin(event) {
      if (!this._focusEventsAllowed) {
        return;
      }
      if (!editor_classPrivateFieldGet(_hasBeenClicked, this)) {
        this.parent.setSelected(this);
      } else {
        editor_classPrivateFieldSet(_hasBeenClicked, this, false);
      }
    }
  }, {
    key: "focusout",
    value: function focusout(event) {
      var _this$parent;
      if (!this._focusEventsAllowed) {
        return;
      }
      if (!this.isAttachedToDOM) {
        return;
      }
      var target = event.relatedTarget;
      if (target !== null && target !== void 0 && target.closest("#".concat(this.id))) {
        return;
      }
      event.preventDefault();
      if (!((_this$parent = this.parent) !== null && _this$parent !== void 0 && _this$parent.isMultipleSelection)) {
        this.commitOrRemove();
      }
    }
  }, {
    key: "commitOrRemove",
    value: function commitOrRemove() {
      if (this.isEmpty()) {
        this.remove();
      } else {
        this.commit();
      }
    }
  }, {
    key: "commit",
    value: function commit() {
      this.addToAnnotationStorage();
    }
  }, {
    key: "addToAnnotationStorage",
    value: function addToAnnotationStorage() {
      this._uiManager.addToAnnotationStorage(this);
    }
  }, {
    key: "setAt",
    value: function setAt(x, y, tx, ty) {
      var _this$parentDimension2 = editor_slicedToArray(this.parentDimensions, 2),
        width = _this$parentDimension2[0],
        height = _this$parentDimension2[1];
      var _this$screenToPageTra = this.screenToPageTranslation(tx, ty);
      var _this$screenToPageTra2 = editor_slicedToArray(_this$screenToPageTra, 2);
      tx = _this$screenToPageTra2[0];
      ty = _this$screenToPageTra2[1];
      this.x = (x + tx) / width;
      this.y = (y + ty) / height;
      this.fixAndSetPosition();
    }
  }, {
    key: "translate",
    value: function translate(x, y) {
      editor_assertClassBrand(_AnnotationEditor_brand, this, _translate).call(this, this.parentDimensions, x, y);
    }
  }, {
    key: "translateInPage",
    value: function translateInPage(x, y) {
      editor_classPrivateFieldGet(_initialRect, this) || editor_classPrivateFieldSet(_initialRect, this, [this.x, this.y, this.width, this.height]);
      editor_assertClassBrand(_AnnotationEditor_brand, this, _translate).call(this, this.pageDimensions, x, y);
      this.div.scrollIntoView({
        block: "nearest"
      });
    }
  }, {
    key: "drag",
    value: function drag(tx, ty) {
      editor_classPrivateFieldGet(_initialRect, this) || editor_classPrivateFieldSet(_initialRect, this, [this.x, this.y, this.width, this.height]);
      var div = this.div,
        _this$parentDimension3 = editor_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension3[0],
        parentHeight = _this$parentDimension3[1];
      this.x += tx / parentWidth;
      this.y += ty / parentHeight;
      if (this.parent && (this.x < 0 || this.x > 1 || this.y < 0 || this.y > 1)) {
        var _this$div$getBounding = this.div.getBoundingClientRect(),
          _x = _this$div$getBounding.x,
          _y = _this$div$getBounding.y;
        if (this.parent.findNewParent(this, _x, _y)) {
          this.x -= Math.floor(this.x);
          this.y -= Math.floor(this.y);
        }
      }
      var x = this.x,
        y = this.y;
      var _this$getBaseTranslat = this.getBaseTranslation(),
        _this$getBaseTranslat2 = editor_slicedToArray(_this$getBaseTranslat, 2),
        bx = _this$getBaseTranslat2[0],
        by = _this$getBaseTranslat2[1];
      x += bx;
      y += by;
      var style = div.style;
      style.left = "".concat((100 * x).toFixed(2), "%");
      style.top = "".concat((100 * y).toFixed(2), "%");
      this._onTranslating(x, y);
      div.scrollIntoView({
        block: "nearest"
      });
    }
  }, {
    key: "_onTranslating",
    value: function _onTranslating(x, y) {}
  }, {
    key: "_onTranslated",
    value: function _onTranslated(x, y) {}
  }, {
    key: "_hasBeenMoved",
    get: function get() {
      return !!editor_classPrivateFieldGet(_initialRect, this) && (editor_classPrivateFieldGet(_initialRect, this)[0] !== this.x || editor_classPrivateFieldGet(_initialRect, this)[1] !== this.y);
    }
  }, {
    key: "_hasBeenResized",
    get: function get() {
      return !!editor_classPrivateFieldGet(_initialRect, this) && (editor_classPrivateFieldGet(_initialRect, this)[2] !== this.width || editor_classPrivateFieldGet(_initialRect, this)[3] !== this.height);
    }
  }, {
    key: "getBaseTranslation",
    value: function getBaseTranslation() {
      var _this$parentDimension4 = editor_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension4[0],
        parentHeight = _this$parentDimension4[1];
      var _borderLineWidth = AnnotationEditor._borderLineWidth;
      var x = _borderLineWidth / parentWidth;
      var y = _borderLineWidth / parentHeight;
      switch (this.rotation) {
        case 90:
          return [-x, y];
        case 180:
          return [x, y];
        case 270:
          return [x, -y];
        default:
          return [-x, -y];
      }
    }
  }, {
    key: "_mustFixPosition",
    get: function get() {
      return true;
    }
  }, {
    key: "fixAndSetPosition",
    value: function fixAndSetPosition() {
      var rotation = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.rotation;
      var style = this.div.style,
        _this$pageDimensions2 = editor_slicedToArray(this.pageDimensions, 2),
        pageWidth = _this$pageDimensions2[0],
        pageHeight = _this$pageDimensions2[1];
      var x = this.x,
        y = this.y,
        width = this.width,
        height = this.height;
      width *= pageWidth;
      height *= pageHeight;
      x *= pageWidth;
      y *= pageHeight;
      if (this._mustFixPosition) {
        switch (rotation) {
          case 0:
            x = Math.max(0, Math.min(pageWidth - width, x));
            y = Math.max(0, Math.min(pageHeight - height, y));
            break;
          case 90:
            x = Math.max(0, Math.min(pageWidth - height, x));
            y = Math.min(pageHeight, Math.max(width, y));
            break;
          case 180:
            x = Math.min(pageWidth, Math.max(width, x));
            y = Math.min(pageHeight, Math.max(height, y));
            break;
          case 270:
            x = Math.min(pageWidth, Math.max(height, x));
            y = Math.max(0, Math.min(pageHeight - width, y));
            break;
        }
      }
      this.x = x /= pageWidth;
      this.y = y /= pageHeight;
      var _this$getBaseTranslat3 = this.getBaseTranslation(),
        _this$getBaseTranslat4 = editor_slicedToArray(_this$getBaseTranslat3, 2),
        bx = _this$getBaseTranslat4[0],
        by = _this$getBaseTranslat4[1];
      x += bx;
      y += by;
      style.left = "".concat((100 * x).toFixed(2), "%");
      style.top = "".concat((100 * y).toFixed(2), "%");
      this.moveInDOM();
    }
  }, {
    key: "screenToPageTranslation",
    value: function screenToPageTranslation(x, y) {
      return _rotatePoint.call(AnnotationEditor, x, y, this.parentRotation);
    }
  }, {
    key: "pageTranslationToScreen",
    value: function pageTranslationToScreen(x, y) {
      return _rotatePoint.call(AnnotationEditor, x, y, 360 - this.parentRotation);
    }
  }, {
    key: "parentScale",
    get: function get() {
      return this._uiManager.viewParameters.realScale;
    }
  }, {
    key: "parentRotation",
    get: function get() {
      return (this._uiManager.viewParameters.rotation + this.pageRotation) % 360;
    }
  }, {
    key: "parentDimensions",
    get: function get() {
      var parentScale = this.parentScale,
        _this$pageDimensions3 = editor_slicedToArray(this.pageDimensions, 2),
        pageWidth = _this$pageDimensions3[0],
        pageHeight = _this$pageDimensions3[1];
      return [pageWidth * parentScale, pageHeight * parentScale];
    }
  }, {
    key: "setDims",
    value: function setDims(width, height) {
      var _this$parentDimension5 = editor_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension5[0],
        parentHeight = _this$parentDimension5[1];
      var style = this.div.style;
      style.width = "".concat((100 * width / parentWidth).toFixed(2), "%");
      if (!editor_classPrivateFieldGet(_keepAspectRatio, this)) {
        style.height = "".concat((100 * height / parentHeight).toFixed(2), "%");
      }
    }
  }, {
    key: "fixDims",
    value: function fixDims() {
      var style = this.div.style;
      var height = style.height,
        width = style.width;
      var widthPercent = width.endsWith("%");
      var heightPercent = !editor_classPrivateFieldGet(_keepAspectRatio, this) && height.endsWith("%");
      if (widthPercent && heightPercent) {
        return;
      }
      var _this$parentDimension6 = editor_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension6[0],
        parentHeight = _this$parentDimension6[1];
      if (!widthPercent) {
        style.width = "".concat((100 * parseFloat(width) / parentWidth).toFixed(2), "%");
      }
      if (!editor_classPrivateFieldGet(_keepAspectRatio, this) && !heightPercent) {
        style.height = "".concat((100 * parseFloat(height) / parentHeight).toFixed(2), "%");
      }
    }
  }, {
    key: "getInitialTranslation",
    value: function getInitialTranslation() {
      return [0, 0];
    }
  }, {
    key: "_onResized",
    value: function _onResized() {}
  }, {
    key: "_onResizing",
    value: function _onResizing() {}
  }, {
    key: "altTextFinish",
    value: function altTextFinish() {
      var _classPrivateFieldGet2;
      (_classPrivateFieldGet2 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.finish();
    }
  }, {
    key: "addEditToolbar",
    value: function () {
      var _addEditToolbar = editor_asyncToGenerator(/*#__PURE__*/editor_regeneratorRuntime().mark(function _callee() {
        return editor_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!(this._editToolbar || editor_classPrivateFieldGet(_isInEditMode, this))) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return", this._editToolbar);
            case 2:
              this._editToolbar = new EditorToolbar(this);
              this.div.append(this._editToolbar.render());
              if (!editor_classPrivateFieldGet(editor_altText, this)) {
                _context.next = 7;
                break;
              }
              _context.next = 7;
              return this._editToolbar.addAltText(editor_classPrivateFieldGet(editor_altText, this));
            case 7:
              return _context.abrupt("return", this._editToolbar);
            case 8:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function addEditToolbar() {
        return _addEditToolbar.apply(this, arguments);
      }
      return addEditToolbar;
    }()
  }, {
    key: "removeEditToolbar",
    value: function removeEditToolbar() {
      var _classPrivateFieldGet3;
      if (!this._editToolbar) {
        return;
      }
      this._editToolbar.remove();
      this._editToolbar = null;
      (_classPrivateFieldGet3 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.destroy();
    }
  }, {
    key: "addContainer",
    value: function addContainer(container) {
      var _this$_editToolbar;
      var editToolbarDiv = (_this$_editToolbar = this._editToolbar) === null || _this$_editToolbar === void 0 ? void 0 : _this$_editToolbar.div;
      if (editToolbarDiv) {
        editToolbarDiv.before(container);
      } else {
        this.div.append(container);
      }
    }
  }, {
    key: "getClientDimensions",
    value: function getClientDimensions() {
      return this.div.getBoundingClientRect();
    }
  }, {
    key: "addAltTextButton",
    value: function () {
      var _addAltTextButton = editor_asyncToGenerator(/*#__PURE__*/editor_regeneratorRuntime().mark(function _callee2() {
        return editor_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!editor_classPrivateFieldGet(editor_altText, this)) {
                _context2.next = 2;
                break;
              }
              return _context2.abrupt("return");
            case 2:
              AltText.initialize(AnnotationEditor._l10n);
              editor_classPrivateFieldSet(editor_altText, this, new AltText(this));
              if (editor_classPrivateFieldGet(_accessibilityData, this)) {
                editor_classPrivateFieldGet(editor_altText, this).data = editor_classPrivateFieldGet(_accessibilityData, this);
                editor_classPrivateFieldSet(_accessibilityData, this, null);
              }
              _context2.next = 7;
              return this.addEditToolbar();
            case 7:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function addAltTextButton() {
        return _addAltTextButton.apply(this, arguments);
      }
      return addAltTextButton;
    }()
  }, {
    key: "altTextData",
    get: function get() {
      var _classPrivateFieldGet4;
      return (_classPrivateFieldGet4 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.data;
    },
    set: function set(data) {
      if (!editor_classPrivateFieldGet(editor_altText, this)) {
        return;
      }
      editor_classPrivateFieldGet(editor_altText, this).data = data;
    }
  }, {
    key: "guessedAltText",
    get: function get() {
      var _classPrivateFieldGet5;
      return (_classPrivateFieldGet5 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet5 === void 0 ? void 0 : _classPrivateFieldGet5.guessedText;
    }
  }, {
    key: "setGuessedAltText",
    value: function () {
      var _setGuessedAltText = editor_asyncToGenerator(/*#__PURE__*/editor_regeneratorRuntime().mark(function _callee3(text) {
        var _classPrivateFieldGet6;
        return editor_regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return (_classPrivateFieldGet6 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet6 === void 0 ? void 0 : _classPrivateFieldGet6.setGuessedText(text);
            case 2:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function setGuessedAltText(_x2) {
        return _setGuessedAltText.apply(this, arguments);
      }
      return setGuessedAltText;
    }()
  }, {
    key: "serializeAltText",
    value: function serializeAltText(isForCopying) {
      var _classPrivateFieldGet7;
      return (_classPrivateFieldGet7 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet7 === void 0 ? void 0 : _classPrivateFieldGet7.serialize(isForCopying);
    }
  }, {
    key: "hasAltText",
    value: function hasAltText() {
      return !!editor_classPrivateFieldGet(editor_altText, this) && !editor_classPrivateFieldGet(editor_altText, this).isEmpty();
    }
  }, {
    key: "hasAltTextData",
    value: function hasAltTextData() {
      var _classPrivateFieldGet8, _classPrivateFieldGet9;
      return (_classPrivateFieldGet8 = (_classPrivateFieldGet9 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet9 === void 0 ? void 0 : _classPrivateFieldGet9.hasData()) !== null && _classPrivateFieldGet8 !== void 0 ? _classPrivateFieldGet8 : false;
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this,
        _this$_uiManager$_edi;
      this.div = document.createElement("div");
      this.div.setAttribute("data-editor-rotation", (360 - this.rotation) % 360);
      this.div.className = this.name;
      this.div.setAttribute("id", this.id);
      this.div.tabIndex = editor_classPrivateFieldGet(_disabled, this) ? -1 : 0;
      if (!this._isVisible) {
        this.div.classList.add("hidden");
      }
      this.setInForeground();
      editor_assertClassBrand(_AnnotationEditor_brand, this, _addFocusListeners).call(this);
      var _this$parentDimension7 = editor_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension7[0],
        parentHeight = _this$parentDimension7[1];
      if (this.parentRotation % 180 !== 0) {
        this.div.style.maxWidth = "".concat((100 * parentHeight / parentWidth).toFixed(2), "%");
        this.div.style.maxHeight = "".concat((100 * parentWidth / parentHeight).toFixed(2), "%");
      }
      var _this$getInitialTrans = this.getInitialTranslation(),
        _this$getInitialTrans2 = editor_slicedToArray(_this$getInitialTrans, 2),
        tx = _this$getInitialTrans2[0],
        ty = _this$getInitialTrans2[1];
      this.translate(tx, ty);
      bindEvents(this, this.div, ["pointerdown"]);
      if (this.isResizable && this._uiManager._supportsPinchToZoom) {
        editor_classPrivateFieldGet(_touchManager, this) || editor_classPrivateFieldSet(_touchManager, this, new TouchManager({
          container: this.div,
          isPinchingDisabled: function isPinchingDisabled() {
            return !_this.isSelected;
          },
          onPinchStart: editor_assertClassBrand(_AnnotationEditor_brand, this, _touchPinchStartCallback).bind(this),
          onPinching: editor_assertClassBrand(_AnnotationEditor_brand, this, _touchPinchCallback).bind(this),
          onPinchEnd: editor_assertClassBrand(_AnnotationEditor_brand, this, _touchPinchEndCallback).bind(this),
          signal: this._uiManager._signal
        }));
      }
      (_this$_uiManager$_edi = this._uiManager._editorUndoBar) === null || _this$_uiManager$_edi === void 0 || _this$_uiManager$_edi.hide();
      return this.div;
    }
  }, {
    key: "pointerdown",
    value: function pointerdown(event) {
      var isMac = util_FeatureTest.platform.isMac;
      if (event.button !== 0 || event.ctrlKey && isMac) {
        event.preventDefault();
        return;
      }
      editor_classPrivateFieldSet(_hasBeenClicked, this, true);
      if (this._isDraggable) {
        editor_assertClassBrand(_AnnotationEditor_brand, this, _setUpDragSession).call(this, event);
        return;
      }
      editor_assertClassBrand(_AnnotationEditor_brand, this, _selectOnPointerEvent).call(this, event);
    }
  }, {
    key: "isSelected",
    get: function get() {
      return this._uiManager.isSelected(this);
    }
  }, {
    key: "_onStartDragging",
    value: function _onStartDragging() {}
  }, {
    key: "_onStopDragging",
    value: function _onStopDragging() {}
  }, {
    key: "moveInDOM",
    value: function moveInDOM() {
      var _this2 = this;
      if (editor_classPrivateFieldGet(_moveInDOMTimeout, this)) {
        clearTimeout(editor_classPrivateFieldGet(_moveInDOMTimeout, this));
      }
      editor_classPrivateFieldSet(_moveInDOMTimeout, this, setTimeout(function () {
        var _this2$parent;
        editor_classPrivateFieldSet(_moveInDOMTimeout, _this2, null);
        (_this2$parent = _this2.parent) === null || _this2$parent === void 0 || _this2$parent.moveEditorInDOM(_this2);
      }, 0));
    }
  }, {
    key: "_setParentAndPosition",
    value: function _setParentAndPosition(parent, x, y) {
      parent.changeParent(this);
      this.x = x;
      this.y = y;
      this.fixAndSetPosition();
      this._onTranslated();
    }
  }, {
    key: "getRect",
    value: function getRect(tx, ty) {
      var rotation = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.rotation;
      var scale = this.parentScale;
      var _this$pageDimensions4 = editor_slicedToArray(this.pageDimensions, 2),
        pageWidth = _this$pageDimensions4[0],
        pageHeight = _this$pageDimensions4[1];
      var _this$pageTranslation = editor_slicedToArray(this.pageTranslation, 2),
        pageX = _this$pageTranslation[0],
        pageY = _this$pageTranslation[1];
      var shiftX = tx / scale;
      var shiftY = ty / scale;
      var x = this.x * pageWidth;
      var y = this.y * pageHeight;
      var width = this.width * pageWidth;
      var height = this.height * pageHeight;
      switch (rotation) {
        case 0:
          return [x + shiftX + pageX, pageHeight - y - shiftY - height + pageY, x + shiftX + width + pageX, pageHeight - y - shiftY + pageY];
        case 90:
          return [x + shiftY + pageX, pageHeight - y + shiftX + pageY, x + shiftY + height + pageX, pageHeight - y + shiftX + width + pageY];
        case 180:
          return [x - shiftX - width + pageX, pageHeight - y + shiftY + pageY, x - shiftX + pageX, pageHeight - y + shiftY + height + pageY];
        case 270:
          return [x - shiftY - height + pageX, pageHeight - y - shiftX - width + pageY, x - shiftY + pageX, pageHeight - y - shiftX + pageY];
        default:
          throw new Error("Invalid rotation");
      }
    }
  }, {
    key: "getRectInCurrentCoords",
    value: function getRectInCurrentCoords(rect, pageHeight) {
      var _rect = editor_slicedToArray(rect, 4),
        x1 = _rect[0],
        y1 = _rect[1],
        x2 = _rect[2],
        y2 = _rect[3];
      var width = x2 - x1;
      var height = y2 - y1;
      switch (this.rotation) {
        case 0:
          return [x1, pageHeight - y2, width, height];
        case 90:
          return [x1, pageHeight - y1, height, width];
        case 180:
          return [x2, pageHeight - y1, width, height];
        case 270:
          return [x2, pageHeight - y2, height, width];
        default:
          throw new Error("Invalid rotation");
      }
    }
  }, {
    key: "onceAdded",
    value: function onceAdded(focus) {}
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return false;
    }
  }, {
    key: "enableEditMode",
    value: function enableEditMode() {
      editor_classPrivateFieldSet(_isInEditMode, this, true);
    }
  }, {
    key: "disableEditMode",
    value: function disableEditMode() {
      editor_classPrivateFieldSet(_isInEditMode, this, false);
    }
  }, {
    key: "isInEditMode",
    value: function isInEditMode() {
      return editor_classPrivateFieldGet(_isInEditMode, this);
    }
  }, {
    key: "shouldGetKeyboardEvents",
    value: function shouldGetKeyboardEvents() {
      return editor_classPrivateFieldGet(_isResizerEnabledForKeyboard, this);
    }
  }, {
    key: "needsToBeRebuilt",
    value: function needsToBeRebuilt() {
      return this.div && !this.isAttachedToDOM;
    }
  }, {
    key: "isOnScreen",
    get: function get() {
      var _this$getClientDimens = this.getClientDimensions(),
        top = _this$getClientDimens.top,
        left = _this$getClientDimens.left,
        bottom = _this$getClientDimens.bottom,
        right = _this$getClientDimens.right;
      var _window = window,
        innerHeight = _window.innerHeight,
        innerWidth = _window.innerWidth;
      return left < innerWidth && right > 0 && top < innerHeight && bottom > 0;
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      editor_assertClassBrand(_AnnotationEditor_brand, this, _addFocusListeners).call(this);
    }
  }, {
    key: "rotate",
    value: function rotate(_angle) {}
  }, {
    key: "resize",
    value: function resize() {}
  }, {
    key: "serializeDeleted",
    value: function serializeDeleted() {
      var _this$_initialData;
      return {
        id: this.annotationElementId,
        deleted: true,
        pageIndex: this.pageIndex,
        popupRef: ((_this$_initialData = this._initialData) === null || _this$_initialData === void 0 ? void 0 : _this$_initialData.popupRef) || ""
      };
    }
  }, {
    key: "serialize",
    value: function serialize() {
      var isForCopying = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      unreachable("An editor must be serializable");
    }
  }, {
    key: "hasBeenModified",
    get: function get() {
      return !!this.annotationElementId && (this.deleted || this.serialize() !== null);
    }
  }, {
    key: "remove",
    value: function remove() {
      var _classPrivateFieldGet10, _classPrivateFieldGet11;
      (_classPrivateFieldGet10 = editor_classPrivateFieldGet(_focusAC, this)) === null || _classPrivateFieldGet10 === void 0 || _classPrivateFieldGet10.abort();
      editor_classPrivateFieldSet(_focusAC, this, null);
      if (!this.isEmpty()) {
        this.commit();
      }
      if (this.parent) {
        this.parent.remove(this);
      } else {
        this._uiManager.removeEditor(this);
      }
      if (editor_classPrivateFieldGet(_moveInDOMTimeout, this)) {
        clearTimeout(editor_classPrivateFieldGet(_moveInDOMTimeout, this));
        editor_classPrivateFieldSet(_moveInDOMTimeout, this, null);
      }
      editor_assertClassBrand(_AnnotationEditor_brand, this, _stopResizing).call(this);
      this.removeEditToolbar();
      if (editor_classPrivateFieldGet(_telemetryTimeouts, this)) {
        var _iterator = editor_createForOfIteratorHelper(editor_classPrivateFieldGet(_telemetryTimeouts, this).values()),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var timeout = _step.value;
            clearTimeout(timeout);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        editor_classPrivateFieldSet(_telemetryTimeouts, this, null);
      }
      this.parent = null;
      (_classPrivateFieldGet11 = editor_classPrivateFieldGet(_touchManager, this)) === null || _classPrivateFieldGet11 === void 0 || _classPrivateFieldGet11.destroy();
      editor_classPrivateFieldSet(_touchManager, this, null);
    }
  }, {
    key: "isResizable",
    get: function get() {
      return false;
    }
  }, {
    key: "makeResizable",
    value: function makeResizable() {
      if (this.isResizable) {
        editor_assertClassBrand(_AnnotationEditor_brand, this, _createResizers).call(this);
        editor_classPrivateFieldGet(_resizersDiv, this).classList.remove("hidden");
        bindEvents(this, this.div, ["keydown"]);
      }
    }
  }, {
    key: "toolbarPosition",
    get: function get() {
      return null;
    }
  }, {
    key: "keydown",
    value: function keydown(event) {
      if (!this.isResizable || event.target !== this.div || event.key !== "Enter") {
        return;
      }
      this._uiManager.setSelected(this);
      editor_classPrivateFieldSet(_savedDimensions, this, {
        savedX: this.x,
        savedY: this.y,
        savedWidth: this.width,
        savedHeight: this.height
      });
      var children = editor_classPrivateFieldGet(_resizersDiv, this).children;
      if (!editor_classPrivateFieldGet(_allResizerDivs, this)) {
        editor_classPrivateFieldSet(_allResizerDivs, this, Array.from(children));
        var boundResizerKeydown = editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerKeydown).bind(this);
        var boundResizerBlur = editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerBlur).bind(this);
        var signal = this._uiManager._signal;
        var _iterator2 = editor_createForOfIteratorHelper(editor_classPrivateFieldGet(_allResizerDivs, this)),
          _step2;
        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var div = _step2.value;
            var name = div.getAttribute("data-resizer-name");
            div.setAttribute("role", "spinbutton");
            div.addEventListener("keydown", boundResizerKeydown, {
              signal: signal
            });
            div.addEventListener("blur", boundResizerBlur, {
              signal: signal
            });
            div.addEventListener("focus", editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerFocus).bind(this, name), {
              signal: signal
            });
            div.setAttribute("data-l10n-id", AnnotationEditor._l10nResizer[name]);
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
      var first = editor_classPrivateFieldGet(_allResizerDivs, this)[0];
      var firstPosition = 0;
      var _iterator3 = editor_createForOfIteratorHelper(children),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _div2 = _step3.value;
          if (_div2 === first) {
            break;
          }
          firstPosition++;
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      var nextFirstPosition = (360 - this.rotation + this.parentRotation) % 360 / 90 * (editor_classPrivateFieldGet(_allResizerDivs, this).length / 4);
      if (nextFirstPosition !== firstPosition) {
        if (nextFirstPosition < firstPosition) {
          for (var _i = 0; _i < firstPosition - nextFirstPosition; _i++) {
            editor_classPrivateFieldGet(_resizersDiv, this).append(editor_classPrivateFieldGet(_resizersDiv, this).firstChild);
          }
        } else if (nextFirstPosition > firstPosition) {
          for (var _i2 = 0; _i2 < nextFirstPosition - firstPosition; _i2++) {
            editor_classPrivateFieldGet(_resizersDiv, this).firstChild.before(editor_classPrivateFieldGet(_resizersDiv, this).lastChild);
          }
        }
        var i = 0;
        var _iterator4 = editor_createForOfIteratorHelper(children),
          _step4;
        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var child = _step4.value;
            var _div = editor_classPrivateFieldGet(_allResizerDivs, this)[i++];
            var _name = _div.getAttribute("data-resizer-name");
            child.setAttribute("data-l10n-id", AnnotationEditor._l10nResizer[_name]);
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      }
      editor_assertClassBrand(_AnnotationEditor_brand, this, _setResizerTabIndex).call(this, 0);
      editor_classPrivateFieldSet(_isResizerEnabledForKeyboard, this, true);
      editor_classPrivateFieldGet(_resizersDiv, this).firstChild.focus({
        focusVisible: true
      });
      event.preventDefault();
      event.stopImmediatePropagation();
    }
  }, {
    key: "_resizeWithKeyboard",
    value: function _resizeWithKeyboard(x, y) {
      if (!editor_classPrivateFieldGet(_isResizerEnabledForKeyboard, this)) {
        return;
      }
      editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerPointermove).call(this, editor_classPrivateFieldGet(_focusedResizerName, this), {
        deltaX: x,
        deltaY: y,
        fromKeyboard: true
      });
    }
  }, {
    key: "_stopResizingWithKeyboard",
    value: function _stopResizingWithKeyboard() {
      editor_assertClassBrand(_AnnotationEditor_brand, this, _stopResizing).call(this);
      this.div.focus();
    }
  }, {
    key: "select",
    value: function select() {
      var _this$div2,
        _this3 = this,
        _this$_editToolbar2,
        _classPrivateFieldGet12;
      this.makeResizable();
      (_this$div2 = this.div) === null || _this$div2 === void 0 || _this$div2.classList.add("selectedEditor");
      if (!this._editToolbar) {
        this.addEditToolbar().then(function () {
          var _this3$div;
          if ((_this3$div = _this3.div) !== null && _this3$div !== void 0 && _this3$div.classList.contains("selectedEditor")) {
            var _this3$_editToolbar;
            (_this3$_editToolbar = _this3._editToolbar) === null || _this3$_editToolbar === void 0 || _this3$_editToolbar.show();
          }
        });
        return;
      }
      (_this$_editToolbar2 = this._editToolbar) === null || _this$_editToolbar2 === void 0 || _this$_editToolbar2.show();
      (_classPrivateFieldGet12 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet12 === void 0 || _classPrivateFieldGet12.toggleAltTextBadge(false);
    }
  }, {
    key: "unselect",
    value: function unselect() {
      var _classPrivateFieldGet13, _this$div3, _this$div4, _this$_editToolbar3, _classPrivateFieldGet14;
      (_classPrivateFieldGet13 = editor_classPrivateFieldGet(_resizersDiv, this)) === null || _classPrivateFieldGet13 === void 0 || _classPrivateFieldGet13.classList.add("hidden");
      (_this$div3 = this.div) === null || _this$div3 === void 0 || _this$div3.classList.remove("selectedEditor");
      if ((_this$div4 = this.div) !== null && _this$div4 !== void 0 && _this$div4.contains(document.activeElement)) {
        this._uiManager.currentLayer.div.focus({
          preventScroll: true
        });
      }
      (_this$_editToolbar3 = this._editToolbar) === null || _this$_editToolbar3 === void 0 || _this$_editToolbar3.hide();
      (_classPrivateFieldGet14 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet14 === void 0 || _classPrivateFieldGet14.toggleAltTextBadge(true);
    }
  }, {
    key: "updateParams",
    value: function updateParams(type, value) {}
  }, {
    key: "disableEditing",
    value: function disableEditing() {}
  }, {
    key: "enableEditing",
    value: function enableEditing() {}
  }, {
    key: "enterInEditMode",
    value: function enterInEditMode() {}
  }, {
    key: "getImageForAltText",
    value: function getImageForAltText() {
      return null;
    }
  }, {
    key: "contentDiv",
    get: function get() {
      return this.div;
    }
  }, {
    key: "isEditing",
    get: function get() {
      return editor_classPrivateFieldGet(_isEditing, this);
    },
    set: function set(value) {
      editor_classPrivateFieldSet(_isEditing, this, value);
      if (!this.parent) {
        return;
      }
      if (value) {
        this.parent.setSelected(this);
        this.parent.setActiveEditor(this);
      } else {
        this.parent.setActiveEditor(null);
      }
    }
  }, {
    key: "setAspectRatio",
    value: function setAspectRatio(width, height) {
      editor_classPrivateFieldSet(_keepAspectRatio, this, true);
      var aspectRatio = width / height;
      var style = this.div.style;
      style.aspectRatio = aspectRatio;
      style.height = "auto";
    }
  }, {
    key: "telemetryInitialData",
    get: function get() {
      return {
        action: "added"
      };
    }
  }, {
    key: "telemetryFinalData",
    get: function get() {
      return null;
    }
  }, {
    key: "_reportTelemetry",
    value: function _reportTelemetry(data) {
      var _this4 = this;
      var mustWait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      if (mustWait) {
        editor_classPrivateFieldGet(_telemetryTimeouts, this) || editor_classPrivateFieldSet(_telemetryTimeouts, this, new Map());
        var action = data.action;
        var timeout = editor_classPrivateFieldGet(_telemetryTimeouts, this).get(action);
        if (timeout) {
          clearTimeout(timeout);
        }
        timeout = setTimeout(function () {
          _this4._reportTelemetry(data);
          editor_classPrivateFieldGet(_telemetryTimeouts, _this4).delete(action);
          if (editor_classPrivateFieldGet(_telemetryTimeouts, _this4).size === 0) {
            editor_classPrivateFieldSet(_telemetryTimeouts, _this4, null);
          }
        }, AnnotationEditor._telemetryTimeout);
        editor_classPrivateFieldGet(_telemetryTimeouts, this).set(action, timeout);
        return;
      }
      data.type || (data.type = this.editorType);
      this._uiManager._eventBus.dispatch("reporttelemetry", {
        source: this,
        details: {
          type: "editing",
          data: data
        }
      });
    }
  }, {
    key: "show",
    value: function show() {
      var visible = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._isVisible;
      this.div.classList.toggle("hidden", !visible);
      this._isVisible = visible;
    }
  }, {
    key: "enable",
    value: function enable() {
      if (this.div) {
        this.div.tabIndex = 0;
      }
      editor_classPrivateFieldSet(_disabled, this, false);
    }
  }, {
    key: "disable",
    value: function disable() {
      if (this.div) {
        this.div.tabIndex = -1;
      }
      editor_classPrivateFieldSet(_disabled, this, true);
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      var content = annotation.container.querySelector(".annotationContent");
      if (!content) {
        content = document.createElement("div");
        content.classList.add("annotationContent", this.editorType);
        annotation.container.prepend(content);
      } else if (content.nodeName === "CANVAS") {
        var canvas = content;
        content = document.createElement("div");
        content.classList.add("annotationContent", this.editorType);
        canvas.before(content);
      }
      return content;
    }
  }, {
    key: "resetAnnotationElement",
    value: function resetAnnotationElement(annotation) {
      var firstChild = annotation.container.firstChild;
      if ((firstChild === null || firstChild === void 0 ? void 0 : firstChild.nodeName) === "DIV" && firstChild.classList.contains("annotationContent")) {
        firstChild.remove();
      }
    }
  }], [{
    key: "_resizerKeyboardManager",
    get: function get() {
      var resize = AnnotationEditor.prototype._resizeWithKeyboard;
      var small = AnnotationEditorUIManager.TRANSLATE_SMALL;
      var big = AnnotationEditorUIManager.TRANSLATE_BIG;
      return shadow(this, "_resizerKeyboardManager", new KeyboardManager([[["ArrowLeft", "mac+ArrowLeft"], resize, {
        args: [-small, 0]
      }], [["ctrl+ArrowLeft", "mac+shift+ArrowLeft"], resize, {
        args: [-big, 0]
      }], [["ArrowRight", "mac+ArrowRight"], resize, {
        args: [small, 0]
      }], [["ctrl+ArrowRight", "mac+shift+ArrowRight"], resize, {
        args: [big, 0]
      }], [["ArrowUp", "mac+ArrowUp"], resize, {
        args: [0, -small]
      }], [["ctrl+ArrowUp", "mac+shift+ArrowUp"], resize, {
        args: [0, -big]
      }], [["ArrowDown", "mac+ArrowDown"], resize, {
        args: [0, small]
      }], [["ctrl+ArrowDown", "mac+shift+ArrowDown"], resize, {
        args: [0, big]
      }], [["Escape", "mac+Escape"], AnnotationEditor.prototype._stopResizingWithKeyboard]]));
    }
  }, {
    key: "isDrawer",
    get: function get() {
      return false;
    }
  }, {
    key: "_defaultLineColor",
    get: function get() {
      return shadow(this, "_defaultLineColor", this._colorManager.getHexCode("CanvasText"));
    }
  }, {
    key: "deleteAnnotationElement",
    value: function deleteAnnotationElement(editor) {
      var fakeEditor = new FakeEditor({
        id: editor.parent.getNextId(),
        parent: editor.parent,
        uiManager: editor._uiManager
      });
      fakeEditor.annotationElementId = editor.annotationElementId;
      fakeEditor.deleted = true;
      fakeEditor._uiManager.addToAnnotationStorage(fakeEditor);
    }
  }, {
    key: "initialize",
    value: function initialize(l10n, _uiManager) {
      var _AnnotationEditor$_l;
      (_AnnotationEditor$_l = AnnotationEditor._l10n) !== null && _AnnotationEditor$_l !== void 0 ? _AnnotationEditor$_l : AnnotationEditor._l10n = l10n;
      AnnotationEditor._l10nResizer || (AnnotationEditor._l10nResizer = Object.freeze({
        topLeft: "pdfjs-editor-resizer-top-left",
        topMiddle: "pdfjs-editor-resizer-top-middle",
        topRight: "pdfjs-editor-resizer-top-right",
        middleRight: "pdfjs-editor-resizer-middle-right",
        bottomRight: "pdfjs-editor-resizer-bottom-right",
        bottomMiddle: "pdfjs-editor-resizer-bottom-middle",
        bottomLeft: "pdfjs-editor-resizer-bottom-left",
        middleLeft: "pdfjs-editor-resizer-middle-left"
      }));
      if (AnnotationEditor._borderLineWidth !== -1) {
        return;
      }
      var style = getComputedStyle(document.documentElement);
      AnnotationEditor._borderLineWidth = parseFloat(style.getPropertyValue("--outline-width")) || 0;
    }
  }, {
    key: "updateDefaultParams",
    value: function updateDefaultParams(_type, _value) {}
  }, {
    key: "defaultPropertiesToUpdate",
    get: function get() {
      return [];
    }
  }, {
    key: "isHandlingMimeForPasting",
    value: function isHandlingMimeForPasting(mime) {
      return false;
    }
  }, {
    key: "paste",
    value: function paste(item, parent) {
      unreachable("Not implemented");
    }
  }, {
    key: "_round",
    value: function _round(x) {
      return Math.round(x * 10000) / 10000;
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = editor_asyncToGenerator(/*#__PURE__*/editor_regeneratorRuntime().mark(function _callee4(data, parent, uiManager) {
        var editor, _editor$pageDimension, pageWidth, pageHeight, _editor$getRectInCurr, _editor$getRectInCurr2, x, y, width, height;
        return editor_regeneratorRuntime().wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              editor = new this.prototype.constructor({
                parent: parent,
                id: parent.getNextId(),
                uiManager: uiManager
              });
              editor.rotation = data.rotation;
              editor_classPrivateFieldSet(_accessibilityData, editor, data.accessibilityData);
              _editor$pageDimension = editor_slicedToArray(editor.pageDimensions, 2), pageWidth = _editor$pageDimension[0], pageHeight = _editor$pageDimension[1];
              _editor$getRectInCurr = editor.getRectInCurrentCoords(data.rect, pageHeight), _editor$getRectInCurr2 = editor_slicedToArray(_editor$getRectInCurr, 4), x = _editor$getRectInCurr2[0], y = _editor$getRectInCurr2[1], width = _editor$getRectInCurr2[2], height = _editor$getRectInCurr2[3];
              editor.x = x / pageWidth;
              editor.y = y / pageHeight;
              editor.width = width / pageWidth;
              editor.height = height / pageHeight;
              return _context4.abrupt("return", editor);
            case 10:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this);
      }));
      function deserialize(_x3, _x4, _x5) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }, {
    key: "MIN_SIZE",
    get: function get() {
      return 16;
    }
  }, {
    key: "canCreateNewEmptyEditor",
    value: function canCreateNewEmptyEditor() {
      return true;
    }
  }]);
}();
_AnnotationEditor = AnnotationEditor;
function _translate(_ref, x, y) {
  var _ref2 = editor_slicedToArray(_ref, 2),
    width = _ref2[0],
    height = _ref2[1];
  var _this$screenToPageTra3 = this.screenToPageTranslation(x, y);
  var _this$screenToPageTra4 = editor_slicedToArray(_this$screenToPageTra3, 2);
  x = _this$screenToPageTra4[0];
  y = _this$screenToPageTra4[1];
  this.x += x / width;
  this.y += y / height;
  this._onTranslating(this.x, this.y);
  this.fixAndSetPosition();
}
function _rotatePoint(x, y, angle) {
  switch (angle) {
    case 90:
      return [y, -x];
    case 180:
      return [-x, -y];
    case 270:
      return [-y, x];
    default:
      return [x, y];
  }
}
function _getRotationMatrix(rotation) {
  switch (rotation) {
    case 90:
      {
        var _this$pageDimensions5 = editor_slicedToArray(this.pageDimensions, 2),
          pageWidth = _this$pageDimensions5[0],
          pageHeight = _this$pageDimensions5[1];
        return [0, -pageWidth / pageHeight, pageHeight / pageWidth, 0];
      }
    case 180:
      return [-1, 0, 0, -1];
    case 270:
      {
        var _this$pageDimensions6 = editor_slicedToArray(this.pageDimensions, 2),
          _pageWidth2 = _this$pageDimensions6[0],
          _pageHeight2 = _this$pageDimensions6[1];
        return [0, _pageWidth2 / _pageHeight2, -_pageHeight2 / _pageWidth2, 0];
      }
    default:
      return [1, 0, 0, 1];
  }
}
function _createResizers() {
  if (editor_classPrivateFieldGet(_resizersDiv, this)) {
    return;
  }
  editor_classPrivateFieldSet(_resizersDiv, this, document.createElement("div"));
  editor_classPrivateFieldGet(_resizersDiv, this).classList.add("resizers");
  var classes = this._willKeepAspectRatio ? ["topLeft", "topRight", "bottomRight", "bottomLeft"] : ["topLeft", "topMiddle", "topRight", "middleRight", "bottomRight", "bottomMiddle", "bottomLeft", "middleLeft"];
  var signal = this._uiManager._signal;
  for (var _i3 = 0, _classes = classes; _i3 < _classes.length; _i3++) {
    var name = _classes[_i3];
    var div = document.createElement("div");
    editor_classPrivateFieldGet(_resizersDiv, this).append(div);
    div.classList.add("resizer", name);
    div.setAttribute("data-resizer-name", name);
    div.addEventListener("pointerdown", editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerPointerdown).bind(this, name), {
      signal: signal
    });
    div.addEventListener("contextmenu", noContextMenu, {
      signal: signal
    });
    div.tabIndex = -1;
  }
  this.div.prepend(editor_classPrivateFieldGet(_resizersDiv, this));
}
function _resizerPointerdown(name, event) {
  var _classPrivateFieldGet15,
    _this6 = this;
  event.preventDefault();
  var isMac = util_FeatureTest.platform.isMac;
  if (event.button !== 0 || event.ctrlKey && isMac) {
    return;
  }
  (_classPrivateFieldGet15 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet15 === void 0 || _classPrivateFieldGet15.toggle(false);
  var savedDraggable = this._isDraggable;
  this._isDraggable = false;
  editor_classPrivateFieldSet(_lastPointerCoords, this, [event.screenX, event.screenY]);
  var ac = new AbortController();
  var signal = this._uiManager.combinedSignal(ac);
  this.parent.togglePointerEvents(false);
  window.addEventListener("pointermove", editor_assertClassBrand(_AnnotationEditor_brand, this, _resizerPointermove).bind(this, name), {
    passive: true,
    capture: true,
    signal: signal
  });
  window.addEventListener("touchmove", stopEvent, {
    passive: false,
    signal: signal
  });
  window.addEventListener("contextmenu", noContextMenu, {
    signal: signal
  });
  editor_classPrivateFieldSet(_savedDimensions, this, {
    savedX: this.x,
    savedY: this.y,
    savedWidth: this.width,
    savedHeight: this.height
  });
  var savedParentCursor = this.parent.div.style.cursor;
  var savedCursor = this.div.style.cursor;
  this.div.style.cursor = this.parent.div.style.cursor = window.getComputedStyle(event.target).cursor;
  var pointerUpCallback = function pointerUpCallback() {
    var _classPrivateFieldGet16;
    ac.abort();
    _this6.parent.togglePointerEvents(true);
    (_classPrivateFieldGet16 = editor_classPrivateFieldGet(editor_altText, _this6)) === null || _classPrivateFieldGet16 === void 0 || _classPrivateFieldGet16.toggle(true);
    _this6._isDraggable = savedDraggable;
    _this6.parent.div.style.cursor = savedParentCursor;
    _this6.div.style.cursor = savedCursor;
    editor_assertClassBrand(_AnnotationEditor_brand, _this6, _addResizeToUndoStack).call(_this6);
  };
  window.addEventListener("pointerup", pointerUpCallback, {
    signal: signal
  });
  window.addEventListener("blur", pointerUpCallback, {
    signal: signal
  });
}
function _resize(x, y, width, height) {
  this.width = width;
  this.height = height;
  this.x = x;
  this.y = y;
  var _this$parentDimension8 = editor_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension8[0],
    parentHeight = _this$parentDimension8[1];
  this.setDims(parentWidth * width, parentHeight * height);
  this.fixAndSetPosition();
  this._onResized();
}
function _addResizeToUndoStack() {
  if (!editor_classPrivateFieldGet(_savedDimensions, this)) {
    return;
  }
  var _classPrivateFieldGet17 = editor_classPrivateFieldGet(_savedDimensions, this),
    savedX = _classPrivateFieldGet17.savedX,
    savedY = _classPrivateFieldGet17.savedY,
    savedWidth = _classPrivateFieldGet17.savedWidth,
    savedHeight = _classPrivateFieldGet17.savedHeight;
  editor_classPrivateFieldSet(_savedDimensions, this, null);
  var newX = this.x;
  var newY = this.y;
  var newWidth = this.width;
  var newHeight = this.height;
  if (newX === savedX && newY === savedY && newWidth === savedWidth && newHeight === savedHeight) {
    return;
  }
  this.addCommands({
    cmd: editor_assertClassBrand(_AnnotationEditor_brand, this, _resize).bind(this, newX, newY, newWidth, newHeight),
    undo: editor_assertClassBrand(_AnnotationEditor_brand, this, _resize).bind(this, savedX, savedY, savedWidth, savedHeight),
    mustExec: true
  });
}
function _resizerPointermove(name, event) {
  var _this$parentDimension9 = editor_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension9[0],
    parentHeight = _this$parentDimension9[1];
  var savedX = this.x;
  var savedY = this.y;
  var savedWidth = this.width;
  var savedHeight = this.height;
  var minWidth = _AnnotationEditor.MIN_SIZE / parentWidth;
  var minHeight = _AnnotationEditor.MIN_SIZE / parentHeight;
  var rotationMatrix = editor_assertClassBrand(_AnnotationEditor_brand, this, _getRotationMatrix).call(this, this.rotation);
  var transf = function transf(x, y) {
    return [rotationMatrix[0] * x + rotationMatrix[2] * y, rotationMatrix[1] * x + rotationMatrix[3] * y];
  };
  var invRotationMatrix = editor_assertClassBrand(_AnnotationEditor_brand, this, _getRotationMatrix).call(this, 360 - this.rotation);
  var invTransf = function invTransf(x, y) {
    return [invRotationMatrix[0] * x + invRotationMatrix[2] * y, invRotationMatrix[1] * x + invRotationMatrix[3] * y];
  };
  var getPoint;
  var getOpposite;
  var isDiagonal = false;
  var isHorizontal = false;
  switch (name) {
    case "topLeft":
      isDiagonal = true;
      getPoint = function getPoint(w, h) {
        return [0, 0];
      };
      getOpposite = function getOpposite(w, h) {
        return [w, h];
      };
      break;
    case "topMiddle":
      getPoint = function getPoint(w, h) {
        return [w / 2, 0];
      };
      getOpposite = function getOpposite(w, h) {
        return [w / 2, h];
      };
      break;
    case "topRight":
      isDiagonal = true;
      getPoint = function getPoint(w, h) {
        return [w, 0];
      };
      getOpposite = function getOpposite(w, h) {
        return [0, h];
      };
      break;
    case "middleRight":
      isHorizontal = true;
      getPoint = function getPoint(w, h) {
        return [w, h / 2];
      };
      getOpposite = function getOpposite(w, h) {
        return [0, h / 2];
      };
      break;
    case "bottomRight":
      isDiagonal = true;
      getPoint = function getPoint(w, h) {
        return [w, h];
      };
      getOpposite = function getOpposite(w, h) {
        return [0, 0];
      };
      break;
    case "bottomMiddle":
      getPoint = function getPoint(w, h) {
        return [w / 2, h];
      };
      getOpposite = function getOpposite(w, h) {
        return [w / 2, 0];
      };
      break;
    case "bottomLeft":
      isDiagonal = true;
      getPoint = function getPoint(w, h) {
        return [0, h];
      };
      getOpposite = function getOpposite(w, h) {
        return [w, 0];
      };
      break;
    case "middleLeft":
      isHorizontal = true;
      getPoint = function getPoint(w, h) {
        return [0, h / 2];
      };
      getOpposite = function getOpposite(w, h) {
        return [w, h / 2];
      };
      break;
  }
  var point = getPoint(savedWidth, savedHeight);
  var oppositePoint = getOpposite(savedWidth, savedHeight);
  var transfOppositePoint = transf.apply(void 0, editor_toConsumableArray(oppositePoint));
  var oppositeX = _AnnotationEditor._round(savedX + transfOppositePoint[0]);
  var oppositeY = _AnnotationEditor._round(savedY + transfOppositePoint[1]);
  var ratioX = 1;
  var ratioY = 1;
  var deltaX, deltaY;
  if (!event.fromKeyboard) {
    var screenX = event.screenX,
      screenY = event.screenY;
    var _classPrivateFieldGet18 = editor_classPrivateFieldGet(_lastPointerCoords, this),
      _classPrivateFieldGet19 = editor_slicedToArray(_classPrivateFieldGet18, 2),
      lastScreenX = _classPrivateFieldGet19[0],
      lastScreenY = _classPrivateFieldGet19[1];
    var _this$screenToPageTra5 = this.screenToPageTranslation(screenX - lastScreenX, screenY - lastScreenY);
    var _this$screenToPageTra6 = editor_slicedToArray(_this$screenToPageTra5, 2);
    deltaX = _this$screenToPageTra6[0];
    deltaY = _this$screenToPageTra6[1];
    editor_classPrivateFieldGet(_lastPointerCoords, this)[0] = screenX;
    editor_classPrivateFieldGet(_lastPointerCoords, this)[1] = screenY;
  } else {
    deltaX = event.deltaX;
    deltaY = event.deltaY;
  }
  var _invTransf = invTransf(deltaX / parentWidth, deltaY / parentHeight);
  var _invTransf2 = editor_slicedToArray(_invTransf, 2);
  deltaX = _invTransf2[0];
  deltaY = _invTransf2[1];
  if (isDiagonal) {
    var oldDiag = Math.hypot(savedWidth, savedHeight);
    ratioX = ratioY = Math.max(Math.min(Math.hypot(oppositePoint[0] - point[0] - deltaX, oppositePoint[1] - point[1] - deltaY) / oldDiag, 1 / savedWidth, 1 / savedHeight), minWidth / savedWidth, minHeight / savedHeight);
  } else if (isHorizontal) {
    ratioX = Math.max(minWidth, Math.min(1, Math.abs(oppositePoint[0] - point[0] - deltaX))) / savedWidth;
  } else {
    ratioY = Math.max(minHeight, Math.min(1, Math.abs(oppositePoint[1] - point[1] - deltaY))) / savedHeight;
  }
  var newWidth = _AnnotationEditor._round(savedWidth * ratioX);
  var newHeight = _AnnotationEditor._round(savedHeight * ratioY);
  transfOppositePoint = transf.apply(void 0, editor_toConsumableArray(getOpposite(newWidth, newHeight)));
  var newX = oppositeX - transfOppositePoint[0];
  var newY = oppositeY - transfOppositePoint[1];
  editor_classPrivateFieldGet(_initialRect, this) || editor_classPrivateFieldSet(_initialRect, this, [this.x, this.y, this.width, this.height]);
  this.width = newWidth;
  this.height = newHeight;
  this.x = newX;
  this.y = newY;
  this.setDims(parentWidth * newWidth, parentHeight * newHeight);
  this.fixAndSetPosition();
  this._onResizing();
}
function _touchPinchStartCallback() {
  var _classPrivateFieldGet20;
  editor_classPrivateFieldSet(_savedDimensions, this, {
    savedX: this.x,
    savedY: this.y,
    savedWidth: this.width,
    savedHeight: this.height
  });
  (_classPrivateFieldGet20 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet20 === void 0 || _classPrivateFieldGet20.toggle(false);
  this.parent.togglePointerEvents(false);
}
function _touchPinchCallback(_origin, prevDistance, distance) {
  var slowDownFactor = 0.7;
  var factor = slowDownFactor * (distance / prevDistance) + 1 - slowDownFactor;
  if (factor === 1) {
    return;
  }
  var rotationMatrix = editor_assertClassBrand(_AnnotationEditor_brand, this, _getRotationMatrix).call(this, this.rotation);
  var transf = function transf(x, y) {
    return [rotationMatrix[0] * x + rotationMatrix[2] * y, rotationMatrix[1] * x + rotationMatrix[3] * y];
  };
  var _this$parentDimension10 = editor_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension10[0],
    parentHeight = _this$parentDimension10[1];
  var savedX = this.x;
  var savedY = this.y;
  var savedWidth = this.width;
  var savedHeight = this.height;
  var minWidth = _AnnotationEditor.MIN_SIZE / parentWidth;
  var minHeight = _AnnotationEditor.MIN_SIZE / parentHeight;
  factor = Math.max(Math.min(factor, 1 / savedWidth, 1 / savedHeight), minWidth / savedWidth, minHeight / savedHeight);
  var newWidth = _AnnotationEditor._round(savedWidth * factor);
  var newHeight = _AnnotationEditor._round(savedHeight * factor);
  if (newWidth === savedWidth && newHeight === savedHeight) {
    return;
  }
  editor_classPrivateFieldGet(_initialRect, this) || editor_classPrivateFieldSet(_initialRect, this, [savedX, savedY, savedWidth, savedHeight]);
  var transfCenterPoint = transf(savedWidth / 2, savedHeight / 2);
  var centerX = _AnnotationEditor._round(savedX + transfCenterPoint[0]);
  var centerY = _AnnotationEditor._round(savedY + transfCenterPoint[1]);
  var newTransfCenterPoint = transf(newWidth / 2, newHeight / 2);
  this.x = centerX - newTransfCenterPoint[0];
  this.y = centerY - newTransfCenterPoint[1];
  this.width = newWidth;
  this.height = newHeight;
  this.setDims(parentWidth * newWidth, parentHeight * newHeight);
  this.fixAndSetPosition();
  this._onResizing();
}
function _touchPinchEndCallback() {
  var _classPrivateFieldGet21;
  (_classPrivateFieldGet21 = editor_classPrivateFieldGet(editor_altText, this)) === null || _classPrivateFieldGet21 === void 0 || _classPrivateFieldGet21.toggle(true);
  this.parent.togglePointerEvents(true);
  editor_assertClassBrand(_AnnotationEditor_brand, this, _addResizeToUndoStack).call(this);
}
function _selectOnPointerEvent(event) {
  var isMac = util_FeatureTest.platform.isMac;
  if (event.ctrlKey && !isMac || event.shiftKey || event.metaKey && isMac) {
    this.parent.toggleSelected(this);
  } else {
    this.parent.setSelected(this);
  }
}
function _setUpDragSession(event) {
  var _this7 = this;
  var isSelected = this.isSelected;
  this._uiManager.setUpDragSession();
  var hasDraggingStarted = false;
  var ac = new AbortController();
  var signal = this._uiManager.combinedSignal(ac);
  var opts = {
    capture: true,
    passive: false,
    signal: signal
  };
  var cancelDrag = function cancelDrag(e) {
    ac.abort();
    editor_classPrivateFieldSet(_dragPointerId, _this7, null);
    editor_classPrivateFieldSet(_hasBeenClicked, _this7, false);
    if (!_this7._uiManager.endDragSession()) {
      editor_assertClassBrand(_AnnotationEditor_brand, _this7, _selectOnPointerEvent).call(_this7, e);
    }
    if (hasDraggingStarted) {
      _this7._onStopDragging();
    }
  };
  if (isSelected) {
    editor_classPrivateFieldSet(_prevDragX, this, event.clientX);
    editor_classPrivateFieldSet(_prevDragY, this, event.clientY);
    editor_classPrivateFieldSet(_dragPointerId, this, event.pointerId);
    editor_classPrivateFieldSet(_dragPointerType, this, event.pointerType);
    window.addEventListener("pointermove", function (e) {
      if (!hasDraggingStarted) {
        hasDraggingStarted = true;
        _this7._onStartDragging();
      }
      var x = e.clientX,
        y = e.clientY,
        pointerId = e.pointerId;
      if (pointerId !== editor_classPrivateFieldGet(_dragPointerId, _this7)) {
        stopEvent(e);
        return;
      }
      var _this7$screenToPageTr = _this7.screenToPageTranslation(x - editor_classPrivateFieldGet(_prevDragX, _this7), y - editor_classPrivateFieldGet(_prevDragY, _this7)),
        _this7$screenToPageTr2 = editor_slicedToArray(_this7$screenToPageTr, 2),
        tx = _this7$screenToPageTr2[0],
        ty = _this7$screenToPageTr2[1];
      editor_classPrivateFieldSet(_prevDragX, _this7, x);
      editor_classPrivateFieldSet(_prevDragY, _this7, y);
      _this7._uiManager.dragSelectedEditors(tx, ty);
    }, opts);
    window.addEventListener("touchmove", stopEvent, opts);
    window.addEventListener("pointerdown", function (e) {
      if (e.pointerType === editor_classPrivateFieldGet(_dragPointerType, _this7)) {
        if (editor_classPrivateFieldGet(_touchManager, _this7) || e.isPrimary) {
          cancelDrag(e);
        }
      }
      stopEvent(e);
    }, opts);
  }
  var pointerUpCallback = function pointerUpCallback(e) {
    if (!editor_classPrivateFieldGet(_dragPointerId, _this7) || editor_classPrivateFieldGet(_dragPointerId, _this7) === e.pointerId) {
      cancelDrag(e);
      return;
    }
    stopEvent(e);
  };
  window.addEventListener("pointerup", pointerUpCallback, {
    signal: signal
  });
  window.addEventListener("blur", pointerUpCallback, {
    signal: signal
  });
}
function _addFocusListeners() {
  if (editor_classPrivateFieldGet(_focusAC, this) || !this.div) {
    return;
  }
  editor_classPrivateFieldSet(_focusAC, this, new AbortController());
  var signal = this._uiManager.combinedSignal(editor_classPrivateFieldGet(_focusAC, this));
  this.div.addEventListener("focusin", this.focusin.bind(this), {
    signal: signal
  });
  this.div.addEventListener("focusout", this.focusout.bind(this), {
    signal: signal
  });
}
function _resizerKeydown(event) {
  _AnnotationEditor._resizerKeyboardManager.exec(this, event);
}
function _resizerBlur(event) {
  var _event$relatedTarget;
  if (editor_classPrivateFieldGet(_isResizerEnabledForKeyboard, this) && ((_event$relatedTarget = event.relatedTarget) === null || _event$relatedTarget === void 0 ? void 0 : _event$relatedTarget.parentNode) !== editor_classPrivateFieldGet(_resizersDiv, this)) {
    editor_assertClassBrand(_AnnotationEditor_brand, this, _stopResizing).call(this);
  }
}
function _resizerFocus(name) {
  editor_classPrivateFieldSet(_focusedResizerName, this, editor_classPrivateFieldGet(_isResizerEnabledForKeyboard, this) ? name : "");
}
function _setResizerTabIndex(value) {
  if (!editor_classPrivateFieldGet(_allResizerDivs, this)) {
    return;
  }
  var _iterator5 = editor_createForOfIteratorHelper(editor_classPrivateFieldGet(_allResizerDivs, this)),
    _step5;
  try {
    for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
      var div = _step5.value;
      div.tabIndex = value;
    }
  } catch (err) {
    _iterator5.e(err);
  } finally {
    _iterator5.f();
  }
}
function _stopResizing() {
  editor_classPrivateFieldSet(_isResizerEnabledForKeyboard, this, false);
  editor_assertClassBrand(_AnnotationEditor_brand, this, _setResizerTabIndex).call(this, -1);
  editor_assertClassBrand(_AnnotationEditor_brand, this, _addResizeToUndoStack).call(this);
}
editor_defineProperty(AnnotationEditor, "_l10n", null);
editor_defineProperty(AnnotationEditor, "_l10nResizer", null);
editor_defineProperty(AnnotationEditor, "_borderLineWidth", -1);
editor_defineProperty(AnnotationEditor, "_colorManager", new ColorManager());
editor_defineProperty(AnnotationEditor, "_zIndex", 1);
editor_defineProperty(AnnotationEditor, "_telemetryTimeout", 1000);
var FakeEditor = /*#__PURE__*/function (_AnnotationEditor2) {
  function FakeEditor(params) {
    var _this5;
    editor_classCallCheck(this, FakeEditor);
    _this5 = editor_callSuper(this, FakeEditor, [params]);
    _this5.annotationElementId = params.annotationElementId;
    _this5.deleted = true;
    return _this5;
  }
  editor_inherits(FakeEditor, _AnnotationEditor2);
  return editor_createClass(FakeEditor, [{
    key: "serialize",
    value: function serialize() {
      return this.serializeDeleted();
    }
  }]);
}(AnnotationEditor);

;// ./src/shared/murmurhash3.js
function murmurhash3_typeof(o) { "@babel/helpers - typeof"; return murmurhash3_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, murmurhash3_typeof(o); }





















































function murmurhash3_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function murmurhash3_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, murmurhash3_toPropertyKey(o.key), o); } }
function murmurhash3_createClass(e, r, t) { return r && murmurhash3_defineProperties(e.prototype, r), t && murmurhash3_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function murmurhash3_toPropertyKey(t) { var i = murmurhash3_toPrimitive(t, "string"); return "symbol" == murmurhash3_typeof(i) ? i : i + ""; }
function murmurhash3_toPrimitive(t, r) { if ("object" != murmurhash3_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != murmurhash3_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var SEED = 0xc3d2e1f0;
var MASK_HIGH = 0xffff0000;
var MASK_LOW = 0xffff;
var MurmurHash3_64 = /*#__PURE__*/function () {
  function MurmurHash3_64(seed) {
    murmurhash3_classCallCheck(this, MurmurHash3_64);
    this.h1 = seed ? seed & 0xffffffff : SEED;
    this.h2 = seed ? seed & 0xffffffff : SEED;
  }
  return murmurhash3_createClass(MurmurHash3_64, [{
    key: "update",
    value: function update(input) {
      var data, length;
      if (typeof input === "string") {
        data = new Uint8Array(input.length * 2);
        length = 0;
        for (var i = 0, ii = input.length; i < ii; i++) {
          var code = input.charCodeAt(i);
          if (code <= 0xff) {
            data[length++] = code;
          } else {
            data[length++] = code >>> 8;
            data[length++] = code & 0xff;
          }
        }
      } else if (ArrayBuffer.isView(input)) {
        data = input.slice();
        length = data.byteLength;
      } else {
        throw new Error("Invalid data format, must be a string or TypedArray.");
      }
      var blockCounts = length >> 2;
      var tailLength = length - blockCounts * 4;
      var dataUint32 = new Uint32Array(data.buffer, 0, blockCounts);
      var k1 = 0,
        k2 = 0;
      var h1 = this.h1,
        h2 = this.h2;
      var C1 = 0xcc9e2d51,
        C2 = 0x1b873593;
      var C1_LOW = C1 & MASK_LOW,
        C2_LOW = C2 & MASK_LOW;
      for (var _i = 0; _i < blockCounts; _i++) {
        if (_i & 1) {
          k1 = dataUint32[_i];
          k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
          k1 = k1 << 15 | k1 >>> 17;
          k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;
          h1 ^= k1;
          h1 = h1 << 13 | h1 >>> 19;
          h1 = h1 * 5 + 0xe6546b64;
        } else {
          k2 = dataUint32[_i];
          k2 = k2 * C1 & MASK_HIGH | k2 * C1_LOW & MASK_LOW;
          k2 = k2 << 15 | k2 >>> 17;
          k2 = k2 * C2 & MASK_HIGH | k2 * C2_LOW & MASK_LOW;
          h2 ^= k2;
          h2 = h2 << 13 | h2 >>> 19;
          h2 = h2 * 5 + 0xe6546b64;
        }
      }
      k1 = 0;
      switch (tailLength) {
        case 3:
          k1 ^= data[blockCounts * 4 + 2] << 16;
        case 2:
          k1 ^= data[blockCounts * 4 + 1] << 8;
        case 1:
          k1 ^= data[blockCounts * 4];
          k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
          k1 = k1 << 15 | k1 >>> 17;
          k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;
          if (blockCounts & 1) {
            h1 ^= k1;
          } else {
            h2 ^= k1;
          }
      }
      this.h1 = h1;
      this.h2 = h2;
    }
  }, {
    key: "hexdigest",
    value: function hexdigest() {
      var h1 = this.h1,
        h2 = this.h2;
      h1 ^= h2 >>> 1;
      h1 = h1 * 0xed558ccd & MASK_HIGH | h1 * 0x8ccd & MASK_LOW;
      h2 = h2 * 0xff51afd7 & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xafd7ed55 & MASK_HIGH) >>> 16;
      h1 ^= h2 >>> 1;
      h1 = h1 * 0x1a85ec53 & MASK_HIGH | h1 * 0xec53 & MASK_LOW;
      h2 = h2 * 0xc4ceb9fe & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xb9fe1a85 & MASK_HIGH) >>> 16;
      h1 ^= h2 >>> 1;
      return (h1 >>> 0).toString(16).padStart(8, "0") + (h2 >>> 0).toString(16).padStart(8, "0");
    }
  }]);
}();

;// ./src/display/annotation_storage.js
function annotation_storage_typeof(o) { "@babel/helpers - typeof"; return annotation_storage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, annotation_storage_typeof(o); }
function annotation_storage_callSuper(t, o, e) { return o = annotation_storage_getPrototypeOf(o), annotation_storage_possibleConstructorReturn(t, annotation_storage_isNativeReflectConstruct() ? Reflect.construct(o, e || [], annotation_storage_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function annotation_storage_possibleConstructorReturn(t, e) { if (e && ("object" == annotation_storage_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return annotation_storage_assertThisInitialized(t); }
function annotation_storage_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function annotation_storage_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (annotation_storage_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function annotation_storage_getPrototypeOf(t) { return annotation_storage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, annotation_storage_getPrototypeOf(t); }
function annotation_storage_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && annotation_storage_setPrototypeOf(t, e); }
function annotation_storage_setPrototypeOf(t, e) { return annotation_storage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, annotation_storage_setPrototypeOf(t, e); }
function annotation_storage_slicedToArray(r, e) { return annotation_storage_arrayWithHoles(r) || annotation_storage_iterableToArrayLimit(r, e) || annotation_storage_unsupportedIterableToArray(r, e) || annotation_storage_nonIterableRest(); }
function annotation_storage_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function annotation_storage_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function annotation_storage_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function annotation_storage_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = annotation_storage_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function annotation_storage_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return annotation_storage_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? annotation_storage_arrayLikeToArray(r, a) : void 0; } }
function annotation_storage_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function annotation_storage_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function annotation_storage_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, annotation_storage_toPropertyKey(o.key), o); } }
function annotation_storage_createClass(e, r, t) { return r && annotation_storage_defineProperties(e.prototype, r), t && annotation_storage_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function annotation_storage_toPropertyKey(t) { var i = annotation_storage_toPrimitive(t, "string"); return "symbol" == annotation_storage_typeof(i) ? i : i + ""; }
function annotation_storage_toPrimitive(t, r) { if ("object" != annotation_storage_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != annotation_storage_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function annotation_storage_classPrivateMethodInitSpec(e, a) { annotation_storage_checkPrivateRedeclaration(e, a), a.add(e); }
function annotation_storage_classPrivateFieldInitSpec(e, t, a) { annotation_storage_checkPrivateRedeclaration(e, t), t.set(e, a); }
function annotation_storage_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function annotation_storage_classPrivateFieldSet(s, a, r) { return s.set(annotation_storage_assertClassBrand(s, a), r), r; }
function annotation_storage_classPrivateFieldGet(s, a) { return s.get(annotation_storage_assertClassBrand(s, a)); }
function annotation_storage_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
















































var SerializableEmpty = Object.freeze({
  map: null,
  hash: "",
  transfer: undefined
});
var _modified = /*#__PURE__*/new WeakMap();
var _modifiedIds = /*#__PURE__*/new WeakMap();
var _storage = /*#__PURE__*/new WeakMap();
var _AnnotationStorage_brand = /*#__PURE__*/new WeakSet();
var AnnotationStorage = /*#__PURE__*/function () {
  function AnnotationStorage() {
    annotation_storage_classCallCheck(this, AnnotationStorage);
    annotation_storage_classPrivateMethodInitSpec(this, _AnnotationStorage_brand);
    annotation_storage_classPrivateFieldInitSpec(this, _modified, false);
    annotation_storage_classPrivateFieldInitSpec(this, _modifiedIds, null);
    annotation_storage_classPrivateFieldInitSpec(this, _storage, new Map());
    this.onSetModified = null;
    this.onResetModified = null;
    this.onAnnotationEditor = null;
  }
  return annotation_storage_createClass(AnnotationStorage, [{
    key: "getValue",
    value: function getValue(key, defaultValue) {
      var value = annotation_storage_classPrivateFieldGet(_storage, this).get(key);
      if (value === undefined) {
        return defaultValue;
      }
      return Object.assign(defaultValue, value);
    }
  }, {
    key: "getRawValue",
    value: function getRawValue(key) {
      return annotation_storage_classPrivateFieldGet(_storage, this).get(key);
    }
  }, {
    key: "remove",
    value: function remove(key) {
      annotation_storage_classPrivateFieldGet(_storage, this).delete(key);
      if (annotation_storage_classPrivateFieldGet(_storage, this).size === 0) {
        this.resetModified();
      }
      if (typeof this.onAnnotationEditor === "function") {
        var _iterator = annotation_storage_createForOfIteratorHelper(annotation_storage_classPrivateFieldGet(_storage, this).values()),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var value = _step.value;
            if (value instanceof AnnotationEditor) {
              return;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        this.onAnnotationEditor(null);
      }
    }
  }, {
    key: "setValue",
    value: function setValue(key, value) {
      var obj = annotation_storage_classPrivateFieldGet(_storage, this).get(key);
      var modified = false;
      if (obj !== undefined) {
        for (var _i = 0, _Object$entries = Object.entries(value); _i < _Object$entries.length; _i++) {
          var _Object$entries$_i = annotation_storage_slicedToArray(_Object$entries[_i], 2),
            entry = _Object$entries$_i[0],
            val = _Object$entries$_i[1];
          if (obj[entry] !== val) {
            modified = true;
            obj[entry] = val;
          }
        }
      } else {
        modified = true;
        annotation_storage_classPrivateFieldGet(_storage, this).set(key, value);
      }
      if (modified) {
        annotation_storage_assertClassBrand(_AnnotationStorage_brand, this, _setModified).call(this);
      }
      if (value instanceof AnnotationEditor && typeof this.onAnnotationEditor === "function") {
        this.onAnnotationEditor(value.constructor._type);
      }
    }
  }, {
    key: "has",
    value: function has(key) {
      return annotation_storage_classPrivateFieldGet(_storage, this).has(key);
    }
  }, {
    key: "getAll",
    value: function getAll() {
      return annotation_storage_classPrivateFieldGet(_storage, this).size > 0 ? objectFromMap(annotation_storage_classPrivateFieldGet(_storage, this)) : null;
    }
  }, {
    key: "setAll",
    value: function setAll(obj) {
      for (var _i2 = 0, _Object$entries2 = Object.entries(obj); _i2 < _Object$entries2.length; _i2++) {
        var _Object$entries2$_i = annotation_storage_slicedToArray(_Object$entries2[_i2], 2),
          key = _Object$entries2$_i[0],
          val = _Object$entries2$_i[1];
        this.setValue(key, val);
      }
    }
  }, {
    key: "size",
    get: function get() {
      return annotation_storage_classPrivateFieldGet(_storage, this).size;
    }
  }, {
    key: "resetModified",
    value: function resetModified() {
      if (annotation_storage_classPrivateFieldGet(_modified, this)) {
        annotation_storage_classPrivateFieldSet(_modified, this, false);
        if (typeof this.onResetModified === "function") {
          this.onResetModified();
        }
      }
    }
  }, {
    key: "print",
    get: function get() {
      return new PrintAnnotationStorage(this);
    }
  }, {
    key: "serializable",
    get: function get() {
      if (annotation_storage_classPrivateFieldGet(_storage, this).size === 0) {
        return SerializableEmpty;
      }
      var map = new Map(),
        hash = new MurmurHash3_64(),
        transfer = [];
      var context = Object.create(null);
      var hasBitmap = false;
      var _iterator2 = annotation_storage_createForOfIteratorHelper(annotation_storage_classPrivateFieldGet(_storage, this)),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = annotation_storage_slicedToArray(_step2.value, 2),
            key = _step2$value[0],
            val = _step2$value[1];
          var serialized = val instanceof AnnotationEditor ? val.serialize(false, context) : val;
          if (serialized) {
            map.set(key, serialized);
            hash.update("".concat(key, ":").concat(JSON.stringify(serialized)));
            hasBitmap || (hasBitmap = !!serialized.bitmap);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      if (hasBitmap) {
        var _iterator3 = annotation_storage_createForOfIteratorHelper(map.values()),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var value = _step3.value;
            if (value.bitmap) {
              transfer.push(value.bitmap);
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }
      return map.size > 0 ? {
        map: map,
        hash: hash.hexdigest(),
        transfer: transfer
      } : SerializableEmpty;
    }
  }, {
    key: "editorStats",
    get: function get() {
      var stats = null;
      var typeToEditor = new Map();
      var _iterator4 = annotation_storage_createForOfIteratorHelper(annotation_storage_classPrivateFieldGet(_storage, this).values()),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var _stats;
          var value = _step4.value;
          if (!(value instanceof AnnotationEditor)) {
            continue;
          }
          var editorStats = value.telemetryFinalData;
          if (!editorStats) {
            continue;
          }
          var type = editorStats.type;
          if (!typeToEditor.has(type)) {
            typeToEditor.set(type, Object.getPrototypeOf(value).constructor);
          }
          stats || (stats = Object.create(null));
          var map = (_stats = stats)[type] || (_stats[type] = new Map());
          for (var _i3 = 0, _Object$entries3 = Object.entries(editorStats); _i3 < _Object$entries3.length; _i3++) {
            var _counters$get;
            var _Object$entries3$_i = annotation_storage_slicedToArray(_Object$entries3[_i3], 2),
              key = _Object$entries3$_i[0],
              val = _Object$entries3$_i[1];
            if (key === "type") {
              continue;
            }
            var counters = map.get(key);
            if (!counters) {
              counters = new Map();
              map.set(key, counters);
            }
            var count = (_counters$get = counters.get(val)) !== null && _counters$get !== void 0 ? _counters$get : 0;
            counters.set(val, count + 1);
          }
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      var _iterator5 = annotation_storage_createForOfIteratorHelper(typeToEditor),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var _step5$value = annotation_storage_slicedToArray(_step5.value, 2),
            _type = _step5$value[0],
            editor = _step5$value[1];
          stats[_type] = editor.computeTelemetryFinalData(stats[_type]);
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      return stats;
    }
  }, {
    key: "resetModifiedIds",
    value: function resetModifiedIds() {
      annotation_storage_classPrivateFieldSet(_modifiedIds, this, null);
    }
  }, {
    key: "modifiedIds",
    get: function get() {
      if (annotation_storage_classPrivateFieldGet(_modifiedIds, this)) {
        return annotation_storage_classPrivateFieldGet(_modifiedIds, this);
      }
      var ids = [];
      var _iterator6 = annotation_storage_createForOfIteratorHelper(annotation_storage_classPrivateFieldGet(_storage, this).values()),
        _step6;
      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var value = _step6.value;
          if (!(value instanceof AnnotationEditor) || !value.annotationElementId || !value.serialize()) {
            continue;
          }
          ids.push(value.annotationElementId);
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }
      return annotation_storage_classPrivateFieldSet(_modifiedIds, this, {
        ids: new Set(ids),
        hash: ids.join(",")
      });
    }
  }]);
}();
function _setModified() {
  if (!annotation_storage_classPrivateFieldGet(_modified, this)) {
    annotation_storage_classPrivateFieldSet(_modified, this, true);
    if (typeof this.onSetModified === "function") {
      this.onSetModified();
    }
  }
}
var _serializable = /*#__PURE__*/new WeakMap();
var PrintAnnotationStorage = /*#__PURE__*/function (_AnnotationStorage2) {
  function PrintAnnotationStorage(parent) {
    var _this;
    annotation_storage_classCallCheck(this, PrintAnnotationStorage);
    _this = annotation_storage_callSuper(this, PrintAnnotationStorage);
    annotation_storage_classPrivateFieldInitSpec(_this, _serializable, void 0);
    var _parent$serializable = parent.serializable,
      map = _parent$serializable.map,
      hash = _parent$serializable.hash,
      transfer = _parent$serializable.transfer;
    var clone = structuredClone(map, transfer ? {
      transfer: transfer
    } : null);
    annotation_storage_classPrivateFieldSet(_serializable, _this, {
      map: clone,
      hash: hash,
      transfer: transfer
    });
    return _this;
  }
  annotation_storage_inherits(PrintAnnotationStorage, _AnnotationStorage2);
  return annotation_storage_createClass(PrintAnnotationStorage, [{
    key: "print",
    get: function get() {
      unreachable("Should not call PrintAnnotationStorage.print");
    }
  }, {
    key: "serializable",
    get: function get() {
      return annotation_storage_classPrivateFieldGet(_serializable, this);
    }
  }, {
    key: "modifiedIds",
    get: function get() {
      return shadow(this, "modifiedIds", {
        ids: new Set(),
        hash: ""
      });
    }
  }]);
}(AnnotationStorage);

;// ./src/display/font_loader.js
function font_loader_typeof(o) { "@babel/helpers - typeof"; return font_loader_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, font_loader_typeof(o); }
function font_loader_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ font_loader_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == font_loader_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(font_loader_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function font_loader_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function font_loader_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { font_loader_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { font_loader_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function font_loader_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = font_loader_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function font_loader_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return font_loader_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? font_loader_arrayLikeToArray(r, a) : void 0; } }
function font_loader_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }













































function font_loader_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function font_loader_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, font_loader_toPropertyKey(o.key), o); } }
function font_loader_createClass(e, r, t) { return r && font_loader_defineProperties(e.prototype, r), t && font_loader_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function font_loader_toPropertyKey(t) { var i = font_loader_toPrimitive(t, "string"); return "symbol" == font_loader_typeof(i) ? i : i + ""; }
function font_loader_toPrimitive(t, r) { if ("object" != font_loader_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != font_loader_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function font_loader_classPrivateFieldInitSpec(e, t, a) { font_loader_checkPrivateRedeclaration(e, t), t.set(e, a); }
function font_loader_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function font_loader_classPrivateFieldGet(s, a) { return s.get(font_loader_assertClassBrand(s, a)); }
function font_loader_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }

var _systemFonts = /*#__PURE__*/new WeakMap();
var FontLoader = /*#__PURE__*/function () {
  function FontLoader(_ref) {
    var _ref$ownerDocument = _ref.ownerDocument,
      ownerDocument = _ref$ownerDocument === void 0 ? globalThis.document : _ref$ownerDocument,
      _ref$styleElement = _ref.styleElement,
      styleElement = _ref$styleElement === void 0 ? null : _ref$styleElement;
    font_loader_classCallCheck(this, FontLoader);
    font_loader_classPrivateFieldInitSpec(this, _systemFonts, new Set());
    this._document = ownerDocument;
    this.nativeFontFaces = new Set();
    this.styleElement = null;
    this.loadingRequests = [];
    this.loadTestFontId = 0;
  }
  return font_loader_createClass(FontLoader, [{
    key: "addNativeFontFace",
    value: function addNativeFontFace(nativeFontFace) {
      this.nativeFontFaces.add(nativeFontFace);
      this._document.fonts.add(nativeFontFace);
    }
  }, {
    key: "removeNativeFontFace",
    value: function removeNativeFontFace(nativeFontFace) {
      this.nativeFontFaces.delete(nativeFontFace);
      this._document.fonts.delete(nativeFontFace);
    }
  }, {
    key: "insertRule",
    value: function insertRule(rule) {
      if (!this.styleElement) {
        this.styleElement = this._document.createElement("style");
        this._document.documentElement.getElementsByTagName("head")[0].append(this.styleElement);
      }
      var styleSheet = this.styleElement.sheet;
      styleSheet.insertRule(rule, styleSheet.cssRules.length);
    }
  }, {
    key: "clear",
    value: function clear() {
      var _iterator = font_loader_createForOfIteratorHelper(this.nativeFontFaces),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var nativeFontFace = _step.value;
          this._document.fonts.delete(nativeFontFace);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      this.nativeFontFaces.clear();
      font_loader_classPrivateFieldGet(_systemFonts, this).clear();
      if (this.styleElement) {
        this.styleElement.remove();
        this.styleElement = null;
      }
    }
  }, {
    key: "loadSystemFont",
    value: function () {
      var _loadSystemFont = font_loader_asyncToGenerator(/*#__PURE__*/font_loader_regeneratorRuntime().mark(function _callee(_ref2) {
        var info, _inspectFont, loadedName, src, style, fontFace;
        return font_loader_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              info = _ref2.systemFontInfo, _inspectFont = _ref2._inspectFont;
              if (!(!info || font_loader_classPrivateFieldGet(_systemFonts, this).has(info.loadedName))) {
                _context.next = 3;
                break;
              }
              return _context.abrupt("return");
            case 3:
              assert(!this.disableFontFace, "loadSystemFont shouldn't be called when `disableFontFace` is set.");
              if (!this.isFontLoadingAPISupported) {
                _context.next = 20;
                break;
              }
              loadedName = info.loadedName, src = info.src, style = info.style;
              fontFace = new FontFace(loadedName, src, style);
              this.addNativeFontFace(fontFace);
              _context.prev = 8;
              _context.next = 11;
              return fontFace.load();
            case 11:
              font_loader_classPrivateFieldGet(_systemFonts, this).add(loadedName);
              _inspectFont === null || _inspectFont === void 0 || _inspectFont(info);
              _context.next = 19;
              break;
            case 15:
              _context.prev = 15;
              _context.t0 = _context["catch"](8);
              warn("Cannot load system font: ".concat(info.baseFontName, ", installing it could help to improve PDF rendering."));
              this.removeNativeFontFace(fontFace);
            case 19:
              return _context.abrupt("return");
            case 20:
              unreachable("Not implemented: loadSystemFont without the Font Loading API.");
            case 21:
            case "end":
              return _context.stop();
          }
        }, _callee, this, [[8, 15]]);
      }));
      function loadSystemFont(_x) {
        return _loadSystemFont.apply(this, arguments);
      }
      return loadSystemFont;
    }()
  }, {
    key: "bind",
    value: function () {
      var _bind = font_loader_asyncToGenerator(/*#__PURE__*/font_loader_regeneratorRuntime().mark(function _callee2(font) {
        var _this = this;
        var nativeFontFace, rule;
        return font_loader_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!(font.attached || font.missingFile && !font.systemFontInfo)) {
                _context2.next = 2;
                break;
              }
              return _context2.abrupt("return");
            case 2:
              font.attached = true;
              if (!font.systemFontInfo) {
                _context2.next = 7;
                break;
              }
              _context2.next = 6;
              return this.loadSystemFont(font);
            case 6:
              return _context2.abrupt("return");
            case 7:
              if (!this.isFontLoadingAPISupported) {
                _context2.next = 22;
                break;
              }
              nativeFontFace = font.createNativeFontFace();
              if (!nativeFontFace) {
                _context2.next = 21;
                break;
              }
              this.addNativeFontFace(nativeFontFace);
              _context2.prev = 11;
              _context2.next = 14;
              return nativeFontFace.loaded;
            case 14:
              _context2.next = 21;
              break;
            case 16:
              _context2.prev = 16;
              _context2.t0 = _context2["catch"](11);
              warn("Failed to load font '".concat(nativeFontFace.family, "': '").concat(_context2.t0, "'."));
              font.disableFontFace = true;
              throw _context2.t0;
            case 21:
              return _context2.abrupt("return");
            case 22:
              rule = font.createFontFaceRule();
              if (!rule) {
                _context2.next = 29;
                break;
              }
              this.insertRule(rule);
              if (!this.isSyncFontLoadingSupported) {
                _context2.next = 27;
                break;
              }
              return _context2.abrupt("return");
            case 27:
              _context2.next = 29;
              return new Promise(function (resolve) {
                var request = _this._queueLoadingCallback(resolve);
                _this._prepareFontLoadEvent(font, request);
              });
            case 29:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this, [[11, 16]]);
      }));
      function bind(_x2) {
        return _bind.apply(this, arguments);
      }
      return bind;
    }()
  }, {
    key: "isFontLoadingAPISupported",
    get: function get() {
      var _this$_document;
      var hasFonts = !!((_this$_document = this._document) !== null && _this$_document !== void 0 && _this$_document.fonts);
      return shadow(this, "isFontLoadingAPISupported", hasFonts);
    }
  }, {
    key: "isSyncFontLoadingSupported",
    get: function get() {
      var _navigator;
      var supported = false;
      if (isNodeJS) {
        supported = true;
      } else if (typeof navigator !== "undefined" && typeof ((_navigator = navigator) === null || _navigator === void 0 ? void 0 : _navigator.userAgent) === "string" && /Mozilla\/5.0.*?rv:\d+.*? Gecko/.test(navigator.userAgent)) {
        supported = true;
      }
      return shadow(this, "isSyncFontLoadingSupported", supported);
    }
  }, {
    key: "_queueLoadingCallback",
    value: function _queueLoadingCallback(callback) {
      function completeRequest() {
        assert(!request.done, "completeRequest() cannot be called twice.");
        request.done = true;
        while (loadingRequests.length > 0 && loadingRequests[0].done) {
          var otherRequest = loadingRequests.shift();
          setTimeout(otherRequest.callback, 0);
        }
      }
      var loadingRequests = this.loadingRequests;
      var request = {
        done: false,
        complete: completeRequest,
        callback: callback
      };
      loadingRequests.push(request);
      return request;
    }
  }, {
    key: "_loadTestFont",
    get: function get() {
      var testFont = atob("T1RUTwALAIAAAwAwQ0ZGIDHtZg4AAAOYAAAAgUZGVE1lkzZwAAAEHAAAABxHREVGABQA" + "FQAABDgAAAAeT1MvMlYNYwkAAAEgAAAAYGNtYXABDQLUAAACNAAAAUJoZWFk/xVFDQAA" + "ALwAAAA2aGhlYQdkA+oAAAD0AAAAJGhtdHgD6AAAAAAEWAAAAAZtYXhwAAJQAAAAARgA" + "AAAGbmFtZVjmdH4AAAGAAAAAsXBvc3T/hgAzAAADeAAAACAAAQAAAAEAALZRFsRfDzz1" + "AAsD6AAAAADOBOTLAAAAAM4KHDwAAAAAA+gDIQAAAAgAAgAAAAAAAAABAAADIQAAAFoD" + "6AAAAAAD6AABAAAAAAAAAAAAAAAAAAAAAQAAUAAAAgAAAAQD6AH0AAUAAAKKArwAAACM" + "AooCvAAAAeAAMQECAAACAAYJAAAAAAAAAAAAAQAAAAAAAAAAAAAAAFBmRWQAwAAuAC4D" + "IP84AFoDIQAAAAAAAQAAAAAAAAAAACAAIAABAAAADgCuAAEAAAAAAAAAAQAAAAEAAAAA" + "AAEAAQAAAAEAAAAAAAIAAQAAAAEAAAAAAAMAAQAAAAEAAAAAAAQAAQAAAAEAAAAAAAUA" + "AQAAAAEAAAAAAAYAAQAAAAMAAQQJAAAAAgABAAMAAQQJAAEAAgABAAMAAQQJAAIAAgAB" + "AAMAAQQJAAMAAgABAAMAAQQJAAQAAgABAAMAAQQJAAUAAgABAAMAAQQJAAYAAgABWABY" + "AAAAAAAAAwAAAAMAAAAcAAEAAAAAADwAAwABAAAAHAAEACAAAAAEAAQAAQAAAC7//wAA" + "AC7////TAAEAAAAAAAABBgAAAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA" + "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAMAAAAAAAD/gwAyAAAAAQAAAAAAAAAAAAAAAAAA" + "AAABAAQEAAEBAQJYAAEBASH4DwD4GwHEAvgcA/gXBIwMAYuL+nz5tQXkD5j3CBLnEQAC" + "AQEBIVhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYWFhYAAABAQAADwACAQEEE/t3" + "Dov6fAH6fAT+fPp8+nwHDosMCvm1Cvm1DAz6fBQAAAAAAAABAAAAAMmJbzEAAAAAzgTj" + "FQAAAADOBOQpAAEAAAAAAAAADAAUAAQAAAABAAAAAgABAAAAAAAAAAAD6AAAAAAAAA==");
      return shadow(this, "_loadTestFont", testFont);
    }
  }, {
    key: "_prepareFontLoadEvent",
    value: function _prepareFontLoadEvent(font, request) {
      function int32(data, offset) {
        return data.charCodeAt(offset) << 24 | data.charCodeAt(offset + 1) << 16 | data.charCodeAt(offset + 2) << 8 | data.charCodeAt(offset + 3) & 0xff;
      }
      function spliceString(s, offset, remove, insert) {
        var chunk1 = s.substring(0, offset);
        var chunk2 = s.substring(offset + remove);
        return chunk1 + insert + chunk2;
      }
      var i, ii;
      var canvas = this._document.createElement("canvas");
      canvas.width = 1;
      canvas.height = 1;
      var ctx = canvas.getContext("2d");
      var called = 0;
      function isFontReady(name, callback) {
        if (++called > 30) {
          warn("Load test font never loaded.");
          callback();
          return;
        }
        ctx.font = "30px " + name;
        ctx.fillText(".", 0, 20);
        var imageData = ctx.getImageData(0, 0, 1, 1);
        if (imageData.data[3] > 0) {
          callback();
          return;
        }
        setTimeout(isFontReady.bind(null, name, callback));
      }
      var loadTestFontId = "lt".concat(Date.now()).concat(this.loadTestFontId++);
      var data = this._loadTestFont;
      var COMMENT_OFFSET = 976;
      data = spliceString(data, COMMENT_OFFSET, loadTestFontId.length, loadTestFontId);
      var CFF_CHECKSUM_OFFSET = 16;
      var XXXX_VALUE = 0x58585858;
      var checksum = int32(data, CFF_CHECKSUM_OFFSET);
      for (i = 0, ii = loadTestFontId.length - 3; i < ii; i += 4) {
        checksum = checksum - XXXX_VALUE + int32(loadTestFontId, i) | 0;
      }
      if (i < loadTestFontId.length) {
        checksum = checksum - XXXX_VALUE + int32(loadTestFontId + "XXX", i) | 0;
      }
      data = spliceString(data, CFF_CHECKSUM_OFFSET, 4, string32(checksum));
      var url = "url(data:font/opentype;base64,".concat(btoa(data), ");");
      var rule = "@font-face {font-family:\"".concat(loadTestFontId, "\";src:").concat(url, "}");
      this.insertRule(rule);
      var div = this._document.createElement("div");
      div.style.visibility = "hidden";
      div.style.width = div.style.height = "10px";
      div.style.position = "absolute";
      div.style.top = div.style.left = "0px";
      for (var _i = 0, _arr = [font.loadedName, loadTestFontId]; _i < _arr.length; _i++) {
        var name = _arr[_i];
        var span = this._document.createElement("span");
        span.textContent = "Hi";
        span.style.fontFamily = name;
        div.append(span);
      }
      this._document.body.append(div);
      isFontReady(loadTestFontId, function () {
        div.remove();
        request.complete();
      });
    }
  }]);
}();
var FontFaceObject = /*#__PURE__*/function () {
  function FontFaceObject(translatedData, _ref3) {
    var _ref3$disableFontFace = _ref3.disableFontFace,
      disableFontFace = _ref3$disableFontFace === void 0 ? false : _ref3$disableFontFace,
      _ref3$fontExtraProper = _ref3.fontExtraProperties,
      fontExtraProperties = _ref3$fontExtraProper === void 0 ? false : _ref3$fontExtraProper,
      _ref3$inspectFont = _ref3.inspectFont,
      inspectFont = _ref3$inspectFont === void 0 ? null : _ref3$inspectFont;
    font_loader_classCallCheck(this, FontFaceObject);
    this.compiledGlyphs = Object.create(null);
    for (var i in translatedData) {
      this[i] = translatedData[i];
    }
    this.disableFontFace = disableFontFace === true;
    this.fontExtraProperties = fontExtraProperties === true;
    this._inspectFont = inspectFont;
  }
  return font_loader_createClass(FontFaceObject, [{
    key: "createNativeFontFace",
    value: function createNativeFontFace() {
      var _this$_inspectFont;
      if (!this.data || this.disableFontFace) {
        return null;
      }
      var nativeFontFace;
      if (!this.cssFontInfo) {
        nativeFontFace = new FontFace(this.loadedName, this.data, {});
      } else {
        var css = {
          weight: this.cssFontInfo.fontWeight
        };
        if (this.cssFontInfo.italicAngle) {
          css.style = "oblique ".concat(this.cssFontInfo.italicAngle, "deg");
        }
        nativeFontFace = new FontFace(this.cssFontInfo.fontFamily, this.data, css);
      }
      (_this$_inspectFont = this._inspectFont) === null || _this$_inspectFont === void 0 || _this$_inspectFont.call(this, this);
      return nativeFontFace;
    }
  }, {
    key: "createFontFaceRule",
    value: function createFontFaceRule() {
      var _this$_inspectFont2;
      if (!this.data || this.disableFontFace) {
        return null;
      }
      var url = "url(data:".concat(this.mimetype, ";base64,").concat(toBase64Util(this.data), ");");
      var rule;
      if (!this.cssFontInfo) {
        rule = "@font-face {font-family:\"".concat(this.loadedName, "\";src:").concat(url, "}");
      } else {
        var css = "font-weight: ".concat(this.cssFontInfo.fontWeight, ";");
        if (this.cssFontInfo.italicAngle) {
          css += "font-style: oblique ".concat(this.cssFontInfo.italicAngle, "deg;");
        }
        rule = "@font-face {font-family:\"".concat(this.cssFontInfo.fontFamily, "\";").concat(css, "src:").concat(url, "}");
      }
      (_this$_inspectFont2 = this._inspectFont) === null || _this$_inspectFont2 === void 0 || _this$_inspectFont2.call(this, this, url);
      return rule;
    }
  }, {
    key: "getPathGenerator",
    value: function getPathGenerator(objs, character) {
      if (this.compiledGlyphs[character] !== undefined) {
        return this.compiledGlyphs[character];
      }
      var objId = this.loadedName + "_path_" + character;
      var cmds;
      try {
        cmds = objs.get(objId);
      } catch (ex) {
        warn("getPathGenerator - ignoring character: \"".concat(ex, "\"."));
      }
      var path = new Path2D(cmds || "");
      if (!this.fontExtraProperties) {
        objs.delete(objId);
      }
      return this.compiledGlyphs[character] = path;
    }
  }]);
}();

;// ./src/display/canvas_factory.js
function canvas_factory_typeof(o) { "@babel/helpers - typeof"; return canvas_factory_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, canvas_factory_typeof(o); }
function canvas_factory_callSuper(t, o, e) { return o = canvas_factory_getPrototypeOf(o), canvas_factory_possibleConstructorReturn(t, canvas_factory_isNativeReflectConstruct() ? Reflect.construct(o, e || [], canvas_factory_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function canvas_factory_possibleConstructorReturn(t, e) { if (e && ("object" == canvas_factory_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return canvas_factory_assertThisInitialized(t); }
function canvas_factory_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function canvas_factory_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (canvas_factory_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function canvas_factory_getPrototypeOf(t) { return canvas_factory_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, canvas_factory_getPrototypeOf(t); }
function canvas_factory_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && canvas_factory_setPrototypeOf(t, e); }
function canvas_factory_setPrototypeOf(t, e) { return canvas_factory_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, canvas_factory_setPrototypeOf(t, e); }

















function canvas_factory_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function canvas_factory_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, canvas_factory_toPropertyKey(o.key), o); } }
function canvas_factory_createClass(e, r, t) { return r && canvas_factory_defineProperties(e.prototype, r), t && canvas_factory_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function canvas_factory_toPropertyKey(t) { var i = canvas_factory_toPrimitive(t, "string"); return "symbol" == canvas_factory_typeof(i) ? i : i + ""; }
function canvas_factory_toPrimitive(t, r) { if ("object" != canvas_factory_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != canvas_factory_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function canvas_factory_classPrivateFieldInitSpec(e, t, a) { canvas_factory_checkPrivateRedeclaration(e, t), t.set(e, a); }
function canvas_factory_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function canvas_factory_classPrivateFieldGet(s, a) { return s.get(canvas_factory_assertClassBrand(s, a)); }
function canvas_factory_classPrivateFieldSet(s, a, r) { return s.set(canvas_factory_assertClassBrand(s, a), r), r; }
function canvas_factory_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }

var _enableHWA = /*#__PURE__*/new WeakMap();
var BaseCanvasFactory = /*#__PURE__*/function () {
  function BaseCanvasFactory(_ref) {
    var _ref$enableHWA = _ref.enableHWA,
      enableHWA = _ref$enableHWA === void 0 ? false : _ref$enableHWA;
    canvas_factory_classCallCheck(this, BaseCanvasFactory);
    canvas_factory_classPrivateFieldInitSpec(this, _enableHWA, false);
    canvas_factory_classPrivateFieldSet(_enableHWA, this, enableHWA);
  }
  return canvas_factory_createClass(BaseCanvasFactory, [{
    key: "create",
    value: function create(width, height) {
      if (width <= 0 || height <= 0) {
        throw new Error("Invalid canvas size");
      }
      var canvas = this._createCanvas(width, height);
      return {
        canvas: canvas,
        context: canvas.getContext("2d", {
          willReadFrequently: !canvas_factory_classPrivateFieldGet(_enableHWA, this)
        })
      };
    }
  }, {
    key: "reset",
    value: function reset(canvasAndContext, width, height) {
      if (!canvasAndContext.canvas) {
        throw new Error("Canvas is not specified");
      }
      if (width <= 0 || height <= 0) {
        throw new Error("Invalid canvas size");
      }
      canvasAndContext.canvas.width = width;
      canvasAndContext.canvas.height = height;
    }
  }, {
    key: "destroy",
    value: function destroy(canvasAndContext) {
      if (!canvasAndContext.canvas) {
        throw new Error("Canvas is not specified");
      }
      canvasAndContext.canvas.width = 0;
      canvasAndContext.canvas.height = 0;
      canvasAndContext.canvas = null;
      canvasAndContext.context = null;
    }
  }, {
    key: "_createCanvas",
    value: function _createCanvas(width, height) {
      unreachable("Abstract method `_createCanvas` called.");
    }
  }]);
}();
var DOMCanvasFactory = /*#__PURE__*/function (_BaseCanvasFactory2) {
  function DOMCanvasFactory(_ref2) {
    var _this;
    var _ref2$ownerDocument = _ref2.ownerDocument,
      ownerDocument = _ref2$ownerDocument === void 0 ? globalThis.document : _ref2$ownerDocument,
      _ref2$enableHWA = _ref2.enableHWA,
      enableHWA = _ref2$enableHWA === void 0 ? false : _ref2$enableHWA;
    canvas_factory_classCallCheck(this, DOMCanvasFactory);
    _this = canvas_factory_callSuper(this, DOMCanvasFactory, [{
      enableHWA: enableHWA
    }]);
    _this._document = ownerDocument;
    return _this;
  }
  canvas_factory_inherits(DOMCanvasFactory, _BaseCanvasFactory2);
  return canvas_factory_createClass(DOMCanvasFactory, [{
    key: "_createCanvas",
    value: function _createCanvas(width, height) {
      var canvas = this._document.createElement("canvas");
      canvas.width = width;
      canvas.height = height;
      return canvas;
    }
  }]);
}(BaseCanvasFactory);

;// ./src/display/cmap_reader_factory.js
function cmap_reader_factory_callSuper(t, o, e) { return o = cmap_reader_factory_getPrototypeOf(o), cmap_reader_factory_possibleConstructorReturn(t, cmap_reader_factory_isNativeReflectConstruct() ? Reflect.construct(o, e || [], cmap_reader_factory_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function cmap_reader_factory_possibleConstructorReturn(t, e) { if (e && ("object" == cmap_reader_factory_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return cmap_reader_factory_assertThisInitialized(t); }
function cmap_reader_factory_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function cmap_reader_factory_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (cmap_reader_factory_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function cmap_reader_factory_getPrototypeOf(t) { return cmap_reader_factory_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, cmap_reader_factory_getPrototypeOf(t); }
function cmap_reader_factory_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && cmap_reader_factory_setPrototypeOf(t, e); }
function cmap_reader_factory_setPrototypeOf(t, e) { return cmap_reader_factory_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, cmap_reader_factory_setPrototypeOf(t, e); }
function cmap_reader_factory_typeof(o) { "@babel/helpers - typeof"; return cmap_reader_factory_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, cmap_reader_factory_typeof(o); }
function cmap_reader_factory_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ cmap_reader_factory_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == cmap_reader_factory_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(cmap_reader_factory_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
































































function cmap_reader_factory_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function cmap_reader_factory_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { cmap_reader_factory_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { cmap_reader_factory_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function cmap_reader_factory_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function cmap_reader_factory_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, cmap_reader_factory_toPropertyKey(o.key), o); } }
function cmap_reader_factory_createClass(e, r, t) { return r && cmap_reader_factory_defineProperties(e.prototype, r), t && cmap_reader_factory_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function cmap_reader_factory_toPropertyKey(t) { var i = cmap_reader_factory_toPrimitive(t, "string"); return "symbol" == cmap_reader_factory_typeof(i) ? i : i + ""; }
function cmap_reader_factory_toPrimitive(t, r) { if ("object" != cmap_reader_factory_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != cmap_reader_factory_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var BaseCMapReaderFactory = /*#__PURE__*/function () {
  function BaseCMapReaderFactory(_ref) {
    var _ref$baseUrl = _ref.baseUrl,
      baseUrl = _ref$baseUrl === void 0 ? null : _ref$baseUrl,
      _ref$isCompressed = _ref.isCompressed,
      isCompressed = _ref$isCompressed === void 0 ? true : _ref$isCompressed;
    cmap_reader_factory_classCallCheck(this, BaseCMapReaderFactory);
    this.baseUrl = baseUrl;
    this.isCompressed = isCompressed;
  }
  return cmap_reader_factory_createClass(BaseCMapReaderFactory, [{
    key: "fetch",
    value: function () {
      var _fetch2 = cmap_reader_factory_asyncToGenerator(/*#__PURE__*/cmap_reader_factory_regeneratorRuntime().mark(function _callee(_ref2) {
        var _this = this;
        var name, url;
        return cmap_reader_factory_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              name = _ref2.name;
              if (this.baseUrl) {
                _context.next = 3;
                break;
              }
              throw new Error("Ensure that the `cMapUrl` and `cMapPacked` API parameters are provided.");
            case 3:
              if (name) {
                _context.next = 5;
                break;
              }
              throw new Error("CMap name must be specified.");
            case 5:
              url = this.baseUrl + name + (this.isCompressed ? ".bcmap" : "");
              return _context.abrupt("return", this._fetch(url).then(function (cMapData) {
                return {
                  cMapData: cMapData,
                  isCompressed: _this.isCompressed
                };
              }).catch(function (reason) {
                throw new Error("Unable to load ".concat(_this.isCompressed ? "binary " : "", "CMap at: ").concat(url));
              }));
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function fetch(_x) {
        return _fetch2.apply(this, arguments);
      }
      return fetch;
    }()
  }, {
    key: "_fetch",
    value: function () {
      var _fetch3 = cmap_reader_factory_asyncToGenerator(/*#__PURE__*/cmap_reader_factory_regeneratorRuntime().mark(function _callee2(url) {
        return cmap_reader_factory_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              unreachable("Abstract method `_fetch` called.");
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      function _fetch(_x2) {
        return _fetch3.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}();
var DOMCMapReaderFactory = /*#__PURE__*/function (_BaseCMapReaderFactor) {
  function DOMCMapReaderFactory() {
    cmap_reader_factory_classCallCheck(this, DOMCMapReaderFactory);
    return cmap_reader_factory_callSuper(this, DOMCMapReaderFactory, arguments);
  }
  cmap_reader_factory_inherits(DOMCMapReaderFactory, _BaseCMapReaderFactor);
  return cmap_reader_factory_createClass(DOMCMapReaderFactory, [{
    key: "_fetch",
    value: function () {
      var _fetch4 = cmap_reader_factory_asyncToGenerator(/*#__PURE__*/cmap_reader_factory_regeneratorRuntime().mark(function _callee3(url) {
        var data;
        return cmap_reader_factory_regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return fetchData(url, this.isCompressed ? "arraybuffer" : "text");
            case 2:
              data = _context3.sent;
              return _context3.abrupt("return", data instanceof ArrayBuffer ? new Uint8Array(data) : stringToBytes(data));
            case 4:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function _fetch(_x3) {
        return _fetch4.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}(BaseCMapReaderFactory);

;// ./src/display/filter_factory.js
function filter_factory_toConsumableArray(r) { return filter_factory_arrayWithoutHoles(r) || filter_factory_iterableToArray(r) || filter_factory_unsupportedIterableToArray(r) || filter_factory_nonIterableSpread(); }
function filter_factory_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function filter_factory_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function filter_factory_arrayWithoutHoles(r) { if (Array.isArray(r)) return filter_factory_arrayLikeToArray(r); }
function filter_factory_slicedToArray(r, e) { return filter_factory_arrayWithHoles(r) || filter_factory_iterableToArrayLimit(r, e) || filter_factory_unsupportedIterableToArray(r, e) || filter_factory_nonIterableRest(); }
function filter_factory_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function filter_factory_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return filter_factory_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? filter_factory_arrayLikeToArray(r, a) : void 0; } }
function filter_factory_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function filter_factory_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function filter_factory_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function filter_factory_callSuper(t, o, e) { return o = filter_factory_getPrototypeOf(o), filter_factory_possibleConstructorReturn(t, filter_factory_isNativeReflectConstruct() ? Reflect.construct(o, e || [], filter_factory_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function filter_factory_possibleConstructorReturn(t, e) { if (e && ("object" == filter_factory_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return filter_factory_assertThisInitialized(t); }
function filter_factory_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function filter_factory_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (filter_factory_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function filter_factory_getPrototypeOf(t) { return filter_factory_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, filter_factory_getPrototypeOf(t); }
function filter_factory_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && filter_factory_setPrototypeOf(t, e); }
function filter_factory_setPrototypeOf(t, e) { return filter_factory_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, filter_factory_setPrototypeOf(t, e); }
function filter_factory_classPrivateMethodInitSpec(e, a) { filter_factory_checkPrivateRedeclaration(e, a), a.add(e); }
function filter_factory_classPrivateFieldInitSpec(e, t, a) { filter_factory_checkPrivateRedeclaration(e, t), t.set(e, a); }
function filter_factory_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function filter_factory_classPrivateGetter(s, r, a) { return a(filter_factory_assertClassBrand(s, r)); }
function filter_factory_classPrivateFieldGet(s, a) { return s.get(filter_factory_assertClassBrand(s, a)); }
function filter_factory_classPrivateFieldSet(s, a, r) { return s.set(filter_factory_assertClassBrand(s, a), r), r; }
function filter_factory_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
































function filter_factory_typeof(o) { "@babel/helpers - typeof"; return filter_factory_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, filter_factory_typeof(o); }
function filter_factory_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function filter_factory_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, filter_factory_toPropertyKey(o.key), o); } }
function filter_factory_createClass(e, r, t) { return r && filter_factory_defineProperties(e.prototype, r), t && filter_factory_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function filter_factory_toPropertyKey(t) { var i = filter_factory_toPrimitive(t, "string"); return "symbol" == filter_factory_typeof(i) ? i : i + ""; }
function filter_factory_toPrimitive(t, r) { if ("object" != filter_factory_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != filter_factory_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var BaseFilterFactory = /*#__PURE__*/function () {
  function BaseFilterFactory() {
    filter_factory_classCallCheck(this, BaseFilterFactory);
  }
  return filter_factory_createClass(BaseFilterFactory, [{
    key: "addFilter",
    value: function addFilter(maps) {
      return "none";
    }
  }, {
    key: "addHCMFilter",
    value: function addHCMFilter(fgColor, bgColor) {
      return "none";
    }
  }, {
    key: "addAlphaFilter",
    value: function addAlphaFilter(map) {
      return "none";
    }
  }, {
    key: "addLuminosityFilter",
    value: function addLuminosityFilter(map) {
      return "none";
    }
  }, {
    key: "addHighlightHCMFilter",
    value: function addHighlightHCMFilter(filterName, fgColor, bgColor, newFgColor, newBgColor) {
      return "none";
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var keepHCM = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    }
  }]);
}();
var _baseUrl = /*#__PURE__*/new WeakMap();
var filter_factory_cache = /*#__PURE__*/new WeakMap();
var _defs = /*#__PURE__*/new WeakMap();
var _docId = /*#__PURE__*/new WeakMap();
var _document = /*#__PURE__*/new WeakMap();
var _hcmCache = /*#__PURE__*/new WeakMap();
var filter_factory_id = /*#__PURE__*/new WeakMap();
var _DOMFilterFactory_brand = /*#__PURE__*/new WeakSet();
var DOMFilterFactory = /*#__PURE__*/function (_BaseFilterFactory) {
  function DOMFilterFactory(_ref) {
    var _this4;
    var docId = _ref.docId,
      _ref$ownerDocument = _ref.ownerDocument,
      ownerDocument = _ref$ownerDocument === void 0 ? globalThis.document : _ref$ownerDocument;
    filter_factory_classCallCheck(this, DOMFilterFactory);
    _this4 = filter_factory_callSuper(this, DOMFilterFactory);
    filter_factory_classPrivateMethodInitSpec(_this4, _DOMFilterFactory_brand);
    filter_factory_classPrivateFieldInitSpec(_this4, _baseUrl, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, filter_factory_cache, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, _defs, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, _docId, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, _document, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, _hcmCache, void 0);
    filter_factory_classPrivateFieldInitSpec(_this4, filter_factory_id, 0);
    filter_factory_classPrivateFieldSet(_docId, _this4, docId);
    filter_factory_classPrivateFieldSet(_document, _this4, ownerDocument);
    return _this4;
  }
  filter_factory_inherits(DOMFilterFactory, _BaseFilterFactory);
  return filter_factory_createClass(DOMFilterFactory, [{
    key: "addFilter",
    value: function addFilter(maps) {
      var _this$id, _this$id2;
      if (!maps) {
        return "none";
      }
      var value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(maps);
      if (value) {
        return value;
      }
      var _assertClassBrand$cal = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createTables).call(this, maps),
        _assertClassBrand$cal2 = filter_factory_slicedToArray(_assertClassBrand$cal, 3),
        tableR = _assertClassBrand$cal2[0],
        tableG = _assertClassBrand$cal2[1],
        tableB = _assertClassBrand$cal2[2];
      var key = maps.length === 1 ? tableR : "".concat(tableR).concat(tableG).concat(tableB);
      value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(key);
      if (value) {
        filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(maps, value);
        return value;
      }
      var id = "g_".concat(filter_factory_classPrivateFieldGet(_docId, this), "_transfer_map_").concat((filter_factory_classPrivateFieldSet(filter_factory_id, this, (_this$id = filter_factory_classPrivateFieldGet(filter_factory_id, this), _this$id2 = _this$id++, _this$id)), _this$id2));
      var url = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createUrl).call(this, id);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(maps, url);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(key, url);
      var filter = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createFilter).call(this, id);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapConversion).call(this, tableR, tableG, tableB, filter);
      return url;
    }
  }, {
    key: "addHCMFilter",
    value: function addHCMFilter(fgColor, bgColor) {
      var _info;
      var key = "".concat(fgColor, "-").concat(bgColor);
      var filterName = "base";
      var info = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_hcmCache).get(filterName);
      if (((_info = info) === null || _info === void 0 ? void 0 : _info.key) === key) {
        return info.url;
      }
      if (info) {
        var _info$filter;
        (_info$filter = info.filter) === null || _info$filter === void 0 || _info$filter.remove();
        info.key = key;
        info.url = "none";
        info.filter = null;
      } else {
        info = {
          key: key,
          url: "none",
          filter: null
        };
        filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_hcmCache).set(filterName, info);
      }
      if (!fgColor || !bgColor) {
        return info.url;
      }
      var fgRGB = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _getRGB).call(this, fgColor);
      fgColor = Util.makeHexColor.apply(Util, filter_factory_toConsumableArray(fgRGB));
      var bgRGB = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _getRGB).call(this, bgColor);
      bgColor = Util.makeHexColor.apply(Util, filter_factory_toConsumableArray(bgRGB));
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_defs).style.color = "";
      if (fgColor === "#000000" && bgColor === "#ffffff" || fgColor === bgColor) {
        return info.url;
      }
      var map = new Array(256);
      for (var i = 0; i <= 255; i++) {
        var x = i / 255;
        map[i] = x <= 0.03928 ? x / 12.92 : Math.pow((x + 0.055) / 1.055, 2.4);
      }
      var table = map.join(",");
      var id = "g_".concat(filter_factory_classPrivateFieldGet(_docId, this), "_hcm_filter");
      var filter = info.filter = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createFilter).call(this, id);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapConversion).call(this, table, table, table, filter);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addGrayConversion).call(this, filter);
      var getSteps = function getSteps(c, n) {
        var start = fgRGB[c] / 255;
        var end = bgRGB[c] / 255;
        var arr = new Array(n + 1);
        for (var _i = 0; _i <= n; _i++) {
          arr[_i] = start + _i / n * (end - start);
        }
        return arr.join(",");
      };
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapConversion).call(this, getSteps(0, 5), getSteps(1, 5), getSteps(2, 5), filter);
      info.url = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createUrl).call(this, id);
      return info.url;
    }
  }, {
    key: "addAlphaFilter",
    value: function addAlphaFilter(map) {
      var _this$id3, _this$id4;
      var value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(map);
      if (value) {
        return value;
      }
      var _assertClassBrand$cal3 = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createTables).call(this, [map]),
        _assertClassBrand$cal4 = filter_factory_slicedToArray(_assertClassBrand$cal3, 1),
        tableA = _assertClassBrand$cal4[0];
      var key = "alpha_".concat(tableA);
      value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(key);
      if (value) {
        filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(map, value);
        return value;
      }
      var id = "g_".concat(filter_factory_classPrivateFieldGet(_docId, this), "_alpha_map_").concat((filter_factory_classPrivateFieldSet(filter_factory_id, this, (_this$id3 = filter_factory_classPrivateFieldGet(filter_factory_id, this), _this$id4 = _this$id3++, _this$id3)), _this$id4));
      var url = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createUrl).call(this, id);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(map, url);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(key, url);
      var filter = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createFilter).call(this, id);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapAlphaConversion).call(this, tableA, filter);
      return url;
    }
  }, {
    key: "addLuminosityFilter",
    value: function addLuminosityFilter(map) {
      var _this$id5, _this$id6;
      var value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(map || "luminosity");
      if (value) {
        return value;
      }
      var tableA, key;
      if (map) {
        var _assertClassBrand$cal5 = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createTables).call(this, [map]);
        var _assertClassBrand$cal6 = filter_factory_slicedToArray(_assertClassBrand$cal5, 1);
        tableA = _assertClassBrand$cal6[0];
        key = "luminosity_".concat(tableA);
      } else {
        key = "luminosity";
      }
      value = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).get(key);
      if (value) {
        filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(map, value);
        return value;
      }
      var id = "g_".concat(filter_factory_classPrivateFieldGet(_docId, this), "_luminosity_map_").concat((filter_factory_classPrivateFieldSet(filter_factory_id, this, (_this$id5 = filter_factory_classPrivateFieldGet(filter_factory_id, this), _this$id6 = _this$id5++, _this$id5)), _this$id6));
      var url = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createUrl).call(this, id);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(map, url);
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_cache).set(key, url);
      var filter = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createFilter).call(this, id);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addLuminosityConversion).call(this, filter);
      if (map) {
        filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapAlphaConversion).call(this, tableA, filter);
      }
      return url;
    }
  }, {
    key: "addHighlightHCMFilter",
    value: function addHighlightHCMFilter(filterName, fgColor, bgColor, newFgColor, newBgColor) {
      var _info2;
      var key = "".concat(fgColor, "-").concat(bgColor, "-").concat(newFgColor, "-").concat(newBgColor);
      var info = filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_hcmCache).get(filterName);
      if (((_info2 = info) === null || _info2 === void 0 ? void 0 : _info2.key) === key) {
        return info.url;
      }
      if (info) {
        var _info$filter2;
        (_info$filter2 = info.filter) === null || _info$filter2 === void 0 || _info$filter2.remove();
        info.key = key;
        info.url = "none";
        info.filter = null;
      } else {
        info = {
          key: key,
          url: "none",
          filter: null
        };
        filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_hcmCache).set(filterName, info);
      }
      if (!fgColor || !bgColor) {
        return info.url;
      }
      var _map = [fgColor, bgColor].map(filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _getRGB).bind(this)),
        _map2 = filter_factory_slicedToArray(_map, 2),
        fgRGB = _map2[0],
        bgRGB = _map2[1];
      var fgGray = Math.round(0.2126 * fgRGB[0] + 0.7152 * fgRGB[1] + 0.0722 * fgRGB[2]);
      var bgGray = Math.round(0.2126 * bgRGB[0] + 0.7152 * bgRGB[1] + 0.0722 * bgRGB[2]);
      var _map3 = [newFgColor, newBgColor].map(filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _getRGB).bind(this)),
        _map4 = filter_factory_slicedToArray(_map3, 2),
        newFgRGB = _map4[0],
        newBgRGB = _map4[1];
      if (bgGray < fgGray) {
        var _ref2 = [bgGray, fgGray, newBgRGB, newFgRGB];
        fgGray = _ref2[0];
        bgGray = _ref2[1];
        newFgRGB = _ref2[2];
        newBgRGB = _ref2[3];
      }
      filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_defs).style.color = "";
      var getSteps = function getSteps(fg, bg, n) {
        var arr = new Array(256);
        var step = (bgGray - fgGray) / n;
        var newStart = fg / 255;
        var newStep = (bg - fg) / (255 * n);
        var prev = 0;
        for (var i = 0; i <= n; i++) {
          var k = Math.round(fgGray + i * step);
          var value = newStart + i * newStep;
          for (var j = prev; j <= k; j++) {
            arr[j] = value;
          }
          prev = k + 1;
        }
        for (var _i2 = prev; _i2 < 256; _i2++) {
          arr[_i2] = arr[prev - 1];
        }
        return arr.join(",");
      };
      var id = "g_".concat(filter_factory_classPrivateFieldGet(_docId, this), "_hcm_").concat(filterName, "_filter");
      var filter = info.filter = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createFilter).call(this, id);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addGrayConversion).call(this, filter);
      filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _addTransferMapConversion).call(this, getSteps(newFgRGB[0], newBgRGB[0], 5), getSteps(newFgRGB[1], newBgRGB[1], 5), getSteps(newFgRGB[2], newBgRGB[2], 5), filter);
      info.url = filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _createUrl).call(this, id);
      return info.url;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet2, _classPrivateFieldGet3, _classPrivateFieldGet4, _classPrivateFieldGet5;
      var keepHCM = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (keepHCM && (_classPrivateFieldGet2 = filter_factory_classPrivateFieldGet(_hcmCache, this)) !== null && _classPrivateFieldGet2 !== void 0 && _classPrivateFieldGet2.size) {
        return;
      }
      (_classPrivateFieldGet3 = filter_factory_classPrivateFieldGet(_defs, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.parentNode.parentNode.remove();
      filter_factory_classPrivateFieldSet(_defs, this, null);
      (_classPrivateFieldGet4 = filter_factory_classPrivateFieldGet(filter_factory_cache, this)) === null || _classPrivateFieldGet4 === void 0 || _classPrivateFieldGet4.clear();
      filter_factory_classPrivateFieldSet(filter_factory_cache, this, null);
      (_classPrivateFieldGet5 = filter_factory_classPrivateFieldGet(_hcmCache, this)) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.clear();
      filter_factory_classPrivateFieldSet(_hcmCache, this, null);
      filter_factory_classPrivateFieldSet(filter_factory_id, this, 0);
    }
  }]);
}(BaseFilterFactory);
function _get_cache(_this) {
  return filter_factory_classPrivateFieldGet(filter_factory_cache, _this) || filter_factory_classPrivateFieldSet(filter_factory_cache, _this, new Map());
}
function _get_hcmCache(_this2) {
  return filter_factory_classPrivateFieldGet(_hcmCache, _this2) || filter_factory_classPrivateFieldSet(_hcmCache, _this2, new Map());
}
function _get_defs(_this3) {
  if (!filter_factory_classPrivateFieldGet(_defs, _this3)) {
    var div = filter_factory_classPrivateFieldGet(_document, _this3).createElement("div");
    var style = div.style;
    style.visibility = "hidden";
    style.contain = "strict";
    style.width = style.height = 0;
    style.position = "absolute";
    style.top = style.left = 0;
    style.zIndex = -1;
    var svg = filter_factory_classPrivateFieldGet(_document, _this3).createElementNS(SVG_NS, "svg");
    svg.setAttribute("width", 0);
    svg.setAttribute("height", 0);
    filter_factory_classPrivateFieldSet(_defs, _this3, filter_factory_classPrivateFieldGet(_document, _this3).createElementNS(SVG_NS, "defs"));
    div.append(svg);
    svg.append(filter_factory_classPrivateFieldGet(_defs, _this3));
    filter_factory_classPrivateFieldGet(_document, _this3).body.append(div);
  }
  return filter_factory_classPrivateFieldGet(_defs, _this3);
}
function _createTables(maps) {
  if (maps.length === 1) {
    var _mapR = maps[0];
    var buffer = new Array(256);
    for (var i = 0; i < 256; i++) {
      buffer[i] = _mapR[i] / 255;
    }
    var table = buffer.join(",");
    return [table, table, table];
  }
  var _maps = filter_factory_slicedToArray(maps, 3),
    mapR = _maps[0],
    mapG = _maps[1],
    mapB = _maps[2];
  var bufferR = new Array(256);
  var bufferG = new Array(256);
  var bufferB = new Array(256);
  for (var _i3 = 0; _i3 < 256; _i3++) {
    bufferR[_i3] = mapR[_i3] / 255;
    bufferG[_i3] = mapG[_i3] / 255;
    bufferB[_i3] = mapB[_i3] / 255;
  }
  return [bufferR.join(","), bufferG.join(","), bufferB.join(",")];
}
function _createUrl(id) {
  if (filter_factory_classPrivateFieldGet(_baseUrl, this) === undefined) {
    filter_factory_classPrivateFieldSet(_baseUrl, this, "");
    var url = filter_factory_classPrivateFieldGet(_document, this).URL;
    if (url !== filter_factory_classPrivateFieldGet(_document, this).baseURI) {
      if (isDataScheme(url)) {
        warn('#createUrl: ignore "data:"-URL for performance reasons.');
      } else {
        filter_factory_classPrivateFieldSet(_baseUrl, this, url.split("#", 1)[0]);
      }
    }
  }
  return "url(".concat(filter_factory_classPrivateFieldGet(_baseUrl, this), "#").concat(id, ")");
}
function _addLuminosityConversion(filter) {
  var feColorMatrix = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, "feColorMatrix");
  feColorMatrix.setAttribute("type", "matrix");
  feColorMatrix.setAttribute("values", "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.3 0.59 0.11 0 0");
  filter.append(feColorMatrix);
}
function _addGrayConversion(filter) {
  var feColorMatrix = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, "feColorMatrix");
  feColorMatrix.setAttribute("type", "matrix");
  feColorMatrix.setAttribute("values", "0.2126 0.7152 0.0722 0 0 0.2126 0.7152 0.0722 0 0 0.2126 0.7152 0.0722 0 0 0 0 0 1 0");
  filter.append(feColorMatrix);
}
function _createFilter(id) {
  var filter = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, "filter");
  filter.setAttribute("color-interpolation-filters", "sRGB");
  filter.setAttribute("id", id);
  filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_defs).append(filter);
  return filter;
}
function _appendFeFunc(feComponentTransfer, func, table) {
  var feFunc = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, func);
  feFunc.setAttribute("type", "discrete");
  feFunc.setAttribute("tableValues", table);
  feComponentTransfer.append(feFunc);
}
function _addTransferMapConversion(rTable, gTable, bTable, filter) {
  var feComponentTransfer = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, "feComponentTransfer");
  filter.append(feComponentTransfer);
  filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _appendFeFunc).call(this, feComponentTransfer, "feFuncR", rTable);
  filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _appendFeFunc).call(this, feComponentTransfer, "feFuncG", gTable);
  filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _appendFeFunc).call(this, feComponentTransfer, "feFuncB", bTable);
}
function _addTransferMapAlphaConversion(aTable, filter) {
  var feComponentTransfer = filter_factory_classPrivateFieldGet(_document, this).createElementNS(SVG_NS, "feComponentTransfer");
  filter.append(feComponentTransfer);
  filter_factory_assertClassBrand(_DOMFilterFactory_brand, this, _appendFeFunc).call(this, feComponentTransfer, "feFuncA", aTable);
}
function _getRGB(color) {
  filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_defs).style.color = color;
  return getRGB(getComputedStyle(filter_factory_classPrivateGetter(_DOMFilterFactory_brand, this, _get_defs)).getPropertyValue("color"));
}

;// ./src/display/standard_fontdata_factory.js
function standard_fontdata_factory_callSuper(t, o, e) { return o = standard_fontdata_factory_getPrototypeOf(o), standard_fontdata_factory_possibleConstructorReturn(t, standard_fontdata_factory_isNativeReflectConstruct() ? Reflect.construct(o, e || [], standard_fontdata_factory_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function standard_fontdata_factory_possibleConstructorReturn(t, e) { if (e && ("object" == standard_fontdata_factory_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return standard_fontdata_factory_assertThisInitialized(t); }
function standard_fontdata_factory_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function standard_fontdata_factory_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (standard_fontdata_factory_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function standard_fontdata_factory_getPrototypeOf(t) { return standard_fontdata_factory_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, standard_fontdata_factory_getPrototypeOf(t); }
function standard_fontdata_factory_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && standard_fontdata_factory_setPrototypeOf(t, e); }
function standard_fontdata_factory_setPrototypeOf(t, e) { return standard_fontdata_factory_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, standard_fontdata_factory_setPrototypeOf(t, e); }
function standard_fontdata_factory_typeof(o) { "@babel/helpers - typeof"; return standard_fontdata_factory_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, standard_fontdata_factory_typeof(o); }
function standard_fontdata_factory_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ standard_fontdata_factory_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == standard_fontdata_factory_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(standard_fontdata_factory_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
































































function standard_fontdata_factory_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function standard_fontdata_factory_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { standard_fontdata_factory_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { standard_fontdata_factory_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function standard_fontdata_factory_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function standard_fontdata_factory_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, standard_fontdata_factory_toPropertyKey(o.key), o); } }
function standard_fontdata_factory_createClass(e, r, t) { return r && standard_fontdata_factory_defineProperties(e.prototype, r), t && standard_fontdata_factory_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function standard_fontdata_factory_toPropertyKey(t) { var i = standard_fontdata_factory_toPrimitive(t, "string"); return "symbol" == standard_fontdata_factory_typeof(i) ? i : i + ""; }
function standard_fontdata_factory_toPrimitive(t, r) { if ("object" != standard_fontdata_factory_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != standard_fontdata_factory_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var BaseStandardFontDataFactory = /*#__PURE__*/function () {
  function BaseStandardFontDataFactory(_ref) {
    var _ref$baseUrl = _ref.baseUrl,
      baseUrl = _ref$baseUrl === void 0 ? null : _ref$baseUrl;
    standard_fontdata_factory_classCallCheck(this, BaseStandardFontDataFactory);
    this.baseUrl = baseUrl;
  }
  return standard_fontdata_factory_createClass(BaseStandardFontDataFactory, [{
    key: "fetch",
    value: function () {
      var _fetch2 = standard_fontdata_factory_asyncToGenerator(/*#__PURE__*/standard_fontdata_factory_regeneratorRuntime().mark(function _callee(_ref2) {
        var filename, url;
        return standard_fontdata_factory_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              filename = _ref2.filename;
              if (this.baseUrl) {
                _context.next = 3;
                break;
              }
              throw new Error("Ensure that the `standardFontDataUrl` API parameter is provided.");
            case 3:
              if (filename) {
                _context.next = 5;
                break;
              }
              throw new Error("Font filename must be specified.");
            case 5:
              url = "".concat(this.baseUrl).concat(filename);
              return _context.abrupt("return", this._fetch(url).catch(function (reason) {
                throw new Error("Unable to load font data at: ".concat(url));
              }));
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function fetch(_x) {
        return _fetch2.apply(this, arguments);
      }
      return fetch;
    }()
  }, {
    key: "_fetch",
    value: function () {
      var _fetch3 = standard_fontdata_factory_asyncToGenerator(/*#__PURE__*/standard_fontdata_factory_regeneratorRuntime().mark(function _callee2(url) {
        return standard_fontdata_factory_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              unreachable("Abstract method `_fetch` called.");
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      function _fetch(_x2) {
        return _fetch3.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}();
var DOMStandardFontDataFactory = /*#__PURE__*/function (_BaseStandardFontData) {
  function DOMStandardFontDataFactory() {
    standard_fontdata_factory_classCallCheck(this, DOMStandardFontDataFactory);
    return standard_fontdata_factory_callSuper(this, DOMStandardFontDataFactory, arguments);
  }
  standard_fontdata_factory_inherits(DOMStandardFontDataFactory, _BaseStandardFontData);
  return standard_fontdata_factory_createClass(DOMStandardFontDataFactory, [{
    key: "_fetch",
    value: function () {
      var _fetch4 = standard_fontdata_factory_asyncToGenerator(/*#__PURE__*/standard_fontdata_factory_regeneratorRuntime().mark(function _callee3(url) {
        var data;
        return standard_fontdata_factory_regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return fetchData(url, "arraybuffer");
            case 2:
              data = _context3.sent;
              return _context3.abrupt("return", new Uint8Array(data));
            case 4:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }));
      function _fetch(_x3) {
        return _fetch4.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}(BaseStandardFontDataFactory);

;// ./src/display/node_utils.js
function node_utils_typeof(o) { "@babel/helpers - typeof"; return node_utils_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, node_utils_typeof(o); }
function node_utils_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ node_utils_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == node_utils_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(node_utils_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function node_utils_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, node_utils_toPropertyKey(o.key), o); } }
function node_utils_createClass(e, r, t) { return r && node_utils_defineProperties(e.prototype, r), t && node_utils_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function node_utils_toPropertyKey(t) { var i = node_utils_toPrimitive(t, "string"); return "symbol" == node_utils_typeof(i) ? i : i + ""; }
function node_utils_toPrimitive(t, r) { if ("object" != node_utils_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != node_utils_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function node_utils_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function node_utils_callSuper(t, o, e) { return o = node_utils_getPrototypeOf(o), node_utils_possibleConstructorReturn(t, node_utils_isNativeReflectConstruct() ? Reflect.construct(o, e || [], node_utils_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function node_utils_possibleConstructorReturn(t, e) { if (e && ("object" == node_utils_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return node_utils_assertThisInitialized(t); }
function node_utils_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function node_utils_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (node_utils_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function node_utils_getPrototypeOf(t) { return node_utils_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, node_utils_getPrototypeOf(t); }
function node_utils_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && node_utils_setPrototypeOf(t, e); }
function node_utils_setPrototypeOf(t, e) { return node_utils_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, node_utils_setPrototypeOf(t, e); }
function node_utils_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function node_utils_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { node_utils_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { node_utils_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }





































































if (isNodeJS) {
  var canvas;
  try {
    var node_utils_require = process.getBuiltinModule("module").createRequire(import.meta.url);
    try {
      canvas = node_utils_require("@napi-rs/canvas");
    } catch (ex) {
      warn("Cannot load \"@napi-rs/canvas\" package: \"".concat(ex, "\"."));
    }
  } catch (ex) {
    warn("Cannot access the `require` function: \"".concat(ex, "\"."));
  }
  if (!globalThis.DOMMatrix) {
    var _canvas;
    if ((_canvas = canvas) !== null && _canvas !== void 0 && _canvas.DOMMatrix) {
      globalThis.DOMMatrix = canvas.DOMMatrix;
    } else {
      warn("Cannot polyfill `DOMMatrix`, rendering may be broken.");
    }
  }
  if (!globalThis.ImageData) {
    var _canvas2;
    if ((_canvas2 = canvas) !== null && _canvas2 !== void 0 && _canvas2.ImageData) {
      globalThis.ImageData = canvas.ImageData;
    } else {
      warn("Cannot polyfill `ImageData`, rendering may be broken.");
    }
  }
  if (!globalThis.Path2D) {
    var _canvas3;
    if ((_canvas3 = canvas) !== null && _canvas3 !== void 0 && _canvas3.Path2D) {
      globalThis.Path2D = canvas.Path2D;
    } else {
      warn("Cannot polyfill `Path2D`, rendering may be broken.");
    }
  }
}
function node_utils_fetchData(_x) {
  return display_node_utils_fetchData.apply(this, arguments);
}
function display_node_utils_fetchData() {
  display_node_utils_fetchData = node_utils_asyncToGenerator(/*#__PURE__*/node_utils_regeneratorRuntime().mark(function _callee3(url) {
    var fs, data;
    return node_utils_regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          fs = process.getBuiltinModule("fs");
          _context3.next = 3;
          return fs.promises.readFile(url);
        case 3:
          data = _context3.sent;
          return _context3.abrupt("return", new Uint8Array(data));
        case 5:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return display_node_utils_fetchData.apply(this, arguments);
}
var NodeFilterFactory = /*#__PURE__*/function (_BaseFilterFactory) {
  function NodeFilterFactory() {
    node_utils_classCallCheck(this, NodeFilterFactory);
    return node_utils_callSuper(this, NodeFilterFactory, arguments);
  }
  node_utils_inherits(NodeFilterFactory, _BaseFilterFactory);
  return node_utils_createClass(NodeFilterFactory);
}(BaseFilterFactory);
var NodeCanvasFactory = /*#__PURE__*/function (_BaseCanvasFactory) {
  function NodeCanvasFactory() {
    node_utils_classCallCheck(this, NodeCanvasFactory);
    return node_utils_callSuper(this, NodeCanvasFactory, arguments);
  }
  node_utils_inherits(NodeCanvasFactory, _BaseCanvasFactory);
  return node_utils_createClass(NodeCanvasFactory, [{
    key: "_createCanvas",
    value: function _createCanvas(width, height) {
      var require = process.getBuiltinModule("module").createRequire(import.meta.url);
      var canvas = require("@napi-rs/canvas");
      return canvas.createCanvas(width, height);
    }
  }]);
}(BaseCanvasFactory);
var NodeCMapReaderFactory = /*#__PURE__*/function (_BaseCMapReaderFactor) {
  function NodeCMapReaderFactory() {
    node_utils_classCallCheck(this, NodeCMapReaderFactory);
    return node_utils_callSuper(this, NodeCMapReaderFactory, arguments);
  }
  node_utils_inherits(NodeCMapReaderFactory, _BaseCMapReaderFactor);
  return node_utils_createClass(NodeCMapReaderFactory, [{
    key: "_fetch",
    value: function () {
      var _fetch2 = node_utils_asyncToGenerator(/*#__PURE__*/node_utils_regeneratorRuntime().mark(function _callee(url) {
        return node_utils_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              return _context.abrupt("return", node_utils_fetchData(url));
            case 1:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      function _fetch(_x2) {
        return _fetch2.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}(BaseCMapReaderFactory);
var NodeStandardFontDataFactory = /*#__PURE__*/function (_BaseStandardFontData) {
  function NodeStandardFontDataFactory() {
    node_utils_classCallCheck(this, NodeStandardFontDataFactory);
    return node_utils_callSuper(this, NodeStandardFontDataFactory, arguments);
  }
  node_utils_inherits(NodeStandardFontDataFactory, _BaseStandardFontData);
  return node_utils_createClass(NodeStandardFontDataFactory, [{
    key: "_fetch",
    value: function () {
      var _fetch3 = node_utils_asyncToGenerator(/*#__PURE__*/node_utils_regeneratorRuntime().mark(function _callee2(url) {
        return node_utils_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", node_utils_fetchData(url));
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      function _fetch(_x3) {
        return _fetch3.apply(this, arguments);
      }
      return _fetch;
    }()
  }]);
}(BaseStandardFontDataFactory);

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.fill.js
var es_array_fill = __webpack_require__(3771);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.math.fround.js
var es_math_fround = __webpack_require__(605);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.math.sign.js
var es_math_sign = __webpack_require__(5914);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.int32-array.js
var es_typed_array_int32_array = __webpack_require__(5477);
;// ./src/display/pattern_helper.js
function pattern_helper_defineProperty(e, r, t) { return (r = pattern_helper_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function pattern_helper_toConsumableArray(r) { return pattern_helper_arrayWithoutHoles(r) || pattern_helper_iterableToArray(r) || pattern_helper_unsupportedIterableToArray(r) || pattern_helper_nonIterableSpread(); }
function pattern_helper_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function pattern_helper_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function pattern_helper_arrayWithoutHoles(r) { if (Array.isArray(r)) return pattern_helper_arrayLikeToArray(r); }
function pattern_helper_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = pattern_helper_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function pattern_helper_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return pattern_helper_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? pattern_helper_arrayLikeToArray(r, a) : void 0; } }
function pattern_helper_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function pattern_helper_callSuper(t, o, e) { return o = pattern_helper_getPrototypeOf(o), pattern_helper_possibleConstructorReturn(t, pattern_helper_isNativeReflectConstruct() ? Reflect.construct(o, e || [], pattern_helper_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function pattern_helper_possibleConstructorReturn(t, e) { if (e && ("object" == pattern_helper_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return pattern_helper_assertThisInitialized(t); }
function pattern_helper_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function pattern_helper_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (pattern_helper_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function pattern_helper_getPrototypeOf(t) { return pattern_helper_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, pattern_helper_getPrototypeOf(t); }
function pattern_helper_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && pattern_helper_setPrototypeOf(t, e); }
function pattern_helper_setPrototypeOf(t, e) { return pattern_helper_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, pattern_helper_setPrototypeOf(t, e); }





















function pattern_helper_typeof(o) { "@babel/helpers - typeof"; return pattern_helper_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, pattern_helper_typeof(o); }
function pattern_helper_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function pattern_helper_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, pattern_helper_toPropertyKey(o.key), o); } }
function pattern_helper_createClass(e, r, t) { return r && pattern_helper_defineProperties(e.prototype, r), t && pattern_helper_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function pattern_helper_toPropertyKey(t) { var i = pattern_helper_toPrimitive(t, "string"); return "symbol" == pattern_helper_typeof(i) ? i : i + ""; }
function pattern_helper_toPrimitive(t, r) { if ("object" != pattern_helper_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != pattern_helper_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var PathType = {
  FILL: "Fill",
  STROKE: "Stroke",
  SHADING: "Shading"
};
function applyBoundingBox(ctx, bbox) {
  if (!bbox) {
    return;
  }
  var width = bbox[2] - bbox[0];
  var height = bbox[3] - bbox[1];
  var region = new Path2D();
  region.rect(bbox[0], bbox[1], width, height);
  ctx.clip(region);
}
var BaseShadingPattern = /*#__PURE__*/function () {
  function BaseShadingPattern() {
    pattern_helper_classCallCheck(this, BaseShadingPattern);
  }
  return pattern_helper_createClass(BaseShadingPattern, [{
    key: "getPattern",
    value: function getPattern() {
      unreachable("Abstract method `getPattern` called.");
    }
  }]);
}();
var RadialAxialShadingPattern = /*#__PURE__*/function (_BaseShadingPattern) {
  function RadialAxialShadingPattern(IR) {
    var _this;
    pattern_helper_classCallCheck(this, RadialAxialShadingPattern);
    _this = pattern_helper_callSuper(this, RadialAxialShadingPattern);
    _this._type = IR[1];
    _this._bbox = IR[2];
    _this._colorStops = IR[3];
    _this._p0 = IR[4];
    _this._p1 = IR[5];
    _this._r0 = IR[6];
    _this._r1 = IR[7];
    _this.matrix = null;
    return _this;
  }
  pattern_helper_inherits(RadialAxialShadingPattern, _BaseShadingPattern);
  return pattern_helper_createClass(RadialAxialShadingPattern, [{
    key: "_createGradient",
    value: function _createGradient(ctx) {
      var grad;
      if (this._type === "axial") {
        grad = ctx.createLinearGradient(this._p0[0], this._p0[1], this._p1[0], this._p1[1]);
      } else if (this._type === "radial") {
        grad = ctx.createRadialGradient(this._p0[0], this._p0[1], this._r0, this._p1[0], this._p1[1], this._r1);
      }
      var _iterator = pattern_helper_createForOfIteratorHelper(this._colorStops),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var colorStop = _step.value;
          grad.addColorStop(colorStop[0], colorStop[1]);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return grad;
    }
  }, {
    key: "getPattern",
    value: function getPattern(ctx, owner, inverse, pathType) {
      var pattern;
      if (pathType === PathType.STROKE || pathType === PathType.FILL) {
        var ownerBBox = owner.current.getClippedPathBoundingBox(pathType, getCurrentTransform(ctx)) || [0, 0, 0, 0];
        var width = Math.ceil(ownerBBox[2] - ownerBBox[0]) || 1;
        var height = Math.ceil(ownerBBox[3] - ownerBBox[1]) || 1;
        var tmpCanvas = owner.cachedCanvases.getCanvas("pattern", width, height);
        var tmpCtx = tmpCanvas.context;
        tmpCtx.clearRect(0, 0, tmpCtx.canvas.width, tmpCtx.canvas.height);
        tmpCtx.beginPath();
        tmpCtx.rect(0, 0, tmpCtx.canvas.width, tmpCtx.canvas.height);
        tmpCtx.translate(-ownerBBox[0], -ownerBBox[1]);
        inverse = Util.transform(inverse, [1, 0, 0, 1, ownerBBox[0], ownerBBox[1]]);
        tmpCtx.transform.apply(tmpCtx, pattern_helper_toConsumableArray(owner.baseTransform));
        if (this.matrix) {
          tmpCtx.transform.apply(tmpCtx, pattern_helper_toConsumableArray(this.matrix));
        }
        applyBoundingBox(tmpCtx, this._bbox);
        tmpCtx.fillStyle = this._createGradient(tmpCtx);
        tmpCtx.fill();
        pattern = ctx.createPattern(tmpCanvas.canvas, "no-repeat");
        var domMatrix = new DOMMatrix(inverse);
        pattern.setTransform(domMatrix);
      } else {
        applyBoundingBox(ctx, this._bbox);
        pattern = this._createGradient(ctx);
      }
      return pattern;
    }
  }]);
}(BaseShadingPattern);
function drawTriangle(data, context, p1, p2, p3, c1, c2, c3) {
  var coords = context.coords,
    colors = context.colors;
  var bytes = data.data,
    rowSize = data.width * 4;
  var tmp;
  if (coords[p1 + 1] > coords[p2 + 1]) {
    tmp = p1;
    p1 = p2;
    p2 = tmp;
    tmp = c1;
    c1 = c2;
    c2 = tmp;
  }
  if (coords[p2 + 1] > coords[p3 + 1]) {
    tmp = p2;
    p2 = p3;
    p3 = tmp;
    tmp = c2;
    c2 = c3;
    c3 = tmp;
  }
  if (coords[p1 + 1] > coords[p2 + 1]) {
    tmp = p1;
    p1 = p2;
    p2 = tmp;
    tmp = c1;
    c1 = c2;
    c2 = tmp;
  }
  var x1 = (coords[p1] + context.offsetX) * context.scaleX;
  var y1 = (coords[p1 + 1] + context.offsetY) * context.scaleY;
  var x2 = (coords[p2] + context.offsetX) * context.scaleX;
  var y2 = (coords[p2 + 1] + context.offsetY) * context.scaleY;
  var x3 = (coords[p3] + context.offsetX) * context.scaleX;
  var y3 = (coords[p3 + 1] + context.offsetY) * context.scaleY;
  if (y1 >= y3) {
    return;
  }
  var c1r = colors[c1],
    c1g = colors[c1 + 1],
    c1b = colors[c1 + 2];
  var c2r = colors[c2],
    c2g = colors[c2 + 1],
    c2b = colors[c2 + 2];
  var c3r = colors[c3],
    c3g = colors[c3 + 1],
    c3b = colors[c3 + 2];
  var minY = Math.round(y1),
    maxY = Math.round(y3);
  var xa, car, cag, cab;
  var xb, cbr, cbg, cbb;
  for (var y = minY; y <= maxY; y++) {
    if (y < y2) {
      var _k = y < y1 ? 0 : (y1 - y) / (y1 - y2);
      xa = x1 - (x1 - x2) * _k;
      car = c1r - (c1r - c2r) * _k;
      cag = c1g - (c1g - c2g) * _k;
      cab = c1b - (c1b - c2b) * _k;
    } else {
      var _k2 = void 0;
      if (y > y3) {
        _k2 = 1;
      } else if (y2 === y3) {
        _k2 = 0;
      } else {
        _k2 = (y2 - y) / (y2 - y3);
      }
      xa = x2 - (x2 - x3) * _k2;
      car = c2r - (c2r - c3r) * _k2;
      cag = c2g - (c2g - c3g) * _k2;
      cab = c2b - (c2b - c3b) * _k2;
    }
    var k = void 0;
    if (y < y1) {
      k = 0;
    } else if (y > y3) {
      k = 1;
    } else {
      k = (y1 - y) / (y1 - y3);
    }
    xb = x1 - (x1 - x3) * k;
    cbr = c1r - (c1r - c3r) * k;
    cbg = c1g - (c1g - c3g) * k;
    cbb = c1b - (c1b - c3b) * k;
    var x1_ = Math.round(Math.min(xa, xb));
    var x2_ = Math.round(Math.max(xa, xb));
    var j = rowSize * y + x1_ * 4;
    for (var x = x1_; x <= x2_; x++) {
      k = (xa - x) / (xa - xb);
      if (k < 0) {
        k = 0;
      } else if (k > 1) {
        k = 1;
      }
      bytes[j++] = car - (car - cbr) * k | 0;
      bytes[j++] = cag - (cag - cbg) * k | 0;
      bytes[j++] = cab - (cab - cbb) * k | 0;
      bytes[j++] = 255;
    }
  }
}
function drawFigure(data, figure, context) {
  var ps = figure.coords;
  var cs = figure.colors;
  var i, ii;
  switch (figure.type) {
    case "lattice":
      var verticesPerRow = figure.verticesPerRow;
      var rows = Math.floor(ps.length / verticesPerRow) - 1;
      var cols = verticesPerRow - 1;
      for (i = 0; i < rows; i++) {
        var q = i * verticesPerRow;
        for (var j = 0; j < cols; j++, q++) {
          drawTriangle(data, context, ps[q], ps[q + 1], ps[q + verticesPerRow], cs[q], cs[q + 1], cs[q + verticesPerRow]);
          drawTriangle(data, context, ps[q + verticesPerRow + 1], ps[q + 1], ps[q + verticesPerRow], cs[q + verticesPerRow + 1], cs[q + 1], cs[q + verticesPerRow]);
        }
      }
      break;
    case "triangles":
      for (i = 0, ii = ps.length; i < ii; i += 3) {
        drawTriangle(data, context, ps[i], ps[i + 1], ps[i + 2], cs[i], cs[i + 1], cs[i + 2]);
      }
      break;
    default:
      throw new Error("illegal figure");
  }
}
var MeshShadingPattern = /*#__PURE__*/function (_BaseShadingPattern2) {
  function MeshShadingPattern(IR) {
    var _this2;
    pattern_helper_classCallCheck(this, MeshShadingPattern);
    _this2 = pattern_helper_callSuper(this, MeshShadingPattern);
    _this2._coords = IR[2];
    _this2._colors = IR[3];
    _this2._figures = IR[4];
    _this2._bounds = IR[5];
    _this2._bbox = IR[7];
    _this2._background = IR[8];
    _this2.matrix = null;
    return _this2;
  }
  pattern_helper_inherits(MeshShadingPattern, _BaseShadingPattern2);
  return pattern_helper_createClass(MeshShadingPattern, [{
    key: "_createMeshCanvas",
    value: function _createMeshCanvas(combinedScale, backgroundColor, cachedCanvases) {
      var EXPECTED_SCALE = 1.1;
      var MAX_PATTERN_SIZE = 3000;
      var BORDER_SIZE = 2;
      var offsetX = Math.floor(this._bounds[0]);
      var offsetY = Math.floor(this._bounds[1]);
      var boundsWidth = Math.ceil(this._bounds[2]) - offsetX;
      var boundsHeight = Math.ceil(this._bounds[3]) - offsetY;
      var width = Math.min(Math.ceil(Math.abs(boundsWidth * combinedScale[0] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
      var height = Math.min(Math.ceil(Math.abs(boundsHeight * combinedScale[1] * EXPECTED_SCALE)), MAX_PATTERN_SIZE);
      var scaleX = boundsWidth / width;
      var scaleY = boundsHeight / height;
      var context = {
        coords: this._coords,
        colors: this._colors,
        offsetX: -offsetX,
        offsetY: -offsetY,
        scaleX: 1 / scaleX,
        scaleY: 1 / scaleY
      };
      var paddedWidth = width + BORDER_SIZE * 2;
      var paddedHeight = height + BORDER_SIZE * 2;
      var tmpCanvas = cachedCanvases.getCanvas("mesh", paddedWidth, paddedHeight);
      var tmpCtx = tmpCanvas.context;
      var data = tmpCtx.createImageData(width, height);
      if (backgroundColor) {
        var bytes = data.data;
        for (var i = 0, ii = bytes.length; i < ii; i += 4) {
          bytes[i] = backgroundColor[0];
          bytes[i + 1] = backgroundColor[1];
          bytes[i + 2] = backgroundColor[2];
          bytes[i + 3] = 255;
        }
      }
      var _iterator2 = pattern_helper_createForOfIteratorHelper(this._figures),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var figure = _step2.value;
          drawFigure(data, figure, context);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      tmpCtx.putImageData(data, BORDER_SIZE, BORDER_SIZE);
      var canvas = tmpCanvas.canvas;
      return {
        canvas: canvas,
        offsetX: offsetX - BORDER_SIZE * scaleX,
        offsetY: offsetY - BORDER_SIZE * scaleY,
        scaleX: scaleX,
        scaleY: scaleY
      };
    }
  }, {
    key: "getPattern",
    value: function getPattern(ctx, owner, inverse, pathType) {
      applyBoundingBox(ctx, this._bbox);
      var scale;
      if (pathType === PathType.SHADING) {
        scale = Util.singularValueDecompose2dScale(getCurrentTransform(ctx));
      } else {
        scale = Util.singularValueDecompose2dScale(owner.baseTransform);
        if (this.matrix) {
          var matrixScale = Util.singularValueDecompose2dScale(this.matrix);
          scale = [scale[0] * matrixScale[0], scale[1] * matrixScale[1]];
        }
      }
      var temporaryPatternCanvas = this._createMeshCanvas(scale, pathType === PathType.SHADING ? null : this._background, owner.cachedCanvases);
      if (pathType !== PathType.SHADING) {
        ctx.setTransform.apply(ctx, pattern_helper_toConsumableArray(owner.baseTransform));
        if (this.matrix) {
          ctx.transform.apply(ctx, pattern_helper_toConsumableArray(this.matrix));
        }
      }
      ctx.translate(temporaryPatternCanvas.offsetX, temporaryPatternCanvas.offsetY);
      ctx.scale(temporaryPatternCanvas.scaleX, temporaryPatternCanvas.scaleY);
      return ctx.createPattern(temporaryPatternCanvas.canvas, "no-repeat");
    }
  }]);
}(BaseShadingPattern);
var DummyShadingPattern = /*#__PURE__*/function (_BaseShadingPattern3) {
  function DummyShadingPattern() {
    pattern_helper_classCallCheck(this, DummyShadingPattern);
    return pattern_helper_callSuper(this, DummyShadingPattern, arguments);
  }
  pattern_helper_inherits(DummyShadingPattern, _BaseShadingPattern3);
  return pattern_helper_createClass(DummyShadingPattern, [{
    key: "getPattern",
    value: function getPattern() {
      return "hotpink";
    }
  }]);
}(BaseShadingPattern);
function getShadingPattern(IR) {
  switch (IR[0]) {
    case "RadialAxial":
      return new RadialAxialShadingPattern(IR);
    case "Mesh":
      return new MeshShadingPattern(IR);
    case "Dummy":
      return new DummyShadingPattern();
  }
  throw new Error("Unknown IR type: ".concat(IR[0]));
}
var PaintType = {
  COLORED: 1,
  UNCOLORED: 2
};
var TilingPattern = /*#__PURE__*/function () {
  function TilingPattern(IR, color, ctx, canvasGraphicsFactory, baseTransform) {
    pattern_helper_classCallCheck(this, TilingPattern);
    this.operatorList = IR[2];
    this.matrix = IR[3];
    this.bbox = IR[4];
    this.xstep = IR[5];
    this.ystep = IR[6];
    this.paintType = IR[7];
    this.tilingType = IR[8];
    this.color = color;
    this.ctx = ctx;
    this.canvasGraphicsFactory = canvasGraphicsFactory;
    this.baseTransform = baseTransform;
  }
  return pattern_helper_createClass(TilingPattern, [{
    key: "createPatternCanvas",
    value: function createPatternCanvas(owner) {
      var bbox = this.bbox,
        operatorList = this.operatorList,
        paintType = this.paintType,
        tilingType = this.tilingType,
        color = this.color,
        canvasGraphicsFactory = this.canvasGraphicsFactory;
      var xstep = this.xstep,
        ystep = this.ystep;
      xstep = Math.abs(xstep);
      ystep = Math.abs(ystep);
      info("TilingType: " + tilingType);
      var x0 = bbox[0],
        y0 = bbox[1],
        x1 = bbox[2],
        y1 = bbox[3];
      var width = x1 - x0;
      var height = y1 - y0;
      var matrixScale = Util.singularValueDecompose2dScale(this.matrix);
      var curMatrixScale = Util.singularValueDecompose2dScale(this.baseTransform);
      var combinedScaleX = matrixScale[0] * curMatrixScale[0];
      var combinedScaleY = matrixScale[1] * curMatrixScale[1];
      var canvasWidth = width,
        canvasHeight = height,
        redrawHorizontally = false,
        redrawVertically = false;
      var xScaledStep = Math.ceil(xstep * combinedScaleX);
      var yScaledStep = Math.ceil(ystep * combinedScaleY);
      var xScaledWidth = Math.ceil(width * combinedScaleX);
      var yScaledHeight = Math.ceil(height * combinedScaleY);
      if (xScaledStep >= xScaledWidth) {
        canvasWidth = xstep;
      } else {
        redrawHorizontally = true;
      }
      if (yScaledStep >= yScaledHeight) {
        canvasHeight = ystep;
      } else {
        redrawVertically = true;
      }
      var dimx = this.getSizeAndScale(canvasWidth, this.ctx.canvas.width, combinedScaleX);
      var dimy = this.getSizeAndScale(canvasHeight, this.ctx.canvas.height, combinedScaleY);
      var tmpCanvas = owner.cachedCanvases.getCanvas("pattern", dimx.size, dimy.size);
      var tmpCtx = tmpCanvas.context;
      var graphics = canvasGraphicsFactory.createCanvasGraphics(tmpCtx);
      graphics.groupLevel = owner.groupLevel;
      this.setFillAndStrokeStyleToContext(graphics, paintType, color);
      tmpCtx.translate(-dimx.scale * x0, -dimy.scale * y0);
      graphics.transform(dimx.scale, 0, 0, dimy.scale, 0, 0);
      tmpCtx.save();
      this.clipBbox(graphics, x0, y0, x1, y1);
      graphics.baseTransform = getCurrentTransform(graphics.ctx);
      graphics.executeOperatorList(operatorList);
      graphics.endDrawing();
      tmpCtx.restore();
      if (redrawHorizontally || redrawVertically) {
        var image = tmpCanvas.canvas;
        if (redrawHorizontally) {
          canvasWidth = xstep;
        }
        if (redrawVertically) {
          canvasHeight = ystep;
        }
        var dimx2 = this.getSizeAndScale(canvasWidth, this.ctx.canvas.width, combinedScaleX);
        var dimy2 = this.getSizeAndScale(canvasHeight, this.ctx.canvas.height, combinedScaleY);
        var xSize = dimx2.size;
        var ySize = dimy2.size;
        var tmpCanvas2 = owner.cachedCanvases.getCanvas("pattern-workaround", xSize, ySize);
        var tmpCtx2 = tmpCanvas2.context;
        var ii = redrawHorizontally ? Math.floor(width / xstep) : 0;
        var jj = redrawVertically ? Math.floor(height / ystep) : 0;
        for (var i = 0; i <= ii; i++) {
          for (var j = 0; j <= jj; j++) {
            tmpCtx2.drawImage(image, xSize * i, ySize * j, xSize, ySize, 0, 0, xSize, ySize);
          }
        }
        return {
          canvas: tmpCanvas2.canvas,
          scaleX: dimx2.scale,
          scaleY: dimy2.scale,
          offsetX: x0,
          offsetY: y0
        };
      }
      return {
        canvas: tmpCanvas.canvas,
        scaleX: dimx.scale,
        scaleY: dimy.scale,
        offsetX: x0,
        offsetY: y0
      };
    }
  }, {
    key: "getSizeAndScale",
    value: function getSizeAndScale(step, realOutputSize, scale) {
      var maxSize = Math.max(TilingPattern.MAX_PATTERN_SIZE, realOutputSize);
      var size = Math.ceil(step * scale);
      if (size >= maxSize) {
        size = maxSize;
      } else {
        scale = size / step;
      }
      return {
        scale: scale,
        size: size
      };
    }
  }, {
    key: "clipBbox",
    value: function clipBbox(graphics, x0, y0, x1, y1) {
      var bboxWidth = x1 - x0;
      var bboxHeight = y1 - y0;
      graphics.ctx.rect(x0, y0, bboxWidth, bboxHeight);
      graphics.current.updateRectMinMax(getCurrentTransform(graphics.ctx), [x0, y0, x1, y1]);
      graphics.clip();
      graphics.endPath();
    }
  }, {
    key: "setFillAndStrokeStyleToContext",
    value: function setFillAndStrokeStyleToContext(graphics, paintType, color) {
      var context = graphics.ctx,
        current = graphics.current;
      switch (paintType) {
        case PaintType.COLORED:
          var ctx = this.ctx;
          context.fillStyle = ctx.fillStyle;
          context.strokeStyle = ctx.strokeStyle;
          current.fillColor = ctx.fillStyle;
          current.strokeColor = ctx.strokeStyle;
          break;
        case PaintType.UNCOLORED:
          var cssColor = Util.makeHexColor(color[0], color[1], color[2]);
          context.fillStyle = cssColor;
          context.strokeStyle = cssColor;
          current.fillColor = cssColor;
          current.strokeColor = cssColor;
          break;
        default:
          throw new FormatError("Unsupported paint type: ".concat(paintType));
      }
    }
  }, {
    key: "getPattern",
    value: function getPattern(ctx, owner, inverse, pathType) {
      var matrix = inverse;
      if (pathType !== PathType.SHADING) {
        matrix = Util.transform(matrix, owner.baseTransform);
        if (this.matrix) {
          matrix = Util.transform(matrix, this.matrix);
        }
      }
      var temporaryPatternCanvas = this.createPatternCanvas(owner);
      var domMatrix = new DOMMatrix(matrix);
      domMatrix = domMatrix.translate(temporaryPatternCanvas.offsetX, temporaryPatternCanvas.offsetY);
      domMatrix = domMatrix.scale(1 / temporaryPatternCanvas.scaleX, 1 / temporaryPatternCanvas.scaleY);
      var pattern = ctx.createPattern(temporaryPatternCanvas.canvas, "repeat");
      pattern.setTransform(domMatrix);
      return pattern;
    }
  }]);
}();
pattern_helper_defineProperty(TilingPattern, "MAX_PATTERN_SIZE", 3000);

;// ./src/shared/image_utils.js



















































function image_utils_slicedToArray(r, e) { return image_utils_arrayWithHoles(r) || image_utils_iterableToArrayLimit(r, e) || image_utils_unsupportedIterableToArray(r, e) || image_utils_nonIterableRest(); }
function image_utils_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function image_utils_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return image_utils_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? image_utils_arrayLikeToArray(r, a) : void 0; } }
function image_utils_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function image_utils_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function image_utils_arrayWithHoles(r) { if (Array.isArray(r)) return r; }

function convertToRGBA(params) {
  switch (params.kind) {
    case ImageKind.GRAYSCALE_1BPP:
      return convertBlackAndWhiteToRGBA(params);
    case ImageKind.RGB_24BPP:
      return convertRGBToRGBA(params);
  }
  return null;
}
function convertBlackAndWhiteToRGBA(_ref) {
  var src = _ref.src,
    _ref$srcPos = _ref.srcPos,
    srcPos = _ref$srcPos === void 0 ? 0 : _ref$srcPos,
    dest = _ref.dest,
    width = _ref.width,
    height = _ref.height,
    _ref$nonBlackColor = _ref.nonBlackColor,
    nonBlackColor = _ref$nonBlackColor === void 0 ? 0xffffffff : _ref$nonBlackColor,
    _ref$inverseDecode = _ref.inverseDecode,
    inverseDecode = _ref$inverseDecode === void 0 ? false : _ref$inverseDecode;
  var black = util_FeatureTest.isLittleEndian ? 0xff000000 : 0x000000ff;
  var _ref2 = inverseDecode ? [nonBlackColor, black] : [black, nonBlackColor],
    _ref3 = image_utils_slicedToArray(_ref2, 2),
    zeroMapping = _ref3[0],
    oneMapping = _ref3[1];
  var widthInSource = width >> 3;
  var widthRemainder = width & 7;
  var srcLength = src.length;
  dest = new Uint32Array(dest.buffer);
  var destPos = 0;
  for (var i = 0; i < height; i++) {
    for (var max = srcPos + widthInSource; srcPos < max; srcPos++) {
      var _elem = srcPos < srcLength ? src[srcPos] : 255;
      dest[destPos++] = _elem & 128 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 64 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 32 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 16 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 8 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 4 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 2 ? oneMapping : zeroMapping;
      dest[destPos++] = _elem & 1 ? oneMapping : zeroMapping;
    }
    if (widthRemainder === 0) {
      continue;
    }
    var elem = srcPos < srcLength ? src[srcPos++] : 255;
    for (var j = 0; j < widthRemainder; j++) {
      dest[destPos++] = elem & 1 << 7 - j ? oneMapping : zeroMapping;
    }
  }
  return {
    srcPos: srcPos,
    destPos: destPos
  };
}
function convertRGBToRGBA(_ref4) {
  var src = _ref4.src,
    _ref4$srcPos = _ref4.srcPos,
    srcPos = _ref4$srcPos === void 0 ? 0 : _ref4$srcPos,
    dest = _ref4.dest,
    _ref4$destPos = _ref4.destPos,
    destPos = _ref4$destPos === void 0 ? 0 : _ref4$destPos,
    width = _ref4.width,
    height = _ref4.height;
  var i = 0;
  var len = width * height * 3;
  var len32 = len >> 2;
  var src32 = new Uint32Array(src.buffer, srcPos, len32);
  if (FeatureTest.isLittleEndian) {
    for (; i < len32 - 2; i += 3, destPos += 4) {
      var s1 = src32[i];
      var s2 = src32[i + 1];
      var s3 = src32[i + 2];
      dest[destPos] = s1 | 0xff000000;
      dest[destPos + 1] = s1 >>> 24 | s2 << 8 | 0xff000000;
      dest[destPos + 2] = s2 >>> 16 | s3 << 16 | 0xff000000;
      dest[destPos + 3] = s3 >>> 8 | 0xff000000;
    }
    for (var j = i * 4, jj = srcPos + len; j < jj; j += 3) {
      dest[destPos++] = src[j] | src[j + 1] << 8 | src[j + 2] << 16 | 0xff000000;
    }
  } else {
    for (; i < len32 - 2; i += 3, destPos += 4) {
      var _s = src32[i];
      var _s2 = src32[i + 1];
      var _s3 = src32[i + 2];
      dest[destPos] = _s | 0xff;
      dest[destPos + 1] = _s << 24 | _s2 >>> 8 | 0xff;
      dest[destPos + 2] = _s2 << 16 | _s3 >>> 16 | 0xff;
      dest[destPos + 3] = _s3 << 8 | 0xff;
    }
    for (var _j = i * 4, _jj = srcPos + len; _j < _jj; _j += 3) {
      dest[destPos++] = src[_j] << 24 | src[_j + 1] << 16 | src[_j + 2] << 8 | 0xff;
    }
  }
  return {
    srcPos: srcPos + len,
    destPos: destPos
  };
}
function grayToRGBA(src, dest) {
  if (FeatureTest.isLittleEndian) {
    for (var i = 0, ii = src.length; i < ii; i++) {
      dest[i] = src[i] * 0x10101 | 0xff000000;
    }
  } else {
    for (var _i = 0, _ii = src.length; _i < _ii; _i++) {
      dest[_i] = src[_i] * 0x1010100 | 0x000000ff;
    }
  }
}

;// ./src/display/canvas.js
function canvas_typeof(o) { "@babel/helpers - typeof"; return canvas_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, canvas_typeof(o); }
function canvas_toConsumableArray(r) { return canvas_arrayWithoutHoles(r) || canvas_iterableToArray(r) || canvas_unsupportedIterableToArray(r) || canvas_nonIterableSpread(); }
function canvas_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function canvas_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function canvas_arrayWithoutHoles(r) { if (Array.isArray(r)) return canvas_arrayLikeToArray(r); }
function canvas_classPrivateMethodInitSpec(e, a) { canvas_checkPrivateRedeclaration(e, a), a.add(e); }
function canvas_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function canvas_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function canvas_readOnlyError(r) { throw new TypeError('"' + r + '" is read-only'); }
function canvas_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = canvas_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function canvas_slicedToArray(r, e) { return canvas_arrayWithHoles(r) || canvas_iterableToArrayLimit(r, e) || canvas_unsupportedIterableToArray(r, e) || canvas_nonIterableRest(); }
function canvas_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function canvas_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return canvas_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? canvas_arrayLikeToArray(r, a) : void 0; } }
function canvas_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function canvas_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function canvas_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function canvas_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function canvas_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, canvas_toPropertyKey(o.key), o); } }
function canvas_createClass(e, r, t) { return r && canvas_defineProperties(e.prototype, r), t && canvas_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function canvas_toPropertyKey(t) { var i = canvas_toPrimitive(t, "string"); return "symbol" == canvas_typeof(i) ? i : i + ""; }
function canvas_toPrimitive(t, r) { if ("object" != canvas_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != canvas_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }













































































var MIN_FONT_SIZE = 16;
var MAX_FONT_SIZE = 100;
var EXECUTION_TIME = 15;
var EXECUTION_STEPS = 10;
var MAX_SIZE_TO_COMPILE = 1000;
var FULL_CHUNK_HEIGHT = 16;
function mirrorContextOperations(ctx, destCtx) {
  if (ctx._removeMirroring) {
    throw new Error("Context is already forwarding operations.");
  }
  ctx.__originalSave = ctx.save;
  ctx.__originalRestore = ctx.restore;
  ctx.__originalRotate = ctx.rotate;
  ctx.__originalScale = ctx.scale;
  ctx.__originalTranslate = ctx.translate;
  ctx.__originalTransform = ctx.transform;
  ctx.__originalSetTransform = ctx.setTransform;
  ctx.__originalResetTransform = ctx.resetTransform;
  ctx.__originalClip = ctx.clip;
  ctx.__originalMoveTo = ctx.moveTo;
  ctx.__originalLineTo = ctx.lineTo;
  ctx.__originalBezierCurveTo = ctx.bezierCurveTo;
  ctx.__originalRect = ctx.rect;
  ctx.__originalClosePath = ctx.closePath;
  ctx.__originalBeginPath = ctx.beginPath;
  ctx._removeMirroring = function () {
    ctx.save = ctx.__originalSave;
    ctx.restore = ctx.__originalRestore;
    ctx.rotate = ctx.__originalRotate;
    ctx.scale = ctx.__originalScale;
    ctx.translate = ctx.__originalTranslate;
    ctx.transform = ctx.__originalTransform;
    ctx.setTransform = ctx.__originalSetTransform;
    ctx.resetTransform = ctx.__originalResetTransform;
    ctx.clip = ctx.__originalClip;
    ctx.moveTo = ctx.__originalMoveTo;
    ctx.lineTo = ctx.__originalLineTo;
    ctx.bezierCurveTo = ctx.__originalBezierCurveTo;
    ctx.rect = ctx.__originalRect;
    ctx.closePath = ctx.__originalClosePath;
    ctx.beginPath = ctx.__originalBeginPath;
    delete ctx._removeMirroring;
  };
  ctx.save = function ctxSave() {
    destCtx.save();
    this.__originalSave();
  };
  ctx.restore = function ctxRestore() {
    destCtx.restore();
    this.__originalRestore();
  };
  ctx.translate = function ctxTranslate(x, y) {
    destCtx.translate(x, y);
    this.__originalTranslate(x, y);
  };
  ctx.scale = function ctxScale(x, y) {
    destCtx.scale(x, y);
    this.__originalScale(x, y);
  };
  ctx.transform = function ctxTransform(a, b, c, d, e, f) {
    destCtx.transform(a, b, c, d, e, f);
    this.__originalTransform(a, b, c, d, e, f);
  };
  ctx.setTransform = function ctxSetTransform(a, b, c, d, e, f) {
    destCtx.setTransform(a, b, c, d, e, f);
    this.__originalSetTransform(a, b, c, d, e, f);
  };
  ctx.resetTransform = function ctxResetTransform() {
    destCtx.resetTransform();
    this.__originalResetTransform();
  };
  ctx.rotate = function ctxRotate(angle) {
    destCtx.rotate(angle);
    this.__originalRotate(angle);
  };
  ctx.clip = function ctxRotate(rule) {
    destCtx.clip(rule);
    this.__originalClip(rule);
  };
  ctx.moveTo = function (x, y) {
    destCtx.moveTo(x, y);
    this.__originalMoveTo(x, y);
  };
  ctx.lineTo = function (x, y) {
    destCtx.lineTo(x, y);
    this.__originalLineTo(x, y);
  };
  ctx.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y) {
    destCtx.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
    this.__originalBezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
  };
  ctx.rect = function (x, y, width, height) {
    destCtx.rect(x, y, width, height);
    this.__originalRect(x, y, width, height);
  };
  ctx.closePath = function () {
    destCtx.closePath();
    this.__originalClosePath();
  };
  ctx.beginPath = function () {
    destCtx.beginPath();
    this.__originalBeginPath();
  };
}
var CachedCanvases = /*#__PURE__*/function () {
  function CachedCanvases(canvasFactory) {
    canvas_classCallCheck(this, CachedCanvases);
    this.canvasFactory = canvasFactory;
    this.cache = Object.create(null);
  }
  return canvas_createClass(CachedCanvases, [{
    key: "getCanvas",
    value: function getCanvas(id, width, height) {
      var canvasEntry;
      if (this.cache[id] !== undefined) {
        canvasEntry = this.cache[id];
        this.canvasFactory.reset(canvasEntry, width, height);
      } else {
        canvasEntry = this.canvasFactory.create(width, height);
        this.cache[id] = canvasEntry;
      }
      return canvasEntry;
    }
  }, {
    key: "delete",
    value: function _delete(id) {
      delete this.cache[id];
    }
  }, {
    key: "clear",
    value: function clear() {
      for (var id in this.cache) {
        var canvasEntry = this.cache[id];
        this.canvasFactory.destroy(canvasEntry);
        delete this.cache[id];
      }
    }
  }]);
}();
function drawImageAtIntegerCoords(ctx, srcImg, srcX, srcY, srcW, srcH, destX, destY, destW, destH) {
  var _getCurrentTransform = getCurrentTransform(ctx),
    _getCurrentTransform2 = canvas_slicedToArray(_getCurrentTransform, 6),
    a = _getCurrentTransform2[0],
    b = _getCurrentTransform2[1],
    c = _getCurrentTransform2[2],
    d = _getCurrentTransform2[3],
    tx = _getCurrentTransform2[4],
    ty = _getCurrentTransform2[5];
  if (b === 0 && c === 0) {
    var tlX = destX * a + tx;
    var rTlX = Math.round(tlX);
    var tlY = destY * d + ty;
    var rTlY = Math.round(tlY);
    var brX = (destX + destW) * a + tx;
    var rWidth = Math.abs(Math.round(brX) - rTlX) || 1;
    var brY = (destY + destH) * d + ty;
    var rHeight = Math.abs(Math.round(brY) - rTlY) || 1;
    ctx.setTransform(Math.sign(a), 0, 0, Math.sign(d), rTlX, rTlY);
    ctx.drawImage(srcImg, srcX, srcY, srcW, srcH, 0, 0, rWidth, rHeight);
    ctx.setTransform(a, b, c, d, tx, ty);
    return [rWidth, rHeight];
  }
  if (a === 0 && d === 0) {
    var _tlX = destY * c + tx;
    var _rTlX = Math.round(_tlX);
    var _tlY = destX * b + ty;
    var _rTlY = Math.round(_tlY);
    var _brX = (destY + destH) * c + tx;
    var _rWidth = Math.abs(Math.round(_brX) - _rTlX) || 1;
    var _brY = (destX + destW) * b + ty;
    var _rHeight = Math.abs(Math.round(_brY) - _rTlY) || 1;
    ctx.setTransform(0, Math.sign(b), Math.sign(c), 0, _rTlX, _rTlY);
    ctx.drawImage(srcImg, srcX, srcY, srcW, srcH, 0, 0, _rHeight, _rWidth);
    ctx.setTransform(a, b, c, d, tx, ty);
    return [_rHeight, _rWidth];
  }
  ctx.drawImage(srcImg, srcX, srcY, srcW, srcH, destX, destY, destW, destH);
  var scaleX = Math.hypot(a, b);
  var scaleY = Math.hypot(c, d);
  return [scaleX * destW, scaleY * destH];
}
function compileType3Glyph(imgData) {
  var width = imgData.width,
    height = imgData.height;
  if (width > MAX_SIZE_TO_COMPILE || height > MAX_SIZE_TO_COMPILE) {
    return null;
  }
  var POINT_TO_PROCESS_LIMIT = 1000;
  var POINT_TYPES = new Uint8Array([0, 2, 4, 0, 1, 0, 5, 4, 8, 10, 0, 8, 0, 2, 1, 0]);
  var width1 = width + 1;
  var points = new Uint8Array(width1 * (height + 1));
  var i, j, j0;
  var lineSize = width + 7 & ~7;
  var data = new Uint8Array(lineSize * height),
    pos = 0;
  var _iterator = canvas_createForOfIteratorHelper(imgData.data),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var elem = _step.value;
      var mask = 128;
      while (mask > 0) {
        data[pos++] = elem & mask ? 0 : 255;
        mask >>= 1;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  var count = 0;
  pos = 0;
  if (data[pos] !== 0) {
    points[0] = 1;
    ++count;
  }
  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j] = data[pos] ? 2 : 1;
      ++count;
    }
    pos++;
  }
  if (data[pos] !== 0) {
    points[j] = 2;
    ++count;
  }
  for (i = 1; i < height; i++) {
    pos = i * lineSize;
    j0 = i * width1;
    if (data[pos - lineSize] !== data[pos]) {
      points[j0] = data[pos] ? 1 : 8;
      ++count;
    }
    var sum = (data[pos] ? 4 : 0) + (data[pos - lineSize] ? 8 : 0);
    for (j = 1; j < width; j++) {
      sum = (sum >> 2) + (data[pos + 1] ? 4 : 0) + (data[pos - lineSize + 1] ? 8 : 0);
      if (POINT_TYPES[sum]) {
        points[j0 + j] = POINT_TYPES[sum];
        ++count;
      }
      pos++;
    }
    if (data[pos - lineSize] !== data[pos]) {
      points[j0 + j] = data[pos] ? 2 : 4;
      ++count;
    }
    if (count > POINT_TO_PROCESS_LIMIT) {
      return null;
    }
  }
  pos = lineSize * (height - 1);
  j0 = i * width1;
  if (data[pos] !== 0) {
    points[j0] = 8;
    ++count;
  }
  for (j = 1; j < width; j++) {
    if (data[pos] !== data[pos + 1]) {
      points[j0 + j] = data[pos] ? 4 : 8;
      ++count;
    }
    pos++;
  }
  if (data[pos] !== 0) {
    points[j0 + j] = 4;
    ++count;
  }
  if (count > POINT_TO_PROCESS_LIMIT) {
    return null;
  }
  var steps = new Int32Array([0, width1, -1, 0, -width1, 0, 0, 0, 1]);
  var path = new Path2D();
  for (i = 0; count && i <= height; i++) {
    var p = i * width1;
    var end = p + width;
    while (p < end && !points[p]) {
      p++;
    }
    if (p === end) {
      continue;
    }
    path.moveTo(p % width1, i);
    var p0 = p;
    var type = points[p];
    do {
      var step = steps[type];
      do {
        p += step;
      } while (!points[p]);
      var pp = points[p];
      if (pp !== 5 && pp !== 10) {
        type = pp;
        points[p] = 0;
      } else {
        type = pp & 0x33 * type >> 4;
        points[p] &= type >> 2 | type << 2;
      }
      path.lineTo(p % width1, p / width1 | 0);
      if (!points[p]) {
        --count;
      }
    } while (p0 !== p);
    --i;
  }
  data = null;
  points = null;
  var drawOutline = function drawOutline(c) {
    c.save();
    c.scale(1 / width, -1 / height);
    c.translate(0, -height);
    c.fill(path);
    c.beginPath();
    c.restore();
  };
  return drawOutline;
}
var CanvasExtraState = /*#__PURE__*/function () {
  function CanvasExtraState(width, height) {
    canvas_classCallCheck(this, CanvasExtraState);
    this.alphaIsShape = false;
    this.fontSize = 0;
    this.fontSizeScale = 1;
    this.textMatrix = IDENTITY_MATRIX;
    this.textMatrixScale = 1;
    this.fontMatrix = FONT_IDENTITY_MATRIX;
    this.leading = 0;
    this.x = 0;
    this.y = 0;
    this.lineX = 0;
    this.lineY = 0;
    this.charSpacing = 0;
    this.wordSpacing = 0;
    this.textHScale = 1;
    this.textRenderingMode = TextRenderingMode.FILL;
    this.textRise = 0;
    this.fillColor = "#000000";
    this.strokeColor = "#000000";
    this.patternFill = false;
    this.patternStroke = false;
    this.fillAlpha = 1;
    this.strokeAlpha = 1;
    this.lineWidth = 1;
    this.activeSMask = null;
    this.transferMaps = "none";
    this.startNewPathAndClipBox([0, 0, width, height]);
  }
  return canvas_createClass(CanvasExtraState, [{
    key: "clone",
    value: function clone() {
      var clone = Object.create(this);
      clone.clipBox = this.clipBox.slice();
      return clone;
    }
  }, {
    key: "setCurrentPoint",
    value: function setCurrentPoint(x, y) {
      this.x = x;
      this.y = y;
    }
  }, {
    key: "updatePathMinMax",
    value: function updatePathMinMax(transform, x, y) {
      var _Util$applyTransform = Util.applyTransform([x, y], transform);
      var _Util$applyTransform2 = canvas_slicedToArray(_Util$applyTransform, 2);
      x = _Util$applyTransform2[0];
      y = _Util$applyTransform2[1];
      this.minX = Math.min(this.minX, x);
      this.minY = Math.min(this.minY, y);
      this.maxX = Math.max(this.maxX, x);
      this.maxY = Math.max(this.maxY, y);
    }
  }, {
    key: "updateRectMinMax",
    value: function updateRectMinMax(transform, rect) {
      var p1 = Util.applyTransform(rect, transform);
      var p2 = Util.applyTransform(rect.slice(2), transform);
      var p3 = Util.applyTransform([rect[0], rect[3]], transform);
      var p4 = Util.applyTransform([rect[2], rect[1]], transform);
      this.minX = Math.min(this.minX, p1[0], p2[0], p3[0], p4[0]);
      this.minY = Math.min(this.minY, p1[1], p2[1], p3[1], p4[1]);
      this.maxX = Math.max(this.maxX, p1[0], p2[0], p3[0], p4[0]);
      this.maxY = Math.max(this.maxY, p1[1], p2[1], p3[1], p4[1]);
    }
  }, {
    key: "updateScalingPathMinMax",
    value: function updateScalingPathMinMax(transform, minMax) {
      Util.scaleMinMax(transform, minMax);
      this.minX = Math.min(this.minX, minMax[0]);
      this.minY = Math.min(this.minY, minMax[1]);
      this.maxX = Math.max(this.maxX, minMax[2]);
      this.maxY = Math.max(this.maxY, minMax[3]);
    }
  }, {
    key: "updateCurvePathMinMax",
    value: function updateCurvePathMinMax(transform, x0, y0, x1, y1, x2, y2, x3, y3, minMax) {
      var box = Util.bezierBoundingBox(x0, y0, x1, y1, x2, y2, x3, y3, minMax);
      if (minMax) {
        return;
      }
      this.updateRectMinMax(transform, box);
    }
  }, {
    key: "getPathBoundingBox",
    value: function getPathBoundingBox() {
      var pathType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : PathType.FILL;
      var transform = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var box = [this.minX, this.minY, this.maxX, this.maxY];
      if (pathType === PathType.STROKE) {
        if (!transform) {
          unreachable("Stroke bounding box must include transform.");
        }
        var scale = Util.singularValueDecompose2dScale(transform);
        var xStrokePad = scale[0] * this.lineWidth / 2;
        var yStrokePad = scale[1] * this.lineWidth / 2;
        box[0] -= xStrokePad;
        box[1] -= yStrokePad;
        box[2] += xStrokePad;
        box[3] += yStrokePad;
      }
      return box;
    }
  }, {
    key: "updateClipFromPath",
    value: function updateClipFromPath() {
      var intersect = Util.intersect(this.clipBox, this.getPathBoundingBox());
      this.startNewPathAndClipBox(intersect || [0, 0, 0, 0]);
    }
  }, {
    key: "isEmptyClip",
    value: function isEmptyClip() {
      return this.minX === Infinity;
    }
  }, {
    key: "startNewPathAndClipBox",
    value: function startNewPathAndClipBox(box) {
      this.clipBox = box;
      this.minX = Infinity;
      this.minY = Infinity;
      this.maxX = 0;
      this.maxY = 0;
    }
  }, {
    key: "getClippedPathBoundingBox",
    value: function getClippedPathBoundingBox() {
      var pathType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : PathType.FILL;
      var transform = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      return Util.intersect(this.clipBox, this.getPathBoundingBox(pathType, transform));
    }
  }]);
}();
function putBinaryImageData(ctx, imgData) {
  if (imgData instanceof ImageData) {
    ctx.putImageData(imgData, 0, 0);
    return;
  }
  var height = imgData.height,
    width = imgData.width;
  var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
  var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
  var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
  var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
  var srcPos = 0,
    destPos;
  var src = imgData.data;
  var dest = chunkImgData.data;
  var i, j, thisChunkHeight, elemsInThisChunk;
  if (imgData.kind === util_ImageKind.GRAYSCALE_1BPP) {
    var srcLength = src.byteLength;
    var dest32 = new Uint32Array(dest.buffer, 0, dest.byteLength >> 2);
    var dest32DataLength = dest32.length;
    var fullSrcDiff = width + 7 >> 3;
    var white = 0xffffffff;
    var black = util_FeatureTest.isLittleEndian ? 0xff000000 : 0x000000ff;
    for (i = 0; i < totalChunks; i++) {
      thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
      destPos = 0;
      for (j = 0; j < thisChunkHeight; j++) {
        var srcDiff = srcLength - srcPos;
        var k = 0;
        var kEnd = srcDiff > fullSrcDiff ? width : srcDiff * 8 - 7;
        var kEndUnrolled = kEnd & ~7;
        var mask = 0;
        var srcByte = 0;
        for (; k < kEndUnrolled; k += 8) {
          srcByte = src[srcPos++];
          dest32[destPos++] = srcByte & 128 ? white : black;
          dest32[destPos++] = srcByte & 64 ? white : black;
          dest32[destPos++] = srcByte & 32 ? white : black;
          dest32[destPos++] = srcByte & 16 ? white : black;
          dest32[destPos++] = srcByte & 8 ? white : black;
          dest32[destPos++] = srcByte & 4 ? white : black;
          dest32[destPos++] = srcByte & 2 ? white : black;
          dest32[destPos++] = srcByte & 1 ? white : black;
        }
        for (; k < kEnd; k++) {
          if (mask === 0) {
            srcByte = src[srcPos++];
            mask = 128;
          }
          dest32[destPos++] = srcByte & mask ? white : black;
          mask >>= 1;
        }
      }
      while (destPos < dest32DataLength) {
        dest32[destPos++] = 0;
      }
      ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
    }
  } else if (imgData.kind === util_ImageKind.RGBA_32BPP) {
    j = 0;
    elemsInThisChunk = width * FULL_CHUNK_HEIGHT * 4;
    for (i = 0; i < fullChunks; i++) {
      dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
      srcPos += elemsInThisChunk;
      ctx.putImageData(chunkImgData, 0, j);
      j += FULL_CHUNK_HEIGHT;
    }
    if (i < totalChunks) {
      elemsInThisChunk = width * partialChunkHeight * 4;
      dest.set(src.subarray(srcPos, srcPos + elemsInThisChunk));
      ctx.putImageData(chunkImgData, 0, j);
    }
  } else if (imgData.kind === util_ImageKind.RGB_24BPP) {
    thisChunkHeight = FULL_CHUNK_HEIGHT;
    elemsInThisChunk = width * thisChunkHeight;
    for (i = 0; i < totalChunks; i++) {
      if (i >= fullChunks) {
        thisChunkHeight = partialChunkHeight;
        elemsInThisChunk = width * thisChunkHeight;
      }
      destPos = 0;
      for (j = elemsInThisChunk; j--;) {
        dest[destPos++] = src[srcPos++];
        dest[destPos++] = src[srcPos++];
        dest[destPos++] = src[srcPos++];
        dest[destPos++] = 255;
      }
      ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
    }
  } else {
    throw new Error("bad image kind: ".concat(imgData.kind));
  }
}
function putBinaryImageMask(ctx, imgData) {
  if (imgData.bitmap) {
    ctx.drawImage(imgData.bitmap, 0, 0);
    return;
  }
  var height = imgData.height,
    width = imgData.width;
  var partialChunkHeight = height % FULL_CHUNK_HEIGHT;
  var fullChunks = (height - partialChunkHeight) / FULL_CHUNK_HEIGHT;
  var totalChunks = partialChunkHeight === 0 ? fullChunks : fullChunks + 1;
  var chunkImgData = ctx.createImageData(width, FULL_CHUNK_HEIGHT);
  var srcPos = 0;
  var src = imgData.data;
  var dest = chunkImgData.data;
  for (var i = 0; i < totalChunks; i++) {
    var thisChunkHeight = i < fullChunks ? FULL_CHUNK_HEIGHT : partialChunkHeight;
    var _convertBlackAndWhite = convertBlackAndWhiteToRGBA({
      src: src,
      srcPos: srcPos,
      dest: dest,
      width: width,
      height: thisChunkHeight,
      nonBlackColor: 0
    });
    srcPos = _convertBlackAndWhite.srcPos;
    ctx.putImageData(chunkImgData, 0, i * FULL_CHUNK_HEIGHT);
  }
}
function copyCtxState(sourceCtx, destCtx) {
  var properties = ["strokeStyle", "fillStyle", "fillRule", "globalAlpha", "lineWidth", "lineCap", "lineJoin", "miterLimit", "globalCompositeOperation", "font", "filter"];
  for (var _i = 0, _properties = properties; _i < _properties.length; _i++) {
    var property = _properties[_i];
    if (sourceCtx[property] !== undefined) {
      destCtx[property] = sourceCtx[property];
    }
  }
  if (sourceCtx.setLineDash !== undefined) {
    destCtx.setLineDash(sourceCtx.getLineDash());
    destCtx.lineDashOffset = sourceCtx.lineDashOffset;
  }
}
function resetCtxToDefault(ctx) {
  ctx.strokeStyle = ctx.fillStyle = "#000000";
  ctx.fillRule = "nonzero";
  ctx.globalAlpha = 1;
  ctx.lineWidth = 1;
  ctx.lineCap = "butt";
  ctx.lineJoin = "miter";
  ctx.miterLimit = 10;
  ctx.globalCompositeOperation = "source-over";
  ctx.font = "10px sans-serif";
  if (ctx.setLineDash !== undefined) {
    ctx.setLineDash([]);
    ctx.lineDashOffset = 0;
  }
  if (!isNodeJS) {
    var filter = ctx.filter;
    if (filter !== "none" && filter !== "") {
      ctx.filter = "none";
    }
  }
}
function getImageSmoothingEnabled(transform, interpolate) {
  if (interpolate) {
    return true;
  }
  var scale = Util.singularValueDecompose2dScale(transform);
  scale[0] = Math.fround(scale[0]);
  scale[1] = Math.fround(scale[1]);
  var actualScale = Math.fround((globalThis.devicePixelRatio || 1) * PixelsPerInch.PDF_TO_CSS_UNITS);
  return scale[0] <= actualScale && scale[1] <= actualScale;
}
var LINE_CAP_STYLES = ["butt", "round", "square"];
var LINE_JOIN_STYLES = ["miter", "round", "bevel"];
var NORMAL_CLIP = {};
var EO_CLIP = {};
var _CanvasGraphics_brand = /*#__PURE__*/new WeakSet();
var CanvasGraphics = /*#__PURE__*/function () {
  function CanvasGraphics(canvasCtx, commonObjs, objs, canvasFactory, filterFactory, _ref, annotationCanvasMap, pageColors) {
    var optionalContentConfig = _ref.optionalContentConfig,
      _ref$markedContentSta = _ref.markedContentStack,
      markedContentStack = _ref$markedContentSta === void 0 ? null : _ref$markedContentSta;
    canvas_classCallCheck(this, CanvasGraphics);
    canvas_classPrivateMethodInitSpec(this, _CanvasGraphics_brand);
    this.ctx = canvasCtx;
    this.current = new CanvasExtraState(this.ctx.canvas.width, this.ctx.canvas.height);
    this.stateStack = [];
    this.pendingClip = null;
    this.pendingEOFill = false;
    this.res = null;
    this.xobjs = null;
    this.commonObjs = commonObjs;
    this.objs = objs;
    this.canvasFactory = canvasFactory;
    this.filterFactory = filterFactory;
    this.groupStack = [];
    this.processingType3 = null;
    this.baseTransform = null;
    this.baseTransformStack = [];
    this.groupLevel = 0;
    this.smaskStack = [];
    this.smaskCounter = 0;
    this.tempSMask = null;
    this.suspendedCtx = null;
    this.contentVisible = true;
    this.markedContentStack = markedContentStack || [];
    this.optionalContentConfig = optionalContentConfig;
    this.cachedCanvases = new CachedCanvases(this.canvasFactory);
    this.cachedPatterns = new Map();
    this.annotationCanvasMap = annotationCanvasMap;
    this.viewportScale = 1;
    this.outputScaleX = 1;
    this.outputScaleY = 1;
    this.pageColors = pageColors;
    this._cachedScaleForStroking = [-1, 0];
    this._cachedGetSinglePixelWidth = null;
    this._cachedBitmapsMap = new Map();
  }
  return canvas_createClass(CanvasGraphics, [{
    key: "getObject",
    value: function getObject(data) {
      var fallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (typeof data === "string") {
        return data.startsWith("g_") ? this.commonObjs.get(data) : this.objs.get(data);
      }
      return fallback;
    }
  }, {
    key: "beginDrawing",
    value: function beginDrawing(_ref2) {
      var _this$ctx3;
      var transform = _ref2.transform,
        viewport = _ref2.viewport,
        _ref2$transparency = _ref2.transparency,
        transparency = _ref2$transparency === void 0 ? false : _ref2$transparency,
        _ref2$background = _ref2.background,
        background = _ref2$background === void 0 ? null : _ref2$background;
      var width = this.ctx.canvas.width;
      var height = this.ctx.canvas.height;
      var savedFillStyle = this.ctx.fillStyle;
      this.ctx.fillStyle = background || "#ffffff";
      this.ctx.fillRect(0, 0, width, height);
      this.ctx.fillStyle = savedFillStyle;
      if (transparency) {
        var _this$ctx;
        var transparentCanvas = this.cachedCanvases.getCanvas("transparent", width, height);
        this.compositeCtx = this.ctx;
        this.transparentCanvas = transparentCanvas.canvas;
        this.ctx = transparentCanvas.context;
        this.ctx.save();
        (_this$ctx = this.ctx).transform.apply(_this$ctx, canvas_toConsumableArray(getCurrentTransform(this.compositeCtx)));
      }
      this.ctx.save();
      resetCtxToDefault(this.ctx);
      if (transform) {
        var _this$ctx2;
        (_this$ctx2 = this.ctx).transform.apply(_this$ctx2, canvas_toConsumableArray(transform));
        this.outputScaleX = transform[0];
        this.outputScaleY = transform[0];
      }
      (_this$ctx3 = this.ctx).transform.apply(_this$ctx3, canvas_toConsumableArray(viewport.transform));
      this.viewportScale = viewport.scale;
      this.baseTransform = getCurrentTransform(this.ctx);
    }
  }, {
    key: "executeOperatorList",
    value: function executeOperatorList(operatorList, executionStartIdx, continueCallback, stepper) {
      var argsArray = operatorList.argsArray;
      var fnArray = operatorList.fnArray;
      var i = executionStartIdx || 0;
      var argsArrayLen = argsArray.length;
      if (argsArrayLen === i) {
        return i;
      }
      var chunkOperations = argsArrayLen - i > EXECUTION_STEPS && typeof continueCallback === "function";
      var endTime = chunkOperations ? Date.now() + EXECUTION_TIME : 0;
      var steps = 0;
      var commonObjs = this.commonObjs;
      var objs = this.objs;
      var fnId;
      while (true) {
        if (stepper !== undefined && i === stepper.nextBreakPoint) {
          stepper.breakIt(i, continueCallback);
          return i;
        }
        fnId = fnArray[i];
        if (fnId !== OPS.dependency) {
          this[fnId].apply(this, argsArray[i]);
        } else {
          var _iterator2 = canvas_createForOfIteratorHelper(argsArray[i]),
            _step2;
          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var depObjId = _step2.value;
              var objsPool = depObjId.startsWith("g_") ? commonObjs : objs;
              if (!objsPool.has(depObjId)) {
                objsPool.get(depObjId, continueCallback);
                return i;
              }
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }
        }
        i++;
        if (i === argsArrayLen) {
          return i;
        }
        if (chunkOperations && ++steps > EXECUTION_STEPS) {
          if (Date.now() > endTime) {
            continueCallback();
            return i;
          }
          steps = 0;
        }
      }
    }
  }, {
    key: "endDrawing",
    value: function endDrawing() {
      canvas_assertClassBrand(_CanvasGraphics_brand, this, _restoreInitialState).call(this);
      this.cachedCanvases.clear();
      this.cachedPatterns.clear();
      var _iterator3 = canvas_createForOfIteratorHelper(this._cachedBitmapsMap.values()),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var cache = _step3.value;
          var _iterator4 = canvas_createForOfIteratorHelper(cache.values()),
            _step4;
          try {
            for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
              var canvas = _step4.value;
              if (typeof HTMLCanvasElement !== "undefined" && canvas instanceof HTMLCanvasElement) {
                canvas.width = canvas.height = 0;
              }
            }
          } catch (err) {
            _iterator4.e(err);
          } finally {
            _iterator4.f();
          }
          cache.clear();
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      this._cachedBitmapsMap.clear();
      canvas_assertClassBrand(_CanvasGraphics_brand, this, _drawFilter).call(this);
    }
  }, {
    key: "_scaleImage",
    value: function _scaleImage(img, inverseTransform) {
      var _img$width, _img$height;
      var width = (_img$width = img.width) !== null && _img$width !== void 0 ? _img$width : img.displayWidth;
      var height = (_img$height = img.height) !== null && _img$height !== void 0 ? _img$height : img.displayHeight;
      var widthScale = Math.max(Math.hypot(inverseTransform[0], inverseTransform[1]), 1);
      var heightScale = Math.max(Math.hypot(inverseTransform[2], inverseTransform[3]), 1);
      var paintWidth = width,
        paintHeight = height;
      var tmpCanvasId = "prescale1";
      var tmpCanvas, tmpCtx;
      while (widthScale > 2 && paintWidth > 1 || heightScale > 2 && paintHeight > 1) {
        var newWidth = paintWidth,
          newHeight = paintHeight;
        if (widthScale > 2 && paintWidth > 1) {
          newWidth = paintWidth >= 16384 ? Math.floor(paintWidth / 2) - 1 || 1 : Math.ceil(paintWidth / 2);
          widthScale /= paintWidth / newWidth;
        }
        if (heightScale > 2 && paintHeight > 1) {
          newHeight = paintHeight >= 16384 ? Math.floor(paintHeight / 2) - 1 || 1 : Math.ceil(paintHeight) / 2;
          heightScale /= paintHeight / newHeight;
        }
        tmpCanvas = this.cachedCanvases.getCanvas(tmpCanvasId, newWidth, newHeight);
        tmpCtx = tmpCanvas.context;
        tmpCtx.clearRect(0, 0, newWidth, newHeight);
        tmpCtx.drawImage(img, 0, 0, paintWidth, paintHeight, 0, 0, newWidth, newHeight);
        img = tmpCanvas.canvas;
        paintWidth = newWidth;
        paintHeight = newHeight;
        tmpCanvasId = tmpCanvasId === "prescale1" ? "prescale2" : "prescale1";
      }
      return {
        img: img,
        paintWidth: paintWidth,
        paintHeight: paintHeight
      };
    }
  }, {
    key: "_createMaskCanvas",
    value: function _createMaskCanvas(img) {
      var ctx = this.ctx;
      var width = img.width,
        height = img.height;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var currentTransform = getCurrentTransform(ctx);
      var cache, cacheKey, scaled, maskCanvas;
      if ((img.bitmap || img.data) && img.count > 1) {
        var mainKey = img.bitmap || img.data.buffer;
        cacheKey = JSON.stringify(isPatternFill ? currentTransform : [currentTransform.slice(0, 4), fillColor]);
        cache = this._cachedBitmapsMap.get(mainKey);
        if (!cache) {
          cache = new Map();
          this._cachedBitmapsMap.set(mainKey, cache);
        }
        var cachedImage = cache.get(cacheKey);
        if (cachedImage && !isPatternFill) {
          var _offsetX = Math.round(Math.min(currentTransform[0], currentTransform[2]) + currentTransform[4]);
          var _offsetY = Math.round(Math.min(currentTransform[1], currentTransform[3]) + currentTransform[5]);
          return {
            canvas: cachedImage,
            offsetX: _offsetX,
            offsetY: _offsetY
          };
        }
        scaled = cachedImage;
      }
      if (!scaled) {
        maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
        putBinaryImageMask(maskCanvas.context, img);
      }
      var maskToCanvas = Util.transform(currentTransform, [1 / width, 0, 0, -1 / height, 0, 0]);
      maskToCanvas = Util.transform(maskToCanvas, [1, 0, 0, 1, 0, -height]);
      var _Util$getAxialAligned = Util.getAxialAlignedBoundingBox([0, 0, width, height], maskToCanvas),
        _Util$getAxialAligned2 = canvas_slicedToArray(_Util$getAxialAligned, 4),
        minX = _Util$getAxialAligned2[0],
        minY = _Util$getAxialAligned2[1],
        maxX = _Util$getAxialAligned2[2],
        maxY = _Util$getAxialAligned2[3];
      var drawnWidth = Math.round(maxX - minX) || 1;
      var drawnHeight = Math.round(maxY - minY) || 1;
      var fillCanvas = this.cachedCanvases.getCanvas("fillCanvas", drawnWidth, drawnHeight);
      var fillCtx = fillCanvas.context;
      var offsetX = minX;
      var offsetY = minY;
      fillCtx.translate(-offsetX, -offsetY);
      fillCtx.transform.apply(fillCtx, canvas_toConsumableArray(maskToCanvas));
      if (!scaled) {
        scaled = this._scaleImage(maskCanvas.canvas, getCurrentTransformInverse(fillCtx));
        scaled = scaled.img;
        if (cache && isPatternFill) {
          cache.set(cacheKey, scaled);
        }
      }
      fillCtx.imageSmoothingEnabled = getImageSmoothingEnabled(getCurrentTransform(fillCtx), img.interpolate);
      drawImageAtIntegerCoords(fillCtx, scaled, 0, 0, scaled.width, scaled.height, 0, 0, width, height);
      fillCtx.globalCompositeOperation = "source-in";
      var inverse = Util.transform(getCurrentTransformInverse(fillCtx), [1, 0, 0, 1, -offsetX, -offsetY]);
      fillCtx.fillStyle = isPatternFill ? fillColor.getPattern(ctx, this, inverse, PathType.FILL) : fillColor;
      fillCtx.fillRect(0, 0, width, height);
      if (cache && !isPatternFill) {
        this.cachedCanvases.delete("fillCanvas");
        cache.set(cacheKey, fillCanvas.canvas);
      }
      return {
        canvas: fillCanvas.canvas,
        offsetX: Math.round(offsetX),
        offsetY: Math.round(offsetY)
      };
    }
  }, {
    key: "setLineWidth",
    value: function setLineWidth(width) {
      if (width !== this.current.lineWidth) {
        this._cachedScaleForStroking[0] = -1;
      }
      this.current.lineWidth = width;
      this.ctx.lineWidth = width;
    }
  }, {
    key: "setLineCap",
    value: function setLineCap(style) {
      this.ctx.lineCap = LINE_CAP_STYLES[style];
    }
  }, {
    key: "setLineJoin",
    value: function setLineJoin(style) {
      this.ctx.lineJoin = LINE_JOIN_STYLES[style];
    }
  }, {
    key: "setMiterLimit",
    value: function setMiterLimit(limit) {
      this.ctx.miterLimit = limit;
    }
  }, {
    key: "setDash",
    value: function setDash(dashArray, dashPhase) {
      var ctx = this.ctx;
      if (ctx.setLineDash !== undefined) {
        ctx.setLineDash(dashArray);
        ctx.lineDashOffset = dashPhase;
      }
    }
  }, {
    key: "setRenderingIntent",
    value: function setRenderingIntent(intent) {}
  }, {
    key: "setFlatness",
    value: function setFlatness(flatness) {}
  }, {
    key: "setGState",
    value: function setGState(states) {
      var _iterator5 = canvas_createForOfIteratorHelper(states),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var _step5$value = canvas_slicedToArray(_step5.value, 2),
            key = _step5$value[0],
            value = _step5$value[1];
          switch (key) {
            case "LW":
              this.setLineWidth(value);
              break;
            case "LC":
              this.setLineCap(value);
              break;
            case "LJ":
              this.setLineJoin(value);
              break;
            case "ML":
              this.setMiterLimit(value);
              break;
            case "D":
              this.setDash(value[0], value[1]);
              break;
            case "RI":
              this.setRenderingIntent(value);
              break;
            case "FL":
              this.setFlatness(value);
              break;
            case "Font":
              this.setFont(value[0], value[1]);
              break;
            case "CA":
              this.current.strokeAlpha = value;
              break;
            case "ca":
              this.current.fillAlpha = value;
              this.ctx.globalAlpha = value;
              break;
            case "BM":
              this.ctx.globalCompositeOperation = value;
              break;
            case "SMask":
              this.current.activeSMask = value ? this.tempSMask : null;
              this.tempSMask = null;
              this.checkSMaskState();
              break;
            case "TR":
              this.ctx.filter = this.current.transferMaps = this.filterFactory.addFilter(value);
              break;
          }
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
    }
  }, {
    key: "inSMaskMode",
    get: function get() {
      return !!this.suspendedCtx;
    }
  }, {
    key: "checkSMaskState",
    value: function checkSMaskState() {
      var inSMaskMode = this.inSMaskMode;
      if (this.current.activeSMask && !inSMaskMode) {
        this.beginSMaskMode();
      } else if (!this.current.activeSMask && inSMaskMode) {
        this.endSMaskMode();
      }
    }
  }, {
    key: "beginSMaskMode",
    value: function beginSMaskMode() {
      if (this.inSMaskMode) {
        throw new Error("beginSMaskMode called while already in smask mode");
      }
      var drawnWidth = this.ctx.canvas.width;
      var drawnHeight = this.ctx.canvas.height;
      var cacheId = "smaskGroupAt" + this.groupLevel;
      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight);
      this.suspendedCtx = this.ctx;
      this.ctx = scratchCanvas.context;
      var ctx = this.ctx;
      ctx.setTransform.apply(ctx, canvas_toConsumableArray(getCurrentTransform(this.suspendedCtx)));
      copyCtxState(this.suspendedCtx, ctx);
      mirrorContextOperations(ctx, this.suspendedCtx);
      this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
    }
  }, {
    key: "endSMaskMode",
    value: function endSMaskMode() {
      if (!this.inSMaskMode) {
        throw new Error("endSMaskMode called while not in smask mode");
      }
      this.ctx._removeMirroring();
      copyCtxState(this.ctx, this.suspendedCtx);
      this.ctx = this.suspendedCtx;
      this.suspendedCtx = null;
    }
  }, {
    key: "compose",
    value: function compose(dirtyBox) {
      if (!this.current.activeSMask) {
        return;
      }
      if (!dirtyBox) {
        dirtyBox = [0, 0, this.ctx.canvas.width, this.ctx.canvas.height];
      } else {
        dirtyBox[0] = Math.floor(dirtyBox[0]);
        dirtyBox[1] = Math.floor(dirtyBox[1]);
        dirtyBox[2] = Math.ceil(dirtyBox[2]);
        dirtyBox[3] = Math.ceil(dirtyBox[3]);
      }
      var smask = this.current.activeSMask;
      var suspendedCtx = this.suspendedCtx;
      this.composeSMask(suspendedCtx, smask, this.ctx, dirtyBox);
      this.ctx.save();
      this.ctx.setTransform(1, 0, 0, 1, 0, 0);
      this.ctx.clearRect(0, 0, this.ctx.canvas.width, this.ctx.canvas.height);
      this.ctx.restore();
    }
  }, {
    key: "composeSMask",
    value: function composeSMask(ctx, smask, layerCtx, layerBox) {
      var layerOffsetX = layerBox[0];
      var layerOffsetY = layerBox[1];
      var layerWidth = layerBox[2] - layerOffsetX;
      var layerHeight = layerBox[3] - layerOffsetY;
      if (layerWidth === 0 || layerHeight === 0) {
        return;
      }
      this.genericComposeSMask(smask.context, layerCtx, layerWidth, layerHeight, smask.subtype, smask.backdrop, smask.transferMap, layerOffsetX, layerOffsetY, smask.offsetX, smask.offsetY);
      ctx.save();
      ctx.globalAlpha = 1;
      ctx.globalCompositeOperation = "source-over";
      ctx.setTransform(1, 0, 0, 1, 0, 0);
      ctx.drawImage(layerCtx.canvas, 0, 0);
      ctx.restore();
    }
  }, {
    key: "genericComposeSMask",
    value: function genericComposeSMask(maskCtx, layerCtx, width, height, subtype, backdrop, transferMap, layerOffsetX, layerOffsetY, maskOffsetX, maskOffsetY) {
      var maskCanvas = maskCtx.canvas;
      var maskX = layerOffsetX - maskOffsetX;
      var maskY = layerOffsetY - maskOffsetY;
      if (backdrop) {
        var backdropRGB = Util.makeHexColor.apply(Util, canvas_toConsumableArray(backdrop));
        if (maskX < 0 || maskY < 0 || maskX + width > maskCanvas.width || maskY + height > maskCanvas.height) {
          var canvas = this.cachedCanvases.getCanvas("maskExtension", width, height);
          var ctx = canvas.context;
          ctx.drawImage(maskCanvas, -maskX, -maskY);
          ctx.globalCompositeOperation = "destination-atop";
          ctx.fillStyle = backdropRGB;
          ctx.fillRect(0, 0, width, height);
          ctx.globalCompositeOperation = "source-over";
          maskCanvas = canvas.canvas;
          maskX = maskY = 0;
        } else {
          maskCtx.save();
          maskCtx.globalAlpha = 1;
          maskCtx.setTransform(1, 0, 0, 1, 0, 0);
          var _clip = new Path2D();
          _clip.rect(maskX, maskY, width, height);
          maskCtx.clip(_clip);
          maskCtx.globalCompositeOperation = "destination-atop";
          maskCtx.fillStyle = backdropRGB;
          maskCtx.fillRect(maskX, maskY, width, height);
          maskCtx.restore();
        }
      }
      layerCtx.save();
      layerCtx.globalAlpha = 1;
      layerCtx.setTransform(1, 0, 0, 1, 0, 0);
      if (subtype === "Alpha" && transferMap) {
        layerCtx.filter = this.filterFactory.addAlphaFilter(transferMap);
      } else if (subtype === "Luminosity") {
        layerCtx.filter = this.filterFactory.addLuminosityFilter(transferMap);
      }
      var clip = new Path2D();
      clip.rect(layerOffsetX, layerOffsetY, width, height);
      layerCtx.clip(clip);
      layerCtx.globalCompositeOperation = "destination-in";
      layerCtx.drawImage(maskCanvas, maskX, maskY, width, height, layerOffsetX, layerOffsetY, width, height);
      layerCtx.restore();
    }
  }, {
    key: "save",
    value: function save() {
      if (this.inSMaskMode) {
        copyCtxState(this.ctx, this.suspendedCtx);
        this.suspendedCtx.save();
      } else {
        this.ctx.save();
      }
      var old = this.current;
      this.stateStack.push(old);
      this.current = old.clone();
    }
  }, {
    key: "restore",
    value: function restore() {
      if (this.stateStack.length === 0 && this.inSMaskMode) {
        this.endSMaskMode();
      }
      if (this.stateStack.length !== 0) {
        this.current = this.stateStack.pop();
        if (this.inSMaskMode) {
          this.suspendedCtx.restore();
          copyCtxState(this.suspendedCtx, this.ctx);
        } else {
          this.ctx.restore();
        }
        this.checkSMaskState();
        this.pendingClip = null;
        this._cachedScaleForStroking[0] = -1;
        this._cachedGetSinglePixelWidth = null;
      }
    }
  }, {
    key: "transform",
    value: function transform(a, b, c, d, e, f) {
      this.ctx.transform(a, b, c, d, e, f);
      this._cachedScaleForStroking[0] = -1;
      this._cachedGetSinglePixelWidth = null;
    }
  }, {
    key: "constructPath",
    value: function constructPath(ops, args, minMax) {
      var ctx = this.ctx;
      var current = this.current;
      var x = current.x,
        y = current.y;
      var startX, startY;
      var currentTransform = getCurrentTransform(ctx);
      var isScalingMatrix = currentTransform[0] === 0 && currentTransform[3] === 0 || currentTransform[1] === 0 && currentTransform[2] === 0;
      var minMaxForBezier = isScalingMatrix ? minMax.slice(0) : null;
      for (var i = 0, j = 0, ii = ops.length; i < ii; i++) {
        switch (ops[i] | 0) {
          case OPS.rectangle:
            x = args[j++];
            y = args[j++];
            var width = args[j++];
            var height = args[j++];
            var xw = x + width;
            var yh = y + height;
            ctx.moveTo(x, y);
            if (width === 0 || height === 0) {
              ctx.lineTo(xw, yh);
            } else {
              ctx.lineTo(xw, y);
              ctx.lineTo(xw, yh);
              ctx.lineTo(x, yh);
            }
            if (!isScalingMatrix) {
              current.updateRectMinMax(currentTransform, [x, y, xw, yh]);
            }
            ctx.closePath();
            break;
          case OPS.moveTo:
            x = args[j++];
            y = args[j++];
            ctx.moveTo(x, y);
            if (!isScalingMatrix) {
              current.updatePathMinMax(currentTransform, x, y);
            }
            break;
          case OPS.lineTo:
            x = args[j++];
            y = args[j++];
            ctx.lineTo(x, y);
            if (!isScalingMatrix) {
              current.updatePathMinMax(currentTransform, x, y);
            }
            break;
          case OPS.curveTo:
            startX = x;
            startY = y;
            x = args[j + 4];
            y = args[j + 5];
            ctx.bezierCurveTo(args[j], args[j + 1], args[j + 2], args[j + 3], x, y);
            current.updateCurvePathMinMax(currentTransform, startX, startY, args[j], args[j + 1], args[j + 2], args[j + 3], x, y, minMaxForBezier);
            j += 6;
            break;
          case OPS.curveTo2:
            startX = x;
            startY = y;
            ctx.bezierCurveTo(x, y, args[j], args[j + 1], args[j + 2], args[j + 3]);
            current.updateCurvePathMinMax(currentTransform, startX, startY, x, y, args[j], args[j + 1], args[j + 2], args[j + 3], minMaxForBezier);
            x = args[j + 2];
            y = args[j + 3];
            j += 4;
            break;
          case OPS.curveTo3:
            startX = x;
            startY = y;
            x = args[j + 2];
            y = args[j + 3];
            ctx.bezierCurveTo(args[j], args[j + 1], x, y, x, y);
            current.updateCurvePathMinMax(currentTransform, startX, startY, args[j], args[j + 1], x, y, x, y, minMaxForBezier);
            j += 4;
            break;
          case OPS.closePath:
            ctx.closePath();
            break;
        }
      }
      if (isScalingMatrix) {
        current.updateScalingPathMinMax(currentTransform, minMaxForBezier);
      }
      current.setCurrentPoint(x, y);
    }
  }, {
    key: "closePath",
    value: function closePath() {
      this.ctx.closePath();
    }
  }, {
    key: "stroke",
    value: function stroke() {
      var consumePath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var ctx = this.ctx;
      var strokeColor = this.current.strokeColor;
      ctx.globalAlpha = this.current.strokeAlpha;
      if (this.contentVisible) {
        if (canvas_typeof(strokeColor) === "object" && strokeColor !== null && strokeColor !== void 0 && strokeColor.getPattern) {
          ctx.save();
          ctx.strokeStyle = strokeColor.getPattern(ctx, this, getCurrentTransformInverse(ctx), PathType.STROKE);
          this.rescaleAndStroke(false);
          ctx.restore();
        } else {
          this.rescaleAndStroke(true);
        }
      }
      if (consumePath) {
        this.consumePath(this.current.getClippedPathBoundingBox());
      }
      ctx.globalAlpha = this.current.fillAlpha;
    }
  }, {
    key: "closeStroke",
    value: function closeStroke() {
      this.closePath();
      this.stroke();
    }
  }, {
    key: "fill",
    value: function fill() {
      var consumePath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var needRestore = false;
      if (isPatternFill) {
        ctx.save();
        ctx.fillStyle = fillColor.getPattern(ctx, this, getCurrentTransformInverse(ctx), PathType.FILL);
        needRestore = true;
      }
      var intersect = this.current.getClippedPathBoundingBox();
      if (this.contentVisible && intersect !== null) {
        if (this.pendingEOFill) {
          ctx.fill("evenodd");
          this.pendingEOFill = false;
        } else {
          ctx.fill();
        }
      }
      if (needRestore) {
        ctx.restore();
      }
      if (consumePath) {
        this.consumePath(intersect);
      }
    }
  }, {
    key: "eoFill",
    value: function eoFill() {
      this.pendingEOFill = true;
      this.fill();
    }
  }, {
    key: "fillStroke",
    value: function fillStroke() {
      this.fill(false);
      this.stroke(false);
      this.consumePath();
    }
  }, {
    key: "eoFillStroke",
    value: function eoFillStroke() {
      this.pendingEOFill = true;
      this.fillStroke();
    }
  }, {
    key: "closeFillStroke",
    value: function closeFillStroke() {
      this.closePath();
      this.fillStroke();
    }
  }, {
    key: "closeEOFillStroke",
    value: function closeEOFillStroke() {
      this.pendingEOFill = true;
      this.closePath();
      this.fillStroke();
    }
  }, {
    key: "endPath",
    value: function endPath() {
      this.consumePath();
    }
  }, {
    key: "clip",
    value: function clip() {
      this.pendingClip = NORMAL_CLIP;
    }
  }, {
    key: "eoClip",
    value: function eoClip() {
      this.pendingClip = EO_CLIP;
    }
  }, {
    key: "beginText",
    value: function beginText() {
      this.current.textMatrix = IDENTITY_MATRIX;
      this.current.textMatrixScale = 1;
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    }
  }, {
    key: "endText",
    value: function endText() {
      var paths = this.pendingTextPaths;
      var ctx = this.ctx;
      if (paths === undefined) {
        ctx.beginPath();
        return;
      }
      var newPath = new Path2D();
      var invTransf = ctx.getTransform().invertSelf();
      var _iterator6 = canvas_createForOfIteratorHelper(paths),
        _step6;
      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var _step6$value = _step6.value,
            transform = _step6$value.transform,
            x = _step6$value.x,
            y = _step6$value.y,
            fontSize = _step6$value.fontSize,
            path = _step6$value.path;
          newPath.addPath(path, new DOMMatrix(transform).preMultiplySelf(invTransf).translate(x, y).scale(fontSize, -fontSize));
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }
      ctx.clip(newPath);
      ctx.beginPath();
      delete this.pendingTextPaths;
    }
  }, {
    key: "setCharSpacing",
    value: function setCharSpacing(spacing) {
      this.current.charSpacing = spacing;
    }
  }, {
    key: "setWordSpacing",
    value: function setWordSpacing(spacing) {
      this.current.wordSpacing = spacing;
    }
  }, {
    key: "setHScale",
    value: function setHScale(scale) {
      this.current.textHScale = scale / 100;
    }
  }, {
    key: "setLeading",
    value: function setLeading(leading) {
      this.current.leading = -leading;
    }
  }, {
    key: "setFont",
    value: function setFont(fontRefName, size) {
      var _fontObj$systemFontIn;
      var fontObj = this.commonObjs.get(fontRefName);
      var current = this.current;
      if (!fontObj) {
        throw new Error("Can't find font for ".concat(fontRefName));
      }
      current.fontMatrix = fontObj.fontMatrix || FONT_IDENTITY_MATRIX;
      if (current.fontMatrix[0] === 0 || current.fontMatrix[3] === 0) {
        warn("Invalid font matrix for font " + fontRefName);
      }
      if (size < 0) {
        size = -size;
        current.fontDirection = -1;
      } else {
        current.fontDirection = 1;
      }
      this.current.font = fontObj;
      this.current.fontSize = size;
      if (fontObj.isType3Font) {
        return;
      }
      var name = fontObj.loadedName || "sans-serif";
      var typeface = ((_fontObj$systemFontIn = fontObj.systemFontInfo) === null || _fontObj$systemFontIn === void 0 ? void 0 : _fontObj$systemFontIn.css) || "\"".concat(name, "\", ").concat(fontObj.fallbackName);
      var bold = "normal";
      if (fontObj.black) {
        bold = "900";
      } else if (fontObj.bold) {
        bold = "bold";
      }
      var italic = fontObj.italic ? "italic" : "normal";
      var browserFontSize = size;
      if (size < MIN_FONT_SIZE) {
        browserFontSize = MIN_FONT_SIZE;
      } else if (size > MAX_FONT_SIZE) {
        browserFontSize = MAX_FONT_SIZE;
      }
      this.current.fontSizeScale = size / browserFontSize;
      this.ctx.font = "".concat(italic, " ").concat(bold, " ").concat(browserFontSize, "px ").concat(typeface);
    }
  }, {
    key: "setTextRenderingMode",
    value: function setTextRenderingMode(mode) {
      this.current.textRenderingMode = mode;
    }
  }, {
    key: "setTextRise",
    value: function setTextRise(rise) {
      this.current.textRise = rise;
    }
  }, {
    key: "moveText",
    value: function moveText(x, y) {
      this.current.x = this.current.lineX += x;
      this.current.y = this.current.lineY += y;
    }
  }, {
    key: "setLeadingMoveText",
    value: function setLeadingMoveText(x, y) {
      this.setLeading(-y);
      this.moveText(x, y);
    }
  }, {
    key: "setTextMatrix",
    value: function setTextMatrix(a, b, c, d, e, f) {
      this.current.textMatrix = [a, b, c, d, e, f];
      this.current.textMatrixScale = Math.hypot(a, b);
      this.current.x = this.current.lineX = 0;
      this.current.y = this.current.lineY = 0;
    }
  }, {
    key: "nextLine",
    value: function nextLine() {
      this.moveText(0, this.current.leading);
    }
  }, {
    key: "paintChar",
    value: function paintChar(character, x, y, patternFillTransform, patternStrokeTransform) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var textRenderingMode = current.textRenderingMode;
      var fontSize = current.fontSize / current.fontSizeScale;
      var fillStrokeMode = textRenderingMode & TextRenderingMode.FILL_STROKE_MASK;
      var isAddToPathSet = !!(textRenderingMode & TextRenderingMode.ADD_TO_PATH_FLAG);
      var patternFill = current.patternFill && !font.missingFile;
      var patternStroke = current.patternStroke && !font.missingFile;
      var path;
      if (font.disableFontFace || isAddToPathSet || patternFill || patternStroke) {
        path = font.getPathGenerator(this.commonObjs, character);
      }
      if (font.disableFontFace || patternFill || patternStroke) {
        ctx.save();
        ctx.translate(x, y);
        ctx.scale(fontSize, -fontSize);
        if (fillStrokeMode === TextRenderingMode.FILL || fillStrokeMode === TextRenderingMode.FILL_STROKE) {
          if (patternFillTransform) {
            var currentTransform = ctx.getTransform();
            ctx.setTransform.apply(ctx, canvas_toConsumableArray(patternFillTransform));
            ctx.fill(canvas_assertClassBrand(_CanvasGraphics_brand, this, _getScaledPath).call(this, path, currentTransform, patternFillTransform));
          } else {
            ctx.fill(path);
          }
        }
        if (fillStrokeMode === TextRenderingMode.STROKE || fillStrokeMode === TextRenderingMode.FILL_STROKE) {
          if (patternStrokeTransform) {
            var _currentTransform = ctx.getTransform();
            ctx.setTransform.apply(ctx, canvas_toConsumableArray(patternStrokeTransform));
            ctx.stroke(canvas_assertClassBrand(_CanvasGraphics_brand, this, _getScaledPath).call(this, path, _currentTransform, patternStrokeTransform));
          } else {
            ctx.lineWidth /= fontSize;
            ctx.stroke(path);
          }
        }
        ctx.restore();
      } else {
        if (fillStrokeMode === TextRenderingMode.FILL || fillStrokeMode === TextRenderingMode.FILL_STROKE) {
          ctx.fillText(character, x, y);
        }
        if (fillStrokeMode === TextRenderingMode.STROKE || fillStrokeMode === TextRenderingMode.FILL_STROKE) {
          ctx.strokeText(character, x, y);
        }
      }
      if (isAddToPathSet) {
        var paths = this.pendingTextPaths || (this.pendingTextPaths = []);
        paths.push({
          transform: getCurrentTransform(ctx),
          x: x,
          y: y,
          fontSize: fontSize,
          path: path
        });
      }
    }
  }, {
    key: "isFontSubpixelAAEnabled",
    get: function get() {
      var _this$cachedCanvases$ = this.cachedCanvases.getCanvas("isFontSubpixelAAEnabled", 10, 10),
        ctx = _this$cachedCanvases$.context;
      ctx.scale(1.5, 1);
      ctx.fillText("I", 0, 10);
      var data = ctx.getImageData(0, 0, 10, 10).data;
      var enabled = false;
      for (var i = 3; i < data.length; i += 4) {
        if (data[i] > 0 && data[i] < 255) {
          enabled = true;
          break;
        }
      }
      return shadow(this, "isFontSubpixelAAEnabled", enabled);
    }
  }, {
    key: "showText",
    value: function showText(glyphs) {
      var current = this.current;
      var font = current.font;
      if (font.isType3Font) {
        return this.showType3Text(glyphs);
      }
      var fontSize = current.fontSize;
      if (fontSize === 0) {
        return undefined;
      }
      var ctx = this.ctx;
      var fontSizeScale = current.fontSizeScale;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var fontDirection = current.fontDirection;
      var textHScale = current.textHScale * fontDirection;
      var glyphsLength = glyphs.length;
      var vertical = font.vertical;
      var spacingDir = vertical ? 1 : -1;
      var defaultVMetrics = font.defaultVMetrics;
      var widthAdvanceScale = fontSize * current.fontMatrix[0];
      var simpleFillText = current.textRenderingMode === TextRenderingMode.FILL && !font.disableFontFace && !current.patternFill;
      ctx.save();
      ctx.transform.apply(ctx, canvas_toConsumableArray(current.textMatrix));
      ctx.translate(current.x, current.y + current.textRise);
      if (fontDirection > 0) {
        ctx.scale(textHScale, -1);
      } else {
        ctx.scale(textHScale, 1);
      }
      var patternFillTransform, patternStrokeTransform;
      if (current.patternFill) {
        ctx.save();
        var pattern = current.fillColor.getPattern(ctx, this, getCurrentTransformInverse(ctx), PathType.FILL);
        patternFillTransform = getCurrentTransform(ctx);
        ctx.restore();
        ctx.fillStyle = pattern;
      }
      if (current.patternStroke) {
        ctx.save();
        var _pattern = current.strokeColor.getPattern(ctx, this, getCurrentTransformInverse(ctx), PathType.STROKE);
        patternStrokeTransform = getCurrentTransform(ctx);
        ctx.restore();
        ctx.strokeStyle = _pattern;
      }
      var lineWidth = current.lineWidth;
      var scale = current.textMatrixScale;
      if (scale === 0 || lineWidth === 0) {
        var fillStrokeMode = current.textRenderingMode & TextRenderingMode.FILL_STROKE_MASK;
        if (fillStrokeMode === TextRenderingMode.STROKE || fillStrokeMode === TextRenderingMode.FILL_STROKE) {
          lineWidth = this.getSinglePixelWidth();
        }
      } else {
        lineWidth /= scale;
      }
      if (fontSizeScale !== 1.0) {
        ctx.scale(fontSizeScale, fontSizeScale);
        lineWidth /= fontSizeScale;
      }
      ctx.lineWidth = lineWidth;
      if (font.isInvalidPDFjsFont) {
        var chars = [];
        var width = 0;
        var _iterator7 = canvas_createForOfIteratorHelper(glyphs),
          _step7;
        try {
          for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
            var glyph = _step7.value;
            chars.push(glyph.unicode);
            width += glyph.width;
          }
        } catch (err) {
          _iterator7.e(err);
        } finally {
          _iterator7.f();
        }
        ctx.fillText(chars.join(""), 0, 0);
        current.x += width * widthAdvanceScale * textHScale;
        ctx.restore();
        this.compose();
        return undefined;
      }
      var x = 0,
        i;
      for (i = 0; i < glyphsLength; ++i) {
        var _glyph = glyphs[i];
        if (typeof _glyph === "number") {
          x += spacingDir * _glyph * fontSize / 1000;
          continue;
        }
        var restoreNeeded = false;
        var spacing = (_glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var character = _glyph.fontChar;
        var accent = _glyph.accent;
        var scaledX = void 0,
          scaledY = void 0;
        var _width = _glyph.width;
        if (vertical) {
          var vmetric = _glyph.vmetric || defaultVMetrics;
          var vx = -(_glyph.vmetric ? vmetric[1] : _width * 0.5) * widthAdvanceScale;
          var vy = vmetric[2] * widthAdvanceScale;
          _width = vmetric ? -vmetric[0] : _width;
          scaledX = vx / fontSizeScale;
          scaledY = (x + vy) / fontSizeScale;
        } else {
          scaledX = x / fontSizeScale;
          scaledY = 0;
        }
        if (font.remeasure && _width > 0) {
          var measuredWidth = ctx.measureText(character).width * 1000 / fontSize * fontSizeScale;
          if (_width < measuredWidth && this.isFontSubpixelAAEnabled) {
            var characterScaleX = _width / measuredWidth;
            restoreNeeded = true;
            ctx.save();
            ctx.scale(characterScaleX, 1);
            scaledX /= characterScaleX;
          } else if (_width !== measuredWidth) {
            scaledX += (_width - measuredWidth) / 2000 * fontSize / fontSizeScale;
          }
        }
        if (this.contentVisible && (_glyph.isInFont || font.missingFile)) {
          if (simpleFillText && !accent) {
            ctx.fillText(character, scaledX, scaledY);
          } else {
            this.paintChar(character, scaledX, scaledY, patternFillTransform, patternStrokeTransform);
            if (accent) {
              var scaledAccentX = scaledX + fontSize * accent.offset.x / fontSizeScale;
              var scaledAccentY = scaledY - fontSize * accent.offset.y / fontSizeScale;
              this.paintChar(accent.fontChar, scaledAccentX, scaledAccentY, patternFillTransform, patternStrokeTransform);
            }
          }
        }
        var charWidth = vertical ? _width * widthAdvanceScale - spacing * fontDirection : _width * widthAdvanceScale + spacing * fontDirection;
        x += charWidth;
        if (restoreNeeded) {
          ctx.restore();
        }
      }
      if (vertical) {
        current.y -= x;
      } else {
        current.x += x * textHScale;
      }
      ctx.restore();
      this.compose();
      return undefined;
    }
  }, {
    key: "showType3Text",
    value: function showType3Text(glyphs) {
      var ctx = this.ctx;
      var current = this.current;
      var font = current.font;
      var fontSize = current.fontSize;
      var fontDirection = current.fontDirection;
      var spacingDir = font.vertical ? 1 : -1;
      var charSpacing = current.charSpacing;
      var wordSpacing = current.wordSpacing;
      var textHScale = current.textHScale * fontDirection;
      var fontMatrix = current.fontMatrix || FONT_IDENTITY_MATRIX;
      var glyphsLength = glyphs.length;
      var isTextInvisible = current.textRenderingMode === TextRenderingMode.INVISIBLE;
      var i, glyph, width, spacingLength;
      if (isTextInvisible || fontSize === 0) {
        return;
      }
      this._cachedScaleForStroking[0] = -1;
      this._cachedGetSinglePixelWidth = null;
      ctx.save();
      ctx.transform.apply(ctx, canvas_toConsumableArray(current.textMatrix));
      ctx.translate(current.x, current.y);
      ctx.scale(textHScale, fontDirection);
      for (i = 0; i < glyphsLength; ++i) {
        glyph = glyphs[i];
        if (typeof glyph === "number") {
          spacingLength = spacingDir * glyph * fontSize / 1000;
          this.ctx.translate(spacingLength, 0);
          current.x += spacingLength * textHScale;
          continue;
        }
        var spacing = (glyph.isSpace ? wordSpacing : 0) + charSpacing;
        var operatorList = font.charProcOperatorList[glyph.operatorListId];
        if (!operatorList) {
          warn("Type3 character \"".concat(glyph.operatorListId, "\" is not available."));
          continue;
        }
        if (this.contentVisible) {
          this.processingType3 = glyph;
          this.save();
          ctx.scale(fontSize, fontSize);
          ctx.transform.apply(ctx, canvas_toConsumableArray(fontMatrix));
          this.executeOperatorList(operatorList);
          this.restore();
        }
        var transformed = Util.applyTransform([glyph.width, 0], fontMatrix);
        width = transformed[0] * fontSize + spacing;
        ctx.translate(width, 0);
        current.x += width * textHScale;
      }
      ctx.restore();
      this.processingType3 = null;
    }
  }, {
    key: "setCharWidth",
    value: function setCharWidth(xWidth, yWidth) {}
  }, {
    key: "setCharWidthAndBounds",
    value: function setCharWidthAndBounds(xWidth, yWidth, llx, lly, urx, ury) {
      this.ctx.rect(llx, lly, urx - llx, ury - lly);
      this.ctx.clip();
      this.endPath();
    }
  }, {
    key: "getColorN_Pattern",
    value: function getColorN_Pattern(IR) {
      var _this = this;
      var pattern;
      if (IR[0] === "TilingPattern") {
        var color = IR[1];
        var baseTransform = this.baseTransform || getCurrentTransform(this.ctx);
        var canvasGraphicsFactory = {
          createCanvasGraphics: function createCanvasGraphics(ctx) {
            return new CanvasGraphics(ctx, _this.commonObjs, _this.objs, _this.canvasFactory, _this.filterFactory, {
              optionalContentConfig: _this.optionalContentConfig,
              markedContentStack: _this.markedContentStack
            });
          }
        };
        pattern = new TilingPattern(IR, color, this.ctx, canvasGraphicsFactory, baseTransform);
      } else {
        pattern = this._getPattern(IR[1], IR[2]);
      }
      return pattern;
    }
  }, {
    key: "setStrokeColorN",
    value: function setStrokeColorN() {
      this.current.strokeColor = this.getColorN_Pattern(arguments);
      this.current.patternStroke = true;
    }
  }, {
    key: "setFillColorN",
    value: function setFillColorN() {
      this.current.fillColor = this.getColorN_Pattern(arguments);
      this.current.patternFill = true;
    }
  }, {
    key: "setStrokeRGBColor",
    value: function setStrokeRGBColor(r, g, b) {
      this.ctx.strokeStyle = this.current.strokeColor = Util.makeHexColor(r, g, b);
      this.current.patternStroke = false;
    }
  }, {
    key: "setStrokeTransparent",
    value: function setStrokeTransparent() {
      this.ctx.strokeStyle = this.current.strokeColor = "transparent";
      this.current.patternStroke = false;
    }
  }, {
    key: "setFillRGBColor",
    value: function setFillRGBColor(r, g, b) {
      this.ctx.fillStyle = this.current.fillColor = Util.makeHexColor(r, g, b);
      this.current.patternFill = false;
    }
  }, {
    key: "setFillTransparent",
    value: function setFillTransparent() {
      this.ctx.fillStyle = this.current.fillColor = "transparent";
      this.current.patternFill = false;
    }
  }, {
    key: "_getPattern",
    value: function _getPattern(objId) {
      var matrix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var pattern;
      if (this.cachedPatterns.has(objId)) {
        pattern = this.cachedPatterns.get(objId);
      } else {
        pattern = getShadingPattern(this.getObject(objId));
        this.cachedPatterns.set(objId, pattern);
      }
      if (matrix) {
        pattern.matrix = matrix;
      }
      return pattern;
    }
  }, {
    key: "shadingFill",
    value: function shadingFill(objId) {
      if (!this.contentVisible) {
        return;
      }
      var ctx = this.ctx;
      this.save();
      var pattern = this._getPattern(objId);
      ctx.fillStyle = pattern.getPattern(ctx, this, getCurrentTransformInverse(ctx), PathType.SHADING);
      var inv = getCurrentTransformInverse(ctx);
      if (inv) {
        var _ctx$canvas = ctx.canvas,
          width = _ctx$canvas.width,
          height = _ctx$canvas.height;
        var _Util$getAxialAligned3 = Util.getAxialAlignedBoundingBox([0, 0, width, height], inv),
          _Util$getAxialAligned4 = canvas_slicedToArray(_Util$getAxialAligned3, 4),
          x0 = _Util$getAxialAligned4[0],
          y0 = _Util$getAxialAligned4[1],
          x1 = _Util$getAxialAligned4[2],
          y1 = _Util$getAxialAligned4[3];
        this.ctx.fillRect(x0, y0, x1 - x0, y1 - y0);
      } else {
        this.ctx.fillRect(-1e10, -1e10, 2e10, 2e10);
      }
      this.compose(this.current.getClippedPathBoundingBox());
      this.restore();
    }
  }, {
    key: "beginInlineImage",
    value: function beginInlineImage() {
      unreachable("Should not call beginInlineImage");
    }
  }, {
    key: "beginImageData",
    value: function beginImageData() {
      unreachable("Should not call beginImageData");
    }
  }, {
    key: "paintFormXObjectBegin",
    value: function paintFormXObjectBegin(matrix, bbox) {
      if (!this.contentVisible) {
        return;
      }
      this.save();
      this.baseTransformStack.push(this.baseTransform);
      if (matrix) {
        this.transform.apply(this, canvas_toConsumableArray(matrix));
      }
      this.baseTransform = getCurrentTransform(this.ctx);
      if (bbox) {
        var width = bbox[2] - bbox[0];
        var height = bbox[3] - bbox[1];
        this.ctx.rect(bbox[0], bbox[1], width, height);
        this.current.updateRectMinMax(getCurrentTransform(this.ctx), bbox);
        this.clip();
        this.endPath();
      }
    }
  }, {
    key: "paintFormXObjectEnd",
    value: function paintFormXObjectEnd() {
      if (!this.contentVisible) {
        return;
      }
      this.restore();
      this.baseTransform = this.baseTransformStack.pop();
    }
  }, {
    key: "beginGroup",
    value: function beginGroup(group) {
      if (!this.contentVisible) {
        return;
      }
      this.save();
      if (this.inSMaskMode) {
        this.endSMaskMode();
        this.current.activeSMask = null;
      }
      var currentCtx = this.ctx;
      if (!group.isolated) {
        info("TODO: Support non-isolated groups.");
      }
      if (group.knockout) {
        warn("Knockout groups not supported.");
      }
      var currentTransform = getCurrentTransform(currentCtx);
      if (group.matrix) {
        currentCtx.transform.apply(currentCtx, canvas_toConsumableArray(group.matrix));
      }
      if (!group.bbox) {
        throw new Error("Bounding box is required.");
      }
      var bounds = Util.getAxialAlignedBoundingBox(group.bbox, getCurrentTransform(currentCtx));
      var canvasBounds = [0, 0, currentCtx.canvas.width, currentCtx.canvas.height];
      bounds = Util.intersect(bounds, canvasBounds) || [0, 0, 0, 0];
      var offsetX = Math.floor(bounds[0]);
      var offsetY = Math.floor(bounds[1]);
      var drawnWidth = Math.max(Math.ceil(bounds[2]) - offsetX, 1);
      var drawnHeight = Math.max(Math.ceil(bounds[3]) - offsetY, 1);
      this.current.startNewPathAndClipBox([0, 0, drawnWidth, drawnHeight]);
      var cacheId = "groupAt" + this.groupLevel;
      if (group.smask) {
        cacheId += "_smask_" + this.smaskCounter++ % 2;
      }
      var scratchCanvas = this.cachedCanvases.getCanvas(cacheId, drawnWidth, drawnHeight);
      var groupCtx = scratchCanvas.context;
      groupCtx.translate(-offsetX, -offsetY);
      groupCtx.transform.apply(groupCtx, canvas_toConsumableArray(currentTransform));
      if (group.smask) {
        this.smaskStack.push({
          canvas: scratchCanvas.canvas,
          context: groupCtx,
          offsetX: offsetX,
          offsetY: offsetY,
          subtype: group.smask.subtype,
          backdrop: group.smask.backdrop,
          transferMap: group.smask.transferMap || null,
          startTransformInverse: null
        });
      } else {
        currentCtx.setTransform(1, 0, 0, 1, 0, 0);
        currentCtx.translate(offsetX, offsetY);
        currentCtx.save();
      }
      copyCtxState(currentCtx, groupCtx);
      this.ctx = groupCtx;
      this.setGState([["BM", "source-over"], ["ca", 1], ["CA", 1]]);
      this.groupStack.push(currentCtx);
      this.groupLevel++;
    }
  }, {
    key: "endGroup",
    value: function endGroup(group) {
      if (!this.contentVisible) {
        return;
      }
      this.groupLevel--;
      var groupCtx = this.ctx;
      var ctx = this.groupStack.pop();
      this.ctx = ctx;
      this.ctx.imageSmoothingEnabled = false;
      if (group.smask) {
        this.tempSMask = this.smaskStack.pop();
        this.restore();
      } else {
        var _this$ctx4;
        this.ctx.restore();
        var currentMtx = getCurrentTransform(this.ctx);
        this.restore();
        this.ctx.save();
        (_this$ctx4 = this.ctx).setTransform.apply(_this$ctx4, canvas_toConsumableArray(currentMtx));
        var dirtyBox = Util.getAxialAlignedBoundingBox([0, 0, groupCtx.canvas.width, groupCtx.canvas.height], currentMtx);
        this.ctx.drawImage(groupCtx.canvas, 0, 0);
        this.ctx.restore();
        this.compose(dirtyBox);
      }
    }
  }, {
    key: "beginAnnotation",
    value: function beginAnnotation(id, rect, transform, matrix, hasOwnCanvas) {
      canvas_assertClassBrand(_CanvasGraphics_brand, this, _restoreInitialState).call(this);
      resetCtxToDefault(this.ctx);
      this.ctx.save();
      this.save();
      if (this.baseTransform) {
        var _this$ctx5;
        (_this$ctx5 = this.ctx).setTransform.apply(_this$ctx5, canvas_toConsumableArray(this.baseTransform));
      }
      if (rect) {
        var width = rect[2] - rect[0];
        var height = rect[3] - rect[1];
        if (hasOwnCanvas && this.annotationCanvasMap) {
          transform = transform.slice();
          transform[4] -= rect[0];
          transform[5] -= rect[1];
          rect = rect.slice();
          rect[0] = rect[1] = 0;
          rect[2] = width;
          rect[3] = height;
          var _Util$singularValueDe = Util.singularValueDecompose2dScale(getCurrentTransform(this.ctx)),
            _Util$singularValueDe2 = canvas_slicedToArray(_Util$singularValueDe, 2),
            scaleX = _Util$singularValueDe2[0],
            scaleY = _Util$singularValueDe2[1];
          var viewportScale = this.viewportScale;
          var canvasWidth = Math.ceil(width * this.outputScaleX * viewportScale);
          var canvasHeight = Math.ceil(height * this.outputScaleY * viewportScale);
          this.annotationCanvas = this.canvasFactory.create(canvasWidth, canvasHeight);
          var _this$annotationCanva = this.annotationCanvas,
            canvas = _this$annotationCanva.canvas,
            context = _this$annotationCanva.context;
          this.annotationCanvasMap.set(id, canvas);
          this.annotationCanvas.savedCtx = this.ctx;
          this.ctx = context;
          this.ctx.save();
          this.ctx.setTransform(scaleX, 0, 0, -scaleY, 0, height * scaleY);
          resetCtxToDefault(this.ctx);
        } else {
          resetCtxToDefault(this.ctx);
          this.endPath();
          this.ctx.rect(rect[0], rect[1], width, height);
          this.ctx.clip();
          this.ctx.beginPath();
        }
      }
      this.current = new CanvasExtraState(this.ctx.canvas.width, this.ctx.canvas.height);
      this.transform.apply(this, canvas_toConsumableArray(transform));
      this.transform.apply(this, canvas_toConsumableArray(matrix));
    }
  }, {
    key: "endAnnotation",
    value: function endAnnotation() {
      if (this.annotationCanvas) {
        this.ctx.restore();
        canvas_assertClassBrand(_CanvasGraphics_brand, this, _drawFilter).call(this);
        this.ctx = this.annotationCanvas.savedCtx;
        delete this.annotationCanvas.savedCtx;
        delete this.annotationCanvas;
      }
    }
  }, {
    key: "paintImageMaskXObject",
    value: function paintImageMaskXObject(img) {
      if (!this.contentVisible) {
        return;
      }
      var count = img.count;
      img = this.getObject(img.data, img);
      img.count = count;
      var ctx = this.ctx;
      var glyph = this.processingType3;
      if (glyph) {
        if (glyph.compiled === undefined) {
          glyph.compiled = compileType3Glyph(img);
        }
        if (glyph.compiled) {
          glyph.compiled(ctx);
          return;
        }
      }
      var mask = this._createMaskCanvas(img);
      var maskCanvas = mask.canvas;
      ctx.save();
      ctx.setTransform(1, 0, 0, 1, 0, 0);
      ctx.drawImage(maskCanvas, mask.offsetX, mask.offsetY);
      ctx.restore();
      this.compose();
    }
  }, {
    key: "paintImageMaskXObjectRepeat",
    value: function paintImageMaskXObjectRepeat(img, scaleX) {
      var skewX = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
      var skewY = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
      var scaleY = arguments.length > 4 ? arguments[4] : undefined;
      var positions = arguments.length > 5 ? arguments[5] : undefined;
      if (!this.contentVisible) {
        return;
      }
      img = this.getObject(img.data, img);
      var ctx = this.ctx;
      ctx.save();
      var currentTransform = getCurrentTransform(ctx);
      ctx.transform(scaleX, skewX, skewY, scaleY, 0, 0);
      var mask = this._createMaskCanvas(img);
      ctx.setTransform(1, 0, 0, 1, mask.offsetX - currentTransform[4], mask.offsetY - currentTransform[5]);
      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        var trans = Util.transform(currentTransform, [scaleX, skewX, skewY, scaleY, positions[i], positions[i + 1]]);
        var _Util$applyTransform3 = Util.applyTransform([0, 0], trans),
          _Util$applyTransform4 = canvas_slicedToArray(_Util$applyTransform3, 2),
          x = _Util$applyTransform4[0],
          y = _Util$applyTransform4[1];
        ctx.drawImage(mask.canvas, x, y);
      }
      ctx.restore();
      this.compose();
    }
  }, {
    key: "paintImageMaskXObjectGroup",
    value: function paintImageMaskXObjectGroup(images) {
      if (!this.contentVisible) {
        return;
      }
      var ctx = this.ctx;
      var fillColor = this.current.fillColor;
      var isPatternFill = this.current.patternFill;
      var _iterator8 = canvas_createForOfIteratorHelper(images),
        _step8;
      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var image = _step8.value;
          var data = image.data,
            width = image.width,
            height = image.height,
            transform = image.transform;
          var maskCanvas = this.cachedCanvases.getCanvas("maskCanvas", width, height);
          var maskCtx = maskCanvas.context;
          maskCtx.save();
          var img = this.getObject(data, image);
          putBinaryImageMask(maskCtx, img);
          maskCtx.globalCompositeOperation = "source-in";
          maskCtx.fillStyle = isPatternFill ? fillColor.getPattern(maskCtx, this, getCurrentTransformInverse(ctx), PathType.FILL) : fillColor;
          maskCtx.fillRect(0, 0, width, height);
          maskCtx.restore();
          ctx.save();
          ctx.transform.apply(ctx, canvas_toConsumableArray(transform));
          ctx.scale(1, -1);
          drawImageAtIntegerCoords(ctx, maskCanvas.canvas, 0, 0, width, height, 0, -1, 1, 1);
          ctx.restore();
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }
      this.compose();
    }
  }, {
    key: "paintImageXObject",
    value: function paintImageXObject(objId) {
      if (!this.contentVisible) {
        return;
      }
      var imgData = this.getObject(objId);
      if (!imgData) {
        warn("Dependent image isn't ready yet");
        return;
      }
      this.paintInlineImageXObject(imgData);
    }
  }, {
    key: "paintImageXObjectRepeat",
    value: function paintImageXObjectRepeat(objId, scaleX, scaleY, positions) {
      if (!this.contentVisible) {
        return;
      }
      var imgData = this.getObject(objId);
      if (!imgData) {
        warn("Dependent image isn't ready yet");
        return;
      }
      var width = imgData.width;
      var height = imgData.height;
      var map = [];
      for (var i = 0, ii = positions.length; i < ii; i += 2) {
        map.push({
          transform: [scaleX, 0, 0, scaleY, positions[i], positions[i + 1]],
          x: 0,
          y: 0,
          w: width,
          h: height
        });
      }
      this.paintInlineImageXObjectGroup(imgData, map);
    }
  }, {
    key: "applyTransferMapsToCanvas",
    value: function applyTransferMapsToCanvas(ctx) {
      if (this.current.transferMaps !== "none") {
        ctx.filter = this.current.transferMaps;
        ctx.drawImage(ctx.canvas, 0, 0);
        ctx.filter = "none";
      }
      return ctx.canvas;
    }
  }, {
    key: "applyTransferMapsToBitmap",
    value: function applyTransferMapsToBitmap(imgData) {
      if (this.current.transferMaps === "none") {
        return imgData.bitmap;
      }
      var bitmap = imgData.bitmap,
        width = imgData.width,
        height = imgData.height;
      var tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", width, height);
      var tmpCtx = tmpCanvas.context;
      tmpCtx.filter = this.current.transferMaps;
      tmpCtx.drawImage(bitmap, 0, 0);
      tmpCtx.filter = "none";
      return tmpCanvas.canvas;
    }
  }, {
    key: "paintInlineImageXObject",
    value: function paintInlineImageXObject(imgData) {
      if (!this.contentVisible) {
        return;
      }
      var width = imgData.width;
      var height = imgData.height;
      var ctx = this.ctx;
      this.save();
      if (!isNodeJS) {
        var filter = ctx.filter;
        if (filter !== "none" && filter !== "") {
          ctx.filter = "none";
        }
      }
      ctx.scale(1 / width, -1 / height);
      var imgToPaint;
      if (imgData.bitmap) {
        imgToPaint = this.applyTransferMapsToBitmap(imgData);
      } else if (typeof HTMLElement === "function" && imgData instanceof HTMLElement || !imgData.data) {
        imgToPaint = imgData;
      } else {
        var tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", width, height);
        var tmpCtx = tmpCanvas.context;
        putBinaryImageData(tmpCtx, imgData);
        imgToPaint = this.applyTransferMapsToCanvas(tmpCtx);
      }
      var scaled = this._scaleImage(imgToPaint, getCurrentTransformInverse(ctx));
      ctx.imageSmoothingEnabled = getImageSmoothingEnabled(getCurrentTransform(ctx), imgData.interpolate);
      drawImageAtIntegerCoords(ctx, scaled.img, 0, 0, scaled.paintWidth, scaled.paintHeight, 0, -height, width, height);
      this.compose();
      this.restore();
    }
  }, {
    key: "paintInlineImageXObjectGroup",
    value: function paintInlineImageXObjectGroup(imgData, map) {
      if (!this.contentVisible) {
        return;
      }
      var ctx = this.ctx;
      var imgToPaint;
      if (imgData.bitmap) {
        imgToPaint = imgData.bitmap;
      } else {
        var w = imgData.width;
        var h = imgData.height;
        var tmpCanvas = this.cachedCanvases.getCanvas("inlineImage", w, h);
        var tmpCtx = tmpCanvas.context;
        putBinaryImageData(tmpCtx, imgData);
        imgToPaint = this.applyTransferMapsToCanvas(tmpCtx);
      }
      var _iterator9 = canvas_createForOfIteratorHelper(map),
        _step9;
      try {
        for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
          var entry = _step9.value;
          ctx.save();
          ctx.transform.apply(ctx, canvas_toConsumableArray(entry.transform));
          ctx.scale(1, -1);
          drawImageAtIntegerCoords(ctx, imgToPaint, entry.x, entry.y, entry.w, entry.h, 0, -1, 1, 1);
          ctx.restore();
        }
      } catch (err) {
        _iterator9.e(err);
      } finally {
        _iterator9.f();
      }
      this.compose();
    }
  }, {
    key: "paintSolidColorImageMask",
    value: function paintSolidColorImageMask() {
      if (!this.contentVisible) {
        return;
      }
      this.ctx.fillRect(0, 0, 1, 1);
      this.compose();
    }
  }, {
    key: "markPoint",
    value: function markPoint(tag) {}
  }, {
    key: "markPointProps",
    value: function markPointProps(tag, properties) {}
  }, {
    key: "beginMarkedContent",
    value: function beginMarkedContent(tag) {
      this.markedContentStack.push({
        visible: true
      });
    }
  }, {
    key: "beginMarkedContentProps",
    value: function beginMarkedContentProps(tag, properties) {
      if (tag === "OC") {
        this.markedContentStack.push({
          visible: this.optionalContentConfig.isVisible(properties)
        });
      } else {
        this.markedContentStack.push({
          visible: true
        });
      }
      this.contentVisible = this.isContentVisible();
    }
  }, {
    key: "endMarkedContent",
    value: function endMarkedContent() {
      this.markedContentStack.pop();
      this.contentVisible = this.isContentVisible();
    }
  }, {
    key: "beginCompat",
    value: function beginCompat() {}
  }, {
    key: "endCompat",
    value: function endCompat() {}
  }, {
    key: "consumePath",
    value: function consumePath(clipBox) {
      var isEmpty = this.current.isEmptyClip();
      if (this.pendingClip) {
        this.current.updateClipFromPath();
      }
      if (!this.pendingClip) {
        this.compose(clipBox);
      }
      var ctx = this.ctx;
      if (this.pendingClip) {
        if (!isEmpty) {
          if (this.pendingClip === EO_CLIP) {
            ctx.clip("evenodd");
          } else {
            ctx.clip();
          }
        }
        this.pendingClip = null;
      }
      this.current.startNewPathAndClipBox(this.current.clipBox);
      ctx.beginPath();
    }
  }, {
    key: "getSinglePixelWidth",
    value: function getSinglePixelWidth() {
      if (!this._cachedGetSinglePixelWidth) {
        var m = getCurrentTransform(this.ctx);
        if (m[1] === 0 && m[2] === 0) {
          this._cachedGetSinglePixelWidth = 1 / Math.min(Math.abs(m[0]), Math.abs(m[3]));
        } else {
          var absDet = Math.abs(m[0] * m[3] - m[2] * m[1]);
          var normX = Math.hypot(m[0], m[2]);
          var normY = Math.hypot(m[1], m[3]);
          this._cachedGetSinglePixelWidth = Math.max(normX, normY) / absDet;
        }
      }
      return this._cachedGetSinglePixelWidth;
    }
  }, {
    key: "getScaleForStroking",
    value: function getScaleForStroking() {
      if (this._cachedScaleForStroking[0] === -1) {
        var lineWidth = this.current.lineWidth;
        var _this$ctx$getTransfor = this.ctx.getTransform(),
          a = _this$ctx$getTransfor.a,
          b = _this$ctx$getTransfor.b,
          c = _this$ctx$getTransfor.c,
          d = _this$ctx$getTransfor.d;
        var scaleX, scaleY;
        if (b === 0 && c === 0) {
          var normX = Math.abs(a);
          var normY = Math.abs(d);
          if (normX === normY) {
            if (lineWidth === 0) {
              scaleX = scaleY = 1 / normX;
            } else {
              var scaledLineWidth = normX * lineWidth;
              scaleX = scaleY = scaledLineWidth < 1 ? 1 / scaledLineWidth : 1;
            }
          } else if (lineWidth === 0) {
            scaleX = 1 / normX;
            scaleY = 1 / normY;
          } else {
            var scaledXLineWidth = normX * lineWidth;
            var scaledYLineWidth = normY * lineWidth;
            scaleX = scaledXLineWidth < 1 ? 1 / scaledXLineWidth : 1;
            scaleY = scaledYLineWidth < 1 ? 1 / scaledYLineWidth : 1;
          }
        } else {
          var absDet = Math.abs(a * d - b * c);
          var _normX = Math.hypot(a, b);
          var _normY = Math.hypot(c, d);
          if (lineWidth === 0) {
            scaleX = _normY / absDet;
            scaleY = _normX / absDet;
          } else {
            var baseArea = lineWidth * absDet;
            scaleX = _normY > baseArea ? _normY / baseArea : 1;
            scaleY = _normX > baseArea ? _normX / baseArea : 1;
          }
        }
        this._cachedScaleForStroking[0] = scaleX;
        this._cachedScaleForStroking[1] = scaleY;
      }
      return this._cachedScaleForStroking;
    }
  }, {
    key: "rescaleAndStroke",
    value: function rescaleAndStroke(saveRestore) {
      var ctx = this.ctx;
      var lineWidth = this.current.lineWidth;
      var _this$getScaleForStro = this.getScaleForStroking(),
        _this$getScaleForStro2 = canvas_slicedToArray(_this$getScaleForStro, 2),
        scaleX = _this$getScaleForStro2[0],
        scaleY = _this$getScaleForStro2[1];
      ctx.lineWidth = lineWidth || 1;
      if (scaleX === 1 && scaleY === 1) {
        ctx.stroke();
        return;
      }
      var dashes = ctx.getLineDash();
      if (saveRestore) {
        ctx.save();
      }
      ctx.scale(scaleX, scaleY);
      if (dashes.length > 0) {
        var scale = Math.max(scaleX, scaleY);
        ctx.setLineDash(dashes.map(function (x) {
          return x / scale;
        }));
        ctx.lineDashOffset /= scale;
      }
      ctx.stroke();
      if (saveRestore) {
        ctx.restore();
      }
    }
  }, {
    key: "isContentVisible",
    value: function isContentVisible() {
      for (var i = this.markedContentStack.length - 1; i >= 0; i--) {
        if (!this.markedContentStack[i].visible) {
          return false;
        }
      }
      return true;
    }
  }]);
}();
function _restoreInitialState() {
  while (this.stateStack.length || this.inSMaskMode) {
    this.restore();
  }
  this.current.activeSMask = null;
  this.ctx.restore();
  if (this.transparentCanvas) {
    this.ctx = this.compositeCtx;
    this.ctx.save();
    this.ctx.setTransform(1, 0, 0, 1, 0, 0);
    this.ctx.drawImage(this.transparentCanvas, 0, 0);
    this.ctx.restore();
    this.transparentCanvas = null;
  }
}
function _drawFilter() {
  if (this.pageColors) {
    var hcmFilterId = this.filterFactory.addHCMFilter(this.pageColors.foreground, this.pageColors.background);
    if (hcmFilterId !== "none") {
      var savedFilter = this.ctx.filter;
      this.ctx.filter = hcmFilterId;
      this.ctx.drawImage(this.ctx.canvas, 0, 0);
      this.ctx.filter = savedFilter;
    }
  }
}
function _getScaledPath(path, currentTransform, transform) {
  var newPath = new Path2D();
  newPath.addPath(path, new DOMMatrix(transform).invertSelf().multiplySelf(currentTransform));
  return newPath;
}
for (var op in OPS) {
  if (CanvasGraphics.prototype[op] !== undefined) {
    CanvasGraphics.prototype[OPS[op]] = CanvasGraphics.prototype[op];
  }
}

;// ./src/display/worker_options.js
function worker_options_typeof(o) { "@babel/helpers - typeof"; return worker_options_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, worker_options_typeof(o); }












function worker_options_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function worker_options_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, worker_options_toPropertyKey(o.key), o); } }
function worker_options_createClass(e, r, t) { return r && worker_options_defineProperties(e.prototype, r), t && worker_options_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function worker_options_toPropertyKey(t) { var i = worker_options_toPrimitive(t, "string"); return "symbol" == worker_options_typeof(i) ? i : i + ""; }
function worker_options_toPrimitive(t, r) { if ("object" != worker_options_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != worker_options_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function worker_options_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
var GlobalWorkerOptions = /*#__PURE__*/function () {
  function GlobalWorkerOptions() {
    worker_options_classCallCheck(this, GlobalWorkerOptions);
  }
  return worker_options_createClass(GlobalWorkerOptions, null, [{
    key: "workerPort",
    get: function get() {
      return worker_options_assertClassBrand(GlobalWorkerOptions, this, _port)._;
    },
    set: function set(val) {
      if (!(typeof Worker !== "undefined" && val instanceof Worker) && val !== null) {
        throw new Error("Invalid `workerPort` type.");
      }
      _port._ = worker_options_assertClassBrand(GlobalWorkerOptions, this, val);
    }
  }, {
    key: "workerSrc",
    get: function get() {
      return worker_options_assertClassBrand(GlobalWorkerOptions, this, _src)._;
    },
    set: function set(val) {
      if (typeof val !== "string") {
        throw new Error("Invalid `workerSrc` type.");
      }
      _src._ = worker_options_assertClassBrand(GlobalWorkerOptions, this, val);
    }
  }]);
}();
var _port = {
  _: null
};
var _src = {
  _: ""
};

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.promise.all-settled.js
var es_promise_all_settled = __webpack_require__(6167);
;// ./src/shared/message_handler.js
function message_handler_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ message_handler_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == message_handler_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(message_handler_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function message_handler_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function message_handler_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { message_handler_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { message_handler_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function message_handler_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function message_handler_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, message_handler_toPropertyKey(o.key), o); } }
function message_handler_createClass(e, r, t) { return r && message_handler_defineProperties(e.prototype, r), t && message_handler_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function message_handler_toPropertyKey(t) { var i = message_handler_toPrimitive(t, "string"); return "symbol" == message_handler_typeof(i) ? i : i + ""; }
function message_handler_toPrimitive(t, r) { if ("object" != message_handler_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != message_handler_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function message_handler_classPrivateMethodInitSpec(e, a) { message_handler_checkPrivateRedeclaration(e, a), a.add(e); }
function message_handler_classPrivateFieldInitSpec(e, t, a) { message_handler_checkPrivateRedeclaration(e, t), t.set(e, a); }
function message_handler_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function message_handler_classPrivateFieldSet(s, a, r) { return s.set(message_handler_assertClassBrand(s, a), r), r; }
function message_handler_classPrivateFieldGet(s, a) { return s.get(message_handler_assertClassBrand(s, a)); }
function message_handler_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function message_handler_typeof(o) { "@babel/helpers - typeof"; return message_handler_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, message_handler_typeof(o); }

































var CallbackKind = {
  UNKNOWN: 0,
  DATA: 1,
  ERROR: 2
};
var StreamKind = {
  UNKNOWN: 0,
  CANCEL: 1,
  CANCEL_COMPLETE: 2,
  CLOSE: 3,
  ENQUEUE: 4,
  ERROR: 5,
  PULL: 6,
  PULL_COMPLETE: 7,
  START_COMPLETE: 8
};
function onFn() {}
function wrapReason(reason) {
  if (!(reason instanceof Error || message_handler_typeof(reason) === "object" && reason !== null)) {
    unreachable('wrapReason: Expected "reason" to be a (possibly cloned) Error.');
  }
  switch (reason.name) {
    case "AbortException":
      return new AbortException(reason.message);
    case "MissingPDFException":
      return new MissingPDFException(reason.message);
    case "PasswordException":
      return new PasswordException(reason.message, reason.code);
    case "UnexpectedResponseException":
      return new UnexpectedResponseException(reason.message, reason.status);
    case "UnknownErrorException":
      return new UnknownErrorException(reason.message, reason.details);
    default:
      return new UnknownErrorException(reason.message, reason.toString());
  }
}
var _messageAC = /*#__PURE__*/new WeakMap();
var _MessageHandler_brand = /*#__PURE__*/new WeakSet();
var MessageHandler = /*#__PURE__*/function () {
  function MessageHandler(_sourceName, _targetName, _comObj) {
    message_handler_classCallCheck(this, MessageHandler);
    message_handler_classPrivateMethodInitSpec(this, _MessageHandler_brand);
    message_handler_classPrivateFieldInitSpec(this, _messageAC, new AbortController());
    this.sourceName = _sourceName;
    this.targetName = _targetName;
    this.comObj = _comObj;
    this.callbackId = 1;
    this.streamId = 1;
    this.streamSinks = Object.create(null);
    this.streamControllers = Object.create(null);
    this.callbackCapabilities = Object.create(null);
    this.actionHandler = Object.create(null);
    _comObj.addEventListener("message", message_handler_assertClassBrand(_MessageHandler_brand, this, _onMessage).bind(this), {
      signal: message_handler_classPrivateFieldGet(_messageAC, this).signal
    });
  }
  return message_handler_createClass(MessageHandler, [{
    key: "on",
    value: function on(actionName, handler) {
      var ah = this.actionHandler;
      if (ah[actionName]) {
        throw new Error("There is already an actionName called \"".concat(actionName, "\""));
      }
      ah[actionName] = handler;
    }
  }, {
    key: "send",
    value: function send(actionName, data, transfers) {
      this.comObj.postMessage({
        sourceName: this.sourceName,
        targetName: this.targetName,
        action: actionName,
        data: data
      }, transfers);
    }
  }, {
    key: "sendWithPromise",
    value: function sendWithPromise(actionName, data, transfers) {
      var callbackId = this.callbackId++;
      var capability = Promise.withResolvers();
      this.callbackCapabilities[callbackId] = capability;
      try {
        this.comObj.postMessage({
          sourceName: this.sourceName,
          targetName: this.targetName,
          action: actionName,
          callbackId: callbackId,
          data: data
        }, transfers);
      } catch (ex) {
        capability.reject(ex);
      }
      return capability.promise;
    }
  }, {
    key: "sendWithStream",
    value: function sendWithStream(actionName, data, queueingStrategy, transfers) {
      var _this = this;
      var streamId = this.streamId++,
        sourceName = this.sourceName,
        targetName = this.targetName,
        comObj = this.comObj;
      return new ReadableStream({
        start: function start(controller) {
          var startCapability = Promise.withResolvers();
          _this.streamControllers[streamId] = {
            controller: controller,
            startCall: startCapability,
            pullCall: null,
            cancelCall: null,
            isClosed: false
          };
          comObj.postMessage({
            sourceName: sourceName,
            targetName: targetName,
            action: actionName,
            streamId: streamId,
            data: data,
            desiredSize: controller.desiredSize
          }, transfers);
          return startCapability.promise;
        },
        pull: function pull(controller) {
          var pullCapability = Promise.withResolvers();
          _this.streamControllers[streamId].pullCall = pullCapability;
          comObj.postMessage({
            sourceName: sourceName,
            targetName: targetName,
            stream: StreamKind.PULL,
            streamId: streamId,
            desiredSize: controller.desiredSize
          });
          return pullCapability.promise;
        },
        cancel: function cancel(reason) {
          assert(reason instanceof Error, "cancel must have a valid reason");
          var cancelCapability = Promise.withResolvers();
          _this.streamControllers[streamId].cancelCall = cancelCapability;
          _this.streamControllers[streamId].isClosed = true;
          comObj.postMessage({
            sourceName: sourceName,
            targetName: targetName,
            stream: StreamKind.CANCEL,
            streamId: streamId,
            reason: wrapReason(reason)
          });
          return cancelCapability.promise;
        }
      }, queueingStrategy);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet2;
      (_classPrivateFieldGet2 = message_handler_classPrivateFieldGet(_messageAC, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.abort();
      message_handler_classPrivateFieldSet(_messageAC, this, null);
    }
  }]);
}();
function _onMessage(_ref) {
  var data = _ref.data;
  if (data.targetName !== this.sourceName) {
    return;
  }
  if (data.stream) {
    message_handler_assertClassBrand(_MessageHandler_brand, this, _processStreamMessage).call(this, data);
    return;
  }
  if (data.callback) {
    var callbackId = data.callbackId;
    var capability = this.callbackCapabilities[callbackId];
    if (!capability) {
      throw new Error("Cannot resolve callback ".concat(callbackId));
    }
    delete this.callbackCapabilities[callbackId];
    if (data.callback === CallbackKind.DATA) {
      capability.resolve(data.data);
    } else if (data.callback === CallbackKind.ERROR) {
      capability.reject(wrapReason(data.reason));
    } else {
      throw new Error("Unexpected callback case");
    }
    return;
  }
  var action = this.actionHandler[data.action];
  if (!action) {
    throw new Error("Unknown action from worker: ".concat(data.action));
  }
  if (data.callbackId) {
    var sourceName = this.sourceName,
      targetName = data.sourceName,
      comObj = this.comObj;
    Promise.try(action, data.data).then(function (result) {
      comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        callback: CallbackKind.DATA,
        callbackId: data.callbackId,
        data: result
      });
    }, function (reason) {
      comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        callback: CallbackKind.ERROR,
        callbackId: data.callbackId,
        reason: wrapReason(reason)
      });
    });
    return;
  }
  if (data.streamId) {
    message_handler_assertClassBrand(_MessageHandler_brand, this, _createStreamSink).call(this, data);
    return;
  }
  action(data.data);
}
function _createStreamSink(data) {
  var streamId = data.streamId,
    sourceName = this.sourceName,
    targetName = data.sourceName,
    comObj = this.comObj;
  var self = this,
    action = this.actionHandler[data.action];
  var streamSink = {
    enqueue: function enqueue(chunk) {
      var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var transfers = arguments.length > 2 ? arguments[2] : undefined;
      if (this.isCancelled) {
        return;
      }
      var lastDesiredSize = this.desiredSize;
      this.desiredSize -= size;
      if (lastDesiredSize > 0 && this.desiredSize <= 0) {
        this.sinkCapability = Promise.withResolvers();
        this.ready = this.sinkCapability.promise;
      }
      comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: StreamKind.ENQUEUE,
        streamId: streamId,
        chunk: chunk
      }, transfers);
    },
    close: function close() {
      if (this.isCancelled) {
        return;
      }
      this.isCancelled = true;
      comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: StreamKind.CLOSE,
        streamId: streamId
      });
      delete self.streamSinks[streamId];
    },
    error: function error(reason) {
      assert(reason instanceof Error, "error must have a valid reason");
      if (this.isCancelled) {
        return;
      }
      this.isCancelled = true;
      comObj.postMessage({
        sourceName: sourceName,
        targetName: targetName,
        stream: StreamKind.ERROR,
        streamId: streamId,
        reason: wrapReason(reason)
      });
    },
    sinkCapability: Promise.withResolvers(),
    onPull: null,
    onCancel: null,
    isCancelled: false,
    desiredSize: data.desiredSize,
    ready: null
  };
  streamSink.sinkCapability.resolve();
  streamSink.ready = streamSink.sinkCapability.promise;
  this.streamSinks[streamId] = streamSink;
  Promise.try(action, data.data, streamSink).then(function () {
    comObj.postMessage({
      sourceName: sourceName,
      targetName: targetName,
      stream: StreamKind.START_COMPLETE,
      streamId: streamId,
      success: true
    });
  }, function (reason) {
    comObj.postMessage({
      sourceName: sourceName,
      targetName: targetName,
      stream: StreamKind.START_COMPLETE,
      streamId: streamId,
      reason: wrapReason(reason)
    });
  });
}
function _processStreamMessage(data) {
  var streamId = data.streamId,
    sourceName = this.sourceName,
    targetName = data.sourceName,
    comObj = this.comObj;
  var streamController = this.streamControllers[streamId],
    streamSink = this.streamSinks[streamId];
  switch (data.stream) {
    case StreamKind.START_COMPLETE:
      if (data.success) {
        streamController.startCall.resolve();
      } else {
        streamController.startCall.reject(wrapReason(data.reason));
      }
      break;
    case StreamKind.PULL_COMPLETE:
      if (data.success) {
        streamController.pullCall.resolve();
      } else {
        streamController.pullCall.reject(wrapReason(data.reason));
      }
      break;
    case StreamKind.PULL:
      if (!streamSink) {
        comObj.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: StreamKind.PULL_COMPLETE,
          streamId: streamId,
          success: true
        });
        break;
      }
      if (streamSink.desiredSize <= 0 && data.desiredSize > 0) {
        streamSink.sinkCapability.resolve();
      }
      streamSink.desiredSize = data.desiredSize;
      Promise.try(streamSink.onPull || onFn).then(function () {
        comObj.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: StreamKind.PULL_COMPLETE,
          streamId: streamId,
          success: true
        });
      }, function (reason) {
        comObj.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: StreamKind.PULL_COMPLETE,
          streamId: streamId,
          reason: wrapReason(reason)
        });
      });
      break;
    case StreamKind.ENQUEUE:
      assert(streamController, "enqueue should have stream controller");
      if (streamController.isClosed) {
        break;
      }
      streamController.controller.enqueue(data.chunk);
      break;
    case StreamKind.CLOSE:
      assert(streamController, "close should have stream controller");
      if (streamController.isClosed) {
        break;
      }
      streamController.isClosed = true;
      streamController.controller.close();
      message_handler_assertClassBrand(_MessageHandler_brand, this, _deleteStreamController).call(this, streamController, streamId);
      break;
    case StreamKind.ERROR:
      assert(streamController, "error should have stream controller");
      streamController.controller.error(wrapReason(data.reason));
      message_handler_assertClassBrand(_MessageHandler_brand, this, _deleteStreamController).call(this, streamController, streamId);
      break;
    case StreamKind.CANCEL_COMPLETE:
      if (data.success) {
        streamController.cancelCall.resolve();
      } else {
        streamController.cancelCall.reject(wrapReason(data.reason));
      }
      message_handler_assertClassBrand(_MessageHandler_brand, this, _deleteStreamController).call(this, streamController, streamId);
      break;
    case StreamKind.CANCEL:
      if (!streamSink) {
        break;
      }
      var dataReason = wrapReason(data.reason);
      Promise.try(streamSink.onCancel || onFn, dataReason).then(function () {
        comObj.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: StreamKind.CANCEL_COMPLETE,
          streamId: streamId,
          success: true
        });
      }, function (reason) {
        comObj.postMessage({
          sourceName: sourceName,
          targetName: targetName,
          stream: StreamKind.CANCEL_COMPLETE,
          streamId: streamId,
          reason: wrapReason(reason)
        });
      });
      streamSink.sinkCapability.reject(dataReason);
      streamSink.isCancelled = true;
      delete this.streamSinks[streamId];
      break;
    default:
      throw new Error("Unexpected stream case");
  }
}
function _deleteStreamController(_x, _x2) {
  return _deleteStreamController2.apply(this, arguments);
}
function _deleteStreamController2() {
  _deleteStreamController2 = message_handler_asyncToGenerator(/*#__PURE__*/message_handler_regeneratorRuntime().mark(function _callee(streamController, streamId) {
    var _streamController$sta, _streamController$pul, _streamController$can;
    return message_handler_regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return Promise.allSettled([(_streamController$sta = streamController.startCall) === null || _streamController$sta === void 0 ? void 0 : _streamController$sta.promise, (_streamController$pul = streamController.pullCall) === null || _streamController$pul === void 0 ? void 0 : _streamController$pul.promise, (_streamController$can = streamController.cancelCall) === null || _streamController$can === void 0 ? void 0 : _streamController$can.promise]);
        case 2:
          delete this.streamControllers[streamId];
        case 3:
        case "end":
          return _context.stop();
      }
    }, _callee, this);
  }));
  return _deleteStreamController2.apply(this, arguments);
}

;// ./src/display/metadata.js
function metadata_typeof(o) { "@babel/helpers - typeof"; return metadata_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, metadata_typeof(o); }













function metadata_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function metadata_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, metadata_toPropertyKey(o.key), o); } }
function metadata_createClass(e, r, t) { return r && metadata_defineProperties(e.prototype, r), t && metadata_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function metadata_toPropertyKey(t) { var i = metadata_toPrimitive(t, "string"); return "symbol" == metadata_typeof(i) ? i : i + ""; }
function metadata_toPrimitive(t, r) { if ("object" != metadata_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != metadata_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function metadata_classPrivateFieldInitSpec(e, t, a) { metadata_checkPrivateRedeclaration(e, t), t.set(e, a); }
function metadata_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function metadata_classPrivateFieldGet(s, a) { return s.get(metadata_assertClassBrand(s, a)); }
function metadata_classPrivateFieldSet(s, a, r) { return s.set(metadata_assertClassBrand(s, a), r), r; }
function metadata_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }

var _metadataMap = /*#__PURE__*/new WeakMap();
var _data = /*#__PURE__*/new WeakMap();
var Metadata = /*#__PURE__*/function () {
  function Metadata(_ref) {
    var parsedData = _ref.parsedData,
      rawData = _ref.rawData;
    metadata_classCallCheck(this, Metadata);
    metadata_classPrivateFieldInitSpec(this, _metadataMap, void 0);
    metadata_classPrivateFieldInitSpec(this, _data, void 0);
    metadata_classPrivateFieldSet(_metadataMap, this, parsedData);
    metadata_classPrivateFieldSet(_data, this, rawData);
  }
  return metadata_createClass(Metadata, [{
    key: "getRaw",
    value: function getRaw() {
      return metadata_classPrivateFieldGet(_data, this);
    }
  }, {
    key: "get",
    value: function get(name) {
      var _classPrivateFieldGet2;
      return (_classPrivateFieldGet2 = metadata_classPrivateFieldGet(_metadataMap, this).get(name)) !== null && _classPrivateFieldGet2 !== void 0 ? _classPrivateFieldGet2 : null;
    }
  }, {
    key: "getAll",
    value: function getAll() {
      return objectFromMap(metadata_classPrivateFieldGet(_metadataMap, this));
    }
  }, {
    key: "has",
    value: function has(name) {
      return metadata_classPrivateFieldGet(_metadataMap, this).has(name);
    }
  }]);
}();

;// ./src/display/optional_content_config.js
function optional_content_config_typeof(o) { "@babel/helpers - typeof"; return optional_content_config_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, optional_content_config_typeof(o); }
function optional_content_config_slicedToArray(r, e) { return optional_content_config_arrayWithHoles(r) || optional_content_config_iterableToArrayLimit(r, e) || optional_content_config_unsupportedIterableToArray(r, e) || optional_content_config_nonIterableRest(); }
function optional_content_config_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function optional_content_config_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function optional_content_config_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function optional_content_config_toConsumableArray(r) { return optional_content_config_arrayWithoutHoles(r) || optional_content_config_iterableToArray(r) || optional_content_config_unsupportedIterableToArray(r) || optional_content_config_nonIterableSpread(); }
function optional_content_config_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function optional_content_config_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function optional_content_config_arrayWithoutHoles(r) { if (Array.isArray(r)) return optional_content_config_arrayLikeToArray(r); }
function optional_content_config_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = optional_content_config_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function optional_content_config_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return optional_content_config_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? optional_content_config_arrayLikeToArray(r, a) : void 0; } }
function optional_content_config_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function optional_content_config_classPrivateMethodInitSpec(e, a) { optional_content_config_checkPrivateRedeclaration(e, a), a.add(e); }
function optional_content_config_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function optional_content_config_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, optional_content_config_toPropertyKey(o.key), o); } }
function optional_content_config_createClass(e, r, t) { return r && optional_content_config_defineProperties(e.prototype, r), t && optional_content_config_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function optional_content_config_toPropertyKey(t) { var i = optional_content_config_toPrimitive(t, "string"); return "symbol" == optional_content_config_typeof(i) ? i : i + ""; }
function optional_content_config_toPrimitive(t, r) { if ("object" != optional_content_config_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != optional_content_config_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function optional_content_config_classPrivateFieldInitSpec(e, t, a) { optional_content_config_checkPrivateRedeclaration(e, t), t.set(e, a); }
function optional_content_config_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function optional_content_config_classPrivateFieldGet(s, a) { return s.get(optional_content_config_assertClassBrand(s, a)); }
function optional_content_config_classPrivateFieldSet(s, a, r) { return s.set(optional_content_config_assertClassBrand(s, a), r), r; }
function optional_content_config_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
























var INTERNAL = Symbol("INTERNAL");
var _isDisplay = /*#__PURE__*/new WeakMap();
var _isPrint = /*#__PURE__*/new WeakMap();
var _userSet = /*#__PURE__*/new WeakMap();
var _visible = /*#__PURE__*/new WeakMap();
var OptionalContentGroup = /*#__PURE__*/function () {
  function OptionalContentGroup(renderingIntent, _ref) {
    var name = _ref.name,
      intent = _ref.intent,
      usage = _ref.usage,
      rbGroups = _ref.rbGroups;
    optional_content_config_classCallCheck(this, OptionalContentGroup);
    optional_content_config_classPrivateFieldInitSpec(this, _isDisplay, false);
    optional_content_config_classPrivateFieldInitSpec(this, _isPrint, false);
    optional_content_config_classPrivateFieldInitSpec(this, _userSet, false);
    optional_content_config_classPrivateFieldInitSpec(this, _visible, true);
    optional_content_config_classPrivateFieldSet(_isDisplay, this, !!(renderingIntent & RenderingIntentFlag.DISPLAY));
    optional_content_config_classPrivateFieldSet(_isPrint, this, !!(renderingIntent & RenderingIntentFlag.PRINT));
    this.name = name;
    this.intent = intent;
    this.usage = usage;
    this.rbGroups = rbGroups;
  }
  return optional_content_config_createClass(OptionalContentGroup, [{
    key: "visible",
    get: function get() {
      if (optional_content_config_classPrivateFieldGet(_userSet, this)) {
        return optional_content_config_classPrivateFieldGet(_visible, this);
      }
      if (!optional_content_config_classPrivateFieldGet(_visible, this)) {
        return false;
      }
      var _this$usage = this.usage,
        print = _this$usage.print,
        view = _this$usage.view;
      if (optional_content_config_classPrivateFieldGet(_isDisplay, this)) {
        return (view === null || view === void 0 ? void 0 : view.viewState) !== "OFF";
      } else if (optional_content_config_classPrivateFieldGet(_isPrint, this)) {
        return (print === null || print === void 0 ? void 0 : print.printState) !== "OFF";
      }
      return true;
    }
  }, {
    key: "_setVisible",
    value: function _setVisible(internal, visible) {
      var userSet = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (internal !== INTERNAL) {
        unreachable("Internal method `_setVisible` called.");
      }
      optional_content_config_classPrivateFieldSet(_userSet, this, userSet);
      optional_content_config_classPrivateFieldSet(_visible, this, visible);
    }
  }]);
}();
var _cachedGetHash = /*#__PURE__*/new WeakMap();
var _groups = /*#__PURE__*/new WeakMap();
var _initialHash = /*#__PURE__*/new WeakMap();
var _order = /*#__PURE__*/new WeakMap();
var _OptionalContentConfig_brand = /*#__PURE__*/new WeakSet();
var OptionalContentConfig = /*#__PURE__*/function () {
  function OptionalContentConfig(data) {
    var renderingIntent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : RenderingIntentFlag.DISPLAY;
    optional_content_config_classCallCheck(this, OptionalContentConfig);
    optional_content_config_classPrivateMethodInitSpec(this, _OptionalContentConfig_brand);
    optional_content_config_classPrivateFieldInitSpec(this, _cachedGetHash, null);
    optional_content_config_classPrivateFieldInitSpec(this, _groups, new Map());
    optional_content_config_classPrivateFieldInitSpec(this, _initialHash, null);
    optional_content_config_classPrivateFieldInitSpec(this, _order, null);
    this.renderingIntent = renderingIntent;
    this.name = null;
    this.creator = null;
    if (data === null) {
      return;
    }
    this.name = data.name;
    this.creator = data.creator;
    optional_content_config_classPrivateFieldSet(_order, this, data.order);
    var _iterator = optional_content_config_createForOfIteratorHelper(data.groups),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _group = _step.value;
        optional_content_config_classPrivateFieldGet(_groups, this).set(_group.id, new OptionalContentGroup(renderingIntent, _group));
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    if (data.baseState === "OFF") {
      var _iterator2 = optional_content_config_createForOfIteratorHelper(optional_content_config_classPrivateFieldGet(_groups, this).values()),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var group = _step2.value;
          group._setVisible(INTERNAL, false);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
    var _iterator3 = optional_content_config_createForOfIteratorHelper(data.on),
      _step3;
    try {
      for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
        var on = _step3.value;
        optional_content_config_classPrivateFieldGet(_groups, this).get(on)._setVisible(INTERNAL, true);
      }
    } catch (err) {
      _iterator3.e(err);
    } finally {
      _iterator3.f();
    }
    var _iterator4 = optional_content_config_createForOfIteratorHelper(data.off),
      _step4;
    try {
      for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
        var off = _step4.value;
        optional_content_config_classPrivateFieldGet(_groups, this).get(off)._setVisible(INTERNAL, false);
      }
    } catch (err) {
      _iterator4.e(err);
    } finally {
      _iterator4.f();
    }
    optional_content_config_classPrivateFieldSet(_initialHash, this, this.getHash());
  }
  return optional_content_config_createClass(OptionalContentConfig, [{
    key: "isVisible",
    value: function isVisible(group) {
      if (optional_content_config_classPrivateFieldGet(_groups, this).size === 0) {
        return true;
      }
      if (!group) {
        info("Optional content group not defined.");
        return true;
      }
      if (group.type === "OCG") {
        if (!optional_content_config_classPrivateFieldGet(_groups, this).has(group.id)) {
          warn("Optional content group not found: ".concat(group.id));
          return true;
        }
        return optional_content_config_classPrivateFieldGet(_groups, this).get(group.id).visible;
      } else if (group.type === "OCMD") {
        if (group.expression) {
          return optional_content_config_assertClassBrand(_OptionalContentConfig_brand, this, _evaluateVisibilityExpression).call(this, group.expression);
        }
        if (!group.policy || group.policy === "AnyOn") {
          var _iterator5 = optional_content_config_createForOfIteratorHelper(group.ids),
            _step5;
          try {
            for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
              var id = _step5.value;
              if (!optional_content_config_classPrivateFieldGet(_groups, this).has(id)) {
                warn("Optional content group not found: ".concat(id));
                return true;
              }
              if (optional_content_config_classPrivateFieldGet(_groups, this).get(id).visible) {
                return true;
              }
            }
          } catch (err) {
            _iterator5.e(err);
          } finally {
            _iterator5.f();
          }
          return false;
        } else if (group.policy === "AllOn") {
          var _iterator6 = optional_content_config_createForOfIteratorHelper(group.ids),
            _step6;
          try {
            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
              var _id = _step6.value;
              if (!optional_content_config_classPrivateFieldGet(_groups, this).has(_id)) {
                warn("Optional content group not found: ".concat(_id));
                return true;
              }
              if (!optional_content_config_classPrivateFieldGet(_groups, this).get(_id).visible) {
                return false;
              }
            }
          } catch (err) {
            _iterator6.e(err);
          } finally {
            _iterator6.f();
          }
          return true;
        } else if (group.policy === "AnyOff") {
          var _iterator7 = optional_content_config_createForOfIteratorHelper(group.ids),
            _step7;
          try {
            for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
              var _id2 = _step7.value;
              if (!optional_content_config_classPrivateFieldGet(_groups, this).has(_id2)) {
                warn("Optional content group not found: ".concat(_id2));
                return true;
              }
              if (!optional_content_config_classPrivateFieldGet(_groups, this).get(_id2).visible) {
                return true;
              }
            }
          } catch (err) {
            _iterator7.e(err);
          } finally {
            _iterator7.f();
          }
          return false;
        } else if (group.policy === "AllOff") {
          var _iterator8 = optional_content_config_createForOfIteratorHelper(group.ids),
            _step8;
          try {
            for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
              var _id3 = _step8.value;
              if (!optional_content_config_classPrivateFieldGet(_groups, this).has(_id3)) {
                warn("Optional content group not found: ".concat(_id3));
                return true;
              }
              if (optional_content_config_classPrivateFieldGet(_groups, this).get(_id3).visible) {
                return false;
              }
            }
          } catch (err) {
            _iterator8.e(err);
          } finally {
            _iterator8.f();
          }
          return true;
        }
        warn("Unknown optional content policy ".concat(group.policy, "."));
        return true;
      }
      warn("Unknown group type ".concat(group.type, "."));
      return true;
    }
  }, {
    key: "setVisibility",
    value: function setVisibility(id) {
      var visible = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var preserveRB = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var group = optional_content_config_classPrivateFieldGet(_groups, this).get(id);
      if (!group) {
        warn("Optional content group not found: ".concat(id));
        return;
      }
      if (preserveRB && visible && group.rbGroups.length) {
        var _iterator9 = optional_content_config_createForOfIteratorHelper(group.rbGroups),
          _step9;
        try {
          for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
            var rbGroup = _step9.value;
            var _iterator10 = optional_content_config_createForOfIteratorHelper(rbGroup),
              _step10;
            try {
              for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
                var otherId = _step10.value;
                if (otherId !== id) {
                  var _classPrivateFieldGet2;
                  (_classPrivateFieldGet2 = optional_content_config_classPrivateFieldGet(_groups, this).get(otherId)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2._setVisible(INTERNAL, false, true);
                }
              }
            } catch (err) {
              _iterator10.e(err);
            } finally {
              _iterator10.f();
            }
          }
        } catch (err) {
          _iterator9.e(err);
        } finally {
          _iterator9.f();
        }
      }
      group._setVisible(INTERNAL, !!visible, true);
      optional_content_config_classPrivateFieldSet(_cachedGetHash, this, null);
    }
  }, {
    key: "setOCGState",
    value: function setOCGState(_ref2) {
      var state = _ref2.state,
        preserveRB = _ref2.preserveRB;
      var operator;
      var _iterator11 = optional_content_config_createForOfIteratorHelper(state),
        _step11;
      try {
        for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
          var elem = _step11.value;
          switch (elem) {
            case "ON":
            case "OFF":
            case "Toggle":
              operator = elem;
              continue;
          }
          var group = optional_content_config_classPrivateFieldGet(_groups, this).get(elem);
          if (!group) {
            continue;
          }
          switch (operator) {
            case "ON":
              this.setVisibility(elem, true, preserveRB);
              break;
            case "OFF":
              this.setVisibility(elem, false, preserveRB);
              break;
            case "Toggle":
              this.setVisibility(elem, !group.visible, preserveRB);
              break;
          }
        }
      } catch (err) {
        _iterator11.e(err);
      } finally {
        _iterator11.f();
      }
      optional_content_config_classPrivateFieldSet(_cachedGetHash, this, null);
    }
  }, {
    key: "hasInitialVisibility",
    get: function get() {
      return optional_content_config_classPrivateFieldGet(_initialHash, this) === null || this.getHash() === optional_content_config_classPrivateFieldGet(_initialHash, this);
    }
  }, {
    key: "getOrder",
    value: function getOrder() {
      if (!optional_content_config_classPrivateFieldGet(_groups, this).size) {
        return null;
      }
      if (optional_content_config_classPrivateFieldGet(_order, this)) {
        return optional_content_config_classPrivateFieldGet(_order, this).slice();
      }
      return optional_content_config_toConsumableArray(optional_content_config_classPrivateFieldGet(_groups, this).keys());
    }
  }, {
    key: "getGroups",
    value: function getGroups() {
      return optional_content_config_classPrivateFieldGet(_groups, this).size > 0 ? objectFromMap(optional_content_config_classPrivateFieldGet(_groups, this)) : null;
    }
  }, {
    key: "getGroup",
    value: function getGroup(id) {
      return optional_content_config_classPrivateFieldGet(_groups, this).get(id) || null;
    }
  }, {
    key: "getHash",
    value: function getHash() {
      if (optional_content_config_classPrivateFieldGet(_cachedGetHash, this) !== null) {
        return optional_content_config_classPrivateFieldGet(_cachedGetHash, this);
      }
      var hash = new MurmurHash3_64();
      var _iterator12 = optional_content_config_createForOfIteratorHelper(optional_content_config_classPrivateFieldGet(_groups, this)),
        _step12;
      try {
        for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
          var _step12$value = optional_content_config_slicedToArray(_step12.value, 2),
            id = _step12$value[0],
            group = _step12$value[1];
          hash.update("".concat(id, ":").concat(group.visible));
        }
      } catch (err) {
        _iterator12.e(err);
      } finally {
        _iterator12.f();
      }
      return optional_content_config_classPrivateFieldSet(_cachedGetHash, this, hash.hexdigest());
    }
  }]);
}();
function _evaluateVisibilityExpression(array) {
  var length = array.length;
  if (length < 2) {
    return true;
  }
  var operator = array[0];
  for (var i = 1; i < length; i++) {
    var element = array[i];
    var state = void 0;
    if (Array.isArray(element)) {
      state = optional_content_config_assertClassBrand(_OptionalContentConfig_brand, this, _evaluateVisibilityExpression).call(this, element);
    } else if (optional_content_config_classPrivateFieldGet(_groups, this).has(element)) {
      state = optional_content_config_classPrivateFieldGet(_groups, this).get(element).visible;
    } else {
      warn("Optional content group not found: ".concat(element));
      return true;
    }
    switch (operator) {
      case "And":
        if (!state) {
          return false;
        }
        break;
      case "Or":
        if (state) {
          return true;
        }
        break;
      case "Not":
        return !state;
      default:
        return true;
    }
  }
  return operator === "And";
}

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.index-of.js
var es_array_index_of = __webpack_require__(5276);
;// ./src/display/transport_stream.js
function transport_stream_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ transport_stream_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == transport_stream_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(transport_stream_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function transport_stream_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function transport_stream_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { transport_stream_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { transport_stream_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function transport_stream_typeof(o) { "@babel/helpers - typeof"; return transport_stream_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, transport_stream_typeof(o); }
function transport_stream_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = transport_stream_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function transport_stream_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return transport_stream_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? transport_stream_arrayLikeToArray(r, a) : void 0; } }
function transport_stream_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }







































































function transport_stream_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function transport_stream_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, transport_stream_toPropertyKey(o.key), o); } }
function transport_stream_createClass(e, r, t) { return r && transport_stream_defineProperties(e.prototype, r), t && transport_stream_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function transport_stream_toPropertyKey(t) { var i = transport_stream_toPrimitive(t, "string"); return "symbol" == transport_stream_typeof(i) ? i : i + ""; }
function transport_stream_toPrimitive(t, r) { if ("object" != transport_stream_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != transport_stream_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var PDFDataTransportStream = /*#__PURE__*/function () {
  function PDFDataTransportStream(pdfDataRangeTransport, _ref) {
    var _this = this;
    var _ref$disableRange = _ref.disableRange,
      disableRange = _ref$disableRange === void 0 ? false : _ref$disableRange,
      _ref$disableStream = _ref.disableStream,
      disableStream = _ref$disableStream === void 0 ? false : _ref$disableStream;
    transport_stream_classCallCheck(this, PDFDataTransportStream);
    assert(pdfDataRangeTransport, 'PDFDataTransportStream - missing required "pdfDataRangeTransport" argument.');
    var length = pdfDataRangeTransport.length,
      initialData = pdfDataRangeTransport.initialData,
      progressiveDone = pdfDataRangeTransport.progressiveDone,
      contentDispositionFilename = pdfDataRangeTransport.contentDispositionFilename;
    this._queuedChunks = [];
    this._progressiveDone = progressiveDone;
    this._contentDispositionFilename = contentDispositionFilename;
    if ((initialData === null || initialData === void 0 ? void 0 : initialData.length) > 0) {
      var buffer = initialData instanceof Uint8Array && initialData.byteLength === initialData.buffer.byteLength ? initialData.buffer : new Uint8Array(initialData).buffer;
      this._queuedChunks.push(buffer);
    }
    this._pdfDataRangeTransport = pdfDataRangeTransport;
    this._isStreamingSupported = !disableStream;
    this._isRangeSupported = !disableRange;
    this._contentLength = length;
    this._fullRequestReader = null;
    this._rangeReaders = [];
    pdfDataRangeTransport.addRangeListener(function (begin, chunk) {
      _this._onReceiveData({
        begin: begin,
        chunk: chunk
      });
    });
    pdfDataRangeTransport.addProgressListener(function (loaded, total) {
      _this._onProgress({
        loaded: loaded,
        total: total
      });
    });
    pdfDataRangeTransport.addProgressiveReadListener(function (chunk) {
      _this._onReceiveData({
        chunk: chunk
      });
    });
    pdfDataRangeTransport.addProgressiveDoneListener(function () {
      _this._onProgressiveDone();
    });
    pdfDataRangeTransport.transportReady();
  }
  return transport_stream_createClass(PDFDataTransportStream, [{
    key: "_onReceiveData",
    value: function _onReceiveData(_ref2) {
      var begin = _ref2.begin,
        chunk = _ref2.chunk;
      var buffer = chunk instanceof Uint8Array && chunk.byteLength === chunk.buffer.byteLength ? chunk.buffer : new Uint8Array(chunk).buffer;
      if (begin === undefined) {
        if (this._fullRequestReader) {
          this._fullRequestReader._enqueue(buffer);
        } else {
          this._queuedChunks.push(buffer);
        }
      } else {
        var found = this._rangeReaders.some(function (rangeReader) {
          if (rangeReader._begin !== begin) {
            return false;
          }
          rangeReader._enqueue(buffer);
          return true;
        });
        assert(found, "_onReceiveData - no `PDFDataTransportStreamRangeReader` instance found.");
      }
    }
  }, {
    key: "_progressiveDataLength",
    get: function get() {
      var _this$_fullRequestRea, _this$_fullRequestRea2;
      return (_this$_fullRequestRea = (_this$_fullRequestRea2 = this._fullRequestReader) === null || _this$_fullRequestRea2 === void 0 ? void 0 : _this$_fullRequestRea2._loaded) !== null && _this$_fullRequestRea !== void 0 ? _this$_fullRequestRea : 0;
    }
  }, {
    key: "_onProgress",
    value: function _onProgress(evt) {
      if (evt.total === undefined) {
        var _this$_rangeReaders$, _this$_rangeReaders$$;
        (_this$_rangeReaders$ = this._rangeReaders[0]) === null || _this$_rangeReaders$ === void 0 || (_this$_rangeReaders$$ = _this$_rangeReaders$.onProgress) === null || _this$_rangeReaders$$ === void 0 || _this$_rangeReaders$$.call(_this$_rangeReaders$, {
          loaded: evt.loaded
        });
      } else {
        var _this$_fullRequestRea3, _this$_fullRequestRea4;
        (_this$_fullRequestRea3 = this._fullRequestReader) === null || _this$_fullRequestRea3 === void 0 || (_this$_fullRequestRea4 = _this$_fullRequestRea3.onProgress) === null || _this$_fullRequestRea4 === void 0 || _this$_fullRequestRea4.call(_this$_fullRequestRea3, {
          loaded: evt.loaded,
          total: evt.total
        });
      }
    }
  }, {
    key: "_onProgressiveDone",
    value: function _onProgressiveDone() {
      var _this$_fullRequestRea5;
      (_this$_fullRequestRea5 = this._fullRequestReader) === null || _this$_fullRequestRea5 === void 0 || _this$_fullRequestRea5.progressiveDone();
      this._progressiveDone = true;
    }
  }, {
    key: "_removeRangeReader",
    value: function _removeRangeReader(reader) {
      var i = this._rangeReaders.indexOf(reader);
      if (i >= 0) {
        this._rangeReaders.splice(i, 1);
      }
    }
  }, {
    key: "getFullReader",
    value: function getFullReader() {
      assert(!this._fullRequestReader, "PDFDataTransportStream.getFullReader can only be called once.");
      var queuedChunks = this._queuedChunks;
      this._queuedChunks = null;
      return new PDFDataTransportStreamReader(this, queuedChunks, this._progressiveDone, this._contentDispositionFilename);
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(begin, end) {
      if (end <= this._progressiveDataLength) {
        return null;
      }
      var reader = new PDFDataTransportStreamRangeReader(this, begin, end);
      this._pdfDataRangeTransport.requestDataRange(begin, end);
      this._rangeReaders.push(reader);
      return reader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      var _this$_fullRequestRea6;
      (_this$_fullRequestRea6 = this._fullRequestReader) === null || _this$_fullRequestRea6 === void 0 || _this$_fullRequestRea6.cancel(reason);
      var _iterator = transport_stream_createForOfIteratorHelper(this._rangeReaders.slice(0)),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var reader = _step.value;
          reader.cancel(reason);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      this._pdfDataRangeTransport.abort();
    }
  }]);
}();
var PDFDataTransportStreamReader = /*#__PURE__*/function () {
  function PDFDataTransportStreamReader(stream, queuedChunks) {
    var progressiveDone = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var contentDispositionFilename = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    transport_stream_classCallCheck(this, PDFDataTransportStreamReader);
    this._stream = stream;
    this._done = progressiveDone || false;
    this._filename = isPdfFile(contentDispositionFilename) ? contentDispositionFilename : null;
    this._queuedChunks = queuedChunks || [];
    this._loaded = 0;
    var _iterator2 = transport_stream_createForOfIteratorHelper(this._queuedChunks),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var chunk = _step2.value;
        this._loaded += chunk.byteLength;
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    this._requests = [];
    this._headersReady = Promise.resolve();
    stream._fullRequestReader = this;
    this.onProgress = null;
  }
  return transport_stream_createClass(PDFDataTransportStreamReader, [{
    key: "_enqueue",
    value: function _enqueue(chunk) {
      if (this._done) {
        return;
      }
      if (this._requests.length > 0) {
        var requestCapability = this._requests.shift();
        requestCapability.resolve({
          value: chunk,
          done: false
        });
      } else {
        this._queuedChunks.push(chunk);
      }
      this._loaded += chunk.byteLength;
    }
  }, {
    key: "headersReady",
    get: function get() {
      return this._headersReady;
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._stream._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._stream._isStreamingSupported;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._stream._contentLength;
    }
  }, {
    key: "read",
    value: function () {
      var _read = transport_stream_asyncToGenerator(/*#__PURE__*/transport_stream_regeneratorRuntime().mark(function _callee() {
        var chunk, requestCapability;
        return transport_stream_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!(this._queuedChunks.length > 0)) {
                _context.next = 3;
                break;
              }
              chunk = this._queuedChunks.shift();
              return _context.abrupt("return", {
                value: chunk,
                done: false
              });
            case 3:
              if (!this._done) {
                _context.next = 5;
                break;
              }
              return _context.abrupt("return", {
                value: undefined,
                done: true
              });
            case 5:
              requestCapability = Promise.withResolvers();
              this._requests.push(requestCapability);
              return _context.abrupt("return", requestCapability.promise);
            case 8:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function read() {
        return _read.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      this._done = true;
      var _iterator3 = transport_stream_createForOfIteratorHelper(this._requests),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var requestCapability = _step3.value;
          requestCapability.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      this._requests.length = 0;
    }
  }, {
    key: "progressiveDone",
    value: function progressiveDone() {
      if (this._done) {
        return;
      }
      this._done = true;
    }
  }]);
}();
var PDFDataTransportStreamRangeReader = /*#__PURE__*/function () {
  function PDFDataTransportStreamRangeReader(stream, begin, end) {
    transport_stream_classCallCheck(this, PDFDataTransportStreamRangeReader);
    this._stream = stream;
    this._begin = begin;
    this._end = end;
    this._queuedChunk = null;
    this._requests = [];
    this._done = false;
    this.onProgress = null;
  }
  return transport_stream_createClass(PDFDataTransportStreamRangeReader, [{
    key: "_enqueue",
    value: function _enqueue(chunk) {
      if (this._done) {
        return;
      }
      if (this._requests.length === 0) {
        this._queuedChunk = chunk;
      } else {
        var requestsCapability = this._requests.shift();
        requestsCapability.resolve({
          value: chunk,
          done: false
        });
        var _iterator4 = transport_stream_createForOfIteratorHelper(this._requests),
          _step4;
        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var requestCapability = _step4.value;
            requestCapability.resolve({
              value: undefined,
              done: true
            });
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
        this._requests.length = 0;
      }
      this._done = true;
      this._stream._removeRangeReader(this);
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return false;
    }
  }, {
    key: "read",
    value: function () {
      var _read2 = transport_stream_asyncToGenerator(/*#__PURE__*/transport_stream_regeneratorRuntime().mark(function _callee2() {
        var chunk, requestCapability;
        return transport_stream_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!this._queuedChunk) {
                _context2.next = 4;
                break;
              }
              chunk = this._queuedChunk;
              this._queuedChunk = null;
              return _context2.abrupt("return", {
                value: chunk,
                done: false
              });
            case 4:
              if (!this._done) {
                _context2.next = 6;
                break;
              }
              return _context2.abrupt("return", {
                value: undefined,
                done: true
              });
            case 6:
              requestCapability = Promise.withResolvers();
              this._requests.push(requestCapability);
              return _context2.abrupt("return", requestCapability.promise);
            case 9:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function read() {
        return _read2.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      this._done = true;
      var _iterator5 = transport_stream_createForOfIteratorHelper(this._requests),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var requestCapability = _step5.value;
          requestCapability.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      this._requests.length = 0;
      this._stream._removeRangeReader(this);
    }
  }]);
}();

;// ./src/display/content_disposition.js
function content_disposition_slicedToArray(r, e) { return content_disposition_arrayWithHoles(r) || content_disposition_iterableToArrayLimit(r, e) || content_disposition_unsupportedIterableToArray(r, e) || content_disposition_nonIterableRest(); }
function content_disposition_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function content_disposition_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return content_disposition_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? content_disposition_arrayLikeToArray(r, a) : void 0; } }
function content_disposition_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function content_disposition_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function content_disposition_arrayWithHoles(r) { if (Array.isArray(r)) return r; }





























function getFilenameFromContentDispositionHeader(contentDisposition) {
  var needsEncodingFixup = true;
  var tmp = toParamRegExp("filename\\*", "i").exec(contentDisposition);
  if (tmp) {
    tmp = tmp[1];
    var filename = rfc2616unquote(tmp);
    filename = unescape(filename);
    filename = rfc5987decode(filename);
    filename = rfc2047decode(filename);
    return fixupEncoding(filename);
  }
  tmp = rfc2231getparam(contentDisposition);
  if (tmp) {
    var _filename = rfc2047decode(tmp);
    return fixupEncoding(_filename);
  }
  tmp = toParamRegExp("filename", "i").exec(contentDisposition);
  if (tmp) {
    tmp = tmp[1];
    var _filename2 = rfc2616unquote(tmp);
    _filename2 = rfc2047decode(_filename2);
    return fixupEncoding(_filename2);
  }
  function toParamRegExp(attributePattern, flags) {
    return new RegExp("(?:^|;)\\s*" + attributePattern + "\\s*=\\s*" + "(" + '[^";\\s][^;\\s]*' + "|" + '"(?:[^"\\\\]|\\\\"?)+"?' + ")", flags);
  }
  function textdecode(encoding, value) {
    if (encoding) {
      if (!/^[\x00-\xFF]+$/.test(value)) {
        return value;
      }
      try {
        var decoder = new TextDecoder(encoding, {
          fatal: true
        });
        var buffer = stringToBytes(value);
        value = decoder.decode(buffer);
        needsEncodingFixup = false;
      } catch (_unused) {}
    }
    return value;
  }
  function fixupEncoding(value) {
    if (needsEncodingFixup && /[\x80-\xff]/.test(value)) {
      value = textdecode("utf-8", value);
      if (needsEncodingFixup) {
        value = textdecode("iso-8859-1", value);
      }
    }
    return value;
  }
  function rfc2231getparam(contentDispositionStr) {
    var matches = [];
    var match;
    var iter = toParamRegExp("filename\\*((?!0\\d)\\d+)(\\*?)", "ig");
    while ((match = iter.exec(contentDispositionStr)) !== null) {
      var _match = match,
        _match2 = content_disposition_slicedToArray(_match, 4),
        n = _match2[1],
        quot = _match2[2],
        part = _match2[3];
      n = parseInt(n, 10);
      if (n in matches) {
        if (n === 0) {
          break;
        }
        continue;
      }
      matches[n] = [quot, part];
    }
    var parts = [];
    for (var _n = 0; _n < matches.length; ++_n) {
      if (!(_n in matches)) {
        break;
      }
      var _matches$_n = content_disposition_slicedToArray(matches[_n], 2),
        _quot = _matches$_n[0],
        _part = _matches$_n[1];
      _part = rfc2616unquote(_part);
      if (_quot) {
        _part = unescape(_part);
        if (_n === 0) {
          _part = rfc5987decode(_part);
        }
      }
      parts.push(_part);
    }
    return parts.join("");
  }
  function rfc2616unquote(value) {
    if (value.startsWith('"')) {
      var parts = value.slice(1).split('\\"');
      for (var i = 0; i < parts.length; ++i) {
        var quotindex = parts[i].indexOf('"');
        if (quotindex !== -1) {
          parts[i] = parts[i].slice(0, quotindex);
          parts.length = i + 1;
        }
        parts[i] = parts[i].replaceAll(/\\(.)/g, "$1");
      }
      value = parts.join('"');
    }
    return value;
  }
  function rfc5987decode(extvalue) {
    var encodingend = extvalue.indexOf("'");
    if (encodingend === -1) {
      return extvalue;
    }
    var encoding = extvalue.slice(0, encodingend);
    var langvalue = extvalue.slice(encodingend + 1);
    var value = langvalue.replace(/^[^']*'/, "");
    return textdecode(encoding, value);
  }
  function rfc2047decode(value) {
    if (!value.startsWith("=?") || /[\x00-\x19\x80-\xff]/.test(value)) {
      return value;
    }
    return value.replaceAll(/=\?([\w-]*)\?([QqBb])\?((?:[^?]|\?(?!=))*)\?=/g, function (matches, charset, encoding, text) {
      if (encoding === "q" || encoding === "Q") {
        text = text.replaceAll("_", " ");
        text = text.replaceAll(/=([0-9a-fA-F]{2})/g, function (match, hex) {
          return String.fromCharCode(parseInt(hex, 16));
        });
        return textdecode(charset, text);
      }
      try {
        text = atob(text);
      } catch (_unused2) {}
      return textdecode(charset, text);
    });
  }
  return "";
}

;// ./src/display/network_utils.js



















function network_utils_typeof(o) { "@babel/helpers - typeof"; return network_utils_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, network_utils_typeof(o); }



function createHeaders(isHttp, httpHeaders) {
  var headers = new Headers();
  if (!isHttp || !httpHeaders || network_utils_typeof(httpHeaders) !== "object") {
    return headers;
  }
  for (var key in httpHeaders) {
    var val = httpHeaders[key];
    if (val !== undefined) {
      headers.append(key, val);
    }
  }
  return headers;
}
function getResponseOrigin(url) {
  try {
    return new URL(url).origin;
  } catch (_unused) {}
  return null;
}
function validateRangeRequestCapabilities(_ref) {
  var responseHeaders = _ref.responseHeaders,
    isHttp = _ref.isHttp,
    rangeChunkSize = _ref.rangeChunkSize,
    disableRange = _ref.disableRange;
  var returnValues = {
    allowRangeRequests: false,
    suggestedLength: undefined
  };
  var length = parseInt(responseHeaders.get("Content-Length"), 10);
  if (!Number.isInteger(length)) {
    return returnValues;
  }
  returnValues.suggestedLength = length;
  if (length <= 2 * rangeChunkSize) {
    return returnValues;
  }
  if (disableRange || !isHttp) {
    return returnValues;
  }
  if (responseHeaders.get("Accept-Ranges") !== "bytes") {
    return returnValues;
  }
  var contentEncoding = responseHeaders.get("Content-Encoding") || "identity";
  if (contentEncoding !== "identity") {
    return returnValues;
  }
  returnValues.allowRangeRequests = true;
  return returnValues;
}
function extractFilenameFromHeader(responseHeaders) {
  var contentDisposition = responseHeaders.get("Content-Disposition");
  if (contentDisposition) {
    var filename = getFilenameFromContentDispositionHeader(contentDisposition);
    if (filename.includes("%")) {
      try {
        filename = decodeURIComponent(filename);
      } catch (_unused2) {}
    }
    if (isPdfFile(filename)) {
      return filename;
    }
  }
  return null;
}
function createResponseStatusError(status, url) {
  if (status === 404 || status === 0 && url.startsWith("file:")) {
    return new MissingPDFException('Missing PDF "' + url + '".');
  }
  return new UnexpectedResponseException("Unexpected server response (".concat(status, ") while retrieving PDF \"").concat(url, "\"."), status);
}
function validateResponseStatus(status) {
  return status === 200 || status === 206;
}

;// ./src/display/fetch_stream.js
function fetch_stream_typeof(o) { "@babel/helpers - typeof"; return fetch_stream_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, fetch_stream_typeof(o); }
function fetch_stream_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ fetch_stream_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == fetch_stream_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(fetch_stream_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function fetch_stream_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function fetch_stream_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { fetch_stream_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { fetch_stream_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function fetch_stream_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = fetch_stream_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function fetch_stream_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return fetch_stream_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? fetch_stream_arrayLikeToArray(r, a) : void 0; } }
function fetch_stream_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function fetch_stream_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function fetch_stream_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, fetch_stream_toPropertyKey(o.key), o); } }
function fetch_stream_createClass(e, r, t) { return r && fetch_stream_defineProperties(e.prototype, r), t && fetch_stream_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function fetch_stream_defineProperty(e, r, t) { return (r = fetch_stream_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function fetch_stream_toPropertyKey(t) { var i = fetch_stream_toPrimitive(t, "string"); return "symbol" == fetch_stream_typeof(i) ? i : i + ""; }
function fetch_stream_toPrimitive(t, r) { if ("object" != fetch_stream_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != fetch_stream_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }






































































function createFetchOptions(headers, withCredentials, abortController) {
  return {
    method: "GET",
    headers: headers,
    signal: abortController.signal,
    mode: "cors",
    credentials: withCredentials ? "include" : "same-origin",
    redirect: "follow"
  };
}
function getArrayBuffer(val) {
  if (val instanceof Uint8Array) {
    return val.buffer;
  }
  if (val instanceof ArrayBuffer) {
    return val;
  }
  warn("getArrayBuffer - unexpected data format: ".concat(val));
  return new Uint8Array(val).buffer;
}
var PDFFetchStream = /*#__PURE__*/function () {
  function PDFFetchStream(source) {
    fetch_stream_classCallCheck(this, PDFFetchStream);
    fetch_stream_defineProperty(this, "_responseOrigin", null);
    this.source = source;
    this.isHttp = /^https?:/i.test(source.url);
    this.headers = createHeaders(this.isHttp, source.httpHeaders);
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }
  return fetch_stream_createClass(PDFFetchStream, [{
    key: "_progressiveDataLength",
    get: function get() {
      var _this$_fullRequestRea, _this$_fullRequestRea2;
      return (_this$_fullRequestRea = (_this$_fullRequestRea2 = this._fullRequestReader) === null || _this$_fullRequestRea2 === void 0 ? void 0 : _this$_fullRequestRea2._loaded) !== null && _this$_fullRequestRea !== void 0 ? _this$_fullRequestRea : 0;
    }
  }, {
    key: "getFullReader",
    value: function getFullReader() {
      assert(!this._fullRequestReader, "PDFFetchStream.getFullReader can only be called once.");
      this._fullRequestReader = new PDFFetchStreamReader(this);
      return this._fullRequestReader;
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(begin, end) {
      if (end <= this._progressiveDataLength) {
        return null;
      }
      var reader = new PDFFetchStreamRangeReader(this, begin, end);
      this._rangeRequestReaders.push(reader);
      return reader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      var _this$_fullRequestRea3;
      (_this$_fullRequestRea3 = this._fullRequestReader) === null || _this$_fullRequestRea3 === void 0 || _this$_fullRequestRea3.cancel(reason);
      var _iterator = fetch_stream_createForOfIteratorHelper(this._rangeRequestReaders.slice(0)),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var reader = _step.value;
          reader.cancel(reason);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }]);
}();
var PDFFetchStreamReader = /*#__PURE__*/function () {
  function PDFFetchStreamReader(stream) {
    var _this = this;
    fetch_stream_classCallCheck(this, PDFFetchStreamReader);
    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    this._filename = null;
    var source = stream.source;
    this._withCredentials = source.withCredentials || false;
    this._contentLength = source.length;
    this._headersCapability = Promise.withResolvers();
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;
    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }
    this._abortController = new AbortController();
    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    var headers = new Headers(stream.headers);
    var url = source.url;
    fetch(url, createFetchOptions(headers, this._withCredentials, this._abortController)).then(function (response) {
      stream._responseOrigin = getResponseOrigin(response.url);
      if (!validateResponseStatus(response.status)) {
        throw createResponseStatusError(response.status, url);
      }
      _this._reader = response.body.getReader();
      _this._headersCapability.resolve();
      var responseHeaders = response.headers;
      var _validateRangeRequest = validateRangeRequestCapabilities({
          responseHeaders: responseHeaders,
          isHttp: stream.isHttp,
          rangeChunkSize: _this._rangeChunkSize,
          disableRange: _this._disableRange
        }),
        allowRangeRequests = _validateRangeRequest.allowRangeRequests,
        suggestedLength = _validateRangeRequest.suggestedLength;
      _this._isRangeSupported = allowRangeRequests;
      _this._contentLength = suggestedLength || _this._contentLength;
      _this._filename = extractFilenameFromHeader(responseHeaders);
      if (!_this._isStreamingSupported && _this._isRangeSupported) {
        _this.cancel(new AbortException("Streaming is disabled."));
      }
    }).catch(this._headersCapability.reject);
    this.onProgress = null;
  }
  return fetch_stream_createClass(PDFFetchStreamReader, [{
    key: "headersReady",
    get: function get() {
      return this._headersCapability.promise;
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._contentLength;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }, {
    key: "read",
    value: function () {
      var _read = fetch_stream_asyncToGenerator(/*#__PURE__*/fetch_stream_regeneratorRuntime().mark(function _callee() {
        var _this$onProgress;
        var _yield$this$_reader$r, value, done;
        return fetch_stream_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this._headersCapability.promise;
            case 2:
              _context.next = 4;
              return this._reader.read();
            case 4:
              _yield$this$_reader$r = _context.sent;
              value = _yield$this$_reader$r.value;
              done = _yield$this$_reader$r.done;
              if (!done) {
                _context.next = 9;
                break;
              }
              return _context.abrupt("return", {
                value: value,
                done: done
              });
            case 9:
              this._loaded += value.byteLength;
              (_this$onProgress = this.onProgress) === null || _this$onProgress === void 0 || _this$onProgress.call(this, {
                loaded: this._loaded,
                total: this._contentLength
              });
              return _context.abrupt("return", {
                value: getArrayBuffer(value),
                done: false
              });
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function read() {
        return _read.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      var _this$_reader;
      (_this$_reader = this._reader) === null || _this$_reader === void 0 || _this$_reader.cancel(reason);
      this._abortController.abort();
    }
  }]);
}();
var PDFFetchStreamRangeReader = /*#__PURE__*/function () {
  function PDFFetchStreamRangeReader(stream, begin, end) {
    var _this2 = this;
    fetch_stream_classCallCheck(this, PDFFetchStreamRangeReader);
    this._stream = stream;
    this._reader = null;
    this._loaded = 0;
    var source = stream.source;
    this._withCredentials = source.withCredentials || false;
    this._readCapability = Promise.withResolvers();
    this._isStreamingSupported = !source.disableStream;
    this._abortController = new AbortController();
    var headers = new Headers(stream.headers);
    headers.append("Range", "bytes=".concat(begin, "-").concat(end - 1));
    var url = source.url;
    fetch(url, createFetchOptions(headers, this._withCredentials, this._abortController)).then(function (response) {
      var responseOrigin = getResponseOrigin(response.url);
      if (responseOrigin !== stream._responseOrigin) {
        throw new Error("Expected range response-origin \"".concat(responseOrigin, "\" to match \"").concat(stream._responseOrigin, "\"."));
      }
      if (!validateResponseStatus(response.status)) {
        throw createResponseStatusError(response.status, url);
      }
      _this2._readCapability.resolve();
      _this2._reader = response.body.getReader();
    }).catch(this._readCapability.reject);
    this.onProgress = null;
  }
  return fetch_stream_createClass(PDFFetchStreamRangeReader, [{
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }, {
    key: "read",
    value: function () {
      var _read2 = fetch_stream_asyncToGenerator(/*#__PURE__*/fetch_stream_regeneratorRuntime().mark(function _callee2() {
        var _this$onProgress2;
        var _yield$this$_reader$r2, value, done;
        return fetch_stream_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this._readCapability.promise;
            case 2:
              _context2.next = 4;
              return this._reader.read();
            case 4:
              _yield$this$_reader$r2 = _context2.sent;
              value = _yield$this$_reader$r2.value;
              done = _yield$this$_reader$r2.done;
              if (!done) {
                _context2.next = 9;
                break;
              }
              return _context2.abrupt("return", {
                value: value,
                done: done
              });
            case 9:
              this._loaded += value.byteLength;
              (_this$onProgress2 = this.onProgress) === null || _this$onProgress2 === void 0 || _this$onProgress2.call(this, {
                loaded: this._loaded
              });
              return _context2.abrupt("return", {
                value: getArrayBuffer(value),
                done: false
              });
            case 12:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function read() {
        return _read2.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      var _this$_reader2;
      (_this$_reader2 = this._reader) === null || _this$_reader2 === void 0 || _this$_reader2.cancel(reason);
      this._abortController.abort();
    }
  }]);
}();

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.trim-start.js
var es_string_trim_start = __webpack_require__(3359);
;// ./src/display/network.js
function network_typeof(o) { "@babel/helpers - typeof"; return network_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, network_typeof(o); }
function network_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ network_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == network_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(network_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function network_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function network_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { network_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { network_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function _toArray(r) { return network_arrayWithHoles(r) || network_iterableToArray(r) || network_unsupportedIterableToArray(r) || network_nonIterableRest(); }
function network_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function network_slicedToArray(r, e) { return network_arrayWithHoles(r) || network_iterableToArrayLimit(r, e) || network_unsupportedIterableToArray(r, e) || network_nonIterableRest(); }
function network_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function network_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function network_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function network_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = network_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function network_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return network_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? network_arrayLikeToArray(r, a) : void 0; } }
function network_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function network_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function network_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, network_toPropertyKey(o.key), o); } }
function network_createClass(e, r, t) { return r && network_defineProperties(e.prototype, r), t && network_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function network_defineProperty(e, r, t) { return (r = network_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function network_toPropertyKey(t) { var i = network_toPrimitive(t, "string"); return "symbol" == network_typeof(i) ? i : i + ""; }
function network_toPrimitive(t, r) { if ("object" != network_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != network_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }











































var OK_RESPONSE = 200;
var PARTIAL_CONTENT_RESPONSE = 206;
function network_getArrayBuffer(xhr) {
  var data = xhr.response;
  if (typeof data !== "string") {
    return data;
  }
  return stringToBytes(data).buffer;
}
var NetworkManager = /*#__PURE__*/function () {
  function NetworkManager(_ref) {
    var url = _ref.url,
      httpHeaders = _ref.httpHeaders,
      withCredentials = _ref.withCredentials;
    network_classCallCheck(this, NetworkManager);
    network_defineProperty(this, "_responseOrigin", null);
    this.url = url;
    this.isHttp = /^https?:/i.test(url);
    this.headers = createHeaders(this.isHttp, httpHeaders);
    this.withCredentials = withCredentials || false;
    this.currXhrId = 0;
    this.pendingRequests = Object.create(null);
  }
  return network_createClass(NetworkManager, [{
    key: "requestRange",
    value: function requestRange(begin, end, listeners) {
      var args = {
        begin: begin,
        end: end
      };
      for (var prop in listeners) {
        args[prop] = listeners[prop];
      }
      return this.request(args);
    }
  }, {
    key: "requestFull",
    value: function requestFull(listeners) {
      return this.request(listeners);
    }
  }, {
    key: "request",
    value: function request(args) {
      var xhr = new XMLHttpRequest();
      var xhrId = this.currXhrId++;
      var pendingRequest = this.pendingRequests[xhrId] = {
        xhr: xhr
      };
      xhr.open("GET", this.url);
      xhr.withCredentials = this.withCredentials;
      var _iterator = network_createForOfIteratorHelper(this.headers),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = network_slicedToArray(_step.value, 2),
            key = _step$value[0],
            val = _step$value[1];
          xhr.setRequestHeader(key, val);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      if (this.isHttp && "begin" in args && "end" in args) {
        xhr.setRequestHeader("Range", "bytes=".concat(args.begin, "-").concat(args.end - 1));
        pendingRequest.expectedStatus = PARTIAL_CONTENT_RESPONSE;
      } else {
        pendingRequest.expectedStatus = OK_RESPONSE;
      }
      xhr.responseType = "arraybuffer";
      assert(args.onError, "Expected `onError` callback to be provided.");
      xhr.onerror = function () {
        args.onError(xhr.status);
      };
      xhr.onreadystatechange = this.onStateChange.bind(this, xhrId);
      xhr.onprogress = this.onProgress.bind(this, xhrId);
      pendingRequest.onHeadersReceived = args.onHeadersReceived;
      pendingRequest.onDone = args.onDone;
      pendingRequest.onError = args.onError;
      pendingRequest.onProgress = args.onProgress;
      xhr.send(null);
      return xhrId;
    }
  }, {
    key: "onProgress",
    value: function onProgress(xhrId, evt) {
      var _pendingRequest$onPro;
      var pendingRequest = this.pendingRequests[xhrId];
      if (!pendingRequest) {
        return;
      }
      (_pendingRequest$onPro = pendingRequest.onProgress) === null || _pendingRequest$onPro === void 0 || _pendingRequest$onPro.call(pendingRequest, evt);
    }
  }, {
    key: "onStateChange",
    value: function onStateChange(xhrId, evt) {
      var pendingRequest = this.pendingRequests[xhrId];
      if (!pendingRequest) {
        return;
      }
      var xhr = pendingRequest.xhr;
      if (xhr.readyState >= 2 && pendingRequest.onHeadersReceived) {
        pendingRequest.onHeadersReceived();
        delete pendingRequest.onHeadersReceived;
      }
      if (xhr.readyState !== 4) {
        return;
      }
      if (!(xhrId in this.pendingRequests)) {
        return;
      }
      delete this.pendingRequests[xhrId];
      if (xhr.status === 0 && this.isHttp) {
        pendingRequest.onError(xhr.status);
        return;
      }
      var xhrStatus = xhr.status || OK_RESPONSE;
      var ok_response_on_range_request = xhrStatus === OK_RESPONSE && pendingRequest.expectedStatus === PARTIAL_CONTENT_RESPONSE;
      if (!ok_response_on_range_request && xhrStatus !== pendingRequest.expectedStatus) {
        pendingRequest.onError(xhr.status);
        return;
      }
      var chunk = network_getArrayBuffer(xhr);
      if (xhrStatus === PARTIAL_CONTENT_RESPONSE) {
        var rangeHeader = xhr.getResponseHeader("Content-Range");
        var matches = /bytes (\d+)-(\d+)\/(\d+)/.exec(rangeHeader);
        if (matches) {
          pendingRequest.onDone({
            begin: parseInt(matches[1], 10),
            chunk: chunk
          });
        } else {
          warn("Missing or invalid \"Content-Range\" header.");
          pendingRequest.onError(0);
        }
      } else if (chunk) {
        pendingRequest.onDone({
          begin: 0,
          chunk: chunk
        });
      } else {
        pendingRequest.onError(xhr.status);
      }
    }
  }, {
    key: "getRequestXhr",
    value: function getRequestXhr(xhrId) {
      return this.pendingRequests[xhrId].xhr;
    }
  }, {
    key: "isPendingRequest",
    value: function isPendingRequest(xhrId) {
      return xhrId in this.pendingRequests;
    }
  }, {
    key: "abortRequest",
    value: function abortRequest(xhrId) {
      var xhr = this.pendingRequests[xhrId].xhr;
      delete this.pendingRequests[xhrId];
      xhr.abort();
    }
  }]);
}();
var PDFNetworkStream = /*#__PURE__*/function () {
  function PDFNetworkStream(source) {
    network_classCallCheck(this, PDFNetworkStream);
    this._source = source;
    this._manager = new NetworkManager(source);
    this._rangeChunkSize = source.rangeChunkSize;
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }
  return network_createClass(PDFNetworkStream, [{
    key: "_onRangeRequestReaderClosed",
    value: function _onRangeRequestReaderClosed(reader) {
      var i = this._rangeRequestReaders.indexOf(reader);
      if (i >= 0) {
        this._rangeRequestReaders.splice(i, 1);
      }
    }
  }, {
    key: "getFullReader",
    value: function getFullReader() {
      assert(!this._fullRequestReader, "PDFNetworkStream.getFullReader can only be called once.");
      this._fullRequestReader = new PDFNetworkStreamFullRequestReader(this._manager, this._source);
      return this._fullRequestReader;
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(begin, end) {
      var reader = new PDFNetworkStreamRangeRequestReader(this._manager, begin, end);
      reader.onClosed = this._onRangeRequestReaderClosed.bind(this);
      this._rangeRequestReaders.push(reader);
      return reader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      var _this$_fullRequestRea;
      (_this$_fullRequestRea = this._fullRequestReader) === null || _this$_fullRequestRea === void 0 || _this$_fullRequestRea.cancel(reason);
      var _iterator2 = network_createForOfIteratorHelper(this._rangeRequestReaders.slice(0)),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var reader = _step2.value;
          reader.cancel(reason);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  }]);
}();
var PDFNetworkStreamFullRequestReader = /*#__PURE__*/function () {
  function PDFNetworkStreamFullRequestReader(manager, source) {
    network_classCallCheck(this, PDFNetworkStreamFullRequestReader);
    this._manager = manager;
    var args = {
      onHeadersReceived: this._onHeadersReceived.bind(this),
      onDone: this._onDone.bind(this),
      onError: this._onError.bind(this),
      onProgress: this._onProgress.bind(this)
    };
    this._url = source.url;
    this._fullRequestId = manager.requestFull(args);
    this._headersCapability = Promise.withResolvers();
    this._disableRange = source.disableRange || false;
    this._contentLength = source.length;
    this._rangeChunkSize = source.rangeChunkSize;
    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }
    this._isStreamingSupported = false;
    this._isRangeSupported = false;
    this._cachedChunks = [];
    this._requests = [];
    this._done = false;
    this._storedError = undefined;
    this._filename = null;
    this.onProgress = null;
  }
  return network_createClass(PDFNetworkStreamFullRequestReader, [{
    key: "_onHeadersReceived",
    value: function _onHeadersReceived() {
      var fullRequestXhrId = this._fullRequestId;
      var fullRequestXhr = this._manager.getRequestXhr(fullRequestXhrId);
      this._manager._responseOrigin = getResponseOrigin(fullRequestXhr.responseURL);
      var rawResponseHeaders = fullRequestXhr.getAllResponseHeaders();
      var responseHeaders = new Headers(rawResponseHeaders ? rawResponseHeaders.trimStart().replace(/[^\S ]+$/, "").split(/[\r\n]+/).map(function (x) {
        var _x$split = x.split(": "),
          _x$split2 = _toArray(_x$split),
          key = _x$split2[0],
          val = _x$split2.slice(1);
        return [key, val.join(": ")];
      }) : []);
      var _validateRangeRequest = validateRangeRequestCapabilities({
          responseHeaders: responseHeaders,
          isHttp: this._manager.isHttp,
          rangeChunkSize: this._rangeChunkSize,
          disableRange: this._disableRange
        }),
        allowRangeRequests = _validateRangeRequest.allowRangeRequests,
        suggestedLength = _validateRangeRequest.suggestedLength;
      if (allowRangeRequests) {
        this._isRangeSupported = true;
      }
      this._contentLength = suggestedLength || this._contentLength;
      this._filename = extractFilenameFromHeader(responseHeaders);
      if (this._isRangeSupported) {
        this._manager.abortRequest(fullRequestXhrId);
      }
      this._headersCapability.resolve();
    }
  }, {
    key: "_onDone",
    value: function _onDone(data) {
      if (data) {
        if (this._requests.length > 0) {
          var requestCapability = this._requests.shift();
          requestCapability.resolve({
            value: data.chunk,
            done: false
          });
        } else {
          this._cachedChunks.push(data.chunk);
        }
      }
      this._done = true;
      if (this._cachedChunks.length > 0) {
        return;
      }
      var _iterator3 = network_createForOfIteratorHelper(this._requests),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _requestCapability = _step3.value;
          _requestCapability.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      this._requests.length = 0;
    }
  }, {
    key: "_onError",
    value: function _onError(status) {
      this._storedError = createResponseStatusError(status, this._url);
      this._headersCapability.reject(this._storedError);
      var _iterator4 = network_createForOfIteratorHelper(this._requests),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var requestCapability = _step4.value;
          requestCapability.reject(this._storedError);
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      this._requests.length = 0;
      this._cachedChunks.length = 0;
    }
  }, {
    key: "_onProgress",
    value: function _onProgress(evt) {
      var _this$onProgress;
      (_this$onProgress = this.onProgress) === null || _this$onProgress === void 0 || _this$onProgress.call(this, {
        loaded: evt.loaded,
        total: evt.lengthComputable ? evt.total : this._contentLength
      });
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._contentLength;
    }
  }, {
    key: "headersReady",
    get: function get() {
      return this._headersCapability.promise;
    }
  }, {
    key: "read",
    value: function () {
      var _read = network_asyncToGenerator(/*#__PURE__*/network_regeneratorRuntime().mark(function _callee() {
        var chunk, requestCapability;
        return network_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this._headersCapability.promise;
            case 2:
              if (!this._storedError) {
                _context.next = 4;
                break;
              }
              throw this._storedError;
            case 4:
              if (!(this._cachedChunks.length > 0)) {
                _context.next = 7;
                break;
              }
              chunk = this._cachedChunks.shift();
              return _context.abrupt("return", {
                value: chunk,
                done: false
              });
            case 7:
              if (!this._done) {
                _context.next = 9;
                break;
              }
              return _context.abrupt("return", {
                value: undefined,
                done: true
              });
            case 9:
              requestCapability = Promise.withResolvers();
              this._requests.push(requestCapability);
              return _context.abrupt("return", requestCapability.promise);
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function read() {
        return _read.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      this._done = true;
      this._headersCapability.reject(reason);
      var _iterator5 = network_createForOfIteratorHelper(this._requests),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var requestCapability = _step5.value;
          requestCapability.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      this._requests.length = 0;
      if (this._manager.isPendingRequest(this._fullRequestId)) {
        this._manager.abortRequest(this._fullRequestId);
      }
      this._fullRequestReader = null;
    }
  }]);
}();
var PDFNetworkStreamRangeRequestReader = /*#__PURE__*/function () {
  function PDFNetworkStreamRangeRequestReader(manager, begin, end) {
    network_classCallCheck(this, PDFNetworkStreamRangeRequestReader);
    this._manager = manager;
    var args = {
      onHeadersReceived: this._onHeadersReceived.bind(this),
      onDone: this._onDone.bind(this),
      onError: this._onError.bind(this),
      onProgress: this._onProgress.bind(this)
    };
    this._url = manager.url;
    this._requestId = manager.requestRange(begin, end, args);
    this._requests = [];
    this._queuedChunk = null;
    this._done = false;
    this._storedError = undefined;
    this.onProgress = null;
    this.onClosed = null;
  }
  return network_createClass(PDFNetworkStreamRangeRequestReader, [{
    key: "_onHeadersReceived",
    value: function _onHeadersReceived() {
      var _this$_manager$getReq;
      var responseOrigin = getResponseOrigin((_this$_manager$getReq = this._manager.getRequestXhr(this._requestId)) === null || _this$_manager$getReq === void 0 ? void 0 : _this$_manager$getReq.responseURL);
      if (responseOrigin !== this._manager._responseOrigin) {
        this._storedError = new Error("Expected range response-origin \"".concat(responseOrigin, "\" to match \"").concat(this._manager._responseOrigin, "\"."));
        this._onError(0);
      }
    }
  }, {
    key: "_close",
    value: function _close() {
      var _this$onClosed;
      (_this$onClosed = this.onClosed) === null || _this$onClosed === void 0 || _this$onClosed.call(this, this);
    }
  }, {
    key: "_onDone",
    value: function _onDone(data) {
      var chunk = data.chunk;
      if (this._requests.length > 0) {
        var requestCapability = this._requests.shift();
        requestCapability.resolve({
          value: chunk,
          done: false
        });
      } else {
        this._queuedChunk = chunk;
      }
      this._done = true;
      var _iterator6 = network_createForOfIteratorHelper(this._requests),
        _step6;
      try {
        for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
          var _requestCapability2 = _step6.value;
          _requestCapability2.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator6.e(err);
      } finally {
        _iterator6.f();
      }
      this._requests.length = 0;
      this._close();
    }
  }, {
    key: "_onError",
    value: function _onError(status) {
      var _this$_storedError;
      (_this$_storedError = this._storedError) !== null && _this$_storedError !== void 0 ? _this$_storedError : this._storedError = createResponseStatusError(status, this._url);
      var _iterator7 = network_createForOfIteratorHelper(this._requests),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var requestCapability = _step7.value;
          requestCapability.reject(this._storedError);
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
      this._requests.length = 0;
      this._queuedChunk = null;
    }
  }, {
    key: "_onProgress",
    value: function _onProgress(evt) {
      if (!this.isStreamingSupported) {
        var _this$onProgress2;
        (_this$onProgress2 = this.onProgress) === null || _this$onProgress2 === void 0 || _this$onProgress2.call(this, {
          loaded: evt.loaded
        });
      }
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return false;
    }
  }, {
    key: "read",
    value: function () {
      var _read2 = network_asyncToGenerator(/*#__PURE__*/network_regeneratorRuntime().mark(function _callee2() {
        var chunk, requestCapability;
        return network_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              if (!this._storedError) {
                _context2.next = 2;
                break;
              }
              throw this._storedError;
            case 2:
              if (!(this._queuedChunk !== null)) {
                _context2.next = 6;
                break;
              }
              chunk = this._queuedChunk;
              this._queuedChunk = null;
              return _context2.abrupt("return", {
                value: chunk,
                done: false
              });
            case 6:
              if (!this._done) {
                _context2.next = 8;
                break;
              }
              return _context2.abrupt("return", {
                value: undefined,
                done: true
              });
            case 8:
              requestCapability = Promise.withResolvers();
              this._requests.push(requestCapability);
              return _context2.abrupt("return", requestCapability.promise);
            case 11:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function read() {
        return _read2.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      this._done = true;
      var _iterator8 = network_createForOfIteratorHelper(this._requests),
        _step8;
      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var requestCapability = _step8.value;
          requestCapability.resolve({
            value: undefined,
            done: true
          });
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }
      this._requests.length = 0;
      if (this._manager.isPendingRequest(this._requestId)) {
        this._manager.abortRequest(this._requestId);
      }
      this._close();
    }
  }]);
}();

;// ./src/display/node_stream.js
function node_stream_typeof(o) { "@babel/helpers - typeof"; return node_stream_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, node_stream_typeof(o); }
function node_stream_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ node_stream_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == node_stream_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(node_stream_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function node_stream_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function node_stream_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { node_stream_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { node_stream_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function node_stream_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = node_stream_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function node_stream_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return node_stream_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? node_stream_arrayLikeToArray(r, a) : void 0; } }
function node_stream_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function node_stream_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function node_stream_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, node_stream_toPropertyKey(o.key), o); } }
function node_stream_createClass(e, r, t) { return r && node_stream_defineProperties(e.prototype, r), t && node_stream_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function node_stream_toPropertyKey(t) { var i = node_stream_toPrimitive(t, "string"); return "symbol" == node_stream_typeof(i) ? i : i + ""; }
function node_stream_toPrimitive(t, r) { if ("object" != node_stream_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != node_stream_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }










































































var urlRegex = /^[a-z][a-z0-9\-+.]+:/i;
function parseUrlOrPath(sourceUrl) {
  if (urlRegex.test(sourceUrl)) {
    return new URL(sourceUrl);
  }
  var url = process.getBuiltinModule("url");
  return new URL(url.pathToFileURL(sourceUrl));
}
var PDFNodeStream = /*#__PURE__*/function () {
  function PDFNodeStream(source) {
    node_stream_classCallCheck(this, PDFNodeStream);
    this.source = source;
    this.url = parseUrlOrPath(source.url);
    assert(this.url.protocol === "file:", "PDFNodeStream only supports file:// URLs.");
    this._fullRequestReader = null;
    this._rangeRequestReaders = [];
  }
  return node_stream_createClass(PDFNodeStream, [{
    key: "_progressiveDataLength",
    get: function get() {
      var _this$_fullRequestRea, _this$_fullRequestRea2;
      return (_this$_fullRequestRea = (_this$_fullRequestRea2 = this._fullRequestReader) === null || _this$_fullRequestRea2 === void 0 ? void 0 : _this$_fullRequestRea2._loaded) !== null && _this$_fullRequestRea !== void 0 ? _this$_fullRequestRea : 0;
    }
  }, {
    key: "getFullReader",
    value: function getFullReader() {
      assert(!this._fullRequestReader, "PDFNodeStream.getFullReader can only be called once.");
      this._fullRequestReader = new PDFNodeStreamFsFullReader(this);
      return this._fullRequestReader;
    }
  }, {
    key: "getRangeReader",
    value: function getRangeReader(start, end) {
      if (end <= this._progressiveDataLength) {
        return null;
      }
      var rangeReader = new PDFNodeStreamFsRangeReader(this, start, end);
      this._rangeRequestReaders.push(rangeReader);
      return rangeReader;
    }
  }, {
    key: "cancelAllRequests",
    value: function cancelAllRequests(reason) {
      var _this$_fullRequestRea3;
      (_this$_fullRequestRea3 = this._fullRequestReader) === null || _this$_fullRequestRea3 === void 0 || _this$_fullRequestRea3.cancel(reason);
      var _iterator = node_stream_createForOfIteratorHelper(this._rangeRequestReaders.slice(0)),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var reader = _step.value;
          reader.cancel(reason);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }]);
}();
var PDFNodeStreamFsFullReader = /*#__PURE__*/function () {
  function PDFNodeStreamFsFullReader(stream) {
    var _this = this;
    node_stream_classCallCheck(this, PDFNodeStreamFsFullReader);
    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    var source = stream.source;
    this._contentLength = source.length;
    this._loaded = 0;
    this._filename = null;
    this._disableRange = source.disableRange || false;
    this._rangeChunkSize = source.rangeChunkSize;
    if (!this._rangeChunkSize && !this._disableRange) {
      this._disableRange = true;
    }
    this._isStreamingSupported = !source.disableStream;
    this._isRangeSupported = !source.disableRange;
    this._readableStream = null;
    this._readCapability = Promise.withResolvers();
    this._headersCapability = Promise.withResolvers();
    var fs = process.getBuiltinModule("fs");
    fs.promises.lstat(this._url).then(function (stat) {
      _this._contentLength = stat.size;
      _this._setReadableStream(fs.createReadStream(_this._url));
      _this._headersCapability.resolve();
    }, function (error) {
      if (error.code === "ENOENT") {
        error = new MissingPDFException("Missing PDF \"".concat(_this._url, "\"."));
      }
      _this._storedError = error;
      _this._headersCapability.reject(error);
    });
  }
  return node_stream_createClass(PDFNodeStreamFsFullReader, [{
    key: "headersReady",
    get: function get() {
      return this._headersCapability.promise;
    }
  }, {
    key: "filename",
    get: function get() {
      return this._filename;
    }
  }, {
    key: "contentLength",
    get: function get() {
      return this._contentLength;
    }
  }, {
    key: "isRangeSupported",
    get: function get() {
      return this._isRangeSupported;
    }
  }, {
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }, {
    key: "read",
    value: function () {
      var _read = node_stream_asyncToGenerator(/*#__PURE__*/node_stream_regeneratorRuntime().mark(function _callee() {
        var _this$onProgress;
        var chunk, buffer;
        return node_stream_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return this._readCapability.promise;
            case 2:
              if (!this._done) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", {
                value: undefined,
                done: true
              });
            case 4:
              if (!this._storedError) {
                _context.next = 6;
                break;
              }
              throw this._storedError;
            case 6:
              chunk = this._readableStream.read();
              if (!(chunk === null)) {
                _context.next = 10;
                break;
              }
              this._readCapability = Promise.withResolvers();
              return _context.abrupt("return", this.read());
            case 10:
              this._loaded += chunk.length;
              (_this$onProgress = this.onProgress) === null || _this$onProgress === void 0 || _this$onProgress.call(this, {
                loaded: this._loaded,
                total: this._contentLength
              });
              buffer = new Uint8Array(chunk).buffer;
              return _context.abrupt("return", {
                value: buffer,
                done: false
              });
            case 14:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function read() {
        return _read.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (!this._readableStream) {
        this._error(reason);
        return;
      }
      this._readableStream.destroy(reason);
    }
  }, {
    key: "_error",
    value: function _error(reason) {
      this._storedError = reason;
      this._readCapability.resolve();
    }
  }, {
    key: "_setReadableStream",
    value: function _setReadableStream(readableStream) {
      var _this2 = this;
      this._readableStream = readableStream;
      readableStream.on("readable", function () {
        _this2._readCapability.resolve();
      });
      readableStream.on("end", function () {
        readableStream.destroy();
        _this2._done = true;
        _this2._readCapability.resolve();
      });
      readableStream.on("error", function (reason) {
        _this2._error(reason);
      });
      if (!this._isStreamingSupported && this._isRangeSupported) {
        this._error(new AbortException("streaming is disabled"));
      }
      if (this._storedError) {
        this._readableStream.destroy(this._storedError);
      }
    }
  }]);
}();
var PDFNodeStreamFsRangeReader = /*#__PURE__*/function () {
  function PDFNodeStreamFsRangeReader(stream, start, end) {
    node_stream_classCallCheck(this, PDFNodeStreamFsRangeReader);
    this._url = stream.url;
    this._done = false;
    this._storedError = null;
    this.onProgress = null;
    this._loaded = 0;
    this._readableStream = null;
    this._readCapability = Promise.withResolvers();
    var source = stream.source;
    this._isStreamingSupported = !source.disableStream;
    var fs = process.getBuiltinModule("fs");
    this._setReadableStream(fs.createReadStream(this._url, {
      start: start,
      end: end - 1
    }));
  }
  return node_stream_createClass(PDFNodeStreamFsRangeReader, [{
    key: "isStreamingSupported",
    get: function get() {
      return this._isStreamingSupported;
    }
  }, {
    key: "read",
    value: function () {
      var _read2 = node_stream_asyncToGenerator(/*#__PURE__*/node_stream_regeneratorRuntime().mark(function _callee2() {
        var _this$onProgress2;
        var chunk, buffer;
        return node_stream_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return this._readCapability.promise;
            case 2:
              if (!this._done) {
                _context2.next = 4;
                break;
              }
              return _context2.abrupt("return", {
                value: undefined,
                done: true
              });
            case 4:
              if (!this._storedError) {
                _context2.next = 6;
                break;
              }
              throw this._storedError;
            case 6:
              chunk = this._readableStream.read();
              if (!(chunk === null)) {
                _context2.next = 10;
                break;
              }
              this._readCapability = Promise.withResolvers();
              return _context2.abrupt("return", this.read());
            case 10:
              this._loaded += chunk.length;
              (_this$onProgress2 = this.onProgress) === null || _this$onProgress2 === void 0 || _this$onProgress2.call(this, {
                loaded: this._loaded
              });
              buffer = new Uint8Array(chunk).buffer;
              return _context2.abrupt("return", {
                value: buffer,
                done: false
              });
            case 14:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function read() {
        return _read2.apply(this, arguments);
      }
      return read;
    }()
  }, {
    key: "cancel",
    value: function cancel(reason) {
      if (!this._readableStream) {
        this._error(reason);
        return;
      }
      this._readableStream.destroy(reason);
    }
  }, {
    key: "_error",
    value: function _error(reason) {
      this._storedError = reason;
      this._readCapability.resolve();
    }
  }, {
    key: "_setReadableStream",
    value: function _setReadableStream(readableStream) {
      var _this3 = this;
      this._readableStream = readableStream;
      readableStream.on("readable", function () {
        _this3._readCapability.resolve();
      });
      readableStream.on("end", function () {
        readableStream.destroy();
        _this3._done = true;
        _this3._readCapability.resolve();
      });
      readableStream.on("error", function (reason) {
        _this3._error(reason);
      });
      if (this._storedError) {
        this._readableStream.destroy(this._storedError);
      }
    }
  }]);
}();

;// ./src/display/text_layer.js











var _TextLayer;
function text_layer_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = text_layer_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function text_layer_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return text_layer_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? text_layer_arrayLikeToArray(r, a) : void 0; } }
function text_layer_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function text_layer_typeof(o) { "@babel/helpers - typeof"; return text_layer_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, text_layer_typeof(o); }


























function text_layer_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function text_layer_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, text_layer_toPropertyKey(o.key), o); } }
function text_layer_createClass(e, r, t) { return r && text_layer_defineProperties(e.prototype, r), t && text_layer_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function text_layer_toPropertyKey(t) { var i = text_layer_toPrimitive(t, "string"); return "symbol" == text_layer_typeof(i) ? i : i + ""; }
function text_layer_toPrimitive(t, r) { if ("object" != text_layer_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != text_layer_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function text_layer_classPrivateMethodInitSpec(e, a) { text_layer_checkPrivateRedeclaration(e, a), a.add(e); }
function text_layer_classPrivateFieldInitSpec(e, t, a) { text_layer_checkPrivateRedeclaration(e, t), t.set(e, a); }
function text_layer_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function text_layer_classPrivateFieldGet(s, a) { return s.get(text_layer_assertClassBrand(s, a)); }
function text_layer_classPrivateFieldSet(s, a, r) { return s.set(text_layer_assertClassBrand(s, a), r), r; }
function text_layer_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var MAX_TEXT_DIVS_TO_RENDER = 100000;
var DEFAULT_FONT_SIZE = 30;
var DEFAULT_FONT_ASCENT = 0.8;
var _capability = /*#__PURE__*/new WeakMap();
var text_layer_container = /*#__PURE__*/new WeakMap();
var _disableProcessItems = /*#__PURE__*/new WeakMap();
var _fontInspectorEnabled = /*#__PURE__*/new WeakMap();
var _lang = /*#__PURE__*/new WeakMap();
var _layoutTextParams = /*#__PURE__*/new WeakMap();
var _pageHeight = /*#__PURE__*/new WeakMap();
var _pageWidth = /*#__PURE__*/new WeakMap();
var _reader = /*#__PURE__*/new WeakMap();
var _rootContainer = /*#__PURE__*/new WeakMap();
var _rotation = /*#__PURE__*/new WeakMap();
var _scale = /*#__PURE__*/new WeakMap();
var _styleCache = /*#__PURE__*/new WeakMap();
var _textContentItemsStr = /*#__PURE__*/new WeakMap();
var _textContentSource = /*#__PURE__*/new WeakMap();
var _textDivs = /*#__PURE__*/new WeakMap();
var _textDivProperties = /*#__PURE__*/new WeakMap();
var _transform = /*#__PURE__*/new WeakMap();
var _TextLayer_brand = /*#__PURE__*/new WeakSet();
var TextLayer = /*#__PURE__*/function () {
  function TextLayer(_ref) {
    var _globalThis$FontInspe,
      _this = this;
    var textContentSource = _ref.textContentSource,
      container = _ref.container,
      viewport = _ref.viewport;
    text_layer_classCallCheck(this, TextLayer);
    text_layer_classPrivateMethodInitSpec(this, _TextLayer_brand);
    text_layer_classPrivateFieldInitSpec(this, _capability, Promise.withResolvers());
    text_layer_classPrivateFieldInitSpec(this, text_layer_container, null);
    text_layer_classPrivateFieldInitSpec(this, _disableProcessItems, false);
    text_layer_classPrivateFieldInitSpec(this, _fontInspectorEnabled, !!((_globalThis$FontInspe = globalThis.FontInspector) !== null && _globalThis$FontInspe !== void 0 && _globalThis$FontInspe.enabled));
    text_layer_classPrivateFieldInitSpec(this, _lang, null);
    text_layer_classPrivateFieldInitSpec(this, _layoutTextParams, null);
    text_layer_classPrivateFieldInitSpec(this, _pageHeight, 0);
    text_layer_classPrivateFieldInitSpec(this, _pageWidth, 0);
    text_layer_classPrivateFieldInitSpec(this, _reader, null);
    text_layer_classPrivateFieldInitSpec(this, _rootContainer, null);
    text_layer_classPrivateFieldInitSpec(this, _rotation, 0);
    text_layer_classPrivateFieldInitSpec(this, _scale, 0);
    text_layer_classPrivateFieldInitSpec(this, _styleCache, Object.create(null));
    text_layer_classPrivateFieldInitSpec(this, _textContentItemsStr, []);
    text_layer_classPrivateFieldInitSpec(this, _textContentSource, null);
    text_layer_classPrivateFieldInitSpec(this, _textDivs, []);
    text_layer_classPrivateFieldInitSpec(this, _textDivProperties, new WeakMap());
    text_layer_classPrivateFieldInitSpec(this, _transform, null);
    if (textContentSource instanceof ReadableStream) {
      text_layer_classPrivateFieldSet(_textContentSource, this, textContentSource);
    } else if (text_layer_typeof(textContentSource) === "object") {
      text_layer_classPrivateFieldSet(_textContentSource, this, new ReadableStream({
        start: function start(controller) {
          controller.enqueue(textContentSource);
          controller.close();
        }
      }));
    } else {
      throw new Error('No "textContentSource" parameter specified.');
    }
    text_layer_classPrivateFieldSet(text_layer_container, this, text_layer_classPrivateFieldSet(_rootContainer, this, container));
    text_layer_classPrivateFieldSet(_scale, this, viewport.scale * (globalThis.devicePixelRatio || 1));
    text_layer_classPrivateFieldSet(_rotation, this, viewport.rotation);
    text_layer_classPrivateFieldSet(_layoutTextParams, this, {
      div: null,
      properties: null,
      ctx: null
    });
    var _viewport$rawDims = viewport.rawDims,
      pageWidth = _viewport$rawDims.pageWidth,
      pageHeight = _viewport$rawDims.pageHeight,
      pageX = _viewport$rawDims.pageX,
      pageY = _viewport$rawDims.pageY;
    text_layer_classPrivateFieldSet(_transform, this, [1, 0, 0, -1, -pageX, pageY + pageHeight]);
    text_layer_classPrivateFieldSet(_pageWidth, this, pageWidth);
    text_layer_classPrivateFieldSet(_pageHeight, this, pageHeight);
    _ensureMinFontSizeComputed.call(TextLayer);
    setLayerDimensions(container, viewport);
    text_layer_classPrivateFieldGet(_capability, this).promise.finally(function () {
      _pendingTextLayers._.delete(_this);
      text_layer_classPrivateFieldSet(_layoutTextParams, _this, null);
      text_layer_classPrivateFieldSet(_styleCache, _this, null);
    }).catch(function () {});
  }
  return text_layer_createClass(TextLayer, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _pump = function pump() {
        text_layer_classPrivateFieldGet(_reader, _this2).read().then(function (_ref2) {
          var _classPrivateFieldGet2;
          var value = _ref2.value,
            done = _ref2.done;
          if (done) {
            text_layer_classPrivateFieldGet(_capability, _this2).resolve();
            return;
          }
          (_classPrivateFieldGet2 = text_layer_classPrivateFieldGet(_lang, _this2)) !== null && _classPrivateFieldGet2 !== void 0 ? _classPrivateFieldGet2 : text_layer_classPrivateFieldSet(_lang, _this2, value.lang);
          Object.assign(text_layer_classPrivateFieldGet(_styleCache, _this2), value.styles);
          text_layer_assertClassBrand(_TextLayer_brand, _this2, _processItems).call(_this2, value.items);
          _pump();
        }, text_layer_classPrivateFieldGet(_capability, _this2).reject);
      };
      text_layer_classPrivateFieldSet(_reader, this, text_layer_classPrivateFieldGet(_textContentSource, this).getReader());
      _pendingTextLayers._.add(this);
      _pump();
      return text_layer_classPrivateFieldGet(_capability, this).promise;
    }
  }, {
    key: "update",
    value: function update(_ref3) {
      var viewport = _ref3.viewport,
        _ref3$onBefore = _ref3.onBefore,
        onBefore = _ref3$onBefore === void 0 ? null : _ref3$onBefore;
      var scale = viewport.scale * (globalThis.devicePixelRatio || 1);
      var rotation = viewport.rotation;
      if (rotation !== text_layer_classPrivateFieldGet(_rotation, this)) {
        onBefore === null || onBefore === void 0 || onBefore();
        text_layer_classPrivateFieldSet(_rotation, this, rotation);
        setLayerDimensions(text_layer_classPrivateFieldGet(_rootContainer, this), {
          rotation: rotation
        });
      }
      if (scale !== text_layer_classPrivateFieldGet(_scale, this)) {
        onBefore === null || onBefore === void 0 || onBefore();
        text_layer_classPrivateFieldSet(_scale, this, scale);
        var params = {
          div: null,
          properties: null,
          ctx: _getCtx.call(TextLayer, text_layer_classPrivateFieldGet(_lang, this))
        };
        var _iterator = text_layer_createForOfIteratorHelper(text_layer_classPrivateFieldGet(_textDivs, this)),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var div = _step.value;
            params.properties = text_layer_classPrivateFieldGet(_textDivProperties, this).get(div);
            params.div = div;
            text_layer_assertClassBrand(_TextLayer_brand, this, _layout).call(this, params);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
    }
  }, {
    key: "cancel",
    value: function cancel() {
      var _classPrivateFieldGet3;
      var abortEx = new AbortException("TextLayer task cancelled.");
      (_classPrivateFieldGet3 = text_layer_classPrivateFieldGet(_reader, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.cancel(abortEx).catch(function () {});
      text_layer_classPrivateFieldSet(_reader, this, null);
      text_layer_classPrivateFieldGet(_capability, this).reject(abortEx);
    }
  }, {
    key: "textDivs",
    get: function get() {
      return text_layer_classPrivateFieldGet(_textDivs, this);
    }
  }, {
    key: "textContentItemsStr",
    get: function get() {
      return text_layer_classPrivateFieldGet(_textContentItemsStr, this);
    }
  }], [{
    key: "fontFamilyMap",
    get: function get() {
      var _FeatureTest$platform = util_FeatureTest.platform,
        isWindows = _FeatureTest$platform.isWindows,
        isFirefox = _FeatureTest$platform.isFirefox;
      return shadow(this, "fontFamilyMap", new Map([["sans-serif", "".concat(isWindows && isFirefox ? "Calibri, " : "", "sans-serif")], ["monospace", "".concat(isWindows && isFirefox ? "Lucida Console, " : "", "monospace")]]));
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      if (text_layer_assertClassBrand(TextLayer, this, _pendingTextLayers)._.size > 0) {
        return;
      }
      text_layer_assertClassBrand(TextLayer, this, _ascentCache)._.clear();
      var _iterator2 = text_layer_createForOfIteratorHelper(text_layer_assertClassBrand(TextLayer, this, _canvasContexts)._.values()),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var canvas = _step2.value.canvas;
          canvas.remove();
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      text_layer_assertClassBrand(TextLayer, this, _canvasContexts)._.clear();
    }
  }]);
}();
_TextLayer = TextLayer;
function _processItems(items) {
  var _classPrivateFieldGet4, _classPrivateFieldGet5;
  if (text_layer_classPrivateFieldGet(_disableProcessItems, this)) {
    return;
  }
  (_classPrivateFieldGet5 = (_classPrivateFieldGet4 = text_layer_classPrivateFieldGet(_layoutTextParams, this)).ctx) !== null && _classPrivateFieldGet5 !== void 0 ? _classPrivateFieldGet5 : _classPrivateFieldGet4.ctx = _getCtx.call(_TextLayer, text_layer_classPrivateFieldGet(_lang, this));
  var textDivs = text_layer_classPrivateFieldGet(_textDivs, this),
    textContentItemsStr = text_layer_classPrivateFieldGet(_textContentItemsStr, this);
  var _iterator3 = text_layer_createForOfIteratorHelper(items),
    _step3;
  try {
    for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
      var item = _step3.value;
      if (textDivs.length > MAX_TEXT_DIVS_TO_RENDER) {
        warn("Ignoring additional textDivs for performance reasons.");
        text_layer_classPrivateFieldSet(_disableProcessItems, this, true);
        return;
      }
      if (item.str === undefined) {
        if (item.type === "beginMarkedContentProps" || item.type === "beginMarkedContent") {
          var parent = text_layer_classPrivateFieldGet(text_layer_container, this);
          text_layer_classPrivateFieldSet(text_layer_container, this, document.createElement("span"));
          text_layer_classPrivateFieldGet(text_layer_container, this).classList.add("markedContent");
          if (item.id !== null) {
            text_layer_classPrivateFieldGet(text_layer_container, this).setAttribute("id", "".concat(item.id));
          }
          parent.append(text_layer_classPrivateFieldGet(text_layer_container, this));
        } else if (item.type === "endMarkedContent") {
          text_layer_classPrivateFieldSet(text_layer_container, this, text_layer_classPrivateFieldGet(text_layer_container, this).parentNode);
        }
        continue;
      }
      textContentItemsStr.push(item.str);
      text_layer_assertClassBrand(_TextLayer_brand, this, _appendText).call(this, item);
    }
  } catch (err) {
    _iterator3.e(err);
  } finally {
    _iterator3.f();
  }
}
function _appendText(geom) {
  var textDiv = document.createElement("span");
  var textDivProperties = {
    angle: 0,
    canvasWidth: 0,
    hasText: geom.str !== "",
    hasEOL: geom.hasEOL,
    fontSize: 0
  };
  text_layer_classPrivateFieldGet(_textDivs, this).push(textDiv);
  var tx = Util.transform(text_layer_classPrivateFieldGet(_transform, this), geom.transform);
  var angle = Math.atan2(tx[1], tx[0]);
  var style = text_layer_classPrivateFieldGet(_styleCache, this)[geom.fontName];
  if (style.vertical) {
    angle += Math.PI / 2;
  }
  var fontFamily = text_layer_classPrivateFieldGet(_fontInspectorEnabled, this) && style.fontSubstitution || style.fontFamily;
  fontFamily = _TextLayer.fontFamilyMap.get(fontFamily) || fontFamily;
  var fontHeight = Math.hypot(tx[2], tx[3]);
  var fontAscent = fontHeight * _getAscent.call(_TextLayer, fontFamily, text_layer_classPrivateFieldGet(_lang, this));
  var left, top;
  if (angle === 0) {
    left = tx[4];
    top = tx[5] - fontAscent;
  } else {
    left = tx[4] + fontAscent * Math.sin(angle);
    top = tx[5] - fontAscent * Math.cos(angle);
  }
  var scaleFactorStr = "calc(var(--scale-factor)*";
  var divStyle = textDiv.style;
  if (text_layer_classPrivateFieldGet(text_layer_container, this) === text_layer_classPrivateFieldGet(_rootContainer, this)) {
    divStyle.left = "".concat((100 * left / text_layer_classPrivateFieldGet(_pageWidth, this)).toFixed(2), "%");
    divStyle.top = "".concat((100 * top / text_layer_classPrivateFieldGet(_pageHeight, this)).toFixed(2), "%");
  } else {
    divStyle.left = "".concat(scaleFactorStr).concat(left.toFixed(2), "px)");
    divStyle.top = "".concat(scaleFactorStr).concat(top.toFixed(2), "px)");
  }
  divStyle.fontSize = "".concat(scaleFactorStr).concat((_minFontSize._ * fontHeight).toFixed(2), "px)");
  divStyle.fontFamily = fontFamily;
  textDivProperties.fontSize = fontHeight;
  textDiv.setAttribute("role", "presentation");
  textDiv.textContent = geom.str;
  textDiv.dir = geom.dir;
  if (text_layer_classPrivateFieldGet(_fontInspectorEnabled, this)) {
    textDiv.dataset.fontName = style.fontSubstitutionLoadedName || geom.fontName;
  }
  if (angle !== 0) {
    textDivProperties.angle = angle * (180 / Math.PI);
  }
  var shouldScaleText = false;
  if (geom.str.length > 1) {
    shouldScaleText = true;
  } else if (geom.str !== " " && geom.transform[0] !== geom.transform[3]) {
    var absScaleX = Math.abs(geom.transform[0]),
      absScaleY = Math.abs(geom.transform[3]);
    if (absScaleX !== absScaleY && Math.max(absScaleX, absScaleY) / Math.min(absScaleX, absScaleY) > 1.5) {
      shouldScaleText = true;
    }
  }
  if (shouldScaleText) {
    textDivProperties.canvasWidth = style.vertical ? geom.height : geom.width;
  }
  text_layer_classPrivateFieldGet(_textDivProperties, this).set(textDiv, textDivProperties);
  text_layer_classPrivateFieldGet(_layoutTextParams, this).div = textDiv;
  text_layer_classPrivateFieldGet(_layoutTextParams, this).properties = textDivProperties;
  text_layer_assertClassBrand(_TextLayer_brand, this, _layout).call(this, text_layer_classPrivateFieldGet(_layoutTextParams, this));
  if (textDivProperties.hasText) {
    text_layer_classPrivateFieldGet(text_layer_container, this).append(textDiv);
  }
  if (textDivProperties.hasEOL) {
    var br = document.createElement("br");
    br.setAttribute("role", "presentation");
    text_layer_classPrivateFieldGet(text_layer_container, this).append(br);
  }
}
function _layout(params) {
  var div = params.div,
    properties = params.properties,
    ctx = params.ctx;
  var style = div.style;
  var transform = "";
  if (_minFontSize._ > 1) {
    transform = "scale(".concat(1 / _minFontSize._, ")");
  }
  if (properties.canvasWidth !== 0 && properties.hasText) {
    var fontFamily = style.fontFamily;
    var canvasWidth = properties.canvasWidth,
      fontSize = properties.fontSize;
    _ensureCtxFont.call(_TextLayer, ctx, fontSize * text_layer_classPrivateFieldGet(_scale, this), fontFamily);
    var _ctx$measureText = ctx.measureText(div.textContent),
      width = _ctx$measureText.width;
    if (width > 0) {
      transform = "scaleX(".concat(canvasWidth * text_layer_classPrivateFieldGet(_scale, this) / width, ") ").concat(transform);
    }
  }
  if (properties.angle !== 0) {
    transform = "rotate(".concat(properties.angle, "deg) ").concat(transform);
  }
  if (transform.length > 0) {
    style.transform = transform;
  }
}
function _getCtx() {
  var lang = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var ctx = text_layer_assertClassBrand(_TextLayer, this, _canvasContexts)._.get(lang || (lang = ""));
  if (!ctx) {
    var canvas = document.createElement("canvas");
    canvas.className = "hiddenCanvasElement";
    canvas.lang = lang;
    document.body.append(canvas);
    ctx = canvas.getContext("2d", {
      alpha: false,
      willReadFrequently: true
    });
    text_layer_assertClassBrand(_TextLayer, this, _canvasContexts)._.set(lang, ctx);
    text_layer_assertClassBrand(_TextLayer, this, _canvasCtxFonts)._.set(ctx, {
      size: 0,
      family: ""
    });
  }
  return ctx;
}
function _ensureCtxFont(ctx, size, family) {
  var cached = text_layer_assertClassBrand(_TextLayer, this, _canvasCtxFonts)._.get(ctx);
  if (size === cached.size && family === cached.family) {
    return;
  }
  ctx.font = "".concat(size, "px ").concat(family);
  cached.size = size;
  cached.family = family;
}
function _ensureMinFontSizeComputed() {
  if (text_layer_assertClassBrand(_TextLayer, this, _minFontSize)._ !== null) {
    return;
  }
  var div = document.createElement("div");
  div.style.opacity = 0;
  div.style.lineHeight = 1;
  div.style.fontSize = "1px";
  div.style.position = "absolute";
  div.textContent = "X";
  document.body.append(div);
  _minFontSize._ = text_layer_assertClassBrand(_TextLayer, this, div.getBoundingClientRect().height);
  div.remove();
}
function _getAscent(fontFamily, lang) {
  var cachedAscent = text_layer_assertClassBrand(_TextLayer, this, _ascentCache)._.get(fontFamily);
  if (cachedAscent) {
    return cachedAscent;
  }
  var ctx = text_layer_assertClassBrand(_TextLayer, this, _getCtx).call(this, lang);
  ctx.canvas.width = ctx.canvas.height = DEFAULT_FONT_SIZE;
  text_layer_assertClassBrand(_TextLayer, this, _ensureCtxFont).call(this, ctx, DEFAULT_FONT_SIZE, fontFamily);
  var metrics = ctx.measureText("");
  var ascent = metrics.fontBoundingBoxAscent;
  var descent = Math.abs(metrics.fontBoundingBoxDescent);
  if (ascent) {
    var _ratio = ascent / (ascent + descent);
    text_layer_assertClassBrand(_TextLayer, this, _ascentCache)._.set(fontFamily, _ratio);
    ctx.canvas.width = ctx.canvas.height = 0;
    return _ratio;
  }
  ctx.strokeStyle = "red";
  ctx.clearRect(0, 0, DEFAULT_FONT_SIZE, DEFAULT_FONT_SIZE);
  ctx.strokeText("g", 0, 0);
  var pixels = ctx.getImageData(0, 0, DEFAULT_FONT_SIZE, DEFAULT_FONT_SIZE).data;
  descent = 0;
  for (var i = pixels.length - 1 - 3; i >= 0; i -= 4) {
    if (pixels[i] > 0) {
      descent = Math.ceil(i / 4 / DEFAULT_FONT_SIZE);
      break;
    }
  }
  ctx.clearRect(0, 0, DEFAULT_FONT_SIZE, DEFAULT_FONT_SIZE);
  ctx.strokeText("A", 0, DEFAULT_FONT_SIZE);
  pixels = ctx.getImageData(0, 0, DEFAULT_FONT_SIZE, DEFAULT_FONT_SIZE).data;
  ascent = 0;
  for (var _i = 0, ii = pixels.length; _i < ii; _i += 4) {
    if (pixels[_i] > 0) {
      ascent = DEFAULT_FONT_SIZE - Math.floor(_i / 4 / DEFAULT_FONT_SIZE);
      break;
    }
  }
  ctx.canvas.width = ctx.canvas.height = 0;
  var ratio = ascent ? ascent / (ascent + descent) : DEFAULT_FONT_ASCENT;
  text_layer_assertClassBrand(_TextLayer, this, _ascentCache)._.set(fontFamily, ratio);
  return ratio;
}
var _ascentCache = {
  _: new Map()
};
var _canvasContexts = {
  _: new Map()
};
var _canvasCtxFonts = {
  _: new WeakMap()
};
var _minFontSize = {
  _: null
};
var _pendingTextLayers = {
  _: new Set()
};

;// ./src/display/xfa_text.js
function xfa_text_typeof(o) { "@babel/helpers - typeof"; return xfa_text_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, xfa_text_typeof(o); }
function xfa_text_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = xfa_text_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function xfa_text_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return xfa_text_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? xfa_text_arrayLikeToArray(r, a) : void 0; } }
function xfa_text_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }


















function xfa_text_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function xfa_text_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, xfa_text_toPropertyKey(o.key), o); } }
function xfa_text_createClass(e, r, t) { return r && xfa_text_defineProperties(e.prototype, r), t && xfa_text_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function xfa_text_toPropertyKey(t) { var i = xfa_text_toPrimitive(t, "string"); return "symbol" == xfa_text_typeof(i) ? i : i + ""; }
function xfa_text_toPrimitive(t, r) { if ("object" != xfa_text_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != xfa_text_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var XfaText = /*#__PURE__*/function () {
  function XfaText() {
    xfa_text_classCallCheck(this, XfaText);
  }
  return xfa_text_createClass(XfaText, null, [{
    key: "textContent",
    value: function textContent(xfa) {
      var items = [];
      var output = {
        items: items,
        styles: Object.create(null)
      };
      function walk(node) {
        var _node$attributes;
        if (!node) {
          return;
        }
        var str = null;
        var name = node.name;
        if (name === "#text") {
          str = node.value;
        } else if (!XfaText.shouldBuildText(name)) {
          return;
        } else if (node !== null && node !== void 0 && (_node$attributes = node.attributes) !== null && _node$attributes !== void 0 && _node$attributes.textContent) {
          str = node.attributes.textContent;
        } else if (node.value) {
          str = node.value;
        }
        if (str !== null) {
          items.push({
            str: str
          });
        }
        if (!node.children) {
          return;
        }
        var _iterator = xfa_text_createForOfIteratorHelper(node.children),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var child = _step.value;
            walk(child);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }
      walk(xfa);
      return output;
    }
  }, {
    key: "shouldBuildText",
    value: function shouldBuildText(name) {
      return !(name === "textarea" || name === "input" || name === "option" || name === "select");
    }
  }]);
}();

;// ./src/display/api.js
var _PDFWorker;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { api_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function api_defineProperty(e, r, t) { return (r = api_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function api_classPrivateGetter(s, r, a) { return a(api_assertClassBrand(s, r)); }
function api_toConsumableArray(r) { return api_arrayWithoutHoles(r) || api_iterableToArray(r) || api_unsupportedIterableToArray(r) || api_nonIterableSpread(); }
function api_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function api_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function api_arrayWithoutHoles(r) { if (Array.isArray(r)) return api_arrayLikeToArray(r); }
function api_slicedToArray(r, e) { return api_arrayWithHoles(r) || api_iterableToArrayLimit(r, e) || api_unsupportedIterableToArray(r, e) || api_nonIterableRest(); }
function api_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function api_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function api_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function api_classPrivateMethodInitSpec(e, a) { api_checkPrivateRedeclaration(e, a), a.add(e); }
function api_classPrivateFieldInitSpec(e, t, a) { api_checkPrivateRedeclaration(e, t), t.set(e, a); }
function api_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function api_classPrivateFieldGet(s, a) { return s.get(api_assertClassBrand(s, a)); }
function api_classPrivateFieldSet(s, a, r) { return s.set(api_assertClassBrand(s, a), r), r; }
function api_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function api_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = api_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function api_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return api_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? api_arrayLikeToArray(r, a) : void 0; } }
function api_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function api_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ api_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == api_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(api_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function api_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function api_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { api_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { api_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function api_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function api_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, api_toPropertyKey(o.key), o); } }
function api_createClass(e, r, t) { return r && api_defineProperties(e.prototype, r), t && api_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function api_toPropertyKey(t) { var i = api_toPrimitive(t, "string"); return "symbol" == api_typeof(i) ? i : i + ""; }
function api_toPrimitive(t, r) { if ("object" != api_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != api_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function api_typeof(o) { "@babel/helpers - typeof"; return api_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, api_typeof(o); }

























































































































var DEFAULT_RANGE_CHUNK_SIZE = 65536;
var RENDERING_CANCELLED_TIMEOUT = 100;
var DELAYED_CLEANUP_TIMEOUT = 5000;
var DefaultCanvasFactory = isNodeJS ? NodeCanvasFactory : DOMCanvasFactory;
var DefaultCMapReaderFactory = isNodeJS ? NodeCMapReaderFactory : DOMCMapReaderFactory;
var DefaultFilterFactory = isNodeJS ? NodeFilterFactory : DOMFilterFactory;
var DefaultStandardFontDataFactory = isNodeJS ? NodeStandardFontDataFactory : DOMStandardFontDataFactory;
function getDocument() {
  var _src$password, _src$length;
  var src = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (typeof src === "string" || src instanceof URL) {
    src = {
      url: src
    };
  } else if (src instanceof ArrayBuffer || ArrayBuffer.isView(src)) {
    src = {
      data: src
    };
  }
  var task = new PDFDocumentLoadingTask();
  var docId = task.docId;
  var url = src.url ? getUrlProp(src.url) : null;
  var data = src.data ? getDataProp(src.data) : null;
  var httpHeaders = src.httpHeaders || null;
  var withCredentials = src.withCredentials === true;
  var password = (_src$password = src.password) !== null && _src$password !== void 0 ? _src$password : null;
  var rangeTransport = src.range instanceof PDFDataRangeTransport ? src.range : null;
  var rangeChunkSize = Number.isInteger(src.rangeChunkSize) && src.rangeChunkSize > 0 ? src.rangeChunkSize : DEFAULT_RANGE_CHUNK_SIZE;
  var worker = src.worker instanceof PDFWorker ? src.worker : null;
  var verbosity = src.verbosity;
  var docBaseUrl = typeof src.docBaseUrl === "string" && !isDataScheme(src.docBaseUrl) ? src.docBaseUrl : null;
  var cMapUrl = typeof src.cMapUrl === "string" ? src.cMapUrl : null;
  var cMapPacked = src.cMapPacked !== false;
  var CMapReaderFactory = src.CMapReaderFactory || DefaultCMapReaderFactory;
  var standardFontDataUrl = typeof src.standardFontDataUrl === "string" ? src.standardFontDataUrl : null;
  var StandardFontDataFactory = src.StandardFontDataFactory || DefaultStandardFontDataFactory;
  var ignoreErrors = src.stopAtErrors !== true;
  var maxImageSize = Number.isInteger(src.maxImageSize) && src.maxImageSize > -1 ? src.maxImageSize : -1;
  var isEvalSupported = src.isEvalSupported !== false;
  var isOffscreenCanvasSupported = typeof src.isOffscreenCanvasSupported === "boolean" ? src.isOffscreenCanvasSupported : !isNodeJS;
  var isImageDecoderSupported = typeof src.isImageDecoderSupported === "boolean" ? src.isImageDecoderSupported : !isNodeJS && (util_FeatureTest.platform.isFirefox || !globalThis.chrome);
  var canvasMaxAreaInBytes = Number.isInteger(src.canvasMaxAreaInBytes) ? src.canvasMaxAreaInBytes : -1;
  var disableFontFace = typeof src.disableFontFace === "boolean" ? src.disableFontFace : isNodeJS;
  var fontExtraProperties = src.fontExtraProperties === true;
  var enableXfa = src.enableXfa === true;
  var ownerDocument = src.ownerDocument || globalThis.document;
  var disableRange = src.disableRange === true;
  var disableStream = src.disableStream === true;
  var disableAutoFetch = src.disableAutoFetch === true;
  var pdfBug = src.pdfBug === true;
  var CanvasFactory = src.CanvasFactory || DefaultCanvasFactory;
  var FilterFactory = src.FilterFactory || DefaultFilterFactory;
  var enableHWA = src.enableHWA === true;
  var length = rangeTransport ? rangeTransport.length : (_src$length = src.length) !== null && _src$length !== void 0 ? _src$length : NaN;
  var useSystemFonts = typeof src.useSystemFonts === "boolean" ? src.useSystemFonts : !isNodeJS && !disableFontFace;
  var useWorkerFetch = typeof src.useWorkerFetch === "boolean" ? src.useWorkerFetch : CMapReaderFactory === DOMCMapReaderFactory && StandardFontDataFactory === DOMStandardFontDataFactory && cMapUrl && standardFontDataUrl && isValidFetchUrl(cMapUrl, document.baseURI) && isValidFetchUrl(standardFontDataUrl, document.baseURI);
  var styleElement = null;
  setVerbosityLevel(verbosity);
  var transportFactory = {
    canvasFactory: new CanvasFactory({
      ownerDocument: ownerDocument,
      enableHWA: enableHWA
    }),
    filterFactory: new FilterFactory({
      docId: docId,
      ownerDocument: ownerDocument
    }),
    cMapReaderFactory: useWorkerFetch ? null : new CMapReaderFactory({
      baseUrl: cMapUrl,
      isCompressed: cMapPacked
    }),
    standardFontDataFactory: useWorkerFetch ? null : new StandardFontDataFactory({
      baseUrl: standardFontDataUrl
    })
  };
  if (!worker) {
    var workerParams = {
      verbosity: verbosity,
      port: GlobalWorkerOptions.workerPort
    };
    worker = workerParams.port ? PDFWorker.fromPort(workerParams) : new PDFWorker(workerParams);
    task._worker = worker;
  }
  var docParams = {
    docId: docId,
    apiVersion: "4.10.8",
    data: data,
    password: password,
    disableAutoFetch: disableAutoFetch,
    rangeChunkSize: rangeChunkSize,
    length: length,
    docBaseUrl: docBaseUrl,
    enableXfa: enableXfa,
    evaluatorOptions: {
      maxImageSize: maxImageSize,
      disableFontFace: disableFontFace,
      ignoreErrors: ignoreErrors,
      isEvalSupported: isEvalSupported,
      isOffscreenCanvasSupported: isOffscreenCanvasSupported,
      isImageDecoderSupported: isImageDecoderSupported,
      canvasMaxAreaInBytes: canvasMaxAreaInBytes,
      fontExtraProperties: fontExtraProperties,
      useSystemFonts: useSystemFonts,
      cMapUrl: useWorkerFetch ? cMapUrl : null,
      standardFontDataUrl: useWorkerFetch ? standardFontDataUrl : null
    }
  };
  var transportParams = {
    disableFontFace: disableFontFace,
    fontExtraProperties: fontExtraProperties,
    ownerDocument: ownerDocument,
    pdfBug: pdfBug,
    styleElement: styleElement,
    loadingParams: {
      disableAutoFetch: disableAutoFetch,
      enableXfa: enableXfa
    }
  };
  worker.promise.then(function () {
    if (task.destroyed) {
      throw new Error("Loading aborted");
    }
    if (worker.destroyed) {
      throw new Error("Worker was destroyed");
    }
    var workerIdPromise = worker.messageHandler.sendWithPromise("GetDocRequest", docParams, data ? [data.buffer] : null);
    var networkStream;
    if (rangeTransport) {
      networkStream = new PDFDataTransportStream(rangeTransport, {
        disableRange: disableRange,
        disableStream: disableStream
      });
    } else if (!data) {
      if (!url) {
        throw new Error("getDocument - no `url` parameter provided.");
      }
      var NetworkStream;
      if (isNodeJS) {
        if (isValidFetchUrl(url)) {
          if (typeof fetch === "undefined" || typeof Response === "undefined" || !("body" in Response.prototype)) {
            throw new Error("getDocument - the Fetch API was disabled in Node.js, see `--no-experimental-fetch`.");
          }
          NetworkStream = PDFFetchStream;
        } else {
          NetworkStream = PDFNodeStream;
        }
      } else {
        NetworkStream = isValidFetchUrl(url) ? PDFFetchStream : PDFNetworkStream;
      }
      networkStream = new NetworkStream({
        url: url,
        length: length,
        httpHeaders: httpHeaders,
        withCredentials: withCredentials,
        rangeChunkSize: rangeChunkSize,
        disableRange: disableRange,
        disableStream: disableStream
      });
    }
    return workerIdPromise.then(function (workerId) {
      if (task.destroyed) {
        throw new Error("Loading aborted");
      }
      if (worker.destroyed) {
        throw new Error("Worker was destroyed");
      }
      var messageHandler = new MessageHandler(docId, workerId, worker.port);
      var transport = new WorkerTransport(messageHandler, task, networkStream, transportParams, transportFactory);
      task._transport = transport;
      messageHandler.send("Ready", null);
    });
  }).catch(task._capability.reject);
  return task;
}
function getUrlProp(val) {
  if (val instanceof URL) {
    return val.href;
  }
  try {
    return new URL(val, window.location).href;
  } catch (_unused) {
    if (isNodeJS && typeof val === "string") {
      return val;
    }
  }
  throw new Error("Invalid PDF url data: " + "either string or URL-object is expected in the url property.");
}
function getDataProp(val) {
  if (isNodeJS && typeof Buffer !== "undefined" && val instanceof Buffer) {
    throw new Error("Please provide binary data as `Uint8Array`, rather than `Buffer`.");
  }
  if (val instanceof Uint8Array && val.byteLength === val.buffer.byteLength) {
    return val;
  }
  if (typeof val === "string") {
    return stringToBytes(val);
  }
  if (val instanceof ArrayBuffer || ArrayBuffer.isView(val) || api_typeof(val) === "object" && !isNaN(val === null || val === void 0 ? void 0 : val.length)) {
    return new Uint8Array(val);
  }
  throw new Error("Invalid PDF binary data: either TypedArray, " + "string, or array-like object is expected in the data property.");
}
function isRefProxy(ref) {
  return api_typeof(ref) === "object" && Number.isInteger(ref === null || ref === void 0 ? void 0 : ref.num) && ref.num >= 0 && Number.isInteger(ref === null || ref === void 0 ? void 0 : ref.gen) && ref.gen >= 0;
}
var PDFDocumentLoadingTask = /*#__PURE__*/function () {
  function PDFDocumentLoadingTask() {
    var _PDFDocumentLoadingTa, _PDFDocumentLoadingTa2;
    api_classCallCheck(this, PDFDocumentLoadingTask);
    this._capability = Promise.withResolvers();
    this._transport = null;
    this._worker = null;
    this.docId = "d".concat((api_docId._ = (_PDFDocumentLoadingTa = api_docId._, _PDFDocumentLoadingTa2 = _PDFDocumentLoadingTa++, _PDFDocumentLoadingTa), _PDFDocumentLoadingTa2));
    this.destroyed = false;
    this.onPassword = null;
    this.onProgress = null;
  }
  return api_createClass(PDFDocumentLoadingTask, [{
    key: "promise",
    get: function get() {
      return this._capability.promise;
    }
  }, {
    key: "destroy",
    value: function () {
      var _destroy = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee() {
        var _this$_worker3;
        var _this$_worker, _this$_transport2, _this$_worker2;
        return api_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              this.destroyed = true;
              _context.prev = 1;
              if ((_this$_worker = this._worker) !== null && _this$_worker !== void 0 && _this$_worker.port) {
                this._worker._pendingDestroy = true;
              }
              _context.next = 5;
              return (_this$_transport2 = this._transport) === null || _this$_transport2 === void 0 ? void 0 : _this$_transport2.destroy();
            case 5:
              _context.next = 11;
              break;
            case 7:
              _context.prev = 7;
              _context.t0 = _context["catch"](1);
              if ((_this$_worker2 = this._worker) !== null && _this$_worker2 !== void 0 && _this$_worker2.port) {
                delete this._worker._pendingDestroy;
              }
              throw _context.t0;
            case 11:
              this._transport = null;
              (_this$_worker3 = this._worker) === null || _this$_worker3 === void 0 || _this$_worker3.destroy();
              this._worker = null;
            case 14:
            case "end":
              return _context.stop();
          }
        }, _callee, this, [[1, 7]]);
      }));
      function destroy() {
        return _destroy.apply(this, arguments);
      }
      return destroy;
    }()
  }]);
}();
var api_docId = {
  _: 0
};
var PDFDataRangeTransport = /*#__PURE__*/function () {
  function PDFDataRangeTransport(length, initialData) {
    var progressiveDone = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var contentDispositionFilename = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    api_classCallCheck(this, PDFDataRangeTransport);
    this.length = length;
    this.initialData = initialData;
    this.progressiveDone = progressiveDone;
    this.contentDispositionFilename = contentDispositionFilename;
    this._rangeListeners = [];
    this._progressListeners = [];
    this._progressiveReadListeners = [];
    this._progressiveDoneListeners = [];
    this._readyCapability = Promise.withResolvers();
  }
  return api_createClass(PDFDataRangeTransport, [{
    key: "addRangeListener",
    value: function addRangeListener(listener) {
      this._rangeListeners.push(listener);
    }
  }, {
    key: "addProgressListener",
    value: function addProgressListener(listener) {
      this._progressListeners.push(listener);
    }
  }, {
    key: "addProgressiveReadListener",
    value: function addProgressiveReadListener(listener) {
      this._progressiveReadListeners.push(listener);
    }
  }, {
    key: "addProgressiveDoneListener",
    value: function addProgressiveDoneListener(listener) {
      this._progressiveDoneListeners.push(listener);
    }
  }, {
    key: "onDataRange",
    value: function onDataRange(begin, chunk) {
      var _iterator = api_createForOfIteratorHelper(this._rangeListeners),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var listener = _step.value;
          listener(begin, chunk);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "onDataProgress",
    value: function onDataProgress(loaded, total) {
      var _this = this;
      this._readyCapability.promise.then(function () {
        var _iterator2 = api_createForOfIteratorHelper(_this._progressListeners),
          _step2;
        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var listener = _step2.value;
            listener(loaded, total);
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      });
    }
  }, {
    key: "onDataProgressiveRead",
    value: function onDataProgressiveRead(chunk) {
      var _this2 = this;
      this._readyCapability.promise.then(function () {
        var _iterator3 = api_createForOfIteratorHelper(_this2._progressiveReadListeners),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var listener = _step3.value;
            listener(chunk);
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      });
    }
  }, {
    key: "onDataProgressiveDone",
    value: function onDataProgressiveDone() {
      var _this3 = this;
      this._readyCapability.promise.then(function () {
        var _iterator4 = api_createForOfIteratorHelper(_this3._progressiveDoneListeners),
          _step4;
        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var listener = _step4.value;
            listener();
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      });
    }
  }, {
    key: "transportReady",
    value: function transportReady() {
      this._readyCapability.resolve();
    }
  }, {
    key: "requestDataRange",
    value: function requestDataRange(begin, end) {
      unreachable("Abstract method PDFDataRangeTransport.requestDataRange");
    }
  }, {
    key: "abort",
    value: function abort() {}
  }]);
}();
var PDFDocumentProxy = /*#__PURE__*/function () {
  function PDFDocumentProxy(pdfInfo, transport) {
    var _this4 = this;
    api_classCallCheck(this, PDFDocumentProxy);
    this._pdfInfo = pdfInfo;
    this._transport = transport;
  }
  return api_createClass(PDFDocumentProxy, [{
    key: "annotationStorage",
    get: function get() {
      return this._transport.annotationStorage;
    }
  }, {
    key: "canvasFactory",
    get: function get() {
      return this._transport.canvasFactory;
    }
  }, {
    key: "filterFactory",
    get: function get() {
      return this._transport.filterFactory;
    }
  }, {
    key: "numPages",
    get: function get() {
      return this._pdfInfo.numPages;
    }
  }, {
    key: "fingerprints",
    get: function get() {
      return this._pdfInfo.fingerprints;
    }
  }, {
    key: "isPureXfa",
    get: function get() {
      return shadow(this, "isPureXfa", !!this._transport._htmlForXfa);
    }
  }, {
    key: "allXfaHtml",
    get: function get() {
      return this._transport._htmlForXfa;
    }
  }, {
    key: "getPage",
    value: function getPage(pageNumber) {
      return this._transport.getPage(pageNumber);
    }
  }, {
    key: "getPageIndex",
    value: function getPageIndex(ref) {
      return this._transport.getPageIndex(ref);
    }
  }, {
    key: "getDestinations",
    value: function getDestinations() {
      return this._transport.getDestinations();
    }
  }, {
    key: "getDestination",
    value: function getDestination(id) {
      return this._transport.getDestination(id);
    }
  }, {
    key: "getPageLabels",
    value: function getPageLabels() {
      return this._transport.getPageLabels();
    }
  }, {
    key: "getPageLayout",
    value: function getPageLayout() {
      return this._transport.getPageLayout();
    }
  }, {
    key: "getPageMode",
    value: function getPageMode() {
      return this._transport.getPageMode();
    }
  }, {
    key: "getViewerPreferences",
    value: function getViewerPreferences() {
      return this._transport.getViewerPreferences();
    }
  }, {
    key: "getOpenAction",
    value: function getOpenAction() {
      return this._transport.getOpenAction();
    }
  }, {
    key: "getAttachments",
    value: function getAttachments() {
      return this._transport.getAttachments();
    }
  }, {
    key: "getJSActions",
    value: function getJSActions() {
      return this._transport.getDocJSActions();
    }
  }, {
    key: "getOutline",
    value: function getOutline() {
      return this._transport.getOutline();
    }
  }, {
    key: "getOptionalContentConfig",
    value: function getOptionalContentConfig() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$intent = _ref.intent,
        intent = _ref$intent === void 0 ? "display" : _ref$intent;
      var _this$_transport$getR = this._transport.getRenderingIntent(intent),
        renderingIntent = _this$_transport$getR.renderingIntent;
      return this._transport.getOptionalContentConfig(renderingIntent);
    }
  }, {
    key: "getPermissions",
    value: function getPermissions() {
      return this._transport.getPermissions();
    }
  }, {
    key: "getMetadata",
    value: function getMetadata() {
      return this._transport.getMetadata();
    }
  }, {
    key: "getMarkInfo",
    value: function getMarkInfo() {
      return this._transport.getMarkInfo();
    }
  }, {
    key: "getData",
    value: function getData() {
      return this._transport.getData();
    }
  }, {
    key: "saveDocument",
    value: function saveDocument() {
      return this._transport.saveDocument();
    }
  }, {
    key: "getDownloadInfo",
    value: function getDownloadInfo() {
      return this._transport.downloadInfoCapability.promise;
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      var keepLoadedFonts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      return this._transport.startCleanup(keepLoadedFonts || this.isPureXfa);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      return this.loadingTask.destroy();
    }
  }, {
    key: "cachedPageNumber",
    value: function cachedPageNumber(ref) {
      return this._transport.cachedPageNumber(ref);
    }
  }, {
    key: "loadingParams",
    get: function get() {
      return this._transport.loadingParams;
    }
  }, {
    key: "loadingTask",
    get: function get() {
      return this._transport.loadingTask;
    }
  }, {
    key: "getFieldObjects",
    value: function getFieldObjects() {
      return this._transport.getFieldObjects();
    }
  }, {
    key: "hasJSActions",
    value: function hasJSActions() {
      return this._transport.hasJSActions();
    }
  }, {
    key: "getCalculationOrderIds",
    value: function getCalculationOrderIds() {
      return this._transport.getCalculationOrderIds();
    }
  }]);
}();
var _delayedCleanupTimeout = /*#__PURE__*/new WeakMap();
var _pendingCleanup = /*#__PURE__*/new WeakMap();
var _PDFPageProxy_brand = /*#__PURE__*/new WeakSet();
var PDFPageProxy = /*#__PURE__*/function () {
  function PDFPageProxy(pageIndex, pageInfo, transport) {
    var pdfBug = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    api_classCallCheck(this, PDFPageProxy);
    api_classPrivateMethodInitSpec(this, _PDFPageProxy_brand);
    api_classPrivateFieldInitSpec(this, _delayedCleanupTimeout, null);
    api_classPrivateFieldInitSpec(this, _pendingCleanup, false);
    this._pageIndex = pageIndex;
    this._pageInfo = pageInfo;
    this._transport = transport;
    this._stats = pdfBug ? new StatTimer() : null;
    this._pdfBug = pdfBug;
    this.commonObjs = transport.commonObjs;
    this.objs = new PDFObjects();
    this._maybeCleanupAfterRender = false;
    this._intentStates = new Map();
    this.destroyed = false;
  }
  return api_createClass(PDFPageProxy, [{
    key: "pageNumber",
    get: function get() {
      return this._pageIndex + 1;
    }
  }, {
    key: "rotate",
    get: function get() {
      return this._pageInfo.rotate;
    }
  }, {
    key: "ref",
    get: function get() {
      return this._pageInfo.ref;
    }
  }, {
    key: "userUnit",
    get: function get() {
      return this._pageInfo.userUnit;
    }
  }, {
    key: "view",
    get: function get() {
      return this._pageInfo.view;
    }
  }, {
    key: "getViewport",
    value: function getViewport() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        scale = _ref2.scale,
        _ref2$rotation = _ref2.rotation,
        rotation = _ref2$rotation === void 0 ? this.rotate : _ref2$rotation,
        _ref2$offsetX = _ref2.offsetX,
        offsetX = _ref2$offsetX === void 0 ? 0 : _ref2$offsetX,
        _ref2$offsetY = _ref2.offsetY,
        offsetY = _ref2$offsetY === void 0 ? 0 : _ref2$offsetY,
        _ref2$dontFlip = _ref2.dontFlip,
        dontFlip = _ref2$dontFlip === void 0 ? false : _ref2$dontFlip;
      return new PageViewport({
        viewBox: this.view,
        userUnit: this.userUnit,
        scale: scale,
        rotation: rotation,
        offsetX: offsetX,
        offsetY: offsetY,
        dontFlip: dontFlip
      });
    }
  }, {
    key: "getAnnotations",
    value: function getAnnotations() {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref3$intent = _ref3.intent,
        intent = _ref3$intent === void 0 ? "display" : _ref3$intent;
      var _this$_transport$getR2 = this._transport.getRenderingIntent(intent),
        renderingIntent = _this$_transport$getR2.renderingIntent;
      return this._transport.getAnnotations(this._pageIndex, renderingIntent);
    }
  }, {
    key: "getJSActions",
    value: function getJSActions() {
      return this._transport.getPageJSActions(this._pageIndex);
    }
  }, {
    key: "filterFactory",
    get: function get() {
      return this._transport.filterFactory;
    }
  }, {
    key: "isPureXfa",
    get: function get() {
      return shadow(this, "isPureXfa", !!this._transport._htmlForXfa);
    }
  }, {
    key: "getXfa",
    value: function () {
      var _getXfa = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee2() {
        var _this$_transport$_htm;
        return api_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", ((_this$_transport$_htm = this._transport._htmlForXfa) === null || _this$_transport$_htm === void 0 ? void 0 : _this$_transport$_htm.children[this._pageIndex]) || null);
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function getXfa() {
        return _getXfa.apply(this, arguments);
      }
      return getXfa;
    }()
  }, {
    key: "render",
    value: function render(_ref4) {
      var _this$_stats,
        _this5 = this,
        _intentState;
      var canvasContext = _ref4.canvasContext,
        viewport = _ref4.viewport,
        _ref4$intent = _ref4.intent,
        intent = _ref4$intent === void 0 ? "display" : _ref4$intent,
        _ref4$annotationMode = _ref4.annotationMode,
        annotationMode = _ref4$annotationMode === void 0 ? AnnotationMode.ENABLE : _ref4$annotationMode,
        _ref4$transform = _ref4.transform,
        transform = _ref4$transform === void 0 ? null : _ref4$transform,
        _ref4$background = _ref4.background,
        background = _ref4$background === void 0 ? null : _ref4$background,
        _ref4$optionalContent = _ref4.optionalContentConfigPromise,
        optionalContentConfigPromise = _ref4$optionalContent === void 0 ? null : _ref4$optionalContent,
        _ref4$annotationCanva = _ref4.annotationCanvasMap,
        annotationCanvasMap = _ref4$annotationCanva === void 0 ? null : _ref4$annotationCanva,
        _ref4$pageColors = _ref4.pageColors,
        pageColors = _ref4$pageColors === void 0 ? null : _ref4$pageColors,
        _ref4$printAnnotation = _ref4.printAnnotationStorage,
        printAnnotationStorage = _ref4$printAnnotation === void 0 ? null : _ref4$printAnnotation,
        _ref4$isEditing = _ref4.isEditing,
        isEditing = _ref4$isEditing === void 0 ? false : _ref4$isEditing;
      (_this$_stats = this._stats) === null || _this$_stats === void 0 || _this$_stats.time("Overall");
      var intentArgs = this._transport.getRenderingIntent(intent, annotationMode, printAnnotationStorage, isEditing);
      var renderingIntent = intentArgs.renderingIntent,
        cacheKey = intentArgs.cacheKey;
      api_classPrivateFieldSet(_pendingCleanup, this, false);
      api_assertClassBrand(_PDFPageProxy_brand, this, _abortDelayedCleanup).call(this);
      optionalContentConfigPromise || (optionalContentConfigPromise = this._transport.getOptionalContentConfig(renderingIntent));
      var intentState = this._intentStates.get(cacheKey);
      if (!intentState) {
        intentState = Object.create(null);
        this._intentStates.set(cacheKey, intentState);
      }
      if (intentState.streamReaderCancelTimeout) {
        clearTimeout(intentState.streamReaderCancelTimeout);
        intentState.streamReaderCancelTimeout = null;
      }
      var intentPrint = !!(renderingIntent & RenderingIntentFlag.PRINT);
      if (!intentState.displayReadyCapability) {
        var _this$_stats2;
        intentState.displayReadyCapability = Promise.withResolvers();
        intentState.operatorList = {
          fnArray: [],
          argsArray: [],
          lastChunk: false,
          separateAnnots: null
        };
        (_this$_stats2 = this._stats) === null || _this$_stats2 === void 0 || _this$_stats2.time("Page Request");
        this._pumpOperatorList(intentArgs);
      }
      var complete = function complete(error) {
        intentState.renderTasks.delete(internalRenderTask);
        if (_this5._maybeCleanupAfterRender || intentPrint) {
          api_classPrivateFieldSet(_pendingCleanup, _this5, true);
        }
        api_assertClassBrand(_PDFPageProxy_brand, _this5, _tryCleanup).call(_this5, !intentPrint);
        if (error) {
          internalRenderTask.capability.reject(error);
          _this5._abortOperatorList({
            intentState: intentState,
            reason: error instanceof Error ? error : new Error(error)
          });
        } else {
          internalRenderTask.capability.resolve();
        }
        if (_this5._stats) {
          var _globalThis$Stats;
          _this5._stats.timeEnd("Rendering");
          _this5._stats.timeEnd("Overall");
          if ((_globalThis$Stats = globalThis.Stats) !== null && _globalThis$Stats !== void 0 && _globalThis$Stats.enabled) {
            globalThis.Stats.add(_this5.pageNumber, _this5._stats);
          }
        }
      };
      var internalRenderTask = new InternalRenderTask({
        callback: complete,
        params: {
          canvasContext: canvasContext,
          viewport: viewport,
          transform: transform,
          background: background
        },
        objs: this.objs,
        commonObjs: this.commonObjs,
        annotationCanvasMap: annotationCanvasMap,
        operatorList: intentState.operatorList,
        pageIndex: this._pageIndex,
        canvasFactory: this._transport.canvasFactory,
        filterFactory: this._transport.filterFactory,
        useRequestAnimationFrame: !intentPrint,
        pdfBug: this._pdfBug,
        pageColors: pageColors
      });
      ((_intentState = intentState).renderTasks || (_intentState.renderTasks = new Set())).add(internalRenderTask);
      var renderTask = internalRenderTask.task;
      Promise.all([intentState.displayReadyCapability.promise, optionalContentConfigPromise]).then(function (_ref5) {
        var _this5$_stats;
        var _ref6 = api_slicedToArray(_ref5, 2),
          transparency = _ref6[0],
          optionalContentConfig = _ref6[1];
        if (_this5.destroyed) {
          complete();
          return;
        }
        (_this5$_stats = _this5._stats) === null || _this5$_stats === void 0 || _this5$_stats.time("Rendering");
        if (!(optionalContentConfig.renderingIntent & renderingIntent)) {
          throw new Error("Must use the same `intent`-argument when calling the `PDFPageProxy.render` " + "and `PDFDocumentProxy.getOptionalContentConfig` methods.");
        }
        internalRenderTask.initializeGraphics({
          transparency: transparency,
          optionalContentConfig: optionalContentConfig
        });
        internalRenderTask.operatorListChanged();
      }).catch(complete);
      return renderTask;
    }
  }, {
    key: "getOperatorList",
    value: function getOperatorList() {
      var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref7$intent = _ref7.intent,
        intent = _ref7$intent === void 0 ? "display" : _ref7$intent,
        _ref7$annotationMode = _ref7.annotationMode,
        annotationMode = _ref7$annotationMode === void 0 ? AnnotationMode.ENABLE : _ref7$annotationMode,
        _ref7$printAnnotation = _ref7.printAnnotationStorage,
        printAnnotationStorage = _ref7$printAnnotation === void 0 ? null : _ref7$printAnnotation,
        _ref7$isEditing = _ref7.isEditing,
        isEditing = _ref7$isEditing === void 0 ? false : _ref7$isEditing;
      function operatorListChanged() {
        if (intentState.operatorList.lastChunk) {
          intentState.opListReadCapability.resolve(intentState.operatorList);
          intentState.renderTasks.delete(opListTask);
        }
      }
      var intentArgs = this._transport.getRenderingIntent(intent, annotationMode, printAnnotationStorage, isEditing, true);
      var intentState = this._intentStates.get(intentArgs.cacheKey);
      if (!intentState) {
        intentState = Object.create(null);
        this._intentStates.set(intentArgs.cacheKey, intentState);
      }
      var opListTask;
      if (!intentState.opListReadCapability) {
        var _intentState2, _this$_stats3;
        opListTask = Object.create(null);
        opListTask.operatorListChanged = operatorListChanged;
        intentState.opListReadCapability = Promise.withResolvers();
        ((_intentState2 = intentState).renderTasks || (_intentState2.renderTasks = new Set())).add(opListTask);
        intentState.operatorList = {
          fnArray: [],
          argsArray: [],
          lastChunk: false,
          separateAnnots: null
        };
        (_this$_stats3 = this._stats) === null || _this$_stats3 === void 0 || _this$_stats3.time("Page Request");
        this._pumpOperatorList(intentArgs);
      }
      return intentState.opListReadCapability.promise;
    }
  }, {
    key: "streamTextContent",
    value: function streamTextContent() {
      var _ref8 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref8$includeMarkedCo = _ref8.includeMarkedContent,
        includeMarkedContent = _ref8$includeMarkedCo === void 0 ? false : _ref8$includeMarkedCo,
        _ref8$disableNormaliz = _ref8.disableNormalization,
        disableNormalization = _ref8$disableNormaliz === void 0 ? false : _ref8$disableNormaliz;
      var TEXT_CONTENT_CHUNK_SIZE = 100;
      return this._transport.messageHandler.sendWithStream("GetTextContent", {
        pageIndex: this._pageIndex,
        includeMarkedContent: includeMarkedContent === true,
        disableNormalization: disableNormalization === true
      }, {
        highWaterMark: TEXT_CONTENT_CHUNK_SIZE,
        size: function size(textContent) {
          return textContent.items.length;
        }
      });
    }
  }, {
    key: "getTextContent",
    value: function getTextContent() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      if (this._transport._htmlForXfa) {
        return this.getXfa().then(function (xfa) {
          return XfaText.textContent(xfa);
        });
      }
      var readableStream = this.streamTextContent(params);
      return new Promise(function (resolve, reject) {
        function pump() {
          reader.read().then(function (_ref9) {
            var _textContent$lang, _textContent$items;
            var value = _ref9.value,
              done = _ref9.done;
            if (done) {
              resolve(textContent);
              return;
            }
            (_textContent$lang = textContent.lang) !== null && _textContent$lang !== void 0 ? _textContent$lang : textContent.lang = value.lang;
            Object.assign(textContent.styles, value.styles);
            (_textContent$items = textContent.items).push.apply(_textContent$items, api_toConsumableArray(value.items));
            pump();
          }, reject);
        }
        var reader = readableStream.getReader();
        var textContent = {
          items: [],
          styles: Object.create(null),
          lang: null
        };
        pump();
      });
    }
  }, {
    key: "getStructTree",
    value: function getStructTree() {
      return this._transport.getStructTree(this._pageIndex);
    }
  }, {
    key: "_destroy",
    value: function _destroy() {
      this.destroyed = true;
      var waitOn = [];
      var _iterator5 = api_createForOfIteratorHelper(this._intentStates.values()),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var intentState = _step5.value;
          this._abortOperatorList({
            intentState: intentState,
            reason: new Error("Page was destroyed."),
            force: true
          });
          if (intentState.opListReadCapability) {
            continue;
          }
          var _iterator6 = api_createForOfIteratorHelper(intentState.renderTasks),
            _step6;
          try {
            for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
              var internalRenderTask = _step6.value;
              waitOn.push(internalRenderTask.completed);
              internalRenderTask.cancel();
            }
          } catch (err) {
            _iterator6.e(err);
          } finally {
            _iterator6.f();
          }
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      this.objs.clear();
      api_classPrivateFieldSet(_pendingCleanup, this, false);
      api_assertClassBrand(_PDFPageProxy_brand, this, _abortDelayedCleanup).call(this);
      return Promise.all(waitOn);
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      var resetStats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      api_classPrivateFieldSet(_pendingCleanup, this, true);
      var success = api_assertClassBrand(_PDFPageProxy_brand, this, _tryCleanup).call(this, false);
      if (resetStats && success) {
        this._stats && (this._stats = new StatTimer());
      }
      return success;
    }
  }, {
    key: "_startRenderPage",
    value: function _startRenderPage(transparency, cacheKey) {
      var _this$_stats4, _intentState$displayR;
      var intentState = this._intentStates.get(cacheKey);
      if (!intentState) {
        return;
      }
      (_this$_stats4 = this._stats) === null || _this$_stats4 === void 0 || _this$_stats4.timeEnd("Page Request");
      (_intentState$displayR = intentState.displayReadyCapability) === null || _intentState$displayR === void 0 || _intentState$displayR.resolve(transparency);
    }
  }, {
    key: "_renderPageChunk",
    value: function _renderPageChunk(operatorListChunk, intentState) {
      for (var i = 0, ii = operatorListChunk.length; i < ii; i++) {
        intentState.operatorList.fnArray.push(operatorListChunk.fnArray[i]);
        intentState.operatorList.argsArray.push(operatorListChunk.argsArray[i]);
      }
      intentState.operatorList.lastChunk = operatorListChunk.lastChunk;
      intentState.operatorList.separateAnnots = operatorListChunk.separateAnnots;
      var _iterator7 = api_createForOfIteratorHelper(intentState.renderTasks),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var internalRenderTask = _step7.value;
          internalRenderTask.operatorListChanged();
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
      if (operatorListChunk.lastChunk) {
        api_assertClassBrand(_PDFPageProxy_brand, this, _tryCleanup).call(this, true);
      }
    }
  }, {
    key: "_pumpOperatorList",
    value: function _pumpOperatorList(_ref10) {
      var _this6 = this;
      var renderingIntent = _ref10.renderingIntent,
        cacheKey = _ref10.cacheKey,
        annotationStorageSerializable = _ref10.annotationStorageSerializable,
        modifiedIds = _ref10.modifiedIds;
      var map = annotationStorageSerializable.map,
        transfer = annotationStorageSerializable.transfer;
      var readableStream = this._transport.messageHandler.sendWithStream("GetOperatorList", {
        pageIndex: this._pageIndex,
        intent: renderingIntent,
        cacheKey: cacheKey,
        annotationStorage: map,
        modifiedIds: modifiedIds
      }, transfer);
      var reader = readableStream.getReader();
      var intentState = this._intentStates.get(cacheKey);
      intentState.streamReader = reader;
      var _pump = function pump() {
        reader.read().then(function (_ref11) {
          var value = _ref11.value,
            done = _ref11.done;
          if (done) {
            intentState.streamReader = null;
            return;
          }
          if (_this6._transport.destroyed) {
            return;
          }
          _this6._renderPageChunk(value, intentState);
          _pump();
        }, function (reason) {
          intentState.streamReader = null;
          if (_this6._transport.destroyed) {
            return;
          }
          if (intentState.operatorList) {
            intentState.operatorList.lastChunk = true;
            var _iterator8 = api_createForOfIteratorHelper(intentState.renderTasks),
              _step8;
            try {
              for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
                var internalRenderTask = _step8.value;
                internalRenderTask.operatorListChanged();
              }
            } catch (err) {
              _iterator8.e(err);
            } finally {
              _iterator8.f();
            }
            api_assertClassBrand(_PDFPageProxy_brand, _this6, _tryCleanup).call(_this6, true);
          }
          if (intentState.displayReadyCapability) {
            intentState.displayReadyCapability.reject(reason);
          } else if (intentState.opListReadCapability) {
            intentState.opListReadCapability.reject(reason);
          } else {
            throw reason;
          }
        });
      };
      _pump();
    }
  }, {
    key: "_abortOperatorList",
    value: function _abortOperatorList(_ref12) {
      var _this7 = this;
      var intentState = _ref12.intentState,
        reason = _ref12.reason,
        _ref12$force = _ref12.force,
        force = _ref12$force === void 0 ? false : _ref12$force;
      if (!intentState.streamReader) {
        return;
      }
      if (intentState.streamReaderCancelTimeout) {
        clearTimeout(intentState.streamReaderCancelTimeout);
        intentState.streamReaderCancelTimeout = null;
      }
      if (!force) {
        if (intentState.renderTasks.size > 0) {
          return;
        }
        if (reason instanceof RenderingCancelledException) {
          var delay = RENDERING_CANCELLED_TIMEOUT;
          if (reason.extraDelay > 0 && reason.extraDelay < 1000) {
            delay += reason.extraDelay;
          }
          intentState.streamReaderCancelTimeout = setTimeout(function () {
            intentState.streamReaderCancelTimeout = null;
            _this7._abortOperatorList({
              intentState: intentState,
              reason: reason,
              force: true
            });
          }, delay);
          return;
        }
      }
      intentState.streamReader.cancel(new AbortException(reason.message)).catch(function () {});
      intentState.streamReader = null;
      if (this._transport.destroyed) {
        return;
      }
      var _iterator9 = api_createForOfIteratorHelper(this._intentStates),
        _step9;
      try {
        for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
          var _step9$value = api_slicedToArray(_step9.value, 2),
            curCacheKey = _step9$value[0],
            curIntentState = _step9$value[1];
          if (curIntentState === intentState) {
            this._intentStates.delete(curCacheKey);
            break;
          }
        }
      } catch (err) {
        _iterator9.e(err);
      } finally {
        _iterator9.f();
      }
      this.cleanup();
    }
  }, {
    key: "stats",
    get: function get() {
      return this._stats;
    }
  }]);
}();
function _tryCleanup() {
  var _this22 = this;
  var delayed = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  api_assertClassBrand(_PDFPageProxy_brand, this, _abortDelayedCleanup).call(this);
  if (!api_classPrivateFieldGet(_pendingCleanup, this) || this.destroyed) {
    return false;
  }
  if (delayed) {
    api_classPrivateFieldSet(_delayedCleanupTimeout, this, setTimeout(function () {
      api_classPrivateFieldSet(_delayedCleanupTimeout, _this22, null);
      api_assertClassBrand(_PDFPageProxy_brand, _this22, _tryCleanup).call(_this22, false);
    }, DELAYED_CLEANUP_TIMEOUT));
    return false;
  }
  var _iterator16 = api_createForOfIteratorHelper(this._intentStates.values()),
    _step16;
  try {
    for (_iterator16.s(); !(_step16 = _iterator16.n()).done;) {
      var _step16$value = _step16.value,
        renderTasks = _step16$value.renderTasks,
        operatorList = _step16$value.operatorList;
      if (renderTasks.size > 0 || !operatorList.lastChunk) {
        return false;
      }
    }
  } catch (err) {
    _iterator16.e(err);
  } finally {
    _iterator16.f();
  }
  this._intentStates.clear();
  this.objs.clear();
  api_classPrivateFieldSet(_pendingCleanup, this, false);
  return true;
}
function _abortDelayedCleanup() {
  if (api_classPrivateFieldGet(_delayedCleanupTimeout, this)) {
    clearTimeout(api_classPrivateFieldGet(_delayedCleanupTimeout, this));
    api_classPrivateFieldSet(_delayedCleanupTimeout, this, null);
  }
}
var _listeners = /*#__PURE__*/new WeakMap();
var _deferred = /*#__PURE__*/new WeakMap();
var LoopbackPort = /*#__PURE__*/function () {
  function LoopbackPort() {
    api_classCallCheck(this, LoopbackPort);
    api_classPrivateFieldInitSpec(this, _listeners, new Map());
    api_classPrivateFieldInitSpec(this, _deferred, Promise.resolve());
  }
  return api_createClass(LoopbackPort, [{
    key: "postMessage",
    value: function postMessage(obj, transfer) {
      var _this8 = this;
      var event = {
        data: structuredClone(obj, transfer ? {
          transfer: transfer
        } : null)
      };
      api_classPrivateFieldGet(_deferred, this).then(function () {
        var _iterator10 = api_createForOfIteratorHelper(api_classPrivateFieldGet(_listeners, _this8)),
          _step10;
        try {
          for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
            var _step10$value = api_slicedToArray(_step10.value, 1),
              listener = _step10$value[0];
            listener.call(_this8, event);
          }
        } catch (err) {
          _iterator10.e(err);
        } finally {
          _iterator10.f();
        }
      });
    }
  }, {
    key: "addEventListener",
    value: function addEventListener(name, listener) {
      var _this9 = this;
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var rmAbort = null;
      if ((options === null || options === void 0 ? void 0 : options.signal) instanceof AbortSignal) {
        var signal = options.signal;
        if (signal.aborted) {
          warn("LoopbackPort - cannot use an `aborted` signal.");
          return;
        }
        var onAbort = function onAbort() {
          return _this9.removeEventListener(name, listener);
        };
        rmAbort = function rmAbort() {
          return signal.removeEventListener("abort", onAbort);
        };
        signal.addEventListener("abort", onAbort);
      }
      api_classPrivateFieldGet(_listeners, this).set(listener, rmAbort);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(name, listener) {
      var rmAbort = api_classPrivateFieldGet(_listeners, this).get(listener);
      rmAbort === null || rmAbort === void 0 || rmAbort();
      api_classPrivateFieldGet(_listeners, this).delete(listener);
    }
  }, {
    key: "terminate",
    value: function terminate() {
      var _iterator11 = api_createForOfIteratorHelper(api_classPrivateFieldGet(_listeners, this)),
        _step11;
      try {
        for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
          var _step11$value = api_slicedToArray(_step11.value, 2),
            rmAbort = _step11$value[1];
          rmAbort === null || rmAbort === void 0 || rmAbort();
        }
      } catch (err) {
        _iterator11.e(err);
      } finally {
        _iterator11.f();
      }
      api_classPrivateFieldGet(_listeners, this).clear();
    }
  }]);
}();
var _PDFWorker_brand = /*#__PURE__*/new WeakSet();
var PDFWorker = /*#__PURE__*/function () {
  function PDFWorker() {
    var _ref13 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref13$name = _ref13.name,
      name = _ref13$name === void 0 ? null : _ref13$name,
      _ref13$port = _ref13.port,
      port = _ref13$port === void 0 ? null : _ref13$port,
      _ref13$verbosity = _ref13.verbosity,
      verbosity = _ref13$verbosity === void 0 ? getVerbosityLevel() : _ref13$verbosity;
    api_classCallCheck(this, PDFWorker);
    api_classPrivateMethodInitSpec(this, _PDFWorker_brand);
    this.name = name;
    this.destroyed = false;
    this.verbosity = verbosity;
    this._readyCapability = Promise.withResolvers();
    this._port = null;
    this._webWorker = null;
    this._messageHandler = null;
    if (port) {
      var _workerPorts$_;
      if ((_workerPorts$_ = _workerPorts._) !== null && _workerPorts$_ !== void 0 && _workerPorts$_.has(port)) {
        throw new Error("Cannot use more than one PDFWorker per port.");
      }
      (_workerPorts._ || (_workerPorts._ = new WeakMap())).set(port, this);
      this._initializeFromPort(port);
      return;
    }
    this._initialize();
  }
  return api_createClass(PDFWorker, [{
    key: "promise",
    get: function get() {
      return this._readyCapability.promise;
    }
  }, {
    key: "port",
    get: function get() {
      return this._port;
    }
  }, {
    key: "messageHandler",
    get: function get() {
      return this._messageHandler;
    }
  }, {
    key: "_initializeFromPort",
    value: function _initializeFromPort(port) {
      this._port = port;
      this._messageHandler = new MessageHandler("main", "worker", port);
      this._messageHandler.on("ready", function () {});
      api_assertClassBrand(_PDFWorker_brand, this, _resolve).call(this);
    }
  }, {
    key: "_initialize",
    value: function _initialize() {
      var _this11 = this;
      if (_isWorkerDisabled._ || _get_mainThreadWorkerMessageHandler(PDFWorker)) {
        this._setupFakeWorker();
        return;
      }
      var workerSrc = PDFWorker.workerSrc;
      try {
        if (!PDFWorker._isSameOrigin(window.location.href, workerSrc)) {
          workerSrc = PDFWorker._createCDNWrapper(new URL(workerSrc, window.location).href);
        }
        var worker = new Worker(workerSrc, {
          type: "module"
        });
        var messageHandler = new MessageHandler("main", "worker", worker);
        var terminateEarly = function terminateEarly() {
          ac.abort();
          messageHandler.destroy();
          worker.terminate();
          if (_this11.destroyed) {
            _this11._readyCapability.reject(new Error("Worker was destroyed"));
          } else {
            _this11._setupFakeWorker();
          }
        };
        var ac = new AbortController();
        worker.addEventListener("error", function () {
          if (!_this11._webWorker) {
            terminateEarly();
          }
        }, {
          signal: ac.signal
        });
        messageHandler.on("test", function (data) {
          ac.abort();
          if (_this11.destroyed || !data) {
            terminateEarly();
            return;
          }
          _this11._messageHandler = messageHandler;
          _this11._port = worker;
          _this11._webWorker = worker;
          api_assertClassBrand(_PDFWorker_brand, _this11, _resolve).call(_this11);
        });
        messageHandler.on("ready", function (data) {
          ac.abort();
          if (_this11.destroyed) {
            terminateEarly();
            return;
          }
          try {
            sendTest();
          } catch (_unused2) {
            _this11._setupFakeWorker();
          }
        });
        var sendTest = function sendTest() {
          var testObj = new Uint8Array();
          messageHandler.send("test", testObj, [testObj.buffer]);
        };
        sendTest();
        return;
      } catch (_unused3) {
        info("The worker has been disabled.");
      }
      this._setupFakeWorker();
    }
  }, {
    key: "_setupFakeWorker",
    value: function _setupFakeWorker() {
      var _this12 = this;
      if (!_isWorkerDisabled._) {
        warn("Setting up fake worker.");
        _isWorkerDisabled._ = true;
      }
      PDFWorker._setupFakeWorkerGlobal.then(function (WorkerMessageHandler) {
        var _PDFWorker$fakeWorker, _PDFWorker$fakeWorker2;
        if (_this12.destroyed) {
          _this12._readyCapability.reject(new Error("Worker was destroyed"));
          return;
        }
        var port = new LoopbackPort();
        _this12._port = port;
        var id = "fake".concat((_fakeWorkerId._ = (_PDFWorker$fakeWorker = _fakeWorkerId._, _PDFWorker$fakeWorker2 = _PDFWorker$fakeWorker++, _PDFWorker$fakeWorker), _PDFWorker$fakeWorker2));
        var workerHandler = new MessageHandler(id + "_worker", id, port);
        WorkerMessageHandler.setup(workerHandler, port);
        _this12._messageHandler = new MessageHandler(id, id + "_worker", port);
        api_assertClassBrand(_PDFWorker_brand, _this12, _resolve).call(_this12);
      }).catch(function (reason) {
        _this12._readyCapability.reject(new Error("Setting up fake worker failed: \"".concat(reason.message, "\".")));
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _this$_webWorker, _workerPorts$_2, _this$_messageHandler;
      this.destroyed = true;
      (_this$_webWorker = this._webWorker) === null || _this$_webWorker === void 0 || _this$_webWorker.terminate();
      this._webWorker = null;
      (_workerPorts$_2 = _workerPorts._) === null || _workerPorts$_2 === void 0 || _workerPorts$_2.delete(this._port);
      this._port = null;
      (_this$_messageHandler = this._messageHandler) === null || _this$_messageHandler === void 0 || _this$_messageHandler.destroy();
      this._messageHandler = null;
    }
  }], [{
    key: "fromPort",
    value: function fromPort(params) {
      var _assertClassBrand$_;
      if (!(params !== null && params !== void 0 && params.port)) {
        throw new Error("PDFWorker.fromPort - invalid method signature.");
      }
      var cachedPort = (_assertClassBrand$_ = api_assertClassBrand(PDFWorker, this, _workerPorts)._) === null || _assertClassBrand$_ === void 0 ? void 0 : _assertClassBrand$_.get(params.port);
      if (cachedPort) {
        if (cachedPort._pendingDestroy) {
          throw new Error("PDFWorker.fromPort - the worker is being destroyed.\n" + "Please remember to await `PDFDocumentLoadingTask.destroy()`-calls.");
        }
        return cachedPort;
      }
      return new PDFWorker(params);
    }
  }, {
    key: "workerSrc",
    get: function get() {
      if (GlobalWorkerOptions.workerSrc) {
        return GlobalWorkerOptions.workerSrc;
      }
      throw new Error('No "GlobalWorkerOptions.workerSrc" specified.');
    }
  }, {
    key: "_setupFakeWorkerGlobal",
    get: function get() {
      var _this13 = this;
      var loader = /*#__PURE__*/function () {
        var _ref14 = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee3() {
          var worker;
          return api_regeneratorRuntime().wrap(function _callee3$(_context3) {
            while (1) switch (_context3.prev = _context3.next) {
              case 0:
                if (!api_classPrivateGetter(PDFWorker, _this13, _get_mainThreadWorkerMessageHandler)) {
                  _context3.next = 2;
                  break;
                }
                return _context3.abrupt("return", api_classPrivateGetter(PDFWorker, _this13, _get_mainThreadWorkerMessageHandler));
              case 2:
                _context3.next = 4;
                return import(/*webpackIgnore: true*/_this13.workerSrc);
              case 4:
                worker = _context3.sent;
                return _context3.abrupt("return", worker.WorkerMessageHandler);
              case 6:
              case "end":
                return _context3.stop();
            }
          }, _callee3);
        }));
        return function loader() {
          return _ref14.apply(this, arguments);
        };
      }();
      return shadow(this, "_setupFakeWorkerGlobal", loader());
    }
  }]);
}();
_PDFWorker = PDFWorker;
function _resolve() {
  this._readyCapability.resolve();
  this._messageHandler.send("configure", {
    verbosity: this.verbosity
  });
}
function _get_mainThreadWorkerMessageHandler(_this10) {
  try {
    var _globalThis$pdfjsWork;
    return ((_globalThis$pdfjsWork = globalThis.pdfjsWorker) === null || _globalThis$pdfjsWork === void 0 ? void 0 : _globalThis$pdfjsWork.WorkerMessageHandler) || null;
  } catch (_unused5) {
    return null;
  }
}
var _fakeWorkerId = {
  _: 0
};
var _isWorkerDisabled = {
  _: false
};
var _workerPorts = {
  _: void 0
};
(function () {
  if (isNodeJS) {
    _isWorkerDisabled._ = api_assertClassBrand(_PDFWorker, _PDFWorker, true);
    GlobalWorkerOptions.workerSrc || (GlobalWorkerOptions.workerSrc = "./pdf.worker.mjs");
  }
  _PDFWorker._isSameOrigin = function (baseUrl, otherUrl) {
    var base;
    try {
      base = new URL(baseUrl);
      if (!base.origin || base.origin === "null") {
        return false;
      }
    } catch (_unused4) {
      return false;
    }
    var other = new URL(otherUrl, base);
    return base.origin === other.origin;
  };
  _PDFWorker._createCDNWrapper = function (url) {
    var wrapper = "await import(\"".concat(url, "\");");
    return URL.createObjectURL(new Blob([wrapper], {
      type: "text/javascript"
    }));
  };
})();
var _methodPromises = /*#__PURE__*/new WeakMap();
var _pageCache = /*#__PURE__*/new WeakMap();
var _pagePromises = /*#__PURE__*/new WeakMap();
var _pageRefCache = /*#__PURE__*/new WeakMap();
var _passwordCapability = /*#__PURE__*/new WeakMap();
var _WorkerTransport_brand = /*#__PURE__*/new WeakSet();
var WorkerTransport = /*#__PURE__*/function () {
  function WorkerTransport(messageHandler, loadingTask, networkStream, params, factory) {
    var _this14 = this;
    api_classCallCheck(this, WorkerTransport);
    api_classPrivateMethodInitSpec(this, _WorkerTransport_brand);
    api_classPrivateFieldInitSpec(this, _methodPromises, new Map());
    api_classPrivateFieldInitSpec(this, _pageCache, new Map());
    api_classPrivateFieldInitSpec(this, _pagePromises, new Map());
    api_classPrivateFieldInitSpec(this, _pageRefCache, new Map());
    api_classPrivateFieldInitSpec(this, _passwordCapability, null);
    this.messageHandler = messageHandler;
    this.loadingTask = loadingTask;
    this.commonObjs = new PDFObjects();
    this.fontLoader = new FontLoader({
      ownerDocument: params.ownerDocument,
      styleElement: params.styleElement
    });
    this.loadingParams = params.loadingParams;
    this._params = params;
    this.canvasFactory = factory.canvasFactory;
    this.filterFactory = factory.filterFactory;
    this.cMapReaderFactory = factory.cMapReaderFactory;
    this.standardFontDataFactory = factory.standardFontDataFactory;
    this.destroyed = false;
    this.destroyCapability = null;
    this._networkStream = networkStream;
    this._fullReader = null;
    this._lastProgress = null;
    this.downloadInfoCapability = Promise.withResolvers();
    this.setupMessageHandler();
  }
  return api_createClass(WorkerTransport, [{
    key: "annotationStorage",
    get: function get() {
      return shadow(this, "annotationStorage", new AnnotationStorage());
    }
  }, {
    key: "getRenderingIntent",
    value: function getRenderingIntent(intent) {
      var annotationMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AnnotationMode.ENABLE;
      var printAnnotationStorage = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var isEditing = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var isOpList = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      var renderingIntent = RenderingIntentFlag.DISPLAY;
      var annotationStorageSerializable = SerializableEmpty;
      switch (intent) {
        case "any":
          renderingIntent = RenderingIntentFlag.ANY;
          break;
        case "display":
          break;
        case "print":
          renderingIntent = RenderingIntentFlag.PRINT;
          break;
        default:
          warn("getRenderingIntent - invalid intent: ".concat(intent));
      }
      var annotationStorage = renderingIntent & RenderingIntentFlag.PRINT && printAnnotationStorage instanceof PrintAnnotationStorage ? printAnnotationStorage : this.annotationStorage;
      switch (annotationMode) {
        case AnnotationMode.DISABLE:
          renderingIntent += RenderingIntentFlag.ANNOTATIONS_DISABLE;
          break;
        case AnnotationMode.ENABLE:
          break;
        case AnnotationMode.ENABLE_FORMS:
          renderingIntent += RenderingIntentFlag.ANNOTATIONS_FORMS;
          break;
        case AnnotationMode.ENABLE_STORAGE:
          renderingIntent += RenderingIntentFlag.ANNOTATIONS_STORAGE;
          annotationStorageSerializable = annotationStorage.serializable;
          break;
        default:
          warn("getRenderingIntent - invalid annotationMode: ".concat(annotationMode));
      }
      if (isEditing) {
        renderingIntent += RenderingIntentFlag.IS_EDITING;
      }
      if (isOpList) {
        renderingIntent += RenderingIntentFlag.OPLIST;
      }
      var _annotationStorage$mo = annotationStorage.modifiedIds,
        modifiedIds = _annotationStorage$mo.ids,
        modifiedIdsHash = _annotationStorage$mo.hash;
      var cacheKeyBuf = [renderingIntent, annotationStorageSerializable.hash, modifiedIdsHash];
      return {
        renderingIntent: renderingIntent,
        cacheKey: cacheKeyBuf.join("_"),
        annotationStorageSerializable: annotationStorageSerializable,
        modifiedIds: modifiedIds
      };
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet2,
        _this15 = this;
      if (this.destroyCapability) {
        return this.destroyCapability.promise;
      }
      this.destroyed = true;
      this.destroyCapability = Promise.withResolvers();
      (_classPrivateFieldGet2 = api_classPrivateFieldGet(_passwordCapability, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.reject(new Error("Worker was destroyed during onPassword callback"));
      var waitOn = [];
      var _iterator12 = api_createForOfIteratorHelper(api_classPrivateFieldGet(_pageCache, this).values()),
        _step12;
      try {
        for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
          var page = _step12.value;
          waitOn.push(page._destroy());
        }
      } catch (err) {
        _iterator12.e(err);
      } finally {
        _iterator12.f();
      }
      api_classPrivateFieldGet(_pageCache, this).clear();
      api_classPrivateFieldGet(_pagePromises, this).clear();
      api_classPrivateFieldGet(_pageRefCache, this).clear();
      if (this.hasOwnProperty("annotationStorage")) {
        this.annotationStorage.resetModified();
      }
      var terminated = this.messageHandler.sendWithPromise("Terminate", null);
      waitOn.push(terminated);
      Promise.all(waitOn).then(function () {
        var _this15$_networkStrea, _this15$messageHandle;
        _this15.commonObjs.clear();
        _this15.fontLoader.clear();
        api_classPrivateFieldGet(_methodPromises, _this15).clear();
        _this15.filterFactory.destroy();
        TextLayer.cleanup();
        (_this15$_networkStrea = _this15._networkStream) === null || _this15$_networkStrea === void 0 || _this15$_networkStrea.cancelAllRequests(new AbortException("Worker was terminated."));
        (_this15$messageHandle = _this15.messageHandler) === null || _this15$messageHandle === void 0 || _this15$messageHandle.destroy();
        _this15.messageHandler = null;
        _this15.destroyCapability.resolve();
      }, this.destroyCapability.reject);
      return this.destroyCapability.promise;
    }
  }, {
    key: "setupMessageHandler",
    value: function setupMessageHandler() {
      var _this16 = this;
      var messageHandler = this.messageHandler,
        loadingTask = this.loadingTask;
      messageHandler.on("GetReader", function (data, sink) {
        assert(_this16._networkStream, "GetReader - no `IPDFStream` instance available.");
        _this16._fullReader = _this16._networkStream.getFullReader();
        _this16._fullReader.onProgress = function (evt) {
          _this16._lastProgress = {
            loaded: evt.loaded,
            total: evt.total
          };
        };
        sink.onPull = function () {
          _this16._fullReader.read().then(function (_ref15) {
            var value = _ref15.value,
              done = _ref15.done;
            if (done) {
              sink.close();
              return;
            }
            assert(value instanceof ArrayBuffer, "GetReader - expected an ArrayBuffer.");
            sink.enqueue(new Uint8Array(value), 1, [value]);
          }).catch(function (reason) {
            sink.error(reason);
          });
        };
        sink.onCancel = function (reason) {
          _this16._fullReader.cancel(reason);
          sink.ready.catch(function (readyReason) {
            if (_this16.destroyed) {
              return;
            }
            throw readyReason;
          });
        };
      });
      messageHandler.on("ReaderHeadersReady", /*#__PURE__*/function () {
        var _ref16 = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee4(data) {
          var _this16$_fullReader, isStreamingSupported, isRangeSupported, contentLength, _loadingTask$onProgre;
          return api_regeneratorRuntime().wrap(function _callee4$(_context4) {
            while (1) switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _this16._fullReader.headersReady;
              case 2:
                _this16$_fullReader = _this16._fullReader, isStreamingSupported = _this16$_fullReader.isStreamingSupported, isRangeSupported = _this16$_fullReader.isRangeSupported, contentLength = _this16$_fullReader.contentLength;
                if (!isStreamingSupported || !isRangeSupported) {
                  if (_this16._lastProgress) {
                    (_loadingTask$onProgre = loadingTask.onProgress) === null || _loadingTask$onProgre === void 0 || _loadingTask$onProgre.call(loadingTask, _this16._lastProgress);
                  }
                  _this16._fullReader.onProgress = function (evt) {
                    var _loadingTask$onProgre2;
                    (_loadingTask$onProgre2 = loadingTask.onProgress) === null || _loadingTask$onProgre2 === void 0 || _loadingTask$onProgre2.call(loadingTask, {
                      loaded: evt.loaded,
                      total: evt.total
                    });
                  };
                }
                return _context4.abrupt("return", {
                  isStreamingSupported: isStreamingSupported,
                  isRangeSupported: isRangeSupported,
                  contentLength: contentLength
                });
              case 5:
              case "end":
                return _context4.stop();
            }
          }, _callee4);
        }));
        return function (_x) {
          return _ref16.apply(this, arguments);
        };
      }());
      messageHandler.on("GetRangeReader", function (data, sink) {
        assert(_this16._networkStream, "GetRangeReader - no `IPDFStream` instance available.");
        var rangeReader = _this16._networkStream.getRangeReader(data.begin, data.end);
        if (!rangeReader) {
          sink.close();
          return;
        }
        sink.onPull = function () {
          rangeReader.read().then(function (_ref17) {
            var value = _ref17.value,
              done = _ref17.done;
            if (done) {
              sink.close();
              return;
            }
            assert(value instanceof ArrayBuffer, "GetRangeReader - expected an ArrayBuffer.");
            sink.enqueue(new Uint8Array(value), 1, [value]);
          }).catch(function (reason) {
            sink.error(reason);
          });
        };
        sink.onCancel = function (reason) {
          rangeReader.cancel(reason);
          sink.ready.catch(function (readyReason) {
            if (_this16.destroyed) {
              return;
            }
            throw readyReason;
          });
        };
      });
      messageHandler.on("GetDoc", function (_ref18) {
        var pdfInfo = _ref18.pdfInfo;
        _this16._numPages = pdfInfo.numPages;
        _this16._htmlForXfa = pdfInfo.htmlForXfa;
        delete pdfInfo.htmlForXfa;
        loadingTask._capability.resolve(new PDFDocumentProxy(pdfInfo, _this16));
      });
      messageHandler.on("DocException", function (ex) {
        var reason;
        switch (ex.name) {
          case "PasswordException":
            reason = new PasswordException(ex.message, ex.code);
            break;
          case "InvalidPDFException":
            reason = new InvalidPDFException(ex.message);
            break;
          case "MissingPDFException":
            reason = new MissingPDFException(ex.message);
            break;
          case "UnexpectedResponseException":
            reason = new UnexpectedResponseException(ex.message, ex.status);
            break;
          case "UnknownErrorException":
            reason = new UnknownErrorException(ex.message, ex.details);
            break;
          default:
            unreachable("DocException - expected a valid Error.");
        }
        loadingTask._capability.reject(reason);
      });
      messageHandler.on("PasswordRequest", function (exception) {
        api_classPrivateFieldSet(_passwordCapability, _this16, Promise.withResolvers());
        if (loadingTask.onPassword) {
          var updatePassword = function updatePassword(password) {
            if (password instanceof Error) {
              api_classPrivateFieldGet(_passwordCapability, _this16).reject(password);
            } else {
              api_classPrivateFieldGet(_passwordCapability, _this16).resolve({
                password: password
              });
            }
          };
          try {
            loadingTask.onPassword(updatePassword, exception.code);
          } catch (ex) {
            api_classPrivateFieldGet(_passwordCapability, _this16).reject(ex);
          }
        } else {
          api_classPrivateFieldGet(_passwordCapability, _this16).reject(new PasswordException(exception.message, exception.code));
        }
        return api_classPrivateFieldGet(_passwordCapability, _this16).promise;
      });
      messageHandler.on("DataLoaded", function (data) {
        var _loadingTask$onProgre3;
        (_loadingTask$onProgre3 = loadingTask.onProgress) === null || _loadingTask$onProgre3 === void 0 || _loadingTask$onProgre3.call(loadingTask, {
          loaded: data.length,
          total: data.length
        });
        _this16.downloadInfoCapability.resolve(data);
      });
      messageHandler.on("StartRenderPage", function (data) {
        if (_this16.destroyed) {
          return;
        }
        var page = api_classPrivateFieldGet(_pageCache, _this16).get(data.pageIndex);
        page._startRenderPage(data.transparency, data.cacheKey);
      });
      messageHandler.on("commonobj", function (_ref19) {
        var _globalThis$FontInspe;
        var _ref20 = api_slicedToArray(_ref19, 3),
          id = _ref20[0],
          type = _ref20[1],
          exportedData = _ref20[2];
        if (_this16.destroyed) {
          return null;
        }
        if (_this16.commonObjs.has(id)) {
          return null;
        }
        switch (type) {
          case "Font":
            var _this16$_params = _this16._params,
              disableFontFace = _this16$_params.disableFontFace,
              fontExtraProperties = _this16$_params.fontExtraProperties,
              pdfBug = _this16$_params.pdfBug;
            if ("error" in exportedData) {
              var exportedError = exportedData.error;
              warn("Error during font loading: ".concat(exportedError));
              _this16.commonObjs.resolve(id, exportedError);
              break;
            }
            var inspectFont = pdfBug && (_globalThis$FontInspe = globalThis.FontInspector) !== null && _globalThis$FontInspe !== void 0 && _globalThis$FontInspe.enabled ? function (font, url) {
              return globalThis.FontInspector.fontAdded(font, url);
            } : null;
            var font = new FontFaceObject(exportedData, {
              disableFontFace: disableFontFace,
              fontExtraProperties: fontExtraProperties,
              inspectFont: inspectFont
            });
            _this16.fontLoader.bind(font).catch(function () {
              return messageHandler.sendWithPromise("FontFallback", {
                id: id
              });
            }).finally(function () {
              if (!fontExtraProperties && font.data) {
                font.data = null;
              }
              _this16.commonObjs.resolve(id, font);
            });
            break;
          case "CopyLocalImage":
            var imageRef = exportedData.imageRef;
            assert(imageRef, "The imageRef must be defined.");
            var _iterator13 = api_createForOfIteratorHelper(api_classPrivateFieldGet(_pageCache, _this16).values()),
              _step13;
            try {
              for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
                var pageProxy = _step13.value;
                var _iterator14 = api_createForOfIteratorHelper(pageProxy.objs),
                  _step14;
                try {
                  for (_iterator14.s(); !(_step14 = _iterator14.n()).done;) {
                    var _step14$value = api_slicedToArray(_step14.value, 2),
                      data = _step14$value[1];
                    if ((data === null || data === void 0 ? void 0 : data.ref) !== imageRef) {
                      continue;
                    }
                    if (!data.dataLen) {
                      return null;
                    }
                    _this16.commonObjs.resolve(id, structuredClone(data));
                    return data.dataLen;
                  }
                } catch (err) {
                  _iterator14.e(err);
                } finally {
                  _iterator14.f();
                }
              }
            } catch (err) {
              _iterator13.e(err);
            } finally {
              _iterator13.f();
            }
            break;
          case "FontPath":
          case "Image":
          case "Pattern":
            _this16.commonObjs.resolve(id, exportedData);
            break;
          default:
            throw new Error("Got unknown common object type ".concat(type));
        }
        return null;
      });
      messageHandler.on("obj", function (_ref21) {
        var _ref22 = api_slicedToArray(_ref21, 4),
          id = _ref22[0],
          pageIndex = _ref22[1],
          type = _ref22[2],
          imageData = _ref22[3];
        if (_this16.destroyed) {
          return;
        }
        var pageProxy = api_classPrivateFieldGet(_pageCache, _this16).get(pageIndex);
        if (pageProxy.objs.has(id)) {
          return;
        }
        if (pageProxy._intentStates.size === 0) {
          var _imageData$bitmap;
          imageData === null || imageData === void 0 || (_imageData$bitmap = imageData.bitmap) === null || _imageData$bitmap === void 0 || _imageData$bitmap.close();
          return;
        }
        switch (type) {
          case "Image":
            pageProxy.objs.resolve(id, imageData);
            if ((imageData === null || imageData === void 0 ? void 0 : imageData.dataLen) > MAX_IMAGE_SIZE_TO_CACHE) {
              pageProxy._maybeCleanupAfterRender = true;
            }
            break;
          case "Pattern":
            pageProxy.objs.resolve(id, imageData);
            break;
          default:
            throw new Error("Got unknown object type ".concat(type));
        }
      });
      messageHandler.on("DocProgress", function (data) {
        var _loadingTask$onProgre4;
        if (_this16.destroyed) {
          return;
        }
        (_loadingTask$onProgre4 = loadingTask.onProgress) === null || _loadingTask$onProgre4 === void 0 || _loadingTask$onProgre4.call(loadingTask, {
          loaded: data.loaded,
          total: data.total
        });
      });
      messageHandler.on("FetchBuiltInCMap", /*#__PURE__*/function () {
        var _ref23 = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee5(data) {
          return api_regeneratorRuntime().wrap(function _callee5$(_context5) {
            while (1) switch (_context5.prev = _context5.next) {
              case 0:
                if (!_this16.destroyed) {
                  _context5.next = 2;
                  break;
                }
                throw new Error("Worker was destroyed.");
              case 2:
                if (_this16.cMapReaderFactory) {
                  _context5.next = 4;
                  break;
                }
                throw new Error("CMapReaderFactory not initialized, see the `useWorkerFetch` parameter.");
              case 4:
                return _context5.abrupt("return", _this16.cMapReaderFactory.fetch(data));
              case 5:
              case "end":
                return _context5.stop();
            }
          }, _callee5);
        }));
        return function (_x2) {
          return _ref23.apply(this, arguments);
        };
      }());
      messageHandler.on("FetchStandardFontData", /*#__PURE__*/function () {
        var _ref24 = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee6(data) {
          return api_regeneratorRuntime().wrap(function _callee6$(_context6) {
            while (1) switch (_context6.prev = _context6.next) {
              case 0:
                if (!_this16.destroyed) {
                  _context6.next = 2;
                  break;
                }
                throw new Error("Worker was destroyed.");
              case 2:
                if (_this16.standardFontDataFactory) {
                  _context6.next = 4;
                  break;
                }
                throw new Error("StandardFontDataFactory not initialized, see the `useWorkerFetch` parameter.");
              case 4:
                return _context6.abrupt("return", _this16.standardFontDataFactory.fetch(data));
              case 5:
              case "end":
                return _context6.stop();
            }
          }, _callee6);
        }));
        return function (_x3) {
          return _ref24.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "getData",
    value: function getData() {
      return this.messageHandler.sendWithPromise("GetData", null);
    }
  }, {
    key: "saveDocument",
    value: function saveDocument() {
      var _this$_fullReader$fil,
        _this$_fullReader,
        _this17 = this;
      if (this.annotationStorage.size <= 0) {
        warn("saveDocument called while `annotationStorage` is empty, " + "please use the getData-method instead.");
      }
      var _this$annotationStora = this.annotationStorage.serializable,
        map = _this$annotationStora.map,
        transfer = _this$annotationStora.transfer;
      return this.messageHandler.sendWithPromise("SaveDocument", {
        isPureXfa: !!this._htmlForXfa,
        numPages: this._numPages,
        annotationStorage: map,
        filename: (_this$_fullReader$fil = (_this$_fullReader = this._fullReader) === null || _this$_fullReader === void 0 ? void 0 : _this$_fullReader.filename) !== null && _this$_fullReader$fil !== void 0 ? _this$_fullReader$fil : null
      }, transfer).finally(function () {
        _this17.annotationStorage.resetModified();
      });
    }
  }, {
    key: "getPage",
    value: function getPage(pageNumber) {
      var _this18 = this;
      if (!Number.isInteger(pageNumber) || pageNumber <= 0 || pageNumber > this._numPages) {
        return Promise.reject(new Error("Invalid page request."));
      }
      var pageIndex = pageNumber - 1,
        cachedPromise = api_classPrivateFieldGet(_pagePromises, this).get(pageIndex);
      if (cachedPromise) {
        return cachedPromise;
      }
      var promise = this.messageHandler.sendWithPromise("GetPage", {
        pageIndex: pageIndex
      }).then(function (pageInfo) {
        if (_this18.destroyed) {
          throw new Error("Transport destroyed");
        }
        if (pageInfo.refStr) {
          api_classPrivateFieldGet(_pageRefCache, _this18).set(pageInfo.refStr, pageNumber);
        }
        var page = new PDFPageProxy(pageIndex, pageInfo, _this18, _this18._params.pdfBug);
        api_classPrivateFieldGet(_pageCache, _this18).set(pageIndex, page);
        return page;
      });
      api_classPrivateFieldGet(_pagePromises, this).set(pageIndex, promise);
      return promise;
    }
  }, {
    key: "getPageIndex",
    value: function getPageIndex(ref) {
      if (!isRefProxy(ref)) {
        return Promise.reject(new Error("Invalid pageIndex request."));
      }
      return this.messageHandler.sendWithPromise("GetPageIndex", {
        num: ref.num,
        gen: ref.gen
      });
    }
  }, {
    key: "getAnnotations",
    value: function getAnnotations(pageIndex, intent) {
      return this.messageHandler.sendWithPromise("GetAnnotations", {
        pageIndex: pageIndex,
        intent: intent
      });
    }
  }, {
    key: "getFieldObjects",
    value: function getFieldObjects() {
      return api_assertClassBrand(_WorkerTransport_brand, this, _cacheSimpleMethod).call(this, "GetFieldObjects");
    }
  }, {
    key: "hasJSActions",
    value: function hasJSActions() {
      return api_assertClassBrand(_WorkerTransport_brand, this, _cacheSimpleMethod).call(this, "HasJSActions");
    }
  }, {
    key: "getCalculationOrderIds",
    value: function getCalculationOrderIds() {
      return this.messageHandler.sendWithPromise("GetCalculationOrderIds", null);
    }
  }, {
    key: "getDestinations",
    value: function getDestinations() {
      return this.messageHandler.sendWithPromise("GetDestinations", null);
    }
  }, {
    key: "getDestination",
    value: function getDestination(id) {
      if (typeof id !== "string") {
        return Promise.reject(new Error("Invalid destination request."));
      }
      return this.messageHandler.sendWithPromise("GetDestination", {
        id: id
      });
    }
  }, {
    key: "getPageLabels",
    value: function getPageLabels() {
      return this.messageHandler.sendWithPromise("GetPageLabels", null);
    }
  }, {
    key: "getPageLayout",
    value: function getPageLayout() {
      return this.messageHandler.sendWithPromise("GetPageLayout", null);
    }
  }, {
    key: "getPageMode",
    value: function getPageMode() {
      return this.messageHandler.sendWithPromise("GetPageMode", null);
    }
  }, {
    key: "getViewerPreferences",
    value: function getViewerPreferences() {
      return this.messageHandler.sendWithPromise("GetViewerPreferences", null);
    }
  }, {
    key: "getOpenAction",
    value: function getOpenAction() {
      return this.messageHandler.sendWithPromise("GetOpenAction", null);
    }
  }, {
    key: "getAttachments",
    value: function getAttachments() {
      return this.messageHandler.sendWithPromise("GetAttachments", null);
    }
  }, {
    key: "getDocJSActions",
    value: function getDocJSActions() {
      return api_assertClassBrand(_WorkerTransport_brand, this, _cacheSimpleMethod).call(this, "GetDocJSActions");
    }
  }, {
    key: "getPageJSActions",
    value: function getPageJSActions(pageIndex) {
      return this.messageHandler.sendWithPromise("GetPageJSActions", {
        pageIndex: pageIndex
      });
    }
  }, {
    key: "getStructTree",
    value: function getStructTree(pageIndex) {
      return this.messageHandler.sendWithPromise("GetStructTree", {
        pageIndex: pageIndex
      });
    }
  }, {
    key: "getOutline",
    value: function getOutline() {
      return this.messageHandler.sendWithPromise("GetOutline", null);
    }
  }, {
    key: "getOptionalContentConfig",
    value: function getOptionalContentConfig(renderingIntent) {
      return api_assertClassBrand(_WorkerTransport_brand, this, _cacheSimpleMethod).call(this, "GetOptionalContentConfig").then(function (data) {
        return new OptionalContentConfig(data, renderingIntent);
      });
    }
  }, {
    key: "getPermissions",
    value: function getPermissions() {
      return this.messageHandler.sendWithPromise("GetPermissions", null);
    }
  }, {
    key: "getMetadata",
    value: function getMetadata() {
      var _this19 = this;
      var name = "GetMetadata",
        cachedPromise = api_classPrivateFieldGet(_methodPromises, this).get(name);
      if (cachedPromise) {
        return cachedPromise;
      }
      var promise = this.messageHandler.sendWithPromise(name, null).then(function (results) {
        var _this19$_fullReader$f, _this19$_fullReader, _this19$_fullReader$c, _this19$_fullReader2;
        return {
          info: results[0],
          metadata: results[1] ? new Metadata(results[1]) : null,
          contentDispositionFilename: (_this19$_fullReader$f = (_this19$_fullReader = _this19._fullReader) === null || _this19$_fullReader === void 0 ? void 0 : _this19$_fullReader.filename) !== null && _this19$_fullReader$f !== void 0 ? _this19$_fullReader$f : null,
          contentLength: (_this19$_fullReader$c = (_this19$_fullReader2 = _this19._fullReader) === null || _this19$_fullReader2 === void 0 ? void 0 : _this19$_fullReader2.contentLength) !== null && _this19$_fullReader$c !== void 0 ? _this19$_fullReader$c : null
        };
      });
      api_classPrivateFieldGet(_methodPromises, this).set(name, promise);
      return promise;
    }
  }, {
    key: "getMarkInfo",
    value: function getMarkInfo() {
      return this.messageHandler.sendWithPromise("GetMarkInfo", null);
    }
  }, {
    key: "startCleanup",
    value: function () {
      var _startCleanup = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee7() {
        var keepLoadedFonts,
          _iterator15,
          _step15,
          page,
          cleanupSuccessful,
          _args7 = arguments;
        return api_regeneratorRuntime().wrap(function _callee7$(_context7) {
          while (1) switch (_context7.prev = _context7.next) {
            case 0:
              keepLoadedFonts = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : false;
              if (!this.destroyed) {
                _context7.next = 3;
                break;
              }
              return _context7.abrupt("return");
            case 3:
              _context7.next = 5;
              return this.messageHandler.sendWithPromise("Cleanup", null);
            case 5:
              _iterator15 = api_createForOfIteratorHelper(api_classPrivateFieldGet(_pageCache, this).values());
              _context7.prev = 6;
              _iterator15.s();
            case 8:
              if ((_step15 = _iterator15.n()).done) {
                _context7.next = 15;
                break;
              }
              page = _step15.value;
              cleanupSuccessful = page.cleanup();
              if (cleanupSuccessful) {
                _context7.next = 13;
                break;
              }
              throw new Error("startCleanup: Page ".concat(page.pageNumber, " is currently rendering."));
            case 13:
              _context7.next = 8;
              break;
            case 15:
              _context7.next = 20;
              break;
            case 17:
              _context7.prev = 17;
              _context7.t0 = _context7["catch"](6);
              _iterator15.e(_context7.t0);
            case 20:
              _context7.prev = 20;
              _iterator15.f();
              return _context7.finish(20);
            case 23:
              this.commonObjs.clear();
              if (!keepLoadedFonts) {
                this.fontLoader.clear();
              }
              api_classPrivateFieldGet(_methodPromises, this).clear();
              this.filterFactory.destroy(true);
              TextLayer.cleanup();
            case 28:
            case "end":
              return _context7.stop();
          }
        }, _callee7, this, [[6, 17, 20, 23]]);
      }));
      function startCleanup() {
        return _startCleanup.apply(this, arguments);
      }
      return startCleanup;
    }()
  }, {
    key: "cachedPageNumber",
    value: function cachedPageNumber(ref) {
      var _classPrivateFieldGet3;
      if (!isRefProxy(ref)) {
        return null;
      }
      var refStr = ref.gen === 0 ? "".concat(ref.num, "R") : "".concat(ref.num, "R").concat(ref.gen);
      return (_classPrivateFieldGet3 = api_classPrivateFieldGet(_pageRefCache, this).get(refStr)) !== null && _classPrivateFieldGet3 !== void 0 ? _classPrivateFieldGet3 : null;
    }
  }]);
}();
function _cacheSimpleMethod(name) {
  var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var cachedPromise = api_classPrivateFieldGet(_methodPromises, this).get(name);
  if (cachedPromise) {
    return cachedPromise;
  }
  var promise = this.messageHandler.sendWithPromise(name, data);
  api_classPrivateFieldGet(_methodPromises, this).set(name, promise);
  return promise;
}
var INITIAL_DATA = Symbol("INITIAL_DATA");
var _objs = /*#__PURE__*/new WeakMap();
var _PDFObjects_brand = /*#__PURE__*/new WeakSet();
var PDFObjects = /*#__PURE__*/function () {
  function PDFObjects() {
    api_classCallCheck(this, PDFObjects);
    api_classPrivateMethodInitSpec(this, _PDFObjects_brand);
    api_classPrivateFieldInitSpec(this, _objs, Object.create(null));
  }
  return api_createClass(PDFObjects, [{
    key: "get",
    value: function get(objId) {
      var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (callback) {
        var _obj = api_assertClassBrand(_PDFObjects_brand, this, _ensureObj).call(this, objId);
        _obj.promise.then(function () {
          return callback(_obj.data);
        });
        return null;
      }
      var obj = api_classPrivateFieldGet(_objs, this)[objId];
      if (!obj || obj.data === INITIAL_DATA) {
        throw new Error("Requesting object that isn't resolved yet ".concat(objId, "."));
      }
      return obj.data;
    }
  }, {
    key: "has",
    value: function has(objId) {
      var obj = api_classPrivateFieldGet(_objs, this)[objId];
      return !!obj && obj.data !== INITIAL_DATA;
    }
  }, {
    key: "delete",
    value: function _delete(objId) {
      var obj = api_classPrivateFieldGet(_objs, this)[objId];
      if (!obj || obj.data === INITIAL_DATA) {
        return false;
      }
      delete api_classPrivateFieldGet(_objs, this)[objId];
      return true;
    }
  }, {
    key: "resolve",
    value: function resolve(objId) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var obj = api_assertClassBrand(_PDFObjects_brand, this, _ensureObj).call(this, objId);
      obj.data = data;
      obj.resolve();
    }
  }, {
    key: "clear",
    value: function clear() {
      for (var objId in api_classPrivateFieldGet(_objs, this)) {
        var _data$bitmap;
        var data = api_classPrivateFieldGet(_objs, this)[objId].data;
        data === null || data === void 0 || (_data$bitmap = data.bitmap) === null || _data$bitmap === void 0 || _data$bitmap.close();
      }
      api_classPrivateFieldSet(_objs, this, Object.create(null));
    }
  }, {
    key: Symbol.iterator,
    value: /*#__PURE__*/api_regeneratorRuntime().mark(function value() {
      var objId, data;
      return api_regeneratorRuntime().wrap(function value$(_context8) {
        while (1) switch (_context8.prev = _context8.next) {
          case 0:
            _context8.t0 = api_regeneratorRuntime().keys(api_classPrivateFieldGet(_objs, this));
          case 1:
            if ((_context8.t1 = _context8.t0()).done) {
              _context8.next = 10;
              break;
            }
            objId = _context8.t1.value;
            data = api_classPrivateFieldGet(_objs, this)[objId].data;
            if (!(data === INITIAL_DATA)) {
              _context8.next = 6;
              break;
            }
            return _context8.abrupt("continue", 1);
          case 6:
            _context8.next = 8;
            return [objId, data];
          case 8:
            _context8.next = 1;
            break;
          case 10:
          case "end":
            return _context8.stop();
        }
      }, value, this);
    })
  }]);
}();
function _ensureObj(objId) {
  var _classPrivateFieldGet5;
  return (_classPrivateFieldGet5 = api_classPrivateFieldGet(_objs, this))[objId] || (_classPrivateFieldGet5[objId] = _objectSpread(_objectSpread({}, Promise.withResolvers()), {}, {
    data: INITIAL_DATA
  }));
}
var _internalRenderTask = /*#__PURE__*/new WeakMap();
var RenderTask = /*#__PURE__*/function () {
  function RenderTask(internalRenderTask) {
    var _this20 = this;
    api_classCallCheck(this, RenderTask);
    api_classPrivateFieldInitSpec(this, _internalRenderTask, null);
    api_classPrivateFieldSet(_internalRenderTask, this, internalRenderTask);
    this.onContinue = null;
  }
  return api_createClass(RenderTask, [{
    key: "promise",
    get: function get() {
      return api_classPrivateFieldGet(_internalRenderTask, this).capability.promise;
    }
  }, {
    key: "cancel",
    value: function cancel() {
      var extraDelay = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      api_classPrivateFieldGet(_internalRenderTask, this).cancel(null, extraDelay);
    }
  }, {
    key: "separateAnnots",
    get: function get() {
      var separateAnnots = api_classPrivateFieldGet(_internalRenderTask, this).operatorList.separateAnnots;
      if (!separateAnnots) {
        return false;
      }
      var _classPrivateFieldGet4 = api_classPrivateFieldGet(_internalRenderTask, this),
        annotationCanvasMap = _classPrivateFieldGet4.annotationCanvasMap;
      return separateAnnots.form || separateAnnots.canvas && (annotationCanvasMap === null || annotationCanvasMap === void 0 ? void 0 : annotationCanvasMap.size) > 0;
    }
  }]);
}();
var _rAF = /*#__PURE__*/new WeakMap();
var InternalRenderTask = /*#__PURE__*/function () {
  function InternalRenderTask(_ref25) {
    var callback = _ref25.callback,
      params = _ref25.params,
      objs = _ref25.objs,
      commonObjs = _ref25.commonObjs,
      annotationCanvasMap = _ref25.annotationCanvasMap,
      operatorList = _ref25.operatorList,
      pageIndex = _ref25.pageIndex,
      canvasFactory = _ref25.canvasFactory,
      filterFactory = _ref25.filterFactory,
      _ref25$useRequestAnim = _ref25.useRequestAnimationFrame,
      useRequestAnimationFrame = _ref25$useRequestAnim === void 0 ? false : _ref25$useRequestAnim,
      _ref25$pdfBug = _ref25.pdfBug,
      pdfBug = _ref25$pdfBug === void 0 ? false : _ref25$pdfBug,
      _ref25$pageColors = _ref25.pageColors,
      pageColors = _ref25$pageColors === void 0 ? null : _ref25$pageColors;
    api_classCallCheck(this, InternalRenderTask);
    api_classPrivateFieldInitSpec(this, _rAF, null);
    this.callback = callback;
    this.params = params;
    this.objs = objs;
    this.commonObjs = commonObjs;
    this.annotationCanvasMap = annotationCanvasMap;
    this.operatorListIdx = null;
    this.operatorList = operatorList;
    this._pageIndex = pageIndex;
    this.canvasFactory = canvasFactory;
    this.filterFactory = filterFactory;
    this._pdfBug = pdfBug;
    this.pageColors = pageColors;
    this.running = false;
    this.graphicsReadyCallback = null;
    this.graphicsReady = false;
    this._useRequestAnimationFrame = useRequestAnimationFrame === true && typeof window !== "undefined";
    this.cancelled = false;
    this.capability = Promise.withResolvers();
    this.task = new RenderTask(this);
    this._cancelBound = this.cancel.bind(this);
    this._continueBound = this._continue.bind(this);
    this._scheduleNextBound = this._scheduleNext.bind(this);
    this._nextBound = this._next.bind(this);
    this._canvas = params.canvasContext.canvas;
  }
  return api_createClass(InternalRenderTask, [{
    key: "completed",
    get: function get() {
      return this.capability.promise.catch(function () {});
    }
  }, {
    key: "initializeGraphics",
    value: function initializeGraphics(_ref26) {
      var _globalThis$StepperMa, _this$graphicsReadyCa;
      var _ref26$transparency = _ref26.transparency,
        transparency = _ref26$transparency === void 0 ? false : _ref26$transparency,
        optionalContentConfig = _ref26.optionalContentConfig;
      if (this.cancelled) {
        return;
      }
      if (this._canvas) {
        if (_canvasInUse._.has(this._canvas)) {
          throw new Error("Cannot use the same canvas during multiple render() operations. " + "Use different canvas or ensure previous operations were " + "cancelled or completed.");
        }
        _canvasInUse._.add(this._canvas);
      }
      if (this._pdfBug && (_globalThis$StepperMa = globalThis.StepperManager) !== null && _globalThis$StepperMa !== void 0 && _globalThis$StepperMa.enabled) {
        this.stepper = globalThis.StepperManager.create(this._pageIndex);
        this.stepper.init(this.operatorList);
        this.stepper.nextBreakPoint = this.stepper.getNextBreakPoint();
      }
      var _this$params = this.params,
        canvasContext = _this$params.canvasContext,
        viewport = _this$params.viewport,
        transform = _this$params.transform,
        background = _this$params.background;
      this.gfx = new CanvasGraphics(canvasContext, this.commonObjs, this.objs, this.canvasFactory, this.filterFactory, {
        optionalContentConfig: optionalContentConfig
      }, this.annotationCanvasMap, this.pageColors);
      this.gfx.beginDrawing({
        transform: transform,
        viewport: viewport,
        transparency: transparency,
        background: background
      });
      this.operatorListIdx = 0;
      this.graphicsReady = true;
      (_this$graphicsReadyCa = this.graphicsReadyCallback) === null || _this$graphicsReadyCa === void 0 || _this$graphicsReadyCa.call(this);
    }
  }, {
    key: "cancel",
    value: function cancel() {
      var _this$gfx;
      var error = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var extraDelay = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      this.running = false;
      this.cancelled = true;
      (_this$gfx = this.gfx) === null || _this$gfx === void 0 || _this$gfx.endDrawing();
      if (api_classPrivateFieldGet(_rAF, this)) {
        window.cancelAnimationFrame(api_classPrivateFieldGet(_rAF, this));
        api_classPrivateFieldSet(_rAF, this, null);
      }
      _canvasInUse._.delete(this._canvas);
      this.callback(error || new RenderingCancelledException("Rendering cancelled, page ".concat(this._pageIndex + 1), extraDelay));
    }
  }, {
    key: "operatorListChanged",
    value: function operatorListChanged() {
      var _this$stepper;
      if (!this.graphicsReady) {
        this.graphicsReadyCallback || (this.graphicsReadyCallback = this._continueBound);
        return;
      }
      (_this$stepper = this.stepper) === null || _this$stepper === void 0 || _this$stepper.updateOperatorList(this.operatorList);
      if (this.running) {
        return;
      }
      this._continue();
    }
  }, {
    key: "_continue",
    value: function _continue() {
      this.running = true;
      if (this.cancelled) {
        return;
      }
      if (this.task.onContinue) {
        this.task.onContinue(this._scheduleNextBound);
      } else {
        this._scheduleNext();
      }
    }
  }, {
    key: "_scheduleNext",
    value: function _scheduleNext() {
      var _this21 = this;
      if (this._useRequestAnimationFrame) {
        api_classPrivateFieldSet(_rAF, this, window.requestAnimationFrame(function () {
          api_classPrivateFieldSet(_rAF, _this21, null);
          _this21._nextBound().catch(_this21._cancelBound);
        }));
      } else {
        Promise.resolve().then(this._nextBound).catch(this._cancelBound);
      }
    }
  }, {
    key: "_next",
    value: function () {
      var _next2 = api_asyncToGenerator(/*#__PURE__*/api_regeneratorRuntime().mark(function _callee8() {
        return api_regeneratorRuntime().wrap(function _callee8$(_context9) {
          while (1) switch (_context9.prev = _context9.next) {
            case 0:
              if (!this.cancelled) {
                _context9.next = 2;
                break;
              }
              return _context9.abrupt("return");
            case 2:
              this.operatorListIdx = this.gfx.executeOperatorList(this.operatorList, this.operatorListIdx, this._continueBound, this.stepper);
              if (this.operatorListIdx === this.operatorList.argsArray.length) {
                this.running = false;
                if (this.operatorList.lastChunk) {
                  this.gfx.endDrawing();
                  _canvasInUse._.delete(this._canvas);
                  this.callback();
                }
              }
            case 4:
            case "end":
              return _context9.stop();
          }
        }, _callee8, this);
      }));
      function _next() {
        return _next2.apply(this, arguments);
      }
      return _next;
    }()
  }]);
}();
var _canvasInUse = {
  _: new WeakSet()
};
var version = "4.10.8";
var build = "2df5d8f3e";

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.reflect.get.js
var es_reflect_get = __webpack_require__(888);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.reflect.to-string-tag.js
var es_reflect_to_string_tag = __webpack_require__(5472);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.reduce.js
var es_array_reduce = __webpack_require__(2712);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.string.trim-end.js
var es_string_trim_end = __webpack_require__(9202);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.find-index.js
var es_array_find_index = __webpack_require__(8980);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.flat-map.js
var es_array_flat_map = __webpack_require__(8350);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.unscopables.flat-map.js
var es_array_unscopables_flat_map = __webpack_require__(237);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.values.js
var es_object_values = __webpack_require__(6034);
// EXTERNAL MODULE: ./node_modules/core-js/modules/esnext.iterator.flat-map.js
var esnext_iterator_flat_map = __webpack_require__(670);
;// ./src/shared/scripting_utils.js
function scripting_utils_typeof(o) { "@babel/helpers - typeof"; return scripting_utils_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, scripting_utils_typeof(o); }
function scripting_utils_slicedToArray(r, e) { return scripting_utils_arrayWithHoles(r) || scripting_utils_iterableToArrayLimit(r, e) || scripting_utils_unsupportedIterableToArray(r, e) || scripting_utils_nonIterableRest(); }
function scripting_utils_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function scripting_utils_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return scripting_utils_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? scripting_utils_arrayLikeToArray(r, a) : void 0; } }
function scripting_utils_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function scripting_utils_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function scripting_utils_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function scripting_utils_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function scripting_utils_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, scripting_utils_toPropertyKey(o.key), o); } }
function scripting_utils_createClass(e, r, t) { return r && scripting_utils_defineProperties(e.prototype, r), t && scripting_utils_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function scripting_utils_toPropertyKey(t) { var i = scripting_utils_toPrimitive(t, "string"); return "symbol" == scripting_utils_typeof(i) ? i : i + ""; }
function scripting_utils_toPrimitive(t, r) { if ("object" != scripting_utils_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != scripting_utils_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }























function makeColorComp(n) {
  return Math.floor(Math.max(0, Math.min(1, n)) * 255).toString(16).padStart(2, "0");
}
function scaleAndClamp(x) {
  return Math.max(0, Math.min(255, 255 * x));
}
var ColorConverters = /*#__PURE__*/function () {
  function ColorConverters() {
    scripting_utils_classCallCheck(this, ColorConverters);
  }
  return scripting_utils_createClass(ColorConverters, null, [{
    key: "CMYK_G",
    value: function CMYK_G(_ref) {
      var _ref2 = scripting_utils_slicedToArray(_ref, 4),
        c = _ref2[0],
        y = _ref2[1],
        m = _ref2[2],
        k = _ref2[3];
      return ["G", 1 - Math.min(1, 0.3 * c + 0.59 * m + 0.11 * y + k)];
    }
  }, {
    key: "G_CMYK",
    value: function G_CMYK(_ref3) {
      var _ref4 = scripting_utils_slicedToArray(_ref3, 1),
        g = _ref4[0];
      return ["CMYK", 0, 0, 0, 1 - g];
    }
  }, {
    key: "G_RGB",
    value: function G_RGB(_ref5) {
      var _ref6 = scripting_utils_slicedToArray(_ref5, 1),
        g = _ref6[0];
      return ["RGB", g, g, g];
    }
  }, {
    key: "G_rgb",
    value: function G_rgb(_ref7) {
      var _ref8 = scripting_utils_slicedToArray(_ref7, 1),
        g = _ref8[0];
      g = scaleAndClamp(g);
      return [g, g, g];
    }
  }, {
    key: "G_HTML",
    value: function G_HTML(_ref9) {
      var _ref10 = scripting_utils_slicedToArray(_ref9, 1),
        g = _ref10[0];
      var G = makeColorComp(g);
      return "#".concat(G).concat(G).concat(G);
    }
  }, {
    key: "RGB_G",
    value: function RGB_G(_ref11) {
      var _ref12 = scripting_utils_slicedToArray(_ref11, 3),
        r = _ref12[0],
        g = _ref12[1],
        b = _ref12[2];
      return ["G", 0.3 * r + 0.59 * g + 0.11 * b];
    }
  }, {
    key: "RGB_rgb",
    value: function RGB_rgb(color) {
      return color.map(scaleAndClamp);
    }
  }, {
    key: "RGB_HTML",
    value: function RGB_HTML(color) {
      return "#".concat(color.map(makeColorComp).join(""));
    }
  }, {
    key: "T_HTML",
    value: function T_HTML() {
      return "#00000000";
    }
  }, {
    key: "T_rgb",
    value: function T_rgb() {
      return [null];
    }
  }, {
    key: "CMYK_RGB",
    value: function CMYK_RGB(_ref13) {
      var _ref14 = scripting_utils_slicedToArray(_ref13, 4),
        c = _ref14[0],
        y = _ref14[1],
        m = _ref14[2],
        k = _ref14[3];
      return ["RGB", 1 - Math.min(1, c + k), 1 - Math.min(1, m + k), 1 - Math.min(1, y + k)];
    }
  }, {
    key: "CMYK_rgb",
    value: function CMYK_rgb(_ref15) {
      var _ref16 = scripting_utils_slicedToArray(_ref15, 4),
        c = _ref16[0],
        y = _ref16[1],
        m = _ref16[2],
        k = _ref16[3];
      return [scaleAndClamp(1 - Math.min(1, c + k)), scaleAndClamp(1 - Math.min(1, m + k)), scaleAndClamp(1 - Math.min(1, y + k))];
    }
  }, {
    key: "CMYK_HTML",
    value: function CMYK_HTML(components) {
      var rgb = this.CMYK_RGB(components).slice(1);
      return this.RGB_HTML(rgb);
    }
  }, {
    key: "RGB_CMYK",
    value: function RGB_CMYK(_ref17) {
      var _ref18 = scripting_utils_slicedToArray(_ref17, 3),
        r = _ref18[0],
        g = _ref18[1],
        b = _ref18[2];
      var c = 1 - r;
      var m = 1 - g;
      var y = 1 - b;
      var k = Math.min(c, m, y);
      return ["CMYK", c, m, y, k];
    }
  }]);
}();

;// ./src/display/svg_factory.js
function svg_factory_callSuper(t, o, e) { return o = svg_factory_getPrototypeOf(o), svg_factory_possibleConstructorReturn(t, svg_factory_isNativeReflectConstruct() ? Reflect.construct(o, e || [], svg_factory_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function svg_factory_possibleConstructorReturn(t, e) { if (e && ("object" == svg_factory_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return svg_factory_assertThisInitialized(t); }
function svg_factory_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function svg_factory_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (svg_factory_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function svg_factory_getPrototypeOf(t) { return svg_factory_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, svg_factory_getPrototypeOf(t); }
function svg_factory_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && svg_factory_setPrototypeOf(t, e); }
function svg_factory_setPrototypeOf(t, e) { return svg_factory_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, svg_factory_setPrototypeOf(t, e); }
function svg_factory_typeof(o) { "@babel/helpers - typeof"; return svg_factory_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, svg_factory_typeof(o); }
















function svg_factory_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function svg_factory_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, svg_factory_toPropertyKey(o.key), o); } }
function svg_factory_createClass(e, r, t) { return r && svg_factory_defineProperties(e.prototype, r), t && svg_factory_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function svg_factory_toPropertyKey(t) { var i = svg_factory_toPrimitive(t, "string"); return "symbol" == svg_factory_typeof(i) ? i : i + ""; }
function svg_factory_toPrimitive(t, r) { if ("object" != svg_factory_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != svg_factory_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }


var BaseSVGFactory = /*#__PURE__*/function () {
  function BaseSVGFactory() {
    svg_factory_classCallCheck(this, BaseSVGFactory);
  }
  return svg_factory_createClass(BaseSVGFactory, [{
    key: "create",
    value: function create(width, height) {
      var skipDimensions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (width <= 0 || height <= 0) {
        throw new Error("Invalid SVG dimensions");
      }
      var svg = this._createSVG("svg:svg");
      svg.setAttribute("version", "1.1");
      if (!skipDimensions) {
        svg.setAttribute("width", "".concat(width, "px"));
        svg.setAttribute("height", "".concat(height, "px"));
      }
      svg.setAttribute("preserveAspectRatio", "none");
      svg.setAttribute("viewBox", "0 0 ".concat(width, " ").concat(height));
      return svg;
    }
  }, {
    key: "createElement",
    value: function createElement(type) {
      if (typeof type !== "string") {
        throw new Error("Invalid SVG element type");
      }
      return this._createSVG(type);
    }
  }, {
    key: "_createSVG",
    value: function _createSVG(type) {
      unreachable("Abstract method `_createSVG` called.");
    }
  }]);
}();
var DOMSVGFactory = /*#__PURE__*/function (_BaseSVGFactory) {
  function DOMSVGFactory() {
    svg_factory_classCallCheck(this, DOMSVGFactory);
    return svg_factory_callSuper(this, DOMSVGFactory, arguments);
  }
  svg_factory_inherits(DOMSVGFactory, _BaseSVGFactory);
  return svg_factory_createClass(DOMSVGFactory, [{
    key: "_createSVG",
    value: function _createSVG(type) {
      return document.createElementNS(SVG_NS, type);
    }
  }]);
}(BaseSVGFactory);

;// ./src/display/xfa_layer.js
function xfa_layer_typeof(o) { "@babel/helpers - typeof"; return xfa_layer_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, xfa_layer_typeof(o); }
function xfa_layer_slicedToArray(r, e) { return xfa_layer_arrayWithHoles(r) || xfa_layer_iterableToArrayLimit(r, e) || xfa_layer_unsupportedIterableToArray(r, e) || xfa_layer_nonIterableRest(); }
function xfa_layer_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function xfa_layer_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function xfa_layer_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
























function xfa_layer_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = xfa_layer_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function xfa_layer_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return xfa_layer_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? xfa_layer_arrayLikeToArray(r, a) : void 0; } }
function xfa_layer_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function xfa_layer_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function xfa_layer_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, xfa_layer_toPropertyKey(o.key), o); } }
function xfa_layer_createClass(e, r, t) { return r && xfa_layer_defineProperties(e.prototype, r), t && xfa_layer_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function xfa_layer_toPropertyKey(t) { var i = xfa_layer_toPrimitive(t, "string"); return "symbol" == xfa_layer_typeof(i) ? i : i + ""; }
function xfa_layer_toPrimitive(t, r) { if ("object" != xfa_layer_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != xfa_layer_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

var XfaLayer = /*#__PURE__*/function () {
  function XfaLayer() {
    xfa_layer_classCallCheck(this, XfaLayer);
  }
  return xfa_layer_createClass(XfaLayer, null, [{
    key: "setupStorage",
    value: function setupStorage(html, id, element, storage, intent) {
      var storedData = storage.getValue(id, {
        value: null
      });
      switch (element.name) {
        case "textarea":
          if (storedData.value !== null) {
            html.textContent = storedData.value;
          }
          if (intent === "print") {
            break;
          }
          html.addEventListener("input", function (event) {
            storage.setValue(id, {
              value: event.target.value
            });
          });
          break;
        case "input":
          if (element.attributes.type === "radio" || element.attributes.type === "checkbox") {
            if (storedData.value === element.attributes.xfaOn) {
              html.setAttribute("checked", true);
            } else if (storedData.value === element.attributes.xfaOff) {
              html.removeAttribute("checked");
            }
            if (intent === "print") {
              break;
            }
            html.addEventListener("change", function (event) {
              storage.setValue(id, {
                value: event.target.checked ? event.target.getAttribute("xfaOn") : event.target.getAttribute("xfaOff")
              });
            });
          } else {
            if (storedData.value !== null) {
              html.setAttribute("value", storedData.value);
            }
            if (intent === "print") {
              break;
            }
            html.addEventListener("input", function (event) {
              storage.setValue(id, {
                value: event.target.value
              });
            });
          }
          break;
        case "select":
          if (storedData.value !== null) {
            html.setAttribute("value", storedData.value);
            var _iterator = xfa_layer_createForOfIteratorHelper(element.children),
              _step;
            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var option = _step.value;
                if (option.attributes.value === storedData.value) {
                  option.attributes.selected = true;
                } else if (option.attributes.hasOwnProperty("selected")) {
                  delete option.attributes.selected;
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
          }
          html.addEventListener("input", function (event) {
            var options = event.target.options;
            var value = options.selectedIndex === -1 ? "" : options[options.selectedIndex].value;
            storage.setValue(id, {
              value: value
            });
          });
          break;
      }
    }
  }, {
    key: "setAttributes",
    value: function setAttributes(_ref) {
      var html = _ref.html,
        element = _ref.element,
        _ref$storage = _ref.storage,
        storage = _ref$storage === void 0 ? null : _ref$storage,
        intent = _ref.intent,
        linkService = _ref.linkService;
      var attributes = element.attributes;
      var isHTMLAnchorElement = html instanceof HTMLAnchorElement;
      if (attributes.type === "radio") {
        attributes.name = "".concat(attributes.name, "-").concat(intent);
      }
      for (var _i = 0, _Object$entries = Object.entries(attributes); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = xfa_layer_slicedToArray(_Object$entries[_i], 2),
          key = _Object$entries$_i[0],
          value = _Object$entries$_i[1];
        if (value === null || value === undefined) {
          continue;
        }
        switch (key) {
          case "class":
            if (value.length) {
              html.setAttribute(key, value.join(" "));
            }
            break;
          case "dataId":
            break;
          case "id":
            html.setAttribute("data-element-id", value);
            break;
          case "style":
            Object.assign(html.style, value);
            break;
          case "textContent":
            html.textContent = value;
            break;
          default:
            if (!isHTMLAnchorElement || key !== "href" && key !== "newWindow") {
              html.setAttribute(key, value);
            }
        }
      }
      if (isHTMLAnchorElement) {
        linkService.addLinkAttributes(html, attributes.href, attributes.newWindow);
      }
      if (storage && attributes.dataId) {
        this.setupStorage(html, attributes.dataId, element, storage);
      }
    }
  }, {
    key: "render",
    value: function render(parameters) {
      var storage = parameters.annotationStorage;
      var linkService = parameters.linkService;
      var root = parameters.xfaHtml;
      var intent = parameters.intent || "display";
      var rootHtml = document.createElement(root.name);
      if (root.attributes) {
        this.setAttributes({
          html: rootHtml,
          element: root,
          intent: intent,
          linkService: linkService
        });
      }
      var isNotForRichText = intent !== "richText";
      var rootDiv = parameters.div;
      rootDiv.append(rootHtml);
      if (parameters.viewport) {
        var transform = "matrix(".concat(parameters.viewport.transform.join(","), ")");
        rootDiv.style.transform = transform;
      }
      if (isNotForRichText) {
        rootDiv.setAttribute("class", "xfaLayer xfaFont");
      }
      var textDivs = [];
      if (root.children.length === 0) {
        if (root.value) {
          var node = document.createTextNode(root.value);
          rootHtml.append(node);
          if (isNotForRichText && XfaText.shouldBuildText(root.name)) {
            textDivs.push(node);
          }
        }
        return {
          textDivs: textDivs
        };
      }
      var stack = [[root, -1, rootHtml]];
      while (stack.length > 0) {
        var _child$attributes, _child$children;
        var _stack$at = stack.at(-1),
          _stack$at2 = xfa_layer_slicedToArray(_stack$at, 3),
          parent = _stack$at2[0],
          i = _stack$at2[1],
          html = _stack$at2[2];
        if (i + 1 === parent.children.length) {
          stack.pop();
          continue;
        }
        var child = parent.children[++stack.at(-1)[1]];
        if (child === null) {
          continue;
        }
        var name = child.name;
        if (name === "#text") {
          var _node = document.createTextNode(child.value);
          textDivs.push(_node);
          html.append(_node);
          continue;
        }
        var childHtml = child !== null && child !== void 0 && (_child$attributes = child.attributes) !== null && _child$attributes !== void 0 && _child$attributes.xmlns ? document.createElementNS(child.attributes.xmlns, name) : document.createElement(name);
        html.append(childHtml);
        if (child.attributes) {
          this.setAttributes({
            html: childHtml,
            element: child,
            storage: storage,
            intent: intent,
            linkService: linkService
          });
        }
        if (((_child$children = child.children) === null || _child$children === void 0 ? void 0 : _child$children.length) > 0) {
          stack.push([child, -1, childHtml]);
        } else if (child.value) {
          var _node2 = document.createTextNode(child.value);
          if (isNotForRichText && XfaText.shouldBuildText(name)) {
            textDivs.push(_node2);
          }
          childHtml.append(_node2);
        }
      }
      var _iterator2 = xfa_layer_createForOfIteratorHelper(rootDiv.querySelectorAll(".xfaNonInteractive input, .xfaNonInteractive textarea")),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var el = _step2.value;
          el.setAttribute("readOnly", true);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return {
        textDivs: textDivs
      };
    }
  }, {
    key: "update",
    value: function update(parameters) {
      var transform = "matrix(".concat(parameters.viewport.transform.join(","), ")");
      parameters.div.style.transform = transform;
      parameters.div.hidden = false;
    }
  }]);
}();

;// ./src/display/annotation_layer.js
function annotation_layer_typeof(o) { "@babel/helpers - typeof"; return annotation_layer_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, annotation_layer_typeof(o); }
function annotation_layer_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function annotation_layer_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? annotation_layer_ownKeys(Object(t), !0).forEach(function (r) { annotation_layer_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : annotation_layer_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function annotation_layer_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ annotation_layer_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == annotation_layer_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(annotation_layer_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function annotation_layer_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function annotation_layer_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { annotation_layer_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { annotation_layer_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function _toSetter(t, e, n) { e || (e = []); var r = e.length++; return Object.defineProperty({}, "_", { set: function set(o) { e[r] = o, t.apply(n, e); } }); }
function annotation_layer_classPrivateGetter(s, r, a) { return a(annotation_layer_assertClassBrand(s, r)); }
function _superPropGet(t, o, e, r) { var p = annotation_layer_get(annotation_layer_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function annotation_layer_get() { return annotation_layer_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = _superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, annotation_layer_get.apply(null, arguments); }
function _superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = annotation_layer_getPrototypeOf(t));); return t; }
function annotation_layer_toConsumableArray(r) { return annotation_layer_arrayWithoutHoles(r) || annotation_layer_iterableToArray(r) || annotation_layer_unsupportedIterableToArray(r) || annotation_layer_nonIterableSpread(); }
function annotation_layer_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function annotation_layer_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function annotation_layer_arrayWithoutHoles(r) { if (Array.isArray(r)) return annotation_layer_arrayLikeToArray(r); }
function annotation_layer_callSuper(t, o, e) { return o = annotation_layer_getPrototypeOf(o), annotation_layer_possibleConstructorReturn(t, annotation_layer_isNativeReflectConstruct() ? Reflect.construct(o, e || [], annotation_layer_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function annotation_layer_possibleConstructorReturn(t, e) { if (e && ("object" == annotation_layer_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return annotation_layer_assertThisInitialized(t); }
function annotation_layer_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function annotation_layer_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (annotation_layer_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function annotation_layer_getPrototypeOf(t) { return annotation_layer_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, annotation_layer_getPrototypeOf(t); }
function annotation_layer_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && annotation_layer_setPrototypeOf(t, e); }
function annotation_layer_setPrototypeOf(t, e) { return annotation_layer_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, annotation_layer_setPrototypeOf(t, e); }
function annotation_layer_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = annotation_layer_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function annotation_layer_slicedToArray(r, e) { return annotation_layer_arrayWithHoles(r) || annotation_layer_iterableToArrayLimit(r, e) || annotation_layer_unsupportedIterableToArray(r, e) || annotation_layer_nonIterableRest(); }
function annotation_layer_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function annotation_layer_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return annotation_layer_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? annotation_layer_arrayLikeToArray(r, a) : void 0; } }
function annotation_layer_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function annotation_layer_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function annotation_layer_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function annotation_layer_readOnlyError(r) { throw new TypeError('"' + r + '" is read-only'); }
function annotation_layer_defineProperty(e, r, t) { return (r = annotation_layer_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function annotation_layer_classPrivateMethodInitSpec(e, a) { annotation_layer_checkPrivateRedeclaration(e, a), a.add(e); }
function annotation_layer_classPrivateFieldInitSpec(e, t, a) { annotation_layer_checkPrivateRedeclaration(e, t), t.set(e, a); }
function annotation_layer_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function annotation_layer_classPrivateFieldSet(s, a, r) { return s.set(annotation_layer_assertClassBrand(s, a), r), r; }
function annotation_layer_classPrivateFieldGet(s, a) { return s.get(annotation_layer_assertClassBrand(s, a)); }
function annotation_layer_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }
function annotation_layer_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function annotation_layer_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, annotation_layer_toPropertyKey(o.key), o); } }
function annotation_layer_createClass(e, r, t) { return r && annotation_layer_defineProperties(e.prototype, r), t && annotation_layer_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function annotation_layer_toPropertyKey(t) { var i = annotation_layer_toPrimitive(t, "string"); return "symbol" == annotation_layer_typeof(i) ? i : i + ""; }
function annotation_layer_toPrimitive(t, r) { if ("object" != annotation_layer_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != annotation_layer_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }












































































var DEFAULT_TAB_INDEX = 1000;
var annotation_layer_DEFAULT_FONT_SIZE = 9;
var GetElementsByNameSet = new WeakSet();
function getRectDims(rect) {
  return {
    width: rect[2] - rect[0],
    height: rect[3] - rect[1]
  };
}
var AnnotationElementFactory = /*#__PURE__*/function () {
  function AnnotationElementFactory() {
    annotation_layer_classCallCheck(this, AnnotationElementFactory);
  }
  return annotation_layer_createClass(AnnotationElementFactory, null, [{
    key: "create",
    value: function create(parameters) {
      var subtype = parameters.data.annotationType;
      switch (subtype) {
        case AnnotationType.LINK:
          return new LinkAnnotationElement(parameters);
        case AnnotationType.TEXT:
          return new TextAnnotationElement(parameters);
        case AnnotationType.WIDGET:
          var fieldType = parameters.data.fieldType;
          switch (fieldType) {
            case "Tx":
              return new TextWidgetAnnotationElement(parameters);
            case "Btn":
              if (parameters.data.radioButton) {
                return new RadioButtonWidgetAnnotationElement(parameters);
              } else if (parameters.data.checkBox) {
                return new CheckboxWidgetAnnotationElement(parameters);
              }
              return new PushButtonWidgetAnnotationElement(parameters);
            case "Ch":
              return new ChoiceWidgetAnnotationElement(parameters);
            case "Sig":
              return new SignatureWidgetAnnotationElement(parameters);
          }
          return new WidgetAnnotationElement(parameters);
        case AnnotationType.POPUP:
          return new PopupAnnotationElement(parameters);
        case AnnotationType.FREETEXT:
          return new FreeTextAnnotationElement(parameters);
        case AnnotationType.LINE:
          return new LineAnnotationElement(parameters);
        case AnnotationType.SQUARE:
          return new SquareAnnotationElement(parameters);
        case AnnotationType.CIRCLE:
          return new CircleAnnotationElement(parameters);
        case AnnotationType.POLYLINE:
          return new PolylineAnnotationElement(parameters);
        case AnnotationType.CARET:
          return new CaretAnnotationElement(parameters);
        case AnnotationType.INK:
          return new InkAnnotationElement(parameters);
        case AnnotationType.POLYGON:
          return new PolygonAnnotationElement(parameters);
        case AnnotationType.HIGHLIGHT:
          return new HighlightAnnotationElement(parameters);
        case AnnotationType.UNDERLINE:
          return new UnderlineAnnotationElement(parameters);
        case AnnotationType.SQUIGGLY:
          return new SquigglyAnnotationElement(parameters);
        case AnnotationType.STRIKEOUT:
          return new StrikeOutAnnotationElement(parameters);
        case AnnotationType.STAMP:
          return new StampAnnotationElement(parameters);
        case AnnotationType.FILEATTACHMENT:
          return new FileAttachmentAnnotationElement(parameters);
        default:
          return new AnnotationElement(parameters);
      }
    }
  }]);
}();
var _updates = /*#__PURE__*/new WeakMap();
var _hasBorder = /*#__PURE__*/new WeakMap();
var _popupElement = /*#__PURE__*/new WeakMap();
var _AnnotationElement_brand = /*#__PURE__*/new WeakSet();
var AnnotationElement = /*#__PURE__*/function () {
  function AnnotationElement(parameters) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$isRenderable = _ref.isRenderable,
      isRenderable = _ref$isRenderable === void 0 ? false : _ref$isRenderable,
      _ref$ignoreBorder = _ref.ignoreBorder,
      ignoreBorder = _ref$ignoreBorder === void 0 ? false : _ref$ignoreBorder,
      _ref$createQuadrilate = _ref.createQuadrilaterals,
      createQuadrilaterals = _ref$createQuadrilate === void 0 ? false : _ref$createQuadrilate;
    annotation_layer_classCallCheck(this, AnnotationElement);
    annotation_layer_classPrivateMethodInitSpec(this, _AnnotationElement_brand);
    annotation_layer_classPrivateFieldInitSpec(this, _updates, null);
    annotation_layer_classPrivateFieldInitSpec(this, _hasBorder, false);
    annotation_layer_classPrivateFieldInitSpec(this, _popupElement, null);
    this.isRenderable = isRenderable;
    this.data = parameters.data;
    this.layer = parameters.layer;
    this.linkService = parameters.linkService;
    this.downloadManager = parameters.downloadManager;
    this.imageResourcesPath = parameters.imageResourcesPath;
    this.renderForms = parameters.renderForms;
    this.svgFactory = parameters.svgFactory;
    this.annotationStorage = parameters.annotationStorage;
    this.enableScripting = parameters.enableScripting;
    this.hasJSActions = parameters.hasJSActions;
    this._fieldObjects = parameters.fieldObjects;
    this.parent = parameters.parent;
    if (isRenderable) {
      this.container = this._createContainer(ignoreBorder);
    }
    if (createQuadrilaterals) {
      this._createQuadrilaterals();
    }
  }
  return annotation_layer_createClass(AnnotationElement, [{
    key: "_isEditable",
    get: function get() {
      return this.data.isEditable;
    }
  }, {
    key: "hasPopupData",
    get: function get() {
      return AnnotationElement._hasPopupData(this.data);
    }
  }, {
    key: "updateEdited",
    value: function updateEdited(params) {
      var _classPrivateFieldGet2;
      if (!this.container) {
        return;
      }
      annotation_layer_classPrivateFieldGet(_updates, this) || annotation_layer_classPrivateFieldSet(_updates, this, {
        rect: this.data.rect.slice(0)
      });
      var rect = params.rect;
      if (rect) {
        annotation_layer_assertClassBrand(_AnnotationElement_brand, this, _setRectEdited).call(this, rect);
      }
      (_classPrivateFieldGet2 = annotation_layer_classPrivateFieldGet(_popupElement, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.popup.updateEdited(params);
    }
  }, {
    key: "resetEdited",
    value: function resetEdited() {
      var _classPrivateFieldGet3;
      if (!annotation_layer_classPrivateFieldGet(_updates, this)) {
        return;
      }
      annotation_layer_assertClassBrand(_AnnotationElement_brand, this, _setRectEdited).call(this, annotation_layer_classPrivateFieldGet(_updates, this).rect);
      (_classPrivateFieldGet3 = annotation_layer_classPrivateFieldGet(_popupElement, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.popup.resetEdited();
      annotation_layer_classPrivateFieldSet(_updates, this, null);
    }
  }, {
    key: "_createContainer",
    value: function _createContainer(ignoreBorder) {
      var data = this.data,
        _this$parent = this.parent,
        page = _this$parent.page,
        viewport = _this$parent.viewport;
      var container = document.createElement("section");
      container.setAttribute("data-annotation-id", data.id);
      if (!(this instanceof WidgetAnnotationElement)) {
        container.tabIndex = DEFAULT_TAB_INDEX;
      }
      var style = container.style;
      style.zIndex = this.parent.zIndex++;
      if (data.alternativeText) {
        container.title = data.alternativeText;
      }
      if (data.noRotate) {
        container.classList.add("norotate");
      }
      if (!data.rect || this instanceof PopupAnnotationElement) {
        var _rotation = data.rotation;
        if (!data.hasOwnCanvas && _rotation !== 0) {
          this.setRotation(_rotation, container);
        }
        return container;
      }
      var _getRectDims = getRectDims(data.rect),
        width = _getRectDims.width,
        height = _getRectDims.height;
      if (!ignoreBorder && data.borderStyle.width > 0) {
        style.borderWidth = "".concat(data.borderStyle.width, "px");
        var horizontalRadius = data.borderStyle.horizontalCornerRadius;
        var verticalRadius = data.borderStyle.verticalCornerRadius;
        if (horizontalRadius > 0 || verticalRadius > 0) {
          var radius = "calc(".concat(horizontalRadius, "px * var(--scale-factor)) / calc(").concat(verticalRadius, "px * var(--scale-factor))");
          style.borderRadius = radius;
        } else if (this instanceof RadioButtonWidgetAnnotationElement) {
          var _radius = "calc(".concat(width, "px * var(--scale-factor)) / calc(").concat(height, "px * var(--scale-factor))");
          style.borderRadius = _radius;
        }
        switch (data.borderStyle.style) {
          case AnnotationBorderStyleType.SOLID:
            style.borderStyle = "solid";
            break;
          case AnnotationBorderStyleType.DASHED:
            style.borderStyle = "dashed";
            break;
          case AnnotationBorderStyleType.BEVELED:
            warn("Unimplemented border style: beveled");
            break;
          case AnnotationBorderStyleType.INSET:
            warn("Unimplemented border style: inset");
            break;
          case AnnotationBorderStyleType.UNDERLINE:
            style.borderBottomStyle = "solid";
            break;
          default:
            break;
        }
        var borderColor = data.borderColor || null;
        if (borderColor) {
          annotation_layer_classPrivateFieldSet(_hasBorder, this, true);
          style.borderColor = Util.makeHexColor(borderColor[0] | 0, borderColor[1] | 0, borderColor[2] | 0);
        } else {
          style.borderWidth = 0;
        }
      }
      var rect = Util.normalizeRect([data.rect[0], page.view[3] - data.rect[1] + page.view[1], data.rect[2], page.view[3] - data.rect[3] + page.view[1]]);
      var _viewport$rawDims = viewport.rawDims,
        pageWidth = _viewport$rawDims.pageWidth,
        pageHeight = _viewport$rawDims.pageHeight,
        pageX = _viewport$rawDims.pageX,
        pageY = _viewport$rawDims.pageY;
      style.left = "".concat(100 * (rect[0] - pageX) / pageWidth, "%");
      style.top = "".concat(100 * (rect[1] - pageY) / pageHeight, "%");
      var rotation = data.rotation;
      if (data.hasOwnCanvas || rotation === 0) {
        style.width = "".concat(100 * width / pageWidth, "%");
        style.height = "".concat(100 * height / pageHeight, "%");
      } else {
        this.setRotation(rotation, container);
      }
      return container;
    }
  }, {
    key: "setRotation",
    value: function setRotation(angle) {
      var container = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.container;
      if (!this.data.rect) {
        return;
      }
      var _this$parent$viewport = this.parent.viewport.rawDims,
        pageWidth = _this$parent$viewport.pageWidth,
        pageHeight = _this$parent$viewport.pageHeight;
      var _getRectDims2 = getRectDims(this.data.rect),
        width = _getRectDims2.width,
        height = _getRectDims2.height;
      var elementWidth, elementHeight;
      if (angle % 180 === 0) {
        elementWidth = 100 * width / pageWidth;
        elementHeight = 100 * height / pageHeight;
      } else {
        elementWidth = 100 * height / pageWidth;
        elementHeight = 100 * width / pageHeight;
      }
      container.style.width = "".concat(elementWidth, "%");
      container.style.height = "".concat(elementHeight, "%");
      container.setAttribute("data-main-rotation", (360 - angle) % 360);
    }
  }, {
    key: "_commonActions",
    get: function get() {
      var _this = this;
      var setColor = function setColor(jsName, styleName, event) {
        var color = event.detail[jsName];
        var colorType = color[0];
        var colorArray = color.slice(1);
        event.target.style[styleName] = ColorConverters["".concat(colorType, "_HTML")](colorArray);
        _this.annotationStorage.setValue(_this.data.id, annotation_layer_defineProperty({}, styleName, ColorConverters["".concat(colorType, "_rgb")](colorArray)));
      };
      return shadow(this, "_commonActions", {
        display: function display(event) {
          var display = event.detail.display;
          var hidden = display % 2 === 1;
          _this.container.style.visibility = hidden ? "hidden" : "visible";
          _this.annotationStorage.setValue(_this.data.id, {
            noView: hidden,
            noPrint: display === 1 || display === 2
          });
        },
        print: function print(event) {
          _this.annotationStorage.setValue(_this.data.id, {
            noPrint: !event.detail.print
          });
        },
        hidden: function hidden(event) {
          var hidden = event.detail.hidden;
          _this.container.style.visibility = hidden ? "hidden" : "visible";
          _this.annotationStorage.setValue(_this.data.id, {
            noPrint: hidden,
            noView: hidden
          });
        },
        focus: function focus(event) {
          setTimeout(function () {
            return event.target.focus({
              preventScroll: false
            });
          }, 0);
        },
        userName: function userName(event) {
          event.target.title = event.detail.userName;
        },
        readonly: function readonly(event) {
          event.target.disabled = event.detail.readonly;
        },
        required: function required(event) {
          _this._setRequired(event.target, event.detail.required);
        },
        bgColor: function bgColor(event) {
          setColor("bgColor", "backgroundColor", event);
        },
        fillColor: function fillColor(event) {
          setColor("fillColor", "backgroundColor", event);
        },
        fgColor: function fgColor(event) {
          setColor("fgColor", "color", event);
        },
        textColor: function textColor(event) {
          setColor("textColor", "color", event);
        },
        borderColor: function borderColor(event) {
          setColor("borderColor", "borderColor", event);
        },
        strokeColor: function strokeColor(event) {
          setColor("strokeColor", "borderColor", event);
        },
        rotation: function rotation(event) {
          var angle = event.detail.rotation;
          _this.setRotation(angle);
          _this.annotationStorage.setValue(_this.data.id, {
            rotation: angle
          });
        }
      });
    }
  }, {
    key: "_dispatchEventFromSandbox",
    value: function _dispatchEventFromSandbox(actions, jsEvent) {
      var commonActions = this._commonActions;
      for (var _i = 0, _Object$keys = Object.keys(jsEvent.detail); _i < _Object$keys.length; _i++) {
        var name = _Object$keys[_i];
        var action = actions[name] || commonActions[name];
        action === null || action === void 0 || action(jsEvent);
      }
    }
  }, {
    key: "_setDefaultPropertiesFromJS",
    value: function _setDefaultPropertiesFromJS(element) {
      if (!this.enableScripting) {
        return;
      }
      var storedData = this.annotationStorage.getRawValue(this.data.id);
      if (!storedData) {
        return;
      }
      var commonActions = this._commonActions;
      for (var _i2 = 0, _Object$entries = Object.entries(storedData); _i2 < _Object$entries.length; _i2++) {
        var _Object$entries$_i = annotation_layer_slicedToArray(_Object$entries[_i2], 2),
          actionName = _Object$entries$_i[0],
          detail = _Object$entries$_i[1];
        var action = commonActions[actionName];
        if (action) {
          var eventProxy = {
            detail: annotation_layer_defineProperty({}, actionName, detail),
            target: element
          };
          action(eventProxy);
          delete storedData[actionName];
        }
      }
    }
  }, {
    key: "_createQuadrilaterals",
    value: function _createQuadrilaterals() {
      if (!this.container) {
        return;
      }
      var quadPoints = this.data.quadPoints;
      if (!quadPoints) {
        return;
      }
      var _this$data$rect$map = this.data.rect.map(function (x) {
          return Math.fround(x);
        }),
        _this$data$rect$map2 = annotation_layer_slicedToArray(_this$data$rect$map, 4),
        rectBlX = _this$data$rect$map2[0],
        rectBlY = _this$data$rect$map2[1],
        rectTrX = _this$data$rect$map2[2],
        rectTrY = _this$data$rect$map2[3];
      if (quadPoints.length === 8) {
        var _quadPoints$subarray = quadPoints.subarray(2, 6),
          _quadPoints$subarray2 = annotation_layer_slicedToArray(_quadPoints$subarray, 4),
          trX = _quadPoints$subarray2[0],
          trY = _quadPoints$subarray2[1],
          blX = _quadPoints$subarray2[2],
          blY = _quadPoints$subarray2[3];
        if (rectTrX === trX && rectTrY === trY && rectBlX === blX && rectBlY === blY) {
          return;
        }
      }
      var style = this.container.style;
      var svgBuffer;
      if (annotation_layer_classPrivateFieldGet(_hasBorder, this)) {
        var borderColor = style.borderColor,
          borderWidth = style.borderWidth;
        style.borderWidth = 0;
        svgBuffer = ["url('data:image/svg+xml;utf8,", "<svg xmlns=\"http://www.w3.org/2000/svg\"", " preserveAspectRatio=\"none\" viewBox=\"0 0 1 1\">", "<g fill=\"transparent\" stroke=\"".concat(borderColor, "\" stroke-width=\"").concat(borderWidth, "\">")];
        this.container.classList.add("hasBorder");
      }
      var width = rectTrX - rectBlX;
      var height = rectTrY - rectBlY;
      var svgFactory = this.svgFactory;
      var svg = svgFactory.createElement("svg");
      svg.classList.add("quadrilateralsContainer");
      svg.setAttribute("width", 0);
      svg.setAttribute("height", 0);
      var defs = svgFactory.createElement("defs");
      svg.append(defs);
      var clipPath = svgFactory.createElement("clipPath");
      var id = "clippath_".concat(this.data.id);
      clipPath.setAttribute("id", id);
      clipPath.setAttribute("clipPathUnits", "objectBoundingBox");
      defs.append(clipPath);
      for (var i = 2, ii = quadPoints.length; i < ii; i += 8) {
        var _svgBuffer;
        var _trX = quadPoints[i];
        var _trY = quadPoints[i + 1];
        var _blX = quadPoints[i + 2];
        var _blY = quadPoints[i + 3];
        var rect = svgFactory.createElement("rect");
        var x = (_blX - rectBlX) / width;
        var y = (rectTrY - _trY) / height;
        var rectWidth = (_trX - _blX) / width;
        var rectHeight = (_trY - _blY) / height;
        rect.setAttribute("x", x);
        rect.setAttribute("y", y);
        rect.setAttribute("width", rectWidth);
        rect.setAttribute("height", rectHeight);
        clipPath.append(rect);
        (_svgBuffer = svgBuffer) === null || _svgBuffer === void 0 || _svgBuffer.push("<rect vector-effect=\"non-scaling-stroke\" x=\"".concat(x, "\" y=\"").concat(y, "\" width=\"").concat(rectWidth, "\" height=\"").concat(rectHeight, "\"/>"));
      }
      if (annotation_layer_classPrivateFieldGet(_hasBorder, this)) {
        svgBuffer.push("</g></svg>')");
        style.backgroundImage = svgBuffer.join("");
      }
      this.container.append(svg);
      this.container.style.clipPath = "url(#".concat(id, ")");
    }
  }, {
    key: "_createPopup",
    value: function _createPopup() {
      var data = this.data;
      var popup = annotation_layer_classPrivateFieldSet(_popupElement, this, new PopupAnnotationElement({
        data: {
          color: data.color,
          titleObj: data.titleObj,
          modificationDate: data.modificationDate,
          contentsObj: data.contentsObj,
          richText: data.richText,
          parentRect: data.rect,
          borderStyle: 0,
          id: "popup_".concat(data.id),
          rotation: data.rotation
        },
        parent: this.parent,
        elements: [this]
      }));
      this.parent.div.append(popup.render());
    }
  }, {
    key: "render",
    value: function render() {
      unreachable("Abstract method `AnnotationElement.render` called");
    }
  }, {
    key: "_getElementsByName",
    value: function _getElementsByName(name) {
      var skipId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var fields = [];
      if (this._fieldObjects) {
        var fieldObj = this._fieldObjects[name];
        if (fieldObj) {
          var _iterator = annotation_layer_createForOfIteratorHelper(fieldObj),
            _step;
          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var _step$value = _step.value,
                page = _step$value.page,
                id = _step$value.id,
                exportValues = _step$value.exportValues;
              if (page === -1) {
                continue;
              }
              if (id === skipId) {
                continue;
              }
              var exportValue = typeof exportValues === "string" ? exportValues : null;
              var domElement = document.querySelector("[data-element-id=\"".concat(id, "\"]"));
              if (domElement && !GetElementsByNameSet.has(domElement)) {
                warn("_getElementsByName - element not allowed: ".concat(id));
                continue;
              }
              fields.push({
                id: id,
                exportValue: exportValue,
                domElement: domElement
              });
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
        return fields;
      }
      var _iterator2 = annotation_layer_createForOfIteratorHelper(document.getElementsByName(name)),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _domElement = _step2.value;
          var _exportValue = _domElement.exportValue;
          var _id = _domElement.getAttribute("data-element-id");
          if (_id === skipId) {
            continue;
          }
          if (!GetElementsByNameSet.has(_domElement)) {
            continue;
          }
          fields.push({
            id: _id,
            exportValue: _exportValue,
            domElement: _domElement
          });
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return fields;
    }
  }, {
    key: "show",
    value: function show() {
      var _this$popup;
      if (this.container) {
        this.container.hidden = false;
      }
      (_this$popup = this.popup) === null || _this$popup === void 0 || _this$popup.maybeShow();
    }
  }, {
    key: "hide",
    value: function hide() {
      var _this$popup2;
      if (this.container) {
        this.container.hidden = true;
      }
      (_this$popup2 = this.popup) === null || _this$popup2 === void 0 || _this$popup2.forceHide();
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return this.container;
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      var triggers = this.getElementsToTriggerPopup();
      if (Array.isArray(triggers)) {
        var _iterator3 = annotation_layer_createForOfIteratorHelper(triggers),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var element = _step3.value;
            element.classList.add("highlightArea");
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      } else {
        triggers.classList.add("highlightArea");
      }
    }
  }, {
    key: "_editOnDoubleClick",
    value: function _editOnDoubleClick() {
      var _this2 = this;
      if (!this._isEditable) {
        return;
      }
      var mode = this.annotationEditorType,
        editId = this.data.id;
      this.container.addEventListener("dblclick", function () {
        var _this2$linkService$ev;
        (_this2$linkService$ev = _this2.linkService.eventBus) === null || _this2$linkService$ev === void 0 || _this2$linkService$ev.dispatch("switchannotationeditormode", {
          source: _this2,
          mode: mode,
          editId: editId
        });
      });
    }
  }], [{
    key: "_hasPopupData",
    value: function _hasPopupData(_ref2) {
      var titleObj = _ref2.titleObj,
        contentsObj = _ref2.contentsObj,
        richText = _ref2.richText;
      return !!(titleObj !== null && titleObj !== void 0 && titleObj.str || contentsObj !== null && contentsObj !== void 0 && contentsObj.str || richText !== null && richText !== void 0 && richText.str);
    }
  }]);
}();
function _setRectEdited(rect) {
  var style = this.container.style,
    _this$data3 = this.data,
    currentRect = _this$data3.rect,
    rotation = _this$data3.rotation,
    _this$parent$viewport2 = this.parent.viewport.rawDims,
    pageWidth = _this$parent$viewport2.pageWidth,
    pageHeight = _this$parent$viewport2.pageHeight,
    pageX = _this$parent$viewport2.pageX,
    pageY = _this$parent$viewport2.pageY;
  currentRect === null || currentRect === void 0 || currentRect.splice.apply(currentRect, [0, 4].concat(annotation_layer_toConsumableArray(rect)));
  var _getRectDims8 = getRectDims(rect),
    width = _getRectDims8.width,
    height = _getRectDims8.height;
  style.left = "".concat(100 * (rect[0] - pageX) / pageWidth, "%");
  style.top = "".concat(100 * (pageHeight - rect[3] + pageY) / pageHeight, "%");
  if (rotation === 0) {
    style.width = "".concat(100 * width / pageWidth, "%");
    style.height = "".concat(100 * height / pageHeight, "%");
  } else {
    this.setRotation(rotation);
  }
}
var _LinkAnnotationElement_brand = /*#__PURE__*/new WeakSet();
var LinkAnnotationElement = /*#__PURE__*/function (_AnnotationElement2) {
  function LinkAnnotationElement(parameters) {
    var _this3;
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    annotation_layer_classCallCheck(this, LinkAnnotationElement);
    _this3 = annotation_layer_callSuper(this, LinkAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: !!(options !== null && options !== void 0 && options.ignoreBorder),
      createQuadrilaterals: true
    }]);
    annotation_layer_classPrivateMethodInitSpec(_this3, _LinkAnnotationElement_brand);
    _this3.isTooltipOnly = parameters.data.isTooltipOnly;
    return _this3;
  }
  annotation_layer_inherits(LinkAnnotationElement, _AnnotationElement2);
  return annotation_layer_createClass(LinkAnnotationElement, [{
    key: "render",
    value: function render() {
      var data = this.data,
        linkService = this.linkService;
      var link = document.createElement("a");
      link.setAttribute("data-element-id", data.id);
      var isBound = false;
      if (data.url) {
        linkService.addLinkAttributes(link, data.url, data.newWindow);
        isBound = true;
      } else if (data.action) {
        this._bindNamedAction(link, data.action);
        isBound = true;
      } else if (data.attachment) {
        annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _bindAttachment).call(this, link, data.attachment, data.attachmentDest);
        isBound = true;
      } else if (data.setOCGState) {
        annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _bindSetOCGState).call(this, link, data.setOCGState);
        isBound = true;
      } else if (data.dest) {
        this._bindLink(link, data.dest);
        isBound = true;
      } else {
        if (data.actions && (data.actions.Action || data.actions["Mouse Up"] || data.actions["Mouse Down"]) && this.enableScripting && this.hasJSActions) {
          this._bindJSAction(link, data);
          isBound = true;
        }
        if (data.resetForm) {
          this._bindResetFormAction(link, data.resetForm);
          isBound = true;
        } else if (this.isTooltipOnly && !isBound) {
          this._bindLink(link, "");
          isBound = true;
        }
      }
      this.container.classList.add("linkAnnotation");
      if (isBound) {
        this.container.append(link);
      }
      return this.container;
    }
  }, {
    key: "_bindLink",
    value: function _bindLink(link, destination) {
      var _this4 = this;
      link.href = this.linkService.getDestinationHash(destination);
      link.onclick = function () {
        if (destination) {
          _this4.linkService.goToDestination(destination);
        }
        return false;
      };
      if (destination || destination === "") {
        annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
      }
    }
  }, {
    key: "_bindNamedAction",
    value: function _bindNamedAction(link, action) {
      var _this5 = this;
      link.href = this.linkService.getAnchorUrl("");
      link.onclick = function () {
        _this5.linkService.executeNamedAction(action);
        return false;
      };
      annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
    }
  }, {
    key: "_bindJSAction",
    value: function _bindJSAction(link, data) {
      var _this6 = this;
      link.href = this.linkService.getAnchorUrl("");
      var map = new Map([["Action", "onclick"], ["Mouse Up", "onmouseup"], ["Mouse Down", "onmousedown"]]);
      var _loop = function _loop() {
        var name = _Object$keys2[_i3];
        var jsName = map.get(name);
        if (!jsName) {
          return 1; // continue
        }
        link[jsName] = function () {
          var _this6$linkService$ev;
          (_this6$linkService$ev = _this6.linkService.eventBus) === null || _this6$linkService$ev === void 0 || _this6$linkService$ev.dispatch("dispatcheventinsandbox", {
            source: _this6,
            detail: {
              id: data.id,
              name: name
            }
          });
          return false;
        };
      };
      for (var _i3 = 0, _Object$keys2 = Object.keys(data.actions); _i3 < _Object$keys2.length; _i3++) {
        if (_loop()) continue;
      }
      if (!link.onclick) {
        link.onclick = function () {
          return false;
        };
      }
      annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
    }
  }, {
    key: "_bindResetFormAction",
    value: function _bindResetFormAction(link, resetForm) {
      var _this7 = this;
      var otherClickAction = link.onclick;
      if (!otherClickAction) {
        link.href = this.linkService.getAnchorUrl("");
      }
      annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
      if (!this._fieldObjects) {
        warn("_bindResetFormAction - \"resetForm\" action not supported, " + "ensure that the `fieldObjects` parameter is provided.");
        if (!otherClickAction) {
          link.onclick = function () {
            return false;
          };
        }
        return;
      }
      link.onclick = function () {
        otherClickAction === null || otherClickAction === void 0 || otherClickAction();
        var resetFormFields = resetForm.fields,
          resetFormRefs = resetForm.refs,
          include = resetForm.include;
        var allFields = [];
        if (resetFormFields.length !== 0 || resetFormRefs.length !== 0) {
          var fieldIds = new Set(resetFormRefs);
          var _iterator4 = annotation_layer_createForOfIteratorHelper(resetFormFields),
            _step4;
          try {
            for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
              var fieldName = _step4.value;
              var _fields = _this7._fieldObjects[fieldName] || [];
              var _iterator6 = annotation_layer_createForOfIteratorHelper(_fields),
                _step6;
              try {
                for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                  var id = _step6.value.id;
                  fieldIds.add(id);
                }
              } catch (err) {
                _iterator6.e(err);
              } finally {
                _iterator6.f();
              }
            }
          } catch (err) {
            _iterator4.e(err);
          } finally {
            _iterator4.f();
          }
          for (var _i4 = 0, _Object$values = Object.values(_this7._fieldObjects); _i4 < _Object$values.length; _i4++) {
            var fields = _Object$values[_i4];
            var _iterator5 = annotation_layer_createForOfIteratorHelper(fields),
              _step5;
            try {
              for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                var field = _step5.value;
                if (fieldIds.has(field.id) === include) {
                  allFields.push(field);
                }
              }
            } catch (err) {
              _iterator5.e(err);
            } finally {
              _iterator5.f();
            }
          }
        } else {
          for (var _i5 = 0, _Object$values2 = Object.values(_this7._fieldObjects); _i5 < _Object$values2.length; _i5++) {
            var _fields2 = _Object$values2[_i5];
            allFields.push.apply(allFields, annotation_layer_toConsumableArray(_fields2));
          }
        }
        var storage = _this7.annotationStorage;
        var allIds = [];
        for (var _i6 = 0, _allFields = allFields; _i6 < _allFields.length; _i6++) {
          var _field = _allFields[_i6];
          var _id2 = _field.id;
          allIds.push(_id2);
          switch (_field.type) {
            case "text":
              {
                var value = _field.defaultValue || "";
                storage.setValue(_id2, {
                  value: value
                });
                break;
              }
            case "checkbox":
            case "radiobutton":
              {
                var _value = _field.defaultValue === _field.exportValues;
                storage.setValue(_id2, {
                  value: _value
                });
                break;
              }
            case "combobox":
            case "listbox":
              {
                var _value2 = _field.defaultValue || "";
                storage.setValue(_id2, {
                  value: _value2
                });
                break;
              }
            default:
              continue;
          }
          var domElement = document.querySelector("[data-element-id=\"".concat(_id2, "\"]"));
          if (!domElement) {
            continue;
          } else if (!GetElementsByNameSet.has(domElement)) {
            warn("_bindResetFormAction - element not allowed: ".concat(_id2));
            continue;
          }
          domElement.dispatchEvent(new Event("resetform"));
        }
        if (_this7.enableScripting) {
          var _this7$linkService$ev;
          (_this7$linkService$ev = _this7.linkService.eventBus) === null || _this7$linkService$ev === void 0 || _this7$linkService$ev.dispatch("dispatcheventinsandbox", {
            source: _this7,
            detail: {
              id: "app",
              ids: allIds,
              name: "ResetForm"
            }
          });
        }
        return false;
      };
    }
  }]);
}(AnnotationElement);
function _setInternalLink() {
  this.container.setAttribute("data-internal-link", "");
}
function _bindAttachment(link, attachment) {
  var _this31 = this;
  var dest = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  link.href = this.linkService.getAnchorUrl("");
  if (attachment.description) {
    link.title = attachment.description;
  }
  link.onclick = function () {
    var _this31$downloadManag;
    (_this31$downloadManag = _this31.downloadManager) === null || _this31$downloadManag === void 0 || _this31$downloadManag.openOrDownloadData(attachment.content, attachment.filename, dest);
    return false;
  };
  annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
}
function _bindSetOCGState(link, action) {
  var _this32 = this;
  link.href = this.linkService.getAnchorUrl("");
  link.onclick = function () {
    _this32.linkService.executeSetOCGState(action);
    return false;
  };
  annotation_layer_assertClassBrand(_LinkAnnotationElement_brand, this, _setInternalLink).call(this);
}
var TextAnnotationElement = /*#__PURE__*/function (_AnnotationElement3) {
  function TextAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, TextAnnotationElement);
    return annotation_layer_callSuper(this, TextAnnotationElement, [parameters, {
      isRenderable: true
    }]);
  }
  annotation_layer_inherits(TextAnnotationElement, _AnnotationElement3);
  return annotation_layer_createClass(TextAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("textAnnotation");
      var image = document.createElement("img");
      image.src = this.imageResourcesPath + "annotation-" + this.data.name.toLowerCase() + ".svg";
      image.setAttribute("data-l10n-id", "pdfjs-text-annotation-type");
      image.setAttribute("data-l10n-args", JSON.stringify({
        type: this.data.name
      }));
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.append(image);
      return this.container;
    }
  }]);
}(AnnotationElement);
var WidgetAnnotationElement = /*#__PURE__*/function (_AnnotationElement4) {
  function WidgetAnnotationElement() {
    annotation_layer_classCallCheck(this, WidgetAnnotationElement);
    return annotation_layer_callSuper(this, WidgetAnnotationElement, arguments);
  }
  annotation_layer_inherits(WidgetAnnotationElement, _AnnotationElement4);
  return annotation_layer_createClass(WidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      return this.container;
    }
  }, {
    key: "showElementAndHideCanvas",
    value: function showElementAndHideCanvas(element) {
      if (this.data.hasOwnCanvas) {
        var _element$previousSibl;
        if (((_element$previousSibl = element.previousSibling) === null || _element$previousSibl === void 0 ? void 0 : _element$previousSibl.nodeName) === "CANVAS") {
          element.previousSibling.hidden = true;
        }
        element.hidden = false;
      }
    }
  }, {
    key: "_getKeyModifier",
    value: function _getKeyModifier(event) {
      return util_FeatureTest.platform.isMac ? event.metaKey : event.ctrlKey;
    }
  }, {
    key: "_setEventListener",
    value: function _setEventListener(element, elementData, baseName, eventName, valueGetter) {
      var _this8 = this;
      if (baseName.includes("mouse")) {
        element.addEventListener(baseName, function (event) {
          var _this8$linkService$ev;
          (_this8$linkService$ev = _this8.linkService.eventBus) === null || _this8$linkService$ev === void 0 || _this8$linkService$ev.dispatch("dispatcheventinsandbox", {
            source: _this8,
            detail: {
              id: _this8.data.id,
              name: eventName,
              value: valueGetter(event),
              shift: event.shiftKey,
              modifier: _this8._getKeyModifier(event)
            }
          });
        });
      } else {
        element.addEventListener(baseName, function (event) {
          var _this8$linkService$ev2;
          if (baseName === "blur") {
            if (!elementData.focused || !event.relatedTarget) {
              return;
            }
            elementData.focused = false;
          } else if (baseName === "focus") {
            if (elementData.focused) {
              return;
            }
            elementData.focused = true;
          }
          if (!valueGetter) {
            return;
          }
          (_this8$linkService$ev2 = _this8.linkService.eventBus) === null || _this8$linkService$ev2 === void 0 || _this8$linkService$ev2.dispatch("dispatcheventinsandbox", {
            source: _this8,
            detail: {
              id: _this8.data.id,
              name: eventName,
              value: valueGetter(event)
            }
          });
        });
      }
    }
  }, {
    key: "_setEventListeners",
    value: function _setEventListeners(element, elementData, names, getter) {
      var _iterator7 = annotation_layer_createForOfIteratorHelper(names),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var _this$data$actions;
          var _step7$value = annotation_layer_slicedToArray(_step7.value, 2),
            baseName = _step7$value[0],
            eventName = _step7$value[1];
          if (eventName === "Action" || (_this$data$actions = this.data.actions) !== null && _this$data$actions !== void 0 && _this$data$actions[eventName]) {
            var _this$data$actions2, _this$data$actions3;
            if (eventName === "Focus" || eventName === "Blur") {
              elementData || (elementData = {
                focused: false
              });
            }
            this._setEventListener(element, elementData, baseName, eventName, getter);
            if (eventName === "Focus" && !((_this$data$actions2 = this.data.actions) !== null && _this$data$actions2 !== void 0 && _this$data$actions2.Blur)) {
              this._setEventListener(element, elementData, "blur", "Blur", null);
            } else if (eventName === "Blur" && !((_this$data$actions3 = this.data.actions) !== null && _this$data$actions3 !== void 0 && _this$data$actions3.Focus)) {
              this._setEventListener(element, elementData, "focus", "Focus", null);
            }
          }
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
    }
  }, {
    key: "_setBackgroundColor",
    value: function _setBackgroundColor(element) {
      var color = this.data.backgroundColor || null;
      element.style.backgroundColor = color === null ? "transparent" : Util.makeHexColor(color[0], color[1], color[2]);
    }
  }, {
    key: "_setTextStyle",
    value: function _setTextStyle(element) {
      var TEXT_ALIGNMENT = ["left", "center", "right"];
      var fontColor = this.data.defaultAppearanceData.fontColor;
      var fontSize = this.data.defaultAppearanceData.fontSize || annotation_layer_DEFAULT_FONT_SIZE;
      var style = element.style;
      var computedFontSize;
      var BORDER_SIZE = 2;
      var roundToOneDecimal = function roundToOneDecimal(x) {
        return Math.round(10 * x) / 10;
      };
      if (this.data.multiLine) {
        var height = Math.abs(this.data.rect[3] - this.data.rect[1] - BORDER_SIZE);
        var numberOfLines = Math.round(height / (LINE_FACTOR * fontSize)) || 1;
        var lineHeight = height / numberOfLines;
        computedFontSize = Math.min(fontSize, roundToOneDecimal(lineHeight / LINE_FACTOR));
      } else {
        var _height = Math.abs(this.data.rect[3] - this.data.rect[1] - BORDER_SIZE);
        computedFontSize = Math.min(fontSize, roundToOneDecimal(_height / LINE_FACTOR));
      }
      style.fontSize = "calc(".concat(computedFontSize, "px * var(--scale-factor))");
      style.color = Util.makeHexColor(fontColor[0], fontColor[1], fontColor[2]);
      if (this.data.textAlignment !== null) {
        style.textAlign = TEXT_ALIGNMENT[this.data.textAlignment];
      }
    }
  }, {
    key: "_setRequired",
    value: function _setRequired(element, isRequired) {
      if (isRequired) {
        element.setAttribute("required", true);
      } else {
        element.removeAttribute("required");
      }
      element.setAttribute("aria-required", isRequired);
    }
  }]);
}(AnnotationElement);
var TextWidgetAnnotationElement = /*#__PURE__*/function (_WidgetAnnotationElem) {
  function TextWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, TextWidgetAnnotationElement);
    var isRenderable = parameters.renderForms || parameters.data.hasOwnCanvas || !parameters.data.hasAppearance && !!parameters.data.fieldValue;
    return annotation_layer_callSuper(this, TextWidgetAnnotationElement, [parameters, {
      isRenderable: isRenderable
    }]);
  }
  annotation_layer_inherits(TextWidgetAnnotationElement, _WidgetAnnotationElem);
  return annotation_layer_createClass(TextWidgetAnnotationElement, [{
    key: "setPropertyOnSiblings",
    value: function setPropertyOnSiblings(base, key, value, keyInStorage) {
      var storage = this.annotationStorage;
      var _iterator8 = annotation_layer_createForOfIteratorHelper(this._getElementsByName(base.name, base.id)),
        _step8;
      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var element = _step8.value;
          if (element.domElement) {
            element.domElement[key] = value;
          }
          storage.setValue(element.id, annotation_layer_defineProperty({}, keyInStorage, value));
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this9 = this;
      var storage = this.annotationStorage;
      var id = this.data.id;
      this.container.classList.add("textWidgetAnnotation");
      var element = null;
      if (this.renderForms) {
        var _this$data$textConten;
        var storedData = storage.getValue(id, {
          value: this.data.fieldValue
        });
        var textContent = storedData.value || "";
        var maxLen = storage.getValue(id, {
          charLimit: this.data.maxLen
        }).charLimit;
        if (maxLen && textContent.length > maxLen) {
          textContent = textContent.slice(0, maxLen);
        }
        var fieldFormattedValues = storedData.formattedValue || ((_this$data$textConten = this.data.textContent) === null || _this$data$textConten === void 0 ? void 0 : _this$data$textConten.join("\n")) || null;
        if (fieldFormattedValues && this.data.comb) {
          fieldFormattedValues = fieldFormattedValues.replaceAll(/\s+/g, "");
        }
        var elementData = {
          userValue: textContent,
          formattedValue: fieldFormattedValues,
          lastCommittedValue: null,
          commitKey: 1,
          focused: false
        };
        if (this.data.multiLine) {
          var _fieldFormattedValues;
          element = document.createElement("textarea");
          element.textContent = (_fieldFormattedValues = fieldFormattedValues) !== null && _fieldFormattedValues !== void 0 ? _fieldFormattedValues : textContent;
          if (this.data.doNotScroll) {
            element.style.overflowY = "hidden";
          }
        } else {
          var _fieldFormattedValues2;
          element = document.createElement("input");
          element.type = "text";
          element.setAttribute("value", (_fieldFormattedValues2 = fieldFormattedValues) !== null && _fieldFormattedValues2 !== void 0 ? _fieldFormattedValues2 : textContent);
          if (this.data.doNotScroll) {
            element.style.overflowX = "hidden";
          }
        }
        if (this.data.hasOwnCanvas) {
          element.hidden = true;
        }
        GetElementsByNameSet.add(element);
        element.setAttribute("data-element-id", id);
        element.disabled = this.data.readOnly;
        element.name = this.data.fieldName;
        element.tabIndex = DEFAULT_TAB_INDEX;
        this._setRequired(element, this.data.required);
        if (maxLen) {
          element.maxLength = maxLen;
        }
        element.addEventListener("input", function (event) {
          storage.setValue(id, {
            value: event.target.value
          });
          _this9.setPropertyOnSiblings(element, "value", event.target.value, "value");
          elementData.formattedValue = null;
        });
        element.addEventListener("resetform", function (event) {
          var _this9$data$defaultFi;
          var defaultValue = (_this9$data$defaultFi = _this9.data.defaultFieldValue) !== null && _this9$data$defaultFi !== void 0 ? _this9$data$defaultFi : "";
          element.value = elementData.userValue = defaultValue;
          elementData.formattedValue = null;
        });
        var blurListener = function blurListener(event) {
          var formattedValue = elementData.formattedValue;
          if (formattedValue !== null && formattedValue !== undefined) {
            event.target.value = formattedValue;
          }
          event.target.scrollLeft = 0;
        };
        if (this.enableScripting && this.hasJSActions) {
          var _this$data$actions4;
          element.addEventListener("focus", function (event) {
            var _this9$data$actions;
            if (elementData.focused) {
              return;
            }
            var target = event.target;
            if (elementData.userValue) {
              target.value = elementData.userValue;
            }
            elementData.lastCommittedValue = target.value;
            elementData.commitKey = 1;
            if (!((_this9$data$actions = _this9.data.actions) !== null && _this9$data$actions !== void 0 && _this9$data$actions.Focus)) {
              elementData.focused = true;
            }
          });
          element.addEventListener("updatefromsandbox", function (jsEvent) {
            _this9.showElementAndHideCanvas(jsEvent.target);
            var actions = {
              value: function value(event) {
                var _event$detail$value;
                elementData.userValue = (_event$detail$value = event.detail.value) !== null && _event$detail$value !== void 0 ? _event$detail$value : "";
                storage.setValue(id, {
                  value: elementData.userValue.toString()
                });
                event.target.value = elementData.userValue;
              },
              formattedValue: function formattedValue(event) {
                var formattedValue = event.detail.formattedValue;
                elementData.formattedValue = formattedValue;
                if (formattedValue !== null && formattedValue !== undefined && event.target !== document.activeElement) {
                  event.target.value = formattedValue;
                }
                storage.setValue(id, {
                  formattedValue: formattedValue
                });
              },
              selRange: function selRange(event) {
                var _event$target;
                (_event$target = event.target).setSelectionRange.apply(_event$target, annotation_layer_toConsumableArray(event.detail.selRange));
              },
              charLimit: function charLimit(event) {
                var _this9$linkService$ev;
                var charLimit = event.detail.charLimit;
                var target = event.target;
                if (charLimit === 0) {
                  target.removeAttribute("maxLength");
                  return;
                }
                target.setAttribute("maxLength", charLimit);
                var value = elementData.userValue;
                if (!value || value.length <= charLimit) {
                  return;
                }
                value = value.slice(0, charLimit);
                target.value = elementData.userValue = value;
                storage.setValue(id, {
                  value: value
                });
                (_this9$linkService$ev = _this9.linkService.eventBus) === null || _this9$linkService$ev === void 0 || _this9$linkService$ev.dispatch("dispatcheventinsandbox", {
                  source: _this9,
                  detail: {
                    id: id,
                    name: "Keystroke",
                    value: value,
                    willCommit: true,
                    commitKey: 1,
                    selStart: target.selectionStart,
                    selEnd: target.selectionEnd
                  }
                });
              }
            };
            _this9._dispatchEventFromSandbox(actions, jsEvent);
          });
          element.addEventListener("keydown", function (event) {
            var _this9$linkService$ev2;
            elementData.commitKey = 1;
            var commitKey = -1;
            if (event.key === "Escape") {
              commitKey = 0;
            } else if (event.key === "Enter" && !_this9.data.multiLine) {
              commitKey = 2;
            } else if (event.key === "Tab") {
              elementData.commitKey = 3;
            }
            if (commitKey === -1) {
              return;
            }
            var value = event.target.value;
            if (elementData.lastCommittedValue === value) {
              return;
            }
            elementData.lastCommittedValue = value;
            elementData.userValue = value;
            (_this9$linkService$ev2 = _this9.linkService.eventBus) === null || _this9$linkService$ev2 === void 0 || _this9$linkService$ev2.dispatch("dispatcheventinsandbox", {
              source: _this9,
              detail: {
                id: id,
                name: "Keystroke",
                value: value,
                willCommit: true,
                commitKey: commitKey,
                selStart: event.target.selectionStart,
                selEnd: event.target.selectionEnd
              }
            });
          });
          var _blurListener = blurListener;
          blurListener = null;
          element.addEventListener("blur", function (event) {
            var _this9$data$actions2;
            if (!elementData.focused || !event.relatedTarget) {
              return;
            }
            if (!((_this9$data$actions2 = _this9.data.actions) !== null && _this9$data$actions2 !== void 0 && _this9$data$actions2.Blur)) {
              elementData.focused = false;
            }
            var value = event.target.value;
            elementData.userValue = value;
            if (elementData.lastCommittedValue !== value) {
              var _this9$linkService$ev3;
              (_this9$linkService$ev3 = _this9.linkService.eventBus) === null || _this9$linkService$ev3 === void 0 || _this9$linkService$ev3.dispatch("dispatcheventinsandbox", {
                source: _this9,
                detail: {
                  id: id,
                  name: "Keystroke",
                  value: value,
                  willCommit: true,
                  commitKey: elementData.commitKey,
                  selStart: event.target.selectionStart,
                  selEnd: event.target.selectionEnd
                }
              });
            }
            _blurListener(event);
          });
          if ((_this$data$actions4 = this.data.actions) !== null && _this$data$actions4 !== void 0 && _this$data$actions4.Keystroke) {
            element.addEventListener("beforeinput", function (event) {
              var _this9$linkService$ev4;
              elementData.lastCommittedValue = null;
              var data = event.data,
                target = event.target;
              var value = target.value,
                selectionStart = target.selectionStart,
                selectionEnd = target.selectionEnd;
              var selStart = selectionStart,
                selEnd = selectionEnd;
              switch (event.inputType) {
                case "deleteWordBackward":
                  {
                    var match = value.substring(0, selectionStart).match(/\w*[^\w]*$/);
                    if (match) {
                      selStart -= match[0].length;
                    }
                    break;
                  }
                case "deleteWordForward":
                  {
                    var _match = value.substring(selectionStart).match(/^[^\w]*\w*/);
                    if (_match) {
                      selEnd += _match[0].length;
                    }
                    break;
                  }
                case "deleteContentBackward":
                  if (selectionStart === selectionEnd) {
                    selStart -= 1;
                  }
                  break;
                case "deleteContentForward":
                  if (selectionStart === selectionEnd) {
                    selEnd += 1;
                  }
                  break;
              }
              event.preventDefault();
              (_this9$linkService$ev4 = _this9.linkService.eventBus) === null || _this9$linkService$ev4 === void 0 || _this9$linkService$ev4.dispatch("dispatcheventinsandbox", {
                source: _this9,
                detail: {
                  id: id,
                  name: "Keystroke",
                  value: value,
                  change: data || "",
                  willCommit: false,
                  selStart: selStart,
                  selEnd: selEnd
                }
              });
            });
          }
          this._setEventListeners(element, elementData, [["focus", "Focus"], ["blur", "Blur"], ["mousedown", "Mouse Down"], ["mouseenter", "Mouse Enter"], ["mouseleave", "Mouse Exit"], ["mouseup", "Mouse Up"]], function (event) {
            return event.target.value;
          });
        }
        if (blurListener) {
          element.addEventListener("blur", blurListener);
        }
        if (this.data.comb) {
          var fieldWidth = this.data.rect[2] - this.data.rect[0];
          var combWidth = fieldWidth / maxLen;
          element.classList.add("comb");
          element.style.letterSpacing = "calc(".concat(combWidth, "px * var(--scale-factor) - 1ch)");
        }
      } else {
        element = document.createElement("div");
        element.textContent = this.data.fieldValue;
        element.style.verticalAlign = "middle";
        element.style.display = "table-cell";
        if (this.data.hasOwnCanvas) {
          element.hidden = true;
        }
      }
      this._setTextStyle(element);
      this._setBackgroundColor(element);
      this._setDefaultPropertiesFromJS(element);
      this.container.append(element);
      return this.container;
    }
  }]);
}(WidgetAnnotationElement);
var SignatureWidgetAnnotationElement = /*#__PURE__*/function (_WidgetAnnotationElem2) {
  function SignatureWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, SignatureWidgetAnnotationElement);
    return annotation_layer_callSuper(this, SignatureWidgetAnnotationElement, [parameters, {
      isRenderable: !!parameters.data.hasOwnCanvas
    }]);
  }
  annotation_layer_inherits(SignatureWidgetAnnotationElement, _WidgetAnnotationElem2);
  return annotation_layer_createClass(SignatureWidgetAnnotationElement);
}(WidgetAnnotationElement);
var CheckboxWidgetAnnotationElement = /*#__PURE__*/function (_WidgetAnnotationElem3) {
  function CheckboxWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, CheckboxWidgetAnnotationElement);
    return annotation_layer_callSuper(this, CheckboxWidgetAnnotationElement, [parameters, {
      isRenderable: parameters.renderForms
    }]);
  }
  annotation_layer_inherits(CheckboxWidgetAnnotationElement, _WidgetAnnotationElem3);
  return annotation_layer_createClass(CheckboxWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var _this10 = this;
      var storage = this.annotationStorage;
      var data = this.data;
      var id = data.id;
      var value = storage.getValue(id, {
        value: data.exportValue === data.fieldValue
      }).value;
      if (typeof value === "string") {
        value = value !== "Off";
        storage.setValue(id, {
          value: value
        });
      }
      this.container.classList.add("buttonWidgetAnnotation", "checkBox");
      var element = document.createElement("input");
      GetElementsByNameSet.add(element);
      element.setAttribute("data-element-id", id);
      element.disabled = data.readOnly;
      this._setRequired(element, this.data.required);
      element.type = "checkbox";
      element.name = data.fieldName;
      if (value) {
        element.setAttribute("checked", true);
      }
      element.setAttribute("exportValue", data.exportValue);
      element.tabIndex = DEFAULT_TAB_INDEX;
      element.addEventListener("change", function (event) {
        var _event$target2 = event.target,
          name = _event$target2.name,
          checked = _event$target2.checked;
        var _iterator9 = annotation_layer_createForOfIteratorHelper(_this10._getElementsByName(name, id)),
          _step9;
        try {
          for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
            var checkbox = _step9.value;
            var curChecked = checked && checkbox.exportValue === data.exportValue;
            if (checkbox.domElement) {
              checkbox.domElement.checked = curChecked;
            }
            storage.setValue(checkbox.id, {
              value: curChecked
            });
          }
        } catch (err) {
          _iterator9.e(err);
        } finally {
          _iterator9.f();
        }
        storage.setValue(id, {
          value: checked
        });
      });
      element.addEventListener("resetform", function (event) {
        var defaultValue = data.defaultFieldValue || "Off";
        event.target.checked = defaultValue === data.exportValue;
      });
      if (this.enableScripting && this.hasJSActions) {
        element.addEventListener("updatefromsandbox", function (jsEvent) {
          var actions = {
            value: function value(event) {
              event.target.checked = event.detail.value !== "Off";
              storage.setValue(id, {
                value: event.target.checked
              });
            }
          };
          _this10._dispatchEventFromSandbox(actions, jsEvent);
        });
        this._setEventListeners(element, null, [["change", "Validate"], ["change", "Action"], ["focus", "Focus"], ["blur", "Blur"], ["mousedown", "Mouse Down"], ["mouseenter", "Mouse Enter"], ["mouseleave", "Mouse Exit"], ["mouseup", "Mouse Up"]], function (event) {
          return event.target.checked;
        });
      }
      this._setBackgroundColor(element);
      this._setDefaultPropertiesFromJS(element);
      this.container.append(element);
      return this.container;
    }
  }]);
}(WidgetAnnotationElement);
var RadioButtonWidgetAnnotationElement = /*#__PURE__*/function (_WidgetAnnotationElem4) {
  function RadioButtonWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, RadioButtonWidgetAnnotationElement);
    return annotation_layer_callSuper(this, RadioButtonWidgetAnnotationElement, [parameters, {
      isRenderable: parameters.renderForms
    }]);
  }
  annotation_layer_inherits(RadioButtonWidgetAnnotationElement, _WidgetAnnotationElem4);
  return annotation_layer_createClass(RadioButtonWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var _this11 = this;
      this.container.classList.add("buttonWidgetAnnotation", "radioButton");
      var storage = this.annotationStorage;
      var data = this.data;
      var id = data.id;
      var value = storage.getValue(id, {
        value: data.fieldValue === data.buttonValue
      }).value;
      if (typeof value === "string") {
        value = value !== data.buttonValue;
        storage.setValue(id, {
          value: value
        });
      }
      if (value) {
        var _iterator10 = annotation_layer_createForOfIteratorHelper(this._getElementsByName(data.fieldName, id)),
          _step10;
        try {
          for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
            var radio = _step10.value;
            storage.setValue(radio.id, {
              value: false
            });
          }
        } catch (err) {
          _iterator10.e(err);
        } finally {
          _iterator10.f();
        }
      }
      var element = document.createElement("input");
      GetElementsByNameSet.add(element);
      element.setAttribute("data-element-id", id);
      element.disabled = data.readOnly;
      this._setRequired(element, this.data.required);
      element.type = "radio";
      element.name = data.fieldName;
      if (value) {
        element.setAttribute("checked", true);
      }
      element.tabIndex = DEFAULT_TAB_INDEX;
      element.addEventListener("change", function (event) {
        var _event$target3 = event.target,
          name = _event$target3.name,
          checked = _event$target3.checked;
        var _iterator11 = annotation_layer_createForOfIteratorHelper(_this11._getElementsByName(name, id)),
          _step11;
        try {
          for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
            var _radio = _step11.value;
            storage.setValue(_radio.id, {
              value: false
            });
          }
        } catch (err) {
          _iterator11.e(err);
        } finally {
          _iterator11.f();
        }
        storage.setValue(id, {
          value: checked
        });
      });
      element.addEventListener("resetform", function (event) {
        var defaultValue = data.defaultFieldValue;
        event.target.checked = defaultValue !== null && defaultValue !== undefined && defaultValue === data.buttonValue;
      });
      if (this.enableScripting && this.hasJSActions) {
        var pdfButtonValue = data.buttonValue;
        element.addEventListener("updatefromsandbox", function (jsEvent) {
          var actions = {
            value: function value(event) {
              var checked = pdfButtonValue === event.detail.value;
              var _iterator12 = annotation_layer_createForOfIteratorHelper(_this11._getElementsByName(event.target.name)),
                _step12;
              try {
                for (_iterator12.s(); !(_step12 = _iterator12.n()).done;) {
                  var _radio2 = _step12.value;
                  var curChecked = checked && _radio2.id === id;
                  if (_radio2.domElement) {
                    _radio2.domElement.checked = curChecked;
                  }
                  storage.setValue(_radio2.id, {
                    value: curChecked
                  });
                }
              } catch (err) {
                _iterator12.e(err);
              } finally {
                _iterator12.f();
              }
            }
          };
          _this11._dispatchEventFromSandbox(actions, jsEvent);
        });
        this._setEventListeners(element, null, [["change", "Validate"], ["change", "Action"], ["focus", "Focus"], ["blur", "Blur"], ["mousedown", "Mouse Down"], ["mouseenter", "Mouse Enter"], ["mouseleave", "Mouse Exit"], ["mouseup", "Mouse Up"]], function (event) {
          return event.target.checked;
        });
      }
      this._setBackgroundColor(element);
      this._setDefaultPropertiesFromJS(element);
      this.container.append(element);
      return this.container;
    }
  }]);
}(WidgetAnnotationElement);
var PushButtonWidgetAnnotationElement = /*#__PURE__*/function (_LinkAnnotationElemen) {
  function PushButtonWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, PushButtonWidgetAnnotationElement);
    return annotation_layer_callSuper(this, PushButtonWidgetAnnotationElement, [parameters, {
      ignoreBorder: parameters.data.hasAppearance
    }]);
  }
  annotation_layer_inherits(PushButtonWidgetAnnotationElement, _LinkAnnotationElemen);
  return annotation_layer_createClass(PushButtonWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var _this12 = this;
      var container = _superPropGet(PushButtonWidgetAnnotationElement, "render", this, 3)([]);
      container.classList.add("buttonWidgetAnnotation", "pushButton");
      var linkElement = container.lastChild;
      if (this.enableScripting && this.hasJSActions && linkElement) {
        this._setDefaultPropertiesFromJS(linkElement);
        linkElement.addEventListener("updatefromsandbox", function (jsEvent) {
          _this12._dispatchEventFromSandbox({}, jsEvent);
        });
      }
      return container;
    }
  }]);
}(LinkAnnotationElement);
var ChoiceWidgetAnnotationElement = /*#__PURE__*/function (_WidgetAnnotationElem5) {
  function ChoiceWidgetAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, ChoiceWidgetAnnotationElement);
    return annotation_layer_callSuper(this, ChoiceWidgetAnnotationElement, [parameters, {
      isRenderable: parameters.renderForms
    }]);
  }
  annotation_layer_inherits(ChoiceWidgetAnnotationElement, _WidgetAnnotationElem5);
  return annotation_layer_createClass(ChoiceWidgetAnnotationElement, [{
    key: "render",
    value: function render() {
      var _this13 = this;
      this.container.classList.add("choiceWidgetAnnotation");
      var storage = this.annotationStorage;
      var id = this.data.id;
      var storedData = storage.getValue(id, {
        value: this.data.fieldValue
      });
      var selectElement = document.createElement("select");
      GetElementsByNameSet.add(selectElement);
      selectElement.setAttribute("data-element-id", id);
      selectElement.disabled = this.data.readOnly;
      this._setRequired(selectElement, this.data.required);
      selectElement.name = this.data.fieldName;
      selectElement.tabIndex = DEFAULT_TAB_INDEX;
      var addAnEmptyEntry = this.data.combo && this.data.options.length > 0;
      if (!this.data.combo) {
        selectElement.size = this.data.options.length;
        if (this.data.multiSelect) {
          selectElement.multiple = true;
        }
      }
      selectElement.addEventListener("resetform", function (event) {
        var defaultValue = _this13.data.defaultFieldValue;
        var _iterator13 = annotation_layer_createForOfIteratorHelper(selectElement.options),
          _step13;
        try {
          for (_iterator13.s(); !(_step13 = _iterator13.n()).done;) {
            var option = _step13.value;
            option.selected = option.value === defaultValue;
          }
        } catch (err) {
          _iterator13.e(err);
        } finally {
          _iterator13.f();
        }
      });
      var _iterator14 = annotation_layer_createForOfIteratorHelper(this.data.options),
        _step14;
      try {
        for (_iterator14.s(); !(_step14 = _iterator14.n()).done;) {
          var option = _step14.value;
          var optionElement = document.createElement("option");
          optionElement.textContent = option.displayValue;
          optionElement.value = option.exportValue;
          if (storedData.value.includes(option.exportValue)) {
            optionElement.setAttribute("selected", true);
            addAnEmptyEntry = false;
          }
          selectElement.append(optionElement);
        }
      } catch (err) {
        _iterator14.e(err);
      } finally {
        _iterator14.f();
      }
      var _removeEmptyEntry = null;
      if (addAnEmptyEntry) {
        var noneOptionElement = document.createElement("option");
        noneOptionElement.value = " ";
        noneOptionElement.setAttribute("hidden", true);
        noneOptionElement.setAttribute("selected", true);
        selectElement.prepend(noneOptionElement);
        _removeEmptyEntry = function removeEmptyEntry() {
          noneOptionElement.remove();
          selectElement.removeEventListener("input", _removeEmptyEntry);
          _removeEmptyEntry = null;
        };
        selectElement.addEventListener("input", _removeEmptyEntry);
      }
      var getValue = function getValue(isExport) {
        var name = isExport ? "value" : "textContent";
        var options = selectElement.options,
          multiple = selectElement.multiple;
        if (!multiple) {
          return options.selectedIndex === -1 ? null : options[options.selectedIndex][name];
        }
        return Array.prototype.filter.call(options, function (option) {
          return option.selected;
        }).map(function (option) {
          return option[name];
        });
      };
      var selectedValues = getValue(false);
      var getItems = function getItems(event) {
        var options = event.target.options;
        return Array.prototype.map.call(options, function (option) {
          return {
            displayValue: option.textContent,
            exportValue: option.value
          };
        });
      };
      if (this.enableScripting && this.hasJSActions) {
        selectElement.addEventListener("updatefromsandbox", function (jsEvent) {
          var actions = {
            value: function value(event) {
              var _removeEmptyEntry2;
              (_removeEmptyEntry2 = _removeEmptyEntry) === null || _removeEmptyEntry2 === void 0 || _removeEmptyEntry2();
              var value = event.detail.value;
              var values = new Set(Array.isArray(value) ? value : [value]);
              var _iterator15 = annotation_layer_createForOfIteratorHelper(selectElement.options),
                _step15;
              try {
                for (_iterator15.s(); !(_step15 = _iterator15.n()).done;) {
                  var option = _step15.value;
                  option.selected = values.has(option.value);
                }
              } catch (err) {
                _iterator15.e(err);
              } finally {
                _iterator15.f();
              }
              storage.setValue(id, {
                value: getValue(true)
              });
              selectedValues = getValue(false);
            },
            multipleSelection: function multipleSelection(event) {
              selectElement.multiple = true;
            },
            remove: function remove(event) {
              var options = selectElement.options;
              var index = event.detail.remove;
              options[index].selected = false;
              selectElement.remove(index);
              if (options.length > 0) {
                var i = Array.prototype.findIndex.call(options, function (option) {
                  return option.selected;
                });
                if (i === -1) {
                  options[0].selected = true;
                }
              }
              storage.setValue(id, {
                value: getValue(true),
                items: getItems(event)
              });
              selectedValues = getValue(false);
            },
            clear: function clear(event) {
              while (selectElement.length !== 0) {
                selectElement.remove(0);
              }
              storage.setValue(id, {
                value: null,
                items: []
              });
              selectedValues = getValue(false);
            },
            insert: function insert(event) {
              var _event$detail$insert = event.detail.insert,
                index = _event$detail$insert.index,
                displayValue = _event$detail$insert.displayValue,
                exportValue = _event$detail$insert.exportValue;
              var selectChild = selectElement.children[index];
              var optionElement = document.createElement("option");
              optionElement.textContent = displayValue;
              optionElement.value = exportValue;
              if (selectChild) {
                selectChild.before(optionElement);
              } else {
                selectElement.append(optionElement);
              }
              storage.setValue(id, {
                value: getValue(true),
                items: getItems(event)
              });
              selectedValues = getValue(false);
            },
            items: function items(event) {
              var items = event.detail.items;
              while (selectElement.length !== 0) {
                selectElement.remove(0);
              }
              var _iterator16 = annotation_layer_createForOfIteratorHelper(items),
                _step16;
              try {
                for (_iterator16.s(); !(_step16 = _iterator16.n()).done;) {
                  var item = _step16.value;
                  var displayValue = item.displayValue,
                    exportValue = item.exportValue;
                  var optionElement = document.createElement("option");
                  optionElement.textContent = displayValue;
                  optionElement.value = exportValue;
                  selectElement.append(optionElement);
                }
              } catch (err) {
                _iterator16.e(err);
              } finally {
                _iterator16.f();
              }
              if (selectElement.options.length > 0) {
                selectElement.options[0].selected = true;
              }
              storage.setValue(id, {
                value: getValue(true),
                items: getItems(event)
              });
              selectedValues = getValue(false);
            },
            indices: function indices(event) {
              var indices = new Set(event.detail.indices);
              var _iterator17 = annotation_layer_createForOfIteratorHelper(event.target.options),
                _step17;
              try {
                for (_iterator17.s(); !(_step17 = _iterator17.n()).done;) {
                  var option = _step17.value;
                  option.selected = indices.has(option.index);
                }
              } catch (err) {
                _iterator17.e(err);
              } finally {
                _iterator17.f();
              }
              storage.setValue(id, {
                value: getValue(true)
              });
              selectedValues = getValue(false);
            },
            editable: function editable(event) {
              event.target.disabled = !event.detail.editable;
            }
          };
          _this13._dispatchEventFromSandbox(actions, jsEvent);
        });
        selectElement.addEventListener("input", function (event) {
          var _this13$linkService$e;
          var exportValue = getValue(true);
          var change = getValue(false);
          storage.setValue(id, {
            value: exportValue
          });
          event.preventDefault();
          (_this13$linkService$e = _this13.linkService.eventBus) === null || _this13$linkService$e === void 0 || _this13$linkService$e.dispatch("dispatcheventinsandbox", {
            source: _this13,
            detail: {
              id: id,
              name: "Keystroke",
              value: selectedValues,
              change: change,
              changeEx: exportValue,
              willCommit: false,
              commitKey: 1,
              keyDown: false
            }
          });
        });
        this._setEventListeners(selectElement, null, [["focus", "Focus"], ["blur", "Blur"], ["mousedown", "Mouse Down"], ["mouseenter", "Mouse Enter"], ["mouseleave", "Mouse Exit"], ["mouseup", "Mouse Up"], ["input", "Action"], ["input", "Validate"]], function (event) {
          return event.target.value;
        });
      } else {
        selectElement.addEventListener("input", function (event) {
          storage.setValue(id, {
            value: getValue(true)
          });
        });
      }
      if (this.data.combo) {
        this._setTextStyle(selectElement);
      } else {}
      this._setBackgroundColor(selectElement);
      this._setDefaultPropertiesFromJS(selectElement);
      this.container.append(selectElement);
      return this.container;
    }
  }]);
}(WidgetAnnotationElement);
var PopupAnnotationElement = /*#__PURE__*/function (_AnnotationElement5) {
  function PopupAnnotationElement(parameters) {
    var _this14;
    annotation_layer_classCallCheck(this, PopupAnnotationElement);
    var data = parameters.data,
      elements = parameters.elements;
    _this14 = annotation_layer_callSuper(this, PopupAnnotationElement, [parameters, {
      isRenderable: AnnotationElement._hasPopupData(data)
    }]);
    _this14.elements = elements;
    _this14.popup = null;
    return _this14;
  }
  annotation_layer_inherits(PopupAnnotationElement, _AnnotationElement5);
  return annotation_layer_createClass(PopupAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("popupAnnotation");
      var popup = this.popup = new PopupElement({
        container: this.container,
        color: this.data.color,
        titleObj: this.data.titleObj,
        modificationDate: this.data.modificationDate,
        contentsObj: this.data.contentsObj,
        richText: this.data.richText,
        rect: this.data.rect,
        parentRect: this.data.parentRect || null,
        parent: this.parent,
        elements: this.elements,
        open: this.data.open
      });
      var elementIds = [];
      var _iterator18 = annotation_layer_createForOfIteratorHelper(this.elements),
        _step18;
      try {
        for (_iterator18.s(); !(_step18 = _iterator18.n()).done;) {
          var element = _step18.value;
          element.popup = popup;
          element.container.ariaHasPopup = "dialog";
          elementIds.push(element.data.id);
          element.addHighlightArea();
        }
      } catch (err) {
        _iterator18.e(err);
      } finally {
        _iterator18.f();
      }
      this.container.setAttribute("aria-controls", elementIds.map(function (id) {
        return "".concat(AnnotationPrefix).concat(id);
      }).join(","));
      return this.container;
    }
  }]);
}(AnnotationElement);
var _boundKeyDown = /*#__PURE__*/new WeakMap();
var _boundHide = /*#__PURE__*/new WeakMap();
var _boundShow = /*#__PURE__*/new WeakMap();
var _boundToggle = /*#__PURE__*/new WeakMap();
var _color = /*#__PURE__*/new WeakMap();
var annotation_layer_container = /*#__PURE__*/new WeakMap();
var _contentsObj = /*#__PURE__*/new WeakMap();
var _dateObj = /*#__PURE__*/new WeakMap();
var _elements = /*#__PURE__*/new WeakMap();
var _parent = /*#__PURE__*/new WeakMap();
var _parentRect = /*#__PURE__*/new WeakMap();
var _pinned = /*#__PURE__*/new WeakMap();
var _popup = /*#__PURE__*/new WeakMap();
var annotation_layer_position = /*#__PURE__*/new WeakMap();
var _rect = /*#__PURE__*/new WeakMap();
var _richText = /*#__PURE__*/new WeakMap();
var _titleObj = /*#__PURE__*/new WeakMap();
var _updates2 = /*#__PURE__*/new WeakMap();
var _wasVisible = /*#__PURE__*/new WeakMap();
var _PopupElement_brand = /*#__PURE__*/new WeakSet();
var PopupElement = /*#__PURE__*/function () {
  function PopupElement(_ref3) {
    var _this18 = this;
    var container = _ref3.container,
      color = _ref3.color,
      elements = _ref3.elements,
      titleObj = _ref3.titleObj,
      modificationDate = _ref3.modificationDate,
      _contentsObj2 = _ref3.contentsObj,
      _richText2 = _ref3.richText,
      parent = _ref3.parent,
      _rect2 = _ref3.rect,
      parentRect = _ref3.parentRect,
      open = _ref3.open;
    annotation_layer_classCallCheck(this, PopupElement);
    annotation_layer_classPrivateMethodInitSpec(this, _PopupElement_brand);
    annotation_layer_classPrivateFieldInitSpec(this, _boundKeyDown, annotation_layer_assertClassBrand(_PopupElement_brand, this, _keyDown).bind(this));
    annotation_layer_classPrivateFieldInitSpec(this, _boundHide, annotation_layer_assertClassBrand(_PopupElement_brand, this, _hide).bind(this));
    annotation_layer_classPrivateFieldInitSpec(this, _boundShow, annotation_layer_assertClassBrand(_PopupElement_brand, this, _show).bind(this));
    annotation_layer_classPrivateFieldInitSpec(this, _boundToggle, annotation_layer_assertClassBrand(_PopupElement_brand, this, _toggle).bind(this));
    annotation_layer_classPrivateFieldInitSpec(this, _color, null);
    annotation_layer_classPrivateFieldInitSpec(this, annotation_layer_container, null);
    annotation_layer_classPrivateFieldInitSpec(this, _contentsObj, null);
    annotation_layer_classPrivateFieldInitSpec(this, _dateObj, null);
    annotation_layer_classPrivateFieldInitSpec(this, _elements, null);
    annotation_layer_classPrivateFieldInitSpec(this, _parent, null);
    annotation_layer_classPrivateFieldInitSpec(this, _parentRect, null);
    annotation_layer_classPrivateFieldInitSpec(this, _pinned, false);
    annotation_layer_classPrivateFieldInitSpec(this, _popup, null);
    annotation_layer_classPrivateFieldInitSpec(this, annotation_layer_position, null);
    annotation_layer_classPrivateFieldInitSpec(this, _rect, null);
    annotation_layer_classPrivateFieldInitSpec(this, _richText, null);
    annotation_layer_classPrivateFieldInitSpec(this, _titleObj, null);
    annotation_layer_classPrivateFieldInitSpec(this, _updates2, null);
    annotation_layer_classPrivateFieldInitSpec(this, _wasVisible, false);
    annotation_layer_classPrivateFieldSet(annotation_layer_container, this, container);
    annotation_layer_classPrivateFieldSet(_titleObj, this, titleObj);
    annotation_layer_classPrivateFieldSet(_contentsObj, this, _contentsObj2);
    annotation_layer_classPrivateFieldSet(_richText, this, _richText2);
    annotation_layer_classPrivateFieldSet(_parent, this, parent);
    annotation_layer_classPrivateFieldSet(_color, this, color);
    annotation_layer_classPrivateFieldSet(_rect, this, _rect2);
    annotation_layer_classPrivateFieldSet(_parentRect, this, parentRect);
    annotation_layer_classPrivateFieldSet(_elements, this, elements);
    annotation_layer_classPrivateFieldSet(_dateObj, this, PDFDateString.toDateObject(modificationDate));
    this.trigger = elements.flatMap(function (e) {
      return e.getElementsToTriggerPopup();
    });
    var _iterator19 = annotation_layer_createForOfIteratorHelper(this.trigger),
      _step19;
    try {
      for (_iterator19.s(); !(_step19 = _iterator19.n()).done;) {
        var element = _step19.value;
        element.addEventListener("click", annotation_layer_classPrivateFieldGet(_boundToggle, this));
        element.addEventListener("mouseenter", annotation_layer_classPrivateFieldGet(_boundShow, this));
        element.addEventListener("mouseleave", annotation_layer_classPrivateFieldGet(_boundHide, this));
        element.classList.add("popupTriggerArea");
      }
    } catch (err) {
      _iterator19.e(err);
    } finally {
      _iterator19.f();
    }
    var _iterator20 = annotation_layer_createForOfIteratorHelper(elements),
      _step20;
    try {
      for (_iterator20.s(); !(_step20 = _iterator20.n()).done;) {
        var _element$container;
        var _element = _step20.value;
        (_element$container = _element.container) === null || _element$container === void 0 || _element$container.addEventListener("keydown", annotation_layer_classPrivateFieldGet(_boundKeyDown, this));
      }
    } catch (err) {
      _iterator20.e(err);
    } finally {
      _iterator20.f();
    }
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden = true;
    if (open) {
      annotation_layer_assertClassBrand(_PopupElement_brand, this, _toggle).call(this);
    }
  }
  return annotation_layer_createClass(PopupElement, [{
    key: "render",
    value: function render() {
      if (annotation_layer_classPrivateFieldGet(_popup, this)) {
        return;
      }
      var popup = annotation_layer_classPrivateFieldSet(_popup, this, document.createElement("div"));
      popup.className = "popup";
      if (annotation_layer_classPrivateFieldGet(_color, this)) {
        var baseColor = popup.style.outlineColor = Util.makeHexColor.apply(Util, annotation_layer_toConsumableArray(annotation_layer_classPrivateFieldGet(_color, this)));
        if (CSS.supports("background-color", "color-mix(in srgb, red 30%, white)")) {
          popup.style.backgroundColor = "color-mix(in srgb, ".concat(baseColor, " 30%, white)");
        } else {
          var BACKGROUND_ENLIGHT = 0.7;
          popup.style.backgroundColor = Util.makeHexColor.apply(Util, annotation_layer_toConsumableArray(annotation_layer_classPrivateFieldGet(_color, this).map(function (c) {
            return Math.floor(BACKGROUND_ENLIGHT * (255 - c) + c);
          })));
        }
      }
      var header = document.createElement("span");
      header.className = "header";
      var title = document.createElement("h1");
      header.append(title);
      var _classPrivateFieldGet4 = annotation_layer_classPrivateFieldGet(_titleObj, this);
      title.dir = _classPrivateFieldGet4.dir;
      title.textContent = _classPrivateFieldGet4.str;
      popup.append(header);
      if (annotation_layer_classPrivateFieldGet(_dateObj, this)) {
        var modificationDate = document.createElement("span");
        modificationDate.classList.add("popupDate");
        modificationDate.setAttribute("data-l10n-id", "pdfjs-annotation-date-time-string");
        modificationDate.setAttribute("data-l10n-args", JSON.stringify({
          dateObj: annotation_layer_classPrivateFieldGet(_dateObj, this).valueOf()
        }));
        header.append(modificationDate);
      }
      var html = annotation_layer_classPrivateGetter(_PopupElement_brand, this, _get_html);
      if (html) {
        XfaLayer.render({
          xfaHtml: html,
          intent: "richText",
          div: popup
        });
        popup.lastChild.classList.add("richText", "popupContent");
      } else {
        var contents = this._formatContents(annotation_layer_classPrivateFieldGet(_contentsObj, this));
        popup.append(contents);
      }
      annotation_layer_classPrivateFieldGet(annotation_layer_container, this).append(popup);
    }
  }, {
    key: "_formatContents",
    value: function _formatContents(_ref5) {
      var str = _ref5.str,
        dir = _ref5.dir;
      var p = document.createElement("p");
      p.classList.add("popupContent");
      p.dir = dir;
      var lines = str.split(/(?:\r\n?|\n)/);
      for (var i = 0, ii = lines.length; i < ii; ++i) {
        var line = lines[i];
        p.append(document.createTextNode(line));
        if (i < ii - 1) {
          p.append(document.createElement("br"));
        }
      }
      return p;
    }
  }, {
    key: "updateEdited",
    value: function updateEdited(_ref6) {
      var _classPrivateFieldGet5;
      var rect = _ref6.rect,
        popupContent = _ref6.popupContent;
      annotation_layer_classPrivateFieldGet(_updates2, this) || annotation_layer_classPrivateFieldSet(_updates2, this, {
        contentsObj: annotation_layer_classPrivateFieldGet(_contentsObj, this),
        richText: annotation_layer_classPrivateFieldGet(_richText, this)
      });
      if (rect) {
        annotation_layer_classPrivateFieldSet(annotation_layer_position, this, null);
      }
      if (popupContent) {
        annotation_layer_classPrivateFieldSet(_richText, this, annotation_layer_assertClassBrand(_PopupElement_brand, this, _makePopupContent).call(this, popupContent));
        annotation_layer_classPrivateFieldSet(_contentsObj, this, null);
      }
      (_classPrivateFieldGet5 = annotation_layer_classPrivateFieldGet(_popup, this)) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.remove();
      annotation_layer_classPrivateFieldSet(_popup, this, null);
    }
  }, {
    key: "resetEdited",
    value: function resetEdited() {
      var _classPrivateFieldGet7;
      if (!annotation_layer_classPrivateFieldGet(_updates2, this)) {
        return;
      }
      var _classPrivateFieldGet6 = annotation_layer_classPrivateFieldGet(_updates2, this);
      _toSetter(annotation_layer_classPrivateFieldSet, [_contentsObj, this])._ = _classPrivateFieldGet6.contentsObj;
      _toSetter(annotation_layer_classPrivateFieldSet, [_richText, this])._ = _classPrivateFieldGet6.richText;
      annotation_layer_classPrivateFieldSet(_updates2, this, null);
      (_classPrivateFieldGet7 = annotation_layer_classPrivateFieldGet(_popup, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.remove();
      annotation_layer_classPrivateFieldSet(_popup, this, null);
      annotation_layer_classPrivateFieldSet(annotation_layer_position, this, null);
    }
  }, {
    key: "forceHide",
    value: function forceHide() {
      annotation_layer_classPrivateFieldSet(_wasVisible, this, this.isVisible);
      if (!annotation_layer_classPrivateFieldGet(_wasVisible, this)) {
        return;
      }
      annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden = true;
    }
  }, {
    key: "maybeShow",
    value: function maybeShow() {
      if (!annotation_layer_classPrivateFieldGet(_wasVisible, this)) {
        return;
      }
      if (!annotation_layer_classPrivateFieldGet(_popup, this)) {
        annotation_layer_assertClassBrand(_PopupElement_brand, this, _show).call(this);
      }
      annotation_layer_classPrivateFieldSet(_wasVisible, this, false);
      annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden = false;
    }
  }, {
    key: "isVisible",
    get: function get() {
      return annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden === false;
    }
  }]);
}();
function _get_html(_this15) {
  var richText = annotation_layer_classPrivateFieldGet(_richText, _this15);
  var contentsObj = annotation_layer_classPrivateFieldGet(_contentsObj, _this15);
  if (richText !== null && richText !== void 0 && richText.str && (!(contentsObj !== null && contentsObj !== void 0 && contentsObj.str) || contentsObj.str === richText.str)) {
    return annotation_layer_classPrivateFieldGet(_richText, _this15).html || null;
  }
  return null;
}
function _get_fontSize(_this16) {
  var _classPrivateGetter2;
  return ((_classPrivateGetter2 = annotation_layer_classPrivateGetter(_PopupElement_brand, _this16, _get_html)) === null || _classPrivateGetter2 === void 0 || (_classPrivateGetter2 = _classPrivateGetter2.attributes) === null || _classPrivateGetter2 === void 0 || (_classPrivateGetter2 = _classPrivateGetter2.style) === null || _classPrivateGetter2 === void 0 ? void 0 : _classPrivateGetter2.fontSize) || 0;
}
function _get_fontColor(_this17) {
  var _classPrivateGetter3;
  return ((_classPrivateGetter3 = annotation_layer_classPrivateGetter(_PopupElement_brand, _this17, _get_html)) === null || _classPrivateGetter3 === void 0 || (_classPrivateGetter3 = _classPrivateGetter3.attributes) === null || _classPrivateGetter3 === void 0 || (_classPrivateGetter3 = _classPrivateGetter3.style) === null || _classPrivateGetter3 === void 0 ? void 0 : _classPrivateGetter3.color) || null;
}
function _makePopupContent(text) {
  var popupLines = [];
  var popupContent = {
    str: text,
    html: {
      name: "div",
      attributes: {
        dir: "auto"
      },
      children: [{
        name: "p",
        children: popupLines
      }]
    }
  };
  var lineAttributes = {
    style: {
      color: annotation_layer_classPrivateGetter(_PopupElement_brand, this, _get_fontColor),
      fontSize: annotation_layer_classPrivateGetter(_PopupElement_brand, this, _get_fontSize) ? "calc(".concat(annotation_layer_classPrivateGetter(_PopupElement_brand, this, _get_fontSize), "px * var(--scale-factor))") : ""
    }
  };
  var _iterator24 = annotation_layer_createForOfIteratorHelper(text.split("\n")),
    _step24;
  try {
    for (_iterator24.s(); !(_step24 = _iterator24.n()).done;) {
      var line = _step24.value;
      popupLines.push({
        name: "span",
        value: line,
        attributes: lineAttributes
      });
    }
  } catch (err) {
    _iterator24.e(err);
  } finally {
    _iterator24.f();
  }
  return popupContent;
}
function _keyDown(event) {
  if (event.altKey || event.shiftKey || event.ctrlKey || event.metaKey) {
    return;
  }
  if (event.key === "Enter" || event.key === "Escape" && annotation_layer_classPrivateFieldGet(_pinned, this)) {
    annotation_layer_assertClassBrand(_PopupElement_brand, this, _toggle).call(this);
  }
}
function _setPosition() {
  if (annotation_layer_classPrivateFieldGet(annotation_layer_position, this) !== null) {
    return;
  }
  var _classPrivateFieldGet8 = annotation_layer_classPrivateFieldGet(_parent, this),
    view = _classPrivateFieldGet8.page.view,
    _classPrivateFieldGet9 = _classPrivateFieldGet8.viewport.rawDims,
    pageWidth = _classPrivateFieldGet9.pageWidth,
    pageHeight = _classPrivateFieldGet9.pageHeight,
    pageX = _classPrivateFieldGet9.pageX,
    pageY = _classPrivateFieldGet9.pageY;
  var useParentRect = !!annotation_layer_classPrivateFieldGet(_parentRect, this);
  var rect = useParentRect ? annotation_layer_classPrivateFieldGet(_parentRect, this) : annotation_layer_classPrivateFieldGet(_rect, this);
  var _iterator25 = annotation_layer_createForOfIteratorHelper(annotation_layer_classPrivateFieldGet(_elements, this)),
    _step25;
  try {
    for (_iterator25.s(); !(_step25 = _iterator25.n()).done;) {
      var element = _step25.value;
      if (!rect || Util.intersect(element.data.rect, rect) !== null) {
        rect = element.data.rect;
        useParentRect = true;
        break;
      }
    }
  } catch (err) {
    _iterator25.e(err);
  } finally {
    _iterator25.f();
  }
  var normalizedRect = Util.normalizeRect([rect[0], view[3] - rect[1] + view[1], rect[2], view[3] - rect[3] + view[1]]);
  var HORIZONTAL_SPACE_AFTER_ANNOTATION = 5;
  var parentWidth = useParentRect ? rect[2] - rect[0] + HORIZONTAL_SPACE_AFTER_ANNOTATION : 0;
  var popupLeft = normalizedRect[0] + parentWidth;
  var popupTop = normalizedRect[1];
  annotation_layer_classPrivateFieldSet(annotation_layer_position, this, [100 * (popupLeft - pageX) / pageWidth, 100 * (popupTop - pageY) / pageHeight]);
  var _classPrivateFieldGet10 = annotation_layer_classPrivateFieldGet(annotation_layer_container, this),
    style = _classPrivateFieldGet10.style;
  style.left = "".concat(annotation_layer_classPrivateFieldGet(annotation_layer_position, this)[0], "%");
  style.top = "".concat(annotation_layer_classPrivateFieldGet(annotation_layer_position, this)[1], "%");
}
function _toggle() {
  annotation_layer_classPrivateFieldSet(_pinned, this, !annotation_layer_classPrivateFieldGet(_pinned, this));
  if (annotation_layer_classPrivateFieldGet(_pinned, this)) {
    annotation_layer_assertClassBrand(_PopupElement_brand, this, _show).call(this);
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).addEventListener("click", annotation_layer_classPrivateFieldGet(_boundToggle, this));
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).addEventListener("keydown", annotation_layer_classPrivateFieldGet(_boundKeyDown, this));
  } else {
    annotation_layer_assertClassBrand(_PopupElement_brand, this, _hide).call(this);
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).removeEventListener("click", annotation_layer_classPrivateFieldGet(_boundToggle, this));
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).removeEventListener("keydown", annotation_layer_classPrivateFieldGet(_boundKeyDown, this));
  }
}
function _show() {
  if (!annotation_layer_classPrivateFieldGet(_popup, this)) {
    this.render();
  }
  if (!this.isVisible) {
    annotation_layer_assertClassBrand(_PopupElement_brand, this, _setPosition).call(this);
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden = false;
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).style.zIndex = parseInt(annotation_layer_classPrivateFieldGet(annotation_layer_container, this).style.zIndex) + 1000;
  } else if (annotation_layer_classPrivateFieldGet(_pinned, this)) {
    annotation_layer_classPrivateFieldGet(annotation_layer_container, this).classList.add("focused");
  }
}
function _hide() {
  annotation_layer_classPrivateFieldGet(annotation_layer_container, this).classList.remove("focused");
  if (annotation_layer_classPrivateFieldGet(_pinned, this) || !this.isVisible) {
    return;
  }
  annotation_layer_classPrivateFieldGet(annotation_layer_container, this).hidden = true;
  annotation_layer_classPrivateFieldGet(annotation_layer_container, this).style.zIndex = parseInt(annotation_layer_classPrivateFieldGet(annotation_layer_container, this).style.zIndex) - 1000;
}
var FreeTextAnnotationElement = /*#__PURE__*/function (_AnnotationElement6) {
  function FreeTextAnnotationElement(parameters) {
    var _this19;
    annotation_layer_classCallCheck(this, FreeTextAnnotationElement);
    _this19 = annotation_layer_callSuper(this, FreeTextAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    _this19.textContent = parameters.data.textContent;
    _this19.textPosition = parameters.data.textPosition;
    _this19.annotationEditorType = AnnotationEditorType.FREETEXT;
    return _this19;
  }
  annotation_layer_inherits(FreeTextAnnotationElement, _AnnotationElement6);
  return annotation_layer_createClass(FreeTextAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("freeTextAnnotation");
      if (this.textContent) {
        var content = document.createElement("div");
        content.classList.add("annotationTextContent");
        content.setAttribute("role", "comment");
        var _iterator21 = annotation_layer_createForOfIteratorHelper(this.textContent),
          _step21;
        try {
          for (_iterator21.s(); !(_step21 = _iterator21.n()).done;) {
            var line = _step21.value;
            var lineSpan = document.createElement("span");
            lineSpan.textContent = line;
            content.append(lineSpan);
          }
        } catch (err) {
          _iterator21.e(err);
        } finally {
          _iterator21.f();
        }
        this.container.append(content);
      }
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this._editOnDoubleClick();
      return this.container;
    }
  }]);
}(AnnotationElement);
var _line = /*#__PURE__*/new WeakMap();
var LineAnnotationElement = /*#__PURE__*/function (_AnnotationElement7) {
  function LineAnnotationElement(parameters) {
    var _this20;
    annotation_layer_classCallCheck(this, LineAnnotationElement);
    _this20 = annotation_layer_callSuper(this, LineAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    annotation_layer_classPrivateFieldInitSpec(_this20, _line, null);
    return _this20;
  }
  annotation_layer_inherits(LineAnnotationElement, _AnnotationElement7);
  return annotation_layer_createClass(LineAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("lineAnnotation");
      var data = this.data;
      var _getRectDims3 = getRectDims(data.rect),
        width = _getRectDims3.width,
        height = _getRectDims3.height;
      var svg = this.svgFactory.create(width, height, true);
      var line = annotation_layer_classPrivateFieldSet(_line, this, this.svgFactory.createElement("svg:line"));
      line.setAttribute("x1", data.rect[2] - data.lineCoordinates[0]);
      line.setAttribute("y1", data.rect[3] - data.lineCoordinates[1]);
      line.setAttribute("x2", data.rect[2] - data.lineCoordinates[2]);
      line.setAttribute("y2", data.rect[3] - data.lineCoordinates[3]);
      line.setAttribute("stroke-width", data.borderStyle.width || 1);
      line.setAttribute("stroke", "transparent");
      line.setAttribute("fill", "transparent");
      svg.append(line);
      this.container.append(svg);
      if (!data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      return this.container;
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_line, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
var _square = /*#__PURE__*/new WeakMap();
var SquareAnnotationElement = /*#__PURE__*/function (_AnnotationElement8) {
  function SquareAnnotationElement(parameters) {
    var _this21;
    annotation_layer_classCallCheck(this, SquareAnnotationElement);
    _this21 = annotation_layer_callSuper(this, SquareAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    annotation_layer_classPrivateFieldInitSpec(_this21, _square, null);
    return _this21;
  }
  annotation_layer_inherits(SquareAnnotationElement, _AnnotationElement8);
  return annotation_layer_createClass(SquareAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("squareAnnotation");
      var data = this.data;
      var _getRectDims4 = getRectDims(data.rect),
        width = _getRectDims4.width,
        height = _getRectDims4.height;
      var svg = this.svgFactory.create(width, height, true);
      var borderWidth = data.borderStyle.width;
      var square = annotation_layer_classPrivateFieldSet(_square, this, this.svgFactory.createElement("svg:rect"));
      square.setAttribute("x", borderWidth / 2);
      square.setAttribute("y", borderWidth / 2);
      square.setAttribute("width", width - borderWidth);
      square.setAttribute("height", height - borderWidth);
      square.setAttribute("stroke-width", borderWidth || 1);
      square.setAttribute("stroke", "transparent");
      square.setAttribute("fill", "transparent");
      svg.append(square);
      this.container.append(svg);
      if (!data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      return this.container;
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_square, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
var _circle = /*#__PURE__*/new WeakMap();
var CircleAnnotationElement = /*#__PURE__*/function (_AnnotationElement9) {
  function CircleAnnotationElement(parameters) {
    var _this22;
    annotation_layer_classCallCheck(this, CircleAnnotationElement);
    _this22 = annotation_layer_callSuper(this, CircleAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    annotation_layer_classPrivateFieldInitSpec(_this22, _circle, null);
    return _this22;
  }
  annotation_layer_inherits(CircleAnnotationElement, _AnnotationElement9);
  return annotation_layer_createClass(CircleAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("circleAnnotation");
      var data = this.data;
      var _getRectDims5 = getRectDims(data.rect),
        width = _getRectDims5.width,
        height = _getRectDims5.height;
      var svg = this.svgFactory.create(width, height, true);
      var borderWidth = data.borderStyle.width;
      var circle = annotation_layer_classPrivateFieldSet(_circle, this, this.svgFactory.createElement("svg:ellipse"));
      circle.setAttribute("cx", width / 2);
      circle.setAttribute("cy", height / 2);
      circle.setAttribute("rx", width / 2 - borderWidth / 2);
      circle.setAttribute("ry", height / 2 - borderWidth / 2);
      circle.setAttribute("stroke-width", borderWidth || 1);
      circle.setAttribute("stroke", "transparent");
      circle.setAttribute("fill", "transparent");
      svg.append(circle);
      this.container.append(svg);
      if (!data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      return this.container;
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_circle, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
var _polyline = /*#__PURE__*/new WeakMap();
var PolylineAnnotationElement = /*#__PURE__*/function (_AnnotationElement10) {
  function PolylineAnnotationElement(parameters) {
    var _this23;
    annotation_layer_classCallCheck(this, PolylineAnnotationElement);
    _this23 = annotation_layer_callSuper(this, PolylineAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    annotation_layer_classPrivateFieldInitSpec(_this23, _polyline, null);
    _this23.containerClassName = "polylineAnnotation";
    _this23.svgElementName = "svg:polyline";
    return _this23;
  }
  annotation_layer_inherits(PolylineAnnotationElement, _AnnotationElement10);
  return annotation_layer_createClass(PolylineAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add(this.containerClassName);
      var _this$data = this.data,
        rect = _this$data.rect,
        vertices = _this$data.vertices,
        borderStyle = _this$data.borderStyle,
        popupRef = _this$data.popupRef;
      if (!vertices) {
        return this.container;
      }
      var _getRectDims6 = getRectDims(rect),
        width = _getRectDims6.width,
        height = _getRectDims6.height;
      var svg = this.svgFactory.create(width, height, true);
      var points = [];
      for (var i = 0, ii = vertices.length; i < ii; i += 2) {
        var x = vertices[i] - rect[0];
        var y = rect[3] - vertices[i + 1];
        points.push("".concat(x, ",").concat(y));
      }
      points = points.join(" ");
      var polyline = annotation_layer_classPrivateFieldSet(_polyline, this, this.svgFactory.createElement(this.svgElementName));
      polyline.setAttribute("points", points);
      polyline.setAttribute("stroke-width", borderStyle.width || 1);
      polyline.setAttribute("stroke", "transparent");
      polyline.setAttribute("fill", "transparent");
      svg.append(polyline);
      this.container.append(svg);
      if (!popupRef && this.hasPopupData) {
        this._createPopup();
      }
      return this.container;
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_polyline, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
var PolygonAnnotationElement = /*#__PURE__*/function (_PolylineAnnotationEl) {
  function PolygonAnnotationElement(parameters) {
    var _this24;
    annotation_layer_classCallCheck(this, PolygonAnnotationElement);
    _this24 = annotation_layer_callSuper(this, PolygonAnnotationElement, [parameters]);
    _this24.containerClassName = "polygonAnnotation";
    _this24.svgElementName = "svg:polygon";
    return _this24;
  }
  annotation_layer_inherits(PolygonAnnotationElement, _PolylineAnnotationEl);
  return annotation_layer_createClass(PolygonAnnotationElement);
}(PolylineAnnotationElement);
var CaretAnnotationElement = /*#__PURE__*/function (_AnnotationElement11) {
  function CaretAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, CaretAnnotationElement);
    return annotation_layer_callSuper(this, CaretAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
  }
  annotation_layer_inherits(CaretAnnotationElement, _AnnotationElement11);
  return annotation_layer_createClass(CaretAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("caretAnnotation");
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      return this.container;
    }
  }]);
}(AnnotationElement);
var _polylinesGroupElement = /*#__PURE__*/new WeakMap();
var _polylines = /*#__PURE__*/new WeakMap();
var _InkAnnotationElement_brand = /*#__PURE__*/new WeakSet();
var InkAnnotationElement = /*#__PURE__*/function (_AnnotationElement12) {
  function InkAnnotationElement(parameters) {
    var _this25;
    annotation_layer_classCallCheck(this, InkAnnotationElement);
    _this25 = annotation_layer_callSuper(this, InkAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    annotation_layer_classPrivateMethodInitSpec(_this25, _InkAnnotationElement_brand);
    annotation_layer_classPrivateFieldInitSpec(_this25, _polylinesGroupElement, null);
    annotation_layer_classPrivateFieldInitSpec(_this25, _polylines, []);
    _this25.containerClassName = "inkAnnotation";
    _this25.svgElementName = "svg:polyline";
    _this25.annotationEditorType = _this25.data.it === "InkHighlight" ? AnnotationEditorType.HIGHLIGHT : AnnotationEditorType.INK;
    return _this25;
  }
  annotation_layer_inherits(InkAnnotationElement, _AnnotationElement12);
  return annotation_layer_createClass(InkAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add(this.containerClassName);
      var _this$data2 = this.data,
        rect = _this$data2.rect,
        rotation = _this$data2.rotation,
        inkLists = _this$data2.inkLists,
        borderStyle = _this$data2.borderStyle,
        popupRef = _this$data2.popupRef;
      var _assertClassBrand$cal = annotation_layer_assertClassBrand(_InkAnnotationElement_brand, this, _getTransform).call(this, rotation, rect),
        transform = _assertClassBrand$cal.transform,
        width = _assertClassBrand$cal.width,
        height = _assertClassBrand$cal.height;
      var svg = this.svgFactory.create(width, height, true);
      var g = annotation_layer_classPrivateFieldSet(_polylinesGroupElement, this, this.svgFactory.createElement("svg:g"));
      svg.append(g);
      g.setAttribute("stroke-width", borderStyle.width || 1);
      g.setAttribute("stroke-linecap", "round");
      g.setAttribute("stroke-linejoin", "round");
      g.setAttribute("stroke-miterlimit", 10);
      g.setAttribute("stroke", "transparent");
      g.setAttribute("fill", "transparent");
      g.setAttribute("transform", transform);
      for (var i = 0, ii = inkLists.length; i < ii; i++) {
        var polyline = this.svgFactory.createElement(this.svgElementName);
        annotation_layer_classPrivateFieldGet(_polylines, this).push(polyline);
        polyline.setAttribute("points", inkLists[i].join(","));
        g.append(polyline);
      }
      if (!popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.append(svg);
      this._editOnDoubleClick();
      return this.container;
    }
  }, {
    key: "updateEdited",
    value: function updateEdited(params) {
      _superPropGet(InkAnnotationElement, "updateEdited", this, 3)([params]);
      var thickness = params.thickness,
        points = params.points,
        rect = params.rect;
      var g = annotation_layer_classPrivateFieldGet(_polylinesGroupElement, this);
      if (thickness >= 0) {
        g.setAttribute("stroke-width", thickness || 1);
      }
      if (points) {
        for (var i = 0, ii = annotation_layer_classPrivateFieldGet(_polylines, this).length; i < ii; i++) {
          annotation_layer_classPrivateFieldGet(_polylines, this)[i].setAttribute("points", points[i].join(","));
        }
      }
      if (rect) {
        var _assertClassBrand$cal2 = annotation_layer_assertClassBrand(_InkAnnotationElement_brand, this, _getTransform).call(this, this.data.rotation, rect),
          transform = _assertClassBrand$cal2.transform,
          width = _assertClassBrand$cal2.width,
          height = _assertClassBrand$cal2.height;
        var root = g.parentElement;
        root.setAttribute("viewBox", "0 0 ".concat(width, " ").concat(height));
        g.setAttribute("transform", transform);
      }
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_polylines, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
function _getTransform(rotation, rect) {
  switch (rotation) {
    case 90:
      return {
        transform: "rotate(90) translate(".concat(-rect[0], ",").concat(rect[1], ") scale(1,-1)"),
        width: rect[3] - rect[1],
        height: rect[2] - rect[0]
      };
    case 180:
      return {
        transform: "rotate(180) translate(".concat(-rect[2], ",").concat(rect[1], ") scale(1,-1)"),
        width: rect[2] - rect[0],
        height: rect[3] - rect[1]
      };
    case 270:
      return {
        transform: "rotate(270) translate(".concat(-rect[2], ",").concat(rect[3], ") scale(1,-1)"),
        width: rect[3] - rect[1],
        height: rect[2] - rect[0]
      };
    default:
      return {
        transform: "translate(".concat(-rect[0], ",").concat(rect[3], ") scale(1,-1)"),
        width: rect[2] - rect[0],
        height: rect[3] - rect[1]
      };
  }
}
var HighlightAnnotationElement = /*#__PURE__*/function (_AnnotationElement13) {
  function HighlightAnnotationElement(parameters) {
    var _this26;
    annotation_layer_classCallCheck(this, HighlightAnnotationElement);
    _this26 = annotation_layer_callSuper(this, HighlightAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true,
      createQuadrilaterals: true
    }]);
    _this26.annotationEditorType = AnnotationEditorType.HIGHLIGHT;
    return _this26;
  }
  annotation_layer_inherits(HighlightAnnotationElement, _AnnotationElement13);
  return annotation_layer_createClass(HighlightAnnotationElement, [{
    key: "render",
    value: function render() {
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.classList.add("highlightAnnotation");
      this._editOnDoubleClick();
      return this.container;
    }
  }]);
}(AnnotationElement);
var UnderlineAnnotationElement = /*#__PURE__*/function (_AnnotationElement14) {
  function UnderlineAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, UnderlineAnnotationElement);
    return annotation_layer_callSuper(this, UnderlineAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true,
      createQuadrilaterals: true
    }]);
  }
  annotation_layer_inherits(UnderlineAnnotationElement, _AnnotationElement14);
  return annotation_layer_createClass(UnderlineAnnotationElement, [{
    key: "render",
    value: function render() {
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.classList.add("underlineAnnotation");
      return this.container;
    }
  }]);
}(AnnotationElement);
var SquigglyAnnotationElement = /*#__PURE__*/function (_AnnotationElement15) {
  function SquigglyAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, SquigglyAnnotationElement);
    return annotation_layer_callSuper(this, SquigglyAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true,
      createQuadrilaterals: true
    }]);
  }
  annotation_layer_inherits(SquigglyAnnotationElement, _AnnotationElement15);
  return annotation_layer_createClass(SquigglyAnnotationElement, [{
    key: "render",
    value: function render() {
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.classList.add("squigglyAnnotation");
      return this.container;
    }
  }]);
}(AnnotationElement);
var StrikeOutAnnotationElement = /*#__PURE__*/function (_AnnotationElement16) {
  function StrikeOutAnnotationElement(parameters) {
    annotation_layer_classCallCheck(this, StrikeOutAnnotationElement);
    return annotation_layer_callSuper(this, StrikeOutAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true,
      createQuadrilaterals: true
    }]);
  }
  annotation_layer_inherits(StrikeOutAnnotationElement, _AnnotationElement16);
  return annotation_layer_createClass(StrikeOutAnnotationElement, [{
    key: "render",
    value: function render() {
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this.container.classList.add("strikeoutAnnotation");
      return this.container;
    }
  }]);
}(AnnotationElement);
var StampAnnotationElement = /*#__PURE__*/function (_AnnotationElement17) {
  function StampAnnotationElement(parameters) {
    var _this27;
    annotation_layer_classCallCheck(this, StampAnnotationElement);
    _this27 = annotation_layer_callSuper(this, StampAnnotationElement, [parameters, {
      isRenderable: true,
      ignoreBorder: true
    }]);
    _this27.annotationEditorType = AnnotationEditorType.STAMP;
    return _this27;
  }
  annotation_layer_inherits(StampAnnotationElement, _AnnotationElement17);
  return annotation_layer_createClass(StampAnnotationElement, [{
    key: "render",
    value: function render() {
      this.container.classList.add("stampAnnotation");
      this.container.setAttribute("role", "img");
      if (!this.data.popupRef && this.hasPopupData) {
        this._createPopup();
      }
      this._editOnDoubleClick();
      return this.container;
    }
  }]);
}(AnnotationElement);
var _trigger = /*#__PURE__*/new WeakMap();
var _FileAttachmentAnnotationElement_brand = /*#__PURE__*/new WeakSet();
var FileAttachmentAnnotationElement = /*#__PURE__*/function (_AnnotationElement18) {
  function FileAttachmentAnnotationElement(parameters) {
    var _this28$linkService$e;
    var _this28;
    annotation_layer_classCallCheck(this, FileAttachmentAnnotationElement);
    _this28 = annotation_layer_callSuper(this, FileAttachmentAnnotationElement, [parameters, {
      isRenderable: true
    }]);
    annotation_layer_classPrivateMethodInitSpec(_this28, _FileAttachmentAnnotationElement_brand);
    annotation_layer_classPrivateFieldInitSpec(_this28, _trigger, null);
    var file = _this28.data.file;
    _this28.filename = file.filename;
    _this28.content = file.content;
    (_this28$linkService$e = _this28.linkService.eventBus) === null || _this28$linkService$e === void 0 || _this28$linkService$e.dispatch("fileattachmentannotation", annotation_layer_objectSpread({
      source: _this28
    }, file));
    return _this28;
  }
  annotation_layer_inherits(FileAttachmentAnnotationElement, _AnnotationElement18);
  return annotation_layer_createClass(FileAttachmentAnnotationElement, [{
    key: "render",
    value: function render() {
      var _this29 = this;
      this.container.classList.add("fileAttachmentAnnotation");
      var container = this.container,
        data = this.data;
      var trigger;
      if (data.hasAppearance || data.fillAlpha === 0) {
        trigger = document.createElement("div");
      } else {
        trigger = document.createElement("img");
        trigger.src = "".concat(this.imageResourcesPath, "annotation-").concat(/paperclip/i.test(data.name) ? "paperclip" : "pushpin", ".svg");
        if (data.fillAlpha && data.fillAlpha < 1) {
          trigger.style = "filter: opacity(".concat(Math.round(data.fillAlpha * 100), "%);");
        }
      }
      trigger.addEventListener("dblclick", annotation_layer_assertClassBrand(_FileAttachmentAnnotationElement_brand, this, _download).bind(this));
      annotation_layer_classPrivateFieldSet(_trigger, this, trigger);
      var isMac = util_FeatureTest.platform.isMac;
      container.addEventListener("keydown", function (evt) {
        if (evt.key === "Enter" && (isMac ? evt.metaKey : evt.ctrlKey)) {
          annotation_layer_assertClassBrand(_FileAttachmentAnnotationElement_brand, _this29, _download).call(_this29);
        }
      });
      if (!data.popupRef && this.hasPopupData) {
        this._createPopup();
      } else {
        trigger.classList.add("popupTriggerArea");
      }
      container.append(trigger);
      return container;
    }
  }, {
    key: "getElementsToTriggerPopup",
    value: function getElementsToTriggerPopup() {
      return annotation_layer_classPrivateFieldGet(_trigger, this);
    }
  }, {
    key: "addHighlightArea",
    value: function addHighlightArea() {
      this.container.classList.add("highlightArea");
    }
  }]);
}(AnnotationElement);
function _download() {
  var _this$downloadManager;
  (_this$downloadManager = this.downloadManager) === null || _this$downloadManager === void 0 || _this$downloadManager.openOrDownloadData(this.content, this.filename);
}
var _accessibilityManager = /*#__PURE__*/new WeakMap();
var _annotationCanvasMap = /*#__PURE__*/new WeakMap();
var _editableAnnotations = /*#__PURE__*/new WeakMap();
var _structTreeLayer = /*#__PURE__*/new WeakMap();
var _AnnotationLayer_brand = /*#__PURE__*/new WeakSet();
var AnnotationLayer = /*#__PURE__*/function () {
  function AnnotationLayer(_ref7) {
    var _this30 = this;
    var div = _ref7.div,
      accessibilityManager = _ref7.accessibilityManager,
      annotationCanvasMap = _ref7.annotationCanvasMap,
      annotationEditorUIManager = _ref7.annotationEditorUIManager,
      page = _ref7.page,
      viewport = _ref7.viewport,
      structTreeLayer = _ref7.structTreeLayer;
    annotation_layer_classCallCheck(this, AnnotationLayer);
    annotation_layer_classPrivateMethodInitSpec(this, _AnnotationLayer_brand);
    annotation_layer_classPrivateFieldInitSpec(this, _accessibilityManager, null);
    annotation_layer_classPrivateFieldInitSpec(this, _annotationCanvasMap, null);
    annotation_layer_classPrivateFieldInitSpec(this, _editableAnnotations, new Map());
    annotation_layer_classPrivateFieldInitSpec(this, _structTreeLayer, null);
    this.div = div;
    annotation_layer_classPrivateFieldSet(_accessibilityManager, this, accessibilityManager);
    annotation_layer_classPrivateFieldSet(_annotationCanvasMap, this, annotationCanvasMap);
    annotation_layer_classPrivateFieldSet(_structTreeLayer, this, structTreeLayer || null);
    this.page = page;
    this.viewport = viewport;
    this.zIndex = 0;
    this._annotationEditorUIManager = annotationEditorUIManager;
  }
  return annotation_layer_createClass(AnnotationLayer, [{
    key: "hasEditableAnnotations",
    value: function hasEditableAnnotations() {
      return annotation_layer_classPrivateFieldGet(_editableAnnotations, this).size > 0;
    }
  }, {
    key: "render",
    value: function () {
      var _render = annotation_layer_asyncToGenerator(/*#__PURE__*/annotation_layer_regeneratorRuntime().mark(function _callee3(params) {
        var annotations, layer, popupToElements, elementParams, _iterator23, _step23, data, isPopupAnnotation, _getRectDims7, width, height, elements, element, _elements2, rendered, _this$_annotationEdit;
        return annotation_layer_regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              annotations = params.annotations;
              layer = this.div;
              setLayerDimensions(layer, this.viewport);
              popupToElements = new Map();
              elementParams = {
                data: null,
                layer: layer,
                linkService: params.linkService,
                downloadManager: params.downloadManager,
                imageResourcesPath: params.imageResourcesPath || "",
                renderForms: params.renderForms !== false,
                svgFactory: new DOMSVGFactory(),
                annotationStorage: params.annotationStorage || new AnnotationStorage(),
                enableScripting: params.enableScripting === true,
                hasJSActions: params.hasJSActions,
                fieldObjects: params.fieldObjects,
                parent: this,
                elements: null
              };
              _iterator23 = annotation_layer_createForOfIteratorHelper(annotations);
              _context3.prev = 6;
              _iterator23.s();
            case 8:
              if ((_step23 = _iterator23.n()).done) {
                _context3.next = 35;
                break;
              }
              data = _step23.value;
              if (!data.noHTML) {
                _context3.next = 12;
                break;
              }
              return _context3.abrupt("continue", 33);
            case 12:
              isPopupAnnotation = data.annotationType === AnnotationType.POPUP;
              if (isPopupAnnotation) {
                _context3.next = 19;
                break;
              }
              _getRectDims7 = getRectDims(data.rect), width = _getRectDims7.width, height = _getRectDims7.height;
              if (!(width <= 0 || height <= 0)) {
                _context3.next = 17;
                break;
              }
              return _context3.abrupt("continue", 33);
            case 17:
              _context3.next = 23;
              break;
            case 19:
              elements = popupToElements.get(data.id);
              if (elements) {
                _context3.next = 22;
                break;
              }
              return _context3.abrupt("continue", 33);
            case 22:
              elementParams.elements = elements;
            case 23:
              elementParams.data = data;
              element = AnnotationElementFactory.create(elementParams);
              if (element.isRenderable) {
                _context3.next = 27;
                break;
              }
              return _context3.abrupt("continue", 33);
            case 27:
              if (!isPopupAnnotation && data.popupRef) {
                _elements2 = popupToElements.get(data.popupRef);
                if (!_elements2) {
                  popupToElements.set(data.popupRef, [element]);
                } else {
                  _elements2.push(element);
                }
              }
              rendered = element.render();
              if (data.hidden) {
                rendered.style.visibility = "hidden";
              }
              _context3.next = 32;
              return annotation_layer_assertClassBrand(_AnnotationLayer_brand, this, _appendElement).call(this, rendered, data.id);
            case 32:
              if (element._isEditable) {
                annotation_layer_classPrivateFieldGet(_editableAnnotations, this).set(element.data.id, element);
                (_this$_annotationEdit = this._annotationEditorUIManager) === null || _this$_annotationEdit === void 0 || _this$_annotationEdit.renderAnnotationElement(element);
              }
            case 33:
              _context3.next = 8;
              break;
            case 35:
              _context3.next = 40;
              break;
            case 37:
              _context3.prev = 37;
              _context3.t0 = _context3["catch"](6);
              _iterator23.e(_context3.t0);
            case 40:
              _context3.prev = 40;
              _iterator23.f();
              return _context3.finish(40);
            case 43:
              annotation_layer_assertClassBrand(_AnnotationLayer_brand, this, _setAnnotationCanvasMap).call(this);
            case 44:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this, [[6, 37, 40, 43]]);
      }));
      function render(_x) {
        return _render.apply(this, arguments);
      }
      return render;
    }()
  }, {
    key: "update",
    value: function update(_ref8) {
      var viewport = _ref8.viewport;
      var layer = this.div;
      this.viewport = viewport;
      setLayerDimensions(layer, {
        rotation: viewport.rotation
      });
      annotation_layer_assertClassBrand(_AnnotationLayer_brand, this, _setAnnotationCanvasMap).call(this);
      layer.hidden = false;
    }
  }, {
    key: "getEditableAnnotations",
    value: function getEditableAnnotations() {
      return Array.from(annotation_layer_classPrivateFieldGet(_editableAnnotations, this).values());
    }
  }, {
    key: "getEditableAnnotation",
    value: function getEditableAnnotation(id) {
      return annotation_layer_classPrivateFieldGet(_editableAnnotations, this).get(id);
    }
  }]);
}();
function _appendElement(_x2, _x3) {
  return _appendElement2.apply(this, arguments);
}
function _appendElement2() {
  _appendElement2 = annotation_layer_asyncToGenerator(/*#__PURE__*/annotation_layer_regeneratorRuntime().mark(function _callee4(element, id) {
    var _classPrivateFieldGet11, _classPrivateFieldGet12;
    var contentElement, annotationId, ariaAttributes, _iterator27, _step27, _step27$value, key, value;
    return annotation_layer_regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          contentElement = element.firstChild || element;
          annotationId = contentElement.id = "".concat(AnnotationPrefix).concat(id);
          _context4.next = 4;
          return (_classPrivateFieldGet11 = annotation_layer_classPrivateFieldGet(_structTreeLayer, this)) === null || _classPrivateFieldGet11 === void 0 ? void 0 : _classPrivateFieldGet11.getAriaAttributes(annotationId);
        case 4:
          ariaAttributes = _context4.sent;
          if (ariaAttributes) {
            _iterator27 = annotation_layer_createForOfIteratorHelper(ariaAttributes);
            try {
              for (_iterator27.s(); !(_step27 = _iterator27.n()).done;) {
                _step27$value = annotation_layer_slicedToArray(_step27.value, 2), key = _step27$value[0], value = _step27$value[1];
                contentElement.setAttribute(key, value);
              }
            } catch (err) {
              _iterator27.e(err);
            } finally {
              _iterator27.f();
            }
          }
          this.div.append(element);
          (_classPrivateFieldGet12 = annotation_layer_classPrivateFieldGet(_accessibilityManager, this)) === null || _classPrivateFieldGet12 === void 0 || _classPrivateFieldGet12.moveElementInDOM(this.div, element, contentElement, false);
        case 8:
        case "end":
          return _context4.stop();
      }
    }, _callee4, this);
  }));
  return _appendElement2.apply(this, arguments);
}
function _setAnnotationCanvasMap() {
  if (!annotation_layer_classPrivateFieldGet(_annotationCanvasMap, this)) {
    return;
  }
  var layer = this.div;
  var _iterator26 = annotation_layer_createForOfIteratorHelper(annotation_layer_classPrivateFieldGet(_annotationCanvasMap, this)),
    _step26;
  try {
    for (_iterator26.s(); !(_step26 = _iterator26.n()).done;) {
      var _step26$value = annotation_layer_slicedToArray(_step26.value, 2),
        id = _step26$value[0],
        canvas = _step26$value[1];
      var element = layer.querySelector("[data-annotation-id=\"".concat(id, "\"]"));
      if (!element) {
        continue;
      }
      canvas.className = "annotationContent";
      var firstChild = element.firstChild;
      if (!firstChild) {
        element.append(canvas);
      } else if (firstChild.nodeName === "CANVAS") {
        firstChild.replaceWith(canvas);
      } else if (!firstChild.classList.contains("annotationContent")) {
        firstChild.before(canvas);
      } else {
        firstChild.after(canvas);
      }
    }
  } catch (err) {
    _iterator26.e(err);
  } finally {
    _iterator26.f();
  }
  annotation_layer_classPrivateFieldGet(_annotationCanvasMap, this).clear();
}

;// ./src/display/editor/freetext.js



























function freetext_typeof(o) { "@babel/helpers - typeof"; return freetext_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, freetext_typeof(o); }
var _FreeTextEditor;
function freetext_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ freetext_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == freetext_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(freetext_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function freetext_toConsumableArray(r) { return freetext_arrayWithoutHoles(r) || freetext_iterableToArray(r) || freetext_unsupportedIterableToArray(r) || freetext_nonIterableSpread(); }
function freetext_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function freetext_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function freetext_arrayWithoutHoles(r) { if (Array.isArray(r)) return freetext_arrayLikeToArray(r); }
function freetext_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function freetext_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { freetext_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { freetext_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function freetext_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = freetext_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function freetext_slicedToArray(r, e) { return freetext_arrayWithHoles(r) || freetext_iterableToArrayLimit(r, e) || freetext_unsupportedIterableToArray(r, e) || freetext_nonIterableRest(); }
function freetext_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function freetext_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return freetext_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? freetext_arrayLikeToArray(r, a) : void 0; } }
function freetext_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function freetext_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function freetext_arrayWithHoles(r) { if (Array.isArray(r)) return r; }

























function freetext_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function freetext_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? freetext_ownKeys(Object(t), !0).forEach(function (r) { freetext_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : freetext_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function freetext_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function freetext_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, freetext_toPropertyKey(o.key), o); } }
function freetext_createClass(e, r, t) { return r && freetext_defineProperties(e.prototype, r), t && freetext_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function freetext_callSuper(t, o, e) { return o = freetext_getPrototypeOf(o), freetext_possibleConstructorReturn(t, freetext_isNativeReflectConstruct() ? Reflect.construct(o, e || [], freetext_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function freetext_possibleConstructorReturn(t, e) { if (e && ("object" == freetext_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return freetext_assertThisInitialized(t); }
function freetext_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function freetext_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (freetext_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function freetext_superPropGet(t, o, e, r) { var p = freetext_get(freetext_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function freetext_get() { return freetext_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = freetext_superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, freetext_get.apply(null, arguments); }
function freetext_superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = freetext_getPrototypeOf(t));); return t; }
function freetext_getPrototypeOf(t) { return freetext_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, freetext_getPrototypeOf(t); }
function freetext_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && freetext_setPrototypeOf(t, e); }
function freetext_setPrototypeOf(t, e) { return freetext_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, freetext_setPrototypeOf(t, e); }
function freetext_classPrivateMethodInitSpec(e, a) { freetext_checkPrivateRedeclaration(e, a), a.add(e); }
function freetext_defineProperty(e, r, t) { return (r = freetext_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function freetext_toPropertyKey(t) { var i = freetext_toPrimitive(t, "string"); return "symbol" == freetext_typeof(i) ? i : i + ""; }
function freetext_toPrimitive(t, r) { if ("object" != freetext_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != freetext_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function freetext_classPrivateFieldInitSpec(e, t, a) { freetext_checkPrivateRedeclaration(e, t), t.set(e, a); }
function freetext_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function freetext_classPrivateFieldGet(s, a) { return s.get(freetext_assertClassBrand(s, a)); }
function freetext_classPrivateFieldSet(s, a, r) { return s.set(freetext_assertClassBrand(s, a), r), r; }
function freetext_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }




var EOL_PATTERN = /\r\n?|\n/g;
var freetext_color = /*#__PURE__*/new WeakMap();
var _content = /*#__PURE__*/new WeakMap();
var _editorDivId = /*#__PURE__*/new WeakMap();
var _editModeAC = /*#__PURE__*/new WeakMap();
var _fontSize = /*#__PURE__*/new WeakMap();
var _FreeTextEditor_brand = /*#__PURE__*/new WeakSet();
var FreeTextEditor = /*#__PURE__*/function (_AnnotationEditor) {
  function FreeTextEditor(params) {
    var _this;
    freetext_classCallCheck(this, FreeTextEditor);
    _this = freetext_callSuper(this, FreeTextEditor, [freetext_objectSpread(freetext_objectSpread({}, params), {}, {
      name: "freeTextEditor"
    })]);
    freetext_classPrivateMethodInitSpec(_this, _FreeTextEditor_brand);
    freetext_classPrivateFieldInitSpec(_this, freetext_color, void 0);
    freetext_classPrivateFieldInitSpec(_this, _content, "");
    freetext_classPrivateFieldInitSpec(_this, _editorDivId, "".concat(_this.id, "-editor"));
    freetext_classPrivateFieldInitSpec(_this, _editModeAC, null);
    freetext_classPrivateFieldInitSpec(_this, _fontSize, void 0);
    freetext_classPrivateFieldSet(freetext_color, _this, params.color || FreeTextEditor._defaultColor || AnnotationEditor._defaultLineColor);
    freetext_classPrivateFieldSet(_fontSize, _this, params.fontSize || FreeTextEditor._defaultFontSize);
    return _this;
  }
  freetext_inherits(FreeTextEditor, _AnnotationEditor);
  return freetext_createClass(FreeTextEditor, [{
    key: "updateParams",
    value: function updateParams(type, value) {
      switch (type) {
        case AnnotationEditorParamsType.FREETEXT_SIZE:
          freetext_assertClassBrand(_FreeTextEditor_brand, this, _updateFontSize).call(this, value);
          break;
        case AnnotationEditorParamsType.FREETEXT_COLOR:
          freetext_assertClassBrand(_FreeTextEditor_brand, this, _updateColor).call(this, value);
          break;
      }
    }
  }, {
    key: "propertiesToUpdate",
    get: function get() {
      return [[AnnotationEditorParamsType.FREETEXT_SIZE, freetext_classPrivateFieldGet(_fontSize, this)], [AnnotationEditorParamsType.FREETEXT_COLOR, freetext_classPrivateFieldGet(freetext_color, this)]];
    }
  }, {
    key: "_translateEmpty",
    value: function _translateEmpty(x, y) {
      this._uiManager.translateSelectedEditors(x, y, true);
    }
  }, {
    key: "getInitialTranslation",
    value: function getInitialTranslation() {
      var scale = this.parentScale;
      return [-FreeTextEditor._internalPadding * scale, -(FreeTextEditor._internalPadding + freetext_classPrivateFieldGet(_fontSize, this)) * scale];
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      if (!this.parent) {
        return;
      }
      freetext_superPropGet(FreeTextEditor, "rebuild", this, 3)([]);
      if (this.div === null) {
        return;
      }
      if (!this.isAttachedToDOM) {
        this.parent.add(this);
      }
    }
  }, {
    key: "enableEditMode",
    value: function enableEditMode() {
      if (this.isInEditMode()) {
        return;
      }
      this.parent.setEditingState(false);
      this.parent.updateToolbar(AnnotationEditorType.FREETEXT);
      freetext_superPropGet(FreeTextEditor, "enableEditMode", this, 3)([]);
      this.overlayDiv.classList.remove("enabled");
      this.editorDiv.contentEditable = true;
      this._isDraggable = false;
      this.div.removeAttribute("aria-activedescendant");
      freetext_classPrivateFieldSet(_editModeAC, this, new AbortController());
      var signal = this._uiManager.combinedSignal(freetext_classPrivateFieldGet(_editModeAC, this));
      this.editorDiv.addEventListener("keydown", this.editorDivKeydown.bind(this), {
        signal: signal
      });
      this.editorDiv.addEventListener("focus", this.editorDivFocus.bind(this), {
        signal: signal
      });
      this.editorDiv.addEventListener("blur", this.editorDivBlur.bind(this), {
        signal: signal
      });
      this.editorDiv.addEventListener("input", this.editorDivInput.bind(this), {
        signal: signal
      });
      this.editorDiv.addEventListener("paste", this.editorDivPaste.bind(this), {
        signal: signal
      });
    }
  }, {
    key: "disableEditMode",
    value: function disableEditMode() {
      var _classPrivateFieldGet2;
      if (!this.isInEditMode()) {
        return;
      }
      this.parent.setEditingState(true);
      freetext_superPropGet(FreeTextEditor, "disableEditMode", this, 3)([]);
      this.overlayDiv.classList.add("enabled");
      this.editorDiv.contentEditable = false;
      this.div.setAttribute("aria-activedescendant", freetext_classPrivateFieldGet(_editorDivId, this));
      this._isDraggable = true;
      (_classPrivateFieldGet2 = freetext_classPrivateFieldGet(_editModeAC, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.abort();
      freetext_classPrivateFieldSet(_editModeAC, this, null);
      this.div.focus({
        preventScroll: true
      });
      this.isEditing = false;
      this.parent.div.classList.add("freetextEditing");
    }
  }, {
    key: "focusin",
    value: function focusin(event) {
      if (!this._focusEventsAllowed) {
        return;
      }
      freetext_superPropGet(FreeTextEditor, "focusin", this, 3)([event]);
      if (event.target !== this.editorDiv) {
        this.editorDiv.focus();
      }
    }
  }, {
    key: "onceAdded",
    value: function onceAdded(focus) {
      var _this$_initialOptions;
      if (this.width) {
        return;
      }
      this.enableEditMode();
      if (focus) {
        this.editorDiv.focus();
      }
      if ((_this$_initialOptions = this._initialOptions) !== null && _this$_initialOptions !== void 0 && _this$_initialOptions.isCentered) {
        this.center();
      }
      this._initialOptions = null;
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return !this.editorDiv || this.editorDiv.innerText.trim() === "";
    }
  }, {
    key: "remove",
    value: function remove() {
      this.isEditing = false;
      if (this.parent) {
        this.parent.setEditingState(true);
        this.parent.div.classList.add("freetextEditing");
      }
      freetext_superPropGet(FreeTextEditor, "remove", this, 3)([]);
    }
  }, {
    key: "commit",
    value: function commit() {
      var _this2 = this;
      if (!this.isInEditMode()) {
        return;
      }
      freetext_superPropGet(FreeTextEditor, "commit", this, 3)([]);
      this.disableEditMode();
      var savedText = freetext_classPrivateFieldGet(_content, this);
      var newText = freetext_classPrivateFieldSet(_content, this, freetext_assertClassBrand(_FreeTextEditor_brand, this, _extractText).call(this).trimEnd());
      if (savedText === newText) {
        return;
      }
      var setText = function setText(text) {
        freetext_classPrivateFieldSet(_content, _this2, text);
        if (!text) {
          _this2.remove();
          return;
        }
        freetext_assertClassBrand(_FreeTextEditor_brand, _this2, _setContent).call(_this2);
        _this2._uiManager.rebuild(_this2);
        freetext_assertClassBrand(_FreeTextEditor_brand, _this2, _setEditorDimensions).call(_this2);
      };
      this.addCommands({
        cmd: function cmd() {
          setText(newText);
        },
        undo: function undo() {
          setText(savedText);
        },
        mustExec: false
      });
      freetext_assertClassBrand(_FreeTextEditor_brand, this, _setEditorDimensions).call(this);
    }
  }, {
    key: "shouldGetKeyboardEvents",
    value: function shouldGetKeyboardEvents() {
      return this.isInEditMode();
    }
  }, {
    key: "enterInEditMode",
    value: function enterInEditMode() {
      this.enableEditMode();
      this.editorDiv.focus();
    }
  }, {
    key: "dblclick",
    value: function dblclick(event) {
      this.enterInEditMode();
    }
  }, {
    key: "keydown",
    value: function keydown(event) {
      if (event.target === this.div && event.key === "Enter") {
        this.enterInEditMode();
        event.preventDefault();
      }
    }
  }, {
    key: "editorDivKeydown",
    value: function editorDivKeydown(event) {
      FreeTextEditor._keyboardManager.exec(this, event);
    }
  }, {
    key: "editorDivFocus",
    value: function editorDivFocus(event) {
      this.isEditing = true;
    }
  }, {
    key: "editorDivBlur",
    value: function editorDivBlur(event) {
      this.isEditing = false;
    }
  }, {
    key: "editorDivInput",
    value: function editorDivInput(event) {
      this.parent.div.classList.toggle("freetextEditing", this.isEmpty());
    }
  }, {
    key: "disableEditing",
    value: function disableEditing() {
      this.editorDiv.setAttribute("role", "comment");
      this.editorDiv.removeAttribute("aria-multiline");
    }
  }, {
    key: "enableEditing",
    value: function enableEditing() {
      this.editorDiv.setAttribute("role", "textbox");
      this.editorDiv.setAttribute("aria-multiline", true);
    }
  }, {
    key: "render",
    value: function render() {
      if (this.div) {
        return this.div;
      }
      var baseX, baseY;
      if (this.width) {
        baseX = this.x;
        baseY = this.y;
      }
      freetext_superPropGet(FreeTextEditor, "render", this, 3)([]);
      this.editorDiv = document.createElement("div");
      this.editorDiv.className = "internal";
      this.editorDiv.setAttribute("id", freetext_classPrivateFieldGet(_editorDivId, this));
      this.editorDiv.setAttribute("data-l10n-id", "pdfjs-free-text2");
      this.editorDiv.setAttribute("data-l10n-attrs", "default-content");
      this.enableEditing();
      this.editorDiv.contentEditable = true;
      var style = this.editorDiv.style;
      style.fontSize = "calc(".concat(freetext_classPrivateFieldGet(_fontSize, this), "px * var(--scale-factor))");
      style.color = freetext_classPrivateFieldGet(freetext_color, this);
      this.div.append(this.editorDiv);
      this.overlayDiv = document.createElement("div");
      this.overlayDiv.classList.add("overlay", "enabled");
      this.div.append(this.overlayDiv);
      bindEvents(this, this.div, ["dblclick", "keydown"]);
      if (this.width) {
        var _this$parentDimension = freetext_slicedToArray(this.parentDimensions, 2),
          parentWidth = _this$parentDimension[0],
          parentHeight = _this$parentDimension[1];
        if (this.annotationElementId) {
          var position = this._initialData.position;
          var _this$getInitialTrans = this.getInitialTranslation(),
            _this$getInitialTrans2 = freetext_slicedToArray(_this$getInitialTrans, 2),
            tx = _this$getInitialTrans2[0],
            ty = _this$getInitialTrans2[1];
          var _this$pageTranslation = this.pageTranslationToScreen(tx, ty);
          var _this$pageTranslation2 = freetext_slicedToArray(_this$pageTranslation, 2);
          tx = _this$pageTranslation2[0];
          ty = _this$pageTranslation2[1];
          var _this$pageDimensions = freetext_slicedToArray(this.pageDimensions, 2),
            pageWidth = _this$pageDimensions[0],
            pageHeight = _this$pageDimensions[1];
          var _this$pageTranslation3 = freetext_slicedToArray(this.pageTranslation, 2),
            pageX = _this$pageTranslation3[0],
            pageY = _this$pageTranslation3[1];
          var posX, posY;
          switch (this.rotation) {
            case 0:
              posX = baseX + (position[0] - pageX) / pageWidth;
              posY = baseY + this.height - (position[1] - pageY) / pageHeight;
              break;
            case 90:
              posX = baseX + (position[0] - pageX) / pageWidth;
              posY = baseY - (position[1] - pageY) / pageHeight;
              var _ref = [ty, -tx];
              tx = _ref[0];
              ty = _ref[1];
              break;
            case 180:
              posX = baseX - this.width + (position[0] - pageX) / pageWidth;
              posY = baseY - (position[1] - pageY) / pageHeight;
              var _ref2 = [-tx, -ty];
              tx = _ref2[0];
              ty = _ref2[1];
              break;
            case 270:
              posX = baseX + (position[0] - pageX - this.height * pageHeight) / pageWidth;
              posY = baseY + (position[1] - pageY - this.width * pageWidth) / pageHeight;
              var _ref3 = [-ty, tx];
              tx = _ref3[0];
              ty = _ref3[1];
              break;
          }
          this.setAt(posX * parentWidth, posY * parentHeight, tx, ty);
        } else {
          this.setAt(baseX * parentWidth, baseY * parentHeight, this.width * parentWidth, this.height * parentHeight);
        }
        freetext_assertClassBrand(_FreeTextEditor_brand, this, _setContent).call(this);
        this._isDraggable = true;
        this.editorDiv.contentEditable = false;
      } else {
        this._isDraggable = false;
        this.editorDiv.contentEditable = true;
      }
      return this.div;
    }
  }, {
    key: "editorDivPaste",
    value: function editorDivPaste(event) {
      var clipboardData = event.clipboardData || window.clipboardData;
      var types = clipboardData.types;
      if (types.length === 1 && types[0] === "text/plain") {
        return;
      }
      event.preventDefault();
      var paste = _deserializeContent.call(FreeTextEditor, clipboardData.getData("text") || "").replaceAll(EOL_PATTERN, "\n");
      if (!paste) {
        return;
      }
      var selection = window.getSelection();
      if (!selection.rangeCount) {
        return;
      }
      this.editorDiv.normalize();
      selection.deleteFromDocument();
      var range = selection.getRangeAt(0);
      if (!paste.includes("\n")) {
        range.insertNode(document.createTextNode(paste));
        this.editorDiv.normalize();
        selection.collapseToStart();
        return;
      }
      var startContainer = range.startContainer,
        startOffset = range.startOffset;
      var bufferBefore = [];
      var bufferAfter = [];
      if (startContainer.nodeType === Node.TEXT_NODE) {
        var parent = startContainer.parentElement;
        bufferAfter.push(startContainer.nodeValue.slice(startOffset).replaceAll(EOL_PATTERN, ""));
        if (parent !== this.editorDiv) {
          var buffer = bufferBefore;
          var _iterator = freetext_createForOfIteratorHelper(this.editorDiv.childNodes),
            _step;
          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var child = _step.value;
              if (child === parent) {
                buffer = bufferAfter;
                continue;
              }
              buffer.push(_getNodeContent.call(FreeTextEditor, child));
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
        bufferBefore.push(startContainer.nodeValue.slice(0, startOffset).replaceAll(EOL_PATTERN, ""));
      } else if (startContainer === this.editorDiv) {
        var _buffer = bufferBefore;
        var i = 0;
        var _iterator2 = freetext_createForOfIteratorHelper(this.editorDiv.childNodes),
          _step2;
        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var _child = _step2.value;
            if (i++ === startOffset) {
              _buffer = bufferAfter;
            }
            _buffer.push(_getNodeContent.call(FreeTextEditor, _child));
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
      freetext_classPrivateFieldSet(_content, this, "".concat(bufferBefore.join("\n")).concat(paste).concat(bufferAfter.join("\n")));
      freetext_assertClassBrand(_FreeTextEditor_brand, this, _setContent).call(this);
      var newRange = new Range();
      var beforeLength = bufferBefore.reduce(function (acc, line) {
        return acc + line.length;
      }, 0);
      var _iterator3 = freetext_createForOfIteratorHelper(this.editorDiv.childNodes),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var firstChild = _step3.value.firstChild;
          if (firstChild.nodeType === Node.TEXT_NODE) {
            var length = firstChild.nodeValue.length;
            if (beforeLength <= length) {
              newRange.setStart(firstChild, beforeLength);
              newRange.setEnd(firstChild, beforeLength);
              break;
            }
            beforeLength -= length;
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      selection.removeAllRanges();
      selection.addRange(newRange);
    }
  }, {
    key: "contentDiv",
    get: function get() {
      return this.editorDiv;
    }
  }, {
    key: "serialize",
    value: function serialize() {
      var isForCopying = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (this.isEmpty()) {
        return null;
      }
      if (this.deleted) {
        return this.serializeDeleted();
      }
      var padding = FreeTextEditor._internalPadding * this.parentScale;
      var rect = this.getRect(padding, padding);
      var color = AnnotationEditor._colorManager.convert(this.isAttachedToDOM ? getComputedStyle(this.editorDiv).color : freetext_classPrivateFieldGet(freetext_color, this));
      var serialized = {
        annotationType: AnnotationEditorType.FREETEXT,
        color: color,
        fontSize: freetext_classPrivateFieldGet(_fontSize, this),
        value: freetext_assertClassBrand(_FreeTextEditor_brand, this, _serializeContent).call(this),
        pageIndex: this.pageIndex,
        rect: rect,
        rotation: this.rotation,
        structTreeParentId: this._structTreeParentId
      };
      if (isForCopying) {
        return serialized;
      }
      if (this.annotationElementId && !freetext_assertClassBrand(_FreeTextEditor_brand, this, _hasElementChanged).call(this, serialized)) {
        return null;
      }
      serialized.id = this.annotationElementId;
      return serialized;
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      var content = freetext_superPropGet(FreeTextEditor, "renderAnnotationElement", this, 3)([annotation]);
      if (this.deleted) {
        return content;
      }
      var style = content.style;
      style.fontSize = "calc(".concat(freetext_classPrivateFieldGet(_fontSize, this), "px * var(--scale-factor))");
      style.color = freetext_classPrivateFieldGet(freetext_color, this);
      content.replaceChildren();
      var _iterator4 = freetext_createForOfIteratorHelper(freetext_classPrivateFieldGet(_content, this).split("\n")),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var line = _step4.value;
          var div = document.createElement("div");
          div.append(line ? document.createTextNode(line) : document.createElement("br"));
          content.append(div);
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      var padding = FreeTextEditor._internalPadding * this.parentScale;
      annotation.updateEdited({
        rect: this.getRect(padding, padding),
        popupContent: freetext_classPrivateFieldGet(_content, this)
      });
      return content;
    }
  }, {
    key: "resetAnnotationElement",
    value: function resetAnnotationElement(annotation) {
      freetext_superPropGet(FreeTextEditor, "resetAnnotationElement", this, 3)([annotation]);
      annotation.resetEdited();
    }
  }], [{
    key: "_keyboardManager",
    get: function get() {
      var proto = FreeTextEditor.prototype;
      var arrowChecker = function arrowChecker(self) {
        return self.isEmpty();
      };
      var small = AnnotationEditorUIManager.TRANSLATE_SMALL;
      var big = AnnotationEditorUIManager.TRANSLATE_BIG;
      return shadow(this, "_keyboardManager", new KeyboardManager([[["ctrl+s", "mac+meta+s", "ctrl+p", "mac+meta+p"], proto.commitOrRemove, {
        bubbles: true
      }], [["ctrl+Enter", "mac+meta+Enter", "Escape", "mac+Escape"], proto.commitOrRemove], [["ArrowLeft", "mac+ArrowLeft"], proto._translateEmpty, {
        args: [-small, 0],
        checker: arrowChecker
      }], [["ctrl+ArrowLeft", "mac+shift+ArrowLeft"], proto._translateEmpty, {
        args: [-big, 0],
        checker: arrowChecker
      }], [["ArrowRight", "mac+ArrowRight"], proto._translateEmpty, {
        args: [small, 0],
        checker: arrowChecker
      }], [["ctrl+ArrowRight", "mac+shift+ArrowRight"], proto._translateEmpty, {
        args: [big, 0],
        checker: arrowChecker
      }], [["ArrowUp", "mac+ArrowUp"], proto._translateEmpty, {
        args: [0, -small],
        checker: arrowChecker
      }], [["ctrl+ArrowUp", "mac+shift+ArrowUp"], proto._translateEmpty, {
        args: [0, -big],
        checker: arrowChecker
      }], [["ArrowDown", "mac+ArrowDown"], proto._translateEmpty, {
        args: [0, small],
        checker: arrowChecker
      }], [["ctrl+ArrowDown", "mac+shift+ArrowDown"], proto._translateEmpty, {
        args: [0, big],
        checker: arrowChecker
      }]]));
    }
  }, {
    key: "initialize",
    value: function initialize(l10n, uiManager) {
      AnnotationEditor.initialize(l10n, uiManager);
      var style = getComputedStyle(document.documentElement);
      this._internalPadding = parseFloat(style.getPropertyValue("--freetext-padding"));
    }
  }, {
    key: "updateDefaultParams",
    value: function updateDefaultParams(type, value) {
      switch (type) {
        case AnnotationEditorParamsType.FREETEXT_SIZE:
          FreeTextEditor._defaultFontSize = value;
          break;
        case AnnotationEditorParamsType.FREETEXT_COLOR:
          FreeTextEditor._defaultColor = value;
          break;
      }
    }
  }, {
    key: "defaultPropertiesToUpdate",
    get: function get() {
      return [[AnnotationEditorParamsType.FREETEXT_SIZE, FreeTextEditor._defaultFontSize], [AnnotationEditorParamsType.FREETEXT_COLOR, FreeTextEditor._defaultColor || AnnotationEditor._defaultLineColor]];
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = freetext_asyncToGenerator(/*#__PURE__*/freetext_regeneratorRuntime().mark(function _callee(data, parent, uiManager) {
        var initialData, _data, _data$data, _data$data$defaultApp, fontSize, fontColor, rect, rotation, id, popupRef, textContent, textPosition, pageNumber, editor;
        return freetext_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              initialData = null;
              if (!(data instanceof FreeTextAnnotationElement)) {
                _context.next = 6;
                break;
              }
              _data = data, _data$data = _data.data, _data$data$defaultApp = _data$data.defaultAppearanceData, fontSize = _data$data$defaultApp.fontSize, fontColor = _data$data$defaultApp.fontColor, rect = _data$data.rect, rotation = _data$data.rotation, id = _data$data.id, popupRef = _data$data.popupRef, textContent = _data.textContent, textPosition = _data.textPosition, pageNumber = _data.parent.page.pageNumber;
              if (!(!textContent || textContent.length === 0)) {
                _context.next = 5;
                break;
              }
              return _context.abrupt("return", null);
            case 5:
              initialData = data = {
                annotationType: AnnotationEditorType.FREETEXT,
                color: Array.from(fontColor),
                fontSize: fontSize,
                value: textContent.join("\n"),
                position: textPosition,
                pageIndex: pageNumber - 1,
                rect: rect.slice(0),
                rotation: rotation,
                id: id,
                deleted: false,
                popupRef: popupRef
              };
            case 6:
              _context.next = 8;
              return freetext_superPropGet(FreeTextEditor, "deserialize", this, 2)([data, parent, uiManager]);
            case 8:
              editor = _context.sent;
              freetext_classPrivateFieldSet(_fontSize, editor, data.fontSize);
              freetext_classPrivateFieldSet(freetext_color, editor, Util.makeHexColor.apply(Util, freetext_toConsumableArray(data.color)));
              freetext_classPrivateFieldSet(_content, editor, _deserializeContent.call(FreeTextEditor, data.value));
              editor.annotationElementId = data.id || null;
              editor._initialData = initialData;
              return _context.abrupt("return", editor);
            case 15:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function deserialize(_x, _x2, _x3) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }]);
}(AnnotationEditor);
_FreeTextEditor = FreeTextEditor;
function _updateFontSize(fontSize) {
  var _this3 = this;
  var setFontsize = function setFontsize(size) {
    _this3.editorDiv.style.fontSize = "calc(".concat(size, "px * var(--scale-factor))");
    _this3.translate(0, -(size - freetext_classPrivateFieldGet(_fontSize, _this3)) * _this3.parentScale);
    freetext_classPrivateFieldSet(_fontSize, _this3, size);
    freetext_assertClassBrand(_FreeTextEditor_brand, _this3, _setEditorDimensions).call(_this3);
  };
  var savedFontsize = freetext_classPrivateFieldGet(_fontSize, this);
  this.addCommands({
    cmd: setFontsize.bind(this, fontSize),
    undo: setFontsize.bind(this, savedFontsize),
    post: this._uiManager.updateUI.bind(this._uiManager, this),
    mustExec: true,
    type: AnnotationEditorParamsType.FREETEXT_SIZE,
    overwriteIfSameType: true,
    keepUndo: true
  });
}
function _updateColor(color) {
  var _this4 = this;
  var setColor = function setColor(col) {
    freetext_classPrivateFieldSet(freetext_color, _this4, _this4.editorDiv.style.color = col);
  };
  var savedColor = freetext_classPrivateFieldGet(freetext_color, this);
  this.addCommands({
    cmd: setColor.bind(this, color),
    undo: setColor.bind(this, savedColor),
    post: this._uiManager.updateUI.bind(this._uiManager, this),
    mustExec: true,
    type: AnnotationEditorParamsType.FREETEXT_COLOR,
    overwriteIfSameType: true,
    keepUndo: true
  });
}
function _extractText() {
  var buffer = [];
  this.editorDiv.normalize();
  var prevChild = null;
  var _iterator5 = freetext_createForOfIteratorHelper(this.editorDiv.childNodes),
    _step5;
  try {
    for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
      var _prevChild;
      var child = _step5.value;
      if (((_prevChild = prevChild) === null || _prevChild === void 0 ? void 0 : _prevChild.nodeType) === Node.TEXT_NODE && child.nodeName === "BR") {
        continue;
      }
      buffer.push(_getNodeContent.call(_FreeTextEditor, child));
      prevChild = child;
    }
  } catch (err) {
    _iterator5.e(err);
  } finally {
    _iterator5.f();
  }
  return buffer.join("\n");
}
function _setEditorDimensions() {
  var _this$parentDimension2 = freetext_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension2[0],
    parentHeight = _this$parentDimension2[1];
  var rect;
  if (this.isAttachedToDOM) {
    rect = this.div.getBoundingClientRect();
  } else {
    var currentLayer = this.currentLayer,
      div = this.div;
    var savedDisplay = div.style.display;
    var savedVisibility = div.classList.contains("hidden");
    div.classList.remove("hidden");
    div.style.display = "hidden";
    currentLayer.div.append(this.div);
    rect = div.getBoundingClientRect();
    div.remove();
    div.style.display = savedDisplay;
    div.classList.toggle("hidden", savedVisibility);
  }
  if (this.rotation % 180 === this.parentRotation % 180) {
    this.width = rect.width / parentWidth;
    this.height = rect.height / parentHeight;
  } else {
    this.width = rect.height / parentWidth;
    this.height = rect.width / parentHeight;
  }
  this.fixAndSetPosition();
}
function _getNodeContent(node) {
  return (node.nodeType === Node.TEXT_NODE ? node.nodeValue : node.innerText).replaceAll(EOL_PATTERN, "");
}
function _setContent() {
  this.editorDiv.replaceChildren();
  if (!freetext_classPrivateFieldGet(_content, this)) {
    return;
  }
  var _iterator6 = freetext_createForOfIteratorHelper(freetext_classPrivateFieldGet(_content, this).split("\n")),
    _step6;
  try {
    for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
      var line = _step6.value;
      var div = document.createElement("div");
      div.append(line ? document.createTextNode(line) : document.createElement("br"));
      this.editorDiv.append(div);
    }
  } catch (err) {
    _iterator6.e(err);
  } finally {
    _iterator6.f();
  }
}
function _serializeContent() {
  return freetext_classPrivateFieldGet(_content, this).replaceAll("\xa0", " ");
}
function _deserializeContent(content) {
  return content.replaceAll(" ", "\xa0");
}
function _hasElementChanged(serialized) {
  var _this$_initialData = this._initialData,
    value = _this$_initialData.value,
    fontSize = _this$_initialData.fontSize,
    color = _this$_initialData.color,
    pageIndex = _this$_initialData.pageIndex;
  return this._hasBeenMoved || serialized.value !== value || serialized.fontSize !== fontSize || serialized.color.some(function (c, i) {
    return c !== color[i];
  }) || serialized.pageIndex !== pageIndex;
}
freetext_defineProperty(FreeTextEditor, "_freeTextDefaultContent", "");
freetext_defineProperty(FreeTextEditor, "_internalPadding", 0);
freetext_defineProperty(FreeTextEditor, "_defaultColor", null);
freetext_defineProperty(FreeTextEditor, "_defaultFontSize", 10);
freetext_defineProperty(FreeTextEditor, "_type", "freetext");
freetext_defineProperty(FreeTextEditor, "_editorType", AnnotationEditorType.FREETEXT);

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.float32-array.js
var es_typed_array_float32_array = __webpack_require__(4594);
// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.sort.js
var es_array_sort = __webpack_require__(6910);
;// ./src/display/editor/drawers/outline.js
function outline_typeof(o) { "@babel/helpers - typeof"; return outline_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, outline_typeof(o); }
















































function outline_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function outline_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, outline_toPropertyKey(o.key), o); } }
function outline_createClass(e, r, t) { return r && outline_defineProperties(e.prototype, r), t && outline_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function outline_defineProperty(e, r, t) { return (r = outline_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function outline_toPropertyKey(t) { var i = outline_toPrimitive(t, "string"); return "symbol" == outline_typeof(i) ? i : i + ""; }
function outline_toPrimitive(t, r) { if ("object" != outline_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != outline_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

var Outline = /*#__PURE__*/function () {
  function Outline() {
    outline_classCallCheck(this, Outline);
  }
  return outline_createClass(Outline, [{
    key: "toSVGPath",
    value: function toSVGPath() {
      unreachable("Abstract method `toSVGPath` must be implemented.");
    }
  }, {
    key: "box",
    get: function get() {
      unreachable("Abstract getter `box` must be implemented.");
    }
  }, {
    key: "serialize",
    value: function serialize(_bbox, _rotation) {
      unreachable("Abstract method `serialize` must be implemented.");
    }
  }], [{
    key: "_rescale",
    value: function _rescale(src, tx, ty, sx, sy, dest) {
      dest || (dest = new Float32Array(src.length));
      for (var i = 0, ii = src.length; i < ii; i += 2) {
        dest[i] = tx + src[i] * sx;
        dest[i + 1] = ty + src[i + 1] * sy;
      }
      return dest;
    }
  }, {
    key: "_rescaleAndSwap",
    value: function _rescaleAndSwap(src, tx, ty, sx, sy, dest) {
      dest || (dest = new Float32Array(src.length));
      for (var i = 0, ii = src.length; i < ii; i += 2) {
        dest[i] = tx + src[i + 1] * sx;
        dest[i + 1] = ty + src[i] * sy;
      }
      return dest;
    }
  }, {
    key: "_translate",
    value: function _translate(src, tx, ty, dest) {
      dest || (dest = new Float32Array(src.length));
      for (var i = 0, ii = src.length; i < ii; i += 2) {
        dest[i] = tx + src[i];
        dest[i + 1] = ty + src[i + 1];
      }
      return dest;
    }
  }, {
    key: "svgRound",
    value: function svgRound(x) {
      return Math.round(x * 10000);
    }
  }, {
    key: "_normalizePoint",
    value: function _normalizePoint(x, y, parentWidth, parentHeight, rotation) {
      switch (rotation) {
        case 90:
          return [1 - y / parentWidth, x / parentHeight];
        case 180:
          return [1 - x / parentWidth, 1 - y / parentHeight];
        case 270:
          return [y / parentWidth, 1 - x / parentHeight];
        default:
          return [x / parentWidth, y / parentHeight];
      }
    }
  }, {
    key: "_normalizePagePoint",
    value: function _normalizePagePoint(x, y, rotation) {
      switch (rotation) {
        case 90:
          return [1 - y, x];
        case 180:
          return [1 - x, 1 - y];
        case 270:
          return [y, 1 - x];
        default:
          return [x, y];
      }
    }
  }, {
    key: "createBezierPoints",
    value: function createBezierPoints(x1, y1, x2, y2, x3, y3) {
      return [(x1 + 5 * x2) / 6, (y1 + 5 * y2) / 6, (5 * x2 + x3) / 6, (5 * y2 + y3) / 6, (x2 + x3) / 2, (y2 + y3) / 2];
    }
  }]);
}();
outline_defineProperty(Outline, "PRECISION", 1e-4);

;// ./src/display/editor/drawers/freedraw.js
function freedraw_typeof(o) { "@babel/helpers - typeof"; return freedraw_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, freedraw_typeof(o); }
function freedraw_toConsumableArray(r) { return freedraw_arrayWithoutHoles(r) || freedraw_iterableToArray(r) || freedraw_unsupportedIterableToArray(r) || freedraw_nonIterableSpread(); }
function freedraw_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function freedraw_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function freedraw_arrayWithoutHoles(r) { if (Array.isArray(r)) return freedraw_arrayLikeToArray(r); }
function freedraw_callSuper(t, o, e) { return o = freedraw_getPrototypeOf(o), freedraw_possibleConstructorReturn(t, freedraw_isNativeReflectConstruct() ? Reflect.construct(o, e || [], freedraw_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function freedraw_possibleConstructorReturn(t, e) { if (e && ("object" == freedraw_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return freedraw_assertThisInitialized(t); }
function freedraw_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function freedraw_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (freedraw_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function freedraw_getPrototypeOf(t) { return freedraw_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, freedraw_getPrototypeOf(t); }
function freedraw_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && freedraw_setPrototypeOf(t, e); }
function freedraw_setPrototypeOf(t, e) { return freedraw_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, freedraw_setPrototypeOf(t, e); }
function freedraw_slicedToArray(r, e) { return freedraw_arrayWithHoles(r) || freedraw_iterableToArrayLimit(r, e) || freedraw_unsupportedIterableToArray(r, e) || freedraw_nonIterableRest(); }
function freedraw_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function freedraw_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return freedraw_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? freedraw_arrayLikeToArray(r, a) : void 0; } }
function freedraw_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function freedraw_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function freedraw_arrayWithHoles(r) { if (Array.isArray(r)) return r; }






























































function freedraw_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function freedraw_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, freedraw_toPropertyKey(o.key), o); } }
function freedraw_createClass(e, r, t) { return r && freedraw_defineProperties(e.prototype, r), t && freedraw_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function freedraw_toPropertyKey(t) { var i = freedraw_toPrimitive(t, "string"); return "symbol" == freedraw_typeof(i) ? i : i + ""; }
function freedraw_toPrimitive(t, r) { if ("object" != freedraw_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != freedraw_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function freedraw_classPrivateMethodInitSpec(e, a) { freedraw_checkPrivateRedeclaration(e, a), a.add(e); }
function freedraw_classPrivateFieldInitSpec(e, t, a) { freedraw_checkPrivateRedeclaration(e, t), t.set(e, a); }
function freedraw_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function freedraw_classPrivateFieldGet(s, a) { return s.get(freedraw_assertClassBrand(s, a)); }
function freedraw_classPrivateFieldSet(s, a, r) { return s.set(freedraw_assertClassBrand(s, a), r), r; }
function freedraw_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var _box = /*#__PURE__*/new WeakMap();
var _bottom = /*#__PURE__*/new WeakMap();
var _innerMargin = /*#__PURE__*/new WeakMap();
var _isLTR = /*#__PURE__*/new WeakMap();
var _top = /*#__PURE__*/new WeakMap();
var _last = /*#__PURE__*/new WeakMap();
var _lastX = /*#__PURE__*/new WeakMap();
var _lastY = /*#__PURE__*/new WeakMap();
var _min = /*#__PURE__*/new WeakMap();
var _min_dist = /*#__PURE__*/new WeakMap();
var _scaleFactor = /*#__PURE__*/new WeakMap();
var _thickness = /*#__PURE__*/new WeakMap();
var _points = /*#__PURE__*/new WeakMap();
var _FreeDrawOutliner_brand = /*#__PURE__*/new WeakSet();
var FreeDrawOutliner = /*#__PURE__*/function () {
  function FreeDrawOutliner(_ref, box, scaleFactor, thickness, isLTR) {
    var _x = _ref.x,
      _y = _ref.y;
    var innerMargin = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
    freedraw_classCallCheck(this, FreeDrawOutliner);
    freedraw_classPrivateMethodInitSpec(this, _FreeDrawOutliner_brand);
    freedraw_classPrivateFieldInitSpec(this, _box, void 0);
    freedraw_classPrivateFieldInitSpec(this, _bottom, []);
    freedraw_classPrivateFieldInitSpec(this, _innerMargin, void 0);
    freedraw_classPrivateFieldInitSpec(this, _isLTR, void 0);
    freedraw_classPrivateFieldInitSpec(this, _top, []);
    freedraw_classPrivateFieldInitSpec(this, _last, new Float32Array(18));
    freedraw_classPrivateFieldInitSpec(this, _lastX, void 0);
    freedraw_classPrivateFieldInitSpec(this, _lastY, void 0);
    freedraw_classPrivateFieldInitSpec(this, _min, void 0);
    freedraw_classPrivateFieldInitSpec(this, _min_dist, void 0);
    freedraw_classPrivateFieldInitSpec(this, _scaleFactor, void 0);
    freedraw_classPrivateFieldInitSpec(this, _thickness, void 0);
    freedraw_classPrivateFieldInitSpec(this, _points, []);
    freedraw_classPrivateFieldSet(_box, this, box);
    freedraw_classPrivateFieldSet(_thickness, this, thickness * scaleFactor);
    freedraw_classPrivateFieldSet(_isLTR, this, isLTR);
    freedraw_classPrivateFieldGet(_last, this).set([NaN, NaN, NaN, NaN, _x, _y], 6);
    freedraw_classPrivateFieldSet(_innerMargin, this, innerMargin);
    freedraw_classPrivateFieldSet(_min_dist, this, _MIN_DIST._ * scaleFactor);
    freedraw_classPrivateFieldSet(_min, this, _MIN._ * scaleFactor);
    freedraw_classPrivateFieldSet(_scaleFactor, this, scaleFactor);
    freedraw_classPrivateFieldGet(_points, this).push(_x, _y);
  }
  return freedraw_createClass(FreeDrawOutliner, [{
    key: "isEmpty",
    value: function isEmpty() {
      return isNaN(freedraw_classPrivateFieldGet(_last, this)[8]);
    }
  }, {
    key: "add",
    value: function add(_ref2) {
      var _classPrivateFieldGet6;
      var x = _ref2.x,
        y = _ref2.y;
      freedraw_classPrivateFieldSet(_lastX, this, x);
      freedraw_classPrivateFieldSet(_lastY, this, y);
      var _classPrivateFieldGet2 = freedraw_classPrivateFieldGet(_box, this),
        _classPrivateFieldGet3 = freedraw_slicedToArray(_classPrivateFieldGet2, 4),
        layerX = _classPrivateFieldGet3[0],
        layerY = _classPrivateFieldGet3[1],
        layerWidth = _classPrivateFieldGet3[2],
        layerHeight = _classPrivateFieldGet3[3];
      var _classPrivateFieldGet4 = freedraw_classPrivateFieldGet(_last, this).subarray(8, 12),
        _classPrivateFieldGet5 = freedraw_slicedToArray(_classPrivateFieldGet4, 4),
        x1 = _classPrivateFieldGet5[0],
        y1 = _classPrivateFieldGet5[1],
        x2 = _classPrivateFieldGet5[2],
        y2 = _classPrivateFieldGet5[3];
      var diffX = x - x2;
      var diffY = y - y2;
      var d = Math.hypot(diffX, diffY);
      if (d < freedraw_classPrivateFieldGet(_min, this)) {
        return false;
      }
      var diffD = d - freedraw_classPrivateFieldGet(_min_dist, this);
      var K = diffD / d;
      var shiftX = K * diffX;
      var shiftY = K * diffY;
      var x0 = x1;
      var y0 = y1;
      x1 = x2;
      y1 = y2;
      x2 += shiftX;
      y2 += shiftY;
      (_classPrivateFieldGet6 = freedraw_classPrivateFieldGet(_points, this)) === null || _classPrivateFieldGet6 === void 0 || _classPrivateFieldGet6.push(x, y);
      var nX = -shiftY / diffD;
      var nY = shiftX / diffD;
      var thX = nX * freedraw_classPrivateFieldGet(_thickness, this);
      var thY = nY * freedraw_classPrivateFieldGet(_thickness, this);
      freedraw_classPrivateFieldGet(_last, this).set(freedraw_classPrivateFieldGet(_last, this).subarray(2, 8), 0);
      freedraw_classPrivateFieldGet(_last, this).set([x2 + thX, y2 + thY], 4);
      freedraw_classPrivateFieldGet(_last, this).set(freedraw_classPrivateFieldGet(_last, this).subarray(14, 18), 12);
      freedraw_classPrivateFieldGet(_last, this).set([x2 - thX, y2 - thY], 16);
      if (isNaN(freedraw_classPrivateFieldGet(_last, this)[6])) {
        if (freedraw_classPrivateFieldGet(_top, this).length === 0) {
          freedraw_classPrivateFieldGet(_last, this).set([x1 + thX, y1 + thY], 2);
          freedraw_classPrivateFieldGet(_top, this).push(NaN, NaN, NaN, NaN, (x1 + thX - layerX) / layerWidth, (y1 + thY - layerY) / layerHeight);
          freedraw_classPrivateFieldGet(_last, this).set([x1 - thX, y1 - thY], 14);
          freedraw_classPrivateFieldGet(_bottom, this).push(NaN, NaN, NaN, NaN, (x1 - thX - layerX) / layerWidth, (y1 - thY - layerY) / layerHeight);
        }
        freedraw_classPrivateFieldGet(_last, this).set([x0, y0, x1, y1, x2, y2], 6);
        return !this.isEmpty();
      }
      freedraw_classPrivateFieldGet(_last, this).set([x0, y0, x1, y1, x2, y2], 6);
      var angle = Math.abs(Math.atan2(y0 - y1, x0 - x1) - Math.atan2(shiftY, shiftX));
      if (angle < Math.PI / 2) {
        var _classPrivateFieldGet7 = freedraw_classPrivateFieldGet(_last, this).subarray(2, 6);
        var _classPrivateFieldGet8 = freedraw_slicedToArray(_classPrivateFieldGet7, 4);
        x1 = _classPrivateFieldGet8[0];
        y1 = _classPrivateFieldGet8[1];
        x2 = _classPrivateFieldGet8[2];
        y2 = _classPrivateFieldGet8[3];
        freedraw_classPrivateFieldGet(_top, this).push(NaN, NaN, NaN, NaN, ((x1 + x2) / 2 - layerX) / layerWidth, ((y1 + y2) / 2 - layerY) / layerHeight);
        var _classPrivateFieldGet9 = freedraw_classPrivateFieldGet(_last, this).subarray(14, 18);
        var _classPrivateFieldGet10 = freedraw_slicedToArray(_classPrivateFieldGet9, 4);
        x1 = _classPrivateFieldGet10[0];
        y1 = _classPrivateFieldGet10[1];
        x0 = _classPrivateFieldGet10[2];
        y0 = _classPrivateFieldGet10[3];
        freedraw_classPrivateFieldGet(_bottom, this).push(NaN, NaN, NaN, NaN, ((x0 + x1) / 2 - layerX) / layerWidth, ((y0 + y1) / 2 - layerY) / layerHeight);
        return true;
      }
      var _classPrivateFieldGet11 = freedraw_classPrivateFieldGet(_last, this).subarray(0, 6);
      var _classPrivateFieldGet12 = freedraw_slicedToArray(_classPrivateFieldGet11, 6);
      x0 = _classPrivateFieldGet12[0];
      y0 = _classPrivateFieldGet12[1];
      x1 = _classPrivateFieldGet12[2];
      y1 = _classPrivateFieldGet12[3];
      x2 = _classPrivateFieldGet12[4];
      y2 = _classPrivateFieldGet12[5];
      freedraw_classPrivateFieldGet(_top, this).push(((x0 + 5 * x1) / 6 - layerX) / layerWidth, ((y0 + 5 * y1) / 6 - layerY) / layerHeight, ((5 * x1 + x2) / 6 - layerX) / layerWidth, ((5 * y1 + y2) / 6 - layerY) / layerHeight, ((x1 + x2) / 2 - layerX) / layerWidth, ((y1 + y2) / 2 - layerY) / layerHeight);
      var _classPrivateFieldGet13 = freedraw_classPrivateFieldGet(_last, this).subarray(12, 18);
      var _classPrivateFieldGet14 = freedraw_slicedToArray(_classPrivateFieldGet13, 6);
      x2 = _classPrivateFieldGet14[0];
      y2 = _classPrivateFieldGet14[1];
      x1 = _classPrivateFieldGet14[2];
      y1 = _classPrivateFieldGet14[3];
      x0 = _classPrivateFieldGet14[4];
      y0 = _classPrivateFieldGet14[5];
      freedraw_classPrivateFieldGet(_bottom, this).push(((x0 + 5 * x1) / 6 - layerX) / layerWidth, ((y0 + 5 * y1) / 6 - layerY) / layerHeight, ((5 * x1 + x2) / 6 - layerX) / layerWidth, ((5 * y1 + y2) / 6 - layerY) / layerHeight, ((x1 + x2) / 2 - layerX) / layerWidth, ((y1 + y2) / 2 - layerY) / layerHeight);
      return true;
    }
  }, {
    key: "toSVGPath",
    value: function toSVGPath() {
      if (this.isEmpty()) {
        return "";
      }
      var top = freedraw_classPrivateFieldGet(_top, this);
      var bottom = freedraw_classPrivateFieldGet(_bottom, this);
      if (isNaN(freedraw_classPrivateFieldGet(_last, this)[6]) && !this.isEmpty()) {
        return freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _toSVGPathTwoPoints).call(this);
      }
      var buffer = [];
      buffer.push("M".concat(top[4], " ").concat(top[5]));
      for (var i = 6; i < top.length; i += 6) {
        if (isNaN(top[i])) {
          buffer.push("L".concat(top[i + 4], " ").concat(top[i + 5]));
        } else {
          buffer.push("C".concat(top[i], " ").concat(top[i + 1], " ").concat(top[i + 2], " ").concat(top[i + 3], " ").concat(top[i + 4], " ").concat(top[i + 5]));
        }
      }
      freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _toSVGPathEnd).call(this, buffer);
      for (var _i = bottom.length - 6; _i >= 6; _i -= 6) {
        if (isNaN(bottom[_i])) {
          buffer.push("L".concat(bottom[_i + 4], " ").concat(bottom[_i + 5]));
        } else {
          buffer.push("C".concat(bottom[_i], " ").concat(bottom[_i + 1], " ").concat(bottom[_i + 2], " ").concat(bottom[_i + 3], " ").concat(bottom[_i + 4], " ").concat(bottom[_i + 5]));
        }
      }
      freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _toSVGPathStart).call(this, buffer);
      return buffer.join(" ");
    }
  }, {
    key: "newFreeDrawOutline",
    value: function newFreeDrawOutline(outline, points, box, scaleFactor, innerMargin, isLTR) {
      return new FreeDrawOutline(outline, points, box, scaleFactor, innerMargin, isLTR);
    }
  }, {
    key: "getOutlines",
    value: function getOutlines() {
      var _classPrivateFieldGet17, _classPrivateFieldGet18;
      var top = freedraw_classPrivateFieldGet(_top, this);
      var bottom = freedraw_classPrivateFieldGet(_bottom, this);
      var last = freedraw_classPrivateFieldGet(_last, this);
      var _classPrivateFieldGet15 = freedraw_classPrivateFieldGet(_box, this),
        _classPrivateFieldGet16 = freedraw_slicedToArray(_classPrivateFieldGet15, 4),
        layerX = _classPrivateFieldGet16[0],
        layerY = _classPrivateFieldGet16[1],
        layerWidth = _classPrivateFieldGet16[2],
        layerHeight = _classPrivateFieldGet16[3];
      var points = new Float32Array(((_classPrivateFieldGet17 = (_classPrivateFieldGet18 = freedraw_classPrivateFieldGet(_points, this)) === null || _classPrivateFieldGet18 === void 0 ? void 0 : _classPrivateFieldGet18.length) !== null && _classPrivateFieldGet17 !== void 0 ? _classPrivateFieldGet17 : 0) + 2);
      for (var i = 0, ii = points.length - 2; i < ii; i += 2) {
        points[i] = (freedraw_classPrivateFieldGet(_points, this)[i] - layerX) / layerWidth;
        points[i + 1] = (freedraw_classPrivateFieldGet(_points, this)[i + 1] - layerY) / layerHeight;
      }
      points[points.length - 2] = (freedraw_classPrivateFieldGet(_lastX, this) - layerX) / layerWidth;
      points[points.length - 1] = (freedraw_classPrivateFieldGet(_lastY, this) - layerY) / layerHeight;
      if (isNaN(last[6]) && !this.isEmpty()) {
        return freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getOutlineTwoPoints).call(this, points);
      }
      var outline = new Float32Array(freedraw_classPrivateFieldGet(_top, this).length + 24 + freedraw_classPrivateFieldGet(_bottom, this).length);
      var N = top.length;
      for (var _i2 = 0; _i2 < N; _i2 += 2) {
        if (isNaN(top[_i2])) {
          outline[_i2] = outline[_i2 + 1] = NaN;
          continue;
        }
        outline[_i2] = top[_i2];
        outline[_i2 + 1] = top[_i2 + 1];
      }
      N = freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getOutlineEnd).call(this, outline, N);
      for (var _i3 = bottom.length - 6; _i3 >= 6; _i3 -= 6) {
        for (var j = 0; j < 6; j += 2) {
          if (isNaN(bottom[_i3 + j])) {
            outline[N] = outline[N + 1] = NaN;
            N += 2;
            continue;
          }
          outline[N] = bottom[_i3 + j];
          outline[N + 1] = bottom[_i3 + j + 1];
          N += 2;
        }
      }
      freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getOutlineStart).call(this, outline, N);
      return this.newFreeDrawOutline(outline, points, freedraw_classPrivateFieldGet(_box, this), freedraw_classPrivateFieldGet(_scaleFactor, this), freedraw_classPrivateFieldGet(_innerMargin, this), freedraw_classPrivateFieldGet(_isLTR, this));
    }
  }]);
}();
function _getLastCoords() {
  var lastTop = freedraw_classPrivateFieldGet(_last, this).subarray(4, 6);
  var lastBottom = freedraw_classPrivateFieldGet(_last, this).subarray(16, 18);
  var _classPrivateFieldGet25 = freedraw_classPrivateFieldGet(_box, this),
    _classPrivateFieldGet26 = freedraw_slicedToArray(_classPrivateFieldGet25, 4),
    x = _classPrivateFieldGet26[0],
    y = _classPrivateFieldGet26[1],
    width = _classPrivateFieldGet26[2],
    height = _classPrivateFieldGet26[3];
  return [(freedraw_classPrivateFieldGet(_lastX, this) + (lastTop[0] - lastBottom[0]) / 2 - x) / width, (freedraw_classPrivateFieldGet(_lastY, this) + (lastTop[1] - lastBottom[1]) / 2 - y) / height, (freedraw_classPrivateFieldGet(_lastX, this) + (lastBottom[0] - lastTop[0]) / 2 - x) / width, (freedraw_classPrivateFieldGet(_lastY, this) + (lastBottom[1] - lastTop[1]) / 2 - y) / height];
}
function _toSVGPathTwoPoints() {
  var _classPrivateFieldGet27 = freedraw_classPrivateFieldGet(_box, this),
    _classPrivateFieldGet28 = freedraw_slicedToArray(_classPrivateFieldGet27, 4),
    x = _classPrivateFieldGet28[0],
    y = _classPrivateFieldGet28[1],
    width = _classPrivateFieldGet28[2],
    height = _classPrivateFieldGet28[3];
  var _assertClassBrand$cal = freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getLastCoords).call(this),
    _assertClassBrand$cal2 = freedraw_slicedToArray(_assertClassBrand$cal, 4),
    lastTopX = _assertClassBrand$cal2[0],
    lastTopY = _assertClassBrand$cal2[1],
    lastBottomX = _assertClassBrand$cal2[2],
    lastBottomY = _assertClassBrand$cal2[3];
  return "M".concat((freedraw_classPrivateFieldGet(_last, this)[2] - x) / width, " ").concat((freedraw_classPrivateFieldGet(_last, this)[3] - y) / height, " L").concat((freedraw_classPrivateFieldGet(_last, this)[4] - x) / width, " ").concat((freedraw_classPrivateFieldGet(_last, this)[5] - y) / height, " L").concat(lastTopX, " ").concat(lastTopY, " L").concat(lastBottomX, " ").concat(lastBottomY, " L").concat((freedraw_classPrivateFieldGet(_last, this)[16] - x) / width, " ").concat((freedraw_classPrivateFieldGet(_last, this)[17] - y) / height, " L").concat((freedraw_classPrivateFieldGet(_last, this)[14] - x) / width, " ").concat((freedraw_classPrivateFieldGet(_last, this)[15] - y) / height, " Z");
}
function _toSVGPathStart(buffer) {
  var bottom = freedraw_classPrivateFieldGet(_bottom, this);
  buffer.push("L".concat(bottom[4], " ").concat(bottom[5], " Z"));
}
function _toSVGPathEnd(buffer) {
  var _classPrivateFieldGet29 = freedraw_classPrivateFieldGet(_box, this),
    _classPrivateFieldGet30 = freedraw_slicedToArray(_classPrivateFieldGet29, 4),
    x = _classPrivateFieldGet30[0],
    y = _classPrivateFieldGet30[1],
    width = _classPrivateFieldGet30[2],
    height = _classPrivateFieldGet30[3];
  var lastTop = freedraw_classPrivateFieldGet(_last, this).subarray(4, 6);
  var lastBottom = freedraw_classPrivateFieldGet(_last, this).subarray(16, 18);
  var _assertClassBrand$cal3 = freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getLastCoords).call(this),
    _assertClassBrand$cal4 = freedraw_slicedToArray(_assertClassBrand$cal3, 4),
    lastTopX = _assertClassBrand$cal4[0],
    lastTopY = _assertClassBrand$cal4[1],
    lastBottomX = _assertClassBrand$cal4[2],
    lastBottomY = _assertClassBrand$cal4[3];
  buffer.push("L".concat((lastTop[0] - x) / width, " ").concat((lastTop[1] - y) / height, " L").concat(lastTopX, " ").concat(lastTopY, " L").concat(lastBottomX, " ").concat(lastBottomY, " L").concat((lastBottom[0] - x) / width, " ").concat((lastBottom[1] - y) / height));
}
function _getOutlineTwoPoints(points) {
  var last = freedraw_classPrivateFieldGet(_last, this);
  var _classPrivateFieldGet31 = freedraw_classPrivateFieldGet(_box, this),
    _classPrivateFieldGet32 = freedraw_slicedToArray(_classPrivateFieldGet31, 4),
    layerX = _classPrivateFieldGet32[0],
    layerY = _classPrivateFieldGet32[1],
    layerWidth = _classPrivateFieldGet32[2],
    layerHeight = _classPrivateFieldGet32[3];
  var _assertClassBrand$cal5 = freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getLastCoords).call(this),
    _assertClassBrand$cal6 = freedraw_slicedToArray(_assertClassBrand$cal5, 4),
    lastTopX = _assertClassBrand$cal6[0],
    lastTopY = _assertClassBrand$cal6[1],
    lastBottomX = _assertClassBrand$cal6[2],
    lastBottomY = _assertClassBrand$cal6[3];
  var outline = new Float32Array(36);
  outline.set([NaN, NaN, NaN, NaN, (last[2] - layerX) / layerWidth, (last[3] - layerY) / layerHeight, NaN, NaN, NaN, NaN, (last[4] - layerX) / layerWidth, (last[5] - layerY) / layerHeight, NaN, NaN, NaN, NaN, lastTopX, lastTopY, NaN, NaN, NaN, NaN, lastBottomX, lastBottomY, NaN, NaN, NaN, NaN, (last[16] - layerX) / layerWidth, (last[17] - layerY) / layerHeight, NaN, NaN, NaN, NaN, (last[14] - layerX) / layerWidth, (last[15] - layerY) / layerHeight], 0);
  return this.newFreeDrawOutline(outline, points, freedraw_classPrivateFieldGet(_box, this), freedraw_classPrivateFieldGet(_scaleFactor, this), freedraw_classPrivateFieldGet(_innerMargin, this), freedraw_classPrivateFieldGet(_isLTR, this));
}
function _getOutlineStart(outline, pos) {
  var bottom = freedraw_classPrivateFieldGet(_bottom, this);
  outline.set([NaN, NaN, NaN, NaN, bottom[4], bottom[5]], pos);
  return pos += 6;
}
function _getOutlineEnd(outline, pos) {
  var lastTop = freedraw_classPrivateFieldGet(_last, this).subarray(4, 6);
  var lastBottom = freedraw_classPrivateFieldGet(_last, this).subarray(16, 18);
  var _classPrivateFieldGet33 = freedraw_classPrivateFieldGet(_box, this),
    _classPrivateFieldGet34 = freedraw_slicedToArray(_classPrivateFieldGet33, 4),
    layerX = _classPrivateFieldGet34[0],
    layerY = _classPrivateFieldGet34[1],
    layerWidth = _classPrivateFieldGet34[2],
    layerHeight = _classPrivateFieldGet34[3];
  var _assertClassBrand$cal7 = freedraw_assertClassBrand(_FreeDrawOutliner_brand, this, _getLastCoords).call(this),
    _assertClassBrand$cal8 = freedraw_slicedToArray(_assertClassBrand$cal7, 4),
    lastTopX = _assertClassBrand$cal8[0],
    lastTopY = _assertClassBrand$cal8[1],
    lastBottomX = _assertClassBrand$cal8[2],
    lastBottomY = _assertClassBrand$cal8[3];
  outline.set([NaN, NaN, NaN, NaN, (lastTop[0] - layerX) / layerWidth, (lastTop[1] - layerY) / layerHeight, NaN, NaN, NaN, NaN, lastTopX, lastTopY, NaN, NaN, NaN, NaN, lastBottomX, lastBottomY, NaN, NaN, NaN, NaN, (lastBottom[0] - layerX) / layerWidth, (lastBottom[1] - layerY) / layerHeight], pos);
  return pos += 24;
}
var _MIN_DIST = {
  _: 8
};
var _MIN_DIFF = {
  _: 2
};
var _MIN = {
  _: _MIN_DIST._ + _MIN_DIFF._
};
var _box2 = /*#__PURE__*/new WeakMap();
var _bbox = /*#__PURE__*/new WeakMap();
var _innerMargin2 = /*#__PURE__*/new WeakMap();
var _isLTR2 = /*#__PURE__*/new WeakMap();
var _points2 = /*#__PURE__*/new WeakMap();
var _scaleFactor2 = /*#__PURE__*/new WeakMap();
var _outline = /*#__PURE__*/new WeakMap();
var _FreeDrawOutline_brand = /*#__PURE__*/new WeakSet();
var FreeDrawOutline = /*#__PURE__*/function (_Outline) {
  function FreeDrawOutline(_outline2, points, box, scaleFactor, innerMargin, _isLTR3) {
    var _this;
    freedraw_classCallCheck(this, FreeDrawOutline);
    _this = freedraw_callSuper(this, FreeDrawOutline);
    freedraw_classPrivateMethodInitSpec(_this, _FreeDrawOutline_brand);
    freedraw_classPrivateFieldInitSpec(_this, _box2, void 0);
    freedraw_classPrivateFieldInitSpec(_this, _bbox, new Float32Array(4));
    freedraw_classPrivateFieldInitSpec(_this, _innerMargin2, void 0);
    freedraw_classPrivateFieldInitSpec(_this, _isLTR2, void 0);
    freedraw_classPrivateFieldInitSpec(_this, _points2, void 0);
    freedraw_classPrivateFieldInitSpec(_this, _scaleFactor2, void 0);
    freedraw_classPrivateFieldInitSpec(_this, _outline, void 0);
    freedraw_classPrivateFieldSet(_outline, _this, _outline2);
    freedraw_classPrivateFieldSet(_points2, _this, points);
    freedraw_classPrivateFieldSet(_box2, _this, box);
    freedraw_classPrivateFieldSet(_scaleFactor2, _this, scaleFactor);
    freedraw_classPrivateFieldSet(_innerMargin2, _this, innerMargin);
    freedraw_classPrivateFieldSet(_isLTR2, _this, _isLTR3);
    _this.lastPoint = [NaN, NaN];
    freedraw_assertClassBrand(_FreeDrawOutline_brand, _this, _computeMinMax).call(_this, _isLTR3);
    var _classPrivateFieldGet19 = freedraw_classPrivateFieldGet(_bbox, _this),
      _classPrivateFieldGet20 = freedraw_slicedToArray(_classPrivateFieldGet19, 4),
      x = _classPrivateFieldGet20[0],
      y = _classPrivateFieldGet20[1],
      width = _classPrivateFieldGet20[2],
      height = _classPrivateFieldGet20[3];
    for (var i = 0, ii = _outline2.length; i < ii; i += 2) {
      _outline2[i] = (_outline2[i] - x) / width;
      _outline2[i + 1] = (_outline2[i + 1] - y) / height;
    }
    for (var _i4 = 0, _ii = points.length; _i4 < _ii; _i4 += 2) {
      points[_i4] = (points[_i4] - x) / width;
      points[_i4 + 1] = (points[_i4 + 1] - y) / height;
    }
    return _this;
  }
  freedraw_inherits(FreeDrawOutline, _Outline);
  return freedraw_createClass(FreeDrawOutline, [{
    key: "toSVGPath",
    value: function toSVGPath() {
      var buffer = ["M".concat(freedraw_classPrivateFieldGet(_outline, this)[4], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[5])];
      for (var i = 6, ii = freedraw_classPrivateFieldGet(_outline, this).length; i < ii; i += 6) {
        if (isNaN(freedraw_classPrivateFieldGet(_outline, this)[i])) {
          buffer.push("L".concat(freedraw_classPrivateFieldGet(_outline, this)[i + 4], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 5]));
          continue;
        }
        buffer.push("C".concat(freedraw_classPrivateFieldGet(_outline, this)[i], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 1], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 2], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 3], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 4], " ").concat(freedraw_classPrivateFieldGet(_outline, this)[i + 5]));
      }
      buffer.push("Z");
      return buffer.join(" ");
    }
  }, {
    key: "serialize",
    value: function serialize(_ref3, rotation) {
      var _ref4 = freedraw_slicedToArray(_ref3, 4),
        blX = _ref4[0],
        blY = _ref4[1],
        trX = _ref4[2],
        trY = _ref4[3];
      var width = trX - blX;
      var height = trY - blY;
      var outline;
      var points;
      switch (rotation) {
        case 0:
          outline = Outline._rescale(freedraw_classPrivateFieldGet(_outline, this), blX, trY, width, -height);
          points = Outline._rescale(freedraw_classPrivateFieldGet(_points2, this), blX, trY, width, -height);
          break;
        case 90:
          outline = Outline._rescaleAndSwap(freedraw_classPrivateFieldGet(_outline, this), blX, blY, width, height);
          points = Outline._rescaleAndSwap(freedraw_classPrivateFieldGet(_points2, this), blX, blY, width, height);
          break;
        case 180:
          outline = Outline._rescale(freedraw_classPrivateFieldGet(_outline, this), trX, blY, -width, height);
          points = Outline._rescale(freedraw_classPrivateFieldGet(_points2, this), trX, blY, -width, height);
          break;
        case 270:
          outline = Outline._rescaleAndSwap(freedraw_classPrivateFieldGet(_outline, this), trX, trY, -width, -height);
          points = Outline._rescaleAndSwap(freedraw_classPrivateFieldGet(_points2, this), trX, trY, -width, -height);
          break;
      }
      return {
        outline: Array.from(outline),
        points: [Array.from(points)]
      };
    }
  }, {
    key: "box",
    get: function get() {
      return freedraw_classPrivateFieldGet(_bbox, this);
    }
  }, {
    key: "newOutliner",
    value: function newOutliner(point, box, scaleFactor, thickness, isLTR) {
      var innerMargin = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
      return new FreeDrawOutliner(point, box, scaleFactor, thickness, isLTR, innerMargin);
    }
  }, {
    key: "getNewOutline",
    value: function getNewOutline(thickness, innerMargin) {
      var _classPrivateFieldGet21 = freedraw_classPrivateFieldGet(_bbox, this),
        _classPrivateFieldGet22 = freedraw_slicedToArray(_classPrivateFieldGet21, 4),
        x = _classPrivateFieldGet22[0],
        y = _classPrivateFieldGet22[1],
        width = _classPrivateFieldGet22[2],
        height = _classPrivateFieldGet22[3];
      var _classPrivateFieldGet23 = freedraw_classPrivateFieldGet(_box2, this),
        _classPrivateFieldGet24 = freedraw_slicedToArray(_classPrivateFieldGet23, 4),
        layerX = _classPrivateFieldGet24[0],
        layerY = _classPrivateFieldGet24[1],
        layerWidth = _classPrivateFieldGet24[2],
        layerHeight = _classPrivateFieldGet24[3];
      var sx = width * layerWidth;
      var sy = height * layerHeight;
      var tx = x * layerWidth + layerX;
      var ty = y * layerHeight + layerY;
      var outliner = this.newOutliner({
        x: freedraw_classPrivateFieldGet(_points2, this)[0] * sx + tx,
        y: freedraw_classPrivateFieldGet(_points2, this)[1] * sy + ty
      }, freedraw_classPrivateFieldGet(_box2, this), freedraw_classPrivateFieldGet(_scaleFactor2, this), thickness, freedraw_classPrivateFieldGet(_isLTR2, this), innerMargin !== null && innerMargin !== void 0 ? innerMargin : freedraw_classPrivateFieldGet(_innerMargin2, this));
      for (var i = 2; i < freedraw_classPrivateFieldGet(_points2, this).length; i += 2) {
        outliner.add({
          x: freedraw_classPrivateFieldGet(_points2, this)[i] * sx + tx,
          y: freedraw_classPrivateFieldGet(_points2, this)[i + 1] * sy + ty
        });
      }
      return outliner.getOutlines();
    }
  }]);
}(Outline);
function _computeMinMax(isLTR) {
  var outline = freedraw_classPrivateFieldGet(_outline, this);
  var lastX = outline[4];
  var lastY = outline[5];
  var minX = lastX;
  var minY = lastY;
  var maxX = lastX;
  var maxY = lastY;
  var lastPointX = lastX;
  var lastPointY = lastY;
  var ltrCallback = isLTR ? Math.max : Math.min;
  for (var i = 6, ii = outline.length; i < ii; i += 6) {
    if (isNaN(outline[i])) {
      minX = Math.min(minX, outline[i + 4]);
      minY = Math.min(minY, outline[i + 5]);
      maxX = Math.max(maxX, outline[i + 4]);
      maxY = Math.max(maxY, outline[i + 5]);
      if (lastPointY < outline[i + 5]) {
        lastPointX = outline[i + 4];
        lastPointY = outline[i + 5];
      } else if (lastPointY === outline[i + 5]) {
        lastPointX = ltrCallback(lastPointX, outline[i + 4]);
      }
    } else {
      var _bbox2 = Util.bezierBoundingBox.apply(Util, [lastX, lastY].concat(freedraw_toConsumableArray(outline.slice(i, i + 6))));
      minX = Math.min(minX, _bbox2[0]);
      minY = Math.min(minY, _bbox2[1]);
      maxX = Math.max(maxX, _bbox2[2]);
      maxY = Math.max(maxY, _bbox2[3]);
      if (lastPointY < _bbox2[3]) {
        lastPointX = _bbox2[2];
        lastPointY = _bbox2[3];
      } else if (lastPointY === _bbox2[3]) {
        lastPointX = ltrCallback(lastPointX, _bbox2[2]);
      }
    }
    lastX = outline[i + 4];
    lastY = outline[i + 5];
  }
  var bbox = freedraw_classPrivateFieldGet(_bbox, this);
  bbox[0] = minX - freedraw_classPrivateFieldGet(_innerMargin2, this);
  bbox[1] = minY - freedraw_classPrivateFieldGet(_innerMargin2, this);
  bbox[2] = maxX - minX + 2 * freedraw_classPrivateFieldGet(_innerMargin2, this);
  bbox[3] = maxY - minY + 2 * freedraw_classPrivateFieldGet(_innerMargin2, this);
  this.lastPoint = [lastPointX, lastPointY];
}

;// ./src/display/editor/drawers/highlight.js
function highlight_typeof(o) { "@babel/helpers - typeof"; return highlight_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, highlight_typeof(o); }
function highlight_callSuper(t, o, e) { return o = highlight_getPrototypeOf(o), highlight_possibleConstructorReturn(t, highlight_isNativeReflectConstruct() ? Reflect.construct(o, e || [], highlight_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function highlight_possibleConstructorReturn(t, e) { if (e && ("object" == highlight_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return highlight_assertThisInitialized(t); }
function highlight_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function highlight_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (highlight_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function highlight_getPrototypeOf(t) { return highlight_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, highlight_getPrototypeOf(t); }
function highlight_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && highlight_setPrototypeOf(t, e); }
function highlight_setPrototypeOf(t, e) { return highlight_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, highlight_setPrototypeOf(t, e); }
function highlight_toConsumableArray(r) { return highlight_arrayWithoutHoles(r) || highlight_iterableToArray(r) || highlight_unsupportedIterableToArray(r) || highlight_nonIterableSpread(); }
function highlight_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function highlight_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function highlight_arrayWithoutHoles(r) { if (Array.isArray(r)) return highlight_arrayLikeToArray(r); }
function highlight_slicedToArray(r, e) { return highlight_arrayWithHoles(r) || highlight_iterableToArrayLimit(r, e) || highlight_unsupportedIterableToArray(r, e) || highlight_nonIterableRest(); }
function highlight_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function highlight_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function highlight_arrayWithHoles(r) { if (Array.isArray(r)) return r; }









































































function highlight_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = highlight_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function highlight_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return highlight_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? highlight_arrayLikeToArray(r, a) : void 0; } }
function highlight_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function highlight_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function highlight_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, highlight_toPropertyKey(o.key), o); } }
function highlight_createClass(e, r, t) { return r && highlight_defineProperties(e.prototype, r), t && highlight_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function highlight_toPropertyKey(t) { var i = highlight_toPrimitive(t, "string"); return "symbol" == highlight_typeof(i) ? i : i + ""; }
function highlight_toPrimitive(t, r) { if ("object" != highlight_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != highlight_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function highlight_classPrivateMethodInitSpec(e, a) { highlight_checkPrivateRedeclaration(e, a), a.add(e); }
function highlight_classPrivateFieldInitSpec(e, t, a) { highlight_checkPrivateRedeclaration(e, t), t.set(e, a); }
function highlight_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function highlight_classPrivateFieldSet(s, a, r) { return s.set(highlight_assertClassBrand(s, a), r), r; }
function highlight_classPrivateFieldGet(s, a) { return s.get(highlight_assertClassBrand(s, a)); }
function highlight_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var highlight_box = /*#__PURE__*/new WeakMap();
var _lastPoint = /*#__PURE__*/new WeakMap();
var _verticalEdges = /*#__PURE__*/new WeakMap();
var _intervals = /*#__PURE__*/new WeakMap();
var _HighlightOutliner_brand = /*#__PURE__*/new WeakSet();
var HighlightOutliner = /*#__PURE__*/function () {
  function HighlightOutliner(boxes) {
    var borderWidth = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
    var innerMargin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var isLTR = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    highlight_classCallCheck(this, HighlightOutliner);
    highlight_classPrivateMethodInitSpec(this, _HighlightOutliner_brand);
    highlight_classPrivateFieldInitSpec(this, highlight_box, void 0);
    highlight_classPrivateFieldInitSpec(this, _lastPoint, void 0);
    highlight_classPrivateFieldInitSpec(this, _verticalEdges, []);
    highlight_classPrivateFieldInitSpec(this, _intervals, []);
    var minX = Infinity;
    var maxX = -Infinity;
    var minY = Infinity;
    var maxY = -Infinity;
    var NUMBER_OF_DIGITS = 4;
    var EPSILON = Math.pow(10, -NUMBER_OF_DIGITS);
    var _iterator = highlight_createForOfIteratorHelper(boxes),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _step.value,
          x = _step$value.x,
          y = _step$value.y,
          width = _step$value.width,
          height = _step$value.height;
        var x1 = Math.floor((x - borderWidth) / EPSILON) * EPSILON;
        var x2 = Math.ceil((x + width + borderWidth) / EPSILON) * EPSILON;
        var y1 = Math.floor((y - borderWidth) / EPSILON) * EPSILON;
        var y2 = Math.ceil((y + height + borderWidth) / EPSILON) * EPSILON;
        var left = [x1, y1, y2, true];
        var right = [x2, y1, y2, false];
        highlight_classPrivateFieldGet(_verticalEdges, this).push(left, right);
        minX = Math.min(minX, x1);
        maxX = Math.max(maxX, x2);
        minY = Math.min(minY, y1);
        maxY = Math.max(maxY, y2);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    var bboxWidth = maxX - minX + 2 * innerMargin;
    var bboxHeight = maxY - minY + 2 * innerMargin;
    var shiftedMinX = minX - innerMargin;
    var shiftedMinY = minY - innerMargin;
    var lastEdge = highlight_classPrivateFieldGet(_verticalEdges, this).at(isLTR ? -1 : -2);
    var lastPoint = [lastEdge[0], lastEdge[2]];
    var _iterator2 = highlight_createForOfIteratorHelper(highlight_classPrivateFieldGet(_verticalEdges, this)),
      _step2;
    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var edge = _step2.value;
        var _edge = highlight_slicedToArray(edge, 3),
          _x = _edge[0],
          _y = _edge[1],
          _y2 = _edge[2];
        edge[0] = (_x - shiftedMinX) / bboxWidth;
        edge[1] = (_y - shiftedMinY) / bboxHeight;
        edge[2] = (_y2 - shiftedMinY) / bboxHeight;
      }
    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }
    highlight_classPrivateFieldSet(highlight_box, this, new Float32Array([shiftedMinX, shiftedMinY, bboxWidth, bboxHeight]));
    highlight_classPrivateFieldSet(_lastPoint, this, lastPoint);
  }
  return highlight_createClass(HighlightOutliner, [{
    key: "getOutlines",
    value: function getOutlines() {
      highlight_classPrivateFieldGet(_verticalEdges, this).sort(function (a, b) {
        return a[0] - b[0] || a[1] - b[1] || a[2] - b[2];
      });
      var outlineVerticalEdges = [];
      var _iterator3 = highlight_createForOfIteratorHelper(highlight_classPrivateFieldGet(_verticalEdges, this)),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var edge = _step3.value;
          if (edge[3]) {
            outlineVerticalEdges.push.apply(outlineVerticalEdges, highlight_toConsumableArray(highlight_assertClassBrand(_HighlightOutliner_brand, this, _breakEdge).call(this, edge)));
            highlight_assertClassBrand(_HighlightOutliner_brand, this, _insert).call(this, edge);
          } else {
            highlight_assertClassBrand(_HighlightOutliner_brand, this, _remove).call(this, edge);
            outlineVerticalEdges.push.apply(outlineVerticalEdges, highlight_toConsumableArray(highlight_assertClassBrand(_HighlightOutliner_brand, this, _breakEdge).call(this, edge)));
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      return highlight_assertClassBrand(_HighlightOutliner_brand, this, _getOutlines).call(this, outlineVerticalEdges);
    }
  }]);
}();
function _getOutlines(outlineVerticalEdges) {
  var edges = [];
  var allEdges = new Set();
  var _iterator6 = highlight_createForOfIteratorHelper(outlineVerticalEdges),
    _step6;
  try {
    for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
      var _edge5 = _step6.value;
      var _edge6 = highlight_slicedToArray(_edge5, 3),
        _x2 = _edge6[0],
        _y3 = _edge6[1],
        _y4 = _edge6[2];
      edges.push([_x2, _y3, _edge5], [_x2, _y4, _edge5]);
    }
  } catch (err) {
    _iterator6.e(err);
  } finally {
    _iterator6.f();
  }
  edges.sort(function (a, b) {
    return a[1] - b[1] || a[0] - b[0];
  });
  for (var i = 0, ii = edges.length; i < ii; i += 2) {
    var edge1 = edges[i][2];
    var edge2 = edges[i + 1][2];
    edge1.push(edge2);
    edge2.push(edge1);
    allEdges.add(edge1);
    allEdges.add(edge2);
  }
  var outlines = [];
  var outline;
  while (allEdges.size > 0) {
    var edge = allEdges.values().next().value;
    var _edge2 = highlight_slicedToArray(edge, 5),
      x = _edge2[0],
      y1 = _edge2[1],
      y2 = _edge2[2],
      _edge3 = _edge2[3],
      _edge4 = _edge2[4];
    allEdges.delete(edge);
    var lastPointX = x;
    var lastPointY = y1;
    outline = [x, y2];
    outlines.push(outline);
    while (true) {
      var e = void 0;
      if (allEdges.has(_edge3)) {
        e = _edge3;
      } else if (allEdges.has(_edge4)) {
        e = _edge4;
      } else {
        break;
      }
      allEdges.delete(e);
      var _e = e;
      var _e2 = highlight_slicedToArray(_e, 5);
      x = _e2[0];
      y1 = _e2[1];
      y2 = _e2[2];
      _edge3 = _e2[3];
      _edge4 = _e2[4];
      if (lastPointX !== x) {
        outline.push(lastPointX, lastPointY, x, lastPointY === y1 ? y1 : y2);
        lastPointX = x;
      }
      lastPointY = lastPointY === y1 ? y2 : y1;
    }
    outline.push(lastPointX, lastPointY);
  }
  return new HighlightOutline(outlines, highlight_classPrivateFieldGet(highlight_box, this), highlight_classPrivateFieldGet(_lastPoint, this));
}
function _binarySearch(y) {
  var array = highlight_classPrivateFieldGet(_intervals, this);
  var start = 0;
  var end = array.length - 1;
  while (start <= end) {
    var middle = start + end >> 1;
    var y1 = array[middle][0];
    if (y1 === y) {
      return middle;
    }
    if (y1 < y) {
      start = middle + 1;
    } else {
      end = middle - 1;
    }
  }
  return end + 1;
}
function _insert(_ref3) {
  var _ref4 = highlight_slicedToArray(_ref3, 3),
    y1 = _ref4[1],
    y2 = _ref4[2];
  var index = highlight_assertClassBrand(_HighlightOutliner_brand, this, _binarySearch).call(this, y1);
  highlight_classPrivateFieldGet(_intervals, this).splice(index, 0, [y1, y2]);
}
function _remove(_ref5) {
  var _ref6 = highlight_slicedToArray(_ref5, 3),
    y1 = _ref6[1],
    y2 = _ref6[2];
  var index = highlight_assertClassBrand(_HighlightOutliner_brand, this, _binarySearch).call(this, y1);
  for (var i = index; i < highlight_classPrivateFieldGet(_intervals, this).length; i++) {
    var _classPrivateFieldGet2 = highlight_slicedToArray(highlight_classPrivateFieldGet(_intervals, this)[i], 2),
      start = _classPrivateFieldGet2[0],
      end = _classPrivateFieldGet2[1];
    if (start !== y1) {
      break;
    }
    if (start === y1 && end === y2) {
      highlight_classPrivateFieldGet(_intervals, this).splice(i, 1);
      return;
    }
  }
  for (var _i = index - 1; _i >= 0; _i--) {
    var _classPrivateFieldGet3 = highlight_slicedToArray(highlight_classPrivateFieldGet(_intervals, this)[_i], 2),
      _start = _classPrivateFieldGet3[0],
      _end = _classPrivateFieldGet3[1];
    if (_start !== y1) {
      break;
    }
    if (_start === y1 && _end === y2) {
      highlight_classPrivateFieldGet(_intervals, this).splice(_i, 1);
      return;
    }
  }
}
function _breakEdge(edge) {
  var _edge7 = highlight_slicedToArray(edge, 3),
    x = _edge7[0],
    y1 = _edge7[1],
    y2 = _edge7[2];
  var results = [[x, y1, y2]];
  var index = highlight_assertClassBrand(_HighlightOutliner_brand, this, _binarySearch).call(this, y2);
  for (var i = 0; i < index; i++) {
    var _classPrivateFieldGet4 = highlight_slicedToArray(highlight_classPrivateFieldGet(_intervals, this)[i], 2),
      start = _classPrivateFieldGet4[0],
      end = _classPrivateFieldGet4[1];
    for (var j = 0, jj = results.length; j < jj; j++) {
      var _results$j = highlight_slicedToArray(results[j], 3),
        y3 = _results$j[1],
        y4 = _results$j[2];
      if (end <= y3 || y4 <= start) {
        continue;
      }
      if (y3 >= start) {
        if (y4 > end) {
          results[j][1] = end;
        } else {
          if (jj === 1) {
            return [];
          }
          results.splice(j, 1);
          j--;
          jj--;
        }
        continue;
      }
      results[j][2] = start;
      if (y4 > end) {
        results.push([x, end, y4]);
      }
    }
  }
  return results;
}
var highlight_box2 = /*#__PURE__*/new WeakMap();
var _outlines = /*#__PURE__*/new WeakMap();
var HighlightOutline = /*#__PURE__*/function (_Outline) {
  function HighlightOutline(outlines, box, lastPoint) {
    var _this;
    highlight_classCallCheck(this, HighlightOutline);
    _this = highlight_callSuper(this, HighlightOutline);
    highlight_classPrivateFieldInitSpec(_this, highlight_box2, void 0);
    highlight_classPrivateFieldInitSpec(_this, _outlines, void 0);
    highlight_classPrivateFieldSet(_outlines, _this, outlines);
    highlight_classPrivateFieldSet(highlight_box2, _this, box);
    _this.lastPoint = lastPoint;
    return _this;
  }
  highlight_inherits(HighlightOutline, _Outline);
  return highlight_createClass(HighlightOutline, [{
    key: "toSVGPath",
    value: function toSVGPath() {
      var buffer = [];
      var _iterator4 = highlight_createForOfIteratorHelper(highlight_classPrivateFieldGet(_outlines, this)),
        _step4;
      try {
        for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
          var polygon = _step4.value;
          var _polygon = highlight_slicedToArray(polygon, 2),
            prevX = _polygon[0],
            prevY = _polygon[1];
          buffer.push("M".concat(prevX, " ").concat(prevY));
          for (var i = 2; i < polygon.length; i += 2) {
            var x = polygon[i];
            var y = polygon[i + 1];
            if (x === prevX) {
              buffer.push("V".concat(y));
              prevY = y;
            } else if (y === prevY) {
              buffer.push("H".concat(x));
              prevX = x;
            }
          }
          buffer.push("Z");
        }
      } catch (err) {
        _iterator4.e(err);
      } finally {
        _iterator4.f();
      }
      return buffer.join(" ");
    }
  }, {
    key: "serialize",
    value: function serialize(_ref, _rotation) {
      var _ref2 = highlight_slicedToArray(_ref, 4),
        blX = _ref2[0],
        blY = _ref2[1],
        trX = _ref2[2],
        trY = _ref2[3];
      var outlines = [];
      var width = trX - blX;
      var height = trY - blY;
      var _iterator5 = highlight_createForOfIteratorHelper(highlight_classPrivateFieldGet(_outlines, this)),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var outline = _step5.value;
          var points = new Array(outline.length);
          for (var i = 0; i < outline.length; i += 2) {
            points[i] = blX + outline[i] * width;
            points[i + 1] = trY - outline[i + 1] * height;
          }
          outlines.push(points);
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      return outlines;
    }
  }, {
    key: "box",
    get: function get() {
      return highlight_classPrivateFieldGet(highlight_box2, this);
    }
  }, {
    key: "classNamesForOutlining",
    get: function get() {
      return ["highlightOutline"];
    }
  }]);
}(Outline);
var FreeHighlightOutliner = /*#__PURE__*/function (_FreeDrawOutliner) {
  function FreeHighlightOutliner() {
    highlight_classCallCheck(this, FreeHighlightOutliner);
    return highlight_callSuper(this, FreeHighlightOutliner, arguments);
  }
  highlight_inherits(FreeHighlightOutliner, _FreeDrawOutliner);
  return highlight_createClass(FreeHighlightOutliner, [{
    key: "newFreeDrawOutline",
    value: function newFreeDrawOutline(outline, points, box, scaleFactor, innerMargin, isLTR) {
      return new FreeHighlightOutline(outline, points, box, scaleFactor, innerMargin, isLTR);
    }
  }]);
}(FreeDrawOutliner);
var FreeHighlightOutline = /*#__PURE__*/function (_FreeDrawOutline) {
  function FreeHighlightOutline() {
    highlight_classCallCheck(this, FreeHighlightOutline);
    return highlight_callSuper(this, FreeHighlightOutline, arguments);
  }
  highlight_inherits(FreeHighlightOutline, _FreeDrawOutline);
  return highlight_createClass(FreeHighlightOutline, [{
    key: "newOutliner",
    value: function newOutliner(point, box, scaleFactor, thickness, isLTR) {
      var innerMargin = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
      return new FreeHighlightOutliner(point, box, scaleFactor, thickness, isLTR, innerMargin);
    }
  }]);
}(FreeDrawOutline);

;// ./src/display/editor/color_picker.js











function color_picker_typeof(o) { "@babel/helpers - typeof"; return color_picker_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, color_picker_typeof(o); }
var _ColorPicker;
function color_picker_slicedToArray(r, e) { return color_picker_arrayWithHoles(r) || color_picker_iterableToArrayLimit(r, e) || color_picker_unsupportedIterableToArray(r, e) || color_picker_nonIterableRest(); }
function color_picker_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function color_picker_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function color_picker_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function color_picker_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = color_picker_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function color_picker_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return color_picker_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? color_picker_arrayLikeToArray(r, a) : void 0; } }
function color_picker_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }










function color_picker_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function color_picker_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, color_picker_toPropertyKey(o.key), o); } }
function color_picker_createClass(e, r, t) { return r && color_picker_defineProperties(e.prototype, r), t && color_picker_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function color_picker_toPropertyKey(t) { var i = color_picker_toPrimitive(t, "string"); return "symbol" == color_picker_typeof(i) ? i : i + ""; }
function color_picker_toPrimitive(t, r) { if ("object" != color_picker_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != color_picker_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function color_picker_classPrivateMethodInitSpec(e, a) { color_picker_checkPrivateRedeclaration(e, a), a.add(e); }
function color_picker_classPrivateFieldInitSpec(e, t, a) { color_picker_checkPrivateRedeclaration(e, t), t.set(e, a); }
function color_picker_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function color_picker_classPrivateGetter(s, r, a) { return a(color_picker_assertClassBrand(s, r)); }
function color_picker_classPrivateFieldGet(s, a) { return s.get(color_picker_assertClassBrand(s, a)); }
function color_picker_classPrivateFieldSet(s, a, r) { return s.set(color_picker_assertClassBrand(s, a), r), r; }
function color_picker_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }



var _button = /*#__PURE__*/new WeakMap();
var _buttonSwatch = /*#__PURE__*/new WeakMap();
var _defaultColor = /*#__PURE__*/new WeakMap();
var _dropdown = /*#__PURE__*/new WeakMap();
var _dropdownWasFromKeyboard = /*#__PURE__*/new WeakMap();
var _isMainColorPicker = /*#__PURE__*/new WeakMap();
var color_picker_editor = /*#__PURE__*/new WeakMap();
var _eventBus = /*#__PURE__*/new WeakMap();
var _openDropdownAC = /*#__PURE__*/new WeakMap();
var _uiManager = /*#__PURE__*/new WeakMap();
var _type = /*#__PURE__*/new WeakMap();
var _ColorPicker_brand = /*#__PURE__*/new WeakSet();
var ColorPicker = /*#__PURE__*/function () {
  function ColorPicker(_ref) {
    var _classPrivateFieldGet2;
    var _ref$editor = _ref.editor,
      editor = _ref$editor === void 0 ? null : _ref$editor,
      _ref$uiManager = _ref.uiManager,
      uiManager = _ref$uiManager === void 0 ? null : _ref$uiManager;
    color_picker_classCallCheck(this, ColorPicker);
    color_picker_classPrivateMethodInitSpec(this, _ColorPicker_brand);
    color_picker_classPrivateFieldInitSpec(this, _button, null);
    color_picker_classPrivateFieldInitSpec(this, _buttonSwatch, null);
    color_picker_classPrivateFieldInitSpec(this, _defaultColor, void 0);
    color_picker_classPrivateFieldInitSpec(this, _dropdown, null);
    color_picker_classPrivateFieldInitSpec(this, _dropdownWasFromKeyboard, false);
    color_picker_classPrivateFieldInitSpec(this, _isMainColorPicker, false);
    color_picker_classPrivateFieldInitSpec(this, color_picker_editor, null);
    color_picker_classPrivateFieldInitSpec(this, _eventBus, void 0);
    color_picker_classPrivateFieldInitSpec(this, _openDropdownAC, null);
    color_picker_classPrivateFieldInitSpec(this, _uiManager, null);
    color_picker_classPrivateFieldInitSpec(this, _type, void 0);
    if (editor) {
      color_picker_classPrivateFieldSet(_isMainColorPicker, this, false);
      color_picker_classPrivateFieldSet(_type, this, AnnotationEditorParamsType.HIGHLIGHT_COLOR);
      color_picker_classPrivateFieldSet(color_picker_editor, this, editor);
    } else {
      color_picker_classPrivateFieldSet(_isMainColorPicker, this, true);
      color_picker_classPrivateFieldSet(_type, this, AnnotationEditorParamsType.HIGHLIGHT_DEFAULT_COLOR);
    }
    color_picker_classPrivateFieldSet(_uiManager, this, (editor === null || editor === void 0 ? void 0 : editor._uiManager) || uiManager);
    color_picker_classPrivateFieldSet(_eventBus, this, color_picker_classPrivateFieldGet(_uiManager, this)._eventBus);
    color_picker_classPrivateFieldSet(_defaultColor, this, (editor === null || editor === void 0 ? void 0 : editor.color) || ((_classPrivateFieldGet2 = color_picker_classPrivateFieldGet(_uiManager, this)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.highlightColors.values().next().value) || "#FFFF98");
    _l10nColor._ || (_l10nColor._ = Object.freeze({
      blue: "pdfjs-editor-colorpicker-blue",
      green: "pdfjs-editor-colorpicker-green",
      pink: "pdfjs-editor-colorpicker-pink",
      red: "pdfjs-editor-colorpicker-red",
      yellow: "pdfjs-editor-colorpicker-yellow"
    }));
  }
  return color_picker_createClass(ColorPicker, [{
    key: "renderButton",
    value: function renderButton() {
      var button = color_picker_classPrivateFieldSet(_button, this, document.createElement("button"));
      button.className = "colorPicker";
      button.tabIndex = "0";
      button.setAttribute("data-l10n-id", "pdfjs-editor-colorpicker-button");
      button.setAttribute("aria-haspopup", true);
      var signal = color_picker_classPrivateFieldGet(_uiManager, this)._signal;
      button.addEventListener("click", color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).bind(this), {
        signal: signal
      });
      button.addEventListener("keydown", color_picker_assertClassBrand(_ColorPicker_brand, this, color_picker_keyDown).bind(this), {
        signal: signal
      });
      var swatch = color_picker_classPrivateFieldSet(_buttonSwatch, this, document.createElement("span"));
      swatch.className = "swatch";
      swatch.setAttribute("aria-hidden", true);
      swatch.style.backgroundColor = color_picker_classPrivateFieldGet(_defaultColor, this);
      button.append(swatch);
      return button;
    }
  }, {
    key: "renderMainDropdown",
    value: function renderMainDropdown() {
      var dropdown = color_picker_classPrivateFieldSet(_dropdown, this, color_picker_assertClassBrand(_ColorPicker_brand, this, _getDropdownRoot).call(this));
      dropdown.setAttribute("aria-orientation", "horizontal");
      dropdown.setAttribute("aria-labelledby", "highlightColorPickerLabel");
      return dropdown;
    }
  }, {
    key: "_colorSelectFromKeyboard",
    value: function _colorSelectFromKeyboard(event) {
      if (event.target === color_picker_classPrivateFieldGet(_button, this)) {
        color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).call(this, event);
        return;
      }
      var color = event.target.getAttribute("data-color");
      if (!color) {
        return;
      }
      color_picker_assertClassBrand(_ColorPicker_brand, this, _colorSelect).call(this, color, event);
    }
  }, {
    key: "_moveToNext",
    value: function _moveToNext(event) {
      var _event$target$nextSib;
      if (!color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
        color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).call(this, event);
        return;
      }
      if (event.target === color_picker_classPrivateFieldGet(_button, this)) {
        var _classPrivateFieldGet3;
        (_classPrivateFieldGet3 = color_picker_classPrivateFieldGet(_dropdown, this).firstChild) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.focus();
        return;
      }
      (_event$target$nextSib = event.target.nextSibling) === null || _event$target$nextSib === void 0 || _event$target$nextSib.focus();
    }
  }, {
    key: "_moveToPrevious",
    value: function _moveToPrevious(event) {
      var _classPrivateFieldGet4, _event$target$previou;
      if (event.target === ((_classPrivateFieldGet4 = color_picker_classPrivateFieldGet(_dropdown, this)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.firstChild) || event.target === color_picker_classPrivateFieldGet(_button, this)) {
        if (color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
          this._hideDropdownFromKeyboard();
        }
        return;
      }
      if (!color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
        color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).call(this, event);
      }
      (_event$target$previou = event.target.previousSibling) === null || _event$target$previou === void 0 || _event$target$previou.focus();
    }
  }, {
    key: "_moveToBeginning",
    value: function _moveToBeginning(event) {
      var _classPrivateFieldGet5;
      if (!color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
        color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).call(this, event);
        return;
      }
      (_classPrivateFieldGet5 = color_picker_classPrivateFieldGet(_dropdown, this).firstChild) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.focus();
    }
  }, {
    key: "_moveToEnd",
    value: function _moveToEnd(event) {
      var _classPrivateFieldGet6;
      if (!color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
        color_picker_assertClassBrand(_ColorPicker_brand, this, _openDropdown).call(this, event);
        return;
      }
      (_classPrivateFieldGet6 = color_picker_classPrivateFieldGet(_dropdown, this).lastChild) === null || _classPrivateFieldGet6 === void 0 || _classPrivateFieldGet6.focus();
    }
  }, {
    key: "hideDropdown",
    value: function hideDropdown() {
      var _classPrivateFieldGet7, _classPrivateFieldGet8;
      (_classPrivateFieldGet7 = color_picker_classPrivateFieldGet(_dropdown, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.classList.add("hidden");
      (_classPrivateFieldGet8 = color_picker_classPrivateFieldGet(_openDropdownAC, this)) === null || _classPrivateFieldGet8 === void 0 || _classPrivateFieldGet8.abort();
      color_picker_classPrivateFieldSet(_openDropdownAC, this, null);
    }
  }, {
    key: "_hideDropdownFromKeyboard",
    value: function _hideDropdownFromKeyboard() {
      if (color_picker_classPrivateFieldGet(_isMainColorPicker, this)) {
        return;
      }
      if (!color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
        var _classPrivateFieldGet9;
        (_classPrivateFieldGet9 = color_picker_classPrivateFieldGet(color_picker_editor, this)) === null || _classPrivateFieldGet9 === void 0 || _classPrivateFieldGet9.unselect();
        return;
      }
      this.hideDropdown();
      color_picker_classPrivateFieldGet(_button, this).focus({
        preventScroll: true,
        focusVisible: color_picker_classPrivateFieldGet(_dropdownWasFromKeyboard, this)
      });
    }
  }, {
    key: "updateColor",
    value: function updateColor(color) {
      if (color_picker_classPrivateFieldGet(_buttonSwatch, this)) {
        color_picker_classPrivateFieldGet(_buttonSwatch, this).style.backgroundColor = color;
      }
      if (!color_picker_classPrivateFieldGet(_dropdown, this)) {
        return;
      }
      var i = color_picker_classPrivateFieldGet(_uiManager, this).highlightColors.values();
      var _iterator = color_picker_createForOfIteratorHelper(color_picker_classPrivateFieldGet(_dropdown, this).children),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var child = _step.value;
          child.setAttribute("aria-selected", i.next().value === color);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet10, _classPrivateFieldGet11;
      (_classPrivateFieldGet10 = color_picker_classPrivateFieldGet(_button, this)) === null || _classPrivateFieldGet10 === void 0 || _classPrivateFieldGet10.remove();
      color_picker_classPrivateFieldSet(_button, this, null);
      color_picker_classPrivateFieldSet(_buttonSwatch, this, null);
      (_classPrivateFieldGet11 = color_picker_classPrivateFieldGet(_dropdown, this)) === null || _classPrivateFieldGet11 === void 0 || _classPrivateFieldGet11.remove();
      color_picker_classPrivateFieldSet(_dropdown, this, null);
    }
  }], [{
    key: "_keyboardManager",
    get: function get() {
      return shadow(this, "_keyboardManager", new KeyboardManager([[["Escape", "mac+Escape"], ColorPicker.prototype._hideDropdownFromKeyboard], [[" ", "mac+ "], ColorPicker.prototype._colorSelectFromKeyboard], [["ArrowDown", "ArrowRight", "mac+ArrowDown", "mac+ArrowRight"], ColorPicker.prototype._moveToNext], [["ArrowUp", "ArrowLeft", "mac+ArrowUp", "mac+ArrowLeft"], ColorPicker.prototype._moveToPrevious], [["Home", "mac+Home"], ColorPicker.prototype._moveToBeginning], [["End", "mac+End"], ColorPicker.prototype._moveToEnd]]));
    }
  }]);
}();
_ColorPicker = ColorPicker;
function _getDropdownRoot() {
  var div = document.createElement("div");
  var signal = color_picker_classPrivateFieldGet(_uiManager, this)._signal;
  div.addEventListener("contextmenu", noContextMenu, {
    signal: signal
  });
  div.className = "dropdown";
  div.role = "listbox";
  div.setAttribute("aria-multiselectable", false);
  div.setAttribute("aria-orientation", "vertical");
  div.setAttribute("data-l10n-id", "pdfjs-editor-colorpicker-dropdown");
  var _iterator2 = color_picker_createForOfIteratorHelper(color_picker_classPrivateFieldGet(_uiManager, this).highlightColors),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var _step2$value = color_picker_slicedToArray(_step2.value, 2),
        name = _step2$value[0],
        color = _step2$value[1];
      var button = document.createElement("button");
      button.tabIndex = "0";
      button.role = "option";
      button.setAttribute("data-color", color);
      button.title = name;
      button.setAttribute("data-l10n-id", _l10nColor._[name]);
      var swatch = document.createElement("span");
      button.append(swatch);
      swatch.className = "swatch";
      swatch.style.backgroundColor = color;
      button.setAttribute("aria-selected", color === color_picker_classPrivateFieldGet(_defaultColor, this));
      button.addEventListener("click", color_picker_assertClassBrand(_ColorPicker_brand, this, _colorSelect).bind(this, color), {
        signal: signal
      });
      div.append(button);
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  div.addEventListener("keydown", color_picker_assertClassBrand(_ColorPicker_brand, this, color_picker_keyDown).bind(this), {
    signal: signal
  });
  return div;
}
function _colorSelect(color, event) {
  event.stopPropagation();
  color_picker_classPrivateFieldGet(_eventBus, this).dispatch("switchannotationeditorparams", {
    source: this,
    type: color_picker_classPrivateFieldGet(_type, this),
    value: color
  });
}
function color_picker_keyDown(event) {
  _ColorPicker._keyboardManager.exec(this, event);
}
function _openDropdown(event) {
  if (color_picker_classPrivateGetter(_ColorPicker_brand, this, _get_isDropdownVisible)) {
    this.hideDropdown();
    return;
  }
  color_picker_classPrivateFieldSet(_dropdownWasFromKeyboard, this, event.detail === 0);
  if (!color_picker_classPrivateFieldGet(_openDropdownAC, this)) {
    color_picker_classPrivateFieldSet(_openDropdownAC, this, new AbortController());
    window.addEventListener("pointerdown", color_picker_assertClassBrand(_ColorPicker_brand, this, color_picker_pointerDown).bind(this), {
      signal: color_picker_classPrivateFieldGet(_uiManager, this).combinedSignal(color_picker_classPrivateFieldGet(_openDropdownAC, this))
    });
  }
  if (color_picker_classPrivateFieldGet(_dropdown, this)) {
    color_picker_classPrivateFieldGet(_dropdown, this).classList.remove("hidden");
    return;
  }
  var root = color_picker_classPrivateFieldSet(_dropdown, this, color_picker_assertClassBrand(_ColorPicker_brand, this, _getDropdownRoot).call(this));
  color_picker_classPrivateFieldGet(_button, this).append(root);
}
function color_picker_pointerDown(event) {
  var _classPrivateFieldGet12;
  if ((_classPrivateFieldGet12 = color_picker_classPrivateFieldGet(_dropdown, this)) !== null && _classPrivateFieldGet12 !== void 0 && _classPrivateFieldGet12.contains(event.target)) {
    return;
  }
  this.hideDropdown();
}
function _get_isDropdownVisible(_this) {
  return color_picker_classPrivateFieldGet(_dropdown, _this) && !color_picker_classPrivateFieldGet(_dropdown, _this).classList.contains("hidden");
}
var _l10nColor = {
  _: null
};

;// ./src/display/editor/highlight.js



























function editor_highlight_typeof(o) { "@babel/helpers - typeof"; return editor_highlight_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, editor_highlight_typeof(o); }
var _HighlightEditor;
function editor_highlight_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = editor_highlight_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function editor_highlight_toConsumableArray(r) { return editor_highlight_arrayWithoutHoles(r) || editor_highlight_iterableToArray(r) || editor_highlight_unsupportedIterableToArray(r) || editor_highlight_nonIterableSpread(); }
function editor_highlight_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function editor_highlight_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function editor_highlight_arrayWithoutHoles(r) { if (Array.isArray(r)) return editor_highlight_arrayLikeToArray(r); }



















































function editor_highlight_slicedToArray(r, e) { return editor_highlight_arrayWithHoles(r) || editor_highlight_iterableToArrayLimit(r, e) || editor_highlight_unsupportedIterableToArray(r, e) || editor_highlight_nonIterableRest(); }
function editor_highlight_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function editor_highlight_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return editor_highlight_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? editor_highlight_arrayLikeToArray(r, a) : void 0; } }
function editor_highlight_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function editor_highlight_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function editor_highlight_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function highlight_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ highlight_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == editor_highlight_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(editor_highlight_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function highlight_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function highlight_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { highlight_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { highlight_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function highlight_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function highlight_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? highlight_ownKeys(Object(t), !0).forEach(function (r) { highlight_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : highlight_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function editor_highlight_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function editor_highlight_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, editor_highlight_toPropertyKey(o.key), o); } }
function editor_highlight_createClass(e, r, t) { return r && editor_highlight_defineProperties(e.prototype, r), t && editor_highlight_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function editor_highlight_callSuper(t, o, e) { return o = editor_highlight_getPrototypeOf(o), editor_highlight_possibleConstructorReturn(t, editor_highlight_isNativeReflectConstruct() ? Reflect.construct(o, e || [], editor_highlight_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function editor_highlight_possibleConstructorReturn(t, e) { if (e && ("object" == editor_highlight_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return editor_highlight_assertThisInitialized(t); }
function editor_highlight_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function editor_highlight_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (editor_highlight_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function highlight_superPropGet(t, o, e, r) { var p = highlight_get(editor_highlight_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function highlight_get() { return highlight_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = highlight_superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, highlight_get.apply(null, arguments); }
function highlight_superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = editor_highlight_getPrototypeOf(t));); return t; }
function editor_highlight_getPrototypeOf(t) { return editor_highlight_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, editor_highlight_getPrototypeOf(t); }
function editor_highlight_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && editor_highlight_setPrototypeOf(t, e); }
function editor_highlight_setPrototypeOf(t, e) { return editor_highlight_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, editor_highlight_setPrototypeOf(t, e); }
function editor_highlight_classPrivateMethodInitSpec(e, a) { editor_highlight_checkPrivateRedeclaration(e, a), a.add(e); }
function highlight_defineProperty(e, r, t) { return (r = editor_highlight_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function editor_highlight_toPropertyKey(t) { var i = editor_highlight_toPrimitive(t, "string"); return "symbol" == editor_highlight_typeof(i) ? i : i + ""; }
function editor_highlight_toPrimitive(t, r) { if ("object" != editor_highlight_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != editor_highlight_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function editor_highlight_classPrivateFieldInitSpec(e, t, a) { editor_highlight_checkPrivateRedeclaration(e, t), t.set(e, a); }
function editor_highlight_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function highlight_toSetter(t, e, n) { e || (e = []); var r = e.length++; return Object.defineProperty({}, "_", { set: function set(o) { e[r] = o, t.apply(n, e); } }); }
function editor_highlight_classPrivateFieldGet(s, a) { return s.get(editor_highlight_assertClassBrand(s, a)); }
function editor_highlight_classPrivateFieldSet(s, a, r) { return s.set(editor_highlight_assertClassBrand(s, a), r), r; }
function editor_highlight_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }







var _anchorNode = /*#__PURE__*/new WeakMap();
var _anchorOffset = /*#__PURE__*/new WeakMap();
var _boxes = /*#__PURE__*/new WeakMap();
var _clipPathId = /*#__PURE__*/new WeakMap();
var highlight_colorPicker = /*#__PURE__*/new WeakMap();
var _focusOutlines = /*#__PURE__*/new WeakMap();
var _focusNode = /*#__PURE__*/new WeakMap();
var _focusOffset = /*#__PURE__*/new WeakMap();
var _highlightDiv = /*#__PURE__*/new WeakMap();
var _highlightOutlines = /*#__PURE__*/new WeakMap();
var highlight_id = /*#__PURE__*/new WeakMap();
var _isFreeHighlight = /*#__PURE__*/new WeakMap();
var highlight_lastPoint = /*#__PURE__*/new WeakMap();
var _opacity = /*#__PURE__*/new WeakMap();
var _outlineId = /*#__PURE__*/new WeakMap();
var _text = /*#__PURE__*/new WeakMap();
var highlight_thickness = /*#__PURE__*/new WeakMap();
var _methodOfCreation = /*#__PURE__*/new WeakMap();
var _HighlightEditor_brand = /*#__PURE__*/new WeakSet();
var HighlightEditor = /*#__PURE__*/function (_AnnotationEditor) {
  function HighlightEditor(params) {
    var _this;
    editor_highlight_classCallCheck(this, HighlightEditor);
    _this = editor_highlight_callSuper(this, HighlightEditor, [highlight_objectSpread(highlight_objectSpread({}, params), {}, {
      name: "highlightEditor"
    })]);
    editor_highlight_classPrivateMethodInitSpec(_this, _HighlightEditor_brand);
    editor_highlight_classPrivateFieldInitSpec(_this, _anchorNode, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _anchorOffset, 0);
    editor_highlight_classPrivateFieldInitSpec(_this, _boxes, void 0);
    editor_highlight_classPrivateFieldInitSpec(_this, _clipPathId, null);
    editor_highlight_classPrivateFieldInitSpec(_this, highlight_colorPicker, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _focusOutlines, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _focusNode, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _focusOffset, 0);
    editor_highlight_classPrivateFieldInitSpec(_this, _highlightDiv, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _highlightOutlines, null);
    editor_highlight_classPrivateFieldInitSpec(_this, highlight_id, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _isFreeHighlight, false);
    editor_highlight_classPrivateFieldInitSpec(_this, highlight_lastPoint, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _opacity, void 0);
    editor_highlight_classPrivateFieldInitSpec(_this, _outlineId, null);
    editor_highlight_classPrivateFieldInitSpec(_this, _text, "");
    editor_highlight_classPrivateFieldInitSpec(_this, highlight_thickness, void 0);
    editor_highlight_classPrivateFieldInitSpec(_this, _methodOfCreation, "");
    _this.color = params.color || HighlightEditor._defaultColor;
    editor_highlight_classPrivateFieldSet(highlight_thickness, _this, params.thickness || HighlightEditor._defaultThickness);
    editor_highlight_classPrivateFieldSet(_opacity, _this, params.opacity || HighlightEditor._defaultOpacity);
    editor_highlight_classPrivateFieldSet(_boxes, _this, params.boxes || null);
    editor_highlight_classPrivateFieldSet(_methodOfCreation, _this, params.methodOfCreation || "");
    editor_highlight_classPrivateFieldSet(_text, _this, params.text || "");
    _this._isDraggable = false;
    if (params.highlightId > -1) {
      editor_highlight_classPrivateFieldSet(_isFreeHighlight, _this, true);
      editor_highlight_assertClassBrand(_HighlightEditor_brand, _this, _createFreeOutlines).call(_this, params);
      editor_highlight_assertClassBrand(_HighlightEditor_brand, _this, _addToDrawLayer).call(_this);
    } else if (editor_highlight_classPrivateFieldGet(_boxes, _this)) {
      editor_highlight_classPrivateFieldSet(_anchorNode, _this, params.anchorNode);
      editor_highlight_classPrivateFieldSet(_anchorOffset, _this, params.anchorOffset);
      editor_highlight_classPrivateFieldSet(_focusNode, _this, params.focusNode);
      editor_highlight_classPrivateFieldSet(_focusOffset, _this, params.focusOffset);
      editor_highlight_assertClassBrand(_HighlightEditor_brand, _this, _createOutlines).call(_this);
      editor_highlight_assertClassBrand(_HighlightEditor_brand, _this, _addToDrawLayer).call(_this);
      _this.rotate(_this.rotation);
    }
    return _this;
  }
  editor_highlight_inherits(HighlightEditor, _AnnotationEditor);
  return editor_highlight_createClass(HighlightEditor, [{
    key: "telemetryInitialData",
    get: function get() {
      return {
        action: "added",
        type: editor_highlight_classPrivateFieldGet(_isFreeHighlight, this) ? "free_highlight" : "highlight",
        color: this._uiManager.highlightColorNames.get(this.color),
        thickness: editor_highlight_classPrivateFieldGet(highlight_thickness, this),
        methodOfCreation: editor_highlight_classPrivateFieldGet(_methodOfCreation, this)
      };
    }
  }, {
    key: "telemetryFinalData",
    get: function get() {
      return {
        type: "highlight",
        color: this._uiManager.highlightColorNames.get(this.color)
      };
    }
  }, {
    key: "translateInPage",
    value: function translateInPage(x, y) {}
  }, {
    key: "toolbarPosition",
    get: function get() {
      return editor_highlight_classPrivateFieldGet(highlight_lastPoint, this);
    }
  }, {
    key: "updateParams",
    value: function updateParams(type, value) {
      switch (type) {
        case AnnotationEditorParamsType.HIGHLIGHT_COLOR:
          editor_highlight_assertClassBrand(_HighlightEditor_brand, this, highlight_updateColor).call(this, value);
          break;
        case AnnotationEditorParamsType.HIGHLIGHT_THICKNESS:
          editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _updateThickness).call(this, value);
          break;
      }
    }
  }, {
    key: "propertiesToUpdate",
    get: function get() {
      return [[AnnotationEditorParamsType.HIGHLIGHT_COLOR, this.color || HighlightEditor._defaultColor], [AnnotationEditorParamsType.HIGHLIGHT_THICKNESS, editor_highlight_classPrivateFieldGet(highlight_thickness, this) || HighlightEditor._defaultThickness], [AnnotationEditorParamsType.HIGHLIGHT_FREE, editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)]];
    }
  }, {
    key: "addEditToolbar",
    value: function () {
      var _addEditToolbar = highlight_asyncToGenerator(/*#__PURE__*/highlight_regeneratorRuntime().mark(function _callee() {
        var toolbar;
        return highlight_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return highlight_superPropGet(HighlightEditor, "addEditToolbar", this, 3)([]);
            case 2:
              toolbar = _context.sent;
              if (toolbar) {
                _context.next = 5;
                break;
              }
              return _context.abrupt("return", null);
            case 5:
              if (this._uiManager.highlightColors) {
                editor_highlight_classPrivateFieldSet(highlight_colorPicker, this, new ColorPicker({
                  editor: this
                }));
                toolbar.addColorPicker(editor_highlight_classPrivateFieldGet(highlight_colorPicker, this));
              }
              return _context.abrupt("return", toolbar);
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function addEditToolbar() {
        return _addEditToolbar.apply(this, arguments);
      }
      return addEditToolbar;
    }()
  }, {
    key: "disableEditing",
    value: function disableEditing() {
      highlight_superPropGet(HighlightEditor, "disableEditing", this, 3)([]);
      this.div.classList.toggle("disabled", true);
    }
  }, {
    key: "enableEditing",
    value: function enableEditing() {
      highlight_superPropGet(HighlightEditor, "enableEditing", this, 3)([]);
      this.div.classList.toggle("disabled", false);
    }
  }, {
    key: "fixAndSetPosition",
    value: function fixAndSetPosition() {
      return highlight_superPropGet(HighlightEditor, "fixAndSetPosition", this, 3)([editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _getRotation).call(this)]);
    }
  }, {
    key: "getBaseTranslation",
    value: function getBaseTranslation() {
      return [0, 0];
    }
  }, {
    key: "getRect",
    value: function getRect(tx, ty) {
      return highlight_superPropGet(HighlightEditor, "getRect", this, 3)([tx, ty, editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _getRotation).call(this)]);
    }
  }, {
    key: "onceAdded",
    value: function onceAdded(focus) {
      if (!this.annotationElementId) {
        this.parent.addUndoableEditor(this);
      }
      if (focus) {
        this.div.focus();
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _cleanDrawLayer).call(this);
      this._reportTelemetry({
        action: "deleted"
      });
      highlight_superPropGet(HighlightEditor, "remove", this, 3)([]);
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      if (!this.parent) {
        return;
      }
      highlight_superPropGet(HighlightEditor, "rebuild", this, 3)([]);
      if (this.div === null) {
        return;
      }
      editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _addToDrawLayer).call(this);
      if (!this.isAttachedToDOM) {
        this.parent.add(this);
      }
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      var mustBeSelected = false;
      if (this.parent && !parent) {
        editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _cleanDrawLayer).call(this);
      } else if (parent) {
        var _this$div;
        editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _addToDrawLayer).call(this, parent);
        mustBeSelected = !this.parent && ((_this$div = this.div) === null || _this$div === void 0 ? void 0 : _this$div.classList.contains("selectedEditor"));
      }
      highlight_superPropGet(HighlightEditor, "setParent", this, 3)([parent]);
      this.show(this._isVisible);
      if (mustBeSelected) {
        this.select();
      }
    }
  }, {
    key: "rotate",
    value: function rotate(angle) {
      var drawLayer = this.parent.drawLayer;
      var box;
      if (editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)) {
        angle = (angle - this.rotation + 360) % 360;
        box = _rotateBbox.call(HighlightEditor, editor_highlight_classPrivateFieldGet(_highlightOutlines, this).box, angle);
      } else {
        box = _rotateBbox.call(HighlightEditor, [this.x, this.y, this.width, this.height], angle);
      }
      drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(highlight_id, this), {
        bbox: box,
        root: {
          "data-main-rotation": angle
        }
      });
      drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
        bbox: _rotateBbox.call(HighlightEditor, editor_highlight_classPrivateFieldGet(_focusOutlines, this).box, angle),
        root: {
          "data-main-rotation": angle
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      if (this.div) {
        return this.div;
      }
      var div = highlight_superPropGet(HighlightEditor, "render", this, 3)([]);
      if (editor_highlight_classPrivateFieldGet(_text, this)) {
        div.setAttribute("aria-label", editor_highlight_classPrivateFieldGet(_text, this));
        div.setAttribute("role", "mark");
      }
      if (editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)) {
        div.classList.add("free");
      } else {
        this.div.addEventListener("keydown", editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _keydown).bind(this), {
          signal: this._uiManager._signal
        });
      }
      var highlightDiv = editor_highlight_classPrivateFieldSet(_highlightDiv, this, document.createElement("div"));
      div.append(highlightDiv);
      highlightDiv.setAttribute("aria-hidden", "true");
      highlightDiv.className = "internal";
      highlightDiv.style.clipPath = editor_highlight_classPrivateFieldGet(_clipPathId, this);
      var _this$parentDimension = editor_highlight_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension[0],
        parentHeight = _this$parentDimension[1];
      this.setDims(this.width * parentWidth, this.height * parentHeight);
      bindEvents(this, editor_highlight_classPrivateFieldGet(_highlightDiv, this), ["pointerover", "pointerleave"]);
      this.enableEditing();
      return div;
    }
  }, {
    key: "pointerover",
    value: function pointerover() {
      if (!this.isSelected) {
        var _this$parent;
        (_this$parent = this.parent) === null || _this$parent === void 0 || _this$parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
          rootClass: {
            hovered: true
          }
        });
      }
    }
  }, {
    key: "pointerleave",
    value: function pointerleave() {
      if (!this.isSelected) {
        var _this$parent2;
        (_this$parent2 = this.parent) === null || _this$parent2 === void 0 || _this$parent2.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
          rootClass: {
            hovered: false
          }
        });
      }
    }
  }, {
    key: "_moveCaret",
    value: function _moveCaret(direction) {
      this.parent.unselect(this);
      switch (direction) {
        case 0:
        case 2:
          editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _setCaret).call(this, true);
          break;
        case 1:
        case 3:
          editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _setCaret).call(this, false);
          break;
      }
    }
  }, {
    key: "select",
    value: function select() {
      var _this$parent3;
      highlight_superPropGet(HighlightEditor, "select", this, 3)([]);
      if (!editor_highlight_classPrivateFieldGet(_outlineId, this)) {
        return;
      }
      (_this$parent3 = this.parent) === null || _this$parent3 === void 0 || _this$parent3.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
        rootClass: {
          hovered: false,
          selected: true
        }
      });
    }
  }, {
    key: "unselect",
    value: function unselect() {
      var _this$parent4;
      highlight_superPropGet(HighlightEditor, "unselect", this, 3)([]);
      if (!editor_highlight_classPrivateFieldGet(_outlineId, this)) {
        return;
      }
      (_this$parent4 = this.parent) === null || _this$parent4 === void 0 || _this$parent4.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
        rootClass: {
          selected: false
        }
      });
      if (!editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)) {
        editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _setCaret).call(this, false);
      }
    }
  }, {
    key: "_mustFixPosition",
    get: function get() {
      return !editor_highlight_classPrivateFieldGet(_isFreeHighlight, this);
    }
  }, {
    key: "show",
    value: function show() {
      var visible = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this._isVisible;
      highlight_superPropGet(HighlightEditor, "show", this, 3)([visible]);
      if (this.parent) {
        this.parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(highlight_id, this), {
          rootClass: {
            hidden: !visible
          }
        });
        this.parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
          rootClass: {
            hidden: !visible
          }
        });
      }
    }
  }, {
    key: "serialize",
    value: function serialize() {
      var isForCopying = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (this.isEmpty() || isForCopying) {
        return null;
      }
      if (this.deleted) {
        return this.serializeDeleted();
      }
      var rect = this.getRect(0, 0);
      var color = AnnotationEditor._colorManager.convert(this.color);
      var serialized = {
        annotationType: AnnotationEditorType.HIGHLIGHT,
        color: color,
        opacity: editor_highlight_classPrivateFieldGet(_opacity, this),
        thickness: editor_highlight_classPrivateFieldGet(highlight_thickness, this),
        quadPoints: editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _serializeBoxes).call(this),
        outlines: editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _serializeOutlines).call(this, rect),
        pageIndex: this.pageIndex,
        rect: rect,
        rotation: editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _getRotation).call(this),
        structTreeParentId: this._structTreeParentId
      };
      if (this.annotationElementId && !editor_highlight_assertClassBrand(_HighlightEditor_brand, this, highlight_hasElementChanged).call(this, serialized)) {
        return null;
      }
      serialized.id = this.annotationElementId;
      return serialized;
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      annotation.updateEdited({
        rect: this.getRect(0, 0)
      });
      return null;
    }
  }], [{
    key: "_keyboardManager",
    get: function get() {
      var proto = HighlightEditor.prototype;
      return shadow(this, "_keyboardManager", new KeyboardManager([[["ArrowLeft", "mac+ArrowLeft"], proto._moveCaret, {
        args: [0]
      }], [["ArrowRight", "mac+ArrowRight"], proto._moveCaret, {
        args: [1]
      }], [["ArrowUp", "mac+ArrowUp"], proto._moveCaret, {
        args: [2]
      }], [["ArrowDown", "mac+ArrowDown"], proto._moveCaret, {
        args: [3]
      }]]));
    }
  }, {
    key: "computeTelemetryFinalData",
    value: function computeTelemetryFinalData(data) {
      return {
        numberOfColors: data.get("color").size
      };
    }
  }, {
    key: "initialize",
    value: function initialize(l10n, uiManager) {
      var _uiManager$highlightC;
      AnnotationEditor.initialize(l10n, uiManager);
      HighlightEditor._defaultColor || (HighlightEditor._defaultColor = ((_uiManager$highlightC = uiManager.highlightColors) === null || _uiManager$highlightC === void 0 ? void 0 : _uiManager$highlightC.values().next().value) || "#fff066");
    }
  }, {
    key: "updateDefaultParams",
    value: function updateDefaultParams(type, value) {
      switch (type) {
        case AnnotationEditorParamsType.HIGHLIGHT_DEFAULT_COLOR:
          HighlightEditor._defaultColor = value;
          break;
        case AnnotationEditorParamsType.HIGHLIGHT_THICKNESS:
          HighlightEditor._defaultThickness = value;
          break;
      }
    }
  }, {
    key: "defaultPropertiesToUpdate",
    get: function get() {
      return [[AnnotationEditorParamsType.HIGHLIGHT_DEFAULT_COLOR, HighlightEditor._defaultColor], [AnnotationEditorParamsType.HIGHLIGHT_THICKNESS, HighlightEditor._defaultThickness]];
    }
  }, {
    key: "startHighlighting",
    value: function startHighlighting(parent, isLTR, _ref) {
      var _this2 = this;
      var textLayer = _ref.target,
        x = _ref.x,
        y = _ref.y;
      var _textLayer$getBoundin = textLayer.getBoundingClientRect(),
        layerX = _textLayer$getBoundin.x,
        layerY = _textLayer$getBoundin.y,
        parentWidth = _textLayer$getBoundin.width,
        parentHeight = _textLayer$getBoundin.height;
      var ac = new AbortController();
      var signal = parent.combinedSignal(ac);
      var pointerUpCallback = function pointerUpCallback(e) {
        ac.abort();
        editor_highlight_assertClassBrand(HighlightEditor, _this2, _endHighlight).call(_this2, parent, e);
      };
      window.addEventListener("blur", pointerUpCallback, {
        signal: signal
      });
      window.addEventListener("pointerup", pointerUpCallback, {
        signal: signal
      });
      window.addEventListener("pointerdown", stopEvent, {
        capture: true,
        passive: false,
        signal: signal
      });
      window.addEventListener("contextmenu", noContextMenu, {
        signal: signal
      });
      textLayer.addEventListener("pointermove", editor_highlight_assertClassBrand(HighlightEditor, this, _highlightMove).bind(this, parent), {
        signal: signal
      });
      this._freeHighlight = new FreeHighlightOutliner({
        x: x,
        y: y
      }, [layerX, layerY, parentWidth, parentHeight], parent.scale, this._defaultThickness / 2, isLTR, 0.001);
      var _parent$drawLayer$dra = parent.drawLayer.draw({
        bbox: [0, 0, 1, 1],
        root: {
          viewBox: "0 0 1 1",
          fill: this._defaultColor,
          "fill-opacity": this._defaultOpacity
        },
        rootClass: {
          highlight: true,
          free: true
        },
        path: {
          d: this._freeHighlight.toSVGPath()
        }
      }, true, true);
      this._freeHighlightId = _parent$drawLayer$dra.id;
      this._freeHighlightClipId = _parent$drawLayer$dra.clipPathId;
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = highlight_asyncToGenerator(/*#__PURE__*/highlight_regeneratorRuntime().mark(function _callee2(data, parent, uiManager) {
        var initialData, _data, _data$data, _quadPoints, rect, rotation, id, _color, _opacity2, popupRef, pageNumber, _data2, _data2$data, _inkLists, _rect, _rotation, _id2, _color2, thickness, _popupRef, _pageNumber, _data3, color, quadPoints, inkLists, opacity, editor, _editor$pageDimension, pageWidth, pageHeight, _editor$pageTranslati, pageX, pageY, boxes, i, points, point, outliner, _i, ii, _parent$drawLayer$dra2, _id3, clipPathId;
        return highlight_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              initialData = null;
              if (data instanceof HighlightAnnotationElement) {
                _data = data, _data$data = _data.data, _quadPoints = _data$data.quadPoints, rect = _data$data.rect, rotation = _data$data.rotation, id = _data$data.id, _color = _data$data.color, _opacity2 = _data$data.opacity, popupRef = _data$data.popupRef, pageNumber = _data.parent.page.pageNumber;
                initialData = data = {
                  annotationType: AnnotationEditorType.HIGHLIGHT,
                  color: Array.from(_color),
                  opacity: _opacity2,
                  quadPoints: _quadPoints,
                  boxes: null,
                  pageIndex: pageNumber - 1,
                  rect: rect.slice(0),
                  rotation: rotation,
                  id: id,
                  deleted: false,
                  popupRef: popupRef
                };
              } else if (data instanceof InkAnnotationElement) {
                _data2 = data, _data2$data = _data2.data, _inkLists = _data2$data.inkLists, _rect = _data2$data.rect, _rotation = _data2$data.rotation, _id2 = _data2$data.id, _color2 = _data2$data.color, thickness = _data2$data.borderStyle.rawWidth, _popupRef = _data2$data.popupRef, _pageNumber = _data2.parent.page.pageNumber;
                initialData = data = {
                  annotationType: AnnotationEditorType.HIGHLIGHT,
                  color: Array.from(_color2),
                  thickness: thickness,
                  inkLists: _inkLists,
                  boxes: null,
                  pageIndex: _pageNumber - 1,
                  rect: _rect.slice(0),
                  rotation: _rotation,
                  id: _id2,
                  deleted: false,
                  popupRef: _popupRef
                };
              }
              _data3 = data, color = _data3.color, quadPoints = _data3.quadPoints, inkLists = _data3.inkLists, opacity = _data3.opacity;
              _context2.next = 5;
              return highlight_superPropGet(HighlightEditor, "deserialize", this, 2)([data, parent, uiManager]);
            case 5:
              editor = _context2.sent;
              editor.color = Util.makeHexColor.apply(Util, editor_highlight_toConsumableArray(color));
              editor_highlight_classPrivateFieldSet(_opacity, editor, opacity || 1);
              if (inkLists) {
                editor_highlight_classPrivateFieldSet(highlight_thickness, editor, data.thickness);
              }
              editor.annotationElementId = data.id || null;
              editor._initialData = initialData;
              _editor$pageDimension = editor_highlight_slicedToArray(editor.pageDimensions, 2), pageWidth = _editor$pageDimension[0], pageHeight = _editor$pageDimension[1];
              _editor$pageTranslati = editor_highlight_slicedToArray(editor.pageTranslation, 2), pageX = _editor$pageTranslati[0], pageY = _editor$pageTranslati[1];
              if (quadPoints) {
                boxes = editor_highlight_classPrivateFieldSet(_boxes, editor, []);
                for (i = 0; i < quadPoints.length; i += 8) {
                  boxes.push({
                    x: (quadPoints[i] - pageX) / pageWidth,
                    y: 1 - (quadPoints[i + 1] - pageY) / pageHeight,
                    width: (quadPoints[i + 2] - quadPoints[i]) / pageWidth,
                    height: (quadPoints[i + 1] - quadPoints[i + 5]) / pageHeight
                  });
                }
                editor_highlight_assertClassBrand(_HighlightEditor_brand, editor, _createOutlines).call(editor);
                editor_highlight_assertClassBrand(_HighlightEditor_brand, editor, _addToDrawLayer).call(editor);
                editor.rotate(editor.rotation);
              } else if (inkLists) {
                editor_highlight_classPrivateFieldSet(_isFreeHighlight, editor, true);
                points = inkLists[0];
                point = {
                  x: points[0] - pageX,
                  y: pageHeight - (points[1] - pageY)
                };
                outliner = new FreeHighlightOutliner(point, [0, 0, pageWidth, pageHeight], 1, editor_highlight_classPrivateFieldGet(highlight_thickness, editor) / 2, true, 0.001);
                for (_i = 0, ii = points.length; _i < ii; _i += 2) {
                  point.x = points[_i] - pageX;
                  point.y = pageHeight - (points[_i + 1] - pageY);
                  outliner.add(point);
                }
                _parent$drawLayer$dra2 = parent.drawLayer.draw({
                  bbox: [0, 0, 1, 1],
                  root: {
                    viewBox: "0 0 1 1",
                    fill: editor.color,
                    "fill-opacity": editor._defaultOpacity
                  },
                  rootClass: {
                    highlight: true,
                    free: true
                  },
                  path: {
                    d: outliner.toSVGPath()
                  }
                }, true, true), _id3 = _parent$drawLayer$dra2.id, clipPathId = _parent$drawLayer$dra2.clipPathId;
                editor_highlight_assertClassBrand(_HighlightEditor_brand, editor, _createFreeOutlines).call(editor, {
                  highlightOutlines: outliner.getOutlines(),
                  highlightId: _id3,
                  clipPathId: clipPathId
                });
                editor_highlight_assertClassBrand(_HighlightEditor_brand, editor, _addToDrawLayer).call(editor);
              }
              return _context2.abrupt("return", editor);
            case 15:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function deserialize(_x, _x2, _x3) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }, {
    key: "canCreateNewEmptyEditor",
    value: function canCreateNewEmptyEditor() {
      return false;
    }
  }]);
}(AnnotationEditor);
_HighlightEditor = HighlightEditor;
function _createOutlines() {
  var outliner = new HighlightOutliner(editor_highlight_classPrivateFieldGet(_boxes, this), 0.001);
  editor_highlight_classPrivateFieldSet(_highlightOutlines, this, outliner.getOutlines());
  var _classPrivateFieldGet2 = editor_highlight_slicedToArray(editor_highlight_classPrivateFieldGet(_highlightOutlines, this).box, 4);
  this.x = _classPrivateFieldGet2[0];
  this.y = _classPrivateFieldGet2[1];
  this.width = _classPrivateFieldGet2[2];
  this.height = _classPrivateFieldGet2[3];
  var outlinerForOutline = new HighlightOutliner(editor_highlight_classPrivateFieldGet(_boxes, this), 0.0025, 0.001, this._uiManager.direction === "ltr");
  editor_highlight_classPrivateFieldSet(_focusOutlines, this, outlinerForOutline.getOutlines());
  var _classPrivateFieldGet3 = editor_highlight_classPrivateFieldGet(_focusOutlines, this),
    lastPoint = _classPrivateFieldGet3.lastPoint;
  editor_highlight_classPrivateFieldSet(highlight_lastPoint, this, [(lastPoint[0] - this.x) / this.width, (lastPoint[1] - this.y) / this.height]);
}
function _createFreeOutlines(_ref2) {
  var highlightOutlines = _ref2.highlightOutlines,
    highlightId = _ref2.highlightId,
    clipPathId = _ref2.clipPathId;
  editor_highlight_classPrivateFieldSet(_highlightOutlines, this, highlightOutlines);
  var extraThickness = 1.5;
  editor_highlight_classPrivateFieldSet(_focusOutlines, this, highlightOutlines.getNewOutline(editor_highlight_classPrivateFieldGet(highlight_thickness, this) / 2 + extraThickness, 0.0025));
  if (highlightId >= 0) {
    editor_highlight_classPrivateFieldSet(highlight_id, this, highlightId);
    editor_highlight_classPrivateFieldSet(_clipPathId, this, clipPathId);
    this.parent.drawLayer.finalizeDraw(highlightId, {
      bbox: highlightOutlines.box,
      path: {
        d: highlightOutlines.toSVGPath()
      }
    });
    editor_highlight_classPrivateFieldSet(_outlineId, this, this.parent.drawLayer.drawOutline({
      rootClass: {
        highlightOutline: true,
        free: true
      },
      bbox: editor_highlight_classPrivateFieldGet(_focusOutlines, this).box,
      path: {
        d: editor_highlight_classPrivateFieldGet(_focusOutlines, this).toSVGPath()
      }
    }, true));
  } else if (this.parent) {
    var angle = this.parent.viewport.rotation;
    this.parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(highlight_id, this), {
      bbox: _rotateBbox.call(_HighlightEditor, editor_highlight_classPrivateFieldGet(_highlightOutlines, this).box, (angle - this.rotation + 360) % 360),
      path: {
        d: highlightOutlines.toSVGPath()
      }
    });
    this.parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(_outlineId, this), {
      bbox: _rotateBbox.call(_HighlightEditor, editor_highlight_classPrivateFieldGet(_focusOutlines, this).box, angle),
      path: {
        d: editor_highlight_classPrivateFieldGet(_focusOutlines, this).toSVGPath()
      }
    });
  }
  var _highlightOutlines$bo = editor_highlight_slicedToArray(highlightOutlines.box, 4),
    x = _highlightOutlines$bo[0],
    y = _highlightOutlines$bo[1],
    width = _highlightOutlines$bo[2],
    height = _highlightOutlines$bo[3];
  switch (this.rotation) {
    case 0:
      this.x = x;
      this.y = y;
      this.width = width;
      this.height = height;
      break;
    case 90:
      {
        var _this$parentDimension2 = editor_highlight_slicedToArray(this.parentDimensions, 2),
          pageWidth = _this$parentDimension2[0],
          pageHeight = _this$parentDimension2[1];
        this.x = y;
        this.y = 1 - x;
        this.width = width * pageHeight / pageWidth;
        this.height = height * pageWidth / pageHeight;
        break;
      }
    case 180:
      this.x = 1 - x;
      this.y = 1 - y;
      this.width = width;
      this.height = height;
      break;
    case 270:
      {
        var _this$parentDimension3 = editor_highlight_slicedToArray(this.parentDimensions, 2),
          _pageWidth = _this$parentDimension3[0],
          _pageHeight = _this$parentDimension3[1];
        this.x = 1 - y;
        this.y = x;
        this.width = width * _pageHeight / _pageWidth;
        this.height = height * _pageWidth / _pageHeight;
        break;
      }
  }
  var _classPrivateFieldGet4 = editor_highlight_classPrivateFieldGet(_focusOutlines, this),
    lastPoint = _classPrivateFieldGet4.lastPoint;
  editor_highlight_classPrivateFieldSet(highlight_lastPoint, this, [(lastPoint[0] - x) / width, (lastPoint[1] - y) / height]);
}
function highlight_updateColor(color) {
  var _this3 = this;
  var setColorAndOpacity = function setColorAndOpacity(col, opa) {
    var _this3$parent, _classPrivateFieldGet5;
    _this3.color = col;
    editor_highlight_classPrivateFieldSet(_opacity, _this3, opa);
    (_this3$parent = _this3.parent) === null || _this3$parent === void 0 || _this3$parent.drawLayer.updateProperties(editor_highlight_classPrivateFieldGet(highlight_id, _this3), {
      root: {
        fill: col,
        "fill-opacity": opa
      }
    });
    (_classPrivateFieldGet5 = editor_highlight_classPrivateFieldGet(highlight_colorPicker, _this3)) === null || _classPrivateFieldGet5 === void 0 || _classPrivateFieldGet5.updateColor(col);
  };
  var savedColor = this.color;
  var savedOpacity = editor_highlight_classPrivateFieldGet(_opacity, this);
  this.addCommands({
    cmd: setColorAndOpacity.bind(this, color, _HighlightEditor._defaultOpacity),
    undo: setColorAndOpacity.bind(this, savedColor, savedOpacity),
    post: this._uiManager.updateUI.bind(this._uiManager, this),
    mustExec: true,
    type: AnnotationEditorParamsType.HIGHLIGHT_COLOR,
    overwriteIfSameType: true,
    keepUndo: true
  });
  this._reportTelemetry({
    action: "color_changed",
    color: this._uiManager.highlightColorNames.get(color)
  }, true);
}
function _updateThickness(thickness) {
  var _this4 = this;
  var savedThickness = editor_highlight_classPrivateFieldGet(highlight_thickness, this);
  var setThickness = function setThickness(th) {
    editor_highlight_classPrivateFieldSet(highlight_thickness, _this4, th);
    editor_highlight_assertClassBrand(_HighlightEditor_brand, _this4, _changeThickness).call(_this4, th);
  };
  this.addCommands({
    cmd: setThickness.bind(this, thickness),
    undo: setThickness.bind(this, savedThickness),
    post: this._uiManager.updateUI.bind(this._uiManager, this),
    mustExec: true,
    type: AnnotationEditorParamsType.INK_THICKNESS,
    overwriteIfSameType: true,
    keepUndo: true
  });
  this._reportTelemetry({
    action: "thickness_changed",
    thickness: thickness
  }, true);
}
function _changeThickness(thickness) {
  if (!editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)) {
    return;
  }
  editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _createFreeOutlines).call(this, {
    highlightOutlines: editor_highlight_classPrivateFieldGet(_highlightOutlines, this).getNewOutline(thickness / 2)
  });
  this.fixAndSetPosition();
  var _this$parentDimension4 = editor_highlight_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension4[0],
    parentHeight = _this$parentDimension4[1];
  this.setDims(this.width * parentWidth, this.height * parentHeight);
}
function _cleanDrawLayer() {
  if (editor_highlight_classPrivateFieldGet(highlight_id, this) === null || !this.parent) {
    return;
  }
  this.parent.drawLayer.remove(editor_highlight_classPrivateFieldGet(highlight_id, this));
  editor_highlight_classPrivateFieldSet(highlight_id, this, null);
  this.parent.drawLayer.remove(editor_highlight_classPrivateFieldGet(_outlineId, this));
  editor_highlight_classPrivateFieldSet(_outlineId, this, null);
}
function _addToDrawLayer() {
  var parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.parent;
  if (editor_highlight_classPrivateFieldGet(highlight_id, this) !== null) {
    return;
  }
  var _parent$drawLayer$dra3 = parent.drawLayer.draw({
    bbox: editor_highlight_classPrivateFieldGet(_highlightOutlines, this).box,
    root: {
      viewBox: "0 0 1 1",
      fill: this.color,
      "fill-opacity": editor_highlight_classPrivateFieldGet(_opacity, this)
    },
    rootClass: {
      highlight: true,
      free: editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)
    },
    path: {
      d: editor_highlight_classPrivateFieldGet(_highlightOutlines, this).toSVGPath()
    }
  }, false, true);
  highlight_toSetter(editor_highlight_classPrivateFieldSet, [highlight_id, this])._ = _parent$drawLayer$dra3.id;
  highlight_toSetter(editor_highlight_classPrivateFieldSet, [_clipPathId, this])._ = _parent$drawLayer$dra3.clipPathId;
  editor_highlight_classPrivateFieldSet(_outlineId, this, parent.drawLayer.drawOutline({
    rootClass: {
      highlightOutline: true,
      free: editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)
    },
    bbox: editor_highlight_classPrivateFieldGet(_focusOutlines, this).box,
    path: {
      d: editor_highlight_classPrivateFieldGet(_focusOutlines, this).toSVGPath()
    }
  }, editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)));
  if (editor_highlight_classPrivateFieldGet(_highlightDiv, this)) {
    editor_highlight_classPrivateFieldGet(_highlightDiv, this).style.clipPath = editor_highlight_classPrivateFieldGet(_clipPathId, this);
  }
}
function _rotateBbox(_ref3, angle) {
  var _ref4 = editor_highlight_slicedToArray(_ref3, 4),
    x = _ref4[0],
    y = _ref4[1],
    width = _ref4[2],
    height = _ref4[3];
  switch (angle) {
    case 90:
      return [1 - y - height, x, height, width];
    case 180:
      return [1 - x - width, 1 - y - height, width, height];
    case 270:
      return [y, 1 - x - width, height, width];
  }
  return [x, y, width, height];
}
function _keydown(event) {
  _HighlightEditor._keyboardManager.exec(this, event);
}
function _setCaret(start) {
  if (!editor_highlight_classPrivateFieldGet(_anchorNode, this)) {
    return;
  }
  var selection = window.getSelection();
  if (start) {
    selection.setPosition(editor_highlight_classPrivateFieldGet(_anchorNode, this), editor_highlight_classPrivateFieldGet(_anchorOffset, this));
  } else {
    selection.setPosition(editor_highlight_classPrivateFieldGet(_focusNode, this), editor_highlight_classPrivateFieldGet(_focusOffset, this));
  }
}
function _getRotation() {
  return editor_highlight_classPrivateFieldGet(_isFreeHighlight, this) ? this.rotation : 0;
}
function _serializeBoxes() {
  if (editor_highlight_classPrivateFieldGet(_isFreeHighlight, this)) {
    return null;
  }
  var _this$pageDimensions = editor_highlight_slicedToArray(this.pageDimensions, 2),
    pageWidth = _this$pageDimensions[0],
    pageHeight = _this$pageDimensions[1];
  var _this$pageTranslation = editor_highlight_slicedToArray(this.pageTranslation, 2),
    pageX = _this$pageTranslation[0],
    pageY = _this$pageTranslation[1];
  var boxes = editor_highlight_classPrivateFieldGet(_boxes, this);
  var quadPoints = new Float32Array(boxes.length * 8);
  var i = 0;
  var _iterator = editor_highlight_createForOfIteratorHelper(boxes),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var _step$value = _step.value,
        x = _step$value.x,
        y = _step$value.y,
        width = _step$value.width,
        height = _step$value.height;
      var sx = x * pageWidth + pageX;
      var sy = (1 - y) * pageHeight + pageY;
      quadPoints[i] = quadPoints[i + 4] = sx;
      quadPoints[i + 1] = quadPoints[i + 3] = sy;
      quadPoints[i + 2] = quadPoints[i + 6] = sx + width * pageWidth;
      quadPoints[i + 5] = quadPoints[i + 7] = sy - height * pageHeight;
      i += 8;
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return quadPoints;
}
function _serializeOutlines(rect) {
  return editor_highlight_classPrivateFieldGet(_highlightOutlines, this).serialize(rect, editor_highlight_assertClassBrand(_HighlightEditor_brand, this, _getRotation).call(this));
}
function _highlightMove(parent, event) {
  if (this._freeHighlight.add(event)) {
    parent.drawLayer.updateProperties(this._freeHighlightId, {
      path: {
        d: this._freeHighlight.toSVGPath()
      }
    });
  }
}
function _endHighlight(parent, event) {
  if (!this._freeHighlight.isEmpty()) {
    parent.createAndAddNewEditor(event, false, {
      highlightId: this._freeHighlightId,
      highlightOutlines: this._freeHighlight.getOutlines(),
      clipPathId: this._freeHighlightClipId,
      methodOfCreation: "main_toolbar"
    });
  } else {
    parent.drawLayer.remove(this._freeHighlightId);
  }
  this._freeHighlightId = -1;
  this._freeHighlight = null;
  this._freeHighlightClipId = "";
}
function highlight_hasElementChanged(serialized) {
  var color = this._initialData.color;
  return serialized.color.some(function (c, i) {
    return c !== color[i];
  });
}
highlight_defineProperty(HighlightEditor, "_defaultColor", null);
highlight_defineProperty(HighlightEditor, "_defaultOpacity", 1);
highlight_defineProperty(HighlightEditor, "_defaultThickness", 12);
highlight_defineProperty(HighlightEditor, "_type", "highlight");
highlight_defineProperty(HighlightEditor, "_editorType", AnnotationEditorType.HIGHLIGHT);
highlight_defineProperty(HighlightEditor, "_freeHighlightId", -1);
highlight_defineProperty(HighlightEditor, "_freeHighlight", null);
highlight_defineProperty(HighlightEditor, "_freeHighlightClipId", "");

;// ./src/display/editor/draw.js



























function draw_typeof(o) { "@babel/helpers - typeof"; return draw_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, draw_typeof(o); }
var _DrawingEditor;
function draw_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ draw_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == draw_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(draw_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function draw_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function draw_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { draw_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { draw_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function draw_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = draw_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function draw_callSuper(t, o, e) { return o = draw_getPrototypeOf(o), draw_possibleConstructorReturn(t, draw_isNativeReflectConstruct() ? Reflect.construct(o, e || [], draw_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function draw_possibleConstructorReturn(t, e) { if (e && ("object" == draw_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return draw_assertThisInitialized(t); }
function draw_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function draw_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (draw_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function draw_superPropGet(t, o, e, r) { var p = draw_get(draw_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function draw_get() { return draw_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = draw_superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, draw_get.apply(null, arguments); }
function draw_superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = draw_getPrototypeOf(t));); return t; }
function draw_getPrototypeOf(t) { return draw_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, draw_getPrototypeOf(t); }
function draw_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && draw_setPrototypeOf(t, e); }
function draw_setPrototypeOf(t, e) { return draw_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, draw_setPrototypeOf(t, e); }
function draw_classPrivateMethodInitSpec(e, a) { draw_checkPrivateRedeclaration(e, a), a.add(e); }
function draw_defineProperty(e, r, t) { return (r = draw_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function draw_slicedToArray(r, e) { return draw_arrayWithHoles(r) || draw_iterableToArrayLimit(r, e) || draw_unsupportedIterableToArray(r, e) || draw_nonIterableRest(); }
function draw_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function draw_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return draw_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? draw_arrayLikeToArray(r, a) : void 0; } }
function draw_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function draw_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function draw_arrayWithHoles(r) { if (Array.isArray(r)) return r; }




















function draw_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function draw_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, draw_toPropertyKey(o.key), o); } }
function draw_createClass(e, r, t) { return r && draw_defineProperties(e.prototype, r), t && draw_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function draw_toPropertyKey(t) { var i = draw_toPrimitive(t, "string"); return "symbol" == draw_typeof(i) ? i : i + ""; }
function draw_toPrimitive(t, r) { if ("object" != draw_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != draw_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function draw_classPrivateFieldInitSpec(e, t, a) { draw_checkPrivateRedeclaration(e, t), t.set(e, a); }
function draw_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function draw_classPrivateFieldSet(s, a, r) { return s.set(draw_assertClassBrand(s, a), r), r; }
function draw_classPrivateFieldGet(s, a) { return s.get(draw_assertClassBrand(s, a)); }
function draw_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }



var _svgProperties = /*#__PURE__*/new WeakMap();
var DrawingOptions = /*#__PURE__*/function () {
  function DrawingOptions() {
    draw_classCallCheck(this, DrawingOptions);
    draw_classPrivateFieldInitSpec(this, _svgProperties, Object.create(null));
  }
  return draw_createClass(DrawingOptions, [{
    key: "updateProperty",
    value: function updateProperty(name, value) {
      this[name] = value;
      this.updateSVGProperty(name, value);
    }
  }, {
    key: "updateProperties",
    value: function updateProperties(properties) {
      if (!properties) {
        return;
      }
      for (var _i = 0, _Object$entries = Object.entries(properties); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = draw_slicedToArray(_Object$entries[_i], 2),
          name = _Object$entries$_i[0],
          value = _Object$entries$_i[1];
        this.updateProperty(name, value);
      }
    }
  }, {
    key: "updateSVGProperty",
    value: function updateSVGProperty(name, value) {
      draw_classPrivateFieldGet(_svgProperties, this)[name] = value;
    }
  }, {
    key: "toSVGProperties",
    value: function toSVGProperties() {
      var root = draw_classPrivateFieldGet(_svgProperties, this);
      draw_classPrivateFieldSet(_svgProperties, this, Object.create(null));
      return {
        root: root
      };
    }
  }, {
    key: "reset",
    value: function reset() {
      draw_classPrivateFieldSet(_svgProperties, this, Object.create(null));
    }
  }, {
    key: "updateAll",
    value: function updateAll() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this;
      this.updateProperties(options);
    }
  }, {
    key: "clone",
    value: function clone() {
      unreachable("Not implemented");
    }
  }]);
}();
var _drawOutlines = /*#__PURE__*/new WeakMap();
var _mustBeCommitted = /*#__PURE__*/new WeakMap();
var _DrawingEditor_brand = /*#__PURE__*/new WeakSet();
var DrawingEditor = /*#__PURE__*/function (_AnnotationEditor) {
  function DrawingEditor(params) {
    var _this;
    draw_classCallCheck(this, DrawingEditor);
    _this = draw_callSuper(this, DrawingEditor, [params]);
    draw_classPrivateMethodInitSpec(_this, _DrawingEditor_brand);
    draw_classPrivateFieldInitSpec(_this, _drawOutlines, null);
    draw_classPrivateFieldInitSpec(_this, _mustBeCommitted, void 0);
    draw_defineProperty(_this, "_drawId", null);
    draw_classPrivateFieldSet(_mustBeCommitted, _this, params.mustBeCommitted || false);
    if (params.drawOutlines) {
      draw_assertClassBrand(_DrawingEditor_brand, _this, _createDrawOutlines).call(_this, params);
      draw_assertClassBrand(_DrawingEditor_brand, _this, draw_addToDrawLayer).call(_this);
    }
    return _this;
  }
  draw_inherits(DrawingEditor, _AnnotationEditor);
  return draw_createClass(DrawingEditor, [{
    key: "updateParams",
    value: function updateParams(type, value) {
      var propertyName = this.constructor.typesMap.get(type);
      if (propertyName) {
        this._updateProperty(type, propertyName, value);
      }
    }
  }, {
    key: "propertiesToUpdate",
    get: function get() {
      var properties = [];
      var _drawingOptions = this._drawingOptions;
      var _iterator = draw_createForOfIteratorHelper(this.constructor.typesMap),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = draw_slicedToArray(_step.value, 2),
            type = _step$value[0],
            name = _step$value[1];
          properties.push([type, _drawingOptions[name]]);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return properties;
    }
  }, {
    key: "_updateProperty",
    value: function _updateProperty(type, name, value) {
      var _this2 = this;
      var options = this._drawingOptions;
      var savedValue = options[name];
      var setter = function setter(val) {
        var _this2$parent;
        options.updateProperty(name, val);
        var bbox = draw_classPrivateFieldGet(_drawOutlines, _this2).updateProperty(name, val);
        if (bbox) {
          draw_assertClassBrand(_DrawingEditor_brand, _this2, _updateBbox).call(_this2, bbox);
        }
        (_this2$parent = _this2.parent) === null || _this2$parent === void 0 || _this2$parent.drawLayer.updateProperties(_this2._drawId, options.toSVGProperties());
      };
      this.addCommands({
        cmd: setter.bind(this, value),
        undo: setter.bind(this, savedValue),
        post: this._uiManager.updateUI.bind(this._uiManager, this),
        mustExec: true,
        type: type,
        overwriteIfSameType: true,
        keepUndo: true
      });
    }
  }, {
    key: "_onResizing",
    value: function _onResizing() {
      var _this$parent;
      (_this$parent = this.parent) === null || _this$parent === void 0 || _this$parent.drawLayer.updateProperties(this._drawId, DrawingEditor._mergeSVGProperties(draw_classPrivateFieldGet(_drawOutlines, this).getPathResizingSVGProperties(draw_assertClassBrand(_DrawingEditor_brand, this, _convertToDrawSpace).call(this)), {
        bbox: draw_assertClassBrand(_DrawingEditor_brand, this, _rotateBox).call(this)
      }));
    }
  }, {
    key: "_onResized",
    value: function _onResized() {
      var _this$parent2;
      (_this$parent2 = this.parent) === null || _this$parent2 === void 0 || _this$parent2.drawLayer.updateProperties(this._drawId, DrawingEditor._mergeSVGProperties(draw_classPrivateFieldGet(_drawOutlines, this).getPathResizedSVGProperties(draw_assertClassBrand(_DrawingEditor_brand, this, _convertToDrawSpace).call(this)), {
        bbox: draw_assertClassBrand(_DrawingEditor_brand, this, _rotateBox).call(this)
      }));
    }
  }, {
    key: "_onTranslating",
    value: function _onTranslating(x, y) {
      var _this$parent3;
      (_this$parent3 = this.parent) === null || _this$parent3 === void 0 || _this$parent3.drawLayer.updateProperties(this._drawId, {
        bbox: draw_assertClassBrand(_DrawingEditor_brand, this, _rotateBox).call(this, x, y)
      });
    }
  }, {
    key: "_onTranslated",
    value: function _onTranslated() {
      var _this$parent4;
      (_this$parent4 = this.parent) === null || _this$parent4 === void 0 || _this$parent4.drawLayer.updateProperties(this._drawId, DrawingEditor._mergeSVGProperties(draw_classPrivateFieldGet(_drawOutlines, this).getPathTranslatedSVGProperties(draw_assertClassBrand(_DrawingEditor_brand, this, _convertToDrawSpace).call(this), this.parentDimensions), {
        bbox: draw_assertClassBrand(_DrawingEditor_brand, this, _rotateBox).call(this)
      }));
    }
  }, {
    key: "_onStartDragging",
    value: function _onStartDragging() {
      var _this$parent5;
      (_this$parent5 = this.parent) === null || _this$parent5 === void 0 || _this$parent5.drawLayer.updateProperties(this._drawId, {
        rootClass: {
          moving: true
        }
      });
    }
  }, {
    key: "_onStopDragging",
    value: function _onStopDragging() {
      var _this$parent6;
      (_this$parent6 = this.parent) === null || _this$parent6 === void 0 || _this$parent6.drawLayer.updateProperties(this._drawId, {
        rootClass: {
          moving: false
        }
      });
    }
  }, {
    key: "commit",
    value: function commit() {
      draw_superPropGet(DrawingEditor, "commit", this, 3)([]);
      this.disableEditMode();
      this.disableEditing();
    }
  }, {
    key: "disableEditing",
    value: function disableEditing() {
      draw_superPropGet(DrawingEditor, "disableEditing", this, 3)([]);
      this.div.classList.toggle("disabled", true);
    }
  }, {
    key: "enableEditing",
    value: function enableEditing() {
      draw_superPropGet(DrawingEditor, "enableEditing", this, 3)([]);
      this.div.classList.toggle("disabled", false);
    }
  }, {
    key: "getBaseTranslation",
    value: function getBaseTranslation() {
      return [0, 0];
    }
  }, {
    key: "isResizable",
    get: function get() {
      return true;
    }
  }, {
    key: "onceAdded",
    value: function onceAdded(focus) {
      if (!this.annotationElementId) {
        this.parent.addUndoableEditor(this);
      }
      this._isDraggable = true;
      if (draw_classPrivateFieldGet(_mustBeCommitted, this)) {
        draw_classPrivateFieldSet(_mustBeCommitted, this, false);
        this.commit();
        this.parent.setSelected(this);
        if (focus && this.isOnScreen) {
          this.div.focus();
        }
      }
    }
  }, {
    key: "remove",
    value: function remove() {
      draw_assertClassBrand(_DrawingEditor_brand, this, draw_cleanDrawLayer).call(this);
      draw_superPropGet(DrawingEditor, "remove", this, 3)([]);
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      if (!this.parent) {
        return;
      }
      draw_superPropGet(DrawingEditor, "rebuild", this, 3)([]);
      if (this.div === null) {
        return;
      }
      draw_assertClassBrand(_DrawingEditor_brand, this, draw_addToDrawLayer).call(this);
      draw_assertClassBrand(_DrawingEditor_brand, this, _updateBbox).call(this, draw_classPrivateFieldGet(_drawOutlines, this).box);
      if (!this.isAttachedToDOM) {
        this.parent.add(this);
      }
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      var mustBeSelected = false;
      if (this.parent && !parent) {
        this._uiManager.removeShouldRescale(this);
        draw_assertClassBrand(_DrawingEditor_brand, this, draw_cleanDrawLayer).call(this);
      } else if (parent) {
        var _this$div;
        this._uiManager.addShouldRescale(this);
        draw_assertClassBrand(_DrawingEditor_brand, this, draw_addToDrawLayer).call(this, parent);
        mustBeSelected = !this.parent && ((_this$div = this.div) === null || _this$div === void 0 ? void 0 : _this$div.classList.contains("selectedEditor"));
      }
      draw_superPropGet(DrawingEditor, "setParent", this, 3)([parent]);
      if (mustBeSelected) {
        this.select();
      }
    }
  }, {
    key: "rotate",
    value: function rotate() {
      if (!this.parent) {
        return;
      }
      this.parent.drawLayer.updateProperties(this._drawId, DrawingEditor._mergeSVGProperties({
        bbox: draw_assertClassBrand(_DrawingEditor_brand, this, _rotateBox).call(this)
      }, draw_classPrivateFieldGet(_drawOutlines, this).updateRotation((this.parentRotation - this.rotation + 360) % 360)));
    }
  }, {
    key: "onScaleChanging",
    value: function onScaleChanging() {
      if (!this.parent) {
        return;
      }
      draw_assertClassBrand(_DrawingEditor_brand, this, _updateBbox).call(this, draw_classPrivateFieldGet(_drawOutlines, this).updateParentDimensions(this.parentDimensions, this.parent.scale));
    }
  }, {
    key: "render",
    value: function render() {
      if (this.div) {
        return this.div;
      }
      var div = draw_superPropGet(DrawingEditor, "render", this, 3)([]);
      div.classList.add("draw");
      var drawDiv = document.createElement("div");
      div.append(drawDiv);
      drawDiv.setAttribute("aria-hidden", "true");
      drawDiv.className = "internal";
      var _this$parentDimension = draw_slicedToArray(this.parentDimensions, 2),
        parentWidth = _this$parentDimension[0],
        parentHeight = _this$parentDimension[1];
      this.setDims(this.width * parentWidth, this.height * parentHeight);
      this._uiManager.addShouldRescale(this);
      this.disableEditing();
      return div;
    }
  }, {
    key: "createDrawingOptions",
    value: function createDrawingOptions(_data) {}
  }, {
    key: "serializeDraw",
    value: function serializeDraw(isForCopying) {
      var _this$pageTranslation = draw_slicedToArray(this.pageTranslation, 2),
        pageX = _this$pageTranslation[0],
        pageY = _this$pageTranslation[1];
      var _this$pageDimensions = draw_slicedToArray(this.pageDimensions, 2),
        pageWidth = _this$pageDimensions[0],
        pageHeight = _this$pageDimensions[1];
      return draw_classPrivateFieldGet(_drawOutlines, this).serialize([pageX, pageY, pageWidth, pageHeight], isForCopying);
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      annotation.updateEdited({
        rect: this.getRect(0, 0)
      });
      return null;
    }
  }], [{
    key: "_mergeSVGProperties",
    value: function _mergeSVGProperties(p1, p2) {
      var p1Keys = new Set(Object.keys(p1));
      for (var _i2 = 0, _Object$entries2 = Object.entries(p2); _i2 < _Object$entries2.length; _i2++) {
        var _Object$entries2$_i = draw_slicedToArray(_Object$entries2[_i2], 2),
          key = _Object$entries2$_i[0],
          value = _Object$entries2$_i[1];
        if (p1Keys.has(key)) {
          Object.assign(p1[key], value);
        } else {
          p1[key] = value;
        }
      }
      return p1;
    }
  }, {
    key: "getDefaultDrawingOptions",
    value: function getDefaultDrawingOptions(_options) {
      unreachable("Not implemented");
    }
  }, {
    key: "typesMap",
    get: function get() {
      unreachable("Not implemented");
    }
  }, {
    key: "isDrawer",
    get: function get() {
      return true;
    }
  }, {
    key: "supportMultipleDrawings",
    get: function get() {
      return false;
    }
  }, {
    key: "updateDefaultParams",
    value: function updateDefaultParams(type, value) {
      var propertyName = this.typesMap.get(type);
      if (propertyName) {
        this._defaultDrawingOptions.updateProperty(propertyName, value);
      }
      if (this._currentParent) {
        _currentDraw._.updateProperty(propertyName, value);
        this._currentParent.drawLayer.updateProperties(this._currentDrawId, this._defaultDrawingOptions.toSVGProperties());
      }
    }
  }, {
    key: "defaultPropertiesToUpdate",
    get: function get() {
      var properties = [];
      var options = this._defaultDrawingOptions;
      var _iterator2 = draw_createForOfIteratorHelper(this.typesMap),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = draw_slicedToArray(_step2.value, 2),
            type = _step2$value[0],
            name = _step2$value[1];
          properties.push([type, options[name]]);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return properties;
    }
  }, {
    key: "onScaleChangingWhenDrawing",
    value: function onScaleChangingWhenDrawing() {}
  }, {
    key: "createDrawerInstance",
    value: function createDrawerInstance(_x, _y, _parentWidth, _parentHeight, _rotation) {
      unreachable("Not implemented");
    }
  }, {
    key: "startDrawing",
    value: function startDrawing(parent, uiManager, _isLTR, event) {
      var _currentPointerType$_,
        _this3 = this,
        _uiManager$_editorUnd;
      var target = event.target,
        x = event.offsetX,
        y = event.offsetY,
        pointerId = event.pointerId,
        pointerType = event.pointerType;
      if (_currentPointerType._ && _currentPointerType._ !== pointerType) {
        return;
      }
      var rotation = parent.viewport.rotation;
      var _target$getBoundingCl = target.getBoundingClientRect(),
        parentWidth = _target$getBoundingCl.width,
        parentHeight = _target$getBoundingCl.height;
      var ac = _currentDrawingAC._ = new AbortController();
      var signal = parent.combinedSignal(ac);
      _currentPointerId._ || (_currentPointerId._ = pointerId);
      (_currentPointerType$_ = _currentPointerType._) !== null && _currentPointerType$_ !== void 0 ? _currentPointerType$_ : _currentPointerType._ = pointerType;
      window.addEventListener("pointerup", function (e) {
        if (_currentPointerId._ === e.pointerId) {
          _this3._endDraw(e);
        } else {
          var _currentPointerIds$_;
          (_currentPointerIds$_ = _currentPointerIds._) === null || _currentPointerIds$_ === void 0 || _currentPointerIds$_.delete(e.pointerId);
        }
      }, {
        signal: signal
      });
      window.addEventListener("pointercancel", function (e) {
        if (_currentPointerId._ === e.pointerId) {
          _this3._currentParent.endDrawingSession();
        } else {
          var _currentPointerIds$_2;
          (_currentPointerIds$_2 = _currentPointerIds._) === null || _currentPointerIds$_2 === void 0 || _currentPointerIds$_2.delete(e.pointerId);
        }
      }, {
        signal: signal
      });
      window.addEventListener("pointerdown", function (e) {
        if (_currentPointerType._ !== e.pointerType) {
          return;
        }
        (_currentPointerIds._ || (_currentPointerIds._ = new Set())).add(e.pointerId);
        if (_currentDraw._.isCancellable()) {
          _currentDraw._.removeLastElement();
          if (_currentDraw._.isEmpty()) {
            _this3._currentParent.endDrawingSession(true);
          } else {
            _this3._endDraw(null);
          }
        }
      }, {
        capture: true,
        passive: false,
        signal: signal
      });
      window.addEventListener("contextmenu", noContextMenu, {
        signal: signal
      });
      target.addEventListener("pointermove", this._drawMove.bind(this), {
        signal: signal
      });
      target.addEventListener("touchmove", function (e) {
        if (e.timeStamp === _currentMoveTimestamp._) {
          stopEvent(e);
        }
      }, {
        signal: signal
      });
      parent.toggleDrawing();
      (_uiManager$_editorUnd = uiManager._editorUndoBar) === null || _uiManager$_editorUnd === void 0 || _uiManager$_editorUnd.hide();
      if (_currentDraw._) {
        parent.drawLayer.updateProperties(this._currentDrawId, _currentDraw._.startNew(x, y, parentWidth, parentHeight, rotation));
        return;
      }
      uiManager.updateUIForDefaultProperties(this);
      _currentDraw._ = this.createDrawerInstance(x, y, parentWidth, parentHeight, rotation);
      _currentDrawingOptions._ = this.getDefaultDrawingOptions();
      this._currentParent = parent;
      var _parent$drawLayer$dra = parent.drawLayer.draw(this._mergeSVGProperties(_currentDrawingOptions._.toSVGProperties(), _currentDraw._.defaultSVGProperties), true, false);
      this._currentDrawId = _parent$drawLayer$dra.id;
    }
  }, {
    key: "_drawMove",
    value: function _drawMove(event) {
      var _currentPointerIds$_3;
      _currentMoveTimestamp._ = -1;
      if (!_currentDraw._) {
        return;
      }
      var offsetX = event.offsetX,
        offsetY = event.offsetY,
        pointerId = event.pointerId;
      if (_currentPointerId._ !== pointerId) {
        return;
      }
      if (((_currentPointerIds$_3 = _currentPointerIds._) === null || _currentPointerIds$_3 === void 0 ? void 0 : _currentPointerIds$_3.size) >= 1) {
        this._endDraw(event);
        return;
      }
      this._currentParent.drawLayer.updateProperties(this._currentDrawId, _currentDraw._.add(offsetX, offsetY));
      _currentMoveTimestamp._ = event.timeStamp;
      stopEvent(event);
    }
  }, {
    key: "_cleanup",
    value: function _cleanup(all) {
      if (all) {
        this._currentDrawId = -1;
        this._currentParent = null;
        _currentDraw._ = null;
        _currentDrawingOptions._ = null;
        _currentPointerType._ = null;
        _currentMoveTimestamp._ = NaN;
      }
      if (_currentDrawingAC._) {
        _currentDrawingAC._.abort();
        _currentDrawingAC._ = null;
        _currentPointerId._ = NaN;
        _currentPointerIds._ = null;
      }
    }
  }, {
    key: "_endDraw",
    value: function _endDraw(event) {
      var parent = this._currentParent;
      if (!parent) {
        return;
      }
      parent.toggleDrawing(true);
      this._cleanup(false);
      if (event) {
        parent.drawLayer.updateProperties(this._currentDrawId, _currentDraw._.end(event.offsetX, event.offsetY));
      }
      if (this.supportMultipleDrawings) {
        var draw = _currentDraw._;
        var drawId = this._currentDrawId;
        var lastElement = draw.getLastElement();
        parent.addCommands({
          cmd: function cmd() {
            parent.drawLayer.updateProperties(drawId, draw.setLastElement(lastElement));
          },
          undo: function undo() {
            parent.drawLayer.updateProperties(drawId, draw.removeLastElement());
          },
          mustExec: false,
          type: AnnotationEditorParamsType.DRAW_STEP
        });
        return;
      }
      this.endDrawing(false);
    }
  }, {
    key: "endDrawing",
    value: function endDrawing(isAborted) {
      var parent = this._currentParent;
      if (!parent) {
        return null;
      }
      parent.toggleDrawing(true);
      parent.cleanUndoStack(AnnotationEditorParamsType.DRAW_STEP);
      if (!_currentDraw._.isEmpty()) {
        var _parent$pageDimension = draw_slicedToArray(parent.pageDimensions, 2),
          pageWidth = _parent$pageDimension[0],
          pageHeight = _parent$pageDimension[1],
          scale = parent.scale;
        var editor = parent.createAndAddNewEditor({
          offsetX: 0,
          offsetY: 0
        }, false, {
          drawId: this._currentDrawId,
          drawOutlines: _currentDraw._.getOutlines(pageWidth * scale, pageHeight * scale, scale, this._INNER_MARGIN),
          drawingOptions: _currentDrawingOptions._,
          mustBeCommitted: !isAborted
        });
        this._cleanup(true);
        return editor;
      }
      parent.drawLayer.remove(this._currentDrawId);
      this._cleanup(true);
      return null;
    }
  }, {
    key: "deserializeDraw",
    value: function deserializeDraw(_pageX, _pageY, _pageWidth, _pageHeight, _innerWidth, _data) {
      unreachable("Not implemented");
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = draw_asyncToGenerator(/*#__PURE__*/draw_regeneratorRuntime().mark(function _callee(data, parent, uiManager) {
        var _parent$viewport$rawD, pageWidth, pageHeight, pageX, pageY, drawOutlines, editor;
        return draw_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _parent$viewport$rawD = parent.viewport.rawDims, pageWidth = _parent$viewport$rawD.pageWidth, pageHeight = _parent$viewport$rawD.pageHeight, pageX = _parent$viewport$rawD.pageX, pageY = _parent$viewport$rawD.pageY;
              drawOutlines = this.deserializeDraw(pageX, pageY, pageWidth, pageHeight, this._INNER_MARGIN, data);
              _context.next = 4;
              return draw_superPropGet(DrawingEditor, "deserialize", this, 2)([data, parent, uiManager]);
            case 4:
              editor = _context.sent;
              editor.createDrawingOptions(data);
              draw_assertClassBrand(_DrawingEditor_brand, editor, _createDrawOutlines).call(editor, {
                drawOutlines: drawOutlines
              });
              draw_assertClassBrand(_DrawingEditor_brand, editor, draw_addToDrawLayer).call(editor);
              editor.onScaleChanging();
              editor.rotate();
              return _context.abrupt("return", editor);
            case 11:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function deserialize(_x2, _x3, _x4) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }, {
    key: "canCreateNewEmptyEditor",
    value: function canCreateNewEmptyEditor() {
      return false;
    }
  }]);
}(AnnotationEditor);
_DrawingEditor = DrawingEditor;
function _createDrawOutlines(_ref) {
  var drawOutlines = _ref.drawOutlines,
    drawId = _ref.drawId,
    drawingOptions = _ref.drawingOptions;
  draw_classPrivateFieldSet(_drawOutlines, this, drawOutlines);
  this._drawingOptions || (this._drawingOptions = drawingOptions);
  if (drawId >= 0) {
    this._drawId = drawId;
    this.parent.drawLayer.finalizeDraw(drawId, drawOutlines.defaultProperties);
  } else {
    this._drawId = draw_assertClassBrand(_DrawingEditor_brand, this, _createDrawing).call(this, drawOutlines, this.parent);
  }
  draw_assertClassBrand(_DrawingEditor_brand, this, _updateBbox).call(this, drawOutlines.box);
}
function _createDrawing(drawOutlines, parent) {
  var _parent$drawLayer$dra2 = parent.drawLayer.draw(_DrawingEditor._mergeSVGProperties(this._drawingOptions.toSVGProperties(), drawOutlines.defaultSVGProperties), false, false),
    id = _parent$drawLayer$dra2.id;
  return id;
}
function draw_cleanDrawLayer() {
  if (this._drawId === null || !this.parent) {
    return;
  }
  this.parent.drawLayer.remove(this._drawId);
  this._drawId = null;
  this._drawingOptions.reset();
}
function draw_addToDrawLayer() {
  var parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.parent;
  if (this._drawId !== null && this.parent === parent) {
    return;
  }
  if (this._drawId !== null) {
    this.parent.drawLayer.updateParent(this._drawId, parent.drawLayer);
    return;
  }
  this._drawingOptions.updateAll();
  this._drawId = draw_assertClassBrand(_DrawingEditor_brand, this, _createDrawing).call(this, draw_classPrivateFieldGet(_drawOutlines, this), parent);
}
function _convertToParentSpace(_ref2) {
  var _ref3 = draw_slicedToArray(_ref2, 4),
    x = _ref3[0],
    y = _ref3[1],
    width = _ref3[2],
    height = _ref3[3];
  var _this$parentDimension2 = draw_slicedToArray(this.parentDimensions, 2),
    pW = _this$parentDimension2[0],
    pH = _this$parentDimension2[1],
    rotation = this.rotation;
  switch (rotation) {
    case 90:
      return [y, 1 - x, width * (pH / pW), height * (pW / pH)];
    case 180:
      return [1 - x, 1 - y, width, height];
    case 270:
      return [1 - y, x, width * (pH / pW), height * (pW / pH)];
    default:
      return [x, y, width, height];
  }
}
function _convertToDrawSpace() {
  var x = this.x,
    y = this.y,
    width = this.width,
    height = this.height,
    _this$parentDimension3 = draw_slicedToArray(this.parentDimensions, 2),
    pW = _this$parentDimension3[0],
    pH = _this$parentDimension3[1],
    rotation = this.rotation;
  switch (rotation) {
    case 90:
      return [1 - y, x, width * (pW / pH), height * (pH / pW)];
    case 180:
      return [1 - x, 1 - y, width, height];
    case 270:
      return [y, 1 - x, width * (pW / pH), height * (pH / pW)];
    default:
      return [x, y, width, height];
  }
}
function _updateBbox(bbox) {
  var _assertClassBrand$cal = draw_assertClassBrand(_DrawingEditor_brand, this, _convertToParentSpace).call(this, bbox);
  var _assertClassBrand$cal2 = draw_slicedToArray(_assertClassBrand$cal, 4);
  this.x = _assertClassBrand$cal2[0];
  this.y = _assertClassBrand$cal2[1];
  this.width = _assertClassBrand$cal2[2];
  this.height = _assertClassBrand$cal2[3];
  if (this.div) {
    this.fixAndSetPosition();
    var _this$parentDimension4 = draw_slicedToArray(this.parentDimensions, 2),
      parentWidth = _this$parentDimension4[0],
      parentHeight = _this$parentDimension4[1];
    this.setDims(this.width * parentWidth, this.height * parentHeight);
  }
  this._onResized();
}
function _rotateBox() {
  var x = this.x,
    y = this.y,
    width = this.width,
    height = this.height,
    rotation = this.rotation,
    parentRotation = this.parentRotation,
    _this$parentDimension5 = draw_slicedToArray(this.parentDimensions, 2),
    pW = _this$parentDimension5[0],
    pH = _this$parentDimension5[1];
  switch ((rotation * 4 + parentRotation) / 90) {
    case 1:
      return [1 - y - height, x, height, width];
    case 2:
      return [1 - x - width, 1 - y - height, width, height];
    case 3:
      return [y, 1 - x - width, height, width];
    case 4:
      return [x, y - width * (pW / pH), height * (pH / pW), width * (pW / pH)];
    case 5:
      return [1 - y, x, width * (pW / pH), height * (pH / pW)];
    case 6:
      return [1 - x - height * (pH / pW), 1 - y, height * (pH / pW), width * (pW / pH)];
    case 7:
      return [y - width * (pW / pH), 1 - x - height * (pH / pW), width * (pW / pH), height * (pH / pW)];
    case 8:
      return [x - width, y - height, width, height];
    case 9:
      return [1 - y, x - width, height, width];
    case 10:
      return [1 - x, 1 - y, width, height];
    case 11:
      return [y - height, 1 - x, height, width];
    case 12:
      return [x - height * (pH / pW), y, height * (pH / pW), width * (pW / pH)];
    case 13:
      return [1 - y - width * (pW / pH), x - height * (pH / pW), width * (pW / pH), height * (pH / pW)];
    case 14:
      return [1 - x, 1 - y - width * (pW / pH), height * (pH / pW), width * (pW / pH)];
    case 15:
      return [y, 1 - x, width * (pW / pH), height * (pH / pW)];
    default:
      return [x, y, width, height];
  }
}
draw_defineProperty(DrawingEditor, "_currentDrawId", -1);
draw_defineProperty(DrawingEditor, "_currentParent", null);
var _currentDraw = {
  _: null
};
var _currentDrawingAC = {
  _: null
};
var _currentDrawingOptions = {
  _: null
};
var _currentPointerId = {
  _: NaN
};
var _currentPointerType = {
  _: null
};
var _currentPointerIds = {
  _: null
};
var _currentMoveTimestamp = {
  _: NaN
};
draw_defineProperty(DrawingEditor, "_INNER_MARGIN", 3);

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.typed-array.float64-array.js
var es_typed_array_float64_array = __webpack_require__(9833);
;// ./src/display/editor/drawers/inkdraw.js
function inkdraw_typeof(o) { "@babel/helpers - typeof"; return inkdraw_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, inkdraw_typeof(o); }
function inkdraw_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = inkdraw_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function inkdraw_callSuper(t, o, e) { return o = inkdraw_getPrototypeOf(o), inkdraw_possibleConstructorReturn(t, inkdraw_isNativeReflectConstruct() ? Reflect.construct(o, e || [], inkdraw_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function inkdraw_possibleConstructorReturn(t, e) { if (e && ("object" == inkdraw_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return inkdraw_assertThisInitialized(t); }
function inkdraw_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function inkdraw_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (inkdraw_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function inkdraw_getPrototypeOf(t) { return inkdraw_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, inkdraw_getPrototypeOf(t); }
function inkdraw_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && inkdraw_setPrototypeOf(t, e); }
function inkdraw_setPrototypeOf(t, e) { return inkdraw_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, inkdraw_setPrototypeOf(t, e); }
function inkdraw_toConsumableArray(r) { return inkdraw_arrayWithoutHoles(r) || inkdraw_iterableToArray(r) || inkdraw_unsupportedIterableToArray(r) || inkdraw_nonIterableSpread(); }
function inkdraw_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function inkdraw_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function inkdraw_arrayWithoutHoles(r) { if (Array.isArray(r)) return inkdraw_arrayLikeToArray(r); }
function inkdraw_slicedToArray(r, e) { return inkdraw_arrayWithHoles(r) || inkdraw_iterableToArrayLimit(r, e) || inkdraw_unsupportedIterableToArray(r, e) || inkdraw_nonIterableRest(); }
function inkdraw_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function inkdraw_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return inkdraw_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? inkdraw_arrayLikeToArray(r, a) : void 0; } }
function inkdraw_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function inkdraw_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function inkdraw_arrayWithHoles(r) { if (Array.isArray(r)) return r; }





































































function inkdraw_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function inkdraw_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, inkdraw_toPropertyKey(o.key), o); } }
function inkdraw_createClass(e, r, t) { return r && inkdraw_defineProperties(e.prototype, r), t && inkdraw_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function inkdraw_toPropertyKey(t) { var i = inkdraw_toPrimitive(t, "string"); return "symbol" == inkdraw_typeof(i) ? i : i + ""; }
function inkdraw_toPrimitive(t, r) { if ("object" != inkdraw_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != inkdraw_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function inkdraw_classPrivateMethodInitSpec(e, a) { inkdraw_checkPrivateRedeclaration(e, a), a.add(e); }
function inkdraw_classPrivateFieldInitSpec(e, t, a) { inkdraw_checkPrivateRedeclaration(e, t), t.set(e, a); }
function inkdraw_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function inkdraw_classPrivateFieldGet(s, a) { return s.get(inkdraw_assertClassBrand(s, a)); }
function inkdraw_classPrivateFieldSet(s, a, r) { return s.set(inkdraw_assertClassBrand(s, a), r), r; }
function inkdraw_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var inkdraw_last = /*#__PURE__*/new WeakMap();
var inkdraw_line = /*#__PURE__*/new WeakMap();
var _lines = /*#__PURE__*/new WeakMap();
var inkdraw_rotation = /*#__PURE__*/new WeakMap();
var inkdraw_thickness = /*#__PURE__*/new WeakMap();
var inkdraw_points = /*#__PURE__*/new WeakMap();
var _lastSVGPath = /*#__PURE__*/new WeakMap();
var _lastIndex = /*#__PURE__*/new WeakMap();
var inkdraw_outlines = /*#__PURE__*/new WeakMap();
var _parentWidth = /*#__PURE__*/new WeakMap();
var _parentHeight = /*#__PURE__*/new WeakMap();
var _InkDrawOutliner_brand = /*#__PURE__*/new WeakSet();
var InkDrawOutliner = /*#__PURE__*/function () {
  function InkDrawOutliner(_x, _y, parentWidth, parentHeight, rotation, thickness) {
    inkdraw_classCallCheck(this, InkDrawOutliner);
    inkdraw_classPrivateMethodInitSpec(this, _InkDrawOutliner_brand);
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_last, new Float64Array(6));
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_line, void 0);
    inkdraw_classPrivateFieldInitSpec(this, _lines, void 0);
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_rotation, void 0);
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_thickness, void 0);
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_points, void 0);
    inkdraw_classPrivateFieldInitSpec(this, _lastSVGPath, "");
    inkdraw_classPrivateFieldInitSpec(this, _lastIndex, 0);
    inkdraw_classPrivateFieldInitSpec(this, inkdraw_outlines, new InkDrawOutline());
    inkdraw_classPrivateFieldInitSpec(this, _parentWidth, void 0);
    inkdraw_classPrivateFieldInitSpec(this, _parentHeight, void 0);
    inkdraw_classPrivateFieldSet(_parentWidth, this, parentWidth);
    inkdraw_classPrivateFieldSet(_parentHeight, this, parentHeight);
    inkdraw_classPrivateFieldSet(inkdraw_rotation, this, rotation);
    inkdraw_classPrivateFieldSet(inkdraw_thickness, this, thickness);
    var _assertClassBrand$cal = inkdraw_assertClassBrand(_InkDrawOutliner_brand, this, _normalizePoint).call(this, _x, _y);
    var _assertClassBrand$cal2 = inkdraw_slicedToArray(_assertClassBrand$cal, 2);
    _x = _assertClassBrand$cal2[0];
    _y = _assertClassBrand$cal2[1];
    var line = inkdraw_classPrivateFieldSet(inkdraw_line, this, [NaN, NaN, NaN, NaN, _x, _y]);
    inkdraw_classPrivateFieldSet(inkdraw_points, this, [_x, _y]);
    inkdraw_classPrivateFieldSet(_lines, this, [{
      line: line,
      points: inkdraw_classPrivateFieldGet(inkdraw_points, this)
    }]);
    inkdraw_classPrivateFieldGet(inkdraw_last, this).set(line, 0);
  }
  return inkdraw_createClass(InkDrawOutliner, [{
    key: "updateProperty",
    value: function updateProperty(name, value) {
      if (name === "stroke-width") {
        inkdraw_classPrivateFieldSet(inkdraw_thickness, this, value);
      }
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return !inkdraw_classPrivateFieldGet(_lines, this) || inkdraw_classPrivateFieldGet(_lines, this).length === 0;
    }
  }, {
    key: "isCancellable",
    value: function isCancellable() {
      return inkdraw_classPrivateFieldGet(inkdraw_points, this).length <= 10;
    }
  }, {
    key: "add",
    value: function add(x, y) {
      var _classPrivateFieldGet4;
      var _assertClassBrand$cal3 = inkdraw_assertClassBrand(_InkDrawOutliner_brand, this, _normalizePoint).call(this, x, y);
      var _assertClassBrand$cal4 = inkdraw_slicedToArray(_assertClassBrand$cal3, 2);
      x = _assertClassBrand$cal4[0];
      y = _assertClassBrand$cal4[1];
      var _classPrivateFieldGet2 = inkdraw_classPrivateFieldGet(inkdraw_last, this).subarray(2, 6),
        _classPrivateFieldGet3 = inkdraw_slicedToArray(_classPrivateFieldGet2, 4),
        x1 = _classPrivateFieldGet3[0],
        y1 = _classPrivateFieldGet3[1],
        x2 = _classPrivateFieldGet3[2],
        y2 = _classPrivateFieldGet3[3];
      var diffX = x - x2;
      var diffY = y - y2;
      var d = Math.hypot(inkdraw_classPrivateFieldGet(_parentWidth, this) * diffX, inkdraw_classPrivateFieldGet(_parentHeight, this) * diffY);
      if (d <= 2) {
        return null;
      }
      inkdraw_classPrivateFieldGet(inkdraw_points, this).push(x, y);
      if (isNaN(x1)) {
        inkdraw_classPrivateFieldGet(inkdraw_last, this).set([x2, y2, x, y], 2);
        inkdraw_classPrivateFieldGet(inkdraw_line, this).push(NaN, NaN, NaN, NaN, x, y);
        return {
          path: {
            d: this.toSVGPath()
          }
        };
      }
      if (isNaN(inkdraw_classPrivateFieldGet(inkdraw_last, this)[0])) {
        inkdraw_classPrivateFieldGet(inkdraw_line, this).splice(6, 6);
      }
      inkdraw_classPrivateFieldGet(inkdraw_last, this).set([x1, y1, x2, y2, x, y], 0);
      (_classPrivateFieldGet4 = inkdraw_classPrivateFieldGet(inkdraw_line, this)).push.apply(_classPrivateFieldGet4, inkdraw_toConsumableArray(Outline.createBezierPoints(x1, y1, x2, y2, x, y)));
      return {
        path: {
          d: this.toSVGPath()
        }
      };
    }
  }, {
    key: "end",
    value: function end(x, y) {
      var change = this.add(x, y);
      if (change) {
        return change;
      }
      if (inkdraw_classPrivateFieldGet(inkdraw_points, this).length === 2) {
        return {
          path: {
            d: this.toSVGPath()
          }
        };
      }
      return null;
    }
  }, {
    key: "startNew",
    value: function startNew(x, y, parentWidth, parentHeight, rotation) {
      inkdraw_classPrivateFieldSet(_parentWidth, this, parentWidth);
      inkdraw_classPrivateFieldSet(_parentHeight, this, parentHeight);
      inkdraw_classPrivateFieldSet(inkdraw_rotation, this, rotation);
      var _assertClassBrand$cal5 = inkdraw_assertClassBrand(_InkDrawOutliner_brand, this, _normalizePoint).call(this, x, y);
      var _assertClassBrand$cal6 = inkdraw_slicedToArray(_assertClassBrand$cal5, 2);
      x = _assertClassBrand$cal6[0];
      y = _assertClassBrand$cal6[1];
      var line = inkdraw_classPrivateFieldSet(inkdraw_line, this, [NaN, NaN, NaN, NaN, x, y]);
      inkdraw_classPrivateFieldSet(inkdraw_points, this, [x, y]);
      var last = inkdraw_classPrivateFieldGet(_lines, this).at(-1);
      if (last) {
        last.line = new Float32Array(last.line);
        last.points = new Float32Array(last.points);
      }
      inkdraw_classPrivateFieldGet(_lines, this).push({
        line: line,
        points: inkdraw_classPrivateFieldGet(inkdraw_points, this)
      });
      inkdraw_classPrivateFieldGet(inkdraw_last, this).set(line, 0);
      inkdraw_classPrivateFieldSet(_lastIndex, this, 0);
      this.toSVGPath();
      return null;
    }
  }, {
    key: "getLastElement",
    value: function getLastElement() {
      return inkdraw_classPrivateFieldGet(_lines, this).at(-1);
    }
  }, {
    key: "setLastElement",
    value: function setLastElement(element) {
      if (!inkdraw_classPrivateFieldGet(_lines, this)) {
        return inkdraw_classPrivateFieldGet(inkdraw_outlines, this).setLastElement(element);
      }
      inkdraw_classPrivateFieldGet(_lines, this).push(element);
      inkdraw_classPrivateFieldSet(inkdraw_line, this, element.line);
      inkdraw_classPrivateFieldSet(inkdraw_points, this, element.points);
      inkdraw_classPrivateFieldSet(_lastIndex, this, 0);
      return {
        path: {
          d: this.toSVGPath()
        }
      };
    }
  }, {
    key: "removeLastElement",
    value: function removeLastElement() {
      if (!inkdraw_classPrivateFieldGet(_lines, this)) {
        return inkdraw_classPrivateFieldGet(inkdraw_outlines, this).removeLastElement();
      }
      inkdraw_classPrivateFieldGet(_lines, this).pop();
      inkdraw_classPrivateFieldSet(_lastSVGPath, this, "");
      for (var i = 0, ii = inkdraw_classPrivateFieldGet(_lines, this).length; i < ii; i++) {
        var _classPrivateFieldGet5 = inkdraw_classPrivateFieldGet(_lines, this)[i],
          line = _classPrivateFieldGet5.line,
          points = _classPrivateFieldGet5.points;
        inkdraw_classPrivateFieldSet(inkdraw_line, this, line);
        inkdraw_classPrivateFieldSet(inkdraw_points, this, points);
        inkdraw_classPrivateFieldSet(_lastIndex, this, 0);
        this.toSVGPath();
      }
      return {
        path: {
          d: inkdraw_classPrivateFieldGet(_lastSVGPath, this)
        }
      };
    }
  }, {
    key: "toSVGPath",
    value: function toSVGPath() {
      var firstX = Outline.svgRound(inkdraw_classPrivateFieldGet(inkdraw_line, this)[4]);
      var firstY = Outline.svgRound(inkdraw_classPrivateFieldGet(inkdraw_line, this)[5]);
      if (inkdraw_classPrivateFieldGet(inkdraw_points, this).length === 2) {
        inkdraw_classPrivateFieldSet(_lastSVGPath, this, "".concat(inkdraw_classPrivateFieldGet(_lastSVGPath, this), " M ").concat(firstX, " ").concat(firstY, " Z"));
        return inkdraw_classPrivateFieldGet(_lastSVGPath, this);
      }
      if (inkdraw_classPrivateFieldGet(inkdraw_points, this).length <= 6) {
        var i = inkdraw_classPrivateFieldGet(_lastSVGPath, this).lastIndexOf("M");
        inkdraw_classPrivateFieldSet(_lastSVGPath, this, "".concat(inkdraw_classPrivateFieldGet(_lastSVGPath, this).slice(0, i), " M ").concat(firstX, " ").concat(firstY));
        inkdraw_classPrivateFieldSet(_lastIndex, this, 6);
      }
      if (inkdraw_classPrivateFieldGet(inkdraw_points, this).length === 4) {
        var secondX = Outline.svgRound(inkdraw_classPrivateFieldGet(inkdraw_line, this)[10]);
        var secondY = Outline.svgRound(inkdraw_classPrivateFieldGet(inkdraw_line, this)[11]);
        inkdraw_classPrivateFieldSet(_lastSVGPath, this, "".concat(inkdraw_classPrivateFieldGet(_lastSVGPath, this), " L ").concat(secondX, " ").concat(secondY));
        inkdraw_classPrivateFieldSet(_lastIndex, this, 12);
        return inkdraw_classPrivateFieldGet(_lastSVGPath, this);
      }
      var buffer = [];
      if (inkdraw_classPrivateFieldGet(_lastIndex, this) === 0) {
        buffer.push("M ".concat(firstX, " ").concat(firstY));
        inkdraw_classPrivateFieldSet(_lastIndex, this, 6);
      }
      for (var _i = inkdraw_classPrivateFieldGet(_lastIndex, this), ii = inkdraw_classPrivateFieldGet(inkdraw_line, this).length; _i < ii; _i += 6) {
        var _classPrivateFieldGet6 = inkdraw_classPrivateFieldGet(inkdraw_line, this).slice(_i, _i + 6).map(Outline.svgRound),
          _classPrivateFieldGet7 = inkdraw_slicedToArray(_classPrivateFieldGet6, 6),
          c1x = _classPrivateFieldGet7[0],
          c1y = _classPrivateFieldGet7[1],
          c2x = _classPrivateFieldGet7[2],
          c2y = _classPrivateFieldGet7[3],
          x = _classPrivateFieldGet7[4],
          y = _classPrivateFieldGet7[5];
        buffer.push("C".concat(c1x, " ").concat(c1y, " ").concat(c2x, " ").concat(c2y, " ").concat(x, " ").concat(y));
      }
      inkdraw_classPrivateFieldSet(_lastSVGPath, this, inkdraw_classPrivateFieldGet(_lastSVGPath, this) + buffer.join(" "));
      inkdraw_classPrivateFieldSet(_lastIndex, this, inkdraw_classPrivateFieldGet(inkdraw_line, this).length);
      return inkdraw_classPrivateFieldGet(_lastSVGPath, this);
    }
  }, {
    key: "getOutlines",
    value: function getOutlines(parentWidth, parentHeight, scale, innerMargin) {
      var last = inkdraw_classPrivateFieldGet(_lines, this).at(-1);
      last.line = new Float32Array(last.line);
      last.points = new Float32Array(last.points);
      inkdraw_classPrivateFieldGet(inkdraw_outlines, this).build(inkdraw_classPrivateFieldGet(_lines, this), parentWidth, parentHeight, scale, inkdraw_classPrivateFieldGet(inkdraw_rotation, this), inkdraw_classPrivateFieldGet(inkdraw_thickness, this), innerMargin);
      inkdraw_classPrivateFieldSet(inkdraw_last, this, null);
      inkdraw_classPrivateFieldSet(inkdraw_line, this, null);
      inkdraw_classPrivateFieldSet(_lines, this, null);
      inkdraw_classPrivateFieldSet(_lastSVGPath, this, null);
      return inkdraw_classPrivateFieldGet(inkdraw_outlines, this);
    }
  }, {
    key: "defaultSVGProperties",
    get: function get() {
      return {
        root: {
          viewBox: "0 0 10000 10000"
        },
        rootClass: {
          draw: true
        },
        bbox: [0, 0, 1, 1]
      };
    }
  }]);
}();
function _normalizePoint(x, y) {
  return Outline._normalizePoint(x, y, inkdraw_classPrivateFieldGet(_parentWidth, this), inkdraw_classPrivateFieldGet(_parentHeight, this), inkdraw_classPrivateFieldGet(inkdraw_rotation, this));
}
var inkdraw_bbox = /*#__PURE__*/new WeakMap();
var _currentRotation = /*#__PURE__*/new WeakMap();
var inkdraw_innerMargin = /*#__PURE__*/new WeakMap();
var _lines2 = /*#__PURE__*/new WeakMap();
var _parentWidth2 = /*#__PURE__*/new WeakMap();
var _parentHeight2 = /*#__PURE__*/new WeakMap();
var _parentScale = /*#__PURE__*/new WeakMap();
var _rotation2 = /*#__PURE__*/new WeakMap();
var _thickness2 = /*#__PURE__*/new WeakMap();
var _InkDrawOutline_brand = /*#__PURE__*/new WeakSet();
var InkDrawOutline = /*#__PURE__*/function (_Outline) {
  function InkDrawOutline() {
    var _this;
    inkdraw_classCallCheck(this, InkDrawOutline);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = inkdraw_callSuper(this, InkDrawOutline, [].concat(args));
    inkdraw_classPrivateMethodInitSpec(_this, _InkDrawOutline_brand);
    inkdraw_classPrivateFieldInitSpec(_this, inkdraw_bbox, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _currentRotation, 0);
    inkdraw_classPrivateFieldInitSpec(_this, inkdraw_innerMargin, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _lines2, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _parentWidth2, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _parentHeight2, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _parentScale, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _rotation2, void 0);
    inkdraw_classPrivateFieldInitSpec(_this, _thickness2, void 0);
    return _this;
  }
  inkdraw_inherits(InkDrawOutline, _Outline);
  return inkdraw_createClass(InkDrawOutline, [{
    key: "build",
    value: function build(lines, parentWidth, parentHeight, parentScale, rotation, thickness, innerMargin) {
      inkdraw_classPrivateFieldSet(_parentWidth2, this, parentWidth);
      inkdraw_classPrivateFieldSet(_parentHeight2, this, parentHeight);
      inkdraw_classPrivateFieldSet(_parentScale, this, parentScale);
      inkdraw_classPrivateFieldSet(_rotation2, this, rotation);
      inkdraw_classPrivateFieldSet(_thickness2, this, thickness);
      inkdraw_classPrivateFieldSet(inkdraw_innerMargin, this, innerMargin !== null && innerMargin !== void 0 ? innerMargin : 0);
      inkdraw_classPrivateFieldSet(_lines2, this, lines);
      inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _computeBbox).call(this);
    }
  }, {
    key: "setLastElement",
    value: function setLastElement(element) {
      inkdraw_classPrivateFieldGet(_lines2, this).push(element);
      return {
        path: {
          d: this.toSVGPath()
        }
      };
    }
  }, {
    key: "removeLastElement",
    value: function removeLastElement() {
      inkdraw_classPrivateFieldGet(_lines2, this).pop();
      return {
        path: {
          d: this.toSVGPath()
        }
      };
    }
  }, {
    key: "toSVGPath",
    value: function toSVGPath() {
      var buffer = [];
      var _iterator = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var line = _step.value.line;
          buffer.push("M".concat(Outline.svgRound(line[4]), " ").concat(Outline.svgRound(line[5])));
          if (line.length === 6) {
            buffer.push("Z");
            continue;
          }
          if (line.length === 12) {
            buffer.push("L".concat(Outline.svgRound(line[10]), " ").concat(Outline.svgRound(line[11])));
            continue;
          }
          for (var i = 6, ii = line.length; i < ii; i += 6) {
            var _line$subarray$map = line.subarray(i, i + 6).map(Outline.svgRound),
              _line$subarray$map2 = inkdraw_slicedToArray(_line$subarray$map, 6),
              c1x = _line$subarray$map2[0],
              c1y = _line$subarray$map2[1],
              c2x = _line$subarray$map2[2],
              c2y = _line$subarray$map2[3],
              x = _line$subarray$map2[4],
              y = _line$subarray$map2[5];
            buffer.push("C".concat(c1x, " ").concat(c1y, " ").concat(c2x, " ").concat(c2y, " ").concat(x, " ").concat(y));
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return buffer.join("");
    }
  }, {
    key: "serialize",
    value: function serialize(_ref, isForCopying) {
      var _ref2 = inkdraw_slicedToArray(_ref, 4),
        pageX = _ref2[0],
        pageY = _ref2[1],
        pageWidth = _ref2[2],
        pageHeight = _ref2[3];
      var serializedLines = [];
      var serializedPoints = [];
      var _assertClassBrand$cal7 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getBBoxWithNoMargin).call(this),
        _assertClassBrand$cal8 = inkdraw_slicedToArray(_assertClassBrand$cal7, 4),
        x = _assertClassBrand$cal8[0],
        y = _assertClassBrand$cal8[1],
        width = _assertClassBrand$cal8[2],
        height = _assertClassBrand$cal8[3];
      var tx, ty, sx, sy, x1, y1, x2, y2, rescaleFn;
      switch (inkdraw_classPrivateFieldGet(_rotation2, this)) {
        case 0:
          rescaleFn = Outline._rescale;
          tx = pageX;
          ty = pageY + pageHeight;
          sx = pageWidth;
          sy = -pageHeight;
          x1 = pageX + x * pageWidth;
          y1 = pageY + (1 - y - height) * pageHeight;
          x2 = pageX + (x + width) * pageWidth;
          y2 = pageY + (1 - y) * pageHeight;
          break;
        case 90:
          rescaleFn = Outline._rescaleAndSwap;
          tx = pageX;
          ty = pageY;
          sx = pageWidth;
          sy = pageHeight;
          x1 = pageX + y * pageWidth;
          y1 = pageY + x * pageHeight;
          x2 = pageX + (y + height) * pageWidth;
          y2 = pageY + (x + width) * pageHeight;
          break;
        case 180:
          rescaleFn = Outline._rescale;
          tx = pageX + pageWidth;
          ty = pageY;
          sx = -pageWidth;
          sy = pageHeight;
          x1 = pageX + (1 - x - width) * pageWidth;
          y1 = pageY + y * pageHeight;
          x2 = pageX + (1 - x) * pageWidth;
          y2 = pageY + (y + height) * pageHeight;
          break;
        case 270:
          rescaleFn = Outline._rescaleAndSwap;
          tx = pageX + pageWidth;
          ty = pageY + pageHeight;
          sx = -pageWidth;
          sy = -pageHeight;
          x1 = pageX + (1 - y - height) * pageWidth;
          y1 = pageY + (1 - x - width) * pageHeight;
          x2 = pageX + (1 - y) * pageWidth;
          y2 = pageY + (1 - x) * pageHeight;
          break;
      }
      var _iterator2 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var _step2$value = _step2.value,
            line = _step2$value.line,
            points = _step2$value.points;
          serializedLines.push(rescaleFn(line, tx, ty, sx, sy, isForCopying ? new Array(line.length) : null));
          serializedPoints.push(rescaleFn(points, tx, ty, sx, sy, isForCopying ? new Array(points.length) : null));
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return {
        lines: serializedLines,
        points: serializedPoints,
        rect: [x1, y1, x2, y2]
      };
    }
  }, {
    key: "box",
    get: function get() {
      return inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
    }
  }, {
    key: "updateProperty",
    value: function updateProperty(name, value) {
      if (name === "stroke-width") {
        return inkdraw_assertClassBrand(_InkDrawOutline_brand, this, inkdraw_updateThickness).call(this, value);
      }
      return null;
    }
  }, {
    key: "updateParentDimensions",
    value: function updateParentDimensions(_ref3, scale) {
      var _ref4 = inkdraw_slicedToArray(_ref3, 2),
        width = _ref4[0],
        height = _ref4[1];
      var _assertClassBrand$cal9 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
        _assertClassBrand$cal10 = inkdraw_slicedToArray(_assertClassBrand$cal9, 2),
        oldMarginX = _assertClassBrand$cal10[0],
        oldMarginY = _assertClassBrand$cal10[1];
      inkdraw_classPrivateFieldSet(_parentWidth2, this, width);
      inkdraw_classPrivateFieldSet(_parentHeight2, this, height);
      inkdraw_classPrivateFieldSet(_parentScale, this, scale);
      var _assertClassBrand$cal11 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
        _assertClassBrand$cal12 = inkdraw_slicedToArray(_assertClassBrand$cal11, 2),
        newMarginX = _assertClassBrand$cal12[0],
        newMarginY = _assertClassBrand$cal12[1];
      var diffMarginX = newMarginX - oldMarginX;
      var diffMarginY = newMarginY - oldMarginY;
      var bbox = inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
      bbox[0] -= diffMarginX;
      bbox[1] -= diffMarginY;
      bbox[2] += 2 * diffMarginX;
      bbox[3] += 2 * diffMarginY;
      return bbox;
    }
  }, {
    key: "updateRotation",
    value: function updateRotation(rotation) {
      inkdraw_classPrivateFieldSet(_currentRotation, this, rotation);
      return {
        path: {
          transform: this.rotationTransform
        }
      };
    }
  }, {
    key: "viewBox",
    get: function get() {
      return inkdraw_classPrivateFieldGet(inkdraw_bbox, this).map(Outline.svgRound).join(" ");
    }
  }, {
    key: "defaultProperties",
    get: function get() {
      var _classPrivateFieldGet8 = inkdraw_classPrivateFieldGet(inkdraw_bbox, this),
        _classPrivateFieldGet9 = inkdraw_slicedToArray(_classPrivateFieldGet8, 2),
        x = _classPrivateFieldGet9[0],
        y = _classPrivateFieldGet9[1];
      return {
        root: {
          viewBox: this.viewBox
        },
        path: {
          "transform-origin": "".concat(Outline.svgRound(x), " ").concat(Outline.svgRound(y))
        }
      };
    }
  }, {
    key: "rotationTransform",
    get: function get() {
      var _classPrivateFieldGet10 = inkdraw_classPrivateFieldGet(inkdraw_bbox, this),
        _classPrivateFieldGet11 = inkdraw_slicedToArray(_classPrivateFieldGet10, 4),
        width = _classPrivateFieldGet11[2],
        height = _classPrivateFieldGet11[3];
      var a = 0,
        b = 0,
        c = 0,
        d = 0,
        e = 0,
        f = 0;
      switch (inkdraw_classPrivateFieldGet(_currentRotation, this)) {
        case 90:
          b = height / width;
          c = -width / height;
          e = width;
          break;
        case 180:
          a = -1;
          d = -1;
          e = width;
          f = height;
          break;
        case 270:
          b = -height / width;
          c = width / height;
          f = height;
          break;
        default:
          return "";
      }
      return "matrix(".concat(a, " ").concat(b, " ").concat(c, " ").concat(d, " ").concat(Outline.svgRound(e), " ").concat(Outline.svgRound(f), ")");
    }
  }, {
    key: "getPathResizingSVGProperties",
    value: function getPathResizingSVGProperties(_ref5) {
      var _ref6 = inkdraw_slicedToArray(_ref5, 4),
        newX = _ref6[0],
        newY = _ref6[1],
        newWidth = _ref6[2],
        newHeight = _ref6[3];
      var _assertClassBrand$cal13 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
        _assertClassBrand$cal14 = inkdraw_slicedToArray(_assertClassBrand$cal13, 2),
        marginX = _assertClassBrand$cal14[0],
        marginY = _assertClassBrand$cal14[1];
      var _classPrivateFieldGet12 = inkdraw_classPrivateFieldGet(inkdraw_bbox, this),
        _classPrivateFieldGet13 = inkdraw_slicedToArray(_classPrivateFieldGet12, 4),
        x = _classPrivateFieldGet13[0],
        y = _classPrivateFieldGet13[1],
        width = _classPrivateFieldGet13[2],
        height = _classPrivateFieldGet13[3];
      if (Math.abs(width - marginX) <= Outline.PRECISION || Math.abs(height - marginY) <= Outline.PRECISION) {
        var tx = newX + newWidth / 2 - (x + width / 2);
        var ty = newY + newHeight / 2 - (y + height / 2);
        return {
          path: {
            "transform-origin": "".concat(Outline.svgRound(newX), " ").concat(Outline.svgRound(newY)),
            transform: "".concat(this.rotationTransform, " translate(").concat(tx, " ").concat(ty, ")")
          }
        };
      }
      var s1x = (newWidth - 2 * marginX) / (width - 2 * marginX);
      var s1y = (newHeight - 2 * marginY) / (height - 2 * marginY);
      var s2x = width / newWidth;
      var s2y = height / newHeight;
      return {
        path: {
          "transform-origin": "".concat(Outline.svgRound(x), " ").concat(Outline.svgRound(y)),
          transform: "".concat(this.rotationTransform, " scale(").concat(s2x, " ").concat(s2y, ") ") + "translate(".concat(Outline.svgRound(marginX), " ").concat(Outline.svgRound(marginY), ") scale(").concat(s1x, " ").concat(s1y, ") ") + "translate(".concat(Outline.svgRound(-marginX), " ").concat(Outline.svgRound(-marginY), ")")
        }
      };
    }
  }, {
    key: "getPathResizedSVGProperties",
    value: function getPathResizedSVGProperties(_ref7) {
      var _ref8 = inkdraw_slicedToArray(_ref7, 4),
        newX = _ref8[0],
        newY = _ref8[1],
        newWidth = _ref8[2],
        newHeight = _ref8[3];
      var _assertClassBrand$cal15 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
        _assertClassBrand$cal16 = inkdraw_slicedToArray(_assertClassBrand$cal15, 2),
        marginX = _assertClassBrand$cal16[0],
        marginY = _assertClassBrand$cal16[1];
      var bbox = inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
      var _bbox2 = inkdraw_slicedToArray(bbox, 4),
        x = _bbox2[0],
        y = _bbox2[1],
        width = _bbox2[2],
        height = _bbox2[3];
      bbox[0] = newX;
      bbox[1] = newY;
      bbox[2] = newWidth;
      bbox[3] = newHeight;
      if (Math.abs(width - marginX) <= Outline.PRECISION || Math.abs(height - marginY) <= Outline.PRECISION) {
        var _tx = newX + newWidth / 2 - (x + width / 2);
        var _ty = newY + newHeight / 2 - (y + height / 2);
        var _iterator3 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var _step3$value = _step3.value,
              line = _step3$value.line,
              points = _step3$value.points;
            Outline._translate(line, _tx, _ty, line);
            Outline._translate(points, _tx, _ty, points);
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
        return {
          root: {
            viewBox: this.viewBox
          },
          path: {
            "transform-origin": "".concat(Outline.svgRound(newX), " ").concat(Outline.svgRound(newY)),
            transform: this.rotationTransform || null,
            d: this.toSVGPath()
          }
        };
      }
      var s1x = (newWidth - 2 * marginX) / (width - 2 * marginX);
      var s1y = (newHeight - 2 * marginY) / (height - 2 * marginY);
      var tx = -s1x * (x + marginX) + newX + marginX;
      var ty = -s1y * (y + marginY) + newY + marginY;
      if (s1x !== 1 || s1y !== 1 || tx !== 0 || ty !== 0) {
        var _iterator4 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
          _step4;
        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var _step4$value = _step4.value,
              _line2 = _step4$value.line,
              _points2 = _step4$value.points;
            Outline._rescale(_line2, tx, ty, s1x, s1y, _line2);
            Outline._rescale(_points2, tx, ty, s1x, s1y, _points2);
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      }
      return {
        root: {
          viewBox: this.viewBox
        },
        path: {
          "transform-origin": "".concat(Outline.svgRound(newX), " ").concat(Outline.svgRound(newY)),
          transform: this.rotationTransform || null,
          d: this.toSVGPath()
        }
      };
    }
  }, {
    key: "getPathTranslatedSVGProperties",
    value: function getPathTranslatedSVGProperties(_ref9, parentDimensions) {
      var _ref10 = inkdraw_slicedToArray(_ref9, 2),
        newX = _ref10[0],
        newY = _ref10[1];
      var _parentDimensions = inkdraw_slicedToArray(parentDimensions, 2),
        newParentWidth = _parentDimensions[0],
        newParentHeight = _parentDimensions[1];
      var bbox = inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
      var tx = newX - bbox[0];
      var ty = newY - bbox[1];
      if (inkdraw_classPrivateFieldGet(_parentWidth2, this) === newParentWidth && inkdraw_classPrivateFieldGet(_parentHeight2, this) === newParentHeight) {
        var _iterator5 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
          _step5;
        try {
          for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
            var _step5$value = _step5.value,
              line = _step5$value.line,
              points = _step5$value.points;
            Outline._translate(line, tx, ty, line);
            Outline._translate(points, tx, ty, points);
          }
        } catch (err) {
          _iterator5.e(err);
        } finally {
          _iterator5.f();
        }
      } else {
        var sx = inkdraw_classPrivateFieldGet(_parentWidth2, this) / newParentWidth;
        var sy = inkdraw_classPrivateFieldGet(_parentHeight2, this) / newParentHeight;
        inkdraw_classPrivateFieldSet(_parentWidth2, this, newParentWidth);
        inkdraw_classPrivateFieldSet(_parentHeight2, this, newParentHeight);
        var _iterator6 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
          _step6;
        try {
          for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
            var _step6$value = _step6.value,
              _line3 = _step6$value.line,
              _points3 = _step6$value.points;
            Outline._rescale(_line3, tx, ty, sx, sy, _line3);
            Outline._rescale(_points3, tx, ty, sx, sy, _points3);
          }
        } catch (err) {
          _iterator6.e(err);
        } finally {
          _iterator6.f();
        }
        bbox[2] *= sx;
        bbox[3] *= sy;
      }
      bbox[0] = newX;
      bbox[1] = newY;
      return {
        root: {
          viewBox: this.viewBox
        },
        path: {
          d: this.toSVGPath(),
          "transform-origin": "".concat(Outline.svgRound(newX), " ").concat(Outline.svgRound(newY))
        }
      };
    }
  }, {
    key: "defaultSVGProperties",
    get: function get() {
      var bbox = inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
      return {
        root: {
          viewBox: this.viewBox
        },
        rootClass: {
          draw: true
        },
        path: {
          d: this.toSVGPath(),
          "transform-origin": "".concat(Outline.svgRound(bbox[0]), " ").concat(Outline.svgRound(bbox[1])),
          transform: this.rotationTransform || null
        },
        bbox: bbox
      };
    }
  }], [{
    key: "deserialize",
    value: function deserialize(pageX, pageY, pageWidth, pageHeight, innerMargin, _ref11) {
      var _ref11$paths = _ref11.paths,
        lines = _ref11$paths.lines,
        points = _ref11$paths.points,
        rotation = _ref11.rotation,
        thickness = _ref11.thickness;
      var newLines = [];
      var tx, ty, sx, sy, rescaleFn;
      switch (rotation) {
        case 0:
          rescaleFn = Outline._rescale;
          tx = -pageX / pageWidth;
          ty = pageY / pageHeight + 1;
          sx = 1 / pageWidth;
          sy = -1 / pageHeight;
          break;
        case 90:
          rescaleFn = Outline._rescaleAndSwap;
          tx = -pageY / pageHeight;
          ty = -pageX / pageWidth;
          sx = 1 / pageHeight;
          sy = 1 / pageWidth;
          break;
        case 180:
          rescaleFn = Outline._rescale;
          tx = pageX / pageWidth + 1;
          ty = -pageY / pageHeight;
          sx = -1 / pageWidth;
          sy = 1 / pageHeight;
          break;
        case 270:
          rescaleFn = Outline._rescaleAndSwap;
          tx = pageY / pageHeight + 1;
          ty = pageX / pageWidth + 1;
          sx = -1 / pageHeight;
          sy = -1 / pageWidth;
          break;
      }
      if (!lines) {
        lines = [];
        var _iterator7 = inkdraw_createForOfIteratorHelper(points),
          _step7;
        try {
          for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
            var point = _step7.value;
            var len = point.length;
            if (len === 2) {
              lines.push(new Float32Array([NaN, NaN, NaN, NaN, point[0], point[1]]));
              continue;
            }
            if (len === 4) {
              lines.push(new Float32Array([NaN, NaN, NaN, NaN, point[0], point[1], NaN, NaN, NaN, NaN, point[2], point[3]]));
              continue;
            }
            var line = new Float32Array(3 * (len - 2));
            lines.push(line);
            var _point$subarray = point.subarray(0, 4),
              _point$subarray2 = inkdraw_slicedToArray(_point$subarray, 4),
              x1 = _point$subarray2[0],
              y1 = _point$subarray2[1],
              x2 = _point$subarray2[2],
              y2 = _point$subarray2[3];
            line.set([NaN, NaN, NaN, NaN, x1, y1], 0);
            for (var i = 4; i < len; i += 2) {
              var x = point[i];
              var y = point[i + 1];
              line.set(Outline.createBezierPoints(x1, y1, x2, y2, x, y), (i - 2) * 3);
              var _ref12 = [x2, y2, x, y];
              x1 = _ref12[0];
              y1 = _ref12[1];
              x2 = _ref12[2];
              y2 = _ref12[3];
            }
          }
        } catch (err) {
          _iterator7.e(err);
        } finally {
          _iterator7.f();
        }
      }
      for (var _i2 = 0, ii = lines.length; _i2 < ii; _i2++) {
        newLines.push({
          line: rescaleFn(lines[_i2].map(function (x) {
            return x !== null && x !== void 0 ? x : NaN;
          }), tx, ty, sx, sy),
          points: rescaleFn(points[_i2].map(function (x) {
            return x !== null && x !== void 0 ? x : NaN;
          }), tx, ty, sx, sy)
        });
      }
      var outlines = new InkDrawOutline();
      outlines.build(newLines, pageWidth, pageHeight, 1, rotation, thickness, innerMargin);
      return outlines;
    }
  }]);
}(Outline);
function _getMarginComponents() {
  var thickness = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : inkdraw_classPrivateFieldGet(_thickness2, this);
  var margin = inkdraw_classPrivateFieldGet(inkdraw_innerMargin, this) + thickness / 2 * inkdraw_classPrivateFieldGet(_parentScale, this);
  return inkdraw_classPrivateFieldGet(_rotation2, this) % 180 === 0 ? [margin / inkdraw_classPrivateFieldGet(_parentWidth2, this), margin / inkdraw_classPrivateFieldGet(_parentHeight2, this)] : [margin / inkdraw_classPrivateFieldGet(_parentHeight2, this), margin / inkdraw_classPrivateFieldGet(_parentWidth2, this)];
}
function _getBBoxWithNoMargin() {
  var _classPrivateFieldGet14 = inkdraw_classPrivateFieldGet(inkdraw_bbox, this),
    _classPrivateFieldGet15 = inkdraw_slicedToArray(_classPrivateFieldGet14, 4),
    x = _classPrivateFieldGet15[0],
    y = _classPrivateFieldGet15[1],
    width = _classPrivateFieldGet15[2],
    height = _classPrivateFieldGet15[3];
  var _assertClassBrand$cal17 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this, 0),
    _assertClassBrand$cal18 = inkdraw_slicedToArray(_assertClassBrand$cal17, 2),
    marginX = _assertClassBrand$cal18[0],
    marginY = _assertClassBrand$cal18[1];
  return [x + marginX, y + marginY, width - 2 * marginX, height - 2 * marginY];
}
function _computeBbox() {
  var bbox = inkdraw_classPrivateFieldSet(inkdraw_bbox, this, new Float32Array([Infinity, Infinity, -Infinity, -Infinity]));
  var _iterator8 = inkdraw_createForOfIteratorHelper(inkdraw_classPrivateFieldGet(_lines2, this)),
    _step8;
  try {
    for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
      var line = _step8.value.line;
      if (line.length <= 12) {
        for (var i = 4, ii = line.length; i < ii; i += 6) {
          var _line$subarray = line.subarray(i, i + 2),
            _line$subarray2 = inkdraw_slicedToArray(_line$subarray, 2),
            x = _line$subarray2[0],
            y = _line$subarray2[1];
          bbox[0] = Math.min(bbox[0], x);
          bbox[1] = Math.min(bbox[1], y);
          bbox[2] = Math.max(bbox[2], x);
          bbox[3] = Math.max(bbox[3], y);
        }
        continue;
      }
      var lastX = line[4],
        lastY = line[5];
      for (var _i3 = 6, _ii = line.length; _i3 < _ii; _i3 += 6) {
        var _line$subarray3 = line.subarray(_i3, _i3 + 6),
          _line$subarray4 = inkdraw_slicedToArray(_line$subarray3, 6),
          c1x = _line$subarray4[0],
          c1y = _line$subarray4[1],
          c2x = _line$subarray4[2],
          c2y = _line$subarray4[3],
          _x2 = _line$subarray4[4],
          _y2 = _line$subarray4[5];
        Util.bezierBoundingBox(lastX, lastY, c1x, c1y, c2x, c2y, _x2, _y2, bbox);
        lastX = _x2;
        lastY = _y2;
      }
    }
  } catch (err) {
    _iterator8.e(err);
  } finally {
    _iterator8.f();
  }
  var _assertClassBrand$cal19 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
    _assertClassBrand$cal20 = inkdraw_slicedToArray(_assertClassBrand$cal19, 2),
    marginX = _assertClassBrand$cal20[0],
    marginY = _assertClassBrand$cal20[1];
  bbox[0] = Math.min(1, Math.max(0, bbox[0] - marginX));
  bbox[1] = Math.min(1, Math.max(0, bbox[1] - marginY));
  bbox[2] = Math.min(1, Math.max(0, bbox[2] + marginX));
  bbox[3] = Math.min(1, Math.max(0, bbox[3] + marginY));
  bbox[2] -= bbox[0];
  bbox[3] -= bbox[1];
}
function inkdraw_updateThickness(thickness) {
  var _assertClassBrand$cal21 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
    _assertClassBrand$cal22 = inkdraw_slicedToArray(_assertClassBrand$cal21, 2),
    oldMarginX = _assertClassBrand$cal22[0],
    oldMarginY = _assertClassBrand$cal22[1];
  inkdraw_classPrivateFieldSet(_thickness2, this, thickness);
  var _assertClassBrand$cal23 = inkdraw_assertClassBrand(_InkDrawOutline_brand, this, _getMarginComponents).call(this),
    _assertClassBrand$cal24 = inkdraw_slicedToArray(_assertClassBrand$cal23, 2),
    newMarginX = _assertClassBrand$cal24[0],
    newMarginY = _assertClassBrand$cal24[1];
  var diffMarginX = newMarginX - oldMarginX,
    diffMarginY = newMarginY - oldMarginY;
  var bbox = inkdraw_classPrivateFieldGet(inkdraw_bbox, this);
  bbox[0] -= diffMarginX;
  bbox[1] -= diffMarginY;
  bbox[2] += 2 * diffMarginX;
  bbox[3] += 2 * diffMarginY;
  return bbox;
}

;// ./src/display/editor/ink.js
function ink_typeof(o) { "@babel/helpers - typeof"; return ink_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, ink_typeof(o); }
function ink_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ ink_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == ink_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(ink_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function ink_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function ink_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { ink_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { ink_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }











































function ink_toConsumableArray(r) { return ink_arrayWithoutHoles(r) || ink_iterableToArray(r) || ink_unsupportedIterableToArray(r) || ink_nonIterableSpread(); }
function ink_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function ink_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return ink_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? ink_arrayLikeToArray(r, a) : void 0; } }
function ink_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function ink_arrayWithoutHoles(r) { if (Array.isArray(r)) return ink_arrayLikeToArray(r); }
function ink_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function ink_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function ink_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ink_ownKeys(Object(t), !0).forEach(function (r) { ink_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ink_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function ink_classPrivateMethodInitSpec(e, a) { ink_checkPrivateRedeclaration(e, a), a.add(e); }
function ink_defineProperty(e, r, t) { return (r = ink_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function ink_readOnlyError(r) { throw new TypeError('"' + r + '" is read-only'); }
function ink_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function ink_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, ink_toPropertyKey(o.key), o); } }
function ink_createClass(e, r, t) { return r && ink_defineProperties(e.prototype, r), t && ink_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function ink_toPropertyKey(t) { var i = ink_toPrimitive(t, "string"); return "symbol" == ink_typeof(i) ? i : i + ""; }
function ink_toPrimitive(t, r) { if ("object" != ink_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != ink_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function ink_callSuper(t, o, e) { return o = ink_getPrototypeOf(o), ink_possibleConstructorReturn(t, ink_isNativeReflectConstruct() ? Reflect.construct(o, e || [], ink_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function ink_possibleConstructorReturn(t, e) { if (e && ("object" == ink_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return ink_assertThisInitialized(t); }
function ink_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function ink_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (ink_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function ink_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && ink_setPrototypeOf(t, e); }
function ink_setPrototypeOf(t, e) { return ink_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, ink_setPrototypeOf(t, e); }
function ink_superPropGet(t, o, e, r) { var p = ink_get(ink_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function ink_get() { return ink_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = ink_superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, ink_get.apply(null, arguments); }
function ink_superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = ink_getPrototypeOf(t));); return t; }
function ink_getPrototypeOf(t) { return ink_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, ink_getPrototypeOf(t); }
function ink_classPrivateFieldInitSpec(e, t, a) { ink_checkPrivateRedeclaration(e, t), t.set(e, a); }
function ink_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function ink_classPrivateFieldGet(s, a) { return s.get(ink_assertClassBrand(s, a)); }
function ink_classPrivateFieldSet(s, a, r) { return s.set(ink_assertClassBrand(s, a), r), r; }
function ink_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }





var _viewParameters = /*#__PURE__*/new WeakMap();
var InkDrawingOptions = /*#__PURE__*/function (_DrawingOptions) {
  function InkDrawingOptions(viewerParameters) {
    var _this;
    ink_classCallCheck(this, InkDrawingOptions);
    _this = ink_callSuper(this, InkDrawingOptions);
    ink_classPrivateFieldInitSpec(_this, _viewParameters, void 0);
    ink_classPrivateFieldSet(_viewParameters, _this, viewerParameters);
    ink_superPropGet((_this, InkDrawingOptions), "updateProperties", _this, 3)([{
      fill: "none",
      stroke: AnnotationEditor._defaultLineColor,
      "stroke-opacity": 1,
      "stroke-width": 1,
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      "stroke-miterlimit": 10
    }]);
    return _this;
  }
  ink_inherits(InkDrawingOptions, _DrawingOptions);
  return ink_createClass(InkDrawingOptions, [{
    key: "updateSVGProperty",
    value: function updateSVGProperty(name, value) {
      if (name === "stroke-width") {
        var _value;
        (_value = value) !== null && _value !== void 0 ? _value : value = this["stroke-width"];
        value *= ink_classPrivateFieldGet(_viewParameters, this).realScale;
      }
      ink_superPropGet(InkDrawingOptions, "updateSVGProperty", this, 3)([name, value]);
    }
  }, {
    key: "clone",
    value: function clone() {
      var clone = new InkDrawingOptions(ink_classPrivateFieldGet(_viewParameters, this));
      clone.updateAll(this);
      return clone;
    }
  }]);
}(DrawingOptions);
var _InkEditor_brand = /*#__PURE__*/new WeakSet();
var InkEditor = /*#__PURE__*/function (_DrawingEditor) {
  function InkEditor(params) {
    var _this2;
    ink_classCallCheck(this, InkEditor);
    _this2 = ink_callSuper(this, InkEditor, [ink_objectSpread(ink_objectSpread({}, params), {}, {
      name: "inkEditor"
    })]);
    ink_classPrivateMethodInitSpec(_this2, _InkEditor_brand);
    _this2._willKeepAspectRatio = true;
    return _this2;
  }
  ink_inherits(InkEditor, _DrawingEditor);
  return ink_createClass(InkEditor, [{
    key: "onScaleChanging",
    value: function onScaleChanging() {
      if (!this.parent) {
        return;
      }
      ink_superPropGet(InkEditor, "onScaleChanging", this, 3)([]);
      var _drawId = this._drawId,
        _drawingOptions = this._drawingOptions,
        parent = this.parent;
      _drawingOptions.updateSVGProperty("stroke-width");
      parent.drawLayer.updateProperties(_drawId, _drawingOptions.toSVGProperties());
    }
  }, {
    key: "createDrawingOptions",
    value: function createDrawingOptions(_ref) {
      var color = _ref.color,
        thickness = _ref.thickness,
        opacity = _ref.opacity;
      this._drawingOptions = InkEditor.getDefaultDrawingOptions({
        stroke: Util.makeHexColor.apply(Util, ink_toConsumableArray(color)),
        "stroke-width": thickness,
        "stroke-opacity": opacity
      });
    }
  }, {
    key: "serialize",
    value: function serialize() {
      var isForCopying = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (this.isEmpty()) {
        return null;
      }
      if (this.deleted) {
        return this.serializeDeleted();
      }
      var _this$serializeDraw = this.serializeDraw(isForCopying),
        lines = _this$serializeDraw.lines,
        points = _this$serializeDraw.points,
        rect = _this$serializeDraw.rect;
      var _this$_drawingOptions = this._drawingOptions,
        stroke = _this$_drawingOptions.stroke,
        opacity = _this$_drawingOptions["stroke-opacity"],
        thickness = _this$_drawingOptions["stroke-width"];
      var serialized = {
        annotationType: AnnotationEditorType.INK,
        color: AnnotationEditor._colorManager.convert(stroke),
        opacity: opacity,
        thickness: thickness,
        paths: {
          lines: lines,
          points: points
        },
        pageIndex: this.pageIndex,
        rect: rect,
        rotation: this.rotation,
        structTreeParentId: this._structTreeParentId
      };
      if (isForCopying) {
        return serialized;
      }
      if (this.annotationElementId && !ink_assertClassBrand(_InkEditor_brand, this, ink_hasElementChanged).call(this, serialized)) {
        return null;
      }
      serialized.id = this.annotationElementId;
      return serialized;
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      var _this$serializeDraw2 = this.serializeDraw(false),
        points = _this$serializeDraw2.points,
        rect = _this$serializeDraw2.rect;
      annotation.updateEdited({
        rect: rect,
        thickness: this._drawingOptions["stroke-width"],
        points: points
      });
      return null;
    }
  }], [{
    key: "initialize",
    value: function initialize(l10n, uiManager) {
      AnnotationEditor.initialize(l10n, uiManager);
      this._defaultDrawingOptions = new InkDrawingOptions(uiManager.viewParameters);
    }
  }, {
    key: "getDefaultDrawingOptions",
    value: function getDefaultDrawingOptions(options) {
      var clone = this._defaultDrawingOptions.clone();
      clone.updateProperties(options);
      return clone;
    }
  }, {
    key: "supportMultipleDrawings",
    get: function get() {
      return true;
    }
  }, {
    key: "typesMap",
    get: function get() {
      return shadow(this, "typesMap", new Map([[AnnotationEditorParamsType.INK_THICKNESS, "stroke-width"], [AnnotationEditorParamsType.INK_COLOR, "stroke"], [AnnotationEditorParamsType.INK_OPACITY, "stroke-opacity"]]));
    }
  }, {
    key: "createDrawerInstance",
    value: function createDrawerInstance(x, y, parentWidth, parentHeight, rotation) {
      return new InkDrawOutliner(x, y, parentWidth, parentHeight, rotation, this._defaultDrawingOptions["stroke-width"]);
    }
  }, {
    key: "deserializeDraw",
    value: function deserializeDraw(pageX, pageY, pageWidth, pageHeight, innerMargin, data) {
      return InkDrawOutline.deserialize(pageX, pageY, pageWidth, pageHeight, innerMargin, data);
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = ink_asyncToGenerator(/*#__PURE__*/ink_regeneratorRuntime().mark(function _callee(data, parent, uiManager) {
        var initialData, _data, _data$data, inkLists, rect, rotation, id, color, opacity, thickness, popupRef, pageNumber, editor;
        return ink_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              initialData = null;
              if (data instanceof InkAnnotationElement) {
                _data = data, _data$data = _data.data, inkLists = _data$data.inkLists, rect = _data$data.rect, rotation = _data$data.rotation, id = _data$data.id, color = _data$data.color, opacity = _data$data.opacity, thickness = _data$data.borderStyle.rawWidth, popupRef = _data$data.popupRef, pageNumber = _data.parent.page.pageNumber;
                initialData = data = {
                  annotationType: AnnotationEditorType.INK,
                  color: Array.from(color),
                  thickness: thickness,
                  opacity: opacity,
                  paths: {
                    points: inkLists
                  },
                  boxes: null,
                  pageIndex: pageNumber - 1,
                  rect: rect.slice(0),
                  rotation: rotation,
                  id: id,
                  deleted: false,
                  popupRef: popupRef
                };
              }
              _context.next = 4;
              return ink_superPropGet(InkEditor, "deserialize", this, 2)([data, parent, uiManager]);
            case 4:
              editor = _context.sent;
              editor.annotationElementId = data.id || null;
              editor._initialData = initialData;
              return _context.abrupt("return", editor);
            case 8:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function deserialize(_x, _x2, _x3) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }, {
    key: "onScaleChangingWhenDrawing",
    value: function onScaleChangingWhenDrawing() {
      var parent = this._currentParent;
      if (!parent) {
        return;
      }
      ink_superPropGet(InkEditor, "onScaleChangingWhenDrawing", this, 2)([]);
      this._defaultDrawingOptions.updateSVGProperty("stroke-width");
      parent.drawLayer.updateProperties(this._currentDrawId, this._defaultDrawingOptions.toSVGProperties());
    }
  }]);
}(DrawingEditor);
function ink_hasElementChanged(serialized) {
  var _this$_initialData = this._initialData,
    color = _this$_initialData.color,
    thickness = _this$_initialData.thickness,
    opacity = _this$_initialData.opacity,
    pageIndex = _this$_initialData.pageIndex;
  return this._hasBeenMoved || this._hasBeenResized || serialized.color.some(function (c, i) {
    return c !== color[i];
  }) || serialized.thickness !== thickness || serialized.opacity !== opacity || serialized.pageIndex !== pageIndex;
}
ink_defineProperty(InkEditor, "_type", "ink");
ink_defineProperty(InkEditor, "_editorType", AnnotationEditorType.INK);
ink_defineProperty(InkEditor, "_defaultDrawingOptions", null);

;// ./src/display/editor/stamp.js


























function stamp_typeof(o) { "@babel/helpers - typeof"; return stamp_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, stamp_typeof(o); }
var _StampEditor;
function stamp_slicedToArray(r, e) { return stamp_arrayWithHoles(r) || stamp_iterableToArrayLimit(r, e) || stamp_unsupportedIterableToArray(r, e) || stamp_nonIterableRest(); }
function stamp_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function stamp_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return stamp_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? stamp_arrayLikeToArray(r, a) : void 0; } }
function stamp_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function stamp_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function stamp_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function stamp_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ stamp_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == stamp_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(stamp_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }

























function stamp_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function stamp_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { stamp_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { stamp_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function stamp_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function stamp_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? stamp_ownKeys(Object(t), !0).forEach(function (r) { stamp_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : stamp_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function stamp_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function stamp_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, stamp_toPropertyKey(o.key), o); } }
function stamp_createClass(e, r, t) { return r && stamp_defineProperties(e.prototype, r), t && stamp_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function stamp_callSuper(t, o, e) { return o = stamp_getPrototypeOf(o), stamp_possibleConstructorReturn(t, stamp_isNativeReflectConstruct() ? Reflect.construct(o, e || [], stamp_getPrototypeOf(t).constructor) : o.apply(t, e)); }
function stamp_possibleConstructorReturn(t, e) { if (e && ("object" == stamp_typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return stamp_assertThisInitialized(t); }
function stamp_assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function stamp_isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (stamp_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function stamp_superPropGet(t, o, e, r) { var p = stamp_get(stamp_getPrototypeOf(1 & r ? t.prototype : t), o, e); return 2 & r && "function" == typeof p ? function (t) { return p.apply(e, t); } : p; }
function stamp_get() { return stamp_get = "undefined" != typeof Reflect && Reflect.get ? Reflect.get.bind() : function (e, t, r) { var p = stamp_superPropBase(e, t); if (p) { var n = Object.getOwnPropertyDescriptor(p, t); return n.get ? n.get.call(arguments.length < 3 ? e : r) : n.value; } }, stamp_get.apply(null, arguments); }
function stamp_superPropBase(t, o) { for (; !{}.hasOwnProperty.call(t, o) && null !== (t = stamp_getPrototypeOf(t));); return t; }
function stamp_getPrototypeOf(t) { return stamp_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, stamp_getPrototypeOf(t); }
function stamp_inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && stamp_setPrototypeOf(t, e); }
function stamp_setPrototypeOf(t, e) { return stamp_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, stamp_setPrototypeOf(t, e); }
function stamp_classPrivateMethodInitSpec(e, a) { stamp_checkPrivateRedeclaration(e, a), a.add(e); }
function stamp_defineProperty(e, r, t) { return (r = stamp_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function stamp_toPropertyKey(t) { var i = stamp_toPrimitive(t, "string"); return "symbol" == stamp_typeof(i) ? i : i + ""; }
function stamp_toPrimitive(t, r) { if ("object" != stamp_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != stamp_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function stamp_classPrivateFieldInitSpec(e, t, a) { stamp_checkPrivateRedeclaration(e, t), t.set(e, a); }
function stamp_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function stamp_classPrivateFieldGet(s, a) { return s.get(stamp_assertClassBrand(s, a)); }
function stamp_classPrivateFieldSet(s, a, r) { return s.set(stamp_assertClassBrand(s, a), r), r; }
function stamp_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }




var _bitmap = /*#__PURE__*/new WeakMap();
var _bitmapId = /*#__PURE__*/new WeakMap();
var _bitmapPromise = /*#__PURE__*/new WeakMap();
var _bitmapUrl = /*#__PURE__*/new WeakMap();
var _bitmapFile = /*#__PURE__*/new WeakMap();
var _bitmapFileName = /*#__PURE__*/new WeakMap();
var stamp_canvas = /*#__PURE__*/new WeakMap();
var _resizeTimeoutId = /*#__PURE__*/new WeakMap();
var _isSvg = /*#__PURE__*/new WeakMap();
var _hasBeenAddedInUndoStack = /*#__PURE__*/new WeakMap();
var _StampEditor_brand = /*#__PURE__*/new WeakSet();
var StampEditor = /*#__PURE__*/function (_AnnotationEditor) {
  function StampEditor(params) {
    var _this;
    stamp_classCallCheck(this, StampEditor);
    _this = stamp_callSuper(this, StampEditor, [stamp_objectSpread(stamp_objectSpread({}, params), {}, {
      name: "stampEditor"
    })]);
    stamp_classPrivateMethodInitSpec(_this, _StampEditor_brand);
    stamp_classPrivateFieldInitSpec(_this, _bitmap, null);
    stamp_classPrivateFieldInitSpec(_this, _bitmapId, null);
    stamp_classPrivateFieldInitSpec(_this, _bitmapPromise, null);
    stamp_classPrivateFieldInitSpec(_this, _bitmapUrl, null);
    stamp_classPrivateFieldInitSpec(_this, _bitmapFile, null);
    stamp_classPrivateFieldInitSpec(_this, _bitmapFileName, "");
    stamp_classPrivateFieldInitSpec(_this, stamp_canvas, null);
    stamp_classPrivateFieldInitSpec(_this, _resizeTimeoutId, null);
    stamp_classPrivateFieldInitSpec(_this, _isSvg, false);
    stamp_classPrivateFieldInitSpec(_this, _hasBeenAddedInUndoStack, false);
    stamp_classPrivateFieldSet(_bitmapUrl, _this, params.bitmapUrl);
    stamp_classPrivateFieldSet(_bitmapFile, _this, params.bitmapFile);
    return _this;
  }
  stamp_inherits(StampEditor, _AnnotationEditor);
  return stamp_createClass(StampEditor, [{
    key: "altTextFinish",
    value: function altTextFinish() {
      if (this._uiManager.useNewAltTextFlow) {
        this.div.hidden = false;
      }
      stamp_superPropGet(StampEditor, "altTextFinish", this, 3)([]);
    }
  }, {
    key: "telemetryFinalData",
    get: function get() {
      var _this$altTextData;
      return {
        type: "stamp",
        hasAltText: !!((_this$altTextData = this.altTextData) !== null && _this$altTextData !== void 0 && _this$altTextData.altText)
      };
    }
  }, {
    key: "mlGuessAltText",
    value: function () {
      var _mlGuessAltText = stamp_asyncToGenerator(/*#__PURE__*/stamp_regeneratorRuntime().mark(function _callee() {
        var imageData,
          updateAltTextData,
          mlManager,
          _ref,
          data,
          width,
          height,
          response,
          altText,
          _args = arguments;
        return stamp_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              imageData = _args.length > 0 && _args[0] !== undefined ? _args[0] : null;
              updateAltTextData = _args.length > 1 && _args[1] !== undefined ? _args[1] : true;
              if (!this.hasAltTextData()) {
                _context.next = 4;
                break;
              }
              return _context.abrupt("return", null);
            case 4:
              mlManager = this._uiManager.mlManager;
              if (mlManager) {
                _context.next = 7;
                break;
              }
              throw new Error("No ML.");
            case 7:
              _context.next = 9;
              return mlManager.isEnabledFor("altText");
            case 9:
              if (_context.sent) {
                _context.next = 11;
                break;
              }
              throw new Error("ML isn't enabled for alt text.");
            case 11:
              _ref = imageData || this.copyCanvas(null, null, true).imageData, data = _ref.data, width = _ref.width, height = _ref.height;
              _context.next = 14;
              return mlManager.guess({
                name: "altText",
                request: {
                  data: data,
                  width: width,
                  height: height,
                  channels: data.length / (width * height)
                }
              });
            case 14:
              response = _context.sent;
              if (response) {
                _context.next = 17;
                break;
              }
              throw new Error("No response from the AI service.");
            case 17:
              if (!response.error) {
                _context.next = 19;
                break;
              }
              throw new Error("Error from the AI service.");
            case 19:
              if (!response.cancel) {
                _context.next = 21;
                break;
              }
              return _context.abrupt("return", null);
            case 21:
              if (response.output) {
                _context.next = 23;
                break;
              }
              throw new Error("No valid response from the AI service.");
            case 23:
              altText = response.output;
              _context.next = 26;
              return this.setGuessedAltText(altText);
            case 26:
              if (updateAltTextData && !this.hasAltTextData()) {
                this.altTextData = {
                  alt: altText,
                  decorative: false
                };
              }
              return _context.abrupt("return", altText);
            case 28:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function mlGuessAltText() {
        return _mlGuessAltText.apply(this, arguments);
      }
      return mlGuessAltText;
    }()
  }, {
    key: "remove",
    value: function remove() {
      if (stamp_classPrivateFieldGet(_bitmapId, this)) {
        var _classPrivateFieldGet2;
        stamp_classPrivateFieldSet(_bitmap, this, null);
        this._uiManager.imageManager.deleteId(stamp_classPrivateFieldGet(_bitmapId, this));
        (_classPrivateFieldGet2 = stamp_classPrivateFieldGet(stamp_canvas, this)) === null || _classPrivateFieldGet2 === void 0 || _classPrivateFieldGet2.remove();
        stamp_classPrivateFieldSet(stamp_canvas, this, null);
        if (stamp_classPrivateFieldGet(_resizeTimeoutId, this)) {
          clearTimeout(stamp_classPrivateFieldGet(_resizeTimeoutId, this));
          stamp_classPrivateFieldSet(_resizeTimeoutId, this, null);
        }
      }
      stamp_superPropGet(StampEditor, "remove", this, 3)([]);
    }
  }, {
    key: "rebuild",
    value: function rebuild() {
      if (!this.parent) {
        if (stamp_classPrivateFieldGet(_bitmapId, this)) {
          stamp_assertClassBrand(_StampEditor_brand, this, _getBitmap).call(this);
        }
        return;
      }
      stamp_superPropGet(StampEditor, "rebuild", this, 3)([]);
      if (this.div === null) {
        return;
      }
      if (stamp_classPrivateFieldGet(_bitmapId, this) && stamp_classPrivateFieldGet(stamp_canvas, this) === null) {
        stamp_assertClassBrand(_StampEditor_brand, this, _getBitmap).call(this);
      }
      if (!this.isAttachedToDOM) {
        this.parent.add(this);
      }
    }
  }, {
    key: "onceAdded",
    value: function onceAdded(focus) {
      this._isDraggable = true;
      if (focus) {
        this.div.focus();
      }
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return !(stamp_classPrivateFieldGet(_bitmapPromise, this) || stamp_classPrivateFieldGet(_bitmap, this) || stamp_classPrivateFieldGet(_bitmapUrl, this) || stamp_classPrivateFieldGet(_bitmapFile, this) || stamp_classPrivateFieldGet(_bitmapId, this));
    }
  }, {
    key: "isResizable",
    get: function get() {
      return true;
    }
  }, {
    key: "render",
    value: function render() {
      if (this.div) {
        return this.div;
      }
      var baseX, baseY;
      if (this.width) {
        baseX = this.x;
        baseY = this.y;
      }
      stamp_superPropGet(StampEditor, "render", this, 3)([]);
      this.div.hidden = true;
      this.div.setAttribute("role", "figure");
      this.addAltTextButton();
      if (stamp_classPrivateFieldGet(_bitmap, this)) {
        stamp_assertClassBrand(_StampEditor_brand, this, _createCanvas).call(this);
      } else {
        stamp_assertClassBrand(_StampEditor_brand, this, _getBitmap).call(this);
      }
      if (this.width && !this.annotationElementId) {
        var _this$parentDimension = stamp_slicedToArray(this.parentDimensions, 2),
          parentWidth = _this$parentDimension[0],
          parentHeight = _this$parentDimension[1];
        this.setAt(baseX * parentWidth, baseY * parentHeight, this.width * parentWidth, this.height * parentHeight);
      }
      this._uiManager.addShouldRescale(this);
      return this.div;
    }
  }, {
    key: "_onResized",
    value: function _onResized() {
      this.onScaleChanging();
    }
  }, {
    key: "onScaleChanging",
    value: function onScaleChanging() {
      var _this2 = this;
      if (!this.parent) {
        return;
      }
      if (stamp_classPrivateFieldGet(_resizeTimeoutId, this) !== null) {
        clearTimeout(stamp_classPrivateFieldGet(_resizeTimeoutId, this));
      }
      var TIME_TO_WAIT = 200;
      stamp_classPrivateFieldSet(_resizeTimeoutId, this, setTimeout(function () {
        stamp_classPrivateFieldSet(_resizeTimeoutId, _this2, null);
        stamp_assertClassBrand(_StampEditor_brand, _this2, _drawBitmap).call(_this2);
      }, TIME_TO_WAIT));
    }
  }, {
    key: "copyCanvas",
    value: function copyCanvas(maxDataDimension, maxPreviewDimension) {
      var createImageData = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      if (!maxDataDimension) {
        maxDataDimension = 224;
      }
      var _classPrivateFieldGet3 = stamp_classPrivateFieldGet(_bitmap, this),
        bitmapWidth = _classPrivateFieldGet3.width,
        bitmapHeight = _classPrivateFieldGet3.height;
      var outputScale = new OutputScale();
      var bitmap = stamp_classPrivateFieldGet(_bitmap, this);
      var width = bitmapWidth,
        height = bitmapHeight;
      var canvas = null;
      if (maxPreviewDimension) {
        var _window$matchMedia, _window;
        if (bitmapWidth > maxPreviewDimension || bitmapHeight > maxPreviewDimension) {
          var ratio = Math.min(maxPreviewDimension / bitmapWidth, maxPreviewDimension / bitmapHeight);
          width = Math.floor(bitmapWidth * ratio);
          height = Math.floor(bitmapHeight * ratio);
        }
        canvas = document.createElement("canvas");
        var scaledWidth = canvas.width = Math.ceil(width * outputScale.sx);
        var scaledHeight = canvas.height = Math.ceil(height * outputScale.sy);
        if (!stamp_classPrivateFieldGet(_isSvg, this)) {
          bitmap = stamp_assertClassBrand(_StampEditor_brand, this, _scaleBitmap).call(this, scaledWidth, scaledHeight);
        }
        var ctx = canvas.getContext("2d");
        ctx.filter = this._uiManager.hcmFilter;
        var white = "white",
          black = "#cfcfd8";
        if (this._uiManager.hcmFilter !== "none") {
          black = "black";
        } else if ((_window$matchMedia = (_window = window).matchMedia) !== null && _window$matchMedia !== void 0 && _window$matchMedia.call(_window, "(prefers-color-scheme: dark)").matches) {
          white = "#8f8f9d";
          black = "#42414d";
        }
        var boxDim = 15;
        var boxDimWidth = boxDim * outputScale.sx;
        var boxDimHeight = boxDim * outputScale.sy;
        var pattern = new OffscreenCanvas(boxDimWidth * 2, boxDimHeight * 2);
        var patternCtx = pattern.getContext("2d");
        patternCtx.fillStyle = white;
        patternCtx.fillRect(0, 0, boxDimWidth * 2, boxDimHeight * 2);
        patternCtx.fillStyle = black;
        patternCtx.fillRect(0, 0, boxDimWidth, boxDimHeight);
        patternCtx.fillRect(boxDimWidth, boxDimHeight, boxDimWidth, boxDimHeight);
        ctx.fillStyle = ctx.createPattern(pattern, "repeat");
        ctx.fillRect(0, 0, scaledWidth, scaledHeight);
        ctx.drawImage(bitmap, 0, 0, bitmap.width, bitmap.height, 0, 0, scaledWidth, scaledHeight);
      }
      var imageData = null;
      if (createImageData) {
        var dataWidth, dataHeight;
        if (outputScale.symmetric && bitmap.width < maxDataDimension && bitmap.height < maxDataDimension) {
          dataWidth = bitmap.width;
          dataHeight = bitmap.height;
        } else {
          bitmap = stamp_classPrivateFieldGet(_bitmap, this);
          if (bitmapWidth > maxDataDimension || bitmapHeight > maxDataDimension) {
            var _ratio = Math.min(maxDataDimension / bitmapWidth, maxDataDimension / bitmapHeight);
            dataWidth = Math.floor(bitmapWidth * _ratio);
            dataHeight = Math.floor(bitmapHeight * _ratio);
            if (!stamp_classPrivateFieldGet(_isSvg, this)) {
              bitmap = stamp_assertClassBrand(_StampEditor_brand, this, _scaleBitmap).call(this, dataWidth, dataHeight);
            }
          }
        }
        var offscreen = new OffscreenCanvas(dataWidth, dataHeight);
        var offscreenCtx = offscreen.getContext("2d", {
          willReadFrequently: true
        });
        offscreenCtx.drawImage(bitmap, 0, 0, bitmap.width, bitmap.height, 0, 0, dataWidth, dataHeight);
        imageData = {
          width: dataWidth,
          height: dataHeight,
          data: offscreenCtx.getImageData(0, 0, dataWidth, dataHeight).data
        };
      }
      return {
        canvas: canvas,
        width: width,
        height: height,
        imageData: imageData
      };
    }
  }, {
    key: "getImageForAltText",
    value: function getImageForAltText() {
      return stamp_classPrivateFieldGet(stamp_canvas, this);
    }
  }, {
    key: "serialize",
    value: function serialize() {
      var isForCopying = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (this.isEmpty()) {
        return null;
      }
      if (this.deleted) {
        return this.serializeDeleted();
      }
      var serialized = {
        annotationType: AnnotationEditorType.STAMP,
        bitmapId: stamp_classPrivateFieldGet(_bitmapId, this),
        pageIndex: this.pageIndex,
        rect: this.getRect(0, 0),
        rotation: this.rotation,
        isSvg: stamp_classPrivateFieldGet(_isSvg, this),
        structTreeParentId: this._structTreeParentId
      };
      if (isForCopying) {
        serialized.bitmapUrl = stamp_assertClassBrand(_StampEditor_brand, this, _serializeBitmap).call(this, true);
        serialized.accessibilityData = this.serializeAltText(true);
        return serialized;
      }
      var _this$serializeAltTex = this.serializeAltText(false),
        decorative = _this$serializeAltTex.decorative,
        altText = _this$serializeAltTex.altText;
      if (!decorative && altText) {
        serialized.accessibilityData = {
          type: "Figure",
          alt: altText
        };
      }
      if (this.annotationElementId) {
        var changes = stamp_assertClassBrand(_StampEditor_brand, this, stamp_hasElementChanged).call(this, serialized);
        if (changes.isSame) {
          return null;
        }
        if (changes.isSameAltText) {
          delete serialized.accessibilityData;
        } else {
          var _this$_initialData$st;
          serialized.accessibilityData.structParent = (_this$_initialData$st = this._initialData.structParent) !== null && _this$_initialData$st !== void 0 ? _this$_initialData$st : -1;
        }
      }
      serialized.id = this.annotationElementId;
      if (context === null) {
        return serialized;
      }
      context.stamps || (context.stamps = new Map());
      var area = stamp_classPrivateFieldGet(_isSvg, this) ? (serialized.rect[2] - serialized.rect[0]) * (serialized.rect[3] - serialized.rect[1]) : null;
      if (!context.stamps.has(stamp_classPrivateFieldGet(_bitmapId, this))) {
        context.stamps.set(stamp_classPrivateFieldGet(_bitmapId, this), {
          area: area,
          serialized: serialized
        });
        serialized.bitmap = stamp_assertClassBrand(_StampEditor_brand, this, _serializeBitmap).call(this, false);
      } else if (stamp_classPrivateFieldGet(_isSvg, this)) {
        var prevData = context.stamps.get(stamp_classPrivateFieldGet(_bitmapId, this));
        if (area > prevData.area) {
          prevData.area = area;
          prevData.serialized.bitmap.close();
          prevData.serialized.bitmap = stamp_assertClassBrand(_StampEditor_brand, this, _serializeBitmap).call(this, false);
        }
      }
      return serialized;
    }
  }, {
    key: "renderAnnotationElement",
    value: function renderAnnotationElement(annotation) {
      annotation.updateEdited({
        rect: this.getRect(0, 0)
      });
      return null;
    }
  }], [{
    key: "initialize",
    value: function initialize(l10n, uiManager) {
      AnnotationEditor.initialize(l10n, uiManager);
    }
  }, {
    key: "supportedTypes",
    get: function get() {
      var types = ["apng", "avif", "bmp", "gif", "jpeg", "png", "svg+xml", "webp", "x-icon"];
      return shadow(this, "supportedTypes", types.map(function (type) {
        return "image/".concat(type);
      }));
    }
  }, {
    key: "supportedTypesStr",
    get: function get() {
      return shadow(this, "supportedTypesStr", this.supportedTypes.join(","));
    }
  }, {
    key: "isHandlingMimeForPasting",
    value: function isHandlingMimeForPasting(mime) {
      return this.supportedTypes.includes(mime);
    }
  }, {
    key: "paste",
    value: function paste(item, parent) {
      parent.pasteEditor(AnnotationEditorType.STAMP, {
        bitmapFile: item.getAsFile()
      });
    }
  }, {
    key: "computeTelemetryFinalData",
    value: function computeTelemetryFinalData(data) {
      var _hasAltTextStats$get, _hasAltTextStats$get2;
      var hasAltTextStats = data.get("hasAltText");
      return {
        hasAltText: (_hasAltTextStats$get = hasAltTextStats.get(true)) !== null && _hasAltTextStats$get !== void 0 ? _hasAltTextStats$get : 0,
        hasNoAltText: (_hasAltTextStats$get2 = hasAltTextStats.get(false)) !== null && _hasAltTextStats$get2 !== void 0 ? _hasAltTextStats$get2 : 0
      };
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = stamp_asyncToGenerator(/*#__PURE__*/stamp_regeneratorRuntime().mark(function _callee2(data, parent, uiManager) {
        var initialData, _yield$parent$_struct, _data, _data$data, _rect, rotation, id, structParent, popupRef, container, pageNumber, canvas, imageData, altText, editor, _data2, rect, bitmap, bitmapUrl, bitmapId, isSvg, accessibilityData, _editor$pageDimension, parentWidth, parentHeight;
        return stamp_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              initialData = null;
              if (!(data instanceof StampAnnotationElement)) {
                _context2.next = 22;
                break;
              }
              _data = data, _data$data = _data.data, _rect = _data$data.rect, rotation = _data$data.rotation, id = _data$data.id, structParent = _data$data.structParent, popupRef = _data$data.popupRef, container = _data.container, pageNumber = _data.parent.page.pageNumber;
              canvas = container.querySelector("canvas");
              imageData = uiManager.imageManager.getFromCanvas(container.id, canvas);
              canvas.remove();
              _context2.next = 8;
              return parent._structTree.getAriaAttributes("".concat(AnnotationPrefix).concat(id));
            case 8:
              _context2.t2 = _yield$parent$_struct = _context2.sent;
              _context2.t1 = _context2.t2 === null;
              if (_context2.t1) {
                _context2.next = 12;
                break;
              }
              _context2.t1 = _yield$parent$_struct === void 0;
            case 12:
              if (!_context2.t1) {
                _context2.next = 16;
                break;
              }
              _context2.t3 = void 0;
              _context2.next = 17;
              break;
            case 16:
              _context2.t3 = _yield$parent$_struct.get("aria-label");
            case 17:
              _context2.t0 = _context2.t3;
              if (_context2.t0) {
                _context2.next = 20;
                break;
              }
              _context2.t0 = "";
            case 20:
              altText = _context2.t0;
              initialData = data = {
                annotationType: AnnotationEditorType.STAMP,
                bitmapId: imageData.id,
                bitmap: imageData.bitmap,
                pageIndex: pageNumber - 1,
                rect: _rect.slice(0),
                rotation: rotation,
                id: id,
                deleted: false,
                accessibilityData: {
                  decorative: false,
                  altText: altText
                },
                isSvg: false,
                structParent: structParent,
                popupRef: popupRef
              };
            case 22:
              _context2.next = 24;
              return stamp_superPropGet(StampEditor, "deserialize", this, 2)([data, parent, uiManager]);
            case 24:
              editor = _context2.sent;
              _data2 = data, rect = _data2.rect, bitmap = _data2.bitmap, bitmapUrl = _data2.bitmapUrl, bitmapId = _data2.bitmapId, isSvg = _data2.isSvg, accessibilityData = _data2.accessibilityData;
              if (bitmapId && uiManager.imageManager.isValidId(bitmapId)) {
                stamp_classPrivateFieldSet(_bitmapId, editor, bitmapId);
                if (bitmap) {
                  stamp_classPrivateFieldSet(_bitmap, editor, bitmap);
                }
              } else {
                stamp_classPrivateFieldSet(_bitmapUrl, editor, bitmapUrl);
              }
              stamp_classPrivateFieldSet(_isSvg, editor, isSvg);
              _editor$pageDimension = stamp_slicedToArray(editor.pageDimensions, 2), parentWidth = _editor$pageDimension[0], parentHeight = _editor$pageDimension[1];
              editor.width = (rect[2] - rect[0]) / parentWidth;
              editor.height = (rect[3] - rect[1]) / parentHeight;
              editor.annotationElementId = data.id || null;
              if (accessibilityData) {
                editor.altTextData = accessibilityData;
              }
              editor._initialData = initialData;
              stamp_classPrivateFieldSet(_hasBeenAddedInUndoStack, editor, !!initialData);
              return _context2.abrupt("return", editor);
            case 36:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function deserialize(_x, _x2, _x3) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }]);
}(AnnotationEditor);
_StampEditor = StampEditor;
function _getBitmapFetched(data) {
  var fromId = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  if (!data) {
    this.remove();
    return;
  }
  stamp_classPrivateFieldSet(_bitmap, this, data.bitmap);
  if (!fromId) {
    stamp_classPrivateFieldSet(_bitmapId, this, data.id);
    stamp_classPrivateFieldSet(_isSvg, this, data.isSvg);
  }
  if (data.file) {
    stamp_classPrivateFieldSet(_bitmapFileName, this, data.file.name);
  }
  stamp_assertClassBrand(_StampEditor_brand, this, _createCanvas).call(this);
}
function _getBitmapDone() {
  stamp_classPrivateFieldSet(_bitmapPromise, this, null);
  this._uiManager.enableWaiting(false);
  if (!stamp_classPrivateFieldGet(stamp_canvas, this)) {
    return;
  }
  if (this._uiManager.useNewAltTextWhenAddingImage && this._uiManager.useNewAltTextFlow && stamp_classPrivateFieldGet(_bitmap, this)) {
    this._editToolbar.hide();
    this._uiManager.editAltText(this, true);
    return;
  }
  if (!this._uiManager.useNewAltTextWhenAddingImage && this._uiManager.useNewAltTextFlow && stamp_classPrivateFieldGet(_bitmap, this)) {
    this._reportTelemetry({
      action: "pdfjs.image.image_added",
      data: {
        alt_text_modal: false,
        alt_text_type: "empty"
      }
    });
    try {
      this.mlGuessAltText();
    } catch (_unused) {}
  }
  this.div.focus();
}
function _getBitmap() {
  var _this3 = this;
  if (stamp_classPrivateFieldGet(_bitmapId, this)) {
    this._uiManager.enableWaiting(true);
    this._uiManager.imageManager.getFromId(stamp_classPrivateFieldGet(_bitmapId, this)).then(function (data) {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapFetched).call(_this3, data, true);
    }).finally(function () {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapDone).call(_this3);
    });
    return;
  }
  if (stamp_classPrivateFieldGet(_bitmapUrl, this)) {
    var url = stamp_classPrivateFieldGet(_bitmapUrl, this);
    stamp_classPrivateFieldSet(_bitmapUrl, this, null);
    this._uiManager.enableWaiting(true);
    stamp_classPrivateFieldSet(_bitmapPromise, this, this._uiManager.imageManager.getFromUrl(url).then(function (data) {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapFetched).call(_this3, data);
    }).finally(function () {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapDone).call(_this3);
    }));
    return;
  }
  if (stamp_classPrivateFieldGet(_bitmapFile, this)) {
    var file = stamp_classPrivateFieldGet(_bitmapFile, this);
    stamp_classPrivateFieldSet(_bitmapFile, this, null);
    this._uiManager.enableWaiting(true);
    stamp_classPrivateFieldSet(_bitmapPromise, this, this._uiManager.imageManager.getFromFile(file).then(function (data) {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapFetched).call(_this3, data);
    }).finally(function () {
      return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapDone).call(_this3);
    }));
    return;
  }
  var input = document.createElement("input");
  input.type = "file";
  input.accept = _StampEditor.supportedTypesStr;
  var signal = this._uiManager._signal;
  stamp_classPrivateFieldSet(_bitmapPromise, this, new Promise(function (resolve) {
    input.addEventListener("change", /*#__PURE__*/stamp_asyncToGenerator(/*#__PURE__*/stamp_regeneratorRuntime().mark(function _callee3() {
      var data;
      return stamp_regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            if (!(!input.files || input.files.length === 0)) {
              _context3.next = 4;
              break;
            }
            _this3.remove();
            _context3.next = 10;
            break;
          case 4:
            _this3._uiManager.enableWaiting(true);
            _context3.next = 7;
            return _this3._uiManager.imageManager.getFromFile(input.files[0]);
          case 7:
            data = _context3.sent;
            _this3._reportTelemetry({
              action: "pdfjs.image.image_selected",
              data: {
                alt_text_modal: _this3._uiManager.useNewAltTextFlow
              }
            });
            stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapFetched).call(_this3, data);
          case 10:
            resolve();
          case 11:
          case "end":
            return _context3.stop();
        }
      }, _callee3);
    })), {
      signal: signal
    });
    input.addEventListener("cancel", function () {
      _this3.remove();
      resolve();
    }, {
      signal: signal
    });
  }).finally(function () {
    return stamp_assertClassBrand(_StampEditor_brand, _this3, _getBitmapDone).call(_this3);
  }));
  input.click();
}
function _createCanvas() {
  var _this$_initialOptions;
  var div = this.div;
  var _classPrivateFieldGet4 = stamp_classPrivateFieldGet(_bitmap, this),
    width = _classPrivateFieldGet4.width,
    height = _classPrivateFieldGet4.height;
  var _this$pageDimensions = stamp_slicedToArray(this.pageDimensions, 2),
    pageWidth = _this$pageDimensions[0],
    pageHeight = _this$pageDimensions[1];
  var MAX_RATIO = 0.75;
  if (this.width) {
    width = this.width * pageWidth;
    height = this.height * pageHeight;
  } else if (width > MAX_RATIO * pageWidth || height > MAX_RATIO * pageHeight) {
    var factor = Math.min(MAX_RATIO * pageWidth / width, MAX_RATIO * pageHeight / height);
    width *= factor;
    height *= factor;
  }
  var _this$parentDimension2 = stamp_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension2[0],
    parentHeight = _this$parentDimension2[1];
  this.setDims(width * parentWidth / pageWidth, height * parentHeight / pageHeight);
  this._uiManager.enableWaiting(false);
  var canvas = stamp_classPrivateFieldSet(stamp_canvas, this, document.createElement("canvas"));
  canvas.setAttribute("role", "img");
  this.addContainer(canvas);
  this.width = width / pageWidth;
  this.height = height / pageHeight;
  if ((_this$_initialOptions = this._initialOptions) !== null && _this$_initialOptions !== void 0 && _this$_initialOptions.isCentered) {
    this.center();
  } else {
    this.fixAndSetPosition();
  }
  this._initialOptions = null;
  if (!this._uiManager.useNewAltTextWhenAddingImage || !this._uiManager.useNewAltTextFlow || this.annotationElementId) {
    div.hidden = false;
  }
  stamp_assertClassBrand(_StampEditor_brand, this, _drawBitmap).call(this);
  if (!stamp_classPrivateFieldGet(_hasBeenAddedInUndoStack, this)) {
    this.parent.addUndoableEditor(this);
    stamp_classPrivateFieldSet(_hasBeenAddedInUndoStack, this, true);
  }
  this._reportTelemetry({
    action: "inserted_image"
  });
  if (stamp_classPrivateFieldGet(_bitmapFileName, this)) {
    canvas.setAttribute("aria-label", stamp_classPrivateFieldGet(_bitmapFileName, this));
  }
}
function _scaleBitmap(width, height) {
  var _classPrivateFieldGet5 = stamp_classPrivateFieldGet(_bitmap, this),
    bitmapWidth = _classPrivateFieldGet5.width,
    bitmapHeight = _classPrivateFieldGet5.height;
  var newWidth = bitmapWidth;
  var newHeight = bitmapHeight;
  var bitmap = stamp_classPrivateFieldGet(_bitmap, this);
  while (newWidth > 2 * width || newHeight > 2 * height) {
    var prevWidth = newWidth;
    var prevHeight = newHeight;
    if (newWidth > 2 * width) {
      newWidth = newWidth >= 16384 ? Math.floor(newWidth / 2) - 1 : Math.ceil(newWidth / 2);
    }
    if (newHeight > 2 * height) {
      newHeight = newHeight >= 16384 ? Math.floor(newHeight / 2) - 1 : Math.ceil(newHeight / 2);
    }
    var offscreen = new OffscreenCanvas(newWidth, newHeight);
    var ctx = offscreen.getContext("2d");
    ctx.drawImage(bitmap, 0, 0, prevWidth, prevHeight, 0, 0, newWidth, newHeight);
    bitmap = offscreen.transferToImageBitmap();
  }
  return bitmap;
}
function _drawBitmap() {
  var _this$parentDimension3 = stamp_slicedToArray(this.parentDimensions, 2),
    parentWidth = _this$parentDimension3[0],
    parentHeight = _this$parentDimension3[1];
  var width = this.width,
    height = this.height;
  var outputScale = new OutputScale();
  var scaledWidth = Math.ceil(width * parentWidth * outputScale.sx);
  var scaledHeight = Math.ceil(height * parentHeight * outputScale.sy);
  var canvas = stamp_classPrivateFieldGet(stamp_canvas, this);
  if (!canvas || canvas.width === scaledWidth && canvas.height === scaledHeight) {
    return;
  }
  canvas.width = scaledWidth;
  canvas.height = scaledHeight;
  var bitmap = stamp_classPrivateFieldGet(_isSvg, this) ? stamp_classPrivateFieldGet(_bitmap, this) : stamp_assertClassBrand(_StampEditor_brand, this, _scaleBitmap).call(this, scaledWidth, scaledHeight);
  var ctx = canvas.getContext("2d");
  ctx.filter = this._uiManager.hcmFilter;
  ctx.drawImage(bitmap, 0, 0, bitmap.width, bitmap.height, 0, 0, scaledWidth, scaledHeight);
}
function _serializeBitmap(toUrl) {
  if (toUrl) {
    if (stamp_classPrivateFieldGet(_isSvg, this)) {
      var url = this._uiManager.imageManager.getSvgUrl(stamp_classPrivateFieldGet(_bitmapId, this));
      if (url) {
        return url;
      }
    }
    var canvas = document.createElement("canvas");
    var _classPrivateFieldGet6 = stamp_classPrivateFieldGet(_bitmap, this);
    canvas.width = _classPrivateFieldGet6.width;
    canvas.height = _classPrivateFieldGet6.height;
    var ctx = canvas.getContext("2d");
    ctx.drawImage(stamp_classPrivateFieldGet(_bitmap, this), 0, 0);
    return canvas.toDataURL();
  }
  if (stamp_classPrivateFieldGet(_isSvg, this)) {
    var _this$pageDimensions2 = stamp_slicedToArray(this.pageDimensions, 2),
      pageWidth = _this$pageDimensions2[0],
      pageHeight = _this$pageDimensions2[1];
    var width = Math.round(this.width * pageWidth * PixelsPerInch.PDF_TO_CSS_UNITS);
    var height = Math.round(this.height * pageHeight * PixelsPerInch.PDF_TO_CSS_UNITS);
    var offscreen = new OffscreenCanvas(width, height);
    var _ctx = offscreen.getContext("2d");
    _ctx.drawImage(stamp_classPrivateFieldGet(_bitmap, this), 0, 0, stamp_classPrivateFieldGet(_bitmap, this).width, stamp_classPrivateFieldGet(_bitmap, this).height, 0, 0, width, height);
    return offscreen.transferToImageBitmap();
  }
  return structuredClone(stamp_classPrivateFieldGet(_bitmap, this));
}
function stamp_hasElementChanged(serialized) {
  var _serialized$accessibi;
  var _this$_initialData = this._initialData,
    pageIndex = _this$_initialData.pageIndex,
    altText = _this$_initialData.accessibilityData.altText;
  var isSamePageIndex = serialized.pageIndex === pageIndex;
  var isSameAltText = (((_serialized$accessibi = serialized.accessibilityData) === null || _serialized$accessibi === void 0 ? void 0 : _serialized$accessibi.alt) || "") === altText;
  return {
    isSame: !this._hasBeenMoved && !this._hasBeenResized && isSamePageIndex && isSameAltText,
    isSameAltText: isSameAltText
  };
}
stamp_defineProperty(StampEditor, "_type", "stamp");
stamp_defineProperty(StampEditor, "_editorType", AnnotationEditorType.STAMP);

;// ./src/display/editor/annotation_editor_layer.js
function annotation_editor_layer_typeof(o) { "@babel/helpers - typeof"; return annotation_editor_layer_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, annotation_editor_layer_typeof(o); }
function annotation_editor_layer_slicedToArray(r, e) { return annotation_editor_layer_arrayWithHoles(r) || annotation_editor_layer_iterableToArrayLimit(r, e) || annotation_editor_layer_unsupportedIterableToArray(r, e) || annotation_editor_layer_nonIterableRest(); }
function annotation_editor_layer_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function annotation_editor_layer_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function annotation_editor_layer_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function annotation_editor_layer_ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function annotation_editor_layer_objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? annotation_editor_layer_ownKeys(Object(t), !0).forEach(function (r) { annotation_editor_layer_defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : annotation_editor_layer_ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function annotation_editor_layer_regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ annotation_editor_layer_regeneratorRuntime = function _regeneratorRuntime() { return e; }; var t, e = {}, r = Object.prototype, n = r.hasOwnProperty, o = Object.defineProperty || function (t, e, r) { t[e] = r.value; }, i = "function" == typeof Symbol ? Symbol : {}, a = i.iterator || "@@iterator", c = i.asyncIterator || "@@asyncIterator", u = i.toStringTag || "@@toStringTag"; function define(t, e, r) { return Object.defineProperty(t, e, { value: r, enumerable: !0, configurable: !0, writable: !0 }), t[e]; } try { define({}, ""); } catch (t) { define = function define(t, e, r) { return t[e] = r; }; } function wrap(t, e, r, n) { var i = e && e.prototype instanceof Generator ? e : Generator, a = Object.create(i.prototype), c = new Context(n || []); return o(a, "_invoke", { value: makeInvokeMethod(t, r, c) }), a; } function tryCatch(t, e, r) { try { return { type: "normal", arg: t.call(e, r) }; } catch (t) { return { type: "throw", arg: t }; } } e.wrap = wrap; var h = "suspendedStart", l = "suspendedYield", f = "executing", s = "completed", y = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var p = {}; define(p, a, function () { return this; }); var d = Object.getPrototypeOf, v = d && d(d(values([]))); v && v !== r && n.call(v, a) && (p = v); var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p); function defineIteratorMethods(t) { ["next", "throw", "return"].forEach(function (e) { define(t, e, function (t) { return this._invoke(e, t); }); }); } function AsyncIterator(t, e) { function invoke(r, o, i, a) { var c = tryCatch(t[r], t, o); if ("throw" !== c.type) { var u = c.arg, h = u.value; return h && "object" == annotation_editor_layer_typeof(h) && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) { invoke("next", t, i, a); }, function (t) { invoke("throw", t, i, a); }) : e.resolve(h).then(function (t) { u.value = t, i(u); }, function (t) { return invoke("throw", t, i, a); }); } a(c.arg); } var r; o(this, "_invoke", { value: function value(t, n) { function callInvokeWithMethodAndArg() { return new e(function (e, r) { invoke(t, n, e, r); }); } return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(e, r, n) { var o = h; return function (i, a) { if (o === f) throw Error("Generator is already running"); if (o === s) { if ("throw" === i) throw a; return { value: t, done: !0 }; } for (n.method = i, n.arg = a;;) { var c = n.delegate; if (c) { var u = maybeInvokeDelegate(c, n); if (u) { if (u === y) continue; return u; } } if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) { if (o === h) throw o = s, n.arg; n.dispatchException(n.arg); } else "return" === n.method && n.abrupt("return", n.arg); o = f; var p = tryCatch(e, r, n); if ("normal" === p.type) { if (o = n.done ? s : l, p.arg === y) continue; return { value: p.arg, done: n.done }; } "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg); } }; } function maybeInvokeDelegate(e, r) { var n = r.method, o = e.iterator[n]; if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y; var i = tryCatch(o, e.iterator, r.arg); if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y; var a = i.arg; return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y); } function pushTryEntry(t) { var e = { tryLoc: t[0] }; 1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e); } function resetTryEntry(t) { var e = t.completion || {}; e.type = "normal", delete e.arg, t.completion = e; } function Context(t) { this.tryEntries = [{ tryLoc: "root" }], t.forEach(pushTryEntry, this), this.reset(!0); } function values(e) { if (e || "" === e) { var r = e[a]; if (r) return r.call(e); if ("function" == typeof e.next) return e; if (!isNaN(e.length)) { var o = -1, i = function next() { for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next; return next.value = t, next.done = !0, next; }; return i.next = i; } } throw new TypeError(annotation_editor_layer_typeof(e) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), o(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) { var e = "function" == typeof t && t.constructor; return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name)); }, e.mark = function (t) { return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t; }, e.awrap = function (t) { return { __await: t }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () { return this; }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) { void 0 === i && (i = Promise); var a = new AsyncIterator(wrap(t, r, n, o), i); return e.isGeneratorFunction(r) ? a : a.next().then(function (t) { return t.done ? t.value : a.next(); }); }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () { return this; }), define(g, "toString", function () { return "[object Generator]"; }), e.keys = function (t) { var e = Object(t), r = []; for (var n in e) r.push(n); return r.reverse(), function next() { for (; r.length;) { var t = r.pop(); if (t in e) return next.value = t, next.done = !1, next; } return next.done = !0, next; }; }, e.values = values, Context.prototype = { constructor: Context, reset: function reset(e) { if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t); }, stop: function stop() { this.done = !0; var t = this.tryEntries[0].completion; if ("throw" === t.type) throw t.arg; return this.rval; }, dispatchException: function dispatchException(e) { if (this.done) throw e; var r = this; function handle(n, o) { return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o; } for (var o = this.tryEntries.length - 1; o >= 0; --o) { var i = this.tryEntries[o], a = i.completion; if ("root" === i.tryLoc) return handle("end"); if (i.tryLoc <= this.prev) { var c = n.call(i, "catchLoc"), u = n.call(i, "finallyLoc"); if (c && u) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } else if (c) { if (this.prev < i.catchLoc) return handle(i.catchLoc, !0); } else { if (!u) throw Error("try statement without catch or finally"); if (this.prev < i.finallyLoc) return handle(i.finallyLoc); } } } }, abrupt: function abrupt(t, e) { for (var r = this.tryEntries.length - 1; r >= 0; --r) { var o = this.tryEntries[r]; if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) { var i = o; break; } } i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null); var a = i ? i.completion : {}; return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a); }, complete: function complete(t, e) { if ("throw" === t.type) throw t.arg; return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y; }, finish: function finish(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y; } }, catch: function _catch(t) { for (var e = this.tryEntries.length - 1; e >= 0; --e) { var r = this.tryEntries[e]; if (r.tryLoc === t) { var n = r.completion; if ("throw" === n.type) { var o = n.arg; resetTryEntry(r); } return o; } } throw Error("illegal catch attempt"); }, delegateYield: function delegateYield(e, r, n) { return this.delegate = { iterator: values(e), resultName: r, nextLoc: n }, "next" === this.method && (this.arg = t), y; } }, e; }
function annotation_editor_layer_asyncGeneratorStep(n, t, e, r, o, a, c) { try { var i = n[a](c), u = i.value; } catch (n) { return void e(n); } i.done ? t(u) : Promise.resolve(u).then(r, o); }
function annotation_editor_layer_asyncToGenerator(n) { return function () { var t = this, e = arguments; return new Promise(function (r, o) { var a = n.apply(t, e); function _next(n) { annotation_editor_layer_asyncGeneratorStep(a, r, o, _next, _throw, "next", n); } function _throw(n) { annotation_editor_layer_asyncGeneratorStep(a, r, o, _next, _throw, "throw", n); } _next(void 0); }); }; }
function annotation_editor_layer_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = annotation_editor_layer_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function annotation_editor_layer_toConsumableArray(r) { return annotation_editor_layer_arrayWithoutHoles(r) || annotation_editor_layer_iterableToArray(r) || annotation_editor_layer_unsupportedIterableToArray(r) || annotation_editor_layer_nonIterableSpread(); }
function annotation_editor_layer_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function annotation_editor_layer_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return annotation_editor_layer_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? annotation_editor_layer_arrayLikeToArray(r, a) : void 0; } }
function annotation_editor_layer_iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function annotation_editor_layer_arrayWithoutHoles(r) { if (Array.isArray(r)) return annotation_editor_layer_arrayLikeToArray(r); }
function annotation_editor_layer_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
















































function annotation_editor_layer_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function annotation_editor_layer_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, annotation_editor_layer_toPropertyKey(o.key), o); } }
function annotation_editor_layer_createClass(e, r, t) { return r && annotation_editor_layer_defineProperties(e.prototype, r), t && annotation_editor_layer_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function annotation_editor_layer_classPrivateMethodInitSpec(e, a) { annotation_editor_layer_checkPrivateRedeclaration(e, a), a.add(e); }
function annotation_editor_layer_defineProperty(e, r, t) { return (r = annotation_editor_layer_toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function annotation_editor_layer_toPropertyKey(t) { var i = annotation_editor_layer_toPrimitive(t, "string"); return "symbol" == annotation_editor_layer_typeof(i) ? i : i + ""; }
function annotation_editor_layer_toPrimitive(t, r) { if ("object" != annotation_editor_layer_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != annotation_editor_layer_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function annotation_editor_layer_classPrivateFieldInitSpec(e, t, a) { annotation_editor_layer_checkPrivateRedeclaration(e, t), t.set(e, a); }
function annotation_editor_layer_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function annotation_editor_layer_classPrivateGetter(s, r, a) { return a(annotation_editor_layer_assertClassBrand(s, r)); }
function annotation_editor_layer_classPrivateFieldGet(s, a) { return s.get(annotation_editor_layer_assertClassBrand(s, a)); }
function annotation_editor_layer_classPrivateFieldSet(s, a, r) { return s.set(annotation_editor_layer_assertClassBrand(s, a), r), r; }
function annotation_editor_layer_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }







var annotation_editor_layer_accessibilityManager = /*#__PURE__*/new WeakMap();
var _allowClick = /*#__PURE__*/new WeakMap();
var _annotationLayer = /*#__PURE__*/new WeakMap();
var _clickAC = /*#__PURE__*/new WeakMap();
var _editorFocusTimeoutId = /*#__PURE__*/new WeakMap();
var _editors = /*#__PURE__*/new WeakMap();
var _hadPointerDown = /*#__PURE__*/new WeakMap();
var _isDisabling = /*#__PURE__*/new WeakMap();
var _isEnabling = /*#__PURE__*/new WeakMap();
var _drawingAC = /*#__PURE__*/new WeakMap();
var _focusedElement = /*#__PURE__*/new WeakMap();
var _textLayer = /*#__PURE__*/new WeakMap();
var _textSelectionAC = /*#__PURE__*/new WeakMap();
var annotation_editor_layer_uiManager = /*#__PURE__*/new WeakMap();
var _AnnotationEditorLayer_brand = /*#__PURE__*/new WeakSet();
var AnnotationEditorLayer = /*#__PURE__*/function () {
  function AnnotationEditorLayer(_ref) {
    var uiManager = _ref.uiManager,
      pageIndex = _ref.pageIndex,
      div = _ref.div,
      structTreeLayer = _ref.structTreeLayer,
      accessibilityManager = _ref.accessibilityManager,
      annotationLayer = _ref.annotationLayer,
      drawLayer = _ref.drawLayer,
      textLayer = _ref.textLayer,
      viewport = _ref.viewport,
      l10n = _ref.l10n;
    annotation_editor_layer_classCallCheck(this, AnnotationEditorLayer);
    annotation_editor_layer_classPrivateMethodInitSpec(this, _AnnotationEditorLayer_brand);
    annotation_editor_layer_classPrivateFieldInitSpec(this, annotation_editor_layer_accessibilityManager, void 0);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _allowClick, false);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _annotationLayer, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _clickAC, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _editorFocusTimeoutId, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _editors, new Map());
    annotation_editor_layer_classPrivateFieldInitSpec(this, _hadPointerDown, false);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _isDisabling, false);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _isEnabling, false);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _drawingAC, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _focusedElement, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _textLayer, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, _textSelectionAC, null);
    annotation_editor_layer_classPrivateFieldInitSpec(this, annotation_editor_layer_uiManager, void 0);
    var editorTypes = annotation_editor_layer_toConsumableArray(annotation_editor_layer_editorTypes._.values());
    if (!AnnotationEditorLayer._initialized) {
      AnnotationEditorLayer._initialized = true;
      var _iterator = annotation_editor_layer_createForOfIteratorHelper(editorTypes),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var editorType = _step.value;
          editorType.initialize(l10n, uiManager);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
    uiManager.registerEditorTypes(editorTypes);
    annotation_editor_layer_classPrivateFieldSet(annotation_editor_layer_uiManager, this, uiManager);
    this.pageIndex = pageIndex;
    this.div = div;
    annotation_editor_layer_classPrivateFieldSet(annotation_editor_layer_accessibilityManager, this, accessibilityManager);
    annotation_editor_layer_classPrivateFieldSet(_annotationLayer, this, annotationLayer);
    this.viewport = viewport;
    annotation_editor_layer_classPrivateFieldSet(_textLayer, this, textLayer);
    this.drawLayer = drawLayer;
    this._structTree = structTreeLayer;
    annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addLayer(this);
  }
  return annotation_editor_layer_createClass(AnnotationEditorLayer, [{
    key: "isEmpty",
    get: function get() {
      return annotation_editor_layer_classPrivateFieldGet(_editors, this).size === 0;
    }
  }, {
    key: "isInvisible",
    get: function get() {
      return this.isEmpty && annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getMode() === AnnotationEditorType.NONE;
    }
  }, {
    key: "updateToolbar",
    value: function updateToolbar(mode) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).updateToolbar(mode);
    }
  }, {
    key: "updateMode",
    value: function updateMode() {
      var mode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getMode();
      annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _cleanup).call(this);
      switch (mode) {
        case AnnotationEditorType.NONE:
          this.disableTextSelection();
          this.togglePointerEvents(false);
          this.toggleAnnotationLayerPointerEvents(true);
          this.disableClick();
          return;
        case AnnotationEditorType.INK:
          this.disableTextSelection();
          this.togglePointerEvents(true);
          this.enableClick();
          break;
        case AnnotationEditorType.HIGHLIGHT:
          this.enableTextSelection();
          this.togglePointerEvents(false);
          this.disableClick();
          break;
        default:
          this.disableTextSelection();
          this.togglePointerEvents(true);
          this.enableClick();
      }
      this.toggleAnnotationLayerPointerEvents(false);
      var classList = this.div.classList;
      var _iterator2 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_editorTypes._.values()),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var editorType = _step2.value;
          classList.toggle("".concat(editorType._type, "Editing"), mode === editorType._editorType);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      this.div.hidden = false;
    }
  }, {
    key: "hasTextLayer",
    value: function hasTextLayer(textLayer) {
      var _classPrivateFieldGet2;
      return textLayer === ((_classPrivateFieldGet2 = annotation_editor_layer_classPrivateFieldGet(_textLayer, this)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.div);
    }
  }, {
    key: "setEditingState",
    value: function setEditingState(isEditing) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setEditingState(isEditing);
    }
  }, {
    key: "addCommands",
    value: function addCommands(params) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addCommands(params);
    }
  }, {
    key: "cleanUndoStack",
    value: function cleanUndoStack(type) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).cleanUndoStack(type);
    }
  }, {
    key: "toggleDrawing",
    value: function toggleDrawing() {
      var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.div.classList.toggle("drawing", !enabled);
    }
  }, {
    key: "togglePointerEvents",
    value: function togglePointerEvents() {
      var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this.div.classList.toggle("disabled", !enabled);
    }
  }, {
    key: "toggleAnnotationLayerPointerEvents",
    value: function toggleAnnotationLayerPointerEvents() {
      var _classPrivateFieldGet3;
      var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      (_classPrivateFieldGet3 = annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this)) === null || _classPrivateFieldGet3 === void 0 || _classPrivateFieldGet3.div.classList.toggle("disabled", !enabled);
    }
  }, {
    key: "enable",
    value: function () {
      var _enable = annotation_editor_layer_asyncToGenerator(/*#__PURE__*/annotation_editor_layer_regeneratorRuntime().mark(function _callee() {
        var annotationElementIds, _iterator3, _step3, editor, editables, _iterator4, _step4, editable, _editor;
        return annotation_editor_layer_regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              annotation_editor_layer_classPrivateFieldSet(_isEnabling, this, true);
              this.div.tabIndex = 0;
              this.togglePointerEvents(true);
              annotationElementIds = new Set();
              _iterator3 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(_editors, this).values());
              try {
                for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                  editor = _step3.value;
                  editor.enableEditing();
                  editor.show(true);
                  if (editor.annotationElementId) {
                    annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).removeChangedExistingAnnotation(editor);
                    annotationElementIds.add(editor.annotationElementId);
                  }
                }
              } catch (err) {
                _iterator3.e(err);
              } finally {
                _iterator3.f();
              }
              if (annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this)) {
                _context.next = 9;
                break;
              }
              annotation_editor_layer_classPrivateFieldSet(_isEnabling, this, false);
              return _context.abrupt("return");
            case 9:
              editables = annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this).getEditableAnnotations();
              _iterator4 = annotation_editor_layer_createForOfIteratorHelper(editables);
              _context.prev = 11;
              _iterator4.s();
            case 13:
              if ((_step4 = _iterator4.n()).done) {
                _context.next = 29;
                break;
              }
              editable = _step4.value;
              editable.hide();
              if (!annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).isDeletedAnnotationElement(editable.data.id)) {
                _context.next = 18;
                break;
              }
              return _context.abrupt("continue", 27);
            case 18:
              if (!annotationElementIds.has(editable.data.id)) {
                _context.next = 20;
                break;
              }
              return _context.abrupt("continue", 27);
            case 20:
              _context.next = 22;
              return this.deserialize(editable);
            case 22:
              _editor = _context.sent;
              if (_editor) {
                _context.next = 25;
                break;
              }
              return _context.abrupt("continue", 27);
            case 25:
              this.addOrRebuild(_editor);
              _editor.enableEditing();
            case 27:
              _context.next = 13;
              break;
            case 29:
              _context.next = 34;
              break;
            case 31:
              _context.prev = 31;
              _context.t0 = _context["catch"](11);
              _iterator4.e(_context.t0);
            case 34:
              _context.prev = 34;
              _iterator4.f();
              return _context.finish(34);
            case 37:
              annotation_editor_layer_classPrivateFieldSet(_isEnabling, this, false);
            case 38:
            case "end":
              return _context.stop();
          }
        }, _callee, this, [[11, 31, 34, 37]]);
      }));
      function enable() {
        return _enable.apply(this, arguments);
      }
      return enable;
    }()
  }, {
    key: "disable",
    value: function disable() {
      annotation_editor_layer_classPrivateFieldSet(_isDisabling, this, true);
      this.div.tabIndex = -1;
      this.togglePointerEvents(false);
      var changedAnnotations = new Map();
      var resetAnnotations = new Map();
      var _iterator5 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(_editors, this).values()),
        _step5;
      try {
        for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
          var _this$getEditableAnno;
          var _editor2 = _step5.value;
          _editor2.disableEditing();
          if (!_editor2.annotationElementId) {
            continue;
          }
          if (_editor2.serialize() !== null) {
            changedAnnotations.set(_editor2.annotationElementId, _editor2);
            continue;
          } else {
            resetAnnotations.set(_editor2.annotationElementId, _editor2);
          }
          (_this$getEditableAnno = this.getEditableAnnotation(_editor2.annotationElementId)) === null || _this$getEditableAnno === void 0 || _this$getEditableAnno.show();
          _editor2.remove();
        }
      } catch (err) {
        _iterator5.e(err);
      } finally {
        _iterator5.f();
      }
      if (annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this)) {
        var editables = annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this).getEditableAnnotations();
        var _iterator6 = annotation_editor_layer_createForOfIteratorHelper(editables),
          _step6;
        try {
          for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
            var editable = _step6.value;
            var id = editable.data.id;
            if (annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).isDeletedAnnotationElement(id)) {
              continue;
            }
            var editor = resetAnnotations.get(id);
            if (editor) {
              editor.resetAnnotationElement(editable);
              editor.show(false);
              editable.show();
              continue;
            }
            editor = changedAnnotations.get(id);
            if (editor) {
              annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addChangedExistingAnnotation(editor);
              if (editor.renderAnnotationElement(editable)) {
                editor.show(false);
              }
            }
            editable.show();
          }
        } catch (err) {
          _iterator6.e(err);
        } finally {
          _iterator6.f();
        }
      }
      annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _cleanup).call(this);
      if (this.isEmpty) {
        this.div.hidden = true;
      }
      var classList = this.div.classList;
      var _iterator7 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_editorTypes._.values()),
        _step7;
      try {
        for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
          var editorType = _step7.value;
          classList.remove("".concat(editorType._type, "Editing"));
        }
      } catch (err) {
        _iterator7.e(err);
      } finally {
        _iterator7.f();
      }
      this.disableTextSelection();
      this.toggleAnnotationLayerPointerEvents(true);
      annotation_editor_layer_classPrivateFieldSet(_isDisabling, this, false);
    }
  }, {
    key: "getEditableAnnotation",
    value: function getEditableAnnotation(id) {
      var _classPrivateFieldGet4;
      return ((_classPrivateFieldGet4 = annotation_editor_layer_classPrivateFieldGet(_annotationLayer, this)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.getEditableAnnotation(id)) || null;
    }
  }, {
    key: "setActiveEditor",
    value: function setActiveEditor(editor) {
      var currentActive = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getActive();
      if (currentActive === editor) {
        return;
      }
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setActiveEditor(editor);
    }
  }, {
    key: "enableTextSelection",
    value: function enableTextSelection() {
      var _classPrivateFieldGet5;
      this.div.tabIndex = -1;
      if ((_classPrivateFieldGet5 = annotation_editor_layer_classPrivateFieldGet(_textLayer, this)) !== null && _classPrivateFieldGet5 !== void 0 && _classPrivateFieldGet5.div && !annotation_editor_layer_classPrivateFieldGet(_textSelectionAC, this)) {
        annotation_editor_layer_classPrivateFieldSet(_textSelectionAC, this, new AbortController());
        var signal = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).combinedSignal(annotation_editor_layer_classPrivateFieldGet(_textSelectionAC, this));
        annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.addEventListener("pointerdown", annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _textLayerPointerDown).bind(this), {
          signal: signal
        });
        annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.classList.add("highlighting");
      }
    }
  }, {
    key: "disableTextSelection",
    value: function disableTextSelection() {
      var _classPrivateFieldGet6;
      this.div.tabIndex = 0;
      if ((_classPrivateFieldGet6 = annotation_editor_layer_classPrivateFieldGet(_textLayer, this)) !== null && _classPrivateFieldGet6 !== void 0 && _classPrivateFieldGet6.div && annotation_editor_layer_classPrivateFieldGet(_textSelectionAC, this)) {
        annotation_editor_layer_classPrivateFieldGet(_textSelectionAC, this).abort();
        annotation_editor_layer_classPrivateFieldSet(_textSelectionAC, this, null);
        annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.classList.remove("highlighting");
      }
    }
  }, {
    key: "enableClick",
    value: function enableClick() {
      if (annotation_editor_layer_classPrivateFieldGet(_clickAC, this)) {
        return;
      }
      annotation_editor_layer_classPrivateFieldSet(_clickAC, this, new AbortController());
      var signal = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).combinedSignal(annotation_editor_layer_classPrivateFieldGet(_clickAC, this));
      this.div.addEventListener("pointerdown", this.pointerdown.bind(this), {
        signal: signal
      });
      var pointerup = this.pointerup.bind(this);
      this.div.addEventListener("pointerup", pointerup, {
        signal: signal
      });
      this.div.addEventListener("pointercancel", pointerup, {
        signal: signal
      });
    }
  }, {
    key: "disableClick",
    value: function disableClick() {
      var _classPrivateFieldGet7;
      (_classPrivateFieldGet7 = annotation_editor_layer_classPrivateFieldGet(_clickAC, this)) === null || _classPrivateFieldGet7 === void 0 || _classPrivateFieldGet7.abort();
      annotation_editor_layer_classPrivateFieldSet(_clickAC, this, null);
    }
  }, {
    key: "attach",
    value: function attach(editor) {
      annotation_editor_layer_classPrivateFieldGet(_editors, this).set(editor.id, editor);
      var annotationElementId = editor.annotationElementId;
      if (annotationElementId && annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).isDeletedAnnotationElement(annotationElementId)) {
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).removeDeletedAnnotationElement(editor);
      }
    }
  }, {
    key: "detach",
    value: function detach(editor) {
      var _classPrivateFieldGet8;
      annotation_editor_layer_classPrivateFieldGet(_editors, this).delete(editor.id);
      (_classPrivateFieldGet8 = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_accessibilityManager, this)) === null || _classPrivateFieldGet8 === void 0 || _classPrivateFieldGet8.removePointerInTextLayer(editor.contentDiv);
      if (!annotation_editor_layer_classPrivateFieldGet(_isDisabling, this) && editor.annotationElementId) {
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addDeletedAnnotationElement(editor);
      }
    }
  }, {
    key: "remove",
    value: function remove(editor) {
      this.detach(editor);
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).removeEditor(editor);
      editor.div.remove();
      editor.isAttachedToDOM = false;
    }
  }, {
    key: "changeParent",
    value: function changeParent(editor) {
      var _editor$parent;
      if (editor.parent === this) {
        return;
      }
      if (editor.parent && editor.annotationElementId) {
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addDeletedAnnotationElement(editor.annotationElementId);
        AnnotationEditor.deleteAnnotationElement(editor);
        editor.annotationElementId = null;
      }
      this.attach(editor);
      (_editor$parent = editor.parent) === null || _editor$parent === void 0 || _editor$parent.detach(editor);
      editor.setParent(this);
      if (editor.div && editor.isAttachedToDOM) {
        editor.div.remove();
        this.div.append(editor.div);
      }
    }
  }, {
    key: "add",
    value: function add(editor) {
      if (editor.parent === this && editor.isAttachedToDOM) {
        return;
      }
      this.changeParent(editor);
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addEditor(editor);
      this.attach(editor);
      if (!editor.isAttachedToDOM) {
        var div = editor.render();
        this.div.append(div);
        editor.isAttachedToDOM = true;
      }
      editor.fixAndSetPosition();
      editor.onceAdded(!annotation_editor_layer_classPrivateFieldGet(_isEnabling, this));
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).addToAnnotationStorage(editor);
      editor._reportTelemetry(editor.telemetryInitialData);
    }
  }, {
    key: "moveEditorInDOM",
    value: function moveEditorInDOM(editor) {
      var _this2 = this,
        _classPrivateFieldGet9;
      if (!editor.isAttachedToDOM) {
        return;
      }
      var _document = document,
        activeElement = _document.activeElement;
      if (editor.div.contains(activeElement) && !annotation_editor_layer_classPrivateFieldGet(_editorFocusTimeoutId, this)) {
        editor._focusEventsAllowed = false;
        annotation_editor_layer_classPrivateFieldSet(_editorFocusTimeoutId, this, setTimeout(function () {
          annotation_editor_layer_classPrivateFieldSet(_editorFocusTimeoutId, _this2, null);
          if (!editor.div.contains(document.activeElement)) {
            editor.div.addEventListener("focusin", function () {
              editor._focusEventsAllowed = true;
            }, {
              once: true,
              signal: annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, _this2)._signal
            });
            activeElement.focus();
          } else {
            editor._focusEventsAllowed = true;
          }
        }, 0));
      }
      editor._structTreeParentId = (_classPrivateFieldGet9 = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_accessibilityManager, this)) === null || _classPrivateFieldGet9 === void 0 ? void 0 : _classPrivateFieldGet9.moveElementInDOM(this.div, editor.div, editor.contentDiv, true);
    }
  }, {
    key: "addOrRebuild",
    value: function addOrRebuild(editor) {
      if (editor.needsToBeRebuilt()) {
        editor.parent || (editor.parent = this);
        editor.rebuild();
        editor.show();
      } else {
        this.add(editor);
      }
    }
  }, {
    key: "addUndoableEditor",
    value: function addUndoableEditor(editor) {
      var cmd = function cmd() {
        return editor._uiManager.rebuild(editor);
      };
      var undo = function undo() {
        editor.remove();
      };
      this.addCommands({
        cmd: cmd,
        undo: undo,
        mustExec: false
      });
    }
  }, {
    key: "getNextId",
    value: function getNextId() {
      return annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getId();
    }
  }, {
    key: "combinedSignal",
    value: function combinedSignal(ac) {
      return annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).combinedSignal(ac);
    }
  }, {
    key: "canCreateNewEmptyEditor",
    value: function canCreateNewEmptyEditor() {
      var _classPrivateGetter2;
      return (_classPrivateGetter2 = annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType)) === null || _classPrivateGetter2 === void 0 ? void 0 : _classPrivateGetter2.canCreateNewEmptyEditor();
    }
  }, {
    key: "pasteEditor",
    value: function pasteEditor(mode, params) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).updateToolbar(mode);
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).updateMode(mode);
      var _assertClassBrand$cal = annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _getCenterPoint).call(this),
        offsetX = _assertClassBrand$cal.offsetX,
        offsetY = _assertClassBrand$cal.offsetY;
      var id = this.getNextId();
      var editor = annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _createNewEditor).call(this, annotation_editor_layer_objectSpread({
        parent: this,
        id: id,
        x: offsetX,
        y: offsetY,
        uiManager: annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this),
        isCentered: true
      }, params));
      if (editor) {
        this.add(editor);
      }
    }
  }, {
    key: "deserialize",
    value: function () {
      var _deserialize = annotation_editor_layer_asyncToGenerator(/*#__PURE__*/annotation_editor_layer_regeneratorRuntime().mark(function _callee2(data) {
        var _editorTypes$_$get, _data$annotationType;
        return annotation_editor_layer_regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return (_editorTypes$_$get = annotation_editor_layer_editorTypes._.get((_data$annotationType = data.annotationType) !== null && _data$annotationType !== void 0 ? _data$annotationType : data.annotationEditorType)) === null || _editorTypes$_$get === void 0 ? void 0 : _editorTypes$_$get.deserialize(data, this, annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this));
            case 2:
              _context2.t0 = _context2.sent;
              if (_context2.t0) {
                _context2.next = 5;
                break;
              }
              _context2.t0 = null;
            case 5:
              return _context2.abrupt("return", _context2.t0);
            case 6:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function deserialize(_x) {
        return _deserialize.apply(this, arguments);
      }
      return deserialize;
    }()
  }, {
    key: "createAndAddNewEditor",
    value: function createAndAddNewEditor(event, isCentered) {
      var data = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var id = this.getNextId();
      var editor = annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _createNewEditor).call(this, annotation_editor_layer_objectSpread({
        parent: this,
        id: id,
        x: event.offsetX,
        y: event.offsetY,
        uiManager: annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this),
        isCentered: isCentered
      }, data));
      if (editor) {
        this.add(editor);
      }
      return editor;
    }
  }, {
    key: "addNewEditor",
    value: function addNewEditor() {
      this.createAndAddNewEditor(annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _getCenterPoint).call(this), true);
    }
  }, {
    key: "setSelected",
    value: function setSelected(editor) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setSelected(editor);
    }
  }, {
    key: "toggleSelected",
    value: function toggleSelected(editor) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).toggleSelected(editor);
    }
  }, {
    key: "unselect",
    value: function unselect(editor) {
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).unselect(editor);
    }
  }, {
    key: "pointerup",
    value: function pointerup(event) {
      var _classPrivateGetter3;
      var isMac = util_FeatureTest.platform.isMac;
      if (event.button !== 0 || event.ctrlKey && isMac) {
        return;
      }
      if (event.target !== this.div) {
        return;
      }
      if (!annotation_editor_layer_classPrivateFieldGet(_hadPointerDown, this)) {
        return;
      }
      annotation_editor_layer_classPrivateFieldSet(_hadPointerDown, this, false);
      if ((_classPrivateGetter3 = annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType)) !== null && _classPrivateGetter3 !== void 0 && _classPrivateGetter3.isDrawer && annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType).supportMultipleDrawings) {
        return;
      }
      if (!annotation_editor_layer_classPrivateFieldGet(_allowClick, this)) {
        annotation_editor_layer_classPrivateFieldSet(_allowClick, this, true);
        return;
      }
      if (annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getMode() === AnnotationEditorType.STAMP) {
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).unselectAll();
        return;
      }
      this.createAndAddNewEditor(event, false);
    }
  }, {
    key: "pointerdown",
    value: function pointerdown(event) {
      var _classPrivateGetter4;
      if (annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getMode() === AnnotationEditorType.HIGHLIGHT) {
        this.enableTextSelection();
      }
      if (annotation_editor_layer_classPrivateFieldGet(_hadPointerDown, this)) {
        annotation_editor_layer_classPrivateFieldSet(_hadPointerDown, this, false);
        return;
      }
      var isMac = util_FeatureTest.platform.isMac;
      if (event.button !== 0 || event.ctrlKey && isMac) {
        return;
      }
      if (event.target !== this.div) {
        return;
      }
      annotation_editor_layer_classPrivateFieldSet(_hadPointerDown, this, true);
      if ((_classPrivateGetter4 = annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType)) !== null && _classPrivateGetter4 !== void 0 && _classPrivateGetter4.isDrawer) {
        this.startDrawingSession(event);
        return;
      }
      var editor = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getActive();
      annotation_editor_layer_classPrivateFieldSet(_allowClick, this, !editor || editor.isEmpty());
    }
  }, {
    key: "startDrawingSession",
    value: function startDrawingSession(event) {
      var _this3 = this;
      this.div.focus();
      if (annotation_editor_layer_classPrivateFieldGet(_drawingAC, this)) {
        annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType).startDrawing(this, annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this), false, event);
        return;
      }
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setCurrentDrawingSession(this);
      annotation_editor_layer_classPrivateFieldSet(_drawingAC, this, new AbortController());
      var signal = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).combinedSignal(annotation_editor_layer_classPrivateFieldGet(_drawingAC, this));
      this.div.addEventListener("blur", function (_ref2) {
        var relatedTarget = _ref2.relatedTarget;
        if (relatedTarget && !_this3.div.contains(relatedTarget)) {
          annotation_editor_layer_classPrivateFieldSet(_focusedElement, _this3, null);
          _this3.commitOrRemove();
        }
      }, {
        signal: signal
      });
      annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType).startDrawing(this, annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this), false, event);
    }
  }, {
    key: "pause",
    value: function pause(on) {
      var _this4 = this;
      if (on) {
        var _document2 = document,
          activeElement = _document2.activeElement;
        if (this.div.contains(activeElement)) {
          annotation_editor_layer_classPrivateFieldSet(_focusedElement, this, activeElement);
        }
        return;
      }
      if (annotation_editor_layer_classPrivateFieldGet(_focusedElement, this)) {
        setTimeout(function () {
          var _classPrivateFieldGet10;
          (_classPrivateFieldGet10 = annotation_editor_layer_classPrivateFieldGet(_focusedElement, _this4)) === null || _classPrivateFieldGet10 === void 0 || _classPrivateFieldGet10.focus();
          annotation_editor_layer_classPrivateFieldSet(_focusedElement, _this4, null);
        }, 0);
      }
    }
  }, {
    key: "endDrawingSession",
    value: function endDrawingSession() {
      var isAborted = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (!annotation_editor_layer_classPrivateFieldGet(_drawingAC, this)) {
        return null;
      }
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setCurrentDrawingSession(null);
      annotation_editor_layer_classPrivateFieldGet(_drawingAC, this).abort();
      annotation_editor_layer_classPrivateFieldSet(_drawingAC, this, null);
      annotation_editor_layer_classPrivateFieldSet(_focusedElement, this, null);
      return annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType).endDrawing(isAborted);
    }
  }, {
    key: "findNewParent",
    value: function findNewParent(editor, x, y) {
      var layer = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).findParent(x, y);
      if (layer === null || layer === this) {
        return false;
      }
      layer.changeParent(editor);
      return true;
    }
  }, {
    key: "commitOrRemove",
    value: function commitOrRemove() {
      if (annotation_editor_layer_classPrivateFieldGet(_drawingAC, this)) {
        this.endDrawingSession();
        return true;
      }
      return false;
    }
  }, {
    key: "onScaleChanging",
    value: function onScaleChanging() {
      if (!annotation_editor_layer_classPrivateFieldGet(_drawingAC, this)) {
        return;
      }
      annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType).onScaleChangingWhenDrawing(this);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var _classPrivateFieldGet11;
      this.commitOrRemove();
      if (((_classPrivateFieldGet11 = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getActive()) === null || _classPrivateFieldGet11 === void 0 ? void 0 : _classPrivateFieldGet11.parent) === this) {
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).commitOrRemove();
        annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).setActiveEditor(null);
      }
      if (annotation_editor_layer_classPrivateFieldGet(_editorFocusTimeoutId, this)) {
        clearTimeout(annotation_editor_layer_classPrivateFieldGet(_editorFocusTimeoutId, this));
        annotation_editor_layer_classPrivateFieldSet(_editorFocusTimeoutId, this, null);
      }
      var _iterator8 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(_editors, this).values()),
        _step8;
      try {
        for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
          var _classPrivateFieldGet12;
          var editor = _step8.value;
          (_classPrivateFieldGet12 = annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_accessibilityManager, this)) === null || _classPrivateFieldGet12 === void 0 || _classPrivateFieldGet12.removePointerInTextLayer(editor.contentDiv);
          editor.setParent(null);
          editor.isAttachedToDOM = false;
          editor.div.remove();
        }
      } catch (err) {
        _iterator8.e(err);
      } finally {
        _iterator8.f();
      }
      this.div = null;
      annotation_editor_layer_classPrivateFieldGet(_editors, this).clear();
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).removeLayer(this);
    }
  }, {
    key: "render",
    value: function render(_ref3) {
      var viewport = _ref3.viewport;
      this.viewport = viewport;
      setLayerDimensions(this.div, viewport);
      var _iterator9 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).getEditors(this.pageIndex)),
        _step9;
      try {
        for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
          var editor = _step9.value;
          this.add(editor);
          editor.rebuild();
        }
      } catch (err) {
        _iterator9.e(err);
      } finally {
        _iterator9.f();
      }
      this.updateMode();
    }
  }, {
    key: "update",
    value: function update(_ref4) {
      var viewport = _ref4.viewport;
      annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).commitOrRemove();
      annotation_editor_layer_assertClassBrand(_AnnotationEditorLayer_brand, this, _cleanup).call(this);
      var oldRotation = this.viewport.rotation;
      var rotation = viewport.rotation;
      this.viewport = viewport;
      setLayerDimensions(this.div, {
        rotation: rotation
      });
      if (oldRotation !== rotation) {
        var _iterator10 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(_editors, this).values()),
          _step10;
        try {
          for (_iterator10.s(); !(_step10 = _iterator10.n()).done;) {
            var editor = _step10.value;
            editor.rotate(rotation);
          }
        } catch (err) {
          _iterator10.e(err);
        } finally {
          _iterator10.f();
        }
      }
    }
  }, {
    key: "pageDimensions",
    get: function get() {
      var _this$viewport$rawDim = this.viewport.rawDims,
        pageWidth = _this$viewport$rawDim.pageWidth,
        pageHeight = _this$viewport$rawDim.pageHeight;
      return [pageWidth, pageHeight];
    }
  }, {
    key: "scale",
    get: function get() {
      return annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).viewParameters.realScale;
    }
  }]);
}();
function _textLayerPointerDown(event) {
  var _this5 = this;
  annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).unselectAll();
  var target = event.target;
  if (target === annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div || (target.getAttribute("role") === "img" || target.classList.contains("endOfContent")) && annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.contains(target)) {
    var isMac = util_FeatureTest.platform.isMac;
    if (event.button !== 0 || event.ctrlKey && isMac) {
      return;
    }
    annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).showAllEditors("highlight", true, true);
    annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.classList.add("free");
    this.toggleDrawing();
    HighlightEditor.startHighlighting(this, annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this).direction === "ltr", {
      target: annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div,
      x: event.x,
      y: event.y
    });
    annotation_editor_layer_classPrivateFieldGet(_textLayer, this).div.addEventListener("pointerup", function () {
      annotation_editor_layer_classPrivateFieldGet(_textLayer, _this5).div.classList.remove("free");
      _this5.toggleDrawing(true);
    }, {
      once: true,
      signal: annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, this)._signal
    });
    event.preventDefault();
  }
}
function _get_currentEditorType(_this) {
  return annotation_editor_layer_editorTypes._.get(annotation_editor_layer_classPrivateFieldGet(annotation_editor_layer_uiManager, _this).getMode());
}
function _createNewEditor(params) {
  var editorType = annotation_editor_layer_classPrivateGetter(_AnnotationEditorLayer_brand, this, _get_currentEditorType);
  return editorType ? new editorType.prototype.constructor(params) : null;
}
function _getCenterPoint() {
  var _this$div$getBounding = this.div.getBoundingClientRect(),
    x = _this$div$getBounding.x,
    y = _this$div$getBounding.y,
    width = _this$div$getBounding.width,
    height = _this$div$getBounding.height;
  var tlX = Math.max(0, x);
  var tlY = Math.max(0, y);
  var brX = Math.min(window.innerWidth, x + width);
  var brY = Math.min(window.innerHeight, y + height);
  var centerX = (tlX + brX) / 2 - x;
  var centerY = (tlY + brY) / 2 - y;
  var _ref5 = this.viewport.rotation % 180 === 0 ? [centerX, centerY] : [centerY, centerX],
    _ref6 = annotation_editor_layer_slicedToArray(_ref5, 2),
    offsetX = _ref6[0],
    offsetY = _ref6[1];
  return {
    offsetX: offsetX,
    offsetY: offsetY
  };
}
function _cleanup() {
  var _iterator11 = annotation_editor_layer_createForOfIteratorHelper(annotation_editor_layer_classPrivateFieldGet(_editors, this).values()),
    _step11;
  try {
    for (_iterator11.s(); !(_step11 = _iterator11.n()).done;) {
      var editor = _step11.value;
      if (editor.isEmpty()) {
        editor.remove();
      }
    }
  } catch (err) {
    _iterator11.e(err);
  } finally {
    _iterator11.f();
  }
}
annotation_editor_layer_defineProperty(AnnotationEditorLayer, "_initialized", false);
var annotation_editor_layer_editorTypes = {
  _: new Map([FreeTextEditor, InkEditor, StampEditor, HighlightEditor].map(function (type) {
    return [type._editorType, type];
  }))
};

;// ./src/display/draw_layer.js












function draw_layer_typeof(o) { "@babel/helpers - typeof"; return draw_layer_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, draw_layer_typeof(o); }
var _DrawLayer;
function draw_layer_slicedToArray(r, e) { return draw_layer_arrayWithHoles(r) || draw_layer_iterableToArrayLimit(r, e) || draw_layer_unsupportedIterableToArray(r, e) || draw_layer_nonIterableRest(); }
function draw_layer_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function draw_layer_iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function draw_layer_arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function draw_layer_createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = draw_layer_unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t.return || t.return(); } finally { if (u) throw o; } } }; }
function draw_layer_unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return draw_layer_arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? draw_layer_arrayLikeToArray(r, a) : void 0; } }
function draw_layer_arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }











function draw_layer_classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function draw_layer_defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, draw_layer_toPropertyKey(o.key), o); } }
function draw_layer_createClass(e, r, t) { return r && draw_layer_defineProperties(e.prototype, r), t && draw_layer_defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function draw_layer_toPropertyKey(t) { var i = draw_layer_toPrimitive(t, "string"); return "symbol" == draw_layer_typeof(i) ? i : i + ""; }
function draw_layer_toPrimitive(t, r) { if ("object" != draw_layer_typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != draw_layer_typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function draw_layer_classPrivateMethodInitSpec(e, a) { draw_layer_checkPrivateRedeclaration(e, a), a.add(e); }
function draw_layer_classPrivateFieldInitSpec(e, t, a) { draw_layer_checkPrivateRedeclaration(e, t), t.set(e, a); }
function draw_layer_checkPrivateRedeclaration(e, t) { if (t.has(e)) throw new TypeError("Cannot initialize the same private elements twice on an object"); }
function draw_layer_classPrivateFieldSet(s, a, r) { return s.set(draw_layer_assertClassBrand(s, a), r), r; }
function draw_layer_classPrivateFieldGet(s, a) { return s.get(draw_layer_assertClassBrand(s, a)); }
function draw_layer_assertClassBrand(e, t, n) { if ("function" == typeof e ? e === t : e.has(t)) return arguments.length < 3 ? t : n; throw new TypeError("Private element is not present on this object"); }


var draw_layer_parent = /*#__PURE__*/new WeakMap();
var draw_layer_id = /*#__PURE__*/new WeakMap();
var _mapping = /*#__PURE__*/new WeakMap();
var _toUpdate = /*#__PURE__*/new WeakMap();
var _DrawLayer_brand = /*#__PURE__*/new WeakSet();
var DrawLayer = /*#__PURE__*/function () {
  function DrawLayer(_ref) {
    var pageIndex = _ref.pageIndex;
    draw_layer_classCallCheck(this, DrawLayer);
    draw_layer_classPrivateMethodInitSpec(this, _DrawLayer_brand);
    draw_layer_classPrivateFieldInitSpec(this, draw_layer_parent, null);
    draw_layer_classPrivateFieldInitSpec(this, draw_layer_id, 0);
    draw_layer_classPrivateFieldInitSpec(this, _mapping, new Map());
    draw_layer_classPrivateFieldInitSpec(this, _toUpdate, new Map());
    this.pageIndex = pageIndex;
  }
  return draw_layer_createClass(DrawLayer, [{
    key: "setParent",
    value: function setParent(parent) {
      if (!draw_layer_classPrivateFieldGet(draw_layer_parent, this)) {
        draw_layer_classPrivateFieldSet(draw_layer_parent, this, parent);
        return;
      }
      if (draw_layer_classPrivateFieldGet(draw_layer_parent, this) !== parent) {
        if (draw_layer_classPrivateFieldGet(_mapping, this).size > 0) {
          var _iterator = draw_layer_createForOfIteratorHelper(draw_layer_classPrivateFieldGet(_mapping, this).values()),
            _step;
          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var root = _step.value;
              root.remove();
              parent.append(root);
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
        draw_layer_classPrivateFieldSet(draw_layer_parent, this, parent);
      }
    }
  }, {
    key: "draw",
    value: function draw(properties) {
      var _this$id, _this$id2;
      var isPathUpdatable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var hasClip = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var id = (draw_layer_classPrivateFieldSet(draw_layer_id, this, (_this$id = draw_layer_classPrivateFieldGet(draw_layer_id, this), _this$id2 = _this$id++, _this$id)), _this$id2);
      var root = draw_layer_assertClassBrand(_DrawLayer_brand, this, _createSVG).call(this);
      var defs = DrawLayer._svgFactory.createElement("defs");
      root.append(defs);
      var path = DrawLayer._svgFactory.createElement("path");
      defs.append(path);
      var pathId = "path_p".concat(this.pageIndex, "_").concat(id);
      path.setAttribute("id", pathId);
      path.setAttribute("vector-effect", "non-scaling-stroke");
      if (isPathUpdatable) {
        draw_layer_classPrivateFieldGet(_toUpdate, this).set(id, path);
      }
      var clipPathId = hasClip ? draw_layer_assertClassBrand(_DrawLayer_brand, this, _createClipPath).call(this, defs, pathId) : null;
      var use = DrawLayer._svgFactory.createElement("use");
      root.append(use);
      use.setAttribute("href", "#".concat(pathId));
      this.updateProperties(root, properties);
      draw_layer_classPrivateFieldGet(_mapping, this).set(id, root);
      return {
        id: id,
        clipPathId: "url(#".concat(clipPathId, ")")
      };
    }
  }, {
    key: "drawOutline",
    value: function drawOutline(properties, mustRemoveSelfIntersections) {
      var _this$id3, _this$id4;
      var id = (draw_layer_classPrivateFieldSet(draw_layer_id, this, (_this$id3 = draw_layer_classPrivateFieldGet(draw_layer_id, this), _this$id4 = _this$id3++, _this$id3)), _this$id4);
      var root = draw_layer_assertClassBrand(_DrawLayer_brand, this, _createSVG).call(this);
      var defs = DrawLayer._svgFactory.createElement("defs");
      root.append(defs);
      var path = DrawLayer._svgFactory.createElement("path");
      defs.append(path);
      var pathId = "path_p".concat(this.pageIndex, "_").concat(id);
      path.setAttribute("id", pathId);
      path.setAttribute("vector-effect", "non-scaling-stroke");
      var maskId;
      if (mustRemoveSelfIntersections) {
        var mask = DrawLayer._svgFactory.createElement("mask");
        defs.append(mask);
        maskId = "mask_p".concat(this.pageIndex, "_").concat(id);
        mask.setAttribute("id", maskId);
        mask.setAttribute("maskUnits", "objectBoundingBox");
        var rect = DrawLayer._svgFactory.createElement("rect");
        mask.append(rect);
        rect.setAttribute("width", "1");
        rect.setAttribute("height", "1");
        rect.setAttribute("fill", "white");
        var use = DrawLayer._svgFactory.createElement("use");
        mask.append(use);
        use.setAttribute("href", "#".concat(pathId));
        use.setAttribute("stroke", "none");
        use.setAttribute("fill", "black");
        use.setAttribute("fill-rule", "nonzero");
        use.classList.add("mask");
      }
      var use1 = DrawLayer._svgFactory.createElement("use");
      root.append(use1);
      use1.setAttribute("href", "#".concat(pathId));
      if (maskId) {
        use1.setAttribute("mask", "url(#".concat(maskId, ")"));
      }
      var use2 = use1.cloneNode();
      root.append(use2);
      use1.classList.add("mainOutline");
      use2.classList.add("secondaryOutline");
      this.updateProperties(root, properties);
      draw_layer_classPrivateFieldGet(_mapping, this).set(id, root);
      return id;
    }
  }, {
    key: "finalizeDraw",
    value: function finalizeDraw(id, properties) {
      draw_layer_classPrivateFieldGet(_toUpdate, this).delete(id);
      this.updateProperties(id, properties);
    }
  }, {
    key: "updateProperties",
    value: function updateProperties(elementOrId, properties) {
      if (!properties) {
        return;
      }
      var root = properties.root,
        bbox = properties.bbox,
        rootClass = properties.rootClass,
        path = properties.path;
      var element = typeof elementOrId === "number" ? draw_layer_classPrivateFieldGet(_mapping, this).get(elementOrId) : elementOrId;
      if (!element) {
        return;
      }
      if (root) {
        draw_layer_assertClassBrand(_DrawLayer_brand, this, _updateProperties).call(this, element, root);
      }
      if (bbox) {
        _setBox.call(DrawLayer, element, bbox);
      }
      if (rootClass) {
        var classList = element.classList;
        for (var _i = 0, _Object$entries = Object.entries(rootClass); _i < _Object$entries.length; _i++) {
          var _Object$entries$_i = draw_layer_slicedToArray(_Object$entries[_i], 2),
            className = _Object$entries$_i[0],
            value = _Object$entries$_i[1];
          classList.toggle(className, value);
        }
      }
      if (path) {
        var defs = element.firstChild;
        var pathElement = defs.firstChild;
        draw_layer_assertClassBrand(_DrawLayer_brand, this, _updateProperties).call(this, pathElement, path);
      }
    }
  }, {
    key: "updateParent",
    value: function updateParent(id, layer) {
      if (layer === this) {
        return;
      }
      var root = draw_layer_classPrivateFieldGet(_mapping, this).get(id);
      if (!root) {
        return;
      }
      draw_layer_classPrivateFieldGet(draw_layer_parent, layer).append(root);
      draw_layer_classPrivateFieldGet(_mapping, this).delete(id);
      draw_layer_classPrivateFieldGet(_mapping, layer).set(id, root);
    }
  }, {
    key: "remove",
    value: function remove(id) {
      draw_layer_classPrivateFieldGet(_toUpdate, this).delete(id);
      if (draw_layer_classPrivateFieldGet(draw_layer_parent, this) === null) {
        return;
      }
      draw_layer_classPrivateFieldGet(_mapping, this).get(id).remove();
      draw_layer_classPrivateFieldGet(_mapping, this).delete(id);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      draw_layer_classPrivateFieldSet(draw_layer_parent, this, null);
      var _iterator2 = draw_layer_createForOfIteratorHelper(draw_layer_classPrivateFieldGet(_mapping, this).values()),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var root = _step2.value;
          root.remove();
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      draw_layer_classPrivateFieldGet(_mapping, this).clear();
      draw_layer_classPrivateFieldGet(_toUpdate, this).clear();
    }
  }], [{
    key: "_svgFactory",
    get: function get() {
      return shadow(this, "_svgFactory", new DOMSVGFactory());
    }
  }]);
}();
_DrawLayer = DrawLayer;
function _setBox(element, _ref2) {
  var _ref3 = draw_layer_slicedToArray(_ref2, 4),
    x = _ref3[0],
    y = _ref3[1],
    width = _ref3[2],
    height = _ref3[3];
  var style = element.style;
  style.top = "".concat(100 * y, "%");
  style.left = "".concat(100 * x, "%");
  style.width = "".concat(100 * width, "%");
  style.height = "".concat(100 * height, "%");
}
function _createSVG() {
  var svg = _DrawLayer._svgFactory.create(1, 1, true);
  draw_layer_classPrivateFieldGet(draw_layer_parent, this).append(svg);
  svg.setAttribute("aria-hidden", true);
  return svg;
}
function _createClipPath(defs, pathId) {
  var clipPath = _DrawLayer._svgFactory.createElement("clipPath");
  defs.append(clipPath);
  var clipPathId = "clip_".concat(pathId);
  clipPath.setAttribute("id", clipPathId);
  clipPath.setAttribute("clipPathUnits", "objectBoundingBox");
  var clipPathUse = _DrawLayer._svgFactory.createElement("use");
  clipPath.append(clipPathUse);
  clipPathUse.setAttribute("href", "#".concat(pathId));
  clipPathUse.classList.add("clip");
  return clipPathId;
}
function _updateProperties(element, properties) {
  for (var _i2 = 0, _Object$entries2 = Object.entries(properties); _i2 < _Object$entries2.length; _i2++) {
    var _Object$entries2$_i = draw_layer_slicedToArray(_Object$entries2[_i2], 2),
      key = _Object$entries2$_i[0],
      value = _Object$entries2$_i[1];
    if (value === null) {
      element.removeAttribute(key);
    } else {
      element.setAttribute(key, value);
    }
  }
}

;// ./src/pdf.js















var pdfjsVersion = "4.10.8";
var pdfjsBuild = "2df5d8f3e";
{
  globalThis.pdfjsTestingUtils = {
    HighlightOutliner: HighlightOutliner
  };
}

var __webpack_exports__AbortException = __webpack_exports__.AbortException;
var __webpack_exports__AnnotationEditorLayer = __webpack_exports__.AnnotationEditorLayer;
var __webpack_exports__AnnotationEditorParamsType = __webpack_exports__.AnnotationEditorParamsType;
var __webpack_exports__AnnotationEditorType = __webpack_exports__.AnnotationEditorType;
var __webpack_exports__AnnotationEditorUIManager = __webpack_exports__.AnnotationEditorUIManager;
var __webpack_exports__AnnotationLayer = __webpack_exports__.AnnotationLayer;
var __webpack_exports__AnnotationMode = __webpack_exports__.AnnotationMode;
var __webpack_exports__ColorPicker = __webpack_exports__.ColorPicker;
var __webpack_exports__DOMSVGFactory = __webpack_exports__.DOMSVGFactory;
var __webpack_exports__DrawLayer = __webpack_exports__.DrawLayer;
var __webpack_exports__FeatureTest = __webpack_exports__.FeatureTest;
var __webpack_exports__GlobalWorkerOptions = __webpack_exports__.GlobalWorkerOptions;
var __webpack_exports__ImageKind = __webpack_exports__.ImageKind;
var __webpack_exports__InvalidPDFException = __webpack_exports__.InvalidPDFException;
var __webpack_exports__MissingPDFException = __webpack_exports__.MissingPDFException;
var __webpack_exports__OPS = __webpack_exports__.OPS;
var __webpack_exports__OutputScale = __webpack_exports__.OutputScale;
var __webpack_exports__PDFDataRangeTransport = __webpack_exports__.PDFDataRangeTransport;
var __webpack_exports__PDFDateString = __webpack_exports__.PDFDateString;
var __webpack_exports__PDFWorker = __webpack_exports__.PDFWorker;
var __webpack_exports__PasswordResponses = __webpack_exports__.PasswordResponses;
var __webpack_exports__PermissionFlag = __webpack_exports__.PermissionFlag;
var __webpack_exports__PixelsPerInch = __webpack_exports__.PixelsPerInch;
var __webpack_exports__RenderingCancelledException = __webpack_exports__.RenderingCancelledException;
var __webpack_exports__TextLayer = __webpack_exports__.TextLayer;
var __webpack_exports__TouchManager = __webpack_exports__.TouchManager;
var __webpack_exports__UnexpectedResponseException = __webpack_exports__.UnexpectedResponseException;
var __webpack_exports__Util = __webpack_exports__.Util;
var __webpack_exports__VerbosityLevel = __webpack_exports__.VerbosityLevel;
var __webpack_exports__XfaLayer = __webpack_exports__.XfaLayer;
var __webpack_exports__build = __webpack_exports__.build;
var __webpack_exports__createValidAbsoluteUrl = __webpack_exports__.createValidAbsoluteUrl;
var __webpack_exports__fetchData = __webpack_exports__.fetchData;
var __webpack_exports__getDocument = __webpack_exports__.getDocument;
var __webpack_exports__getFilenameFromUrl = __webpack_exports__.getFilenameFromUrl;
var __webpack_exports__getPdfFilenameFromUrl = __webpack_exports__.getPdfFilenameFromUrl;
var __webpack_exports__getXfaPageViewport = __webpack_exports__.getXfaPageViewport;
var __webpack_exports__isDataScheme = __webpack_exports__.isDataScheme;
var __webpack_exports__isPdfFile = __webpack_exports__.isPdfFile;
var __webpack_exports__noContextMenu = __webpack_exports__.noContextMenu;
var __webpack_exports__normalizeUnicode = __webpack_exports__.normalizeUnicode;
var __webpack_exports__setLayerDimensions = __webpack_exports__.setLayerDimensions;
var __webpack_exports__shadow = __webpack_exports__.shadow;
var __webpack_exports__stopEvent = __webpack_exports__.stopEvent;
var __webpack_exports__version = __webpack_exports__.version;
export { __webpack_exports__AbortException as AbortException, __webpack_exports__AnnotationEditorLayer as AnnotationEditorLayer, __webpack_exports__AnnotationEditorParamsType as AnnotationEditorParamsType, __webpack_exports__AnnotationEditorType as AnnotationEditorType, __webpack_exports__AnnotationEditorUIManager as AnnotationEditorUIManager, __webpack_exports__AnnotationLayer as AnnotationLayer, __webpack_exports__AnnotationMode as AnnotationMode, __webpack_exports__ColorPicker as ColorPicker, __webpack_exports__DOMSVGFactory as DOMSVGFactory, __webpack_exports__DrawLayer as DrawLayer, __webpack_exports__FeatureTest as FeatureTest, __webpack_exports__GlobalWorkerOptions as GlobalWorkerOptions, __webpack_exports__ImageKind as ImageKind, __webpack_exports__InvalidPDFException as InvalidPDFException, __webpack_exports__MissingPDFException as MissingPDFException, __webpack_exports__OPS as OPS, __webpack_exports__OutputScale as OutputScale, __webpack_exports__PDFDataRangeTransport as PDFDataRangeTransport, __webpack_exports__PDFDateString as PDFDateString, __webpack_exports__PDFWorker as PDFWorker, __webpack_exports__PasswordResponses as PasswordResponses, __webpack_exports__PermissionFlag as PermissionFlag, __webpack_exports__PixelsPerInch as PixelsPerInch, __webpack_exports__RenderingCancelledException as RenderingCancelledException, __webpack_exports__TextLayer as TextLayer, __webpack_exports__TouchManager as TouchManager, __webpack_exports__UnexpectedResponseException as UnexpectedResponseException, __webpack_exports__Util as Util, __webpack_exports__VerbosityLevel as VerbosityLevel, __webpack_exports__XfaLayer as XfaLayer, __webpack_exports__build as build, __webpack_exports__createValidAbsoluteUrl as createValidAbsoluteUrl, __webpack_exports__fetchData as fetchData, __webpack_exports__getDocument as getDocument, __webpack_exports__getFilenameFromUrl as getFilenameFromUrl, __webpack_exports__getPdfFilenameFromUrl as getPdfFilenameFromUrl, __webpack_exports__getXfaPageViewport as getXfaPageViewport, __webpack_exports__isDataScheme as isDataScheme, __webpack_exports__isPdfFile as isPdfFile, __webpack_exports__noContextMenu as noContextMenu, __webpack_exports__normalizeUnicode as normalizeUnicode, __webpack_exports__setLayerDimensions as setLayerDimensions, __webpack_exports__shadow as shadow, __webpack_exports__stopEvent as stopEvent, __webpack_exports__version as version };

//# sourceMappingURL=pdf.mjs.map